/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/marshalling","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(le){for(var e=[],C=0,O=le.length;C<O;C++)e[C]=Se[le[C]];return e};define(Se[69],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=O,e.$4h=A,e.$5h=N;function C(R){return(p,m,E)=>{let T=null,S=null;if(typeof E.value=="function"?(T="value",S=E.value):typeof E.get=="function"&&(T="get",S=E.get),!S)throw new Error("not supported");E[T]=R(S,m)}}function O(R,p,m){let E=null,T=null;if(typeof m.value=="function"?(E="value",T=m.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(E="get",T=m.get),!T)throw new Error("not supported");const S=`$memoize$${p}`;m[E]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,l)}),this[S]}}function A(R,p,m){return C((E,T)=>{const S=`$debounce$${T}`,l=`$debounce$result$${T}`;return function(...b){this[l]||(this[l]=m?m():void 0),clearTimeout(this[S]),p&&(this[l]=p(this[l],...b),b=[this[l]]),this[S]=setTimeout(()=>{E.apply(this,b),this[l]=m?m():void 0},R)}})}function N(R,p,m){return C((E,T)=>{const S=`$throttle$timer$${T}`,l=`$throttle$result$${T}`,b=`$throttle$lastRun$${T}`,f=`$throttle$pending$${T}`;return function(...s){if(this[l]||(this[l]=m?m():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),p&&(this[l]=p(this[l],...s)),this[f])return;const r=this[b]+R;r<=Date.now()?(this[b]=Date.now(),E.apply(this,[this[l]]),this[l]=m?m():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),E.apply(this,[this[l]]),this[l]=m?m():void 0},r-Date.now()))}})}}),define(Se[125],Ie([1,0,18]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=A,e.$8c=N,e.$9c=R,e.$0c=p,e.$$c=m,e.$_c=E;const O=(b,f)=>b===f;e.$6c=O;function A(b=e.$6c){return(f,s)=>C.$ub(f,s,b)}function N(){return(b,f)=>JSON.stringify(b)===JSON.stringify(f)}function R(){return(b,f)=>b.equals(f)}function p(b,f,s){return!b||!f?b===f:s(b,f)}function m(b,f){if(b===f)return!0;if(Array.isArray(b)&&Array.isArray(f)){if(b.length!==f.length)return!1;for(let s=0;s<b.length;s++)if(!m(b[s],f[s]))return!1;return!0}if(b&&typeof b=="object"&&f&&typeof f=="object"&&Object.getPrototypeOf(b)===Object.prototype&&Object.getPrototypeOf(f)===Object.prototype){const s=b,r=f,o=Object.keys(s),i=Object.keys(r),n=new Set(i);if(o.length!==i.length)return!1;for(const c of o)if(!n.has(c)||!m(s[c],r[c]))return!1;return!0}return!1}function E(b){return JSON.stringify(l(b))}let T=0;const S=new WeakMap;function l(b){if(Array.isArray(b))return b.map(l);if(b&&typeof b=="object")if(Object.getPrototypeOf(b)===Object.prototype){const f=b,s=Object.create(null);for(const r of Object.keys(f).sort())s[r]=l(f[r]);return s}else{let f=S.get(b);return f===void 0&&(f=T++,S.set(b,f)),f+"----2b76a038c20c4bcc"}return b}}),define(Se[91],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$QO=void 0;class C{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$QO=C,e.$RO=new C("id#")}),define(Se[126],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=R,e.$Kn=S,e.$Ln=l,e.$Mn=b,e.$Nn=f,e.$On=s,e.$Pn=r,e.$Qn=o,e.$Rn=i,e.$Sn=n,e.$Tn=c,e.$Un=u;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function R(t,g=!1){let a=0;const d=t.length;let w="",$=0,v=16,y=0;function h(q){let M=0,z=0;for(;M<q;){const G=t.charCodeAt(a);if(G>=48&&G<=57)z=z*16+G-48;else if(G>=65&&G<=70)z=z*16+G-65+10;else if(G>=97&&G<=102)z=z*16+G-97+10;else break;a++,M++}return M<q&&(z=-1),z}function D(q){a=q,w="",$=0,v=16,y=0}function k(){const q=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&E(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&E(t.charCodeAt(a)))for(a++;a<t.length&&E(t.charCodeAt(a));)a++;else return y=3,t.substring(q,a);let M=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&E(t.charCodeAt(a))){for(a++;a<t.length&&E(t.charCodeAt(a));)a++;M=a}else y=3;return t.substring(q,M)}function I(){let q="",M=a;for(;;){if(a>=d){q+=t.substring(M,a),y=2;break}const z=t.charCodeAt(a);if(z===34){q+=t.substring(M,a),a++;break}if(z===92){if(q+=t.substring(M,a),a++,a>=d){y=2;break}switch(t.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=h(4);ie>=0?q+=String.fromCharCode(ie):y=4;break}default:y=5}M=a;continue}if(z>=0&&z<=31)if(m(z)){q+=t.substring(M,a),y=2;break}else y=6;a++}return q}function P(){if(w="",y=0,$=a,a>=d)return $=d,v=17;let q=t.charCodeAt(a);if(p(q)){do a++,w+=String.fromCharCode(q),q=t.charCodeAt(a);while(p(q));return v=15}if(m(q))return a++,w+=String.fromCharCode(q),q===13&&t.charCodeAt(a)===10&&(a++,w+=`
`),v=14;switch(q){case 123:return a++,v=1;case 125:return a++,v=2;case 91:return a++,v=3;case 93:return a++,v=4;case 58:return a++,v=6;case 44:return a++,v=5;case 34:return a++,w=I(),v=10;case 47:{const M=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<d&&!m(t.charCodeAt(a));)a++;return w=t.substring(M,a),v=12}if(t.charCodeAt(a+1)===42){a+=2;const z=d-1;let G=!1;for(;a<z;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,G=!0;break}a++}return G||(a++,y=1),w=t.substring(M,a),v=13}return w+=String.fromCharCode(q),a++,v=16}case 45:if(w+=String.fromCharCode(q),a++,a===d||!E(t.charCodeAt(a)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=k(),v=11;default:for(;a<d&&V(q);)a++,q=t.charCodeAt(a);if($!==a){switch(w=t.substring($,a),w){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return w+=String.fromCharCode(q),a++,v=16}}function V(q){if(p(q)||m(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:D,getPosition:()=>a,scan:g?W:P,getToken:()=>v,getTokenValue:()=>w,getTokenOffset:()=>$,getTokenLength:()=>a-$,getTokenError:()=>y}}function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function S(t,g){const a=[],d=new Object;let w;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function y(h,D,k,I){$.value=h,$.offset=D,$.length=k,$.type=I,$.colonOffset=void 0,w=$}try{n(t,{onObjectBegin:(h,D)=>{if(g<=h)throw d;w=void 0,v=g>h,a.push("")},onObjectProperty:(h,D,k)=>{if(g<D||(y(h,D,k,"property"),a[a.length-1]=h,g<=D+k))throw d},onObjectEnd:(h,D)=>{if(g<=h)throw d;w=void 0,a.pop()},onArrayBegin:(h,D)=>{if(g<=h)throw d;w=void 0,a.push(0)},onArrayEnd:(h,D)=>{if(g<=h)throw d;w=void 0,a.pop()},onLiteralValue:(h,D,k)=>{if(g<D||(y(h,D,k,u(h)),g<=D+k))throw d},onSeparator:(h,D,k)=>{if(g<=D)throw d;if(h===":"&&w&&w.type==="property")w.colonOffset=D,v=!1,w=void 0;else if(h===","){const I=a[a.length-1];typeof I=="number"?a[a.length-1]=I+1:(v=!0,a[a.length-1]=""),w=void 0}}})}catch(h){if(h!==d)throw h}return{path:a,previousNode:w,isAtPropertyKey:v,matches:h=>{let D=0;for(let k=0;D<h.length&&k<a.length;k++)if(h[D]===a[k]||h[D]==="*")D++;else if(h[D]!=="**")return!1;return D===h.length}}}function l(t,g=[],a=N.DEFAULT){let d=null,w=[];const $=[];function v(h){Array.isArray(w)?w.push(h):d!==null&&(w[d]=h)}return n(t,{onObjectBegin:()=>{const h={};v(h),$.push(w),w=h,d=null},onObjectProperty:h=>{d=h},onObjectEnd:()=>{w=$.pop()},onArrayBegin:()=>{const h=[];v(h),$.push(w),w=h,d=null},onArrayEnd:()=>{w=$.pop()},onLiteralValue:v,onError:(h,D,k)=>{g.push({error:h,offset:D,length:k})}},a),w[0]}function b(t,g=[],a=N.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(h){d.type==="property"&&(d.length=h-d.offset,d=d.parent)}function $(h){return d.children.push(h),h}n(t,{onObjectBegin:h=>{d=$({type:"object",offset:h,length:-1,parent:d,children:[]})},onObjectProperty:(h,D,k)=>{d=$({type:"property",offset:D,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:h,offset:D,length:k,parent:d})},onObjectEnd:(h,D)=>{d.length=h+D-d.offset,d=d.parent,w(h+D)},onArrayBegin:(h,D)=>{d=$({type:"array",offset:h,length:-1,parent:d,children:[]})},onArrayEnd:(h,D)=>{d.length=h+D-d.offset,d=d.parent,w(h+D)},onLiteralValue:(h,D,k)=>{$({type:u(h),offset:D,length:k,parent:d,value:h}),w(D+k)},onSeparator:(h,D,k)=>{d.type==="property"&&(h===":"?d.colonOffset=D:h===","&&w(D))},onError:(h,D,k)=>{g.push({error:h,offset:D,length:k})}},a);const y=d.children[0];return y&&delete y.parent,y}function f(t,g){if(!t)return;let a=t;for(const d of g)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let w=!1;for(const $ of a.children)if(Array.isArray($.children)&&$.children[0].value===d){a=$.children[1],w=!0;break}if(!w)return}else{const w=d;if(a.type!=="array"||w<0||!Array.isArray(a.children)||w>=a.children.length)return;a=a.children[w]}return a}function s(t){if(!t.parent||!t.parent.children)return[];const g=s(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;g.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&g.push(a)}return g}function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const g=Object.create(null);for(const a of t.children){const d=a.children[1];d&&(g[a.children[0].value]=r(d))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,g,a=!1){return g>=t.offset&&g<t.offset+t.length||a&&g===t.offset+t.length}function i(t,g,a=!1){if(o(t,g,a)){const d=t.children;if(Array.isArray(d))for(let w=0;w<d.length&&d[w].offset<=g;w++){const $=i(d[w],g,a);if($)return $}return t}}function n(t,g,a=N.DEFAULT){const d=R(t,!1);function w(Ce){return Ce?()=>Ce(d.getTokenOffset(),d.getTokenLength()):()=>!0}function $(Ce){return Ce?se=>Ce(se,d.getTokenOffset(),d.getTokenLength()):()=>!0}const v=w(g.onObjectBegin),y=$(g.onObjectProperty),h=w(g.onObjectEnd),D=w(g.onArrayBegin),k=w(g.onArrayEnd),I=$(g.onLiteralValue),P=$(g.onSeparator),V=w(g.onComment),W=$(g.onError),q=a&&a.disallowComments,M=a&&a.allowTrailingComma;function z(){for(;;){const Ce=d.scan();switch(d.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:q||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(Ce){case 12:case 13:q?G(10):V();break;case 16:G(1);break;case 15:case 14:break;default:return Ce}}}function G(Ce,se=[],Oe=[]){if(W(Ce),se.length+Oe.length>0){let ne=d.getToken();for(;ne!==17;){if(se.indexOf(ne)!==-1){z();break}else if(Oe.indexOf(ne)!==-1)break;ne=z()}}}function ie(Ce){const se=d.getTokenValue();return Ce?I(se):y(se),z(),!0}function de(){switch(d.getToken()){case 11:{let Ce=0;try{Ce=JSON.parse(d.getTokenValue()),typeof Ce!="number"&&(G(2),Ce=0)}catch{G(2)}I(Ce);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return z(),!0}function ye(){return d.getToken()!==10?(G(3,[],[2,5]),!1):(ie(!1),d.getToken()===6?(P(":"),z(),ue()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function Ee(){v(),z();let Ce=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(Ce||G(4,[],[]),P(","),z(),d.getToken()===2&&M)break}else Ce&&G(6,[],[]);ye()||G(4,[],[2,5]),Ce=!0}return h(),d.getToken()!==2?G(7,[2],[]):z(),!0}function me(){D(),z();let Ce=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(Ce||G(4,[],[]),P(","),z(),d.getToken()===4&&M)break}else Ce&&G(6,[],[]);ue()||G(4,[],[4,5]),Ce=!0}return k(),d.getToken()!==4?G(8,[4],[]):z(),!0}function ue(){switch(d.getToken()){case 3:return me();case 1:return Ee();case 10:return ie(!0);default:return de()}}return z(),d.getToken()===17?a.allowEmptyContent?!0:(G(4,[],[]),!1):ue()?(d.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}function c(t,g){const a=R(t),d=[];let w,$=0,v;do switch(v=a.getPosition(),w=a.scan(),w){case 12:case 13:case 17:$!==v&&d.push(t.substring($,v)),g!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,g)),$=a.getPosition();break}while(w!==17);return d.join("")}function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(le,e){typeof define=="function"&&define.amd?define(Se[127],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(ke,we){for(var ge=0;ge<we.length;ge++){var Q=we[ge];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(ke,Q.key,Q)}}function C(ke,we,ge){return we&&e(ke.prototype,we),ge&&e(ke,ge),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function O(ke,we){if(ke){if(typeof ke=="string")return A(ke,we);var ge=Object.prototype.toString.call(ke).slice(8,-1);if(ge==="Object"&&ke.constructor&&(ge=ke.constructor.name),ge==="Map"||ge==="Set")return Array.from(ke);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return A(ke,we)}}function A(ke,we){(we==null||we>ke.length)&&(we=ke.length);for(var ge=0,Q=new Array(we);ge<we;ge++)Q[ge]=ke[ge];return Q}function N(ke,we){var ge=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(ge)return(ge=ge.call(ke)).next.bind(ge);if(Array.isArray(ke)||(ge=O(ke))||we&&ke&&typeof ke.length=="number"){ge&&(ke=ge);var Q=0;return function(){return Q>=ke.length?{done:!0}:{done:!1,value:ke[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=R();function p(ke){le.defaults=ke}var m=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(we){return l[we]};function f(ke,we){if(we){if(m.test(ke))return ke.replace(E,b)}else if(T.test(ke))return ke.replace(S,b);return ke}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(ke){return ke.replace(s,function(we,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(ke,we){ke=typeof ke=="string"?ke:ke.source,we=we||"";var ge={replace:function(Y,he){return he=he.source||he,he=he.replace(o,"$1"),ke=ke.replace(Y,he),ge},getRegex:function(){return new RegExp(ke,we)}};return ge}var n=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(ke,we,ge){if(ke){var Q;try{Q=decodeURIComponent(r(ge)).replace(n,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}we&&!c.test(ge)&&(ge=w(we,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},g=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(ke,we){t[" "+ke]||(g.test(ke)?t[" "+ke]=ke+"/":t[" "+ke]=h(ke,"/",!0)),ke=t[" "+ke];var ge=ke.indexOf(":")===-1;return we.substring(0,2)==="//"?ge?we:ke.replace(a,"$1")+we:we.charAt(0)==="/"?ge?we:ke.replace(d,"$1")+we:ke+we}var $={exec:function(){}};function v(ke){for(var we=1,ge,Q;we<arguments.length;we++){ge=arguments[we];for(Q in ge)Object.prototype.hasOwnProperty.call(ge,Q)&&(ke[Q]=ge[Q])}return ke}function y(ke,we){var ge=ke.replace(/\|/g,function(he,ce,Ne){for(var fe=!1,Pe=ce;--Pe>=0&&Ne[Pe]==="\\";)fe=!fe;return fe?"|":" |"}),Q=ge.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>we)Q.splice(we);else for(;Q.length<we;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function h(ke,we,ge){var Q=ke.length;if(Q===0)return"";for(var Y=0;Y<Q;){var he=ke.charAt(Q-Y-1);if(he===we&&!ge)Y++;else if(he!==we&&ge)Y++;else break}return ke.slice(0,Q-Y)}function D(ke,we){if(ke.indexOf(we[1])===-1)return-1;for(var ge=ke.length,Q=0,Y=0;Y<ge;Y++)if(ke[Y]==="\\")Y++;else if(ke[Y]===we[0])Q++;else if(ke[Y]===we[1]&&(Q--,Q<0))return Y;return-1}function k(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(ke,we){if(we<1)return"";for(var ge="";we>1;)we&1&&(ge+=ke),we>>=1,ke+=ke;return ge+ke}function P(ke,we,ge,Q){var Y=we.href,he=we.title?f(we.title):null,ce=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){Q.state.inLink=!0;var Ne={type:"link",raw:ge,href:Y,title:he,text:ce,tokens:Q.inlineTokens(ce)};return Q.state.inLink=!1,Ne}return{type:"image",raw:ge,href:Y,title:he,text:f(ce)}}function V(ke,we){var ge=ke.match(/^(\s+)(?:```)/);if(ge===null)return we;var Q=ge[1];return we.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var ce=he[0];return ce.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var W=function(){function ke(ge){this.options=ge||le.defaults}var we=ke.prototype;return we.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},we.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:h(he,`
`)}}},we.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var he=Y[0],ce=V(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:ce}}},we.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var ce=h(he,"#");(this.options.pedantic||!ce||/ $/.test(ce))&&(he=ce.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},we.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},we.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},we.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var he,ce,Ne,fe,Pe,Me,je,B,L,K,H,ee,re=Y[1].trim(),Te=re.length>1,Be={type:"list",raw:"",ordered:Te,start:Te?+re.slice(0,-1):"",loose:!1,items:[]};re=Te?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Te?re:"[*+-]");for(var He=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(Y=He.exec(Q))||this.rules.block.hr.test(Q)));){if(he=Y[0],Q=Q.substring(he.length),B=Y[2].split(`
`,1)[0],L=Q.split(`
`,1)[0],this.options.pedantic?(fe=2,H=B.trimLeft()):(fe=Y[2].search(/[^ ]/),fe=fe>4?1:fe,H=B.slice(fe),fe+=Y[1].length),Me=!1,!B&&/^ *$/.test(L)&&(he+=L+`
`,Q=Q.substring(L.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");Q&&(K=Q.split(`
`,1)[0],B=K,this.options.pedantic&&(B=B.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(B)||tt.test(B)||_e.test(B)||xe.test(Q)));){if(B.search(/[^ ]/)>=fe||!B.trim())H+=`
`+B.slice(fe);else if(!Me)H+=`
`+B;else break;!Me&&!B.trim()&&(Me=!0),he+=K+`
`,Q=Q.substring(K.length+1)}Be.loose||(je?Be.loose=!0:/\n *\n *$/.test(he)&&(je=!0)),this.options.gfm&&(ce=/^\[[ xX]\] /.exec(H),ce&&(Ne=ce[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!ce,checked:Ne,loose:!1,text:H}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var it=Be.items.length;for(Pe=0;Pe<it;Pe++){this.lexer.state.top=!1,Be.items[Pe].tokens=this.lexer.blockTokens(Be.items[Pe].text,[]);var at=Be.items[Pe].tokens.filter(function(Ue){return Ue.type==="space"}),gt=at.every(function(Ue){for(var rt=Ue.raw.split(""),Z=0,X=N(rt),$e;!($e=X()).done;){var Ke=$e.value;if(Ke===`
`&&(Z+=1),Z>1)return!0}return!1});!Be.loose&&at.length&&gt&&(Be.loose=!0,Be.items[Pe].loose=!0)}return Be}},we.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var ce=this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]);he.type="paragraph",he.text=ce,he.tokens=this.lexer.inline(ce)}return he}},we.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},we.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var he={type:"table",header:y(Y[1]).map(function(je){return{text:je}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var ce=he.align.length,Ne,fe,Pe,Me;for(Ne=0;Ne<ce;Ne++)/^ *-+: *$/.test(he.align[Ne])?he.align[Ne]="right":/^ *:-+: *$/.test(he.align[Ne])?he.align[Ne]="center":/^ *:-+ *$/.test(he.align[Ne])?he.align[Ne]="left":he.align[Ne]=null;for(ce=he.rows.length,Ne=0;Ne<ce;Ne++)he.rows[Ne]=y(he.rows[Ne],he.header.length).map(function(je){return{text:je}});for(ce=he.header.length,fe=0;fe<ce;fe++)he.header[fe].tokens=this.lexer.inline(he.header[fe].text);for(ce=he.rows.length,fe=0;fe<ce;fe++)for(Me=he.rows[fe],Pe=0;Pe<Me.length;Pe++)Me[Pe].tokens=this.lexer.inline(Me[Pe].text);return he}}},we.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},we.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},we.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},we.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:f(Y[1])}},we.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]}},we.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var ce=h(he.slice(0,-1),"\\");if((he.length-ce.length)%2===0)return}else{var Ne=D(Y[2],"()");if(Ne>-1){var fe=Y[0].indexOf("!")===0?5:4,Pe=fe+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,Pe).trim(),Y[3]=""}}var Me=Y[2],je="";if(this.options.pedantic){var B=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);B&&(Me=B[1],je=B[3])}else je=Y[3]?Y[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(he)?Me=Me.slice(1):Me=Me.slice(1,-1)),P(Y,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},we.reflink=function(Q,Y){var he;if((he=this.rules.inline.reflink.exec(Q))||(he=this.rules.inline.nolink.exec(Q))){var ce=(he[2]||he[1]).replace(/\s+/g," ");if(ce=Y[ce.toLowerCase()],!ce||!ce.href){var Ne=he[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return P(he,ce,he[0],this.lexer)}},we.emStrong=function(Q,Y,he){he===void 0&&(he="");var ce=this.rules.inline.emStrong.lDelim.exec(Q);if(ce&&!(ce[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=ce[1]||ce[2]||"";if(!Ne||Ne&&(he===""||this.rules.inline.punctuation.exec(he))){var fe=ce[0].length-1,Pe,Me,je=fe,B=0,L=ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(L.lastIndex=0,Y=Y.slice(-1*Q.length+fe);(ce=L.exec(Y))!=null;)if(Pe=ce[1]||ce[2]||ce[3]||ce[4]||ce[5]||ce[6],!!Pe){if(Me=Pe.length,ce[3]||ce[4]){je+=Me;continue}else if((ce[5]||ce[6])&&fe%3&&!((fe+Me)%3)){B+=Me;continue}if(je-=Me,!(je>0)){if(Me=Math.min(Me,Me+je+B),Math.min(fe,Me)%2){var K=Q.slice(1,fe+ce.index+Me);return{type:"em",raw:Q.slice(0,fe+ce.index+Me+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=Q.slice(2,fe+ce.index+Me-1);return{type:"strong",raw:Q.slice(0,fe+ce.index+Me+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},we.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var he=Y[2].replace(/\n/g," "),ce=/[^ ]/.test(he),Ne=/^ /.test(he)&&/ $/.test(he);return ce&&Ne&&(he=he.substring(1,he.length-1)),he=f(he,!0),{type:"codespan",raw:Y[0],text:he}}},we.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},we.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},we.autolink=function(Q,Y){var he=this.rules.inline.autolink.exec(Q);if(he){var ce,Ne;return he[2]==="@"?(ce=f(this.options.mangle?Y(he[1]):he[1]),Ne="mailto:"+ce):(ce=f(he[1]),Ne=ce),{type:"link",raw:he[0],text:ce,href:Ne,tokens:[{type:"text",raw:ce,text:ce}]}}},we.url=function(Q,Y){var he;if(he=this.rules.inline.url.exec(Q)){var ce,Ne;if(he[2]==="@")ce=f(this.options.mangle?Y(he[0]):he[0]),Ne="mailto:"+ce;else{var fe;do fe=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(fe!==he[0]);ce=f(he[0]),he[1]==="www."?Ne="http://"+ce:Ne=ce}return{type:"link",raw:he[0],text:ce,href:Ne,tokens:[{type:"text",raw:ce,text:ce}]}}},we.inlineText=function(Q,Y){var he=this.rules.inline.text.exec(Q);if(he){var ce;return this.lexer.state.inRawBlock?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):f(he[0]):he[0]:ce=f(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:ce}}},ke}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=i(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=i(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=i(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=i(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=i(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=v({},q),q.gfm=v({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=i(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=v({},q.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:i(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=i(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=i(q._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=i(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=i(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=i(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=i(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=i(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=i(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=i(M.reflink).replace("label",M._label).replace("ref",q._label).getRegex(),M.nolink=i(M.nolink).replace("ref",q._label).getRegex(),M.reflinkSearch=i(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=v({},M),M.pedantic=v({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=v({},M.normal,{escape:i(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=i(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=v({},M.gfm,{br:i(M.br).replace("{2,}","*").getRegex(),text:i(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(ke){var we="",ge,Q,Y=ke.length;for(ge=0;ge<Y;ge++)Q=ke.charCodeAt(ge),Math.random()>.5&&(Q="x"+Q.toString(16)),we+="&#"+Q+";";return we}var ie=function(){function ke(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||le.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:M.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=M.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=M.breaks:Q.inline=M.gfm),this.tokenizer.rules=Q}ke.lex=function(Q,Y){var he=new ke(Y);return he.lex(Q)},ke.lexInline=function(Q,Y){var he=new ke(Y);return he.inlineTokens(Q)};var we=ke.prototype;return we.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},we.blockTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(je,B,L){return B+"    ".repeat(L.length)});for(var ce,Ne,fe,Pe;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(ce=je.call({lexer:he},Q,Y))?(Q=Q.substring(ce.raw.length),Y.push(ce),!0):!1}))){if(ce=this.tokenizer.space(Q)){Q=Q.substring(ce.raw.length),ce.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(ce);continue}if(ce=this.tokenizer.code(Q)){Q=Q.substring(ce.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+ce.raw,Ne.text+=`
`+ce.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(ce);continue}if(ce=this.tokenizer.fences(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.heading(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.hr(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.blockquote(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.list(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.html(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.def(Q)){Q=Q.substring(ce.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+ce.raw,Ne.text+=`
`+ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[ce.tag]||(this.tokens.links[ce.tag]={href:ce.href,title:ce.title});continue}if(ce=this.tokenizer.table(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.lheading(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(fe=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,B=Q.slice(1),L=void 0;he.options.extensions.startBlock.forEach(function(K){L=K.call({lexer:this},B),typeof L=="number"&&L>=0&&(je=Math.min(je,L))}),je<1/0&&je>=0&&(fe=Q.substring(0,je+1))}(),this.state.top&&(ce=this.tokenizer.paragraph(fe))){Ne=Y[Y.length-1],Pe&&Ne.type==="paragraph"?(Ne.raw+=`
`+ce.raw,Ne.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(ce),Pe=fe.length!==Q.length,Q=Q.substring(ce.raw.length);continue}if(ce=this.tokenizer.text(Q)){Q=Q.substring(ce.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+ce.raw,Ne.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(ce);continue}if(Q){var Me="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,Y},we.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},we.inlineTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]);var ce,Ne,fe,Pe=Q,Me,je,B;if(this.tokens.links){var L=Object.keys(this.tokens.links);if(L.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)L.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Me.index)+"["+I("a",Me[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Me.index)+"["+I("a",Me[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Me.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(je||(B=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(ce=H.call({lexer:he},Q,Y))?(Q=Q.substring(ce.raw.length),Y.push(ce),!0):!1}))){if(ce=this.tokenizer.escape(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.tag(Q)){Q=Q.substring(ce.raw.length),Ne=Y[Y.length-1],Ne&&ce.type==="text"&&Ne.type==="text"?(Ne.raw+=ce.raw,Ne.text+=ce.text):Y.push(ce);continue}if(ce=this.tokenizer.link(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ce.raw.length),Ne=Y[Y.length-1],Ne&&ce.type==="text"&&Ne.type==="text"?(Ne.raw+=ce.raw,Ne.text+=ce.text):Y.push(ce);continue}if(ce=this.tokenizer.emStrong(Q,Pe,B)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.codespan(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.br(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.del(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.autolink(Q,G)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(!this.state.inLink&&(ce=this.tokenizer.url(Q,G))){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(fe=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=Q.slice(1),re=void 0;he.options.extensions.startInline.forEach(function(Te){re=Te.call({lexer:this},ee),typeof re=="number"&&re>=0&&(H=Math.min(H,re))}),H<1/0&&H>=0&&(fe=Q.substring(0,H+1))}(),ce=this.tokenizer.inlineText(fe,z)){Q=Q.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(B=ce.raw.slice(-1)),je=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=ce.raw,Ne.text+=ce.text):Y.push(ce);continue}if(Q){var K="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Y},C(ke,null,[{key:"rules",get:function(){return{block:q,inline:M}}}]),ke}(),de=function(){function ke(ge){this.options=ge||le.defaults}var we=ke.prototype;return we.code=function(Q,Y,he){var ce=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(Q,ce);Ne!=null&&Ne!==Q&&(he=!0,Q=Ne)}return Q=Q.replace(/\n$/,"")+`
`,ce?'<pre><code class="'+this.options.langPrefix+f(ce,!0)+'">'+(he?Q:f(Q,!0))+`</code></pre>
`:"<pre><code>"+(he?Q:f(Q,!0))+`</code></pre>
`},we.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},we.html=function(Q){return Q},we.heading=function(Q,Y,he,ce){if(this.options.headerIds){var Ne=this.options.headerPrefix+ce.slug(he);return"<h"+Y+' id="'+Ne+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(Q,Y,he){var ce=Y?"ol":"ul",Ne=Y&&he!==1?' start="'+he+'"':"";return"<"+ce+Ne+`>
`+Q+"</"+ce+`>
`},we.listitem=function(Q){return"<li>"+Q+`</li>
`},we.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(Q){return"<p>"+Q+`</p>
`},we.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},we.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},we.tablecell=function(Q,Y){var he=Y.header?"th":"td",ce=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return ce+Q+("</"+he+`>
`)},we.strong=function(Q){return"<strong>"+Q+"</strong>"},we.em=function(Q){return"<em>"+Q+"</em>"},we.codespan=function(Q){return"<code>"+Q+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(Q){return"<del>"+Q+"</del>"},we.link=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ce='<a href="'+f(Q)+'"';return Y&&(ce+=' title="'+Y+'"'),ce+=">"+he+"</a>",ce},we.image=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ce='<img src="'+Q+'" alt="'+he+'"';return Y&&(ce+=' title="'+Y+'"'),ce+=this.options.xhtml?"/>":">",ce},we.text=function(Q){return Q},ke}(),ye=function(){function ke(){}var we=ke.prototype;return we.strong=function(Q){return Q},we.em=function(Q){return Q},we.codespan=function(Q){return Q},we.del=function(Q){return Q},we.html=function(Q){return Q},we.text=function(Q){return Q},we.link=function(Q,Y,he){return""+he},we.image=function(Q,Y,he){return""+he},we.br=function(){return""},ke}(),Ee=function(){function ke(){this.seen={}}var we=ke.prototype;return we.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(Q,Y){var he=Q,ce=0;if(this.seen.hasOwnProperty(he)){ce=this.seen[Q];do ce++,he=Q+"-"+ce;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[Q]=ce,this.seen[he]=0),he},we.slug=function(Q,Y){Y===void 0&&(Y={});var he=this.serialize(Q);return this.getNextSafeSlug(he,Y.dryrun)},ke}(),me=function(){function ke(ge){this.options=ge||le.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Ee}ke.parse=function(Q,Y){var he=new ke(Y);return he.parse(Q)},ke.parseInline=function(Q,Y){var he=new ke(Y);return he.parseInline(Q)};var we=ke.prototype;return we.parse=function(Q,Y){Y===void 0&&(Y=!0);var he="",ce,Ne,fe,Pe,Me,je,B,L,K,H,ee,re,Te,Be,He,_e,xe,et,tt,it=Q.length;for(ce=0;ce<it;ce++){if(H=Q[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(tt=this.options.extensions.renderers[H.type].call({parser:this},H),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=tt||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,r(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(L="",B="",Pe=H.header.length,Ne=0;Ne<Pe;Ne++)B+=this.renderer.tablecell(this.parseInline(H.header[Ne].tokens),{header:!0,align:H.align[Ne]});for(L+=this.renderer.tablerow(B),K="",Pe=H.rows.length,Ne=0;Ne<Pe;Ne++){for(je=H.rows[Ne],B="",Me=je.length,fe=0;fe<Me;fe++)B+=this.renderer.tablecell(this.parseInline(je[fe].tokens),{header:!1,align:H.align[fe]});K+=this.renderer.tablerow(B)}he+=this.renderer.table(L,K);continue}case"blockquote":{K=this.parse(H.tokens),he+=this.renderer.blockquote(K);continue}case"list":{for(ee=H.ordered,re=H.start,Te=H.loose,Pe=H.items.length,K="",Ne=0;Ne<Pe;Ne++)He=H.items[Ne],_e=He.checked,xe=He.task,Be="",He.task&&(et=this.renderer.checkbox(_e),Te?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=et+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=et+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(He.tokens,Te),K+=this.renderer.listitem(Be,xe,_e);he+=this.renderer.list(K,ee,re);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;ce+1<it&&Q[ce+1].type==="text";)H=Q[++ce],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=Y?this.renderer.paragraph(K):K;continue}default:{var at='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return he},we.parseInline=function(Q,Y){Y=Y||this.renderer;var he="",ce,Ne,fe,Pe=Q.length;for(ce=0;ce<Pe;ce++){if(Ne=Q[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(fe=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){he+=fe||"";continue}switch(Ne.type){case"escape":{he+=Y.text(Ne.text);break}case"html":{he+=Y.html(Ne.text);break}case"link":{he+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{he+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{he+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{he+=Y.codespan(Ne.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{he+=Y.text(Ne.text);break}default:{var Me='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return he},ke}();function ue(ke,we,ge){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof we=="function"&&(ge=we,we=null),we=v({},ue.defaults,we||{}),k(we),ge){var Q=we.highlight,Y;try{Y=ie.lex(ke,we)}catch(Pe){return ge(Pe)}var he=function(Me){var je;if(!Me)try{we.walkTokens&&ue.walkTokens(Y,we.walkTokens),je=me.parse(Y,we)}catch(B){Me=B}return we.highlight=Q,Me?ge(Me):ge(null,je)};if(!Q||Q.length<3||(delete we.highlight,!Y.length))return he();var ce=0;ue.walkTokens(Y,function(Pe){Pe.type==="code"&&(ce++,setTimeout(function(){Q(Pe.text,Pe.lang,function(Me,je){if(Me)return he(Me);je!=null&&je!==Pe.text&&(Pe.text=je,Pe.escaped=!0),ce--,ce===0&&he()})},0))}),ce===0&&he();return}function Ne(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+f(Pe.message+"",!0)+"</pre>";throw Pe}try{var fe=ie.lex(ke,we);if(we.walkTokens){if(we.async)return Promise.all(ue.walkTokens(fe,we.walkTokens)).then(function(){return me.parse(fe,we)}).catch(Ne);ue.walkTokens(fe,we.walkTokens)}return me.parse(fe,we)}catch(Pe){Ne(Pe)}}ue.options=ue.setOptions=function(ke){return v(ue.defaults,ke),p(ue.defaults),ue},ue.getDefaults=R,ue.defaults=le.defaults,ue.use=function(){for(var ke=arguments.length,we=new Array(ke),ge=0;ge<ke;ge++)we[ge]=arguments[ge];var Q=v.apply(void 0,[{}].concat(we)),Y=ue.defaults.extensions||{renderers:{},childTokens:{}},he;we.forEach(function(ce){if(ce.extensions&&(he=!0,ce.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var Pe=Y.renderers?Y.renderers[fe.name]:null;Pe?Y.renderers[fe.name]=function(){for(var Me=arguments.length,je=new Array(Me),B=0;B<Me;B++)je[B]=arguments[B];var L=fe.renderer.apply(this,je);return L===!1&&(L=Pe.apply(this,je)),L}:Y.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[fe.level]?Y[fe.level].unshift(fe.tokenizer):Y[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?Y.startBlock?Y.startBlock.push(fe.start):Y.startBlock=[fe.start]:fe.level==="inline"&&(Y.startInline?Y.startInline.push(fe.start):Y.startInline=[fe.start]))}fe.childTokens&&(Y.childTokens[fe.name]=fe.childTokens)})),ce.renderer&&function(){var fe=ue.defaults.renderer||new de,Pe=function(B){var L=fe[B];fe[B]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var re=ce.renderer[B].apply(fe,H);return re===!1&&(re=L.apply(fe,H)),re}};for(var Me in ce.renderer)Pe(Me);Q.renderer=fe}(),ce.tokenizer&&function(){var fe=ue.defaults.tokenizer||new W,Pe=function(B){var L=fe[B];fe[B]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var re=ce.tokenizer[B].apply(fe,H);return re===!1&&(re=L.apply(fe,H)),re}};for(var Me in ce.tokenizer)Pe(Me);Q.tokenizer=fe}(),ce.walkTokens){var Ne=ue.defaults.walkTokens;Q.walkTokens=function(fe){var Pe=[];return Pe.push(ce.walkTokens.call(this,fe)),Ne&&(Pe=Pe.concat(Ne.call(this,fe))),Pe}}he&&(Q.extensions=Y),ue.setOptions(Q)})},ue.walkTokens=function(ke,we){for(var ge=[],Q=function(){var Ne=he.value;switch(ge=ge.concat(we.call(ue,Ne)),Ne.type){case"table":{for(var fe=N(Ne.header),Pe;!(Pe=fe()).done;){var Me=Pe.value;ge=ge.concat(ue.walkTokens(Me.tokens,we))}for(var je=N(Ne.rows),B;!(B=je()).done;)for(var L=B.value,K=N(L),H;!(H=K()).done;){var ee=H.value;ge=ge.concat(ue.walkTokens(ee.tokens,we))}break}case"list":{ge=ge.concat(ue.walkTokens(Ne.items,we));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Ne.type]?ue.defaults.extensions.childTokens[Ne.type].forEach(function(re){ge=ge.concat(ue.walkTokens(Ne[re],we))}):Ne.tokens&&(ge=ge.concat(ue.walkTokens(Ne.tokens,we)))}},Y=N(ke),he;!(he=Y()).done;)Q();return ge},ue.parseInline=function(ke,we){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");we=v({},ue.defaults,we||{}),k(we);try{var ge=ie.lexInline(ke,we);return we.walkTokens&&ue.walkTokens(ge,we.walkTokens),me.parseInline(ge,we)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+f(Q.message+"",!0)+"</pre>";throw Q}},ue.Parser=me,ue.parser=me.parse,ue.Renderer=de,ue.TextRenderer=ye,ue.Lexer=ie,ue.lexer=ie.lex,ue.Tokenizer=W,ue.Slugger=Ee,ue.parse=ue;var Ce=ue.options,se=ue.setOptions,Oe=ue.use,ne=ue.walkTokens,U=ue.parseInline,x=ue,ve=me.parse,Fe=ie.lex;le.Lexer=ie,le.Parser=me,le.Renderer=de,le.Slugger=Ee,le.TextRenderer=ye,le.Tokenizer=W,le.getDefaults=R,le.lexer=Fe,le.marked=ue,le.options=Ce,le.parse=x,le.parseInline=U,le.parser=ve,le.setOptions=se,le.use=Oe,le.walkTokens=ne,Object.defineProperty(le,"__esModule",{value:!0})}),define(Se[128],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=C;function C(s){const r=N(s);if(r&&r.length>0)return new Uint32Array(r)}let O=0;const A=new Uint32Array(10);function N(s){if(O=0,R(s,S,4352),O>0||(R(s,l,4449),O>0)||(R(s,b,4520),O>0)||(R(s,f,12593),O))return A.subarray(0,O);if(s>=44032&&s<=55203){const r=s-44032,o=r%588,i=Math.floor(r/588),n=Math.floor(o/28),c=o%28-1;if(i<S.length?R(i,S,0):4352+i-12593<f.length&&R(4352+i,f,12593),n<l.length?R(n,l,0):4449+n-12593<f.length&&R(4449+n-12593,f,12593),c>=0&&(c<b.length?R(c,b,0):4520+c-12593<f.length&&R(4520+c-12593,f,12593)),O>0)return A.subarray(0,O)}}function R(s,r,o){s>=o&&s<o+r.length&&p(r[s-o])}function p(s){s!==0&&(A[O++]=s&255,s>>8&&(A[O++]=s>>8&255),s>>16&&(A[O++]=s>>16&255))}var m;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var E;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(E||(E={}));var T;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(T||(T={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),b=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),f=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[129],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=C,e.rot=O;function C(p,m,E){return Math.min(Math.max(p,m),E)}function O(p,m){return(m+p%m)%m}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=A;class N{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=N;class R{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const E=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=R}),define(Se[130],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=N,e.$cd=l;class C{constructor(f,s,r){this.owner=f,this.debugNameSource=s,this.referenceFn=r}getDebugName(f){return N(f,this)}}e.$ad=C;const O=new Map,A=new WeakMap;function N(b,f){const s=A.get(b);if(s)return s;const r=R(b,f);if(r){let o=O.get(r)??0;o++,O.set(r,o);const i=o===1?r:`${r}#${o}`;return A.set(b,i),i}}function R(b,f){const s=A.get(b);if(s)return s;const r=f.owner?T(f.owner)+".":"";let o;const i=f.debugNameSource;if(i!==void 0)if(typeof i=="function"){if(o=i(),o!==void 0)return r+o}else return r+i;const n=f.referenceFn;if(n!==void 0&&(o=l(n),o!==void 0))return r+o;if(f.owner!==void 0){const c=p(f.owner,b);if(c!==void 0)return r+c}}function p(b,f){for(const s in b)if(b[s]===f)return s}const m=new Map,E=new WeakMap;function T(b){const f=E.get(b);if(f)return f;const s=S(b);let r=m.get(s)??0;r++,m.set(s,r);const o=r===1?s:`${s}#${r}`;return E.set(b,o),o}function S(b){const f=b.constructor;return f?f.name:"Object"}function l(b){const f=b.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(r?r[1]:void 0)?.trim()}}),define(Se[131],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=O,e.$Id=A;let C;function O(s){C=s}function A(){return C}class N{constructor(){this.a=0,this.d=new WeakMap}b(r){return R([p(b("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[p(" "),E(T(r.oldValue,70),{color:"red",strikeThrough:!0}),p(" "),E(T(r.newValue,60),{color:"green"})]:[p(" (unchanged)")]:[p(" "),E(T(r.newValue,60),{color:"green"}),p(" (initial)")]}handleObservableChanged(r,o){console.log(...this.b([m("observable value changed"),E(r.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(r){if(r.size!==0)return E(" (changed deps: "+[...r].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const o=r.handleChange;this.d.set(r,new Set),r.handleChange=(i,n)=>(this.d.get(r).add(i),o.apply(r,[i,n]))}handleDerivedRecomputed(r,o){const i=this.d.get(r);console.log(...this.b([m("derived recomputed"),E(r.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(i),{data:[{fn:r._computeFn}]}])),i.clear()}handleFromEventObservableTriggered(r,o){console.log(...this.b([m("observable from event triggered"),E(r.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const o=r.handleChange;this.d.set(r,new Set),r.handleChange=(i,n)=>(this.d.get(r).add(i),o.apply(r,[i,n]))}handleAutorunTriggered(r){const o=this.d.get(r);console.log(...this.b([m("autorun"),E(r.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:r._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let o=r.getDebugName();o===void 0&&(o=""),console.log(...this.b([m("transaction"),E(o,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=N;function R(s){const r=new Array,o=[];let i="";function n(u){if("length"in u)for(const t of u)t&&n(t);else"text"in u?(i+=`%c${u.text}`,r.push(u.style),u.data&&o.push(...u.data)):"data"in u&&o.push(...u.data)}n(s);const c=[i,...r];return c.push(...o),c}function p(s){return E(s,{color:"black"})}function m(s){return E(f(`${s}: `,10),{color:"black",bold:!0})}function E(s,r={color:"black"}){function o(n){return Object.entries(n).reduce((c,[u,t])=>`${c}${u}:${t};`,"")}const i={color:r.color};return r.strikeThrough&&(i["text-decoration"]="line-through"),r.bold&&(i["font-weight"]="bold"),{text:s,style:o(i)}}function T(s,r){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=r?`"${s}"`:`"${s.substr(0,r-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?S(s,r):l(s,r);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function S(s,r){let o="[ ",i=!0;for(const n of s){if(i||(o+=", "),o.length-5>r){o+="...";break}i=!1,o+=`${T(n,r-o.length)}`}return o+=" ]",o}function l(s,r){let o="{ ",i=!0;for(const[n,c]of Object.entries(s)){if(i||(o+=", "),o.length-5>r){o+="...";break}i=!1,o+=`${n}: ${T(c,r-o.length)}`}return o+=" }",o}function b(s,r){let o="";for(let i=1;i<=r;i++)o+=s;return o}function f(s,r){for(;s.length<r;)s+=" ";return s}}),define(Se[132],Ie([1,0,125,130,131]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=R,e.$Td=m,e.$Ud=T,e.$Xd=b,e.$Yd=s,e.$Zd=r,e.$1d=o,e.$3d=n,e.$4d=c,e.$6d=t;let N;function R(a){N=a}let p;function m(a){p=a}let E;function T(a){E=a}class S{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,w){const $=w===void 0?void 0:d,v=w===void 0?d:w;return E({owner:$,debugName:()=>{const y=(0,O.$cd)(v);if(y!==void 0)return y;const D=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(v.toString());if(D)return`${this.debugName}.${D[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:v},y=>v(this.read(y),y))}recomputeInitiallyAndOnChange(d,w){return d.add(N(this,w)),this}keepObserved(d){return d.add(p(this)),this}get a(){return this.get()}}e.$Vd=S;class l extends S{constructor(){super(...arguments),this.b=new Set}addObserver(d){const w=this.b.size;this.b.add(d),w===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=l;function b(a,d){const w=new i(a,d);try{a(w)}finally{w.finish()}}let f;function s(a){if(f)a(f);else{const d=new i(a,void 0);f=d;try{a(d)}finally{d.finish(),f=void 0}}}async function r(a,d){const w=new i(a,d);try{await a(w)}finally{w.finish()}}function o(a,d,w){a?d(a):b(d,w)}class i{constructor(d,w){this._fn=d,this.b=w,this.a=[],(0,A.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,O.$cd)(this._fn)}updateObserver(d,w){this.a.push({observer:d,observable:w}),d.beginUpdate(w)}finish(){const d=this.a;for(let w=0;w<d.length;w++){const{observer:$,observable:v}=d[w];$.endUpdate(v)}this.a=null,(0,A.$Id)()?.handleEndTransaction()}}e.$2d=i;function n(a,d){let w;return typeof a=="string"?w=new O.$ad(void 0,a,void 0):w=new O.$ad(a,void 0,void 0),new u(w,d,C.$6c)}function c(a,d){return new u(new O.$ad(a.owner,a.debugName,void 0),d,a.equalsFn??C.$6c)}class u extends l{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,w,$){super(),this.e=d,this.g=$,this.d=w}get(){return this.d}set(d,w,$){if($===void 0&&this.g(this.d,d))return;let v;w||(w=v=new i(()=>{},()=>`Setting ${this.debugName}`));try{const y=this.d;this.h(d),(0,A.$Id)()?.handleObservableChanged(this,{oldValue:y,newValue:d,change:$,didChange:!0,hadValue:!0});for(const h of this.b)w.updateObserver(h,this),h.handleChange(this,$)}finally{v&&v.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$5d=u;function t(a,d){let w;return typeof a=="string"?w=new O.$ad(void 0,a,void 0):w=new O.$ad(a,void 0,void 0),new g(w,d,C.$6c)}class g extends u{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$7d=g}),function(){function le(A){const N=[];typeof A=="number"&&N.push("code/timeOrigin",A);function R(m){N.push(m,Date.now())}function p(){const m=[];for(let E=0;E<N.length;E+=2)m.push({name:N[E],startTime:N[E+1]});return m}return{mark:R,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const R of performance.getEntriesByType("mark"))N.push({name:R.name,startTime:Math.round(A+R.startTime)});return N}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function C(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=C(O))}(),define(Se[133],Ie([1,0,42]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=void 0;const O=Symbol("unset");class A{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||C.Iterable.empty()}insert(m,E,T){this.d(m,S=>S._value=E,T)}mutate(m,E){this.d(m,T=>T._value=E(T._value===O?void 0:T._value))}mutatePath(m,E){this.d(m,()=>{},T=>E(T))}delete(m){const E=this.c(m);if(!E)return;let T=E.length-1;const S=E[T].node._value;if(S!==O){for(this.b--,E[T].node._value=O;T>0;T--){const{node:l,part:b}=E[T];if(l.children?.size||l._value!==O)break;E[T-1].node.children.delete(b)}return S}}*deleteRecursive(m){const E=this.c(m);if(!E)return;const T=E[E.length-1].node;for(let S=E.length-1;S>0;S--){const l=E[S-1];if(l.node.children.delete(E[S].part),l.node.children.size>0||l.node._value!==O)break}for(const S of N(T))S._value!==O&&(this.b--,yield S._value)}find(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return;E=S}return E._value===O?void 0:E._value}hasKeyOrParent(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;if(S._value!==O)return!0;E=S}return!1}hasKeyOrChildren(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;E=S}return!0}hasKey(m){let E=this.a;for(const T of m){const S=E.children?.get(T);if(!S)return!1;E=S}return E._value!==O}c(m){const E=[{part:"",node:this.a}];let T=0;for(const S of m){const l=E[T].node.children?.get(S);if(!l)return;E.push({part:S,node:l}),T++}return E}d(m,E,T){let S=this.a;for(const f of m){if(S.children)if(S.children.has(f))S=S.children.get(f);else{const s=new R;S.children.set(f,s),S=s}else{const s=new R;S.children=new Map([[f,s]]),S=s}T?.(S)}const l=S._value===O?0:1;E(S);const b=S._value===O?0:1;this.b+=b-l}*values(){for(const{_value:m}of N(this.a))m!==O&&(yield m)}}e.$AO=A;function*N(p){const m=[p];for(;m.length>0;){const E=m.pop();if(yield E,E.children)for(const T of E.children.values())m.push(T)}}class R{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(m){this._value=m===void 0?O:m}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var O in C)(typeof exports=="object"?exports:le)[O]=C[O]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function C(O){if(e[O])return e[O].exports;var A=e[O]={i:O,l:!1,exports:{}};return le[O].call(A.exports,A,A.exports,C),A.l=!0,A.exports}return C.m=le,C.c=e,C.d=function(O,A,N){C.o(O,A)||Object.defineProperty(O,A,{enumerable:!0,get:N})},C.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},C.t=function(O,A){if(1&A&&(O=C(O)),8&A||4&A&&typeof O=="object"&&O&&O.__esModule)return O;var N=Object.create(null);if(C.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:O}),2&A&&typeof O!="string")for(var R in O)C.d(N,R,function(p){return O[p]}.bind(null,R));return N},C.n=function(O){var A=O&&O.__esModule?function(){return O.default}:function(){return O};return C.d(A,"a",A),A},C.o=function(O,A){return Object.prototype.hasOwnProperty.call(O,A)},C.p="",C(C.s=0)}([function(le,e,C){(function(O){var A;e=le.exports=Oe,A=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var L=Array.prototype.slice.call(arguments,0);L.unshift("SEMVER"),console.log.apply(console,L)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],m=e.src=[],E=0,T=E++;m[T]="0|[1-9]\\d*";var S=E++;m[S]="[0-9]+";var l=E++;m[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=E++;m[b]="("+m[T]+")\\.("+m[T]+")\\.("+m[T]+")";var f=E++;m[f]="("+m[S]+")\\.("+m[S]+")\\.("+m[S]+")";var s=E++;m[s]="(?:"+m[T]+"|"+m[l]+")";var r=E++;m[r]="(?:"+m[S]+"|"+m[l]+")";var o=E++;m[o]="(?:-("+m[s]+"(?:\\."+m[s]+")*))";var i=E++;m[i]="(?:-?("+m[r]+"(?:\\."+m[r]+")*))";var n=E++;m[n]="[0-9A-Za-z-]+";var c=E++;m[c]="(?:\\+("+m[n]+"(?:\\."+m[n]+")*))";var u=E++,t="v?"+m[b]+m[o]+"?"+m[c]+"?";m[u]="^"+t+"$";var g="[v=\\s]*"+m[f]+m[i]+"?"+m[c]+"?",a=E++;m[a]="^"+g+"$";var d=E++;m[d]="((?:<|>)?=?)";var w=E++;m[w]=m[S]+"|x|X|\\*";var $=E++;m[$]=m[T]+"|x|X|\\*";var v=E++;m[v]="[v=\\s]*("+m[$]+")(?:\\.("+m[$]+")(?:\\.("+m[$]+")(?:"+m[o]+")?"+m[c]+"?)?)?";var y=E++;m[y]="[v=\\s]*("+m[w]+")(?:\\.("+m[w]+")(?:\\.("+m[w]+")(?:"+m[i]+")?"+m[c]+"?)?)?";var h=E++;m[h]="^"+m[d]+"\\s*"+m[v]+"$";var D=E++;m[D]="^"+m[d]+"\\s*"+m[y]+"$";var k=E++;m[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=E++;m[I]="(?:~>?)";var P=E++;m[P]="(\\s*)"+m[I]+"\\s+",p[P]=new RegExp(m[P],"g");var V=E++;m[V]="^"+m[I]+m[v]+"$";var W=E++;m[W]="^"+m[I]+m[y]+"$";var q=E++;m[q]="(?:\\^)";var M=E++;m[M]="(\\s*)"+m[q]+"\\s+",p[M]=new RegExp(m[M],"g");var z=E++;m[z]="^"+m[q]+m[v]+"$";var G=E++;m[G]="^"+m[q]+m[y]+"$";var ie=E++;m[ie]="^"+m[d]+"\\s*("+g+")$|^$";var de=E++;m[de]="^"+m[d]+"\\s*("+t+")$|^$";var ye=E++;m[ye]="(\\s*)"+m[d]+"\\s*("+g+"|"+m[v]+")",p[ye]=new RegExp(m[ye],"g");var Ee=E++;m[Ee]="^\\s*("+m[v]+")\\s+-\\s+("+m[v]+")\\s*$";var me=E++;m[me]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var ue=E++;m[ue]="(<|>)?=?\\s*\\*";for(var Ce=0;Ce<35;Ce++)A(Ce,m[Ce]),p[Ce]||(p[Ce]=new RegExp(m[Ce]));function se(L,K){if(L instanceof Oe)return L;if(typeof L!="string"||L.length>N||!(K?p[a]:p[u]).test(L))return null;try{return new Oe(L,K)}catch{return null}}function Oe(L,K){if(L instanceof Oe){if(L.loose===K)return L;L=L.version}else if(typeof L!="string")throw new TypeError("Invalid Version: "+L);if(L.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof Oe))return new Oe(L,K);A("SemVer",L,K),this.loose=K;var H=L.trim().match(K?p[a]:p[u]);if(!H)throw new TypeError("Invalid Version: "+L);if(this.raw=L,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var re=+ee;if(re>=0&&re<R)return re}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=se,e.valid=function(L,K){var H=se(L,K);return H?H.version:null},e.clean=function(L,K){var H=se(L.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=Oe,Oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Oe.prototype.toString=function(){return this.version},Oe.prototype.compare=function(L){return A("SemVer.compare",this.version,this.loose,L),L instanceof Oe||(L=new Oe(L,this.loose)),this.compareMain(L)||this.comparePre(L)},Oe.prototype.compareMain=function(L){return L instanceof Oe||(L=new Oe(L,this.loose)),U(this.major,L.major)||U(this.minor,L.minor)||U(this.patch,L.patch)},Oe.prototype.comparePre=function(L){if(L instanceof Oe||(L=new Oe(L,this.loose)),this.prerelease.length&&!L.prerelease.length)return-1;if(!this.prerelease.length&&L.prerelease.length)return 1;if(!this.prerelease.length&&!L.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],ee=L.prerelease[K];if(A("prerelease compare",K,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return U(H,ee)}while(++K)},Oe.prototype.inc=function(L,K){switch(L){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+L)}return this.format(),this.raw=this.version,this},e.inc=function(L,K,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Oe(L,H).inc(K,ee).version}catch{return null}},e.diff=function(L,K){if(ke(L,K))return null;var H=se(L),ee=se(K);if(H.prerelease.length||ee.prerelease.length){for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return"pre"+re;return"prerelease"}for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==ee[re])return re},e.compareIdentifiers=U;var ne=/^[0-9]+$/;function U(L,K){var H=ne.test(L),ee=ne.test(K);return H&&ee&&(L=+L,K=+K),H&&!ee?-1:ee&&!H?1:L<K?-1:L>K?1:0}function x(L,K,H){return new Oe(L,H).compare(new Oe(K,H))}function ve(L,K,H){return x(L,K,H)>0}function Fe(L,K,H){return x(L,K,H)<0}function ke(L,K,H){return x(L,K,H)===0}function we(L,K,H){return x(L,K,H)!==0}function ge(L,K,H){return x(L,K,H)>=0}function Q(L,K,H){return x(L,K,H)<=0}function Y(L,K,H,ee){var re;switch(K){case"===":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),re=L===H;break;case"!==":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),re=L!==H;break;case"":case"=":case"==":re=ke(L,H,ee);break;case"!=":re=we(L,H,ee);break;case">":re=ve(L,H,ee);break;case">=":re=ge(L,H,ee);break;case"<":re=Fe(L,H,ee);break;case"<=":re=Q(L,H,ee);break;default:throw new TypeError("Invalid operator: "+K)}return re}function he(L,K){if(L instanceof he){if(L.loose===K)return L;L=L.value}if(!(this instanceof he))return new he(L,K);A("comparator",L,K),this.loose=K,this.parse(L),this.semver===ce?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(L,K){return U(K,L)},e.major=function(L,K){return new Oe(L,K).major},e.minor=function(L,K){return new Oe(L,K).minor},e.patch=function(L,K){return new Oe(L,K).patch},e.compare=x,e.compareLoose=function(L,K){return x(L,K,!0)},e.rcompare=function(L,K,H){return x(K,L,H)},e.sort=function(L,K){return L.sort(function(H,ee){return e.compare(H,ee,K)})},e.rsort=function(L,K){return L.sort(function(H,ee){return e.rcompare(H,ee,K)})},e.gt=ve,e.lt=Fe,e.eq=ke,e.neq=we,e.gte=ge,e.lte=Q,e.cmp=Y,e.Comparator=he;var ce={};function Ne(L,K){if(L instanceof Ne)return L.loose===K?L:new Ne(L.raw,K);if(L instanceof he)return new Ne(L.value,K);if(!(this instanceof Ne))return new Ne(L,K);if(this.loose=K,this.raw=L,this.set=L.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+L);this.format()}function fe(L){return!L||L.toLowerCase()==="x"||L==="*"}function Pe(L,K,H,ee,re,Te,Be,He,_e,xe,et,tt,it){return((K=fe(H)?"":fe(ee)?">="+H+".0.0":fe(re)?">="+H+"."+ee+".0":">="+K)+" "+(He=fe(_e)?"":fe(xe)?"<"+(+_e+1)+".0.0":fe(et)?"<"+_e+"."+(+xe+1)+".0":tt?"<="+_e+"."+xe+"."+et+"-"+tt:"<="+He)).trim()}function Me(L,K){for(var H=0;H<L.length;H++)if(!L[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<L.length;H++)if(A(L[H].semver),L[H].semver!==ce&&L[H].semver.prerelease.length>0){var ee=L[H].semver;if(ee.major===K.major&&ee.minor===K.minor&&ee.patch===K.patch)return!0}return!1}return!0}function je(L,K,H){try{K=new Ne(K,H)}catch{return!1}return K.test(L)}function B(L,K,H,ee){var re,Te,Be,He,_e;switch(L=new Oe(L,ee),K=new Ne(K,ee),H){case">":re=ve,Te=Q,Be=Fe,He=">",_e=">=";break;case"<":re=Fe,Te=ge,Be=ve,He="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(L,K,ee))return!1;for(var xe=0;xe<K.set.length;++xe){var et=K.set[xe],tt=null,it=null;if(et.forEach(function(at){at.semver===ce&&(at=new he(">=0.0.0")),tt=tt||at,it=it||at,re(at.semver,tt.semver,ee)?tt=at:Be(at.semver,it.semver,ee)&&(it=at)}),tt.operator===He||tt.operator===_e||(!it.operator||it.operator===He)&&Te(L,it.semver)||it.operator===_e&&Be(L,it.semver))return!1}return!0}he.prototype.parse=function(L){var K=this.loose?p[ie]:p[de],H=L.match(K);if(!H)throw new TypeError("Invalid comparator: "+L);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Oe(H[2],this.loose):this.semver=ce},he.prototype.toString=function(){return this.value},he.prototype.test=function(L){return A("Comparator.test",L,this.loose),this.semver===ce||(typeof L=="string"&&(L=new Oe(L,this.loose)),Y(L,this.operator,this.semver,this.loose))},he.prototype.intersects=function(L,K){if(!(L instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Ne(L.value,K),je(this.value,H,K);if(L.operator==="")return H=new Ne(this.value,K),je(L.semver,H,K);var ee=!(this.operator!==">="&&this.operator!==">"||L.operator!==">="&&L.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||L.operator!=="<="&&L.operator!=="<"),Te=this.semver.version===L.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||L.operator!==">="&&L.operator!=="<="),He=Y(this.semver,"<",L.semver,K)&&(this.operator===">="||this.operator===">")&&(L.operator==="<="||L.operator==="<"),_e=Y(this.semver,">",L.semver,K)&&(this.operator==="<="||this.operator==="<")&&(L.operator===">="||L.operator===">");return ee||re||Te&&Be||He||_e},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(L){return L.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(L){var K=this.loose;L=L.trim(),A("range",L,K);var H=K?p[me]:p[Ee];L=L.replace(H,Pe),A("hyphen replace",L),L=L.replace(p[ye],"$1$2$3"),A("comparator trim",L,p[ye]),L=(L=(L=L.replace(p[P],"$1~")).replace(p[M],"$1^")).split(/\s+/).join(" ");var ee=K?p[ie]:p[de],re=L.split(" ").map(function(Te){return function(Be,He){return A("comp",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){A("caret",tt,it);var at=it?p[G]:p[z];return tt.replace(at,function(gt,Ue,rt,Z,X){var $e;return A("caret",tt,gt,Ue,rt,Z,X),fe(Ue)?$e="":fe(rt)?$e=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":fe(Z)?$e=Ue==="0"?">="+Ue+"."+rt+".0 <"+Ue+"."+(+rt+1)+".0":">="+Ue+"."+rt+".0 <"+(+Ue+1)+".0.0":X?(A("replaceCaret pr",X),X.charAt(0)!=="-"&&(X="-"+X),$e=Ue==="0"?rt==="0"?">="+Ue+"."+rt+"."+Z+X+" <"+Ue+"."+rt+"."+(+Z+1):">="+Ue+"."+rt+"."+Z+X+" <"+Ue+"."+(+rt+1)+".0":">="+Ue+"."+rt+"."+Z+X+" <"+(+Ue+1)+".0.0"):(A("no pr"),$e=Ue==="0"?rt==="0"?">="+Ue+"."+rt+"."+Z+" <"+Ue+"."+rt+"."+(+Z+1):">="+Ue+"."+rt+"."+Z+" <"+Ue+"."+(+rt+1)+".0":">="+Ue+"."+rt+"."+Z+" <"+(+Ue+1)+".0.0"),A("caret return",$e),$e})}(et,xe)}).join(" ")}(Be,He),A("caret",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){var at=it?p[W]:p[V];return tt.replace(at,function(gt,Ue,rt,Z,X){var $e;return A("tilde",tt,gt,Ue,rt,Z,X),fe(Ue)?$e="":fe(rt)?$e=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":fe(Z)?$e=">="+Ue+"."+rt+".0 <"+Ue+"."+(+rt+1)+".0":X?(A("replaceTilde pr",X),X.charAt(0)!=="-"&&(X="-"+X),$e=">="+Ue+"."+rt+"."+Z+X+" <"+Ue+"."+(+rt+1)+".0"):$e=">="+Ue+"."+rt+"."+Z+" <"+Ue+"."+(+rt+1)+".0",A("tilde return",$e),$e})}(et,xe)}).join(" ")}(Be,He),A("tildes",Be),Be=function(_e,xe){return A("replaceXRanges",_e,xe),_e.split(/\s+/).map(function(et){return function(tt,it){tt=tt.trim();var at=it?p[D]:p[h];return tt.replace(at,function(gt,Ue,rt,Z,X,$e){A("xRange",tt,gt,Ue,rt,Z,X,$e);var Ke=fe(rt),be=Ke||fe(Z),st=be||fe(X);return Ue==="="&&st&&(Ue=""),Ke?gt=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&st?(be&&(Z=0),st&&(X=0),Ue===">"?(Ue=">=",be?(rt=+rt+1,Z=0,X=0):st&&(Z=+Z+1,X=0)):Ue==="<="&&(Ue="<",be?rt=+rt+1:Z=+Z+1),gt=Ue+rt+"."+Z+"."+X):be?gt=">="+rt+".0.0 <"+(+rt+1)+".0.0":st&&(gt=">="+rt+"."+Z+".0 <"+rt+"."+(+Z+1)+".0"),A("xRange return",gt),gt})}(et,xe)}).join(" ")}(Be,He),A("xrange",Be),Be=function(_e,xe){return A("replaceStars",_e,xe),_e.trim().replace(p[ue],"")}(Be,He),A("stars",Be),Be}(Te,K)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Te){return!!Te.match(ee)})),re=re.map(function(Te){return new he(Te,K)})},Ne.prototype.intersects=function(L,K){if(!(L instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return L.set.some(function(re){return re.every(function(Te){return ee.intersects(Te,K)})})})})},e.toComparators=function(L,K){return new Ne(L,K).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(L){if(!L)return!1;typeof L=="string"&&(L=new Oe(L,this.loose));for(var K=0;K<this.set.length;K++)if(Me(this.set[K],L))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(L,K,H){var ee=null,re=null;try{var Te=new Ne(K,H)}catch{return null}return L.forEach(function(Be){Te.test(Be)&&(ee&&re.compare(Be)!==-1||(re=new Oe(ee=Be,H)))}),ee},e.minSatisfying=function(L,K,H){var ee=null,re=null;try{var Te=new Ne(K,H)}catch{return null}return L.forEach(function(Be){Te.test(Be)&&(ee&&re.compare(Be)!==1||(re=new Oe(ee=Be,H)))}),ee},e.validRange=function(L,K){try{return new Ne(L,K).range||"*"}catch{return null}},e.ltr=function(L,K,H){return B(L,K,"<",H)},e.gtr=function(L,K,H){return B(L,K,">",H)},e.outside=B,e.prerelease=function(L,K){var H=se(L,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(L,K,H){return L=new Ne(L,H),K=new Ne(K,H),L.intersects(K)},e.coerce=function(L){if(L instanceof Oe)return L;if(typeof L!="string")return null;var K=L.match(p[k]);return K==null?null:se((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,C(1))},function(le,e){var C,O,A=le.exports={};function N(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function p(r){if(C===setTimeout)return setTimeout(r,0);if((C===N||!C)&&setTimeout)return C=setTimeout,setTimeout(r,0);try{return C(r,0)}catch{try{return C.call(null,r,0)}catch{return C.call(this,r,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:N}catch{C=N}try{O=typeof clearTimeout=="function"?clearTimeout:R}catch{O=R}})();var m,E=[],T=!1,S=-1;function l(){T&&m&&(T=!1,m.length?E=m.concat(E):S=-1,E.length&&b())}function b(){if(!T){var r=p(l);T=!0;for(var o=E.length;o;){for(m=E,E=[];++S<o;)m&&m[S].run();S=-1,o=E.length}m=null,T=!1,function(i){if(O===clearTimeout)return clearTimeout(i);if((O===R||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(i);try{O(i)}catch{try{return O.call(null,i)}catch{return O.call(this,i)}}}(r)}}function f(r,o){this.fun=r,this.array=o}function s(){}A.nextTick=function(r){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];E.push(new f(r,o)),E.length!==1||T||p(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=s,A.addListener=s,A.once=s,A.off=s,A.removeListener=s,A.removeAllListeners=s,A.emit=s,A.prependListener=s,A.prependOnceListener=s,A.listeners=function(r){return[]},A.binding=function(r){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(r){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Se[134],Ie([1,0,14,6]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=A,e.$te=N,e.$ue=R,e.$ve=p,e.$we=E,e.$xe=T,e.$ye=S,e.$ze=l,e.$Ae=b,e.$Be=f,e.$Ce=s,e.$De=r,e.$Ee=o,e.$Fe=i,e.$Ge=n;function A(c){const u=c;return u?typeof u.read=="function":!1}function N(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}function R(c){const u=c;return u?N(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function p(c,u){return new m(c,u)}class m{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,C.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let g;switch(u){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const a=g.indexOf(t);a>=0&&g.splice(a,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,u){const t=[];let g;for(;(g=c.read())!==null;)t.push(g);return u(t)}function T(c,u,t){const g=[];let a;for(;(a=c.read())!==null&&g.length<t;)g.push(a);return a===null&&g.length>0?u(g):{read:()=>{if(g.length>0)return g.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return c.read()}}}function S(c,u){return new Promise((t,g)=>{const a=[];l(c,{onData:d=>{u&&a.push(d)},onError:d=>{u?g(d):t(void 0)},onEnd:()=>{t(u?u(a):void 0)}})})}function l(c,u,t){c.on("error",g=>{t?.isCancellationRequested||u.onError(g)}),c.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),c.on("data",g=>{t?.isCancellationRequested||u.onData(g)})}function b(c,u){return new Promise((t,g)=>{const a=new O.$Tc,d=[],w=y=>{if(d.push(y),d.length>u)return a.dispose(),c.pause(),t({stream:c,buffer:d,ended:!1})},$=y=>(a.dispose(),g(y)),v=()=>(a.dispose(),t({stream:c,buffer:d,ended:!0}));a.add((0,O.$Sc)(()=>c.removeListener("error",$))),c.on("error",$),a.add((0,O.$Sc)(()=>c.removeListener("end",v))),c.on("end",v),a.add((0,O.$Sc)(()=>c.removeListener("data",w))),c.on("data",w)})}function f(c,u){const t=p(u);return t.end(c),t}function s(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}function r(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}function o(c,u,t){const g=p(t);return l(c,{onData:a=>g.write(u.data(a)),onError:a=>g.error(u.error?u.error(a):a),onEnd:()=>g.end()}),g}function i(c,u,t){let g=!1;return{read:()=>{const a=u.read();return g?a:(g=!0,a!==null?t([c,a]):c)}}}function n(c,u,t){let g=!1;const a=p(t);return l(u,{onData:d=>g?a.write(d):(g=!0,a.write(t([c,d]))),onError:d=>a.error(d),onEnd:()=>{g||(g=!0,a.write(c)),a.end()}}),a}}),define(Se[22],Ie([1,0,43,134]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=E,e.$Je=T,e.$Ke=S,e.$Le=l,e.$Me=b,e.$Ne=f,e.$Oe=s,e.$Pe=r,e.$Qe=o,e.$Re=i,e.$Se=n,e.$Te=c,e.$Ue=u,e.$Ve=t,e.$We=g,e.$Xe=a,e.$Ye=d,e.$Ze=w,e.$1e=$,e.$2e=h;const A=typeof Buffer<"u",N=new C.$V(()=>new Uint8Array(256));let R,p;class m{static alloc(k){return A?new m(Buffer.allocUnsafe(k)):new m(new Uint8Array(k))}static wrap(k){return A&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new m(k)}static fromString(k,I){return!(I?.dontUseNodeBuffer||!1)&&A?new m(Buffer.from(k)):(R||(R=new TextEncoder),new m(R.encode(k)))}static fromByteArray(k){const I=m.alloc(k.length);for(let P=0,V=k.length;P<V;P++)I.buffer[P]=k[P];return I}static concat(k,I){if(typeof I>"u"){I=0;for(let W=0,q=k.length;W<q;W++)I+=k[W].byteLength}const P=m.alloc(I);let V=0;for(let W=0,q=k.length;W<q;W++){const M=k[W];P.set(M,V),V+=M.byteLength}return P}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=m.alloc(this.byteLength);return k.set(this),k}toString(){return A?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(k,I){return new m(this.buffer.subarray(k,I))}set(k,I){if(k instanceof m)this.buffer.set(k.buffer,I);else if(k instanceof Uint8Array)this.buffer.set(k,I);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),I);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,I){b(this.buffer,k,I)}readUInt32LE(k){return f(this.buffer,k)}writeUInt32LE(k,I){s(this.buffer,k,I)}readUInt8(k){return r(this.buffer,k)}writeUInt8(k,I){o(this.buffer,k,I)}indexOf(k,I=0){return E(this.buffer,k instanceof m?k.buffer:k,I)}}e.$He=m;function E(D,k,I=0){const P=k.byteLength,V=D.byteLength;if(P===0)return 0;if(P===1)return D.indexOf(k[0]);if(P>V-I)return-1;const W=N.value;W.fill(k.length);for(let G=0;G<k.length;G++)W[k[G]]=k.length-G-1;let q=I+k.length-1,M=q,z=-1;for(;q<V;)if(D[q]===k[M]){if(M===0){z=q;break}q--,M--}else q+=Math.max(k.length-M,W[D[q]]),M=k.length-1;return z}function T(D,k){return D[k+0]<<0>>>0|D[k+1]<<8>>>0}function S(D,k,I){D[I+0]=k&255,k=k>>>8,D[I+1]=k&255}function l(D,k){return D[k]*2**24+D[k+1]*2**16+D[k+2]*2**8+D[k+3]}function b(D,k,I){D[I+3]=k,k=k>>>8,D[I+2]=k,k=k>>>8,D[I+1]=k,k=k>>>8,D[I]=k}function f(D,k){return D[k+0]<<0>>>0|D[k+1]<<8>>>0|D[k+2]<<16>>>0|D[k+3]<<24>>>0}function s(D,k,I){D[I+0]=k&255,k=k>>>8,D[I+1]=k&255,k=k>>>8,D[I+2]=k&255,k=k>>>8,D[I+3]=k&255}function r(D,k){return D[k]}function o(D,k,I){D[I]=k}function i(D){return O.$we(D,k=>m.concat(k))}function n(D){return O.$De(D)}function c(D){return O.$ye(D,k=>m.concat(k))}async function u(D){return D.ended?m.concat(D.buffer):m.concat([...D.buffer,await c(D.stream)])}function t(D){return O.$Be(D,k=>m.concat(k))}function g(D){return O.$Ee(D,{data:k=>typeof k=="string"?m.fromString(k):m.wrap(k)},k=>m.concat(k))}function a(D){return O.$ve(k=>m.concat(k),D)}function d(D,k){return O.$Fe(D,k,I=>m.concat(I))}function w(D,k){return O.$Ge(D,k,I=>m.concat(I))}function $(D){let k=0,I=0,P=0;const V=new Uint8Array(Math.floor(D.length/4*3)),W=M=>{switch(I){case 3:V[P++]=k|M,I=0;break;case 2:V[P++]=k|M>>>2,k=M<<6,I=3;break;case 1:V[P++]=k|M>>>4,k=M<<4,I=2;break;default:k=M<<2,I=1}};for(let M=0;M<D.length;M++){const z=D.charCodeAt(M);if(z>=65&&z<=90)W(z-65);else if(z>=97&&z<=122)W(z-97+26);else if(z>=48&&z<=57)W(z-48+52);else if(z===43||z===45)W(62);else if(z===47||z===95)W(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${D[M]}`)}}const q=P;for(;I>0;)W(0);return m.wrap(V).slice(0,q)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:D},k=!0,I=!1){const P=I?y:v;let V="";const W=D.byteLength%3;let q=0;for(;q<D.byteLength-W;q+=3){const M=D[q+0],z=D[q+1],G=D[q+2];V+=P[M>>>2],V+=P[(M<<4|z>>>4)&63],V+=P[(z<<2|G>>>6)&63],V+=P[G&63]}if(W===1){const M=D[q+0];V+=P[M>>>2],V+=P[M<<4&63],k&&(V+="==")}else if(W===2){const M=D[q+0],z=D[q+1];V+=P[M>>>2],V+=P[(M<<4|z>>>4)&63],V+=P[z<<2&63],k&&(V+="=")}return V}}),define(Se[135],Ie([1,0,28,128,13]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.FuzzyScore=e.$Ak=e.$zk=void 0,e.or=N,e.$Bk=p,e.$Ck=m,e.$Dk=S,e.$Ek=$,e.$Fk=v,e.$Gk=P,e.$Hk=V,e.$Ik=W,e.$Jk=q,e.$Kk=x,e.$Mk=we,e.$Nk=Y,e.$Ok=he;function N(...fe){return function(Pe,Me){for(let je=0,B=fe.length;je<B;je++){const L=fe[je](Pe,Me);if(L)return L}return null}}e.$zk=R.bind(void 0,!1),e.$Ak=R.bind(void 0,!0);function R(fe,Pe,Me){if(!Me||Me.length<Pe.length)return null;let je;return fe?je=A.$Af(Me,Pe):je=Me.indexOf(Pe)===0,je?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(fe,Pe){const Me=Pe.toLowerCase().indexOf(fe.toLowerCase());return Me===-1?null:[{start:Me,end:Me+fe.length}]}function m(fe,Pe){return E(fe.toLowerCase(),Pe.toLowerCase(),0,0)}function E(fe,Pe,Me,je){if(Me===fe.length)return[];if(je===Pe.length)return null;if(fe[Me]===Pe[je]){let B=null;return(B=E(fe,Pe,Me+1,je+1))?c({start:je,end:je+1},B):null}return E(fe,Pe,Me,je+1)}function T(fe){return 97<=fe&&fe<=122}function S(fe){return 65<=fe&&fe<=90}function l(fe){return 48<=fe&&fe<=57}function b(fe){return fe===32||fe===9||fe===10||fe===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>f.add(fe.charCodeAt(0)));function s(fe){return b(fe)||f.has(fe)}function r(fe,Pe){return fe===Pe||s(fe)&&s(Pe)}const o=new Map;function i(fe){if(o.has(fe))return o.get(fe);let Pe;const Me=(0,O.$xk)(fe);return Me&&(Pe=Me),o.set(fe,Pe),Pe}function n(fe){return T(fe)||S(fe)||l(fe)}function c(fe,Pe){return Pe.length===0?Pe=[fe]:fe.end===Pe[0].start?Pe[0].start=fe.start:Pe.unshift(fe),Pe}function u(fe,Pe){for(let Me=Pe;Me<fe.length;Me++){const je=fe.charCodeAt(Me);if(S(je)||l(je)||Me>0&&!n(fe.charCodeAt(Me-1)))return Me}return fe.length}function t(fe,Pe,Me,je){if(Me===fe.length)return[];if(je===Pe.length)return null;if(fe[Me]!==Pe[je].toLowerCase())return null;{let B=null,L=je+1;for(B=t(fe,Pe,Me+1,je+1);!B&&(L=u(Pe,L))<Pe.length;)B=t(fe,Pe,Me+1,L),L++;return B===null?null:c({start:je,end:je+1},B)}}function g(fe){let Pe=0,Me=0,je=0,B=0,L=0;for(let Te=0;Te<fe.length;Te++)L=fe.charCodeAt(Te),S(L)&&Pe++,T(L)&&Me++,n(L)&&je++,l(L)&&B++;const K=Pe/fe.length,H=Me/fe.length,ee=je/fe.length,re=B/fe.length;return{upperPercent:K,lowerPercent:H,alphaPercent:ee,numericPercent:re}}function a(fe){const{upperPercent:Pe,lowerPercent:Me}=fe;return Me===0&&Pe>.6}function d(fe){const{upperPercent:Pe,lowerPercent:Me,alphaPercent:je,numericPercent:B}=fe;return Me>.2&&Pe<.8&&je>.6&&B<.2}function w(fe){let Pe=0,Me=0,je=0,B=0;for(let L=0;L<fe.length;L++)je=fe.charCodeAt(L),S(je)&&Pe++,T(je)&&Me++,b(je)&&B++;return(Pe===0||Me===0)&&B===0?fe.length<=30:Pe<=5}function $(fe,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!w(fe))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Me=g(Pe);if(!d(Me)){if(!a(Me))return null;Pe=Pe.toLowerCase()}let je=null,B=0;for(fe=fe.toLowerCase();B<Pe.length&&(je=t(fe,Pe,0,B))===null;)B=u(Pe,B+1);return je}function v(fe,Pe,Me=!1){if(!Pe||Pe.length===0)return null;let je=null,B=0;for(fe=fe.toLowerCase(),Pe=Pe.toLowerCase();B<Pe.length&&(je=y(fe,Pe,0,B,Me),je===null);)B=h(Pe,B+1);return je}function y(fe,Pe,Me,je,B){let L=0;if(Me===fe.length)return[];if(je===Pe.length)return null;if(!r(fe.charCodeAt(Me),Pe.charCodeAt(je))){const ee=i(fe.charCodeAt(Me));if(!ee)return null;for(let re=0;re<ee.length;re++)if(!r(ee[re],Pe.charCodeAt(je+re)))return null;L+=ee.length-1}let K=null,H=je+L+1;if(K=y(fe,Pe,Me+1,H,B),!B)for(;!K&&(H=h(Pe,H))<Pe.length;)K=y(fe,Pe,Me+1,H,B),H++;if(!K)return null;if(fe.charCodeAt(Me)!==Pe.charCodeAt(je)){const ee=i(fe.charCodeAt(Me));if(!ee)return K;for(let re=0;re<ee.length;re++)if(ee[re]!==Pe.charCodeAt(je+re))return K}return c({start:je,end:je+L+1},K)}function h(fe,Pe){for(let Me=Pe;Me<fe.length;Me++)if(s(fe.charCodeAt(Me))||Me>0&&s(fe.charCodeAt(Me-1)))return Me;return fe.length}const D=N(e.$Ak,$,p),k=N(e.$Ak,$,m),I=new C.$Dc(1e4);function P(fe,Pe,Me=!1){if(typeof fe!="string"||typeof Pe!="string")return null;let je=I.get(fe);je||(je=new RegExp(A.$if(fe),"i"),I.set(fe,je));const B=je.exec(Pe);return B?[{start:B.index,end:B.index+B[0].length}]:Me?k(fe,Pe):D(fe,Pe)}function V(fe,Pe){const Me=we(fe,fe.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?q(Me):null}function W(fe,Pe,Me,je,B,L){const K=Math.min(13,fe.length);for(;Me<K;Me++){const H=we(fe,Pe,Me,je,B,L,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,L]}function q(fe){if(typeof fe>"u")return[];const Pe=[],Me=fe[1];for(let je=fe.length-1;je>1;je--){const B=fe[je]+Me,L=Pe[Pe.length-1];L&&L.end===B?L.end=B+1:Pe.push({start:B,end:B+1})}return Pe}const M=128;function z(){const fe=[],Pe=[];for(let Me=0;Me<=M;Me++)Pe[Me]=0;for(let Me=0;Me<=M;Me++)fe.push(Pe.slice(0));return fe}function G(fe){const Pe=[];for(let Me=0;Me<=fe;Me++)Pe[Me]=0;return Pe}const ie=G(2*M),de=G(2*M),ye=z(),Ee=z(),me=z(),ue=!1;function Ce(fe,Pe,Me,je,B){function L(H,ee,re=" "){for(;H.length<ee;)H=re+H;return H}let K=` |   |${je.split("").map(H=>L(H,3)).join("|")}
`;for(let H=0;H<=Me;H++)H===0?K+=" |":K+=`${Pe[H-1]}|`,K+=fe[H].slice(0,B+1).map(ee=>L(ee.toString(),3)).join("|")+`
`;return K}function se(fe,Pe,Me,je){fe=fe.substr(Pe),Me=Me.substr(je),console.log(Ce(Ee,fe,fe.length,Me,Me.length)),console.log(Ce(me,fe,fe.length,Me,Me.length)),console.log(Ce(ye,fe,fe.length,Me,Me.length))}function Oe(fe,Pe){if(Pe<0||Pe>=fe.length)return!1;const Me=fe.codePointAt(Pe);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.$Sf(Me)}}function ne(fe,Pe){if(Pe<0||Pe>=fe.length)return!1;switch(fe.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function U(fe,Pe,Me){return Pe[fe]!==Me[fe]}function x(fe,Pe,Me,je,B,L,K=!1){for(;Pe<Me&&B<L;)fe[Pe]===je[B]&&(K&&(ie[Pe]=B),Pe+=1),B+=1;return Pe===Me}var ve;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Fe;(function(fe){fe.Default=[-100,0];function Pe(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}fe.isDefault=Pe})(Fe||(e.FuzzyScore=Fe={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Me){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Me}}e.$Lk=ke;function we(fe,Pe,Me,je,B,L,K=ke.default){const H=fe.length>M?M:fe.length,ee=je.length>M?M:je.length;if(Me>=H||L>=ee||H-Me>ee-L||!x(Pe,Me,H,B,L,ee,!0))return;ge(H,ee,Me,L,Pe,B);let re=1,Te=1,Be=Me,He=L;const _e=[!1];for(re=1,Be=Me;Be<H;re++,Be++){const at=ie[Be],gt=de[Be],Ue=Be+1<H?de[Be+1]:ee;for(Te=at-L+1,He=at;He<Ue;Te++,He++){let rt=Number.MIN_SAFE_INTEGER,Z=!1;He<=gt&&(rt=Q(fe,Pe,Be,Me,je,B,He,ee,L,ye[re-1][Te-1]===0,_e));let X=0;rt!==Number.MAX_SAFE_INTEGER&&(Z=!0,X=rt+Ee[re-1][Te-1]);const $e=He>at,Ke=$e?Ee[re][Te-1]+(ye[re][Te-1]>0?-5:0):0,be=He>at+1&&ye[re][Te-1]>0,st=be?Ee[re][Te-2]+(ye[re][Te-2]>0?-5:0):0;if(be&&(!$e||st>=Ke)&&(!Z||st>=X))Ee[re][Te]=st,me[re][Te]=3,ye[re][Te]=0;else if($e&&(!Z||Ke>=X))Ee[re][Te]=Ke,me[re][Te]=2,ye[re][Te]=0;else if(Z)Ee[re][Te]=X,me[re][Te]=1,ye[re][Te]=ye[re-1][Te-1]+1;else throw new Error("not possible")}}if(ue&&se(fe,Me,je,L),!_e[0]&&!K.firstMatchCanBeWeak)return;re--,Te--;const xe=[Ee[re][Te],L];let et=0,tt=0;for(;re>=1;){let at=Te;do{const gt=me[re][at];if(gt===3)at=at-2;else if(gt===2)at=at-1;else break}while(at>=1);et>1&&Pe[Me+re-1]===B[L+Te-1]&&!U(at+L-1,je,B)&&et+1>ye[re][at]&&(at=Te),at===Te?et++:et=1,tt||(tt=at),re--,Te=at-1,xe.push(Te)}ee-L===H&&K.boostFullMatch&&(xe[0]+=2);const it=tt-H;return xe[0]-=it,xe}function ge(fe,Pe,Me,je,B,L){let K=fe-1,H=Pe-1;for(;K>=Me&&H>=je;)B[K]===L[H]&&(de[K]=H,K--),H--}function Q(fe,Pe,Me,je,B,L,K,H,ee,re,Te){if(Pe[Me]!==L[K])return Number.MIN_SAFE_INTEGER;let Be=1,He=!1;return K===Me-je?Be=fe[Me]===B[K]?7:5:U(K,B,L)&&(K===0||!U(K-1,B,L))?(Be=fe[Me]===B[K]?7:5,He=!0):Oe(L,K)&&(K===0||!Oe(L,K-1))?Be=5:(Oe(L,K-1)||ne(L,K-1))&&(Be=5,He=!0),Be>1&&Me===je&&(Te[0]=!0),He||(He=U(K,B,L)||Oe(L,K-1)||ne(L,K-1)),Me===je?K>ee&&(Be-=He?3:5):re?Be+=He?2:0:Be+=He?0:1,K+1===H&&(Be-=He?3:5),Be}function Y(fe,Pe,Me,je,B,L,K){return ce(fe,Pe,Me,je,B,L,!0,K)}function he(fe,Pe,Me,je,B,L,K){return ce(fe,Pe,Me,je,B,L,!1,K)}function ce(fe,Pe,Me,je,B,L,K,H){let ee=we(fe,Pe,Me,je,B,L,H);if(ee&&!K)return ee;if(fe.length>=3){const re=Math.min(7,fe.length-1);for(let Te=Me+1;Te<re;Te++){const Be=Ne(fe,Te);if(Be){const He=we(Be,Be.toLowerCase(),Me,je,B,L,H);He&&(He[0]-=3,(!ee||He[0]>ee[0])&&(ee=He))}}}return ee}function Ne(fe,Pe){if(Pe+1>=fe.length)return;const Me=fe[Pe],je=fe[Pe+1];if(Me!==je)return fe.slice(0,Pe)+je+Me+fe.slice(Pe+2)}}),define(Se[32],Ie([1,0,13]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(O||(O={})),function(A){const N="error",R="warning",p="warn",m="info",E="ignore";function T(l){return l?C.$zf(N,l)?A.Error:C.$zf(R,l)||C.$zf(p,l)?A.Warning:C.$zf(m,l)?A.Info:A.Ignore:A.Ignore}A.fromValue=T;function S(l){switch(l){case A.Error:return N;case A.Warning:return R;case A.Info:return m;default:return E}}A.toString=S}(O||(O={})),e.default=O}),define(Se[136],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(Se[54],Ie([1,0,18,13]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class A{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const f=b.charCodeAt(0),s=this.b.charCodeAt(this.c);return f-s}value(){return this.b[this.c]}}e.$Ai=A;class N{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,O.$tf)(b,this.b,0,b.length,this.c,this.d):(0,O.$vf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Bi=N;class R{constructor(b=!0,f=!0){this.f=b,this.g=f}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let f=b.length-1;f>=0;f--,this.c--){const s=this.b.charCodeAt(f);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,O.$tf)(b,this.b,0,b.length,this.d,this.e):(0,O.$vf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ci=R;var p;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(p||(p={}));class m{constructor(b,f){this.f=b,this.g=f,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,O.$uf)(b,this.c.scheme);if(this.d[this.e]===2)return(0,O.$uf)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,O.$sf)(b,this.c.query);if(this.d[this.e]===5)return(0,O.$sf)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Di=m;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(T||(T={}));class S{static forUris(b=()=>!1,f=()=>!1){return new S(new m(b,f))}static forPaths(b=!1){return new S(new R(void 0,!b))}static forStrings(){return new S(new A)}static forConfigKeys(){return new S(new N)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,f){if(f){const s=f.slice(0);(0,C.$Wb)(s);for(const r of s)this.set(r,b)}else{const s=b.slice(0);(0,C.$Wb)(s);for(const r of s)this.set(r[0],r[1])}}set(b,f){const s=this.b.reset(b);let r;this.c||(this.c=new E,this.c.segment=s.value());const o=[];for(r=this.c;;){const n=s.cmp(r.segment);if(n>0)r.left||(r.left=new E,r.left.segment=s.value()),o.push([-1,r]),r=r.left;else if(n<0)r.right||(r.right=new E,r.right.segment=s.value()),o.push([1,r]),r=r.right;else if(s.hasNext())s.next(),r.mid||(r.mid=new E,r.mid.segment=s.value()),o.push([0,r]),r=r.mid;else break}const i=r.value;r.value=f,r.key=b;for(let n=o.length-1;n>=0;n--){const c=o[n][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const t=o[n][0],g=o[n+1][0];if(t===1&&g===1)o[n][1]=c.rotateLeft();else if(t===-1&&g===-1)o[n][1]=c.rotateRight();else if(t===1&&g===-1)c.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=c.rotateLeft();else if(t===-1&&g===1)c.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=c.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(b){return this.d(b)?.value}d(b){const f=this.b.reset(b);let s=this.c;for(;s;){const r=f.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(f.hasNext())f.next(),s=s.mid;else break}return s}has(b){const f=this.d(b);return!(f?.value===void 0&&f?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,f){const s=this.b.reset(b),r=[];let o=this.c;for(;o;){const i=s.cmp(o.segment);if(i>0)r.push([-1,o]),o=o.left;else if(i<0)r.push([1,o]),o=o.right;else if(s.hasNext())s.next(),r.push([0,o]),o=o.mid;else break}if(o){if(f?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:c,segment:u}=i;this.e(i.key,!1),o.key=n,o.value=c,o.segment=u}}else{const i=o.left??o.right;if(r.length>0){const[n,c]=r[r.length-1];switch(n){case-1:c.left=i;break;case 0:c.mid=i;break;case 1:c.right=i;break}}else this.c=i}for(let i=r.length-1;i>=0;i--){const n=r[i][1];n.updateHeight();const c=n.balanceFactor();if(c>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),r[i][1]=n.rotateLeft()):c<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),r[i][1]=n.rotateRight()),i>0)switch(r[i-1][0]){case-1:r[i-1][1].left=r[i][1];break;case 1:r[i-1][1].right=r[i][1];break;case 0:r[i-1][1].mid=r[i][1];break}else this.c=r[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const f=this.b.reset(b);let s=this.c,r;for(;s;){const o=f.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(f.hasNext())f.next(),r=s.value||r,s=s.mid;else break}return s&&s.value||r}findSuperstr(b){return this.g(b,!1)}g(b,f){const s=this.b.reset(b);let r=this.c;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this.h(r.mid):f?r.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[f,s]of this)b(s,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const f=[];return this.j(b,f),f[Symbol.iterator]()}j(b,f){b&&(b.left&&this.j(b.left,f),b.value&&f.push([b.key,b.value]),b.mid&&this.j(b.mid,f),b.right&&this.j(b.right,f))}_isBalanced(){const b=f=>{if(!f)return!0;const s=f.balanceFactor();return s<-1||s>1?!1:b(f.left)&&b(f.right)};return b(this.c)}}e.$Ei=S}),define(Se[36],Ie([1,0,92]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Yj=A;var O;(function(R){function p(m){return m&&typeof m=="object"&&typeof m.id=="string"}R.isThemeColor=p})(O||(e.ThemeColor=O={}));function A(R){return{id:R}}var N;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function m(i){const n=p.exec(i.id);if(!n)return m(C.$Xj.error);const[,c,u]=n,t=["codicon","codicon-"+c];return u&&t.push("codicon-modifier-"+u.substring(1)),t}R.asClassNameArray=m;function E(i){return m(i).join(" ")}R.asClassName=E;function T(i){return"."+m(i).join(".")}R.asCSSSelector=T;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||O.isThemeColor(i.color))}R.isThemeIcon=S;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function b(i){const n=l.exec(i);if(!n)return;const[,c]=n;return{id:c}}R.fromString=b;function f(i){return{id:i}}R.fromId=f;function s(i,n){let c=i.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),n&&(c=`${c}~${n}`),{id:c}}R.modify=s;function r(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=r;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=o})(N||(e.ThemeIcon=N={}))}),define(Se[137],Ie([1,0,135,13,36]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=m,e.$Qk=T,e.$Rk=l,e.$Sk=b,e.$Tk=s,e.$Uk=r;const N="$(",R=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${R.source}`,"g");function m(o){return o.replace(p,(i,n)=>n?i:`\\${i}`)}const E=new RegExp(`\\\\${R.source}`,"g");function T(o){return o.replace(E,i=>`\\${i}`)}const S=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(o){return o.indexOf(N)===-1?o:o.replace(S,(i,n,c,u)=>c?i:n||u||"")}function b(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const f=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(o){f.lastIndex=0;let i="";const n=[];let c=0;for(;;){const u=f.lastIndex,t=f.exec(o),g=o.substring(u,t?.index);if(g.length>0){i+=g;for(let a=0;a<g.length;a++)n.push(c)}if(!t)break;c+=t[0].length}return{text:i,iconOffsets:n}}function r(o,i,n=!1){const{text:c,iconOffsets:u}=i;if(!u||u.length===0)return(0,C.$Gk)(o,c,n);const t=(0,O.$gf)(c," "),g=c.length-t.length,a=(0,C.$Gk)(o,t,n);if(a)for(const d of a){const w=u[d.start+g]+g;d.start+=w,d.end+=w}return a}}),define(Se[33],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=O;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(A){return C.test(A)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(p){for(let m=0;m<p.length;m++)p[m]=Math.floor(Math.random()*256);return p};const N=new Uint8Array(16),R=[];for(let p=0;p<256;p++)R.push(p.toString(16).padStart(2,"0"));return function(){A(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let m=0,E="";return E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+="-",E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E+=R[N[m++]],E}}()}),define(Se[138],Ie([1,0,18,42,33]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=e.$Vt=void 0,e.$Tt=N,e.$Ut=R,e.$Wt=E;function N(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function R(S,l,b){const f={id:(0,A.$Ug)(),name:S,uri:l,data:b};return{asString:async()=>"",asFile:()=>f,value:void 0}}class p{constructor(){this.a=new Map}get size(){let l=0;for(const b of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const b=[...this.a.keys()];return O.Iterable.some(this,([f,s])=>s.asFile())&&b.push("files"),T(m(l),b)}get(l){return this.a.get(this.b(l))?.[0]}append(l,b){const f=this.a.get(l);f?f.push(b):this.a.set(this.b(l),[b])}replace(l,b){this.a.set(this.b(l),[b])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,b]of this.a)for(const f of b)yield[l,f]}b(l){return m(l)}}e.$Vt=p;function m(S){return S.toLowerCase()}function E(S,l){return T(m(S),l.map(m))}function T(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const b=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[f,s,r]=b;return r==="*"?l.some(o=>o.startsWith(s+"/")):!1}e.$Xt=Object.freeze({create:S=>(0,C.$Mb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$Xt.split(S).filter(l=>!l.startsWith("#"))})}),define(Se[139],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$4t=O;var C;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function O(A){let N=0,R=0,p=0,m=0;for(let E=0,T=A.length;E<T;E++){const S=A.charCodeAt(E);S===13?(N===0&&(R=E),N++,E+1<T&&A.charCodeAt(E+1)===10?(m|=2,E++):m|=3,p=E+1):S===10&&(m|=1,N===0&&(R=E),N++,p=E+1)}return N===0&&(R=A.length),[N,R,A.length-p,m]}}),define(Se[140],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=void 0,e.$7s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[141],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=e.$nu=e.IndentAction=void 0;var C;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class O{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let m=0,E=p.notIn.length;m<E;m++)switch(p.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,m){if(p.getTokenCount()===0)return!0;const E=p.findTokenIndexAtOffset(m-2),T=p.getStandardTokenType(E);return this.isOK(T)}g(p,m){for(let E=p;E<=m;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$nu=O;class A{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of p)N(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),N(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),N(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),N(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&N(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$ou=A;function N(R,p,m){R.has(p)?R.get(p).push(m):R.set(p,[m])}}),define(Se[142],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.NodeColor=e.$IC=void 0,e.$KC=A,e.$LC=N,e.$MC=E,e.$NC=T,e.$OC=S,e.$PC=l,e.$QC=b,e.$RC=f;class C{constructor(r,o){this.piece=r,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$JC)return A(this.right);let r=this;for(;r.parent!==e.$JC&&r.parent.left!==r;)r=r.parent;return r.parent===e.$JC?e.$JC:r.parent}prev(){if(this.left!==e.$JC)return N(this.left);let r=this;for(;r.parent!==e.$JC&&r.parent.right!==r;)r=r.parent;return r.parent===e.$JC?e.$JC:r.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$IC=C;var O;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$JC=new C(null,0),e.$JC.parent=e.$JC,e.$JC.left=e.$JC,e.$JC.right=e.$JC,e.$JC.color=0;function A(s){for(;s.left!==e.$JC;)s=s.left;return s}function N(s){for(;s.right!==e.$JC;)s=s.right;return s}function R(s){return s===e.$JC?0:s.size_left+s.piece.length+R(s.right)}function p(s){return s===e.$JC?0:s.lf_left+s.piece.lineFeedCnt+p(s.right)}function m(){e.$JC.parent=e.$JC}function E(s,r){const o=r.right;o.size_left+=r.size_left+(r.piece?r.piece.length:0),o.lf_left+=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),r.right=o.left,o.left!==e.$JC&&(o.left.parent=r),o.parent=r.parent,r.parent===e.$JC?s.root=o:r.parent.left===r?r.parent.left=o:r.parent.right=o,o.left=r,r.parent=o}function T(s,r){const o=r.left;r.left=o.right,o.right!==e.$JC&&(o.right.parent=r),o.parent=r.parent,r.size_left-=o.size_left+(o.piece?o.piece.length:0),r.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),r.parent===e.$JC?s.root=o:r===r.parent.right?r.parent.right=o:r.parent.left=o,o.right=r,r.parent=o}function S(s,r){let o,i;if(r.left===e.$JC?(i=r,o=i.right):r.right===e.$JC?(i=r,o=i.left):(i=A(r.right),o=i.right),i===s.root){s.root=o,o.color=0,r.detach(),m(),s.root.parent=e.$JC;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===r?(o.parent=i.parent,f(s,o)):(i.parent===r?o.parent=i:o.parent=i.parent,f(s,o),i.left=r.left,i.right=r.right,i.parent=r.parent,i.color=r.color,r===s.root?s.root=i:r===r.parent.left?r.parent.left=i:r.parent.right=i,i.left!==e.$JC&&(i.left.parent=i),i.right!==e.$JC&&(i.right.parent=i),i.size_left=r.size_left,i.lf_left=r.lf_left,f(s,i)),r.detach(),o.parent.left===o){const u=R(o),t=p(o);if(u!==o.parent.size_left||t!==o.parent.lf_left){const g=u-o.parent.size_left,a=t-o.parent.lf_left;o.parent.size_left=u,o.parent.lf_left=t,b(s,o.parent,g,a)}}if(f(s,o.parent),n){m();return}let c;for(;o!==s.root&&o.color===0;)o===o.parent.left?(c=o.parent.right,c.color===1&&(c.color=0,o.parent.color=1,E(s,o.parent),c=o.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.right.color===0&&(c.left.color=0,c.color=1,T(s,c),c=o.parent.right),c.color=o.parent.color,o.parent.color=0,c.right.color=0,E(s,o.parent),o=s.root)):(c=o.parent.left,c.color===1&&(c.color=0,o.parent.color=1,T(s,o.parent),c=o.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(s,c),c=o.parent.left),c.color=o.parent.color,o.parent.color=0,c.left.color=0,T(s,o.parent),o=s.root));o.color=0,m()}function l(s,r){for(f(s,r);r!==s.root&&r.parent.color===1;)if(r.parent===r.parent.parent.left){const o=r.parent.parent.right;o.color===1?(r.parent.color=0,o.color=0,r.parent.parent.color=1,r=r.parent.parent):(r===r.parent.right&&(r=r.parent,E(s,r)),r.parent.color=0,r.parent.parent.color=1,T(s,r.parent.parent))}else{const o=r.parent.parent.left;o.color===1?(r.parent.color=0,o.color=0,r.parent.parent.color=1,r=r.parent.parent):(r===r.parent.left&&(r=r.parent,T(s,r)),r.parent.color=0,r.parent.parent.color=1,E(s,r.parent.parent))}s.root.color=0}function b(s,r,o,i){for(;r!==s.root&&r!==e.$JC;)r.parent.left===r&&(r.parent.size_left+=o,r.parent.lf_left+=i),r=r.parent}function f(s,r){let o=0,i=0;if(r!==s.root){for(;r!==s.root&&r===r.parent.right;)r=r.parent;if(r!==s.root)for(r=r.parent,o=R(r.left)-r.size_left,i=p(r.left)-r.lf_left,r.size_left+=o,r.lf_left+=i;r!==s.root&&(o!==0||i!==0);)r.parent.left===r&&(r.parent.size_left+=o,r.parent.lf_left+=i),r=r.parent}}}),define(Se[93],Ie([1,0,94,30,95,142,96]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3C=e.$2C=e.$1C=void 0,e.$YC=T,e.$ZC=S;const p=65535;function m(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class E{constructor(i,n,c,u,t){this.lineStarts=i,this.cr=n,this.lf=c,this.crlf=u,this.isBasicASCII=t}}function T(o,i=!0){const n=[0];let c=1;for(let u=0,t=o.length;u<t;u++){const g=o.charCodeAt(u);g===13?u+1<t&&o.charCodeAt(u+1)===10?(n[c++]=u+2,u++):n[c++]=u+1:g===10&&(n[c++]=u+1)}return i?m(n):n}function S(o,i){o.length=0,o[0]=0;let n=1,c=0,u=0,t=0,g=!0;for(let d=0,w=i.length;d<w;d++){const $=i.charCodeAt(d);$===13?d+1<w&&i.charCodeAt(d+1)===10?(t++,o[n++]=d+2,d++):(c++,o[n++]=d+1):$===10?(u++,o[n++]=d+1):g&&$!==9&&($<32||$>126)&&(g=!1)}const a=new E(m(o),c,u,t,g);return o.length=0,a}class l{constructor(i,n,c,u,t){this.bufferIndex=i,this.start=n,this.end=c,this.lineFeedCnt=u,this.length=t}}e.$1C=l;class b{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$2C=b;class f{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==N.$JC&&i.iterate(i.root,c=>(c!==N.$JC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartOffset<=i&&c.nodeStartOffset+c.node.piece.length>=i)return c}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<i&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=i)return c}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const c=this.b;for(let u=0;u<c.length;u++){const t=c[u];if(t.node.parent===null||t.nodeStartOffset>=i){c[u]=null,n=!0;continue}}if(n){const u=[];for(const t of c)t!==null&&u.push(t);this.b=u}}}class r{constructor(i,n,c){this.create(i,n,c)}create(i,n,c){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=N.$JC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=c;let u=null;for(let t=0,g=i.length;t<g;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=T(i[t].buffer));const a=new l(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),u=this.S(u,a)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,c=n-Math.floor(n/3),u=c*2;let t="",g=0;const a=[];if(this.iterate(this.root,d=>{const w=this.R(d),$=w.length;if(g<=c||g+$<u)return t+=w,g+=$,!0;const v=t.replace(/\r\n|\r|\n/g,i);return a.push(new b(v,T(v))),t=w,g=$,!0}),g>0){const d=t.replace(/\r\n|\r|\n/g,i);a.push(new b(d,T(d)))}this.create(a,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new f(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,u=>{if(u===N.$JC)return!0;const t=this.R(u),g=t.length,a=i.G(n),d=i.G(n+g),w=i.getValueInRange2(a,d);return n+=g,t===w})}getOffsetAt(i,n){let c=0,u=this.root;for(;u!==N.$JC;)if(u.left!==N.$JC&&u.lf_left+1>=i)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=i){c+=u.size_left;const t=this.B(u,i-u.lf_left-2);return c+=t+n-1}else i-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right;return c}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,c=0;const u=i;for(;n!==N.$JC;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(c+=n.lf_left+t.index,t.index===0){const g=this.getOffsetAt(c+1,1),a=u-g;return new C.$wt(c+1,a+1)}return new C.$wt(c+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,c+=n.lf_left+n.piece.lineFeedCnt,n.right===N.$JC){const t=this.getOffsetAt(c+1,1),g=u-i-t;return new C.$wt(c+1,g+1)}else n=n.right;return new C.$wt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const c=this.H(i.startLineNumber,i.startColumn),u=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(c,u);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const a=i.node,d=this.a[a.piece.bufferIndex].buffer,w=this.u(a.piece.bufferIndex,a.piece.start);return d.substring(w+i.remainder,w+n.remainder)}let c=i.node;const u=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let g=u.substring(t+i.remainder,t+c.piece.length);for(c=c.next();c!==N.$JC;){const a=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===n.node){g+=a.substring(d,d+n.remainder);break}else g+=a.substr(d,c.piece.length);c=c.next()}return g}getLinesContent(){const i=[];let n=0,c="",u=!1;return this.iterate(this.root,t=>{if(t===N.$JC)return!0;const g=t.piece;let a=g.length;if(a===0)return!0;const d=this.a[g.bufferIndex].buffer,w=this.a[g.bufferIndex].lineStarts,$=g.start.line,v=g.end.line;let y=w[$]+g.start.column;if(u&&(d.charCodeAt(y)===10&&(y++,a--),i[n++]=c,c="",u=!1,a===0))return!0;if($===v)return!this.f&&d.charCodeAt(y+a-1)===13?(u=!0,c+=d.substr(y,a-1)):c+=d.substr(y,a),!0;c+=this.f?d.substring(y,Math.max(y,w[$+1]-this.e)):d.substring(y,w[$+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;for(let h=$+1;h<v;h++)c=this.f?d.substring(w[h],w[h+1]-this.e):d.substring(w[h],w[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;return!this.f&&d.charCodeAt(w[v]+g.end.column-1)===13?(u=!0,g.end.column===0?n--:c=d.substr(w[v],g.end.column-1)):c=d.substr(w[v],g.end.column),!0}),u&&(i[n++]=c,c=""),i[n++]=c,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const c=this.a[n.piece.bufferIndex],u=this.u(n.piece.bufferIndex,n.piece.start);return c.buffer.charCodeAt(u)}else{const n=this.a[i.node.piece.bufferIndex],u=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(u)}}getLineCharCode(i,n){const c=this.H(i,n+1);return this.l(c)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,c,u,t,g,a,d,w,$,v){const y=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start),D=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,g);let I;const P={line:0,column:0};let V,W;n._wordSeparators?(V=y.buffer.substring(D,k),W=q=>q+D,n.reset(0)):(V=y.buffer,W=q=>q,n.reset(D));do if(I=n.next(V),I){if(W(I.index)>=k)return $;this.s(i,W(I.index)-h,P);const q=this.t(i.piece.bufferIndex,t,P),M=P.line===t.line?P.column-t.column+u:P.column+1,z=M+I[0].length;if(v[$++]=(0,R.$UC)(new O.$xt(c+q,M,c+q,z),I,d),W(I.index)+I[0].length>=k||$>=w)return $}while(I);return $}findMatchesLineByLine(i,n,c,u){const t=[];let g=0;const a=new R.$XC(n.wordSeparators,n.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const w=this.H(i.endLineNumber,i.endColumn);if(w===null)return[];let $=this.s(d.node,d.remainder);const v=this.s(w.node,w.remainder);if(d.node===w.node)return this.findMatchesInNode(d.node,a,i.startLineNumber,i.startColumn,$,v,n,c,u,g,t),t;let y=i.startLineNumber,h=d.node;for(;h!==w.node;){const k=this.t(h.piece.bufferIndex,$,h.piece.end);if(k>=1){const P=this.a[h.piece.bufferIndex].lineStarts,V=this.u(h.piece.bufferIndex,h.piece.start),W=P[$.line+k],q=y===i.startLineNumber?i.startColumn:1;if(g=this.findMatchesInNode(h,a,y,q,$,this.s(h,W-V),n,c,u,g,t),g>=u)return t;y+=k}const I=y===i.startLineNumber?i.startColumn-1:0;if(y===i.endLineNumber){const P=this.getLineContent(y).substring(I,i.endColumn-1);return g=this.n(n,a,P,i.endLineNumber,I,g,t,c,u),t}if(g=this.n(n,a,this.getLineContent(y).substr(I),y,I,g,t,c,u),g>=u)return t;y++,d=this.H(y,1),h=d.node,$=this.s(d.node,d.remainder)}if(y===i.endLineNumber){const k=y===i.startLineNumber?i.startColumn-1:0,I=this.getLineContent(y).substring(k,i.endColumn-1);return g=this.n(n,a,I,i.endLineNumber,k,g,t,c,u),t}const D=y===i.startLineNumber?i.startColumn:1;return g=this.findMatchesInNode(w.node,a,y,D,$,v,n,c,u,g,t),t}n(i,n,c,u,t,g,a,d,w){const $=i.wordSeparators;if(!d&&i.simpleSearch){const y=i.simpleSearch,h=y.length,D=c.length;let k=-h;for(;(k=c.indexOf(y,k+h))!==-1;)if((!$||(0,R.$WC)($,c,D,k,h))&&(a[g++]=new A.$Iv(new O.$xt(u,k+1+t,u,k+1+h+t),null),g>=w))return g;return g}let v;n.reset(0);do if(v=n.next(c),v&&(a[g++]=(0,R.$UC)(new O.$xt(u,v.index+1+t,u,v.index+1+v[0].length+t),v,d),g>=w))return g;while(v);return g}insert(i,n,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==N.$JC){const{node:u,remainder:t,nodeStartOffset:g}=this.G(i),a=u.piece,d=a.bufferIndex,w=this.s(u,t);if(u.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&g+a.length===i&&n.length<p){this.F(u,n),this.y();return}if(g===i)this.o(n,u),this.h.validate(i);else if(g+u.piece.length>i){const $=[];let v=new l(a.bufferIndex,w,a.end,this.t(a.bufferIndex,w,a.end),this.u(d,a.end)-this.u(d,w));if(this.K()&&this.M(n)&&this.I(u,t)===10){const k={line:v.start.line+1,column:0};v=new l(v.bufferIndex,k,v.end,this.t(v.bufferIndex,k,v.end),v.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(u,t-1)===13){const k=this.s(u,t-1);this.C(u,k),n="\r"+n,u.piece.length===0&&$.push(u)}else this.C(u,w);else this.C(u,w);const y=this.w(n);v.length>0&&this.S(u,v);let h=u;for(let D=0;D<y.length;D++)h=this.S(h,y[D]);this.v($)}else this.q(n,u)}else{const u=this.w(n);let t=this.T(null,u[0]);for(let g=1;g<u.length;g++)t=this.S(t,u[g])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===N.$JC)return;const c=this.G(i),u=this.G(i+n),t=c.node,g=u.node;if(t===g){const y=this.s(t,c.remainder),h=this.s(t,u.remainder);if(c.nodeStartOffset===i){if(n===t.piece.length){const D=t.next();(0,N.$OC)(this,t),this.N(D),this.y();return}this.D(t,h),this.h.validate(i),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===i+n){this.C(t,y),this.O(t),this.y();return}this.E(t,y,h),this.y();return}const a=[],d=this.s(t,c.remainder);this.C(t,d),this.h.validate(i),t.piece.length===0&&a.push(t);const w=this.s(g,u.remainder);this.D(g,w),g.piece.length===0&&a.push(g);const $=t.next();for(let y=$;y!==N.$JC&&y!==g;y=y.next())a.push(y);const v=t.piece.length===0?t.prev():t;this.v(a),this.O(v),this.y()}o(i,n){const c=[];if(this.K()&&this.M(i)&&this.L(n)){const g=n.piece,a={line:g.start.line+1,column:0},d=new l(g.bufferIndex,a,g.end,this.t(g.bufferIndex,a,g.end),g.length-1);n.piece=d,i+=`
`,(0,N.$QC)(this,n,-1,-1),n.piece.length===0&&c.push(n)}const u=this.w(i);let t=this.T(n,u[u.length-1]);for(let g=u.length-2;g>=0;g--)t=this.T(t,u[g]);this.N(t),this.v(c)}q(i,n){this.Q(i,n)&&(i+=`
`);const c=this.w(i),u=this.S(n,c[0]);let t=u;for(let g=1;g<c.length;g++)t=this.S(t,c[g]);this.N(u)}s(i,n,c){const u=i.piece,t=i.piece.bufferIndex,g=this.a[t].lineStarts,d=g[u.start.line]+u.start.column+n;let w=u.start.line,$=u.end.line,v=0,y=0,h=0;for(;w<=$&&(v=w+($-w)/2|0,h=g[v],v!==$);)if(y=g[v+1],d<h)$=v-1;else if(d>=y)w=v+1;else break;return c?(c.line=v,c.column=d-h,null):{line:v,column:d-h}}t(i,n,c){if(c.column===0)return c.line-n.line;const u=this.a[i].lineStarts;if(c.line===u.length-1)return c.line-n.line;const t=u[c.line+1],g=u[c.line]+c.column;if(t>g+1)return c.line-n.line;const a=g-1;return this.a[i].buffer.charCodeAt(a)===13?c.line-n.line+1:c.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,N.$OC)(this,i[n])}w(i){if(i.length>p){const $=[];for(;i.length>p;){const y=i.charCodeAt(p-1);let h;y===13||y>=55296&&y<=56319?(h=i.substring(0,p-1),i=i.substring(p-1)):(h=i.substring(0,p),i=i.substring(p));const D=T(h);$.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:h.length-D[D.length-1]},D.length-1,h.length)),this.a.push(new b(h,D))}const v=T(i);return $.push(new l(this.a.length,{line:0,column:0},{line:v.length-1,column:i.length-v[v.length-1]},v.length-1,i.length)),this.a.push(new b(i,v)),$}let n=this.a[0].buffer.length;const c=T(i,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let $=0;$<c.length;$++)c[$]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let $=0;$<c.length;$++)c[$]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[g],d={line:g,column:a},w=new l(0,u,d,this.t(0,u,d),t-n);return this.g=d,[w]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let c=this.root,u="";const t=this.h.get2(i);if(t){c=t.node;const g=this.B(c,i-t.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===i)u=a.substring(d+g,d+c.piece.length);else{const w=this.B(c,i-t.nodeStartLineNumber);return a.substring(d+g,d+w-n)}}else{let g=0;const a=i;for(;c!==N.$JC;)if(c.left!==N.$JC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const d=this.B(c,i-c.lf_left-2),w=this.B(c,i-c.lf_left-1),$=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);return g+=c.size_left,this.h.set({node:c,nodeStartOffset:g,nodeStartLineNumber:a-(i-1-c.lf_left)}),$.substring(v+d,v+w-n)}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const d=this.B(c,i-c.lf_left-2),w=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);u=w.substring($+d,$+c.piece.length);break}else i-=c.lf_left+c.piece.lineFeedCnt,g+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==N.$JC;){const g=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return u+=g.substring(d,d+a-n),u}else{const a=this.u(c.piece.bufferIndex,c.piece.start);u+=g.substr(a,c.piece.length)}c=c.next()}return u}y(){let i=this.root,n=1,c=0;for(;i!==N.$JC;)n+=i.lf_left+i.piece.lineFeedCnt,c+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=c,this.h.validate(this.c)}A(i,n){const c=i.piece,u=this.s(i,n),t=u.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===n){const g=this.t(i.piece.bufferIndex,c.start,u);if(g!==t)return{index:g,remainder:0}}return{index:t,remainder:u.column}}B(i,n){if(n<0)return 0;const c=i.piece,u=this.a[c.bufferIndex].lineStarts,t=c.start.line+n+1;return t>c.end.line?u[c.end.line]+c.end.column-u[c.start.line]-c.start.column:u[t]-u[c.start.line]-c.start.column}C(i,n){const c=i.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),g=n,a=this.u(c.bufferIndex,g),d=this.t(c.bufferIndex,c.start,g),w=d-u,$=a-t,v=c.length+$;i.piece=new l(c.bufferIndex,c.start,g,d,v),(0,N.$QC)(this,i,$,w)}D(i,n){const c=i.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),g=n,a=this.t(c.bufferIndex,g,c.end),d=this.u(c.bufferIndex,g),w=a-u,$=t-d,v=c.length+$;i.piece=new l(c.bufferIndex,g,c.end,a,v),(0,N.$QC)(this,i,$,w)}E(i,n,c){const u=i.piece,t=u.start,g=u.end,a=u.length,d=u.lineFeedCnt,w=n,$=this.t(u.bufferIndex,u.start,w),v=this.u(u.bufferIndex,n)-this.u(u.bufferIndex,t);i.piece=new l(u.bufferIndex,u.start,w,$,v),(0,N.$QC)(this,i,v-a,$-d);const y=new l(u.bufferIndex,c,g,this.t(u.bufferIndex,c,g),this.u(u.bufferIndex,g)-this.u(u.bufferIndex,c)),h=this.S(i,y);this.N(h)}F(i,n){this.Q(n,i)&&(n+=`
`);const c=this.K()&&this.L(n)&&this.M(i),u=this.a[0].buffer.length;this.a[0].buffer+=n;const t=T(n,!1);for(let h=0;h<t.length;h++)t[h]+=u;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const g=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[g],d={line:g,column:a},w=i.piece.length+n.length,$=i.piece.lineFeedCnt,v=this.t(0,i.piece.start,d),y=v-$;i.piece=new l(i.piece.bufferIndex,i.piece.start,d,v,w),this.g=d,(0,N.$QC)(this,i,n.length,y)}G(i){let n=this.root;const c=this.h.get(i);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:i-c.nodeStartOffset};let u=0;for(;n!==N.$JC;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){u+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:u};return this.h.set(t),t}else i-=n.size_left+n.piece.length,u+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let c=this.root,u=0;for(;c!==N.$JC;)if(c.left!==N.$JC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const t=this.B(c,i-c.lf_left-2),g=this.B(c,i-c.lf_left-1);return u+=c.size_left,{node:c,remainder:Math.min(t+n-1,g),nodeStartOffset:u}}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const t=this.B(c,i-c.lf_left-2);if(t+n-1<=c.piece.length)return{node:c,remainder:t+n-1,nodeStartOffset:u};n-=c.piece.length-t;break}else i-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==N.$JC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),g=this.J(c);return{node:c,remainder:Math.min(n-1,t),nodeStartOffset:g}}else if(c.piece.length>=n-1){const t=this.J(c);return{node:c,remainder:n-1,nodeStartOffset:t}}else n-=c.piece.length;c=c.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const c=this.a[i.piece.bufferIndex],u=this.u(i.piece.bufferIndex,i.piece.start)+n;return c.buffer.charCodeAt(u)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===N.$JC||i.piece.lineFeedCnt===0)return!1;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,u=n.start.line,t=c[u]+n.start.column;return u===c.length-1||c[u+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===N.$JC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const c=[],u=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:u[i.piece.end.line]-u[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const g=i.piece.length-1,a=i.piece.lineFeedCnt-1;i.piece=new l(i.piece.bufferIndex,i.piece.start,t,a,g),(0,N.$QC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const d={line:n.piece.start.line+1,column:0},w=n.piece.length-1,$=this.t(n.piece.bufferIndex,d,n.piece.end);n.piece=new l(n.piece.bufferIndex,d,n.piece.end,$,w),(0,N.$QC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const v=this.w(`\r
`);this.S(i,v[0]);for(let y=0;y<c.length;y++)(0,N.$OC)(this,c[y])}Q(i,n){if(this.K()&&this.M(i)){const c=n.next();if(this.L(c)){if(i+=`
`,c.piece.length===1)(0,N.$OC)(this,c);else{const u=c.piece,t={line:u.start.line+1,column:0},g=u.length-1,a=this.t(u.bufferIndex,t,u.end);c.piece=new l(u.bufferIndex,t,u.end,a,g),(0,N.$QC)(this,c,-1,-1)}return!0}}return!1}iterate(i,n){if(i===N.$JC)return n(N.$JC);const c=this.iterate(i.left,n);return c&&n(i)&&this.iterate(i.right,n)}R(i){if(i===N.$JC)return"";const n=this.a[i.piece.bufferIndex],c=i.piece,u=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return n.buffer.substring(u,t)}getPieceContent(i){const n=this.a[i.bufferIndex],c=this.u(i.bufferIndex,i.start),u=this.u(i.bufferIndex,i.end);return n.buffer.substring(c,u)}S(i,n){const c=new N.$IC(n,1);if(c.left=N.$JC,c.right=N.$JC,c.parent=N.$JC,c.size_left=0,c.lf_left=0,this.root===N.$JC)this.root=c,c.color=0;else if(i.right===N.$JC)i.right=c,c.parent=i;else{const t=(0,N.$KC)(i.right);t.left=c,c.parent=t}return(0,N.$PC)(this,c),c}T(i,n){const c=new N.$IC(n,1);if(c.left=N.$JC,c.right=N.$JC,c.parent=N.$JC,c.size_left=0,c.lf_left=0,this.root===N.$JC)this.root=c,c.color=0;else if(i.left===N.$JC)i.left=c,c.parent=i;else{const u=(0,N.$LC)(i.left);u.right=c,c.parent=u}return(0,N.$PC)(this,c),c}U(i){let n="";return this.iterate(i,c=>(n+=this.R(c),!0)),n}}e.$3C=r}),define(Se[143],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0=e.$I0=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const R=this.a.get(N);return this.a.delete(N),R}}addDragOperationTransfer(N,R){this.a.set(N,R)}}e.$I0=C;class O{constructor(N){this.identifier=N}}e.$J0=O}),define(Se[144],Ie([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(Se[145],Ie([1,0,5,6,144]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=void 0,e.$ij=T;class N extends O.$Uc{constructor(l,b="",f="",s=!0,r){super(),this.h=this.B(new C.$fe),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=b,this.u=f,this.w=s,this.C=r}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,b){this.C&&await this.C(l)}}e.$dj=N;class R extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new C.$fe),this.onWillRun=this.f.event,this.m=this.B(new C.$fe),this.onDidRun=this.m.event}async run(l,b){if(!l.enabled)return;this.f.fire({action:l});let f;try{await this.u(l,b)}catch(s){f=s}this.m.fire({action:l,error:f})}async u(l,b){await l.run(b)}}e.$ej=R;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let b=[];for(const f of l)f.length&&(b.length?b=[...b,new p,...f]:b=f);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$fj=p;class m{get actions(){return this.a}constructor(l,b,f,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=b,this.class=s,this.a=f}async run(){}}e.$gj=m;class E extends N{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,A.localize(0,null),void 0,!1)}}e.$hj=E;function T(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...l)=>S.run(...l),tooltip:S.label}}}),define(Se[146],Ie([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(Se[147],Ie([1,0,146]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=E,e.$5m=T,e.$6m=S;const O=60,A=O*60,N=A*24,R=N*7,p=N*30,m=N*365;function E(l,b,f,s){typeof l!="number"&&(l=l.getTime());const r=Math.round((new Date().getTime()-l)/1e3);if(r<-30)return(0,C.localize)(0,null,E(new Date().getTime()+r*1e3,!1));if(!s&&r<30)return(0,C.localize)(1,null);let o;return r<O?(o=r,b?o===1?f?(0,C.localize)(2,null,o):(0,C.localize)(3,null,o):f?(0,C.localize)(4,null,o):(0,C.localize)(5,null,o):o===1?f?(0,C.localize)(6,null,o):(0,C.localize)(7,null,o):f?(0,C.localize)(8,null,o):(0,C.localize)(9,null,o)):r<A?(o=Math.floor(r/O),b?o===1?f?(0,C.localize)(10,null,o):(0,C.localize)(11,null,o):f?(0,C.localize)(12,null,o):(0,C.localize)(13,null,o):o===1?f?(0,C.localize)(14,null,o):(0,C.localize)(15,null,o):f?(0,C.localize)(16,null,o):(0,C.localize)(17,null,o)):r<N?(o=Math.floor(r/A),b?o===1?f?(0,C.localize)(18,null,o):(0,C.localize)(19,null,o):f?(0,C.localize)(20,null,o):(0,C.localize)(21,null,o):o===1?f?(0,C.localize)(22,null,o):(0,C.localize)(23,null,o):f?(0,C.localize)(24,null,o):(0,C.localize)(25,null,o)):r<R?(o=Math.floor(r/N),b?o===1?(0,C.localize)(26,null,o):(0,C.localize)(27,null,o):o===1?(0,C.localize)(28,null,o):(0,C.localize)(29,null,o)):r<p?(o=Math.floor(r/R),b?o===1?f?(0,C.localize)(30,null,o):(0,C.localize)(31,null,o):f?(0,C.localize)(32,null,o):(0,C.localize)(33,null,o):o===1?f?(0,C.localize)(34,null,o):(0,C.localize)(35,null,o):f?(0,C.localize)(36,null,o):(0,C.localize)(37,null,o)):r<m?(o=Math.floor(r/p),b?o===1?f?(0,C.localize)(38,null,o):(0,C.localize)(39,null,o):f?(0,C.localize)(40,null,o):(0,C.localize)(41,null,o):o===1?f?(0,C.localize)(42,null,o):(0,C.localize)(43,null,o):f?(0,C.localize)(44,null,o):(0,C.localize)(45,null,o)):(o=Math.floor(r/m),b?o===1?f?(0,C.localize)(46,null,o):(0,C.localize)(47,null,o):f?(0,C.localize)(48,null,o):(0,C.localize)(49,null,o):o===1?f?(0,C.localize)(50,null,o):(0,C.localize)(51,null,o):f?(0,C.localize)(52,null,o):(0,C.localize)(53,null,o))}function T(l,b){const f=Math.abs(l/1e3);return f<1?b?(0,C.localize)(54,null,l):(0,C.localize)(55,null,l):f<O?b?(0,C.localize)(56,null,Math.round(l)/1e3):(0,C.localize)(57,null,Math.round(l)/1e3):f<A?b?(0,C.localize)(58,null,Math.round(l/(1e3*O))):(0,C.localize)(59,null,Math.round(l/(1e3*O))):f<N?b?(0,C.localize)(60,null,Math.round(l/(1e3*A))):(0,C.localize)(61,null,Math.round(l/(1e3*A))):(0,C.localize)(62,null,Math.round(l/(1e3*N)))}function S(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[148],Ie([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(Se[44],Ie([1,0,18,15,148]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=m,e.$kj=E,e.$lj=T;function N(S,l){return l&&(S.stack||S.stacktrace)?A.localize(0,null,p(S),R(S.stack)||R(S.stacktrace)):p(S)}function R(S){return Array.isArray(S)?S.join(`
`):S}function p(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?A.localize(1,null,S.message):S.message||A.localize(2,null)}function m(S=null,l=!1){if(!S)return A.localize(3,null);if(Array.isArray(S)){const b=C.$Hb(S),f=m(b[0],l);return b.length>1?A.localize(4,null,f,b.length):f}if(O.$$f(S))return S;if(S.detail){const b=S.detail;if(b.error)return N(b.error,l);if(b.exception)return N(b.exception,l)}return S.stack?N(S,l):S.message?S.message:A.localize(5,null)}function E(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}function T(S,l){let b;return typeof S=="string"?b=new Error(S):b=S,b.actions=l,b}}),define(Se[149],Ie([1,0,43,19]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=p,e.$kr=m,e.$lr=E,e.$mr=T,e.$nr=S,e.$or=l,e.$pr=b,e.$qr=f,e.$rr=s,e.$sr=r,e.$tr=w,e.$ur=$,e.$vr=v;const A=new C.$V(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),N=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(y,h,D=!1){const k=y||"",I=h||"",P=A.value.collator.compare(k,I);return A.value.collatorIsNumeric&&P===0&&k!==I?k<I?-1:1:P}function m(y,h){const D=N.value.collator;return y=y||"",h=h||"",c(D,y,h)}function E(y,h){const D=N.value.collator;return y=y||"",h=h||"",a(y,h)||c(D,y,h)}function T(y,h){const D=N.value.collator;return y=y||"",h=h||"",g(y,h)||c(D,y,h)}function S(y,h){return y=y||"",h=h||"",y===h?0:y<h?-1:1}function l(y,h){const[D,k]=i(y),[I,P]=i(h);let V=A.value.collator.compare(k,P);if(V===0){if(A.value.collatorIsNumeric&&k!==P)return k<P?-1:1;if(V=A.value.collator.compare(D,I),A.value.collatorIsNumeric&&V===0&&D!==I)return D<I?-1:1}return V}function b(y,h){y=y||"",h=h||"";const D=n(y),k=n(h),I=N.value.collator,P=R.value.collator;return c(P,D,k)||c(I,y,h)}function f(y,h){y=y||"",h=h||"";const D=n(y),k=n(h),I=N.value.collator,P=R.value.collator;return c(P,D,k)||a(y,h)||c(I,y,h)}function s(y,h){y=y||"",h=h||"";const D=n(y),k=n(h),I=N.value.collator,P=R.value.collator;return c(P,D,k)||g(y,h)||c(I,y,h)}function r(y,h){y=y||"",h=h||"";const D=n(y).toLowerCase(),k=n(h).toLowerCase();return D!==k?D<k?-1:1:y!==h?y<h?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function i(y,h=!1){const D=y?o.exec(y):[];let k=[D&&D[1]||"",D&&D[3]||""];return h&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function n(y){const h=y?o.exec(y):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(y,h,D){const k=y.compare(h,D);return k!==0?k:h.length!==D.length?h.length<D.length?-1:1:0}function u(y){const h=y.charAt(0);return h.toLocaleUpperCase()!==h}function t(y){const h=y.charAt(0);return h.toLocaleLowerCase()!==h}function g(y,h){return u(y)&&t(h)?-1:t(y)&&u(h)?1:0}function a(y,h){return t(y)&&u(h)?-1:u(y)&&t(h)?1:0}function d(y,h,D=!1){return D||(y=y&&y.toLowerCase(),h=h&&h.toLowerCase()),y===h?0:y<h?-1:1}function w(y,h,D=!1){const k=y.split(O.sep),I=h.split(O.sep),P=k.length-1,V=I.length-1;let W,q;for(let M=0;;M++){if(W=P===M,q=V===M,W&&q)return p(k[M],I[M],D);if(W)return-1;if(q)return 1;const z=d(k[M],I[M],D);if(z!==0)return z}}function $(y,h,D){const k=y.toLowerCase(),I=h.toLowerCase(),P=v(y,h,D);if(P)return P;const V=k.endsWith(D),W=I.endsWith(D);if(V!==W)return V?-1:1;const q=p(k,I);return q!==0?q:k.localeCompare(I)}function v(y,h,D){const k=y.toLowerCase(),I=h.toLowerCase(),P=k.startsWith(D),V=I.startsWith(D);if(P!==V)return P?-1:1;if(P&&V){if(k.length<I.length)return-1;if(k.length>I.length)return 1}return 0}}),define(Se[48],Ie([1,0,19,23,13,15]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=R,e.$rg=p,e.$sg=m,e.$tg=E,e.$ug=T,e.$vg=f,e.$wg=s,e.$xg=r,e.$yg=o,e.$zg=i,e.$Ag=n,e.$Bg=c,e.$Cg=u,e.$Dg=t,e.$Eg=g,e.$Fg=a,e.$Gg=$;function R(v){return v===47||v===92}function p(v){return v.replace(/[\\/]/g,C.$gc.sep)}function m(v){return v.indexOf("/")===-1&&(v=p(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function E(v,y=C.$gc.sep){if(!v)return"";const h=v.length,D=v.charCodeAt(0);if(R(D)){if(R(v.charCodeAt(1))&&!R(v.charCodeAt(2))){let I=3;const P=I;for(;I<h&&!R(v.charCodeAt(I));I++);if(P!==I&&!R(v.charCodeAt(I+1))){for(I+=1;I<h;I++)if(R(v.charCodeAt(I)))return v.slice(0,I+1).replace(/[\\/]/g,y)}}return y}else if(o(D)&&v.charCodeAt(1)===58)return R(v.charCodeAt(2))?v.slice(0,2)+y:v.slice(0,2);let k=v.indexOf("://");if(k!==-1){for(k+=3;k<h;k++)if(R(v.charCodeAt(k)))return v.slice(0,k+1)}return""}function T(v){if(!O.$i||!v||v.length<5)return!1;let y=v.charCodeAt(0);if(y!==92||(y=v.charCodeAt(1),y!==92))return!1;let h=2;const D=h;for(;h<v.length&&(y=v.charCodeAt(h),y!==92);h++);return!(D===h||(y=v.charCodeAt(h+1),isNaN(y)||y===92))}const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(v,y=O.$i){const h=y?S:l;return!(!v||v.length===0||/^\s+$/.test(v)||(h.lastIndex=0,h.test(v))||y&&b.test(v)||v==="."||v===".."||y&&v[v.length-1]==="."||y&&v.length!==v.trim().length||v.length>255)}function s(v,y,h){const D=v===y;return!h||D?D:!v||!y?!1:(0,A.$zf)(v,y)}function r(v,y,h,D=C.sep){if(v===y)return!0;if(!v||!y||y.length>v.length)return!1;if(h){if(!(0,A.$Af)(v,y))return!1;if(y.length===v.length)return!0;let I=y.length;return y.charAt(y.length-1)===D&&I--,v.charAt(I)===D}return y.charAt(y.length-1)!==D&&(y+=D),v.indexOf(y)===0}function o(v){return v>=65&&v<=90||v>=97&&v<=122}function i(v,y){return O.$i&&v.endsWith(":")&&(v+=C.sep),(0,C.$ic)(v)||(v=(0,C.$jc)(y,v)),v=(0,C.$hc)(v),n(v)}function n(v){return O.$i?(v=(0,A.$hf)(v,C.sep),v.endsWith(":")&&(v+=C.sep)):(v=(0,A.$hf)(v,C.sep),v||(v=C.sep)),v}function c(v){const y=(0,C.$hc)(v);return O.$i?v.length>3?!1:u(y)&&(v.length===2||y.charCodeAt(2)===92):y===C.$gc.sep}function u(v,y=O.$i){return y?o(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}function t(v,y=O.$i){return u(v,y)?v[0]:void 0}function g(v,y,h){return y.length>v.length?-1:v===y?0:(h&&(v=v.toLowerCase(),y=y.toLowerCase()),v.indexOf(y))}function a(v){const y=v.split(":");let h,D,k;for(const I of y){const P=Number(I);(0,N.$cg)(P)?D===void 0?D=P:k===void 0&&(k=P):h=h?[h,I].join(":"):I}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:D!==void 0?D:void 0,column:k!==void 0?k:D!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function $(v,y,h=8){let D="";for(let I=0;I<h;I++){let P;I===0&&O.$i&&!y&&(h===3||h===4)?P=w:P=d,D+=P.charAt(Math.floor(Math.random()*P.length))}let k;return y?k=`${y}-${D}`:k=D,v?(0,C.$jc)(v,k):k}}),define(Se[70],Ie([1,0,19]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0,e.$Us=N,e.$Vs=R,e.$Ws=p,e.$Xs=E,e.$Ts=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(T){const S=(0,C.$oc)(T),l=O[S.toLowerCase()];return l!==void 0?l:R(T)}function R(T){const S=(0,C.$oc)(T);return A[S.toLowerCase()]}function p(T){for(const S in A)if(A[S]===T)return S}const m=/^(.+)\/(.+?)(;.+)?$/;function E(T,S){const l=m.exec(T);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:T}}),define(Se[49],Ie([1,0,22,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=A,e.$7h=N,e.$8h=p;function A(m){return JSON.stringify(m,R)}function N(m){let E=JSON.parse(m);return E=p(E),E}function R(m,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function p(m,E=0){if(!m||E>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return O.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof C.$He||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let T=0;T<m.length;++T)m[T]=p(m[T],E+1);else for(const T in m)Object.hasOwnProperty.call(m,T)&&(m[T]=p(m[T],E+1))}return m}}),define(Se[16],Ie([1,0,14,23,13,2,19]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Lg=e.$Kg=e.$Jg=e.Schemas=void 0,e.$Hg=m,e.$Ig=E,e.$Mg=S;var p;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(p||(e.Schemas=p={}));function m(f,s){return N.URI.isUri(f)?(0,A.$zf)(f.scheme,s):(0,A.$Af)(f,s+":")}function E(f,...s){return s.some(r=>m(f,r))}e.$Jg="vscode-tkn",e.$Kg="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,r){this.f=S(s,r)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,p.vscodeRemoteResource)}set(s,r,o){this.a[s]=r,this.b[s]=o}setConnectionToken(s,r){this.c[s]=r}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(u){return C.$1(u),s}const r=s.authority;let o=this.a[r];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const i=this.b[r],n=this.c[r];let c=`path=${encodeURIComponent(s.path)}`;return typeof n=="string"&&(c+=`&${e.$Kg}=${encodeURIComponent(n)}`),N.URI.from({scheme:O.$o?this.d:p.vscodeRemoteResource,authority:`${o}:${i}`,path:this.g,query:c})}}e.$Lg=new T;function S(f,s){return R.$gc.join(s??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Ng="vs/../../extensions",e.$Og="vs/../../node_modules",e.$Pg="vs/../../node_modules.asar",e.$Qg="vs/../../node_modules.asar.unpacked",e.$Rg="vscode-app";class l{static{this.a=e.$Rg}asBrowserUri(s){const r=this.b(s,le);return this.uriToBrowserUri(r)}uriToBrowserUri(s){return s.scheme===p.vscodeRemote?e.$Lg.rewrite(s):s.scheme===p.file&&(O.$m||O.$q===`${p.vscodeFileResource}://${l.a}`)?s.with({scheme:p.vscodeFileResource,authority:s.authority||l.a,query:null,fragment:null}):s}asFileUri(s){const r=this.b(s,le);return this.uriToFileUri(r)}uriToFileUri(s){return s.scheme===p.vscodeFileResource?s.with({scheme:p.file,authority:s.authority!==l.a?s.authority:null,query:null,fragment:null}):s}b(s,r){return N.URI.isUri(s)?s:N.URI.parse(r.toUrl(s))}}e.$Sg=new l;var b;(function(f){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(s.get("3"));const r="vscode-coi";function o(n){let c;typeof n=="string"?c=new URL(n).searchParams:n instanceof URL?c=n.searchParams:N.URI.isUri(n)&&(c=new URL(n.toString(!0)).searchParams);const u=c?.get(r);if(u)return s.get(u)}f.getHeadersFromQuery=o;function i(n,c,u){if(!globalThis.crossOriginIsolated)return;const t=c&&u?"3":u?"2":"1";n instanceof URLSearchParams?n.set(r,t):n[r]=t}f.addSearchParam=i})(b||(e.COI=b={}))}),define(Se[24],Ie([1,0,48,16,19,23,13,2]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0,e.$Zg=m,e.$ih=T,e.$jh=l;function m(b){return(0,p.$wc)(b,!0)}class E{constructor(f){this.a=f}compare(f,s,r=!1){return f===s?0:(0,R.$sf)(this.getComparisonKey(f,r),this.getComparisonKey(s,r))}isEqual(f,s,r=!1){return f===s?!0:!f||!s?!1:this.getComparisonKey(f,r)===this.getComparisonKey(s,r)}getComparisonKey(f,s=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,s,r=!1){if(f.scheme===s.scheme){if(f.scheme===O.Schemas.file)return C.$xg(m(f),m(s),this.a(f))&&f.query===s.query&&(r||f.fragment===s.fragment);if((0,e.$eh)(f.authority,s.authority))return C.$xg(f.path,s.path,this.a(f),"/")&&f.query===s.query&&(r||f.fragment===s.fragment)}return!1}joinPath(f,...s){return p.URI.joinPath(f,...s)}basenameOrAuthority(f){return(0,e.$9g)(f)||f.authority}basename(f){return A.$gc.basename(f.path)}extname(f){return A.$gc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let s;return f.scheme===O.Schemas.file?s=p.URI.file(A.$mc(m(f))).path:(s=A.$gc.dirname(f.path),f.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),s="/")),f.with({path:s})}normalizePath(f){if(!f.path.length)return f;let s;return f.scheme===O.Schemas.file?s=p.URI.file(A.$hc(m(f))).path:s=A.$gc.normalize(f.path),f.with({path:s})}relativePath(f,s){if(f.scheme!==s.scheme||!(0,e.$eh)(f.authority,s.authority))return;if(f.scheme===O.Schemas.file){const i=A.$lc(m(f),m(s));return N.$i?C.$rg(i):i}let r=f.path||"/";const o=s.path||"/";if(this.a(f)){let i=0;for(const n=Math.min(r.length,o.length);i<n&&!(r.charCodeAt(i)!==o.charCodeAt(i)&&r.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);r=o.substr(0,i)+r.substr(i)}return A.$gc.relative(r,o)}resolvePath(f,s){if(f.scheme===O.Schemas.file){const r=p.URI.file(A.$kc(m(f),s));return f.with({authority:r.authority,path:r.path})}return s=C.$sg(s),f.with({path:A.$gc.resolve(f.path,s)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,s){return f===s||f!==void 0&&s!==void 0&&(0,R.$zf)(f,s)}hasTrailingPathSeparator(f,s=A.sep){if(f.scheme===O.Schemas.file){const r=m(f);return r.length>C.$tg(r).length&&r[r.length-1]===s}else{const r=f.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,s=A.sep){return(0,e.$fh)(f,s)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,s=A.sep){let r=!1;if(f.scheme===O.Schemas.file){const o=m(f);r=o!==void 0&&o.length===C.$tg(o).length&&o[o.length-1]===s}else{s="/";const o=f.path;r=o.length===1&&o.charCodeAt(o.length-1)===47}return!r&&!(0,e.$fh)(f,s)?f.with({path:f.path+"/"}):f}}e.$1g=E,e.$2g=new E(()=>!1),e.$3g=new E(b=>b.scheme===O.Schemas.file?!N.$k:!0),e.$4g=new E(b=>!0),e.$5g=e.$2g.isEqual.bind(e.$2g),e.$6g=e.$2g.isEqualOrParent.bind(e.$2g),e.$7g=e.$2g.getComparisonKey.bind(e.$2g),e.$8g=e.$2g.basenameOrAuthority.bind(e.$2g),e.$9g=e.$2g.basename.bind(e.$2g),e.$0g=e.$2g.extname.bind(e.$2g),e.$$g=e.$2g.dirname.bind(e.$2g),e.$_g=e.$2g.joinPath.bind(e.$2g),e.$ah=e.$2g.normalizePath.bind(e.$2g),e.$bh=e.$2g.relativePath.bind(e.$2g),e.$ch=e.$2g.resolvePath.bind(e.$2g),e.$dh=e.$2g.isAbsolutePath.bind(e.$2g),e.$eh=e.$2g.isEqualAuthority.bind(e.$2g),e.$fh=e.$2g.hasTrailingPathSeparator.bind(e.$2g),e.$gh=e.$2g.removeTrailingPathSeparator.bind(e.$2g),e.$hh=e.$2g.addTrailingPathSeparator.bind(e.$2g);function T(b,f){const s=[];for(let r=0;r<b.length;r++){const o=f(b[r]);b.some((i,n)=>n===r?!1:(0,e.$6g)(o,f(i)))||s.push(b[r])}return s}var S;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(s){const r=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[c,u]=n.split(":");c&&u&&r.set(c,u)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&r.set(b.META_DATA_MIME,i),r}b.parseMetaData=f})(S||(e.DataUri=S={}));function l(b,f,s){if(f){let r=b.path;return r&&r[0]!==A.$gc.sep&&(r=A.$gc.sep+r),b.with({scheme:s,authority:f,path:r})}return b.with({scheme:s})}}),define(Se[11],Ie([1,0,20,14,5,6,24,23,136,43]),function(le,e,C,O,A,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.Promises=e.$Vh=e.$Uh=e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0,e.$kh=T,e.$lh=S,e.$mh=l,e.$nh=b,e.$oh=f,e.$ph=s,e.$qh=r,e.$rh=o,e.$zh=$,e.$Ah=v,e.$Bh=y,e.$Ch=h,e.$Dh=D,e.$Sh=Ee,e.$1h=ke;function T(ge){return!!ge&&typeof ge.then=="function"}function S(ge){const Q=new C.$qe,Y=ge(Q.token),he=new Promise((ce,Ne)=>{const fe=Q.token.onCancellationRequested(()=>{fe.dispose(),Ne(new O.$5)});Promise.resolve(Y).then(Pe=>{fe.dispose(),Q.dispose(),ce(Pe)},Pe=>{fe.dispose(),Q.dispose(),Ne(Pe)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ce,Ne){return he.then(ce,Ne)}catch(ce){return this.then(void 0,ce)}finally(ce){return he.finally(ce)}}}function l(ge,Q,Y){return new Promise((he,ce)=>{const Ne=Q.onCancellationRequested(()=>{Ne.dispose(),he(Y)});ge.then(he,ce).finally(()=>Ne.dispose())})}function b(ge,Q){return new Promise((Y,he)=>{const ce=Q.onCancellationRequested(()=>{ce.dispose(),he(new O.$5)});ge.then(Y,he).finally(()=>ce.dispose())})}async function f(ge){let Q=-1;const Y=ge.map((he,ce)=>he.then(Ne=>(Q=ce,Ne)));try{return await Promise.race(Y)}finally{ge.forEach((he,ce)=>{ce!==Q&&he.cancel()})}}function s(ge,Q,Y){let he;const ce=setTimeout(()=>{he?.(void 0),Y?.()},Q);return Promise.race([ge.finally(()=>clearTimeout(ce)),new Promise(Ne=>he=Ne)])}function r(ge){return new Promise((Q,Y)=>{const he=ge();T(he)?he.then(Q,Y):Q(he)})}function o(){let ge,Q;return{promise:new Promise((he,ce)=>{ge=he,Q=ce}),resolve:ge,reject:Q}}class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=Q(),new Promise((Y,he)=>{this.a.then(ce=>{this.a=null,Y(ce)},ce=>{this.a=null,he(ce)})})}dispose(){this.f=!0}}e.$sh=i;class n{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$th=n;class c{constructor(){this.a=new Map}queue(Q,Y){const ce=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===ce&&this.a.delete(Q)});return this.a.set(Q,ce),ce}}e.$uh=c;const u=(ge,Q)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,Q()},ge);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},t=ge=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,ge())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class g{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ce,Ne)=>{this.d=ce,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const ce=this.g;return this.g=null,ce()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===m.$ce?t(he):u(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$vh=g;class a{constructor(Q){this.a=new g(Q),this.b=new i}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$wh=a;class d{constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$xh=d;class w extends d{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$yh=w;function $(ge,Q){return Q?new Promise((Y,he)=>{const ce=setTimeout(()=>{Ne.dispose(),Y()},ge),Ne=Q.onCancellationRequested(()=>{clearTimeout(ce),Ne.dispose(),he(new O.$5)})}):S(Y=>$(ge,Y))}function v(ge,Q=0,Y){const he=setTimeout(()=>{ge(),Y&&ce.dispose()},Q),ce=(0,N.$Sc)(()=>{clearTimeout(he),Y?.deleteAndLeak(ce)});return Y?.add(ce),ce}function y(ge){const Q=[];let Y=0;const he=ge.length;function ce(){return Y<he?ge[Y++]():null}function Ne(fe){fe!=null&&Q.push(fe);const Pe=ce();return Pe?Pe.then(Ne):Promise.resolve(Q)}return Promise.resolve(null).then(Ne)}function h(ge,Q=he=>!!he,Y=null){let he=0;const ce=ge.length,Ne=()=>{if(he>=ce)return Promise.resolve(Y);const fe=ge[he++];return Promise.resolve(fe()).then(Me=>Q(Me)?Promise.resolve(Me):Ne())};return Ne()}function D(ge,Q=he=>!!he,Y=null){if(ge.length===0)return Promise.resolve(Y);let he=ge.length;const ce=()=>{he=-1;for(const Ne of ge)Ne.cancel?.()};return new Promise((Ne,fe)=>{for(const Pe of ge)Pe.then(Me=>{--he>=0&&Q(Me)?(ce(),Ne(Me)):he===0&&Ne(Y)}).catch(Me=>{--he>=0&&(ce(),fe(Me))})})}class k{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new A.$fe}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:Q,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Eh=k;class I extends k{constructor(){super(1)}}e.$Fh=I;class P{constructor(){this.a=new me,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Gh=P;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new se;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=R.$2g){const he=Y.getComparisonKey(Q);return this.a.get(he)?.size??0}queueFor(Q,Y,he=R.$2g){const ce=he.getComparisonKey(Q);let Ne=this.a.get(ce);if(!Ne){Ne=new I;const fe=this.f++,Pe=A.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$4c),this.d.set(fe,Pe),this.a.set(ce,Ne)}return Ne.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Hh=V;class W{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$Ih=W;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,he=globalThis){this.cancel();const ce=he.setInterval(()=>{Q()},Y);this.d=(0,N.$Sc)(()=>{he.clearInterval(ce),this.d=void 0})}dispose(){this.cancel()}}e.$Jh=q;class M{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Kh=M;class z{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Lh=z;class G extends M{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Mh=G;class ie extends N.$Uc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new N.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Nh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ph=(ge,Q)=>{(0,p.$B)(()=>{if(Y)return;const he=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Ph=(ge,Q,Y)=>{const he=ge.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,ge.cancelIdleCallback(he))}}},e.$Oh=ge=>(0,e.$Ph)(globalThis,ge)}();class de{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Ph)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Qh=de;class ye extends de{constructor(Q){super(globalThis,Q)}}e.$Rh=ye;async function Ee(ge,Q,Y){let he;for(let ce=0;ce<Y;ce++)try{return await ge()}catch(Ne){he=Ne,await $(Q)}throw he}class me{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,he){return this.a={taskId:Q,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:he,reject:ce}=o();this.b={run:Q,promise:Y,promiseResolve:he,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Th=me;class ue{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Uh=ue;var Ce;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(Ce||(Ce={}));class se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new O.$5)}}e.$Vh=se;var Oe;(function(ge){async function Q(he){let ce;const Ne=await Promise.all(he.map(fe=>fe.then(Pe=>Pe,Pe=>{ce||(ce=Pe)})));if(typeof ce<"u")throw ce;return Ne}ge.settled=Q;function Y(he){return new Promise(async(ce,Ne)=>{try{await he(ce,Ne)}catch(fe){Ne(fe)}})}ge.withAsyncBody=Y})(Oe||(e.Promises=Oe={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Wh=ne;class U{constructor(Q){this.b=Q,this.a=new E.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Xh=U;var x;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(x||(x={}));class ve{static fromArray(Q){return new ve(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new ve(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new ve(async Y=>{await Promise.all(Q.map(async he=>Y.emitOne(await he)))})}static merge(Q){return new ve(async Y=>{await Promise.all(Q.map(async he=>{for await(const ce of he)Y.emitOne(ce)}))})}static{this.EMPTY=ve.fromArray([])}constructor(Q,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new A.$fe,queueMicrotask(async()=>{const he={emitOne:ce=>this.h(ce),emitMany:ce=>this.j(ce),reject:ce=>this.l(ce)};try{await Promise.resolve(Q(he)),this.k()}catch(ce){this.l(ce)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,Y){return new ve(async he=>{for await(const ce of Q)he.emitOne(Y(ce))})}map(Q){return ve.map(this,Q)}static filter(Q,Y){return new ve(async he=>{for await(const ce of Q)Y(ce)&&he.emitOne(ce)})}filter(Q){return ve.filter(this,Q)}static coalesce(Q){return ve.filter(Q,Y=>!!Y)}coalesce(){return ve.coalesce(this)}static async toPromise(Q){const Y=[];for await(const he of Q)Y.push(he);return Y}toPromise(){return ve.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Yh=ve;class Fe extends ve{constructor(Q,Y){super(Y),this.m=Q}cancel(){this.m.cancel()}}e.$Zh=Fe;function ke(ge){const Q=new C.$qe,Y=ge(Q.token);return new Fe(Q,async he=>{const ce=Q.token.onCancellationRequested(()=>{ce.dispose(),Q.dispose(),he.reject(new O.$5)});try{for await(const Ne of Y){if(Q.token.isCancellationRequested)return;he.emitOne(Ne)}ce.dispose(),Q.dispose()}catch(Ne){ce.dispose(),Q.dispose(),he.reject(Ne)}})}class we{constructor(Q){this.a=new se,this.b=new ve(ce=>{if(Y){ce.reject(Y);return}return he&&ce.emitMany(he),this.d=Ne=>ce.reject(Ne),this.f=Ne=>ce.emitOne(Ne),this.a.p},Q);let Y,he;this.f=ce=>{he||(he=[]),he.push(ce)},this.d=ce=>{Y||(Y=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$2h=we}),define(Se[37],Ie([1,0,18,11,48,28,19,23,13]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=void 0,e.$nk=E,e.$qk=f,e.$rk=I,e.$sk=P,e.$tk=V,e.$uk=W,e.$vk=q,e.$wk=ie;function E(){return Object.create(null)}e.$ok="**",e.$pk="/";const T="[/\\\\]",S="[^/\\\\]",l=/\//g;function b(de,ye){switch(de){case 0:return"";case 1:return`${S}*?`;default:return`(?:${T}|${S}+${T}${ye?`|${T}${S}+`:""})*?`}}function f(de,ye){if(!de)return[];const Ee=[];let me=!1,ue=!1,Ce="";for(const se of de){switch(se){case ye:if(!me&&!ue){Ee.push(Ce),Ce="";continue}break;case"{":me=!0;break;case"}":me=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Ce+=se}return Ce&&Ee.push(Ce),Ee}function s(de){if(!de)return"";let ye="";const Ee=f(de,e.$pk);if(Ee.every(me=>me===e.$ok))ye=".*";else{let me=!1;Ee.forEach((ue,Ce)=>{if(ue===e.$ok){if(me)return;ye+=b(2,Ce===Ee.length-1)}else{let se=!1,Oe="",ne=!1,U="";for(const x of ue){if(x!=="}"&&se){Oe+=x;continue}if(ne&&(x!=="]"||!U)){let ve;x==="-"?ve=x:(x==="^"||x==="!")&&!U?ve="^":x===e.$pk?ve="":ve=(0,m.$bf)(x),U+=ve;continue}switch(x){case"{":se=!0;continue;case"[":ne=!0;continue;case"}":{const Fe=`(?:${f(Oe,",").map(ke=>s(ke)).join("|")})`;ye+=Fe,se=!1,Oe="";break}case"]":{ye+="["+U+"]",ne=!1,U="";break}case"?":ye+=S;continue;case"*":ye+=b(1);continue;default:ye+=(0,m.$bf)(x)}}Ce<Ee.length-1&&(Ee[Ce+1]!==e.$ok||Ce+2<Ee.length)&&(ye+=T)}me=ue===e.$ok})}return ye}const r=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Dc(1e4),g=function(){return!1},a=function(){return null};function d(de,ye){if(!de)return a;let Ee;typeof de!="string"?Ee=de.pattern:Ee=de,Ee=Ee.trim();const me=`${Ee}_${!!ye.trimForExclusions}`;let ue=t.get(me);if(ue)return w(ue,de);let Ce;return r.test(Ee)?ue=v(Ee.substr(4),Ee):(Ce=o.exec($(Ee,ye)))?ue=y(Ce[1],Ee):(ye.trimForExclusions?n:i).test(Ee)?ue=h(Ee,ye):(Ce=c.exec($(Ee,ye)))?ue=D(Ce[1].substr(1),Ee,!0):(Ce=u.exec($(Ee,ye)))?ue=D(Ce[1],Ee,!1):ue=k(Ee),t.set(me,ue),w(ue,de)}function w(de,ye){if(typeof ye=="string")return de;const Ee=function(me,ue){return(0,A.$xg)(me,ye.base,!p.$k)?de((0,m.$gf)(me.substr(ye.base.length),R.sep),ue):null};return Ee.allBasenames=de.allBasenames,Ee.allPaths=de.allPaths,Ee.basenames=de.basenames,Ee.patterns=de.patterns,Ee}function $(de,ye){return ye.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function v(de,ye){return function(Ee,me){return typeof Ee=="string"&&Ee.endsWith(de)?ye:null}}function y(de,ye){const Ee=`/${de}`,me=`\\${de}`,ue=function(se,Oe){return typeof se!="string"?null:Oe?Oe===de?ye:null:se===de||se.endsWith(Ee)||se.endsWith(me)?ye:null},Ce=[de];return ue.basenames=Ce,ue.patterns=[ye],ue.allBasenames=Ce,ue}function h(de,ye){const Ee=G(de.slice(1,-1).split(",").map(Oe=>d(Oe,ye)).filter(Oe=>Oe!==a),de),me=Ee.length;if(!me)return a;if(me===1)return Ee[0];const ue=function(Oe,ne){for(let U=0,x=Ee.length;U<x;U++)if(Ee[U](Oe,ne))return de;return null},Ce=Ee.find(Oe=>!!Oe.allBasenames);Ce&&(ue.allBasenames=Ce.allBasenames);const se=Ee.reduce((Oe,ne)=>ne.allPaths?Oe.concat(ne.allPaths):Oe,[]);return se.length&&(ue.allPaths=se),ue}function D(de,ye,Ee){const me=R.sep===R.$gc.sep,ue=me?de:de.replace(l,R.sep),Ce=R.sep+ue,se=R.$gc.sep+de;let Oe;return Ee?Oe=function(ne,U){return typeof ne=="string"&&(ne===ue||ne.endsWith(Ce)||!me&&(ne===de||ne.endsWith(se)))?ye:null}:Oe=function(ne,U){return typeof ne=="string"&&(ne===ue||!me&&ne===de)?ye:null},Oe.allPaths=[(Ee?"*/":"./")+de],Oe}function k(de){try{const ye=new RegExp(`^${s(de)}$`);return function(Ee){return ye.lastIndex=0,typeof Ee=="string"&&ye.test(Ee)?de:null}}catch{return a}}function I(de,ye,Ee){return!de||typeof ye!="string"?!1:P(de)(ye,void 0,Ee)}function P(de,ye={}){if(!de)return g;if(typeof de=="string"||V(de)){const Ee=d(de,ye);if(Ee===a)return g;const me=function(ue,Ce){return!!Ee(ue,Ce)};return Ee.allBasenames&&(me.allBasenames=Ee.allBasenames),Ee.allPaths&&(me.allPaths=Ee.allPaths),me}return M(de,ye)}function V(de){const ye=de;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function W(de){return de.allBasenames||[]}function q(de){return de.allPaths||[]}function M(de,ye){const Ee=G(Object.getOwnPropertyNames(de).map(Oe=>z(Oe,de[Oe],ye)).filter(Oe=>Oe!==a)),me=Ee.length;if(!me)return a;if(!Ee.some(Oe=>!!Oe.requiresSiblings)){if(me===1)return Ee[0];const Oe=function(x,ve){let Fe;for(let ke=0,we=Ee.length;ke<we;ke++){const ge=Ee[ke](x,ve);if(typeof ge=="string")return ge;(0,O.$kh)(ge)&&(Fe||(Fe=[]),Fe.push(ge))}return Fe?(async()=>{for(const ke of Fe){const we=await ke;if(typeof we=="string")return we}return null})():null},ne=Ee.find(x=>!!x.allBasenames);ne&&(Oe.allBasenames=ne.allBasenames);const U=Ee.reduce((x,ve)=>ve.allPaths?x.concat(ve.allPaths):x,[]);return U.length&&(Oe.allPaths=U),Oe}const ue=function(Oe,ne,U){let x,ve;for(let Fe=0,ke=Ee.length;Fe<ke;Fe++){const we=Ee[Fe];we.requiresSiblings&&U&&(ne||(ne=(0,R.$nc)(Oe)),x||(x=ne.substr(0,ne.length-(0,R.$oc)(Oe).length)));const ge=we(Oe,ne,x,U);if(typeof ge=="string")return ge;(0,O.$kh)(ge)&&(ve||(ve=[]),ve.push(ge))}return ve?(async()=>{for(const Fe of ve){const ke=await Fe;if(typeof ke=="string")return ke}return null})():null},Ce=Ee.find(Oe=>!!Oe.allBasenames);Ce&&(ue.allBasenames=Ce.allBasenames);const se=Ee.reduce((Oe,ne)=>ne.allPaths?Oe.concat(ne.allPaths):Oe,[]);return se.length&&(ue.allPaths=se),ue}function z(de,ye,Ee){if(ye===!1)return a;const me=d(de,Ee);if(me===a)return a;if(typeof ye=="boolean")return me;if(ye){const ue=ye.when;if(typeof ue=="string"){const Ce=(se,Oe,ne,U)=>{if(!U||!me(se,Oe))return null;const x=ue.replace("$(basename)",()=>ne),ve=U(x);return(0,O.$kh)(ve)?ve.then(Fe=>Fe?de:null):ve?de:null};return Ce.requiresSiblings=!0,Ce}}return me}function G(de,ye){const Ee=de.filter(Oe=>!!Oe.basenames);if(Ee.length<2)return de;const me=Ee.reduce((Oe,ne)=>{const U=ne.basenames;return U?Oe.concat(U):Oe},[]);let ue;if(ye){ue=[];for(let Oe=0,ne=me.length;Oe<ne;Oe++)ue.push(ye)}else ue=Ee.reduce((Oe,ne)=>{const U=ne.patterns;return U?Oe.concat(U):Oe},[]);const Ce=function(Oe,ne){if(typeof Oe!="string")return null;if(!ne){let x;for(x=Oe.length;x>0;x--){const ve=Oe.charCodeAt(x-1);if(ve===47||ve===92)break}ne=Oe.substr(x)}const U=me.indexOf(ne);return U!==-1?ue[U]:null};Ce.basenames=me,Ce.patterns=ue,Ce.allBasenames=me;const se=de.filter(Oe=>!Oe.basenames);return se.push(Ce),se}function ie(de,ye){return(0,C.$ub)(de,ye,(Ee,me)=>typeof Ee=="string"&&typeof me=="string"?Ee===me:typeof Ee!="string"&&typeof me!="string"?Ee.base===me.base&&Ee.pattern===me.pattern:!1)}}),define(Se[55],Ie([1,0,14,137,24,13,2]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.MarkdownStringTextNewlineStyle=void 0,e.$Wk=E,e.$Xk=T,e.$Yk=S,e.$Zk=l,e.$1k=b,e.$2k=f,e.$3k=s,e.$4k=r;var p;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class m{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,C.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=l(this.supportThemeIcons?(0,O.$Pk)(i):i).replace(/([ \t]+)/g,(c,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${b(n,i)}
`,this}appendLink(i,n,c){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,n){const c=new RegExp((0,N.$bf)(n),"g");return i.replace(c,(u,t)=>i.charAt(t-1)!=="\\"?`\\${u}`:u)}}e.$Vk=m;function E(o){return T(o)?!o.value:Array.isArray(o)?o.every(E):!0}function T(o){return o instanceof m?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function S(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,A.$5g)(R.URI.from(o.baseUri),R.URI.from(i.baseUri)))}function l(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(o,i){const n=o.match(/^`+/gm)?.reduce((u,t)=>u.length>t.length?u:t).length??0,c=n>=3?n+1:3;return[`${"`".repeat(c)}${i}`,o,`${"`".repeat(c)}`].join(`
`)}function f(o){return o.replace(/"/g,"&quot;")}function s(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(o){const i=[],n=o.split("|").map(u=>u.trim());o=n[0];const c=n[1];if(c){const u=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),g=u?u[1]:"",a=t?t[1]:"",d=isFinite(parseInt(a)),w=isFinite(parseInt(g));d&&i.push(`width="${a}"`),w&&i.push(`height="${g}"`)}return{href:o,dimensions:i}}}),define(Se[97],Ie([1,0,18,48,19,23,24,13]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=m,e.$Hw=T,e.$Iw=l,e.$Jw=b,e.$Kw=o,e.$Lw=n,e.$Mw=c,e.$Nw=u,e.$Ow=t,e.$Pw=g;function m(d,w){const{os:$,tildify:v,relative:y}=w;if(y){const k=E(d,y,$);if(typeof k=="string")return k}let h=d.fsPath;if($===1&&!N.$i?h=h.replace(/\//g,"\\"):$!==1&&N.$i&&(h=h.replace(/\\/g,"/")),$!==1&&v?.userHome){const k=v.userHome.fsPath;let I;d.scheme!==v.userHome.scheme&&d.path[0]===A.$gc.sep&&d.path[1]!==A.$gc.sep?I=v.userHome.with({path:d.path}).fsPath:I=h,h=l(I,k,$)}return($===1?A.$fc:A.$gc).normalize(T(h,$===1))}function E(d,w,$){const v=$===1?A.$fc:A.$gc,y=$===3?R.$2g:R.$4g,h=w.getWorkspace(),D=(0,C.$Ob)(h.folders);if(!D)return;d.scheme!==D.uri.scheme&&d.path[0]===A.$gc.sep&&d.path[1]!==A.$gc.sep&&(d=D.uri.with({path:d.path}));const k=w.getWorkspaceFolder(d);if(!k)return;let I;if(y.isEqual(k.uri,d)?I="":I=y.relativePath(k.uri,d)??"",I&&(I=v.normalize(I)),h.folders.length>1&&!w.noPrefix){const P=k.name?k.name:y.basenameOrAuthority(k.uri);I=I?`${P} \u2022 ${I}`:P}return I}function T(d,w=N.$i){return(0,O.$Cg)(d,w)?d.charAt(0).toUpperCase()+d.slice(1):d}let S=Object.create(null);function l(d,w,$=N.OS){if($===1||!d||!w)return d;let v=S.original===w?S.normalized:void 0;v||(v=w,N.$i&&(v=(0,O.$rg)(v)),v=`${(0,p.$hf)(v,A.$gc.sep)}${A.$gc.sep}`,S={original:w,normalized:v});let y=d;return N.$i&&(y=(0,O.$rg)(y)),($===3?y.startsWith(v):(0,p.$Af)(y,v))?`~/${y.substr(v.length)}`:d}function b(d,w){return d.replace(/^~($|\/|\\)/,`${w}$1`)}const f="\u2026",s="\\\\",r="~";function o(d,w=A.sep){const $=new Array(d.length);let v=!1;for(let y=0;y<d.length;y++){const h=d[y];if(h===""){$[y]=`.${w}`;continue}if(!h){$[y]=h;continue}v=!0;let D="",k=h;k.indexOf(s)===0?(D=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length)):k.indexOf(w)===0?(D=k.substr(0,k.indexOf(w)+w.length),k=k.substr(k.indexOf(w)+w.length)):k.indexOf(r)===0&&(D=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length));const I=k.split(w);for(let P=1;v&&P<=I.length;P++)for(let V=I.length-P;v&&V>=0;V--){v=!1;let W=I.slice(V,V+P).join(w);for(let q=0;!v&&q<d.length;q++)if(q!==y&&d[q]&&d[q].indexOf(W)>-1){const M=V+P===I.length,z=V>0&&d[q].indexOf(w)>-1?w+W:W,G=d[q].endsWith(z);v=!M||G}if(!v){let q="";(I[0].endsWith(":")||D!=="")&&(V===1&&(V=0,P++,W=I[0]+w+W),V>0&&(q=I[0]+w),q=D+q),V>0&&(q=q+f+w),q=q+W,V+P<I.length&&(q=q+w+f),$[y]=q}}v&&($[y]=h)}return $}var i;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(d,w=Object.create(null)){const $=[];let v=!1,y="";for(const h of d)if(h==="$"||v&&h==="{")y&&$.push({value:y,type:i.TEXT}),y="",v=!0;else if(h==="}"&&v){const D=w[y];if(typeof D=="string")D.length&&$.push({value:D,type:i.VARIABLE});else if(D){const k=$[$.length-1];(!k||k.type!==i.SEPARATOR)&&$.push({value:D.label,type:i.SEPARATOR})}y="",v=!1}else y+=h;return y&&!v&&$.push({value:y,type:i.TEXT}),$.filter((h,D)=>{if(h.type===i.SEPARATOR){const k=$[D-1],I=$[D+1];return[k,I].every(P=>P&&(P.type===i.VARIABLE||P.type===i.TEXT)&&P.value.length>0)}return!0}).map(h=>h.value).join("")}function c(d,w){return N.$j||w?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):d.replace(/&&|&/g,$=>$==="&"?"&&":"&")}function u(d,w){return N.$j||w?d.replace(/\(&&\w\)|&&/g,""):N.$i?d.replace(/&&|&/g,$=>$==="&"?"&&":"&"):d.replace(/&&/g,"_")}function t(d){return d.replace(/&/g,"&&")}function g(d){if(d.endsWith("]")){const w=d.lastIndexOf(" [",d.length-2);if(w!==-1){const $=a(d.substring(0,w)),v=d.substring(w);return{name:$.name+v,parentPath:$.parentPath}}}return a(d)}function a(d){const w=d.indexOf("/")!==-1?A.$gc:A.$fc,$=w.basename(d),v=w.dirname(d);return $.length?{name:$,parentPath:v}:{name:v,parentPath:""}}}),define(Se[150],Ie([1,0,22,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0,e.$Cn=p,e.$Dn=E,e.$En=T;function A(S){return S.toJSON()}class N{constructor(l){this.a=l}transformIncoming(l){const b=this.a.transformIncoming(l);return b===l?l:A(O.URI.from(b))}transformOutgoing(l){const b=this.a.transformOutgoing(l);return b===l?l:A(O.URI.from(b))}transformOutgoingURI(l){const b=this.a.transformOutgoing(l);return b===l?l:O.URI.from(b)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$An=N,e.$Bn=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function R(S,l,b){if(!S||b>200)return null;if(typeof S=="object"){if(S instanceof O.URI)return l.transformOutgoing(S);for(const f in S)if(Object.hasOwnProperty.call(S,f)){const s=R(S[f],l,b+1);s!==null&&(S[f]=s)}}return null}function p(S,l){const b=R(S,l,0);return b===null?S:b}function m(S,l,b,f){if(!S||f>200)return null;if(typeof S=="object"){if(S.$mid===1)return b?O.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof C.$He)return null;for(const s in S)if(Object.hasOwnProperty.call(S,s)){const r=m(S[s],l,b,f+1);r!==null&&(S[s]=r)}}return null}function E(S,l){const b=m(S,l,!1,0);return b===null?S:b}function T(S,l){const b=m(S,l,!0,0);return b===null?S:b}}),define(Se[151],Ie([1,0,11,5,6,49,15]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.StorageState=e.StorageHint=void 0,e.$Yp=m;var p;(function(l){l[l.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",l[l.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function m(l){const b=l;return b?.changed instanceof Map||b?.deleted instanceof Set}var E;(function(l){l[l.None=0]="None",l[l.Initialized=1]="Initialized",l[l.Closed=2]="Closed"})(E||(e.StorageState=E={}));class T extends A.$Uc{static{this.a=100}constructor(b,f=Object.create(null)){super(),this.r=b,this.s=f,this.b=this.B(new O.$ie),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new C.$wh(T.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(b=>this.u(b)))}u(b){this.b.pause();try{b.changed?.forEach((f,s)=>this.w(s,f)),b.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(b,f){if(this.c===E.Closed)return;let s=!1;(0,R.$hg)(f)?s=this.f.delete(b):this.f.get(b)!==f&&(this.f.set(b,f),s=!0),s&&this.b.fire({key:b,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(b,f){const s=this.f.get(b);return(0,R.$hg)(s)?f:s}getBoolean(b,f){const s=this.get(b);return(0,R.$hg)(s)?f:s==="true"}getNumber(b,f){const s=this.get(b);return(0,R.$hg)(s)?f:parseInt(s,10)}getObject(b,f){const s=this.get(b);return(0,R.$hg)(s)?f:(0,N.$7h)(s)}async set(b,f,s=!1){if(this.c===E.Closed)return;if((0,R.$hg)(f))return this.delete(b,s);const r=(0,R.$ag)(f)||Array.isArray(f)?(0,N.$6h)(f):String(f);if(this.f.get(b)!==r)return this.f.set(b,r),this.j.set(b,r),this.h.delete(b),this.b.fire({key:b,external:s}),this.D()}async delete(b,f=!1){if(!(this.c===E.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire({key:b,external:f}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(b).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(b){if(!(this.c===E.Closed||this.m))return this.D(b)}async D(b){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),b)}async whenFlushed(){if(this.z)return new Promise(b=>this.n.push(b))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$Zp=T;class S{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((f,s)=>this.a.set(s,f)),b.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$1p=S}),define(Se[152],Ie([1,0,13,23,22]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=void 0,e.$Gt=T,e.$Ht=S;let N;function R(){return N||(N=new TextDecoder("UTF-16LE")),N}let p;function m(){return p||(p=new TextDecoder("UTF-16BE")),p}let E;function T(){return E||(E=O.$D()?R():m()),E}function S(f,s,r){const o=new Uint16Array(f.buffer,s,r);return r>0&&(o[0]===65279||o[0]===65534)?l(f,s,r):R().decode(o)}function l(f,s,r){const o=[];let i=0;for(let n=0;n<r;n++){const c=A.$Je(f,s);s+=2,o[i++]=String.fromCharCode(c)}return o.join("")}class b{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return T().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const r=this.a-this.d;r<=1&&(r===0||C.$Df(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const r=s.length;if(this.d+r>=this.a){this.f(),this.c[this.c.length]=s;return}for(let o=0;o<r;o++)this.b[this.d++]=s.charCodeAt(o)}}e.$It=b}),define(Se[153],Ie([1,0,22,152]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=void 0,e.$Kt=R;function A(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,T,S,l){this.oldPosition=E,this.oldText=T,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,T,S){const l=T.length;C.$Me(E,l,S),S+=4;for(let b=0;b<l;b++)C.$Ke(E,T.charCodeAt(b),S),S+=2;return S}static d(E,T){const S=C.$Le(E,T);return T+=4,(0,O.$Ht)(E,T,S)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(E,T){return C.$Me(E,this.oldPosition,T),T+=4,C.$Me(E,this.newPosition,T),T+=4,T=N.c(E,this.oldText,T),T=N.c(E,this.newText,T),T}static read(E,T,S){const l=C.$Le(E,T);T+=4;const b=C.$Le(E,T);T+=4;const f=N.d(E,T);T+=N.a(f);const s=N.d(E,T);return T+=N.a(s),S.push(new N(l,f,b,s)),T}}e.$Jt=N;function R(m,E){return m===null||m.length===0?E:new p(m,E).compress()}class p{constructor(E,T){this.a=E,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,T=0,S=this.n(E),l=this.l(T);for(;E<this.f||T<this.h;){if(S===null){this.k(l),l=this.l(++T);continue}if(l===null){this.m(S),S=this.n(++E);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++T);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++E);continue}if(l.oldPosition<S.newPosition){const[o,i]=p.r(l,S.newPosition-l.oldPosition);this.k(o),l=i;continue}if(S.newPosition<l.oldPosition){const[o,i]=p.q(S,l.oldPosition-S.newPosition);this.m(o),S=i;continue}let s,r;if(l.oldEnd===S.newEnd)s=S,r=l,S=this.n(++E),l=this.l(++T);else if(l.oldEnd<S.newEnd){const[o,i]=p.q(S,l.oldLength);s=o,r=l,S=i,l=this.l(++T)}else{const[o,i]=p.r(l,S.newLength);s=S,r=o,S=this.n(++E),l=i}this.d[this.e++]=new N(s.oldPosition,s.oldText,r.newPosition,r.newText),this.g+=s.newLength-s.oldLength,this.j+=r.newLength-r.oldLength}const b=p.s(this.d);return p.t(b)}k(E){this.d[this.e++]=p.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=p.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,T){return new N(T.oldPosition-E,T.oldText,T.newPosition,T.newText)}static p(E,T){return new N(T.oldPosition,T.oldText,T.newPosition+E,T.newText)}static q(E,T){const S=E.newText.substr(0,T),l=E.newText.substr(T);return[new N(E.oldPosition,E.oldText,E.newPosition,S),new N(E.oldEnd,"",E.newPosition+T,l)]}static r(E,T){const S=E.oldText.substr(0,T),l=E.oldText.substr(T);return[new N(E.oldPosition,S,E.newPosition,E.newText),new N(E.oldPosition+T,l,E.newEnd,"")]}static s(E){if(E.length===0)return E;const T=[];let S=0,l=E[0];for(let b=1;b<E.length;b++){const f=E[b];l.oldEnd===f.oldPosition?l=new N(l.oldPosition,l.oldText+f.oldText,l.newPosition,l.newText+f.newText):(T[S++]=l,l=f)}return T[S++]=l,T}static t(E){if(E.length===0)return E;const T=[];let S=0;for(let l=0;l<E.length;l++){const b=E[l];b.oldText!==b.newText&&(T[S++]=b)}return T}}}),define(Se[154],Ie([1,0,37,19]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1t=A,e.$2t=N;function A(R,p,m,E,T,S){if(Array.isArray(R)){let l=0;for(const b of R){const f=A(b,p,m,E,T,S);if(f===10)return f;f>l&&(l=f)}return l}else{if(typeof R=="string")return E?R==="*"?5:R===m?10:0:0;if(R){const{language:l,pattern:b,scheme:f,hasAccessToAllModels:s,notebookType:r}=R;if(!E&&!s)return 0;r&&T&&(p=T);let o=0;if(f)if(f===p.scheme)o=10;else if(f==="*")o=5;else return 0;if(l)if(l===m)o=10;else if(l==="*")o=Math.max(o,5);else return 0;if(r)if(r===S)o=10;else if(r==="*"&&S!==void 0)o=Math.max(o,5);else return 0;if(b){let i;if(typeof b=="string"?i=b:i={...b,base:(0,O.$hc)(b.base)},i===p.fsPath||(0,C.$rk)(i,p.fsPath))o=10;else return 0}return o}else return 0}}function N(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(N):!!R.notebookType}}),define(Se[155],Ie([1,0,5,13,30,95,93,139,153,6]),function(le,e,C,O,A,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=void 0;class T extends E.$Uc{constructor(l,b,f,s,r,o,i){super(),this.m=this.B(new C.$fe),this.onDidChangeContent=this.m.event,this.f=b,this.j=!o,this.g=s,this.h=r,this.c=new R.$3C(l,f,i)}equals(l){return!(l instanceof T)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,b){return this.c.getOffsetAt(l,b)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,b){const f=l+b,s=this.getPositionAt(l),r=this.getPositionAt(f);return new A.$xt(s.lineNumber,s.column,r.lineNumber,r.column)}getValueInRange(l,b=0){if(l.isEmpty())return"";const f=this.n(b);return this.c.getValueInRange(l,f)}getValueLengthInRange(l,b=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const f=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let r=0;const o=this.n(b),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,c=l.endLineNumber-l.startLineNumber;r=n*c}return s-f+r}getCharacterCountInRange(l,b=0){if(this.j){let f=0;const s=l.startLineNumber,r=l.endLineNumber;for(let o=s;o<=r;o++){const i=this.getLineContent(o),n=o===s?l.startColumn-1:0,c=o===r?l.endColumn-1:i.length;for(let u=n;u<c;u++)O.$Df(i.charCodeAt(u))?(f=f+1,u=u+1):f=f+1}return f+=this.n(b).length*(r-s),f}return this.getValueLengthInRange(l,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,b){return this.c.getLineCharCode(l,b)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const b=O.$of(this.getLineContent(l));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(l){const b=O.$qf(this.getLineContent(l));return b===-1?0:b+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,b,f){let s=this.g,r=this.h,o=this.j,i=!0,n=[];for(let w=0;w<l.length;w++){const $=l[w];i&&$._isTracked&&(i=!1);const v=$.range;if($.text){let I=!0;o||(I=!O.$Of($.text),o=I),!s&&I&&(s=O.$Nf($.text)),!r&&I&&(r=O.$Qf($.text))}let y="",h=0,D=0,k=0;if($.text){let I;[h,D,k,I]=(0,p.$4t)($.text);const P=this.getEOL();I===0||I===(P===`\r
`?2:1)?y=$.text:y=$.text.replace(/\r\n|\r|\n/g,P)}n[w]={sortIndex:w,identifier:$.identifier||null,range:v,rangeOffset:this.getOffsetAt(v.startLineNumber,v.startColumn),rangeLength:this.getValueLengthInRange(v),text:y,eolCount:h,firstLineLength:D,lastLineLength:k,forceMoveMarkers:!!$.forceMoveMarkers,isAutoWhitespaceEdit:$.isAutoWhitespaceEdit||!1}}n.sort(T.u);let c=!1;for(let w=0,$=n.length-1;w<$;w++){const v=n[w].range.getEndPosition(),y=n[w+1].range.getStartPosition();if(y.isBeforeOrEqual(v)){if(y.isBefore(v))throw new Error("Overlapping ranges are not allowed!");c=!0}}i&&(n=this.s(n));const u=f||b?T._getInverseEditRanges(n):[],t=[];if(b)for(let w=0;w<n.length;w++){const $=n[w],v=u[w];if($.isAutoWhitespaceEdit&&$.range.isEmpty())for(let y=v.startLineNumber;y<=v.endLineNumber;y++){let h="";y===v.startLineNumber&&(h=this.getLineContent($.range.startLineNumber),O.$of(h)!==-1)||t.push({lineNumber:y,oldContent:h})}}let g=null;if(f){let w=0;g=[];for(let $=0;$<n.length;$++){const v=n[$],y=u[$],h=this.getValueInRange(v.range),D=v.rangeOffset+w;w+=v.text.length-h.length,g[$]={sortIndex:v.sortIndex,identifier:v.identifier,range:y,text:h,textChange:new m.$Jt(v.rangeOffset,h,D,v.text)}}c||g.sort(($,v)=>$.sortIndex-v.sortIndex)}this.g=s,this.h=r,this.j=o;const a=this.t(n);let d=null;if(b&&t.length>0){t.sort((w,$)=>$.lineNumber-w.lineNumber),d=[];for(let w=0,$=t.length;w<$;w++){const v=t[w].lineNumber;if(w>0&&t[w-1].lineNumber===v)continue;const y=t[w].oldContent,h=this.getLineContent(v);h.length===0||h===y||O.$of(h)!==-1||d.push(v)}}return this.m.fire(),new N.$Mv(g,a,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let b=!1;const f=l[0].range,s=l[l.length-1].range,r=new A.$xt(f.startLineNumber,f.startColumn,s.endLineNumber,s.endColumn);let o=f.startLineNumber,i=f.startColumn;const n=[];for(let a=0,d=l.length;a<d;a++){const w=l[a],$=w.range;b=b||w.forceMoveMarkers,n.push(this.getValueInRange(new A.$xt(o,i,$.startLineNumber,$.startColumn))),w.text.length>0&&n.push(w.text),o=$.endLineNumber,i=$.endColumn}const c=n.join(""),[u,t,g]=(0,p.$4t)(c);return{sortIndex:0,identifier:l[0].identifier,range:r,rangeOffset:this.getOffsetAt(r.startLineNumber,r.startColumn),rangeLength:this.getValueLengthInRange(r,0),text:c,eolCount:u,firstLineLength:t,lastLineLength:g,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(l){l.sort(T.w);const b=[];for(let f=0;f<l.length;f++){const s=l[f],r=s.range.startLineNumber,o=s.range.startColumn,i=s.range.endLineNumber,n=s.range.endColumn;if(r===i&&o===n&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new A.$xt(r,o,i,n);b.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return b}findMatchesLineByLine(l,b,f,s){return this.c.findMatchesLineByLine(l,b,f,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,b){const f=l.startLineNumber,s=l.startColumn,[r,o,i]=(0,p.$4t)(b);let n;if(b.length>0){const c=r+1;c===1?n=new A.$xt(f,s,f,s+o):n=new A.$xt(f,s,f+c-1,i+1)}else n=new A.$xt(f,s,f,s);return n}static _getInverseEditRanges(l){const b=[];let f=0,s=0,r=null;for(let o=0,i=l.length;o<i;o++){const n=l[o];let c,u;r?r.range.endLineNumber===n.range.startLineNumber?(c=f,u=s+(n.range.startColumn-r.range.endColumn)):(c=f+(n.range.startLineNumber-r.range.endLineNumber),u=n.range.startColumn):(c=n.range.startLineNumber,u=n.range.startColumn);let t;if(n.text.length>0){const g=n.eolCount+1;g===1?t=new A.$xt(c,u,c,u+n.firstLineLength):t=new A.$xt(c,u,c+g-1,n.lastLineLength+1)}else t=new A.$xt(c,u,c,u);f=t.endLineNumber,s=t.endColumn,b.push(t),r=n}return b}static u(l,b){const f=A.$xt.compareRangesUsingEnds(l.range,b.range);return f===0?l.sortIndex-b.sortIndex:f}static w(l,b){const f=A.$xt.compareRangesUsingEnds(l.range,b.range);return f===0?b.sortIndex-l.sortIndex:-f}}e.$4C=T}),define(Se[156],Ie([1,0,13,93,155]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=void 0;class N{constructor(m,E,T,S,l,b,f,s,r){this.a=m,this.b=E,this.c=T,this.d=S,this.e=l,this.f=b,this.g=f,this.h=s,this.j=r}k(m){const E=this.c+this.d+this.e,T=this.c+this.e;return E===0?m===1?`
`:`\r
`:T>E/2?`\r
`:`
`}create(m){const E=this.k(m),T=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let l=0,b=T.length;l<b;l++){const f=T[l].buffer.replace(/\r\n|\r|\n/g,E),s=(0,O.$YC)(f);T[l]=new O.$2C(f,s)}const S=new A.$4C(T,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&C.$Yf(m)&&(this.b=C.$Xf,m=m.substr(1));const E=m.charCodeAt(m.length-1);E===13||E>=55296&&E<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=E):(this.m(m,!1),this.c=!1,this.d=E)}m(m,E){!E&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const E=(0,O.$ZC)(this.e,m);this.a.push(new O.$2C(m,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=C.$Nf(m)),this.k||(this.k=C.$Qf(m)))}finish(m=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const E=(0,O.$YC)(m.buffer);m.lineStarts=E,this.d===13&&this.f++}}}e.$5C=R}),define(Se[98],Ie([1,0,22,23]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbb=m,e.$Abb=T;var A;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(A||(A={}));function N(S){for(let l=0,b=S.length;l<b;l+=4){const f=S[l+0],s=S[l+1],r=S[l+2],o=S[l+3];S[l+0]=o,S[l+1]=r,S[l+2]=s,S[l+3]=f}}function R(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return O.$D()||N(l),C.$He.wrap(l)}function p(S){const l=S.buffer;if(O.$D()||N(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const b=new Uint8Array(l.byteLength);return b.set(l),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function m(S){const l=new Uint32Array(E(S));let b=0;if(l[b++]=S.id,S.type==="full")l[b++]=1,l[b++]=S.data.length,l.set(S.data,b),b+=S.data.length;else{l[b++]=2,l[b++]=S.deltas.length;for(const f of S.deltas)l[b++]=f.start,l[b++]=f.deleteCount,f.data?(l[b++]=f.data.length,l.set(f.data,b),b+=f.data.length):l[b++]=0}return R(l)}function E(S){let l=0;if(l+=2,S.type==="full")l+=1+S.data.length;else{l+=1,l+=3*S.deltas.length;for(const b of S.deltas)b.data&&(l+=b.data.length)}return l}function T(S){const l=p(S);let b=0;const f=l[b++];if(l[b++]===1){const i=l[b++],n=l.subarray(b,b+i);return b+=i,{id:f,type:"full",data:n}}const r=l[b++],o=[];for(let i=0;i<r;i++){const n=l[b++],c=l[b++],u=l[b++];let t;u>0&&(t=l.subarray(b,b+u),b+=u),o[i]={start:n,deleteCount:c,data:t}}return{id:f,type:"delta",deltas:o}}}),define(Se[157],Ie([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(Se[158],Ie([1,0,18,26,23,140,159,157]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=r,e.clampedInt=i,e.clampedFloat=c,e.stringSet=g,e.cursorStyleToString=k,e.filterValidationDecorations=ce;var m;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class S{constructor(X,$e,Ke,be){this.id=X,this.name=$e,this.defaultValue=Ke,this.schema=be}applyUpdate(X,$e){return b(X,$e)}compute(X,$e,Ke){return Ke}}class l{constructor(X,$e){this.newValue=X,this.didChange=$e}}e.ApplyUpdateResult=l;function b(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new l(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const Ke=Array.isArray(Z)&&Array.isArray(X)&&C.$ub(Z,X);return new l(X,!Ke)}let $e=!1;for(const Ke in X)if(X.hasOwnProperty(Ke)){const be=b(Z[Ke],X[Ke]);be.didChange&&(Z[Ke]=be.newValue,$e=!0)}return new l(Z,$e)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,$e){return b(X,$e)}validate(X){return this.defaultValue}}class s{constructor(X,$e,Ke,be){this.id=X,this.name=$e,this.defaultValue=Ke,this.schema=be}applyUpdate(X,$e){return b(X,$e)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,$e,Ke){return Ke}}function r(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}class o extends s{constructor(X,$e,Ke,be=void 0){typeof be<"u"&&(be.type="boolean",be.default=Ke),super(X,$e,Ke,be)}validate(X){return r(X,this.defaultValue)}}function i(Z,X,$e,Ke){if(typeof Z>"u")return X;let be=parseInt(Z,10);return isNaN(be)?X:(be=Math.max($e,be),be=Math.min(Ke,be),be|0)}class n extends s{static clampedInt(X,$e,Ke,be){return i(X,$e,Ke,be)}constructor(X,$e,Ke,be,st,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=Ke,dt.minimum=be,dt.maximum=st),super(X,$e,Ke,dt),this.minimum=be,this.maximum=st}validate(X){return n.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function c(Z,X,$e,Ke){if(typeof Z>"u")return X;const be=u.float(Z,X);return u.clamp(be,$e,Ke)}class u extends s{static clamp(X,$e,Ke){return X<$e?$e:X>Ke?Ke:X}static float(X,$e){if(typeof X=="number")return X;if(typeof X>"u")return $e;const Ke=parseFloat(X);return isNaN(Ke)?$e:Ke}constructor(X,$e,Ke,be,st){typeof st<"u"&&(st.type="number",st.default=Ke),super(X,$e,Ke,st),this.validationFn=be}validate(X){return this.validationFn(u.float(X,this.defaultValue))}}class t extends s{static string(X,$e){return typeof X!="string"?$e:X}constructor(X,$e,Ke,be=void 0){typeof be<"u"&&(be.type="string",be.default=Ke),super(X,$e,Ke,be)}validate(X){return t.string(X,this.defaultValue)}}function g(Z,X,$e,Ke){return typeof Z!="string"?X:Ke&&Z in Ke?Ke[Z]:$e.indexOf(Z)===-1?X:Z}class a extends s{constructor(X,$e,Ke,be,st=void 0){typeof st<"u"&&(st.type="string",st.enum=be,st.default=Ke),super(X,$e,Ke,st),this.c=be}validate(X){return g(X,this.defaultValue,this.c)}}class d extends S{constructor(X,$e,Ke,be,st,dt,Ct=void 0){typeof Ct<"u"&&(Ct.type="string",Ct.enum=st,Ct.default=be),super(X,$e,Ke,Ct),this.c=st,this.d=dt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function w(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class $ extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,$e,Ke){return Ke===0?X.accessibilitySupport:Ke}}class v extends S{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:p.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{insertSpace:r($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var y;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(y||(e.TextEditorCursorBlinkingStyle=y={}));function h(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function k(Z){switch(Z){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function I(Z){switch(Z){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class P extends f{constructor(){super(142)}compute(X,$e,Ke){const be=["monaco-editor"];return $e.get(39)&&be.push($e.get(39)),X.extraEditorClassName&&be.push(X.extraEditorClassName),$e.get(74)==="default"?be.push("mouse-default"):$e.get(74)==="copy"&&be.push("mouse-copy"),$e.get(111)&&be.push("showUnused"),$e.get(140)&&be.push("showDeprecated"),be.join(" ")}}class V extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(X,$e,Ke){return Ke&&X.emptySelectionClipboard}}class W extends S{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:p.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:p.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{cursorMoveOnType:r($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":g($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":g($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r($e.loop,this.defaultValue.loop)}}}class q extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?q.OFF:X==="true"?q.ON:X:X?q.ON:q.OFF}}e.EditorFontLigatures=q;class M extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?M.OFF:X==="true"?M.TRANSLATE:X:X?M.TRANSLATE:M.OFF}compute(X,$e,Ke){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class z extends f{constructor(){super(50)}compute(X,$e,Ke){return X.fontInfo}}class G extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(X){const $e=u.float(X,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp($e,6,100)}compute(X,$e,Ke){return X.fontInfo.fontSize}}class ie extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(n.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class de extends S{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ke,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ke,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ke,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ke,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ke,description:p.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{multiple:g($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??g($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??g($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??g($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??g($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??g($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends S{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:p.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),delay:n.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:r($e.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:r($e.above,this.defaultValue.above)}}}var Ee;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Ee||(e.RenderMinimap=Ee={}));class me extends f{constructor(){super(145)}compute(X,$e,Ke){return me.computeLayout($e,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const $e=X.height/X.lineHeight,Ke=Math.floor(X.paddingTop/X.lineHeight);let be=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(be=Math.max(be,$e-1));const st=(Ke+X.viewLineCount+be)/(X.pixelRatio*X.height),dt=Math.floor(X.viewLineCount/st);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:be,desiredRatio:st,minimapLineCount:dt}}static c(X,$e){const Ke=X.outerWidth,be=X.outerHeight,st=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:be};const dt=$e.stableMinimapLayoutInput,Ct=dt&&X.outerHeight===dt.outerHeight&&X.lineHeight===dt.lineHeight&&X.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&X.pixelRatio===dt.pixelRatio&&X.scrollBeyondLastLine===dt.scrollBeyondLastLine&&X.paddingTop===dt.paddingTop&&X.paddingBottom===dt.paddingBottom&&X.minimap.enabled===dt.minimap.enabled&&X.minimap.side===dt.minimap.side&&X.minimap.size===dt.minimap.size&&X.minimap.showSlider===dt.minimap.showSlider&&X.minimap.renderCharacters===dt.minimap.renderCharacters&&X.minimap.maxColumn===dt.minimap.maxColumn&&X.minimap.scale===dt.minimap.scale&&X.verticalScrollbarWidth===dt.verticalScrollbarWidth&&X.isViewportWrapping===dt.isViewportWrapping,Vt=X.lineHeight,Qt=X.typicalHalfwidthCharacterWidth,ii=X.scrollBeyondLastLine,Xt=X.minimap.renderCharacters;let Et=st>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Zt=X.minimap.maxColumn,Yt=X.minimap.size,Ze=X.minimap.side,si=X.verticalScrollbarWidth,Ht=X.viewLineCount,ht=X.remainingWidth,mt=X.isViewportWrapping,xt=Xt?2:3;let Gt=Math.floor(st*be);const Nt=Gt/st;let ft=!1,Bt=!1,_t=xt*Et,zt=Et/st,Qe=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:Rt,extraLinesBeforeFirstLine:ei,extraLinesBeyondLastLine:Wt,desiredRatio:oi,minimapLineCount:Ot}=me.computeContainedMinimapLineCount({viewLineCount:Ht,scrollBeyondLastLine:ii,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:be,lineHeight:Vt,pixelRatio:st});if(Ht/Ot>1)ft=!0,Bt=!0,Et=1,_t=1,zt=Et/st;else{let Mt=!1,St=Et+1;if(Yt==="fit"){const $t=Math.ceil((ei+Ht+Wt)*_t);mt&&Ct&&ht<=$e.stableFitRemainingWidth?(Mt=!0,St=$e.stableFitMaxMinimapScale):Mt=$t>Gt}if(Yt==="fill"||Mt){ft=!0;const $t=Et;_t=Math.min(Vt*st,Math.max(1,Math.floor(1/oi))),mt&&Ct&&ht<=$e.stableFitRemainingWidth&&(St=$e.stableFitMaxMinimapScale),Et=Math.min(St,Math.max(1,Math.floor(_t/xt))),Et>$t&&(Qe=Math.min(2,Et/$t)),zt=Et/st/Qe,Gt=Math.ceil(Math.max(Rt,ei+Ht+Wt)*_t),mt?($e.stableMinimapLayoutInput=X,$e.stableFitRemainingWidth=ht,$e.stableFitMaxMinimapScale=Et):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const ui=Math.floor(Zt*zt),Jt=Math.min(ui,Math.max(0,Math.floor((ht-si-2)*zt/(Qt+zt)))+e.MINIMAP_GUTTER_WIDTH);let Ut=Math.floor(st*Jt);const wt=Ut/st;Ut=Math.floor(Ut*Qe);const jt=Xt?1:2,At=Ze==="left"?0:Ke-Jt-si;return{renderMinimap:jt,minimapLeft:At,minimapWidth:Jt,minimapHeightIsEditorHeight:ft,minimapIsSampling:Bt,minimapScale:Et,minimapLineHeight:_t,minimapCanvasInnerWidth:Ut,minimapCanvasInnerHeight:Gt,minimapCanvasOuterWidth:wt,minimapCanvasOuterHeight:Nt}}static computeLayout(X,$e){const Ke=$e.outerWidth|0,be=$e.outerHeight|0,st=$e.lineHeight|0,dt=$e.lineNumbersDigitCount|0,Ct=$e.typicalHalfwidthCharacterWidth,Vt=$e.maxDigitWidth,Qt=$e.pixelRatio,ii=$e.viewLineCount,Xt=X.get(137),Et=Xt==="inherit"?X.get(136):Xt,Zt=Et==="inherit"?X.get(132):Et,Yt=X.get(135),Ze=$e.isDominatedByLongLines,si=X.get(57),Ht=X.get(68).renderType!==0,ht=X.get(69),mt=X.get(105),xt=X.get(84),Gt=X.get(73),Nt=X.get(103),ft=Nt.verticalScrollbarSize,Bt=Nt.verticalHasArrows,_t=Nt.arrowSize,zt=Nt.horizontalScrollbarSize,Qe=X.get(43),ui=X.get(110)!=="never";let Jt=X.get(66);Qe&&ui&&(Jt+=16);let Ut=0;if(Ht){const ai=Math.max(dt,ht);Ut=Math.round(ai*Vt)}let wt=0;si&&(wt=st*$e.glyphMarginDecorationLaneCount);let jt=0,At=jt+wt,Rt=At+Ut,ei=Rt+Jt;const Wt=Ke-wt-Ut-Jt;let oi=!1,Ot=!1,qt=-1;Et==="inherit"&&Ze?(oi=!0,Ot=!0):Zt==="on"||Zt==="bounded"?Ot=!0:Zt==="wordWrapColumn"&&(qt=Yt);const Mt=me.c({outerWidth:Ke,outerHeight:be,lineHeight:st,typicalHalfwidthCharacterWidth:Ct,pixelRatio:Qt,scrollBeyondLastLine:mt,paddingTop:xt.top,paddingBottom:xt.bottom,minimap:Gt,verticalScrollbarWidth:ft,viewLineCount:ii,remainingWidth:Wt,isViewportWrapping:Ot},$e.memory||new T);Mt.renderMinimap!==0&&Mt.minimapLeft===0&&(jt+=Mt.minimapWidth,At+=Mt.minimapWidth,Rt+=Mt.minimapWidth,ei+=Mt.minimapWidth);const St=Wt-Mt.minimapWidth,$t=Math.max(1,Math.floor((St-ft-2)/Ct)),Dt=Bt?_t:0;return Ot&&(qt=Math.max(1,$t),Zt==="bounded"&&(qt=Math.min(qt,Yt))),{width:Ke,height:be,glyphMarginLeft:jt,glyphMarginWidth:wt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:At,lineNumbersWidth:Ut,decorationsLeft:Rt,decorationsWidth:Jt,contentLeft:ei,contentWidth:St,minimap:Mt,viewportColumn:$t,isWordWrapMinified:oi,isViewportWrapping:Ot,wrappingColumn:qt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:zt,overviewRuler:{top:Dt,width:ft,height:be-2*Dt,right:0}}}}e.EditorLayoutInfoComputer=me;class ue extends S{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(X){return g(X,"simple",["simple","advanced"])}compute(X,$e,Ke){return $e.get(2)===2?"advanced":Ke}}var Ce;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(Ce||(e.ShowLightbulbIconMode=Ce={}));class se extends S{constructor(){const X={enabled:Ce.On};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ce.Off,Ce.OnCode,Ce.On],default:X.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:g(X.enabled,this.defaultValue.enabled,[Ce.Off,Ce.OnCode,Ce.On])}}}class Oe extends S{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:p.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:g($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:r($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends S{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:p.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:g($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),padding:r($e.padding,this.defaultValue.padding)}}}class U extends S{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):n.clampedInt(X,this.defaultValue,0,1e3)}compute(X,$e,Ke){return Ke<0?n.clampedInt(-Ke*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class x extends u{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>u.clamp(X,0,150),{markdownDescription:p.localize(66,null)})}compute(X,$e,Ke){return X.fontInfo.lineHeight}}class ve extends S{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:X.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),autohide:r($e.autohide,this.defaultValue.autohide),size:g($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:g($e.side,this.defaultValue.side,["right","left"]),showSlider:g($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r($e.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt($e.scale,1,1,3),maxColumn:n.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:r($e.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:r($e.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp($e.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Fe(Z){return Z==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class ke extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{top:n.clampedInt($e.top,0,0,1e3),bottom:n.clampedInt($e.bottom,0,0,1e3)}}}class we extends S{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:p.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),cycle:r($e.cycle,this.defaultValue.cycle)}}}class ge extends f{constructor(){super(143)}compute(X,$e,Ke){return X.pixelRatio}}class Q extends S{constructor(){const X={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:X.strings,description:p.localize(88,null)},comments:{anyOf:$e,default:X.comments,description:p.localize(89,null)},other:{anyOf:$e,default:X.other,description:p.localize(90,null)}},default:X,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Qt=X?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!X||typeof X!="object")return this.defaultValue;const{other:$e,comments:Ke,strings:be}=X,st=["on","inline","off"];let dt,Ct,Vt;return typeof $e=="boolean"?dt=$e?"on":"off":dt=g($e,this.defaultValue.other,st),typeof Ke=="boolean"?Ct=Ke?"on":"off":Ct=g(Ke,this.defaultValue.comments,st),typeof be=="boolean"?Vt=be?"on":"off":Vt=g(be,this.defaultValue.strings,st),{other:dt,comments:Ct,strings:Vt}}}var Y;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends S{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(X){let $e=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?($e=4,Ke=X):X==="interval"?$e=3:X==="relative"?$e=2:X==="on"?$e=1:$e=0),{renderType:$e,renderFn:Ke}}}function ce(Z){const X=Z.get(98);return X==="editable"?Z.get(91):X!=="on"}class Ne extends S{constructor(){const X=[],$e={type:"number",description:p.localize(97,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:X,description:p.localize(99,null)})}validate(X){if(Array.isArray(X)){const $e=[];for(const Ke of X)if(typeof Ke=="number")$e.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const be=Ke;$e.push({column:n.clampedInt(be.column,0,0,1e4),color:be.color})}return $e.sort((Ke,be)=>Ke.column-be.column),$e}return this.defaultValue}}class fe extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Pe(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends S{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X,Ke=n.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),be=n.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe($e.vertical,this.defaultValue.vertical),horizontal:Pe($e.horizontal,this.defaultValue.horizontal),useShadows:r($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:r($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt($e.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:be,verticalSliderSize:n.clampedInt($e.verticalSliderSize,be,0,1e3),scrollByPage:r($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:r($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends S{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:p.localize(118,null)}})}applyUpdate(X,$e){let Ke=!1;$e.allowedCharacters&&X&&(O.$9n(X.allowedCharacters,$e.allowedCharacters)||(X={...X,allowedCharacters:$e.allowedCharacters},Ke=!0)),$e.allowedLocales&&X&&(O.$9n(X.allowedLocales,$e.allowedLocales)||(X={...X,allowedLocales:$e.allowedLocales},Ke=!0));const be=super.applyUpdate(X,$e);return Ke?new l(be.newValue,!0):be}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{nonBasicASCII:ee($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,$e){if(typeof X!="object"||!X)return $e;const Ke={};for(const[be,st]of Object.entries(X))st===!0&&(Ke[be]=!0);return Ke}}class B extends S{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:p.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),mode:g($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:g($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:r($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:r($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily)}}}class L extends S{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:p.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),showToolbar:g($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:r($e.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:r($e.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends S{constructor(){const X={enabled:N.$7s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$7s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends S{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:X.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:X.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:X.highlightActiveIndentation,description:p.localize(148,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{bracketPairs:ee($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,X,$e){const Ke=$e.indexOf(Z);return Ke===-1?X:$e[Ke]}class re extends S{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:X.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:X.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{insertMode:g($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:g($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r($e.showIcons,this.defaultValue.showIcons),showStatusBar:r($e.showStatusBar,this.defaultValue.showStatusBar),preview:r($e.preview,this.defaultValue.preview),previewMode:g($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r($e.showMethods,this.defaultValue.showMethods),showFunctions:r($e.showFunctions,this.defaultValue.showFunctions),showConstructors:r($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:r($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r($e.showFields,this.defaultValue.showFields),showVariables:r($e.showVariables,this.defaultValue.showVariables),showClasses:r($e.showClasses,this.defaultValue.showClasses),showStructs:r($e.showStructs,this.defaultValue.showStructs),showInterfaces:r($e.showInterfaces,this.defaultValue.showInterfaces),showModules:r($e.showModules,this.defaultValue.showModules),showProperties:r($e.showProperties,this.defaultValue.showProperties),showEvents:r($e.showEvents,this.defaultValue.showEvents),showOperators:r($e.showOperators,this.defaultValue.showOperators),showUnits:r($e.showUnits,this.defaultValue.showUnits),showValues:r($e.showValues,this.defaultValue.showValues),showConstants:r($e.showConstants,this.defaultValue.showConstants),showEnums:r($e.showEnums,this.defaultValue.showEnums),showEnumMembers:r($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r($e.showKeywords,this.defaultValue.showKeywords),showWords:r($e.showWords,this.defaultValue.showWords),showColors:r($e.showColors,this.defaultValue.showColors),showFiles:r($e.showFiles,this.defaultValue.showFiles),showReferences:r($e.showReferences,this.defaultValue.showReferences),showFolders:r($e.showFolders,this.defaultValue.showFolders),showTypeParameters:r($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r($e.showSnippets,this.defaultValue.showSnippets),showUsers:r($e.showUsers,this.defaultValue.showUsers),showIssues:r($e.showIssues,this.defaultValue.showIssues)}}}class Te extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:r(X.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends S{constructor(){const X=[];super(130,"wordSegmenterLocales",X,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const $e=[];for(const Ke of X)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&$e.push(Ke)}catch{}return $e}return this.defaultValue}}var He;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class _e extends S{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,$e,Ke){return $e.get(2)===2?0:Ke}}class xe extends f{constructor(){super(146)}compute(X,$e,Ke){const be=$e.get(145);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:be.isWordWrapMinified,isViewportWrapping:be.isViewportWrapping,wrappingColumn:be.wrappingColumn}}}class et extends S{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),showDropSelector:g($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends S{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),showPasteSelector:g($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?at:A.$k?gt:it,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var rt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(rt||(e.EditorOption=rt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:Ue(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:Ue(new $),accessibilityPageSize:Ue(new n(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",p.localize(218,null))),ariaRequired:Ue(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:Ue(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:Ue(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:Ue(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:Ue(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:Ue(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:Ue(new o(13,"automaticLayout",!1)),autoSurround:Ue(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:Ue(new K),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new o(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:Ue(new o(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:Ue(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:Ue(new o(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:Ue(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:Ue(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:Ue(new o(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:Ue(new v),contextmenu:Ue(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new o(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:Ue(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:Ue(new d(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:p.localize(260,null)})),cursorSurroundingLines:Ue(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:Ue(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:Ue(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new o(34,"domReadOnly",!1)),dragAndDrop:Ue(new o(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:Ue(new V),dropIntoEditor:Ue(new et),stickyScroll:Ue(new Oe),experimentalWhitespaceRendering:Ue(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:p.localize(271,null)})),find:Ue(new W),fixedOverflowWidgets:Ue(new o(42,"fixedOverflowWidgets",!1)),folding:Ue(new o(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:Ue(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:Ue(new o(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:Ue(new o(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:Ue(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:Ue(new z),fontLigatures2:Ue(new q),fontSize:Ue(new G),fontWeight:Ue(new ie),fontVariations:Ue(new M),formatOnPaste:Ue(new o(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:Ue(new o(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:Ue(new o(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:Ue(new de),hideCursorInOverviewRuler:Ue(new o(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:Ue(new ye),inDiffEditor:Ue(new o(61,"inDiffEditor",!1)),letterSpacing:Ue(new u(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>u.clamp(Z,-5,20),{description:p.localize(285,null)})),lightbulb:Ue(new se),lineDecorationsWidth:Ue(new U),lineHeight:Ue(new x),lineNumbers:Ue(new he),lineNumbersMinChars:Ue(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new o(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:Ue(new o(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:Ue(new a(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:Ue(new ve),mouseStyle:Ue(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:Ue(new o(76,"mouseWheelZoom",!1,{markdownDescription:A.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:Ue(new o(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:Ue(new d(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Fe,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:Ue(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:Ue(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:Ue(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:Ue(new o(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:Ue(new n(83,"overviewRulerLanes",3,0,3)),padding:Ue(new ke),pasteAs:Ue(new tt),parameterHints:Ue(new we),peekWidgetDefaultFocus:Ue(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:Ue(new o(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:Ue(new Q),quickSuggestionsDelay:Ue(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:Ue(new o(91,"readOnly",!1)),readOnlyMessage:Ue(new fe),renameOnType:Ue(new o(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:Ue(new o(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new a(95,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:Ue(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:Ue(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:Ue(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new o(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:Ue(new Ne),scrollbar:Ue(new Me),scrollBeyondLastColumn:Ue(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:Ue(new o(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:Ue(new o(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:Ue(new o(107,"selectionClipboard",!0,{description:p.localize(325,null),included:A.$k})),selectionHighlight:Ue(new o(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:Ue(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:Ue(new o(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:Ue(new o(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:Ue(new ne),snippetSuggestions:Ue(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:Ue(new Te),smoothScrolling:Ue(new o(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:Ue(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new re),inlineSuggest:Ue(new B),inlineEdit:Ue(new L),inlineCompletionsAccessibilityVerbose:Ue(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:Ue(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new o(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:Ue(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:Ue(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:Ue(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new je),unusualLineTerminators:Ue(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:Ue(new o(127,"useShadowDOM",!0)),useTabStops:Ue(new o(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:Ue(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:Ue(new Be),wordSeparators:Ue(new t(131,"wordSeparators",R.$8s,{description:p.localize(359,null)})),wordWrap:Ue(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:Ue(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new P),defaultColorDecorators:Ue(new o(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:Ue(new ge),tabFocusMode:Ue(new o(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:Ue(new me),wrappingInfo:Ue(new xe),wrappingIndent:Ue(new _e),wrappingStrategy:Ue(new ue)}}),define(Se[160],Ie([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[161],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[162],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(Se[163],Ie([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[164],Ie([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[165],Ie([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(Se[166],Ie([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(Se[167],Ie([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(Se[168],Ie([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(Se[169],Ie([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[170],Ie([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[171],Ie([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(Se[172],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[173],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[174],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[175],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[176],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[177],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[178],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[179],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[180],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[181],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[182],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[183],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[184],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(Se[185],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(Se[186],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(Se[187],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[188],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[189],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[190],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[191],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[192],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[193],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[194],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[195],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[196],Ie([1,0,14,162]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var A;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(A||(e.TokenType=A={}));function N(...E){switch(E.length){case 1:return(0,O.localize)(0,null,E[0]);case 2:return(0,O.localize)(1,null,E[0],E[1]);case 3:return(0,O.localize)(2,null,E[0],E[1],E[2]);default:return}}const R=(0,O.localize)(3,null),p=(0,O.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const S=this.d,l=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:T}),this.f.push(b)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const S=this.c.substring(this.d,this.e),l=m.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,S=!1,l=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(p);return}const f=this.c.charCodeAt(T);if(S)S=!1;else if(f===47&&!l){T++;break}else f===91?l=!0:f===92?S=!0:f===93&&(l=!1);T++}for(;T<this.c.length&&m.a.has(this.c.charCodeAt(T));)T++;this.e=T;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=m}),define(Se[197],Ie([1,0,24,32,164,311]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=m,e.$Kp=E,e.$Lp=T,e.$Mp=S,e.$Np=l,e.$Op=b,e.$Pp=f;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function m(o){return o=o.trim(),o==="*"||R.test(o)}function E(o){if(!m(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function T(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,c=o.minorBase;let u=o.minorMustEqual;const t=o.patchBase;let g=o.patchMustEqual;o.hasCaret&&(i===0||(u=!1),g=!1);let a=0;if(o.preRelease){const d=p.exec(o.preRelease);if(d){const[,w,$,v]=d;a=Date.UTC(Number(w),Number($)-1,Number(v))}}return{majorBase:i,majorMustEqual:n,minorBase:c,minorMustEqual:u,patchBase:t,patchMustEqual:g,isMinimum:o.hasGreaterEquals,notBefore:a}}function S(o,i,n){let c;typeof o=="string"?c=T(E(o)):c=o;let u;i instanceof Date?u=i.getTime():typeof i=="string"&&(u=new Date(i).getTime());let t;if(typeof n=="string"?t=T(E(n)):t=n,!c||!t)return!1;const g=c.majorBase,a=c.minorBase,d=c.patchBase;let w=t.majorBase,$=t.minorBase,v=t.patchBase;const y=t.notBefore;let h=t.majorMustEqual,D=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?g>w?!0:g<w?!1:a>$?!0:a<$||u&&u<y?!1:d>=v:(g===1&&w===0&&(!h||!D||!k)&&(w=1,$=0,v=0,h=!0,D=!1,k=!1),g<w?!1:g>w?!h:a<$?!1:a>$?!D:d<v?!1:d>v?!k:!(u&&u<y))}function l(o,i,n,c,u){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([O.default.Error,A.localize(0,null)]),t;if(typeof c.name!="string")return t.push([O.default.Error,A.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([O.default.Error,A.localize(2,null,"version")]),t;if(!c.engines)return t.push([O.default.Error,A.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([O.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!r(c.extensionDependencies))return t.push([O.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!r(c.activationEvents))return t.push([O.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([O.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([O.default.Warning,A.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([O.default.Error,A.localize(9,null,"main")]),t;{const d=(0,C.$_g)(n,c.main);(0,C.$6g)(d,n)||t.push([O.default.Warning,A.localize(10,null,d.path,n.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([O.default.Error,A.localize(11,null,"browser")]),t;{const d=(0,C.$_g)(n,c.browser);(0,C.$6g)(d,n)||t.push([O.default.Warning,A.localize(12,null,d.path,n.path)])}}if(!N.valid(c.version))return t.push([O.default.Error,A.localize(13,null)]),t;const g=[];if(!b(o,i,c,u,g))for(const d of g)t.push([O.default.Error,d]);return t}function b(o,i,n,c,u){return c||typeof n.main>"u"&&typeof n.browser>"u"?!0:s(o,i,n.engines.vscode,u)}function f(o,i,n){return o==="*"||s(i,n,o)}function s(o,i,n,c=[]){const u=T(E(n));if(!u)return c.push(A.localize(14,null,n)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(A.localize(15,null,n)),!1}else if(!u.majorMustEqual)return c.push(A.localize(16,null,n)),!1;return S(o,i,u)?!0:(c.push(A.localize(17,null,o,n)),!1)}function r(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(Se[71],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class C{constructor(A,N=[],R=!1){this.ctor=A,this.staticArguments=N,this.supportsDelayedInstantiation=R}}e.$vi=C}),define(Se[56],Ie([1,0,71]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$As=N,e.$Bs=R;const O=[];var A;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function N(p,m,E){m instanceof C.$vi||(m=new C.$vi(m,[],!!E)),O.push([p,m])}function R(){return O}}),define(Se[198],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=void 0;class C{constructor(N,R){this.key=N,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$dr=C;class O{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const R of this.a.values())R.outgoing.size===0&&N.push(R);return N}insertEdge(N,R){const p=this.lookupOrInsertNode(N),m=this.lookupOrInsertNode(R);p.outgoing.set(m.key,m),m.incoming.set(p.key,p)}removeNode(N){const R=this.b(N);this.a.delete(R);for(const p of this.a.values())p.outgoing.delete(R),p.incoming.delete(R)}lookupOrInsertNode(N){const R=this.b(N);let p=this.a.get(R);return p||(p=new C(R,N),this.a.set(R,p)),p}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[R,p]of this.a)N.push(`${R}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,R]of this.a){const p=new Set([N]),m=this.c(R,p);if(m)return m}}c(N,R){for(const[p,m]of N.outgoing){if(R.has(p))return[...R,p].join(" -> ");R.add(p);const E=this.c(m,R);if(E)return E;R.delete(p)}}}e.$er=O}),define(Se[3],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e._util=void 0,e.$yi=A,e.$zi=N;var C;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function p(m){return m[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=p})(C||(e._util=C={})),e.$xi=A("instantiationService");function O(R,p,m){p[C.DI_TARGET]===p?p[C.DI_DEPENDENCIES].push({id:R,index:m}):(p[C.DI_DEPENDENCIES]=[{id:R,index:m}],p[C.DI_TARGET]=p)}function A(R){if(C.serviceIds.has(R))return C.serviceIds.get(R);const p=function(m,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(p,m,T)};return p.toString=()=>R,C.serviceIds.set(R,p),p}function N(R){return R}}),define(Se[50],Ie([1,0,15,2,3]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=N,e.$7i=R,e.$8i=m,e.$9i=E,e.$0i=T,e.$$i=S,e.$_i=l,e.$aj=f,e.$bj=s,e.$cj=r,e.$5i=(0,A.$yi)("configurationService");function N(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}var p;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function m(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function T(o,i){const n=Object.create(null);for(const c in o)S(n,c,o[c],i);return n}function S(o,i,n,c){const u=i.split("."),t=u.pop();let g=o;for(let a=0;a<u.length;a++){const d=u[a];let w=g[d];switch(typeof w){case"undefined":w=g[d]=Object.create(null);break;case"object":if(w===null){c(`Ignoring ${i} as ${u.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${i} as ${u.slice(0,a+1).join(".")} is ${JSON.stringify(w)}`);return}g=w}if(typeof g=="object"&&g!==null)try{g[t]=n}catch{c(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(g)}`)}else c(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(g)}`)}function l(o,i){const n=i.split(".");b(o,n)}function b(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const c=o[n];typeof c=="object"&&!Array.isArray(c)&&(b(c,i),Object.keys(c).length===0&&delete o[n])}}function f(o,i,n){function c(g,a){let d=g;for(const w of a){if(typeof d!="object"||d===null)return;d=d[w]}return d}const u=i.split("."),t=c(o,u);return typeof t>"u"?n:t}function s(o,i,n){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in o?C.$ag(o[c])&&C.$ag(i[c])?s(o[c],i[c],n):n&&(o[c]=i[c]):o[c]=i[c])})}function r(o){return o.replace(/[\[\]]/g,"")}}),define(Se[31],Ie([1,0,23,13,196,3,161,14]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=E,e.$xj=g,e.$yj=a,e.$Rj=Ce;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",C.$j),m.set("isLinux",C.$k),m.set("isWindows",C.$i),m.set("isWeb",C.$o),m.set("isMacNative",C.$j&&!C.$o),m.set("isEdge",C.$H),m.set("isFirefox",C.$F),m.set("isChrome",C.$E),m.set("isSafari",C.$G);function E(ne,U){if(m.get(ne)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(ne,U)}const T=Object.prototype.hasOwnProperty;var S;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},b=(0,R.localize)(0,null),f=(0,R.localize)(1,null),s=(0,R.localize)(2,null),r=(0,R.localize)(3,null),o=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=l){this.k=U,this.d=new A.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const ve=this.D(),Fe=ve.type===17?i:void 0;throw this.h.push({message:o,offset:ve.offset,lexeme:A.$tj.getLexeme(ve),additionalInfo:Fe}),u.c}return x}catch(x){if(x!==u.c)throw x;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const x=this.o();U.push(x)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const x=this.s();U.push(x)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),$.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,r),x?.negate()}case 17:return this.z(),I.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,r),x}case 17:{const x=U.lexeme;if(this.z(),this.y(9)){const Fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Fe.type!==10)throw this.B("REGEX",Fe);const ke=Fe.lexeme,we=ke.lastIndexOf("/"),ge=we===ke.length-1?void 0:this.w(ke.substring(we+1));let Q;try{Q=new RegExp(ke.substring(1,we),ge)}catch{throw this.B("REGEX",Fe)}return z.create(x,Q)}switch(Fe.type){case 10:case 19:{const ke=[Fe.lexeme];this.z();let we=this.D(),ge=0;for(let Ne=0;Ne<Fe.lexeme.length;Ne++)Fe.lexeme.charCodeAt(Ne)===40?ge++:Fe.lexeme.charCodeAt(Ne)===41&&ge--;for(;!this.E()&&we.type!==15&&we.type!==16;){switch(we.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Ne=0;Ne<we.lexeme.length;Ne++)we.lexeme.charCodeAt(Ne)===40?ge++:Fe.lexeme.charCodeAt(Ne)===41&&ge--}if(ge<0)break;ke.push(A.$tj.getLexeme(we)),this.z(),we=this.D()}const Q=ke.join(""),Y=Q.lastIndexOf("/"),he=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let ce;try{ce=new RegExp(Q.substring(1,Y),he)}catch{throw this.B("REGEX",Fe)}return t.regex(x,ce)}case 18:{const ke=Fe.lexeme;this.z();let we=null;if(!(0,O.$9e)(ke)){const ge=ke.indexOf("/"),Q=ke.lastIndexOf("/");if(ge!==Q&&ge>=0){const Y=ke.slice(ge+1,Q),he=ke[Q+1]==="i"?"i":"";try{we=new RegExp(Y,he)}catch{throw this.B("REGEX",Fe)}}}if(we===null)throw this.B("REGEX",Fe);return z.create(x,we)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Fe=this.u();return t.notIn(x,Fe)}switch(this.D().type){case 3:{this.z();const Fe=this.u();if(this.x().type===18)return t.equals(x,Fe);switch(Fe){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Fe)}}case 4:{this.z();const Fe=this.u();if(this.x().type===18)return t.notEquals(x,Fe);switch(Fe){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Fe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),M.create(x,this.u());case 7:return this.z(),V.create(x,this.u());case 8:return this.z(),W.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:c}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,x){if(this.C(U))return this.z();throw this.B(x,this.D())}B(U,x,ve){const Fe=(0,R.localize)(8,null,U,A.$tj.getLexeme(x)),ke=x.offset,we=A.$tj.getLexeme(x);return this.h.push({message:Fe,offset:ke,lexeme:we,additionalInfo:ve}),u.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=u;class t{static false(){return w.INSTANCE}static true(){return $.INSTANCE}static has(U){return v.create(U)}static equals(U,x){return y.create(U,x)}static notEquals(U,x){return k.create(U,x)}static regex(U,x){return z.create(U,x)}static in(U,x){return h.create(U,x)}static notIn(U,x){return D.create(U,x)}static not(U){return I.create(U)}static and(...U){return de.create(U,null,!0)}static or(...U){return ye.create(U,null,!0)}static greater(U,x){return V.create(U,x)}static greaterEquals(U,x){return W.create(U,x)}static smaller(U,x){return q.create(U,x)}static smallerEquals(U,x){return M.create(U,x)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$wj=t;function g(ne){const U=new u({regexParsingWithErrorRecovery:!1});return ne.map(x=>(U.parse(x),U.lexingErrors.length>0?U.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,R.localize)(9,null,ve.additionalInfo):(0,R.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function a(ne,U){const x=ne?ne.substituteConstants():void 0,ve=U?U.substituteConstants():void 0;return!x&&!ve?!0:!x||!ve?!1:x.equals(ve)}function d(ne,U){return ne.cmp(U)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return $.INSTANCE}}e.$zj=w;class ${static{this.INSTANCE=new $}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return w.INSTANCE}}e.$Aj=$;class v{static create(U,x=null){const ve=m.get(U);return typeof ve=="boolean"?ve?$.INSTANCE:w.INSTANCE:new v(U,x)}constructor(U,x){this.key=U,this.c=x,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:me(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=m.get(this.key);return typeof U=="boolean"?U?$.INSTANCE:w.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$Bj=v;class y{static create(U,x,ve=null){if(typeof x=="boolean")return x?v.create(U,ve):I.create(U,ve);const Fe=m.get(U);return typeof Fe=="boolean"?x===(Fe?"true":"false")?$.INSTANCE:w.INSTANCE:new y(U,x,ve)}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=m.get(this.c);if(typeof U=="boolean"){const x=U?"true":"false";return this.d===x?$.INSTANCE:w.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Cj=y;class h{static create(U,x){return new h(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const x=U.getValue(this.f),ve=U.getValue(this.d);return Array.isArray(x)?x.includes(ve):typeof ve=="string"&&typeof x=="object"&&x!==null?T.call(x,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Dj=h;class D{static create(U,x){return new D(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=11,this.c=h.create(U,x)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=D;class k{static create(U,x,ve=null){if(typeof x=="boolean")return x?I.create(U,ve):v.create(U,ve);const Fe=m.get(U);return typeof Fe=="boolean"?x===(Fe?"true":"false")?w.INSTANCE:$.INSTANCE:new k(U,x,ve)}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=m.get(this.c);if(typeof U=="boolean"){const x=U?"true":"false";return this.d===x?w.INSTANCE:$.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Fj=k;class I{static create(U,x=null){const ve=m.get(U);return typeof ve=="boolean"?ve?w.INSTANCE:$.INSTANCE:new I(U,x)}constructor(U,x){this.c=U,this.d=x,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:me(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=m.get(this.c);return typeof U=="boolean"?U?w.INSTANCE:$.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Gj=I;function P(ne,U){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?U(ne):w.INSTANCE}class V{static create(U,x,ve=null){return P(x,Fe=>new V(U,Fe,ve))}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Hj=V;class W{static create(U,x,ve=null){return P(x,Fe=>new W(U,Fe,ve))}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Ij=W;class q{static create(U,x,ve=null){return P(x,Fe=>new q(U,Fe,ve))}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Jj=q;class M{static create(U,x,ve=null){return P(x,Fe=>new M(U,Fe,ve))}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Kj=M;class z{static create(U,x){return new z(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const x=this.f?this.f.source:"",ve=U.f?U.f.source:"";return x<ve?-1:x>ve?1:0}equals(U){if(U.type===this.type){const x=this.f?this.f.source:"",ve=U.f?U.f.source:"";return this.d===U.d&&x===ve}return!1}substituteConstants(){return this}evaluate(U){const x=U.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$Lj=z;class G{static create(U){return new G(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new G(this.c.map(U))}negate(){return this.c}}e.$Mj=G;function ie(ne){let U=null;for(let x=0,ve=ne.length;x<ve;x++){const Fe=ne[x].substituteConstants();if(ne[x]!==Fe&&U===null){U=[];for(let ke=0;ke<x;ke++)U[ke]=ne[ke]}U!==null&&(U[x]=Fe)}return U===null?ne:U}class de{static create(U,x,ve){return de.d(U,x,ve)}constructor(U,x){this.expr=U,this.c=x,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Fe=d(this.expr[x],U.expr[x]);if(Fe!==0)return Fe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(U.expr[x]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:de.create(U,this.c,!1)}evaluate(U){for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].evaluate(U))return!1;return!0}static d(U,x,ve){const Fe=[];let ke=!1;for(const we of U)if(we){if(we.type===1){ke=!0;continue}if(we.type===0)return w.INSTANCE;if(we.type===6){Fe.push(...we.expr);continue}Fe.push(we)}if(Fe.length===0&&ke)return $.INSTANCE;if(Fe.length!==0){if(Fe.length===1)return Fe[0];Fe.sort(d);for(let we=1;we<Fe.length;we++)Fe[we-1].equals(Fe[we])&&(Fe.splice(we,1),we--);if(Fe.length===1)return Fe[0];for(;Fe.length>1;){const we=Fe[Fe.length-1];if(we.type!==9)break;Fe.pop();const ge=Fe.pop(),Q=Fe.length===0,Y=ye.create(we.expr.map(he=>de.create([he,ge],null,ve)),null,Q);Y&&(Fe.push(Y),Fe.sort(d))}if(Fe.length===1)return Fe[0];if(ve){for(let we=0;we<Fe.length;we++)for(let ge=we+1;ge<Fe.length;ge++)if(Fe[we].negate().equals(Fe[ge]))return w.INSTANCE;if(Fe.length===1)return Fe[0]}return new de(Fe,x)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const x of this.expr)U.push(...x.keys());return U}map(U){return new de(this.expr.map(x=>x.map(U)),null)}negate(){if(!this.c){const U=[];for(const x of this.expr)U.push(x.negate());this.c=ye.create(U,this,!0)}return this.c}}e.$Nj=de;class ye{static create(U,x,ve){return ye.d(U,x,ve)}constructor(U,x){this.expr=U,this.c=x,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Fe=d(this.expr[x],U.expr[x]);if(Fe!==0)return Fe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(U.expr[x]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:ye.create(U,this.c,!1)}evaluate(U){for(let x=0,ve=this.expr.length;x<ve;x++)if(this.expr[x].evaluate(U))return!0;return!1}static d(U,x,ve){let Fe=[],ke=!1;if(U){for(let we=0,ge=U.length;we<ge;we++){const Q=U[we];if(Q){if(Q.type===0){ke=!0;continue}if(Q.type===1)return $.INSTANCE;if(Q.type===9){Fe=Fe.concat(Q.expr);continue}Fe.push(Q)}}if(Fe.length===0&&ke)return w.INSTANCE;Fe.sort(d)}if(Fe.length!==0){if(Fe.length===1)return Fe[0];for(let we=1;we<Fe.length;we++)Fe[we-1].equals(Fe[we])&&(Fe.splice(we,1),we--);if(Fe.length===1)return Fe[0];if(ve){for(let we=0;we<Fe.length;we++)for(let ge=we+1;ge<Fe.length;ge++)if(Fe[we].negate().equals(Fe[ge]))return $.INSTANCE;if(Fe.length===1)return Fe[0]}return new ye(Fe,x)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const x of this.expr)U.push(...x.keys());return U}map(U){return new ye(this.expr.map(x=>x.map(U)),null)}negate(){if(!this.c){const U=[];for(const x of this.expr)U.push(x.negate());for(;U.length>1;){const x=U.shift(),ve=U.shift(),Fe=[];for(const ke of Oe(x))for(const we of Oe(ve))Fe.push(de.create([ke,we],null,!1));U.unshift(ye.create(Fe,null,!1))}this.c=ye.create(U,this,!0)}return this.c}}e.$Oj=ye;class Ee extends v{static{this.d=[]}static all(){return Ee.d.values()}constructor(U,x,ve){super(U,null),this.f=x,typeof ve=="object"?Ee.d.push({...ve,key:U}):ve!==!0&&Ee.d.push({key:U,description:ve,type:x!=null?typeof x:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return y.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$Pj=Ee,e.$Qj=(0,N.$yi)("contextKeyService");function me(ne,U){return ne<U?-1:ne>U?1:0}function ue(ne,U,x,ve){return ne<x?-1:ne>x?1:U<ve?-1:U>ve?1:0}function Ce(ne,U){if(ne.type===0||U.type===1)return!0;if(ne.type===9)return U.type===9?se(ne.expr,U.expr):!1;if(U.type===9){for(const x of U.expr)if(Ce(ne,x))return!0;return!1}if(ne.type===6){if(U.type===6)return se(U.expr,ne.expr);for(const x of ne.expr)if(Ce(x,U))return!0;return!1}return ne.equals(U)}function se(ne,U){let x=0,ve=0;for(;x<ne.length&&ve<U.length;){const Fe=ne[x].cmp(U[ve]);if(Fe<0)return!1;Fe===0&&x++,ve++}return x===ne.length}function Oe(ne){return ne.type===9?ne.expr:[ne]}}),define(Se[99],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,C.$yi)("environmentService"),e.$Gi=(0,C.$zi)(e.$Fi)}),define(Se[100],Ie([1,0,163,3]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.ExtensionManagementErrorCode=e.$0o=e.ExtensionGalleryErrorCode=e.$9o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$3o=A,e.$4o=N,e.$5o=R,e.$6o=p,e.$7o=m,e.$8o=E,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionsSync",e.$2o="dependecyOrPackExtensionInstall";function A(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(i,n){return n==="web"&&!i.includes("web")}function m(i,n,c){return p(n,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var T;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var S;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(i){i.Install="install",i.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$9o=(0,O.$yi)("extensionGalleryService");var f;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class s extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$0o=s;var r;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(r||(e.ExtensionManagementErrorCode=r={}));class o extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$$o=o,e.$_o=(0,O.$yi)("extensionManagementService"),e.$ap="extensionsIdentifiers/disabled",e.$bp="extensionsIdentifiers/enabled",e.$cp=(0,O.$yi)("IGlobalExtensionEnablementService"),e.$dp=(0,O.$yi)("IExtensionTipsService"),e.$ep=(0,C.localize2)(0,"Extensions"),e.$fp=(0,C.localize2)(1,"Preferences")}),define(Se[38],Ie([1,0,54,19,13,15,2,165,3,23,16,43]),function(le,e,C,O,A,N,R,p,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$xl=e.FileKind=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.FileOperationResult=e.$pl=e.$ol=e.$nl=e.$ll=e.FileChangeType=e.$kl=e.FileOperation=e.$el=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$5k=void 0,e.$6k=l,e.$7k=r,e.$8k=i,e.$9k=n,e.$0k=c,e.$$k=u,e.$_k=t,e.$al=g,e.$bl=a,e.$cl=d,e.$dl=w,e.$fl=y,e.$gl=h,e.$hl=D,e.$il=k,e.$jl=I,e.$ml=M,e.$yl=Ee,e.$zl=me,e.$Bl=Ce,e.$5k=(0,m.$yi)("fileService");function l(se){return se.create===!0}var b;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var f;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var s;(function(se){se[se.UPDATED=2]="UPDATED",se[se.ADDED=4]="ADDED",se[se.DELETED=8]="DELETED"})(s||(e.FileChangeFilter=s={}));function r(se){const Oe=se;return!!Oe&&typeof Oe.onDidChange=="function"}var o;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function i(se){return!!(se.capabilities&2)}function n(se){return!!(se.capabilities&8)}function c(se){return!!(se.capabilities&131072)}function u(se){return!!(se.capabilities&4)}function t(se){return!!(se.capabilities&16)}function g(se){return i(se)?!!(se.capabilities&16384):!1}function a(se){return i(se)?!!(se.capabilities&32768):!1}function d(se){return!!(se.capabilities&65536)}function w(se){return!!(se.capabilities&2048)}var $;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})($||(e.FileSystemProviderErrorCode=$={}));class v extends Error{static create(Oe,ne){const U=new v(Oe.toString(),ne);return D(U,ne),U}constructor(Oe,ne){super(Oe),this.code=ne}}e.$el=v;function y(se,Oe){return v.create(se,Oe)}function h(se){return se||y((0,p.localize)(0,null),$.Unknown)}function D(se,Oe){return se.name=Oe?`${Oe} (FileSystemError)`:"FileSystemError",se}function k(se){if(!se)return $.Unknown;if(se instanceof v)return se.code;const Oe=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!Oe)return $.Unknown;switch(Oe[1]){case $.FileExists:return $.FileExists;case $.FileIsADirectory:return $.FileIsADirectory;case $.FileNotADirectory:return $.FileNotADirectory;case $.FileNotFound:return $.FileNotFound;case $.FileTooLarge:return $.FileTooLarge;case $.FileWriteLocked:return $.FileWriteLocked;case $.NoPermissions:return $.NoPermissions;case $.Unavailable:return $.Unavailable}return $.Unknown}function I(se){if(se instanceof z)return se.fileOperationResult;switch(k(se)){case $.FileNotFound:return 1;case $.FileIsADirectory:return 0;case $.FileNotADirectory:return 9;case $.FileWriteLocked:return 5;case $.NoPermissions:return 6;case $.FileExists:return 4;case $.FileTooLarge:return 7;default:return 10}}var P;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class V{constructor(Oe,ne,U){this.resource=Oe,this.operation=ne,this.target=U}isOperation(Oe){return this.operation===Oe}}e.$kl=V;var W;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class q{static{this.a=null}constructor(Oe,ne){this.c=ne,this.b=void 0,this.d=new S.$V(()=>{const U=C.$Ei.forUris(()=>this.c);return U.fill(this.rawAdded.map(x=>[x,!0])),U}),this.f=new S.$V(()=>{const U=C.$Ei.forUris(()=>this.c);return U.fill(this.rawUpdated.map(x=>[x,!0])),U}),this.g=new S.$V(()=>{const U=C.$Ei.forUris(()=>this.c);return U.fill(this.rawDeleted.map(x=>[x,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of Oe){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==q.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Oe,...ne){return this.h(Oe,{includeChildren:!1},...ne)}affects(Oe,...ne){return this.h(Oe,{includeChildren:!0},...ne)}h(Oe,ne,...U){if(!Oe)return!1;const x=U.length>0;return!!((!x||U.includes(1))&&(this.d.value.get(Oe)||ne.includeChildren&&this.d.value.findSuperstr(Oe))||(!x||U.includes(0))&&(this.f.value.get(Oe)||ne.includeChildren&&this.f.value.findSuperstr(Oe))||(!x||U.includes(2))&&(this.g.value.findSubstr(Oe)||ne.includeChildren&&this.g.value.findSuperstr(Oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Oe){return this.b===Oe}hasCorrelation(){return typeof this.b=="number"}}e.$ll=q;function M(se,Oe,ne){return!se||!Oe||se===Oe||Oe.length>se.length?!1:(Oe.charAt(Oe.length-1)!==O.sep&&(Oe+=O.sep),ne?(0,A.$Af)(se,Oe):se.indexOf(Oe)===0)}class z extends Error{constructor(Oe,ne,U){super(Oe),this.fileOperationResult=ne,this.options=U}}e.$nl=z;class G extends z{constructor(Oe,ne,U,x){super(Oe,ne,x),this.fileOperationResult=ne,this.size=U}}e.$ol=G;class ie extends z{constructor(Oe,ne,U){super(Oe,2,U),this.stat=ne}}e.$pl=ie;var de;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(de||(e.FileOperationResult=de={})),e.$ql={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sl="files.associations",e.$tl="files.exclude",e.$ul="files.readonlyInclude",e.$vl="files.readonlyExclude",e.$wl="files.readonlyFromPermissions";var ye;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(e.FileKind=ye={})),e.$xl="";function Ee(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}async function me(se,Oe){if(!Oe.hasProvider(R.URI.from({scheme:se.scheme})))return new Promise(ne=>{const U=Oe.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===se.scheme&&x.added&&(U.dispose(),ne())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(Oe){return(0,N.$cg)(Oe)||(Oe=0),Oe<ue.KB?(0,p.localize)(1,null,Oe.toFixed(0)):Oe<ue.MB?(0,p.localize)(2,null,(Oe/ue.KB).toFixed(2)):Oe<ue.GB?(0,p.localize)(3,null,(Oe/ue.MB).toFixed(2)):Oe<ue.TB?(0,p.localize)(4,null,(Oe/ue.GB).toFixed(2)):(0,p.localize)(5,null,(Oe/ue.TB).toFixed(2))}}e.$Al=ue;function Ce(se){const Oe=typeof se=="string"||se?.scheme===T.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===T.Schemas.file?1024*ue.MB:Oe?10*ue.MB:E.$o?50*ue.MB:1024*ue.MB}}),define(Se[72],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class C{constructor(...A){this.a=new Map;for(const[N,R]of A)this.set(N,R)}set(A,N){const R=this.a.get(A);return this.a.set(A,N),R}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$wi=C}),define(Se[199],Ie([1,0,11,14,6,71,198,3,72,200]),function(le,e,C,O,A,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0;const T=!1;class S extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class l{constructor(r=new m.$wi,o=!1,i,n=T){this.i=r,this.j=o,this.k=i,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$xi,this),this._globalGraph=n?i?._globalGraph??new R.$er(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Pc)(this.h),this.h.clear();for(const r of this.g)(0,A.$Oc)(r)&&r.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(r){this.m();const o=new class extends l{dispose(){this.h.delete(o),super.dispose()}}(r,this.j,this,this.l);return this.h.add(o),o}invokeFunction(r,...o){this.m();const i=f.traceInvocation(this.l,r);let n=!1;try{return r({get:u=>{if(n)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(u,i);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(r,...o){this.m();let i,n;return r instanceof N.$vi?(i=f.traceCreation(this.l,r.ctor),n=this.o(r.ctor,r.staticArguments.concat(o),i)):(i=f.traceCreation(this.l,r),n=this.o(r,o,i)),i.stop(),n}o(r,o=[],i){const n=p._util.getServiceDependencies(r).sort((t,g)=>t.index-g.index),c=[];for(const t of n){const g=this.s(t.id,i);g||this.y(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(g)}const u=n.length>0?n[0].index:o.length;if(o.length!==u){console.trace(`[createInstance] First service dependency of ${r.name} at position ${u+1} conflicts with ${o.length} static arguments`);const t=u-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,u)}return Reflect.construct(r,o.concat(c))}q(r,o){if(this.i.get(r)instanceof N.$vi)this.i.set(r,o);else if(this.k)this.k.q(r,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(r){const o=this.i.get(r);return!o&&this.k?this.k.r(r):o}s(r,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const i=this.r(r);return i instanceof N.$vi?this.u(r,i,o.branch(r,!0)):(o.branch(r,!1),i)}u(r,o,i){if(this.t.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.t.add(r);try{return this.v(r,o,i)}finally{this.t.delete(r)}}v(r,o,i){const n=new R.$er(t=>t.id.toString());let c=0;const u=[{id:r,desc:o,_trace:i}];for(;u.length;){const t=u.pop();if(n.lookupOrInsertNode(t),c++>1e3)throw new S(n);for(const g of p._util.getServiceDependencies(t.desc.ctor)){const a=this.r(g.id);if(a||this.y(`[createInstance] ${r} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(g.id)),a instanceof N.$vi){const d={id:g.id,desc:a,_trace:t._trace.branch(g.id,!0)};n.insertEdge(t,d),u.push(d)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new S(n);break}for(const{data:g}of t){if(this.r(g.id)instanceof N.$vi){const d=this.w(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.q(g.id,d)}n.removeNode(g)}}return this.r(r)}w(r,o,i=[],n,c){if(this.i.get(r)instanceof N.$vi)return this.x(r,o,i,n,c,this.g);if(this.k)return this.k.w(r,o,i,n,c);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(r,o,i=[],n,c,u){if(n){const t=new l(void 0,this.j,this,this.l);t.c=String(r);const g=new Map,a=new C.$Rh(()=>{const d=t.o(o,i,c);for(const[w,$]of g){const v=d[w];if(typeof v=="function")for(const y of $)y.disposable=v.apply(d,y.listener)}return g.clear(),u.add(d),d});return new Proxy(Object.create(null),{get(d,w){if(!a.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let y=g.get(w);return y||(y=new E.$5c,g.set(w,y)),(D,k,I)=>{if(a.isInitialized)return a.value[w](D,k,I);{const P={listener:[D,k,I],disposable:void 0},V=y.push(P);return(0,A.$Sc)(()=>{V(),P.disposable?.dispose()})}}}if(w in d)return d[w];const $=a.value;let v=$[w];return typeof v!="function"||(v=v.bind($),d[w]=v),v},set(d,w,$){return a.value[w]=$,!0},getPrototypeOf(d){return o.prototype}})}else{const t=this.o(o,i,c);return u.add(t),t}}y(r,o){if(o&&console.warn(r),this.j)throw new Error(r)}}e.$fr=l;var b;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(b||(b={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(r,o){return r?new f(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(r,o){return r?new f(1,o.name):f.c}static{this.f=0}constructor(r,o){this.type=r,this.name=o,this.g=Date.now(),this.h=[]}branch(r,o){const i=new f(3,r.toString());return this.h.push([r,o,i]),i}stop(){const r=Date.now()-this.g;f.f+=r;let o=!1;function i(c,u){const t=[],g=new Array(c+1).join("	");for(const[a,d,w]of u.h)if(d&&w){o=!0,t.push(`${g}CREATES -> ${a}`);const $=i(c+1,w);$&&t.push($)}else t.push(`${g}uses -> ${a}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(r>2||o)&&f.all.add(n.join(`
`))}}e.$gr=f}),define(Se[12],Ie([1,0,166,44,5,73,6,28,23,24,15,2,31,3]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=s,e.log=o,e.$gk=v,e.$hk=y,e.$ik=h,e.$jk=D,e.$5j=(0,b.$yi)("logService"),e.$6j=(0,b.$yi)("loggerService");function f(){return new Date().toISOString()}function s(k){return(0,T.$cg)(k)}var r;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$8j=r.Info;function o(k,I,P){switch(I){case r.Trace:k.trace(P);break;case r.Debug:k.debug(P);break;case r.Info:k.info(P);break;case r.Warning:k.warn(P);break;case r.Error:k.error(P);break;case r.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function i(k,I=!1){let P="";for(let V=0;V<k.length;V++){let W=k[V];if(W instanceof Error&&(W=(0,O.$jj)(W,I)),typeof W=="object")try{W=JSON.stringify(W)}catch{}P+=(V>0?" ":"")+W}return P}class n extends R.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new A.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==r.Off&&this.b<=I}}e.$0j=n;class c extends n{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...P){this.f(r.Trace)&&this.g(r.Trace,i([I,...P],!0))}debug(I,...P){this.f(r.Debug)&&this.g(r.Debug,i([I,...P]))}info(I,...P){this.f(r.Info)&&this.g(r.Info,i([I,...P]))}warn(I,...P){this.f(r.Warning)&&this.g(r.Warning,i([I,...P]))}error(I,...P){if(this.f(r.Error))if(I instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=I.stack,this.g(r.Error,i(V))}else this.g(r.Error,i([I,...P]))}flush(){}}e.$$j=c;class u extends n{constructor(I=e.$8j){super(),this.setLevel(I),this.g=!m.$i}trace(I,...P){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}debug(I,...P){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}info(I,...P){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}warn(I,...P){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,I,...P):console.warn(`[main ${f()}]`,I,...P))}error(I,...P){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,I,...P):console.error(`[main ${f()}]`,I,...P))}flush(){}}e.$_j=u;class t extends n{constructor(I=e.$8j,P=!0){super(),this.g=P,this.setLevel(I)}trace(I,...P){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...P):console.log(I,...P))}debug(I,...P){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...P):console.log(I,...P))}info(I,...P){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...P):console.log(I,...P))}warn(I,...P){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...P):console.log(I,...P))}error(I,...P){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...P):console.error(I,...P))}flush(){}}e.$ak=t;class g extends n{constructor(I,P=e.$8j){super(),this.g=I,this.setLevel(P)}trace(I,...P){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(I),...P])}debug(I,...P){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(I),...P])}info(I,...P){this.f(r.Info)&&this.g.log(r.Info,[this.h(I),...P])}warn(I,...P){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(I),...P])}error(I,...P){this.f(r.Error)&&this.g.log(r.Error,[this.h(I),...P])}h(I){return typeof I=="string"?I:(0,O.$jj)(I,this.f(r.Trace))}flush(){}}e.$bk=g;class a extends n{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const P of this.g)P.setLevel(I);super.setLevel(I)}trace(I,...P){for(const V of this.g)V.trace(I,...P)}debug(I,...P){for(const V of this.g)V.debug(I,...P)}info(I,...P){for(const V of this.g)V.info(I,...P)}warn(I,...P){for(const V of this.g)V.warn(I,...P)}error(I,...P){for(const V of this.g)V.error(I,...P)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$ck=a;class d extends R.$Uc{constructor(I,P,V){if(super(),this.h=I,this.j=P,this.b=new p.$Ac,this.c=this.B(new A.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$fe),this.onDidChangeVisibility=this.g.event,V)for(const W of V)this.b.set(W.resource,{logger:void 0,info:W})}m(I){return(0,T.$$f)(I)?[...this.b.values()].find(P=>P.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,P){const V=this.n(I),W=(0,T.$$f)(I)?I:P?.id??(0,N.$mj)(V.toString()).toString(16);let q=this.b.get(V)?.logger;const M=P?.logLevel==="always"?r.Trace:P?.logLevel;q||(q=this.s(V,M??this.getLogLevel(V)??this.h,{...P,id:W}));const z={logger:q,info:{resource:V,id:W,logLevel:M,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(z.info),this.b.set(V,z),q}n(I){return(0,T.$$f)(I)?(0,E.$_g)(this.j,`${I}.log`):I}setLogLevel(I,P){if(S.URI.isUri(I)){const V=I,W=P,q=this.b.get(V);q&&W!==q.info.logLevel&&(q.info.logLevel=W===this.h?void 0:W,q.logger?.setLevel(W),this.b.set(q.info.resource,q),this.f.fire([V,W]))}else{this.h=I;for(const[V,W]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,P){const V=this.m(I);V&&P!==!V.info.hidden&&(V.info.hidden=!P,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,P]))}getLogLevel(I){let P;return I&&(P=this.b.get(I)?.info.logLevel),P??this.h}registerLogger(I){const P=this.b.get(I.resource);P?P.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const P=this.b.get(I);P&&(P.logger&&P.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=d;class w{constructor(){this.onDidChangeLogLevel=new A.$fe().event}setLevel(I){}getLevel(){return r.Info}trace(I,...P){}debug(I,...P){}info(I,...P){}warn(I,...P){}error(I,...P){}critical(I,...P){}dispose(){}flush(){}}e.$ek=w;class $ extends w{}e.$fk=$;function v(k){if(k.verbose)return r.Trace;if(typeof k.logLevel=="string"){const I=D(k.logLevel.toLowerCase());if(I!==void 0)return I}return e.$8j}function y(k){switch(k){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}function h(k){switch(k){case r.Trace:return{original:"Trace",value:C.localize(0,null)};case r.Debug:return{original:"Debug",value:C.localize(1,null)};case r.Info:return{original:"Info",value:C.localize(2,null)};case r.Warning:return{original:"Warning",value:C.localize(3,null)};case r.Error:return{original:"Error",value:C.localize(4,null)};case r.Off:return{original:"Off",value:C.localize(5,null)}}}function D(k){switch(k){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$kk=new l.$Pj("logLevel",y(r.Info))}),define(Se[201],Ie([1,0,6,12]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=void 0;class A extends C.$Uc{constructor(R,p=[]){super(),this.a=new O.$ck([R,...p]),this.B(R.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...p){this.a.trace(R,...p)}debug(R,...p){this.a.debug(R,...p)}info(R,...p){this.a.info(R,...p)}warn(R,...p){this.a.warn(R,...p)}error(R,...p){this.a.error(R,...p)}flush(){this.a.flush()}}e.$_P=A}),define(Se[101],Ie([1,0,32,167,3]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var R;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(m){function E(f,s){return s-f}m.compare=E;const T=Object.create(null);T[m.Error]=(0,O.localize)(0,null),T[m.Warning]=(0,O.localize)(1,null),T[m.Info]=(0,O.localize)(2,null);function S(f){return T[f]||""}m.toString=S;function l(f){switch(f){case C.default.Error:return m.Error;case C.default.Warning:return m.Warning;case C.default.Info:return m.Info;case C.default.Ignore:return m.Hint}}m.fromSeverity=l;function b(f){switch(f){case m.Error:return C.default.Error;case m.Warning:return C.default.Warning;case m.Info:return C.default.Info;case m.Hint:return C.default.Ignore}}m.toSeverity=b}(R||(e.MarkerSeverity=R={}));var p;(function(m){const E="";function T(l){return S(l,!0)}m.makeKey=T;function S(l,b){const f=[E];return l.source?f.push(l.source.replace("\xA6","\\\xA6")):f.push(E),l.code?typeof l.code=="string"?f.push(l.code.replace("\xA6","\\\xA6")):f.push(l.code.value.replace("\xA6","\\\xA6")):f.push(E),l.severity!==void 0&&l.severity!==null?f.push(R.toString(l.severity)):f.push(E),l.message&&b?f.push(l.message.replace("\xA6","\\\xA6")):f.push(E),l.startLineNumber!==void 0&&l.startLineNumber!==null?f.push(l.startLineNumber.toString()):f.push(E),l.startColumn!==void 0&&l.startColumn!==null?f.push(l.startColumn.toString()):f.push(E),l.endLineNumber!==void 0&&l.endLineNumber!==null?f.push(l.endLineNumber.toString()):f.push(E),l.endColumn!==void 0&&l.endColumn!==null?f.push(l.endColumn.toString()):f.push(E),f.push(E),f.join("\xA6")}m.makeKeyOptionalMessage=S})(p||(e.IMarkerData=p={})),e.$0t=(0,A.$yi)("markerService")}),define(Se[202],Ie([1,0,5,32,3]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$aw=e.Severity=void 0,e.$bw=p,e.Severity=O.default,e.$aw=(0,A.$yi)("notificationService");var N;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var R;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function p(S){if(S){const l=S;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var m;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new T,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$cw=E;class T{infinite(){}done(){}total(l){}worked(l){}}e.$dw=T}),define(Se[102],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,C.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(le,e,C,O){var A=arguments.length,N=A<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,C):O,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(le,e,C,O);else for(var p=le.length-1;p>=0;p--)(R=le[p])&&(N=(A<3?R(N):A>3?R(e,C,N):R(e,C))||N);return A>3&&N&&Object.defineProperty(e,C,N),N},We=this&&this.__param||function(le,e){return function(C,O){e(C,O,le)}};define(Se[103],Ie([1,0,11,20,6,3]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.$fw=e.ProgressLocation=e.$ew=void 0,e.$ew=(0,N.$yi)("progressService");var R;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$fw=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$gw=p;class m{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const b=this.d;this.d=()=>{b?.(),l()}}):Promise.resolve()}}e.$hw=m;let E=class extends A.$Uc{constructor(l,b){super(),this.a=new C.$Vh,b.withProgress(l,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,A.$Sc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$iw=E,e.$iw=E=Je([We(1,e.$ew)],E);class T extends A.$Uc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new A.$Tc)}start(l){this.stop();const b=++this.a,f=new O.$qe;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,A.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Sc)(()=>f.cancel())),this.b.add((0,A.$Sc)(()=>this.c?this.c.done():void 0)),{id:b,token:f.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$jw=T,e.$kw=(0,N.$yi)("editorProgressService")}),define(Se[29],Ie([1,0,57,15]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class A{constructor(){this.a=new Map}add(R,p){C.ok(O.$$f(R)),C.ok(O.$ag(p)),C.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,p)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$fo=new A}),define(Se[74],Ie([1,0,5,29]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function A(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class N{constructor(){this.b=new C.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,E){this.a[A(m)]=E,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const R=new N;O.$fo.add(e.$go.JSONContribution,R)}),define(Se[51],Ie([1,0,18,5,15,160,50,74,29]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=s,e.$wo=r,e.$xo=o,e.$yo=n,e.$zo=c;var E;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$ko={Configuration:"base.contributions.configuration"};var T;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const S=m.$fo.as(p.$go.JSONContribution);class l{constructor(){this.h=new Set,this.i=new O.$fe,this.onDidSchemaChange=this.i.event,this.j=new O.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(t,g=!0){this.registerConfigurations([t],g)}registerConfigurations(t,g=!0){const a=new Set;this.n(t,g,a),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const g=new Set;this.o(t,g),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:g})}updateConfigurations({add:t,remove:g}){const a=new Set;this.o(g,a),this.n(t,!1,a),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const g=new Set;this.k(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}k(t,g){const a=[];for(const{overrides:d,source:w}of t)for(const $ in d)if(g.add($),e.$uo.test($)){const v=this.a.get($),y=v?.valuesSources??new Map;if(w)for(const I of Object.keys(d[$]))y.set(I,w);const h={...v?.value||{},...d[$]};this.a.set($,{source:w,value:h,valuesSources:y});const D=(0,R.$cj)($),k={type:"object",default:h,description:N.localize(1,null,D),$ref:e.$ro,defaultDefaultValue:h,source:A.$$f(w)?void 0:w,defaultValueSource:w};a.push(...s($)),this.d[$]=k,this.b.properties[$]=k}else{this.a.set($,{value:d[$],source:w});const v=this.d[$];v&&(this.w($,v),this.r($,v))}this.m(a)}deregisterDefaultConfigurations(t){const g=new Set;this.l(t,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}l(t,g){for(const{overrides:a,source:d}of t)for(const w in a){const $=this.a.get(w),v=A.$$f(d)?d:d?.id,y=A.$$f($?.source)?$?.source:$?.source?.id;if(v===y)if(g.add(w),this.a.delete(w),e.$uo.test(w))delete this.d[w],delete this.b.properties[w];else{const h=this.d[w];h&&(this.w(w,h),this.r(w,h))}}this.u()}deltaConfiguration(t){let g=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),g=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),g=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const g of t)this.h.add(g);this.u()}n(t,g,a){t.forEach(d=>{this.p(d,g,d.extensionInfo,d.restrictedProperties,void 0,a),this.c.push(d),this.q(d)})}o(t,g){const a=d=>{if(d.properties)for(const w in d.properties){g.add(w);const $=this.d[w];$?.policy?.name&&this.e.delete($.policy.name),delete this.d[w],this.s(w,d.properties[w])}d.allOf?.forEach(w=>a(w))};for(const d of t){a(d);const w=this.c.indexOf(d);w!==-1&&this.c.splice(w,1)}}p(t,g=!0,a,d,w=3,$){w=A.$hg(t.scope)?w:t.scope;const v=t.properties;if(v)for(const h in v){const D=v[h];if(g&&n(h,D)){delete v[h];continue}if(D.source=a,D.defaultDefaultValue=v[h].default,this.w(h,D),e.$uo.test(h)?D.scope=void 0:(D.scope=A.$hg(D.scope)?w:D.scope,D.restricted=A.$hg(D.restricted)?!!d?.includes(h):D.restricted),v[h].hasOwnProperty("included")&&!v[h].included){this.f[h]=v[h],delete v[h];continue}else this.d[h]=v[h],v[h].policy?.name&&this.e.set(v[h].policy.name,h);!v[h].deprecationMessage&&v[h].markdownDeprecationMessage&&(v[h].deprecationMessage=v[h].markdownDeprecationMessage),$.add(h)}const y=t.allOf;if(y)for(const h of y)this.p(h,g,a,d,w,$)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const g=a=>{const d=a.properties;if(d)for(const $ in d)this.r($,d[$]);a.allOf?.forEach(g)};g(t)}r(t,g){switch(e.$lo.properties[t]=g,g.scope){case 1:e.$mo.properties[t]=g;break;case 2:e.$no.properties[t]=g;break;case 6:e.$oo.properties[t]=g;break;case 3:e.$po.properties[t]=g;break;case 4:e.$qo.properties[t]=g;break;case 5:e.$qo.properties[t]=g,this.g.properties[t]=g;break}}s(t,g){switch(delete e.$lo.properties[t],g.scope){case 1:delete e.$mo.properties[t];break;case 2:delete e.$no.properties[t];break;case 6:delete e.$oo.properties[t];break;case 3:delete e.$po.properties[t];break;case 4:case 5:delete e.$qo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const g=`[${t}]`,a={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$ro};this.w(g,a),e.$lo.properties[g]=a,e.$mo.properties[g]=a,e.$no.properties[g]=a,e.$oo.properties[g]=a,e.$po.properties[g]=a,e.$qo.properties[g]=a}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=t,e.$mo.patternProperties[e.$to]=t,e.$no.patternProperties[e.$to]=t,e.$oo.patternProperties[e.$to]=t,e.$po.patternProperties[e.$to]=t,e.$qo.patternProperties[e.$to]=t,this.i.fire()}w(t,g){const a=this.a.get(t);let d=a?.value,w=a?.source;A.$fg(d)&&(d=g.defaultDefaultValue,w=void 0),A.$fg(d)&&(d=o(g.type)),g.default=d,g.defaultValueSource=w}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.$to=`^(${b})+$`,e.$uo=new RegExp(e.$to);function s(u){const t=[];if(e.$uo.test(u)){let g=f.exec(u);for(;g?.length;){const a=g[1].trim();a&&t.push(a),g=f.exec(u)}}return(0,C.$Mb)(t)}function r(u){return u.reduce((t,g)=>`${t}[${g}]`,"")}function o(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new l;m.$fo.add(e.$ko.Configuration,i);function n(u,t){return u.trim()?e.$uo.test(u)?N.localize(7,null,u):i.getConfigurationProperties()[u]!==void 0?N.localize(8,null,u):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,u,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function c(){const u=[],t=i.getConfigurationProperties();for(const g of Object.keys(t))u.push([g,t[g].scope]);return u.push(["launch",4]),u.push(["task",4]),u}}),define(Se[203],Ie([1,0,18,5,126,6,28,26,15,2,50,51,29]),function(le,e,C,O,A,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=n;function b(g){return Object.isFrozen(g)?g:p.$6n(g)}class f{static createEmptyModel(a){return new f({},[],[],void 0,a)}constructor(a,d,w,$,v){this.b=a,this.c=d,this.d=w,this.raw=$,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(d=>{if(d instanceof f)return d;const w=new s("",this.f);return w.parseRaw(d),w.configurationModel});this.g=a.reduce((d,w)=>w===d?w:d.merge(w),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,T.$aj)(this.contents,a):this.contents}inspect(a,d){const w=this;return{get value(){return b(w.rawConfiguration.getValue(a))},get override(){return d?b(w.rawConfiguration.getOverrideValue(a,d)):void 0},get merged(){return b(d?w.rawConfiguration.override(d).getValue(a):w.rawConfiguration.getValue(a))},get overrides(){const $=[];for(const{contents:v,identifiers:y,keys:h}of w.rawConfiguration.overrides){const D=new f(v,h,[],void 0,w.f).getValue(a);D!==void 0&&$.push({identifiers:y,value:D})}return $.length?b($):void 0}}}getOverrideValue(a,d){const w=this.j(d);return w?a?(0,T.$aj)(w,a):w:void 0}getKeysForOverrideIdentifier(a){const d=[];for(const w of this.overrides)w.identifiers.includes(a)&&d.push(...w.keys);return C.$Mb(d)}getAllOverrideIdentifiers(){const a=[];for(const d of this.overrides)a.push(...d.identifiers);return C.$Mb(a)}override(a){let d=this.a.get(a);return d||(d=this.h(a),this.a.set(a,d)),d}merge(...a){const d=p.$5n(this.contents),w=p.$5n(this.overrides),$=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const y of a)if(v.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(d,y.contents);for(const h of y.overrides){const[D]=w.filter(k=>C.$ub(k.identifiers,h.identifiers));D?(this.i(D.contents,h.contents),D.keys.push(...h.keys),D.keys=C.$Mb(D.keys)):w.push(p.$5n(h))}for(const h of y.keys)$.indexOf(h)===-1&&$.push(h)}return new f(d,$,w,v.every(y=>y instanceof f)?void 0:v,this.f)}h(a){const d=this.j(a);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const w={};for(const $ of C.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let v=this.contents[$];const y=d[$];y&&(typeof v=="object"&&typeof y=="object"?(v=p.$5n(v),this.i(v,y)):v=y),w[$]=v}return new f(w,this.keys,this.overrides,void 0,this.f)}i(a,d){for(const w of Object.keys(d)){if(w in a&&m.$ag(a[w])&&m.$ag(d[w])){this.i(a[w],d[w]);continue}a[w]=p.$5n(d[w])}}j(a){let d=null,w=null;const $=v=>{v&&(w?this.i(w,v):w=p.$5n(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===a?d=v.contents:v.identifiers.includes(a)&&$(v.contents);return $(d),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,d){this.k(a,d,!0)}setValue(a,d){this.k(a,d,!1)}removeValue(a){const d=this.keys.indexOf(a);d!==-1&&(this.keys.splice(d,1),(0,T.$_i)(this.contents,a),S.$uo.test(a)&&this.overrides.splice(this.overrides.findIndex(w=>C.$ub(w.identifiers,(0,S.$vo)(a))),1))}k(a,d,w){(0,T.$$i)(this.contents,a,d,$=>this.f.error($)),w=w||this.keys.indexOf(a)===-1,w&&this.keys.push(a),S.$uo.test(a)&&this.overrides.push({identifiers:(0,S.$vo)(a),keys:Object.keys(this.contents[a]),contents:(0,T.$0i)(this.contents[a],$=>this.f.error($))})}}e.$Ao=f;class s{constructor(a,d){this.f=a,this.g=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,d){if(!m.$hg(a)){const w=this.h(a);this.parseRaw(w,d)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,d){this.a=a;const{contents:w,keys:$,overrides:v,restricted:y,hasExcludedProperties:h}=this.i(a,d);this.b=new f(w,$,v,h?[a]:void 0,this.g),this.c=y||[]}h(a){let d={},w=null,$=[];const v=[],y=[];function h(k){Array.isArray($)?$.push(k):w!==null&&($[w]=k)}const D={onObjectBegin:()=>{const k={};h(k),v.push($),$=k,w=null},onObjectProperty:k=>{w=k},onObjectEnd:()=>{$=v.pop()},onArrayBegin:()=>{const k=[];h(k),v.push($),$=k,w=null},onArrayEnd:()=>{$=v.pop()},onLiteralValue:h,onError:(k,I,P)=>{y.push({error:k,offset:I,length:P})}};if(a)try{A.$Sn(a,D),d=$[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return d}i(a,d){const w=l.$fo.as(S.$ko.Configuration).getConfigurationProperties(),$=this.j(a,w,!0,d);a=$.raw;const v=(0,T.$0i)(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),y=Object.keys(a),h=this.l(a,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:v,keys:y,overrides:h,restricted:$.restricted,hasExcludedProperties:$.hasExcludedProperties}}j(a,d,w,$){let v=!1;if(!$?.scopes&&!$?.skipRestricted&&!$?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:v};const y={},h=[];for(const D in a)if(S.$uo.test(D)&&w){const k=this.j(a[D],d,!1,$);y[D]=k.raw,v=v||k.hasExcludedProperties,h.push(...k.restricted)}else{const k=d[D],I=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&h.push(D),!$.exclude?.includes(D)&&($.include?.includes(D)||(I===void 0||$.scopes===void 0||$.scopes.includes(I))&&!($.skipRestricted&&k?.restricted))?y[D]=a[D]:v=!0}return{raw:y,restricted:h,hasExcludedProperties:v}}l(a,d){const w=[];for(const $ of Object.keys(a))if(S.$uo.test($)){const v={};for(const y in a[$])v[y]=a[$][y];w.push({identifiers:(0,S.$vo)($),keys:Object.keys(v),contents:(0,T.$0i)(v,d)})}return w}}e.$Bo=s;class r extends N.$Uc{constructor(a,d,w,$,v){super(),this.c=a,this.f=d,this.g=$,this.h=v,this.b=this.B(new O.$fe),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),v),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&w.isEqual(y.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=r;class o{constructor(a,d,w,$,v,y,h,D,k,I,P,V,W){this.a=a,this.b=d,this.c=w,this.overrideIdentifiers=$,this.d=v,this.f=y,this.g=h,this.h=D,this.i=k,this.j=I,this.k=P,this.l=V,this.m=W}get value(){return b(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(a,d,w,$,v,y,h,D,k,I){this.j=a,this.l=d,this.m=w,this.n=$,this.p=v,this.q=y,this.r=h,this.s=D,this.t=k,this.u=I,this.h=null,this.i=new R.$Ac,this.v=null}getValue(a,d,w){return this.w(a,d,w).getValue(a)}updateValue(a,d,w={}){let $;w.resource?($=this.t.get(w.resource),$||($=f.createEmptyModel(this.u),this.t.set(w.resource,$))):$=this.s,d===void 0?$.removeValue(a):$.setValue(a,d),w.resource||(this.h=null)}inspect(a,d,w){const $=this.w(a,d,w),v=this.A(d.resource,w),y=d.resource?this.t.get(d.resource)||this.s:this.s,h=new Set;for(const D of $.overrides)for(const k of D.identifiers)$.getOverrideValue(a,k)!==void 0&&h.add(k);return new o(a,d,$.getValue(a),h.size?[...h]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.q:void 0,v||void 0,y)}keys(a){const d=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,d){this.r.set(a,d),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,d){const w=[];if(!d){const{added:$,updated:v,removed:y}=u(this.j,a);d=[...$,...v,...y]}for(const $ of d)for(const v of(0,S.$vo)($)){const y=this.j.getKeysForOverrideIdentifier(v),h=a.getKeysForOverrideIdentifier(v),D=[...h.filter(k=>y.indexOf(k)===-1),...y.filter(k=>h.indexOf(k)===-1),...y.filter(k=>!p.$9n(this.j.override(v).getValue(k),a.override(v).getValue(k)))];w.push([v,D])}return this.updateDefaultConfiguration(a),{keys:d,overrides:w}}compareAndUpdatePolicyConfiguration(a){const{added:d,updated:w,removed:$}=u(this.l,a),v=[...d,...w,...$];return v.length&&this.updatePolicyConfiguration(a),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:d,updated:w,removed:$,overrides:v}=u(this.applicationConfiguration,a),y=[...d,...w,...$];return y.length&&this.updateApplicationConfiguration(a),{keys:y,overrides:v}}compareAndUpdateLocalUserConfiguration(a){const{added:d,updated:w,removed:$,overrides:v}=u(this.localUserConfiguration,a),y=[...d,...w,...$];return y.length&&this.updateLocalUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateRemoteUserConfiguration(a){const{added:d,updated:w,removed:$,overrides:v}=u(this.remoteUserConfiguration,a),y=[...d,...w,...$];return y.length&&this.updateRemoteUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateWorkspaceConfiguration(a){const{added:d,updated:w,removed:$,overrides:v}=u(this.workspaceConfiguration,a),y=[...d,...w,...$];return y.length&&this.updateWorkspaceConfiguration(a),{keys:y,overrides:v}}compareAndUpdateFolderConfiguration(a,d){const w=this.folderConfigurations.get(a),{added:$,updated:v,removed:y,overrides:h}=u(w,d),D=[...$,...v,...y];return(D.length||!w)&&this.updateFolderConfiguration(a,d),{keys:D,overrides:h}}compareAndDeleteFolderConfiguration(a){const d=this.folderConfigurations.get(a);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:w,updated:$,removed:v,overrides:y}=u(d,void 0);return{keys:[...w,...$,...v],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,d,w){let $=this.x(d,w);return d.overrideIdentifier&&($=$.override(d.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&($=$.merge(this.l)),$}x({resource:a},d){let w=this.y();if(d&&a){const $=d.getFolder(a);$&&(w=this.z($.uri)||w);const v=this.t.get(a);v&&(w=w.merge(v))}return w}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let d=this.i.get(a);if(!d){const w=this.y(),$=this.r.get(a);$?(d=w.merge($),this.i.set(a,d)):d=w}return d}A(a,d){if(d&&a){const w=d.getFolder(a);if(w)return this.r.get(w.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,d)=>{const{contents:w,overrides:$,keys:v}=this.r.get(d);return a.push([d,{contents:w,overrides:$,keys:v}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(d=>a.add(d)),this.userConfiguration.keys.forEach(d=>a.add(d)),this.q.keys.forEach(d=>a.add(d)),this.r.forEach(d=>d.keys.forEach(w=>a.add(w))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.q.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.r.forEach(d=>d.getAllOverrideIdentifiers().forEach(w=>a.add(w))),[...a.values()]}D(a){const d=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(w=>d.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(w=>d.add(w)),this.q.getKeysForOverrideIdentifier(a).forEach(w=>d.add(w)),this.r.forEach(w=>w.getKeysForOverrideIdentifier(a).forEach($=>d.add($))),[...d.values()]}static parse(a,d){const w=this.E(a.defaults,d),$=this.E(a.policy,d),v=this.E(a.application,d),y=this.E(a.user,d),h=this.E(a.workspace,d),D=a.folders.reduce((k,I)=>(k.set(E.URI.revive(I[0]),this.E(I[1],d)),k),new R.$Ac);return new i(w,$,v,y,f.createEmptyModel(d),h,D,f.createEmptyModel(d),new R.$Ac,d)}static E(a,d){return new f(a.contents,a.keys,a.overrides,void 0,d)}}e.$Do=i;function n(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const a=new Set,d=new Map;for(const $ of g)$.keys.forEach(v=>a.add(v)),$.overrides.forEach(([v,y])=>{const h=(0,R.$xc)(d,v,new Set);y.forEach(D=>h.add(D))});const w=[];return d.forEach(($,v)=>w.push([v,[...$.values()]])),{keys:[...a.values()],overrides:w}}class c{constructor(a,d,w,$,v){this.change=a,this.f=d,this.g=w,this.h=$,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of a.keys)this.affectedKeys.add(y);for(const[,y]of a.overrides)for(const h of y)this.affectedKeys.add(h);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,d){const w=this.a+a,$=this.d.indexOf(w);if($<0)return!1;const v=$+w.length;if(v>=this.d.length)return!1;const y=this.d.charCodeAt(v);if(y!==this.b&&y!==this.c)return!1;if(d){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,d,this.f?.workspace):void 0,D=this.g.getValue(a,d,this.h);return!p.$9n(h,D)}return!0}}e.$Fo=c;function u(g,a){const{added:d,removed:w,updated:$}=t(a?.rawConfiguration,g?.rawConfiguration),v=[],y=g?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const D=h.filter(k=>!y.includes(k));for(const k of D)v.push([k,a.getKeysForOverrideIdentifier(k)])}if(g){const D=y.filter(k=>!h.includes(k));for(const k of D)v.push([k,g.getKeysForOverrideIdentifier(k)])}if(a&&g){for(const D of y)if(h.includes(D)){const k=t({contents:g.getOverrideValue(void 0,D)||{},keys:g.getKeysForOverrideIdentifier(D)},{contents:a.getOverrideValue(void 0,D)||{},keys:a.getKeysForOverrideIdentifier(D)});v.push([D,[...k.added,...k.removed,...k.updated]])}}return{added:d,removed:w,updated:$,overrides:v}}function t(g,a){const d=g?a?g.keys.filter(v=>a.keys.indexOf(v)===-1):[...g.keys]:[],w=a?g?a.keys.filter(v=>g.keys.indexOf(v)===-1):[...a.keys]:[],$=[];if(g&&a){for(const v of a.keys)if(g.keys.indexOf(v)!==-1){const y=(0,T.$aj)(a.contents,v),h=(0,T.$aj)(g.contents,v);p.$9n(y,h)||$.push(v)}}return{added:d,removed:w,updated:$}}}),define(Se[104],Ie([1,0,14,3]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.RemoteAuthorityResolverErrorCode=e.$Ll=e.$Kl=e.RemoteConnectionType=e.$Jl=void 0,e.$Nl=E,e.$Jl=(0,O.$yi)("remoteAuthorityResolverService");var A;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class N{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kl=N;class R{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ll=R;var p;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class m extends C.$bb{static isNotAvailable(S){return S instanceof m&&S._code===p.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof m&&S._code===p.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof m&&S._code===p.NoResolverFound}static isInvalidAuthority(S){return S instanceof m&&S._code===p.InvalidAuthority}static isHandled(S){return S instanceof m&&S.isHandled}constructor(S,l=p.Unknown,b){super(S),this._message=S,this._code=l,this._detail=b,this.isHandled=l===p.NotAvailable&&b===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Ml=m;function E(T){const S=T.indexOf("+");return S===-1?T:T.substring(0,S)}}),define(Se[58],Ie([1,0,16]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=O,e.$Km=A,e.$Lm=N,e.$Mm=R;function O(m){return m.scheme===C.Schemas.vscodeRemote?m.authority:void 0}function A(m){if(!m)return;const E=m.indexOf("+");return E<0?m:m.substr(0,E)}function N(m){const{host:E,port:T}=p(m);if(typeof T>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:T}}function R(m,E){let{host:T,port:S}=p(m);return typeof S>"u"&&(S=E),{host:T,port:S}}function p(m){const E=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const T=m.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(Se[21],Ie([1,0,13,3,58]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=N,e.$Wm=S,e.$Xm=l,e.$Ym=b,e.$Zm=f,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function N(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(R||(e.ExtensionType=R={}));var p;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class m{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,o){if(typeof r>"u"||r===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof r=="string"||typeof o=="string"){const i=typeof r=="string"?r:r.value,n=typeof o=="string"?o:o.value;return C.$zf(i,n)}return r._lower===o._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.$Tm=m;class E{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const o of r)this.add(o)}add(r){this.c.add(m.toKey(r))}delete(r){return this.c.delete(m.toKey(r))}has(r){return this.c.has(m.toKey(r))}}e.$Um=E;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(m.toKey(r))}get(r){return this.c.get(m.toKey(r))}has(r){return this.c.has(m.toKey(r))}set(r,o){this.c.set(m.toKey(r),o)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=T;function S(s){return l(s)}function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function b(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function f(s,r){if(r){const o=`onResolveRemoteAuthority:${(0,A.$Km)(r)}`;return!!s.activationEvents?.includes(o)}return!1}e.$1m=(0,O.$yi)("IBuiltinExtensionsScannerService")}),define(Se[105],Ie([1,0,14,21]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pG=e.$oG=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(R,p){this.a.set(R,p)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const p=Object.create(null);for(const m of R){const E=this.readActivationEvents(m);E.length>0&&(p[O.$Tm.toKey(m.identifier)]=E)}return p}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const p=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let m=0;m<p.length;m++)p[m]==="onUri"&&(p[m]=`onUri:${O.$Tm.toKey(R.identifier)}`);if(!R.contributes)return p;for(const m in R.contributes){const E=this.a.get(m);if(!E)continue;const T=R.contributes[m],S=Array.isArray(T)?T:[T];try{E(S,p)}catch(l){(0,C.$1)(l)}}return p}}e.$oG=A,e.$pG=new A}),define(Se[204],Ie([1,0,22,14,6,168,51,3,12,29]),function(le,e,C,O,A,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0,e.$Sp=l,e.$Tp=b,e.$Up=f,e.$Vp=s,e.$Wp=r,e.$Xp=o,e.$Qp=(0,p.$yi)("requestService");class T{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class S extends A.$Uc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,N.localize)(0,null),when:m.$kk.isEqualTo((0,m.$hk)(m.LogLevel.Trace)).serialize()})}async c(u,t,g){const a=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new T(t.headers??{}));try{const d=await g();return this.a.trace(`${a} - end`,t.type,d.res.statusCode,d.res.headers),d}catch(d){throw this.a.error(`${a} - error`,t.type,(0,O.$0)(d)),d}}}e.$Rp=S;function l(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function b(c){return c.res.statusCode===204}async function f(c){return b(c)?null:(await(0,C.$Te)(c.stream)).toString()}async function s(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);return f(c)}async function r(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);if(b(c))return null;const t=(await(0,C.$Te)(c.stream)).toString();try{return JSON.parse(t)}catch(g){throw g.message+=`:
`+t,g}}function o(c){n(c)}let i;function n(c){const u=E.$fo.as(R.$ko.Configuration),t=i;i={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[i],remove:t?[t]:[]})}n(1)}),define(Se[205],Ie([1,0,23,75,33]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=R,e.$hp=p;function N(m){if(C.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function R(m,E,T,S,l,b,f,s,r){const o=Object.create(null);o["common.machineId"]=b,o["common.sqmId"]=f,o.sessionID=(0,A.$Ug)()+Date.now(),o.commitHash=S,o.version=l,o["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$h)(C.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=T,o["common.product"]=r||"desktop",s&&(o["common.msftInternal"]=s);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),C.$l&&(o["common.snap"]="true");const c=N(E);return c&&(o["common.platformDetail"]=c),o}function p(m){const E=O.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return m.some(S=>T===S)}}),define(Se[206],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,C.$yi)("telemetryService"),e.$5l=(0,C.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var O;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var A;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(Se[59],Ie([1,0,26,15,58,205,206]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=void 0,e.$pp=T,e.$qp=S,e.$rp=l,e.$sp=b,e.$tp=s,e.$up=o,e.$vp=i,e.$wp=u;class p{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$ip=p;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$jp=m,e.$kp=new m;class E{async publicLog(g,a,d){}async publicLogError(g,a,d){}}e.$lp=E,e.$mp="telemetry",e.$np="extensionTelemetryLog",e.$op={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!t.enableTelemetry)}function S(t,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function l(t){const g=t.getValue(R.$_l),a=t.getValue(R.$am);if(t.getValue(R.$bm)===!1||a===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function b(t){const g={},a={},d={};r(t,d);for(let w in d){w=w.length>150?w.substr(w.length-149):w;const $=d[w];typeof $=="number"?a[w]=$:typeof $=="boolean"?a[w]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${$.length}`),g[w]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(g[w]=$)}return{properties:g,measurements:a}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(t){if(!t)return"none";const g=(0,A.$Km)(t);return f.has(g)?g:"other"}function r(t,g,a=0,d){if(t)for(const w of Object.getOwnPropertyNames(t)){const $=t[w],v=d?d+w:w;Array.isArray($)?g[v]=(0,C.$0n)($):$ instanceof Date?g[v]=$.toISOString():(0,O.$ag)($)?a<2?r($,g,a+1,v+"."):g[v]=(0,C.$0n)($):g[v]=$}}function o(t,g){const a=t.msftInternalDomains||[],d=g.getValue("telemetry.internalTesting");return(0,N.$hp)(a)||d}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,g){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const d=[];for(const y of g)for(;;){const h=y.exec(t);if(!h)break;d.push([h.index,y.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(a="";;){const y=$.exec(t);if(!y)break;const h=d.some(([D,k])=>y.index<k&&D<$.lastIndex);!w.test(y[0])&&!h&&(a+=t.substring(v,y.index)+"<REDACTED: user-file-path>",v=$.lastIndex)}return v<t.length&&(a+=t.substr(v)),a}function c(t){if(!t)return t;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of g)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function u(t,g){return(0,C.$7n)(t,a=>{if(a instanceof p||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let d=a.replaceAll("%20"," ");d=n(d,g);for(const w of g)d=d.replace(w,"");return d=c(d),d}})}}),define(Se[207],Ie([1,0,13,100,21,23,2,14,75,59]),function(le,e,C,O,A,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$yp=void 0,e.$xp=T,e.$zp=f,e.$Ap=s,e.$Bp=r,e.$Cp=o,e.$Dp=i,e.$Ep=n,e.$Fp=c,e.$Hp=u,e.$Ip=g;function T(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,C.$uf)(a.id,d.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const w=d.manifest?d.manifest.version:d.version,$=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,w,$)}static parse(d){const w=S.exec(d);return w&&w[1]&&w[2]?new l({id:w[1]},w[2],w[4]||void 0):null}constructor(d,w,$="undefined"){this.version=w,this.targetPlatform=$,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?T(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$yp=l;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(a){const d=b.exec(a);return d&&d[1]?[r(d[1]),d[2]]:[r(a),void 0]}function s(a,d){return`${a}.${d}`}function r(a){return a.toLowerCase()}function o(a,d){return r(s(a??A.$Pm,d))}function i(a,d){const w=[],$=v=>{for(const y of w)if(y.some(h=>T(d(h),d(v))))return y;return null};for(const v of a){const y=$(v);y?y.push(v):w.push([v])}return w}function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new E.$ip(a.identifier.id),name:new E.$ip(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Gp=new A.$Tm("pprice.better-merge");function u(a,d){const w=[],$=d.manifest.extensionDependencies?.slice(0)??[];for(;$.length;){const v=$.shift();if(v&&w.every(y=>!T(y.identifier,{id:v}))){const y=a.filter(h=>T(h.identifier,{id:v}));y.length===1&&(w.push(y[0]),$.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function t(a,d){if(!N.$k)return!1;let w;try{w=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){d.debug("Error while getting the os-release file.",(0,p.$0)(v))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(a,d){const w=await t(a,d),$=(0,O.$5o)(w?"alpine":N.$u,m.$ec);return d.debug("ComputeTargetPlatform:",$),$}}),define(Se[208],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=C,e.$ps=O,e.$qs=A,e.$rs=N,e.$ss=R,e.$ts=p;function C(m){return[...m.entries()]}function O(m){return m?[...m.entries()]:[]}function A(m){return new Map(m)}function N(m){return new Map(m??[])}function R(m){return Array.from(m.entries()).map(E=>[E[0],C(E[1].map),O(E[1].descriptionMap)])}function p(m){return new Map(m.map(E=>[E[0],{map:A(E[1]),descriptionMap:N(E[2])}]))}}),define(Se[209],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9vb=void 0;class C{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,N,R=5){const p=N(m=>{const E=typeof m=="string"?m:m.data;let T=this.a.get(A);if(T){T.data.push(E);return}const S=setTimeout(()=>this.flushBuffer(A),R);T={data:[E],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(A),p.dispose()}},this.a.set(A,T)});return p}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const N=this.a.get(A);N&&(this.a.delete(A),this.b(A,N.data.join("")))}}e.$9vb=C}),define(Se[210],Ie([1,0,11,92,312,36,5,15,2,169,74,29]),function(le,e,C,O,A,N,R,p,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$px=e.$ox=e.$nx=e.$mx=e.$lx=e.$kx=e.IconFontDefinition=e.IconContribution=e.$hx=void 0,e.$ix=r,e.$jx=o,e.$hx={IconContribution:"base.contributions.icons"};var l;(function(u){function t(g,a){let d=g.defaults;for(;N.ThemeIcon.isThemeIcon(d);){const w=s.getIcon(d.id);if(!w)return;d=w.defaults}return d}u.getDefinition=t})(l||(e.IconContribution=l={}));var b;(function(u){function t(a){return{weight:a.weight,style:a.style,src:a.src.map(d=>({format:d.format,location:d.location.toString()}))}}u.toJSONObject=t;function g(a){const d=w=>(0,p.$$f)(w)?w:void 0;if(a&&Array.isArray(a.src)&&a.src.every(w=>(0,p.$$f)(w.format)&&(0,p.$$f)(w.location)))return{weight:d(a.weight),style:d(a.style),src:a.src.map(w=>({format:w.format,location:m.URI.parse(w.location)}))}}u.fromJSONObject=g})(b||(e.IconFontDefinition=b={}));class f{constructor(){this.a=new R.$fe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,g,a,d){const w=this.b[t];if(w){if(a&&!w.description){w.description=a,this.d.properties[t].markdownDescription=`${a} $(${t})`;const y=this.e.enum.indexOf(t);y!==-1&&(this.e.enumDescriptions[y]=a),this.a.fire()}return w}const $={id:t,description:a,defaults:g,deprecationMessage:d};this.b[t]=$;const v={$ref:"#/definitions/icons"};return d&&(v.deprecationMessage=d),a&&(v.markdownDescription=`${a}: $(${t})`),this.d.properties[t]=v,this.e.enum.push(t),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const g=this.e.enum.indexOf(t);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,g){const a=this.f[t];return a||(this.f[t]=g,this.a.fire(),g)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(w,$)=>w.id.localeCompare($.id),g=w=>{for(;N.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(w=>this.b[w]);for(const w of d.filter($=>!!$.description).sort(t))a.push(`|<i class="${g(w)}"></i>|${w.id}|${N.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const w of d.filter($=>!N.ThemeIcon.isThemeIcon($.defaults)).sort(t))a.push(`|<i class="${g(w)}"></i>|${w.id}|`);return a.join(`
`)}}const s=new f;S.$fo.add(e.$hx.IconContribution,s);function r(u,t,g,a){return s.registerIcon(u,t,g,a)}function o(){return s}function i(){const u=(0,A.$Tj)();for(const t in u){const g="\\"+u[t].toString(16);s.registerIcon(t,{fontCharacter:g})}}i(),e.$kx="vscode://schemas/icons";const n=S.$fo.as(T.$go.JSONContribution);n.registerSchema(e.$kx,s.getIconSchema());const c=new C.$Kh(()=>n.notifySchemaChanged(e.$kx),200);s.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$lx=r("widget-close",O.$Xj.close,(0,E.localize)(2,null)),e.$mx=r("goto-previous-location",O.$Xj.arrowUp,(0,E.localize)(3,null)),e.$nx=r("goto-next-location",O.$Xj.arrowDown,(0,E.localize)(4,null)),e.$ox=N.ThemeIcon.modify(O.$Xj.sync,"spin"),e.$px=N.ThemeIcon.modify(O.$Xj.loading,"spin")}),define(Se[211],Ie([1,0,5,2,50,3,12]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=e.$vw=e.$sw=e.$qw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$mw=e.$lw=void 0,e.$nw=E,e.$ow=S,e.$pw=l,e.$rw=b,e.$tw=f,e.$uw=s,e.$lw=(0,N.$yi)("tunnelService"),e.$mw=(0,N.$yi)("sharedTunnelsService");var p;(function(i){i.Http="http",i.Https="https"})(p||(e.TunnelProtocol=p={}));var m;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(i){return!!i.forwardPort}var T;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function S(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function l(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const c of n){const u=c.split("=")[1];if(/^https?:/.exec(u)){const t=S(O.URI.parse(u));if(t)return t}}}e.$qw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(i){return e.$qw.indexOf(i)>=0}e.$sw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(i){return e.$sw.indexOf(i)>=0}function s(i,n,c,u){if(c===1)return!1;if(c===2&&f(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class r{constructor(n,c,u){this.remoteAddress=n,this.localAddress=c,this.b=u,this.a=new C.$fe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$vw=r;let o=class{constructor(n,c){this.k=n,this.l=c,this.a=new C.$fe,this.onTunnelOpened=this.a.event,this.b=new C.$fe,this.onTunnelClosed=this.b.event,this.c=new C.$fe,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],c=Array.from(this.e.values());for(const u of c){const t=Array.from(u.values());for(const g of t){const a=await g.value;a&&typeof a!="string"&&n.push(a)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:c}of n.values())await c.then(u=>typeof u!="string"?u?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,c,u,t,g){this.q(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:u,privacy:t,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(f(n)||b(n))&&(n=e.$qw[0]);const u=this.s(n,c);if(u)return++u.refcount,u.value}openTunnel(n,c,u,t,g,a=!1,d,w){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${u} on local port ${g}.`);const $=this.f??n;if(!$)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(u)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.t($,c,u,t,g,a,d,w);return v?v.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,u),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,u);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==u)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&y.privacy!==d&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(h),h}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this.e.get(n.tunnelRemoteHost);if(c){const u=c.get(n.tunnelRemotePort);u&&(u.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,u))}}}}async p(n,c,u){if(u.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const t=u.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(c),t}}async closeTunnel(n,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const u=this.e.get(n);if(u&&u.has(c)){const t=u.get(c);t.refcount=0,await this.p(n,c,t)}}q(n,c,u){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(c,{refcount:1,value:u})}async r(n,c){const u=this.e.get(n);if(u){const t=u.get(c),g=t?await t.value:void 0;(!g||typeof g=="string")&&u.delete(c),u.size===0&&this.e.delete(n)}}s(n,c){const u=[n];b(n)?(u.push(...e.$qw),u.push(...e.$sw)):f(n)&&u.push(...e.$sw);const t=u.map(g=>this.e.get(g));for(const g of t){const a=g?.get(c);if(a)return a}}canTunnel(n){return!!S(n)}u(n,c,u,t,g,a,d){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${u} on local port ${t}.`);const w=u;this.j.add(w);const $=t===void 0?u:t,v={elevationRequired:g?this.isPortPrivileged($):!1},y={remoteAddress:{host:c,port:u},localAddressPort:t,privacy:a,public:a?a!==m.Private:void 0,protocol:d},h=n.forwardPort(y,v);return h?(this.q(c,u,h),h.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(w)})):this.j.delete(w),h}};e.$ww=o,e.$ww=o=Je([We(0,R.$5j),We(1,A.$5i)],o)}),define(Se[212],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,C.$yi)("IUriIdentityService")}),define(Se[213],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$xw=void 0,e.$xw=(0,C.$yi)("editSessionIdentityService");var O;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Se[214],Ie([1,0,16]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=O,e.$RL=A,e.$SL=N,e.$TL=R,e.$UL=p;function O(m){return m.scheme!==C.Schemas.file&&m.scheme!==C.Schemas.vscodeRemote}function A(m){if(m.folders.length)return m.folders.every(E=>O(E.uri))?m.folders[0].uri:void 0;if(m.configuration&&O(m.configuration))return m.configuration}function N(m){return A(m)?.scheme}function R(m){return A(m)?.authority}function p(m){return A(m)!==void 0}}),define(Se[45],Ie([1,0,171,19,54,24,2,3,16]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=E,e.$Ji=T,e.$Mi=S,e.$Ni=l,e.$Oi=b,e.$Pi=s,e.$Qi=r,e.$Ti=n,e.$Yi=c,e.$Zi=u,e.$2i=t,e.$3i=g,e.$4i=a,e.$Hi=(0,p.$yi)("contextService");function E(d){const w=d;return typeof w?.id=="string"&&R.URI.isUri(w.uri)}function T(d){return typeof d?.id=="string"&&!E(d)&&!l(d)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function S(d,w){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,O.$nc)(d)}:w?e.$Ki:e.$Li;const $=d;return $.configuration?{id:$.id,configPath:$.configuration}:$.folders.length===1?{id:$.id,uri:$.folders[0].uri}:{id:$.id}}function l(d){const w=d;return typeof w?.id=="string"&&R.URI.isUri(w.configPath)}function b(d){const w=d;if(w?.uri)return{id:w.id,uri:R.URI.revive(w.uri)};const $=d;if($?.configPath)return{id:$.id,configPath:R.URI.revive($.configPath)};if(d?.id)return{id:d.id}}var f;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function s(d){const w=d;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function r(d){const w=d;return!!(w&&typeof w=="object"&&R.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class o{constructor(w,$,v,y,h){this.h=w,this.j=v,this.k=y,this.l=h,this.c=A.$Ei.forUris(this.l,()=>!0),this.folders=$}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=A.$Ei.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=o;class i{constructor(w,$){this.raw=$,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,N.$_g)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=i;function n(d){return new i({uri:d,index:0,name:(0,N.$8g)(d)},{uri:d.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,C.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function c(d,w){return N.$3g.isEqualOrParent(d,w.untitledWorkspacesHome)}function u(d){let w;return R.URI.isUri(d)?w=d:w=d.configuration,w?.scheme===m.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(d){return d.id===e.$1i}function g(d,w){return!c(d,w)&&!u(d)}function a(d){return(typeof d=="string"?(0,O.$oc)(d):(0,N.$0g)(d))===e.$Vi}}),define(Se[215],Ie([1,0,73,5,6,24,2,170,99,38,3,12,45,28,212,11,33,13,15]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=c,e.$Fl=u,e.$Gl=t;var n;(function(d){d.Settings="settings",d.Keybindings="keybindings",d.Snippets="snippets",d.Tasks="tasks",d.Extensions="extensions",d.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function c(d){const w=d;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&typeof w.isDefault=="boolean"&&typeof w.name=="string"&&R.URI.isUri(w.location)&&R.URI.isUri(w.globalStorageHome)&&R.URI.isUri(w.settingsResource)&&R.URI.isUri(w.keybindingsResource)&&R.URI.isUri(w.tasksResource)&&R.URI.isUri(w.snippetsHome)&&R.URI.isUri(w.extensionsResource))}e.$El=(0,T.$yi)("IUserDataProfilesService");function u(d,w){return{id:d.id,isDefault:d.isDefault,name:d.name,shortName:d.shortName,icon:d.icon,location:R.URI.revive(d.location).with({scheme:w}),globalStorageHome:R.URI.revive(d.globalStorageHome).with({scheme:w}),settingsResource:R.URI.revive(d.settingsResource).with({scheme:w}),keybindingsResource:R.URI.revive(d.keybindingsResource).with({scheme:w}),tasksResource:R.URI.revive(d.tasksResource).with({scheme:w}),snippetsHome:R.URI.revive(d.snippetsHome).with({scheme:w}),extensionsResource:R.URI.revive(d.extensionsResource).with({scheme:w}),cacheHome:R.URI.revive(d.cacheHome).with({scheme:w}),useDefaultFlags:d.useDefaultFlags,isTransient:d.isTransient}}function t(d,w,$,v,y,h){return{id:d,name:w,location:$,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:h&&y?.useDefaultFlags?.globalState?h.globalStorageHome:(0,N.$_g)($,"globalStorage"),settingsResource:h&&y?.useDefaultFlags?.settings?h.settingsResource:(0,N.$_g)($,"settings.json"),keybindingsResource:h&&y?.useDefaultFlags?.keybindings?h.keybindingsResource:(0,N.$_g)($,"keybindings.json"),tasksResource:h&&y?.useDefaultFlags?.tasks?h.tasksResource:(0,N.$_g)($,"tasks.json"),snippetsHome:h&&y?.useDefaultFlags?.snippets?h.snippetsHome:(0,N.$_g)($,"snippets"),extensionsResource:h&&y?.useDefaultFlags?.extensions?h.extensionsResource:(0,N.$_g)($,"extensions.json"),cacheHome:(0,N.$_g)(v,d),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let g=class extends A.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(w,$,v,y){super(),this.t=w,this.u=$,this.w=v,this.y=y,this.f=!0,this.h=this.B(new O.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new b.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(w){this.f!==w&&(this.z=void 0,this.f=w)}isEnabled(){return this.f}get C(){if(!this.z){const w=this.D(),$=[w];if(this.f)try{for(const h of this.O()){if(!h.name||!(0,i.$$f)(h.name)||!h.location){this.y.warn("Skipping the invalid stored profile",h.location||h.name);continue}$.push(t((0,N.$9g)(h.location),h.name,h.location,this.g,{shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags},w))}}catch(h){this.y.error(h)}const v=new b.$Ac,y=new Map;if($.length)try{const h=this.Q();if(h.workspaces)for(const[D,k]of Object.entries(h.workspaces)){const I=R.URI.parse(D),P=$.find(V=>V.id===k);P&&v.set(I,P)}if(h.emptyWindows)for(const[D,k]of Object.entries(h.emptyWindows)){const I=$.find(P=>P.id===k);I&&y.set(D,I)}}catch(h){this.y.error(h)}this.z={profiles:$,workspaces:v,emptyWindows:y}}return this.z}D(){const w=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...w,extensionsResource:this.S()??w.extensionsResource,isDefault:!0}}async createTransientProfile(w){const $="Temp",v=new RegExp(`${(0,o.$bf)($)}\\s(\\d+)`);let y=0;for(const D of this.profiles){const k=v.exec(D.name),I=k?parseInt(k[1]):0;y=I>y?I:y}const h=`${$} ${y+1}`;return this.createProfile((0,C.$mj)((0,r.$Ug)()).toString(16),h,{transient:!0},w)}async createNamedProfile(w,$,v){return this.createProfile((0,C.$mj)((0,r.$Ug)()).toString(16),w,$,v)}async createProfile(w,$,v,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.F(w,$,v);return y&&await this.setProfileForWorkspace(y,h),h}async F(w,$,v){if(!(0,i.$$f)($)||!$)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get($);return y||(y=(async()=>{try{if(this.profiles.find(I=>I.name===$||I.id===w))throw new Error(`Profile with ${$} name already exists`);const D=t(w,$,(0,N.$_g)(this.profilesHome,w),this.g,v,this.defaultProfile);await this.u.createFolder(D.location);const k=[];return this.j.fire({profile:D,join(I){k.push(I)}}),await s.Promises.settled(k),this.I([D],[],[]),D}finally{this.r.delete($)}})(),this.r.set($,y)),y}async updateProfile(w,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(y=>y.id===w.id);if(!v)throw new Error(`Profile '${w.name}' does not exist`);return v=t(v.id,$.name??v.name,v.location,this.g,{shortName:$.shortName??v.shortName,icon:$.icon===null?void 0:$.icon??v.icon,transient:$.transient??v.isTransient,useDefaultFlags:$.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(w.isDefault)throw new Error("Cannot remove default profile");const $=this.profiles.find(y=>y.id===w.id);if(!$)throw new Error(`Profile '${w.name}' does not exist`);const v=[];this.m.fire({profile:$,join(y){v.push(y)}});try{await Promise.allSettled(v)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])$.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])$.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[$],[]);try{await this.u.del($.cacheHome,{recursive:!0})}catch(y){(0,E.$jl)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(w,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(y=>y.id===$.id);if(!v)throw new Error(`Profile '${$.name}' does not exist`);this.L(w,v)}unsetWorkspace(w,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(w,void 0,$)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const w=await this.u.resolve(this.profilesHome);await Promise.all((w.children||[]).filter($=>$.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,$.resource))).map($=>this.u.del($.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const w=this.s.profiles.filter($=>!this.H($));await Promise.allSettled(w.map($=>this.removeProfile($)))}getProfileForWorkspace(w){const $=this.G(w);return R.URI.isUri($)?this.s.workspaces.get($)??this.C.workspaces.get($):this.s.emptyWindows.get($)??this.C.emptyWindows.get($)}G(w){return(0,l.$Ii)(w)?w.uri:(0,l.$Ni)(w)?w.configPath:w.id}H(w){return!!([...this.s.emptyWindows.values()].some($=>this.w.extUri.isEqual($.location,w.location))||[...this.s.workspaces.values()].some($=>this.w.extUri.isEqual($.location,w.location))||[...this.C.emptyWindows.values()].some($=>this.w.extUri.isEqual($.location,w.location))||[...this.C.workspaces.values()].some($=>this.w.extUri.isEqual($.location,w.location)))}I(w,$,v){const y=[...this.profiles,...w],h=[];this.s.profiles=[];for(let D of y)D.isDefault||$.some(k=>D.id===k.id)||(D=v.find(k=>D.id===k.id)??D,D.isTransient?this.s.profiles.push(D):h.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags}));this.P(h),this.z=void 0,this.J(w,$,v)}J(w,$,v){this.h.fire({added:w,removed:$,updated:v,all:this.profiles})}L(w,$,v){v=$?.isTransient?!0:v,v||this.L(w,void 0,!0);const y=this.G(w),h=v?this.s:this.C;R.URI.isUri(y)?(h.workspaces.delete(y),$&&h.workspaces.set(y,$)):(h.emptyWindows.delete(y),$&&h.emptyWindows.set(y,$)),v||this.M()}M(){const w={};for(const[v,y]of this.C.workspaces.entries())w[v.toString()]=y.id;const $={};for(const[v,y]of this.C.emptyWindows.entries())$[v.toString()]=y.id;this.R({workspaces:w,emptyWindows:$}),this.z=void 0}N(w){const $={},v=this.D();if(w.workspaces)for(const[h,D]of Object.entries(w.workspaces)){const k=R.URI.parse(D);$[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}const y={};if(w.emptyWindows)for(const[h,D]of Object.entries(w.emptyWindows)){const k=R.URI.parse(D);y[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}return{workspaces:$,emptyWindows:y}}O(){return[]}P(w){throw new Error("not implemented")}Q(){return{}}R(w){throw new Error("not implemented")}S(){}};e.$Hl=g,e.$Hl=g=Je([We(0,m.$Fi),We(1,E.$5k),We(2,f.$Cl),We(3,S.$5j)],g);class a extends g{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(w){this.a=w}Q(){return this.X}R(w){this.X=w}}e.$Il=a}),define(Se[216],Ie([1,0,11,5,6,60,15,151,3,215]),function(le,e,C,O,A,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$6p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$4p=e.$3p=e.$2p=void 0,e.$5p=b,e.$7p=s,e.$9p=o,e.$2p="__$__isNewStorageMarker",e.$3p="__$__targetStorageMarker",e.$4p=(0,m.$yi)("storageService");var T;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(T||(e.WillSaveStateReason=T={}));var S;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var l;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(l||(e.StorageTarget=l={}));function b(i){const n=i.get(e.$3p);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class f extends A.$Uc{static{this.a=60*1e3}constructor(n={flushInterval:f.a}){super(),this.m=n,this.b=this.B(new O.$ie),this.c=this.B(new O.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new C.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,c,u){return O.Event.filter(this.b.event,t=>t.scope===n&&(c===void 0||t.key===c),u)}n(){this.j.value=(0,C.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,c){const{key:u,external:t}=c;if(u===e.$3p){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:u,target:this.J(n)[u],external:t})}w(n){this.f.fire({reason:n})}get(n,c,u){return this.P(c)?.get(n,u)}getBoolean(n,c,u){return this.P(c)?.getBoolean(n,u)}getNumber(n,c,u){return this.P(c)?.getNumber(n,u)}getObject(n,c,u){return this.P(c)?.getObject(n,u)}storeAll(n,c){this.y(()=>{for(const u of n)this.store(u.key,u.value,u.scope,u.target,c)})}store(n,c,u,t,g=!1){if((0,R.$hg)(c)){this.remove(n,u,g);return}this.y(()=>{this.z(n,u,t),this.P(u)?.set(n,c,g)})}remove(n,c,u=!1){this.y(()=>{this.z(n,c,void 0),this.P(c)?.delete(n,u)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,c){const u=[],t=this.J(n);for(const g of Object.keys(t))t[g]===c&&u.push(g);return u}z(n,c,u,t=!1){const g=this.J(c);typeof u=="number"?g[n]!==u&&(g[n]=u,this.P(c)?.set(e.$3p,JSON.stringify(g),t)):typeof g[n]=="number"&&(delete g[n],this.P(c)?.set(e.$3p,JSON.stringify(g),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const c=this.P(n);return c?b(c):Object.create(null)}isNew(n){return this.getBoolean(e.$2p,n)===!0}async flush(n=T.NONE){this.f.fire({reason:n});const c=this.P(-1),u=this.P(0),t=this.P(1);switch(n){case T.NONE:await C.Promises.settled([c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await C.Promises.settled([c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return o(n,c,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,c){return this.w(T.NONE),(0,E.$Dl)(n)?this.R(n,c):this.S(n,c)}M(n,c){return!(n.id===c.id||s(c)&&s(n))}N(n,c,u){this.y(()=>{const t=new Set;for(const[g,a]of n)t.add(g),c.get(g)!==a&&this.u(u,{key:g,external:!0});for(const[g]of c.items)t.has(g)||this.u(u,{key:g,external:!0})})}}e.$6p=f;function s(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class r extends f{constructor(){super(),this.U=this.B(new p.$Zp(new p.$1p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$Zp(new p.$1p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$Zp(new p.$1p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$8p=r;async function o(i,n,c,u,t,g){const a=I=>{try{return JSON.parse(I)}catch{return I}},d=new Map,w=new Map;i.forEach((I,P)=>{d.set(P,I),w.set(P,a(I))});const $=new Map,v=new Map;n.forEach((I,P)=>{$.set(P,I),v.set(P,a(I))});const y=new Map,h=new Map;c.forEach((I,P)=>{y.set(P,I),h.set(P,a(I))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const D=[];if(d.forEach((I,P)=>{D.push({key:P,value:I})}),console.table(D),console.groupEnd(),console.log(w),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const I=[];$.forEach((P,V)=>{I.push({key:V,value:P})}),console.table(I),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${g})`);const k=[];y.forEach((I,P)=>{k.push({key:P,value:I})}),console.table(k),console.groupEnd(),console.log(h)}}),define(Se[76],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rlc=void 0;class C{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const N=this.c++;return this.b.set(N,A),this.e(),N}get(A,N){return this.b.has(A)?this.b.get(A)[N]:void 0}delete(A){this.b.delete(A),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Rlc=C}),define(Se[46],Ie([1,0,16,24,3]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=e.$Wlc=void 0;class N{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new O.$1g(p=>{const m=this.b.get(p.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(p,m){m===null?this.b.delete(p.scheme):this.b.set(p.scheme,m)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Wlc=N,e.$Xlc=(0,A.$yi)("IExtHostFileSystemInfo")}),define(Se[27],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=void 0,e.$2O=(0,C.$yi)("IExtHostInitDataService")}),define(Se[217],Ie([1,0,176,12,201,27]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=void 0;let R=class extends A.$_P{constructor(m,E,T){const S=T.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",l=T.remote.isRemote?(0,C.localize)(0,null):m?(0,C.localize)(1,null):(0,C.localize)(2,null);super(E.createLogger(S,{name:l}))}};e.$4nc=R,e.$4nc=R=Je([We(1,O.$6j),We(2,N.$2O)],R)}),define(Se[218],Ie([1,0,11]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=e.$Cmc=void 0;class O{constructor(R,p,m){this.h=new Map,this.a=R,this.b=p,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new C.$Kh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of E.values())T.complete()}catch(T){for(const S of E.values())S.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,p){let m=this.f[R];return typeof m>"u"&&(m=p),m}update(R,p){this.f[R]=p;const m=this.h.get(R);if(m!==void 0)return m.p;const E=new C.$Vh;return this.h.set(R,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Cmc=O;class A extends O{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,p){super(R.identifier.value,!0,p),this.j=R}}e.$Dmc=A}),define(Se[219],Ie([1,0,5,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=void 0;class A{constructor(R){this.c=R,this.a=new C.$fe,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$fe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,p,m,E){const S=this.c.getNotebookDocument(O.URI.revive(R)).acceptModelChanged(p.value,m,E);this.b.fire(S)}$acceptDirtyStateChanged(R,p){this.c.getNotebookDocument(O.URI.revive(R)).acceptDirty(p)}$acceptModelSaved(R){const p=this.c.getNotebookDocument(O.URI.revive(R));this.a.fire(p.apiNotebook)}}e.$rnc=A}),define(Se[17],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MO=e.$LO=void 0,e.$LO=(0,C.$yi)("IExtHostRpcService");class O{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$MO=O}),define(Se[220],Ie([1,0,21,5]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;class A{#e;constructor(R,p){this.b=new O.$fe,this.onDidChange=this.b.event,this.a=C.$Tm.toKey(R.identifier),this.#e=p,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(R){return this.#e.get(this.a,R)}store(R,p){return this.#e.store(this.a,R,p)}delete(R){return this.#e.delete(this.a,R)}}e.$Mmc=A}),define(Se[61],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0,e.$amc=(0,C.$yi)("IURITransformerService");class O{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$bmc=O}),define(Se[221],Ie([1,0,22]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8rb=A,e.$9rb=R;class O{constructor(){this.buffers=[]}add(m){let E=this.buffers.indexOf(m);return E<0&&(E=this.buffers.length,this.buffers.push(m)),E}}function A(p,m){if(m.serializeBuffersForPostMessage){const E=new O,S=JSON.stringify(p,(b,f)=>{if(f instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(f)};if(ArrayBuffer.isView(f)){const s=N(f);if(s)return{$$vscode_array_buffer_reference$$:!0,index:E.add(f.buffer),view:{type:s,byteLength:f.byteLength,byteOffset:f.byteOffset}}}return f}),l=E.buffers.map(b=>{const f=new Uint8Array(b);return C.$He.wrap(f)});return{message:S,buffers:l}}else return{message:JSON.stringify(p),buffers:[]}}function N(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(p,m){const E=m.map(l=>{const b=new ArrayBuffer(l.byteLength);return new Uint8Array(b).set(l.buffer),b}),T=m.length?(l,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const f=b,{index:s}=f,r=E[s];if(f.view)switch(f.view.type){case 1:return new Int8Array(r,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return b}:void 0;return{message:JSON.parse(p,T),arrayBuffers:E}}}),define(Se[106],Ie([1,0,185,15,2,6,3,29,38,16,44,145,32]),function(le,e,C,O,A,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$UF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$LF=e.EditorInputCapabilities=e.$KF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=void 0,e.$BF=s,e.$CF=r,e.$DF=o,e.$EF=i,e.$FF=n,e.$GF=c,e.$HF=u,e.$IF=t,e.$JF=g,e.$MF=y,e.$NF=D,e.$OF=k,e.$PF=I,e.$QF=P,e.$RF=V,e.$SF=W,e.$TF=de,e.$VF=me,e.$WF=Ce,e.$XF=se,e.$YF=Oe,e.$wF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$xF={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$yF="workbench.editor.sidebysideEditor",e.$zF="workbench.editors.textDiffEditor",e.$AF="workbench.editors.binaryResourceDiffEditor";var b;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var f;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function s(ne){const U=ne;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function r(ne){const U=ne;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function o(ne,U,x){for(const ve of x.visibleEditorPanes)if(ve.group.id===U&&ne.matches(ve.input))return ve.getViewState()}function i(ne){if(y(ne))return!1;const U=ne;return A.URI.isUri(U?.resource)}function n(ne){if(y(ne))return!1;const U=ne;return U?.original!==void 0&&U.modified!==void 0}function c(ne){if(y(ne))return!1;const U=ne;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function u(ne){if(y(ne)||n(ne))return!1;const U=ne;return U?.primary!==void 0&&U.secondary!==void 0}function t(ne){if(y(ne))return!1;const U=ne;return U?U.resource===void 0||U.resource.scheme===E.Schemas.untitled||U.forceUntitled===!0:!1}function g(ne){if(y(ne))return!1;const U=ne;return A.URI.isUri(U?.base?.resource)&&A.URI.isUri(U?.input1?.resource)&&A.URI.isUri(U?.input2?.resource)&&A.URI.isUri(U?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var d;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class w{constructor(){this.a=new Map}registerSource(U,x){let ve=this.a.get(U);return ve||(ve={source:U,label:x},this.a.set(U,ve)),ve.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$KF=new w;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})($||(e.EditorInputCapabilities=$={}));class v extends N.$Uc{}e.$LF=v;function y(ne){return ne instanceof v}function h(ne){const U=ne;return A.URI.isUri(U?.preferredResource)}function D(ne){const U=ne;return y(U?.primary)&&y(U?.secondary)}function k(ne){const U=ne;return y(U?.modified)&&y(U?.original)}function I(ne,U,x,ve,Fe){return Oe(ve,[(0,S.$ij)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const ke={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(U,ke)}}),(0,S.$ij)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>Fe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function P(ne){return y(ne?.editor)}function V(ne){const U=ne;return P(ne)&&U?.group!==void 0}function W(ne){const U=ne;return typeof U?.groupId=="number"&&y(U.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var M;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var z;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class G{getOriginalUri(U,x){if(!U)return;if(g(U))return e.$UF.getOriginalUri(U.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:ke}=this.a(U);if(Fe&&ke){if(x?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===z.PRIMARY?Fe:ke}}if(n(U)||c(U)||u(U)||g(U))return;const ve=h(U)?U.preferredResource:U.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}a(U){return D(U)||u(U)?{primary:U.primary,secondary:U.secondary}:k(U)||n(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,x){if(!U)return;if(g(U))return e.$UF.getCanonicalUri(U.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:ke}=this.a(U);if(Fe&&ke){if(x?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===z.PRIMARY?Fe:ke}}if(n(U)||c(U)||u(U)||g(U))return;const ve=U.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}b(U,x){if(Array.isArray(x)){if(x.some(ve=>U.scheme===ve))return U}else if(x===U.scheme)return U}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function de(ne,U,x,ve){if(!ne.isSticky(U))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$UF=new G;var ye;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ye||(e.CloseDirection=ye={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start(U){const x=this.a=U.get(R.$xi);for(const[ve,Fe]of this.c)this.e(ve,Fe,x);this.c.clear()}e(U,x,ve){const Fe=ve.createInstance(x);this.d.set(U,Fe)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,O.$jg)(this.b)}registerEditorSerializer(U,x){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,x,this.a):this.c.set(U,x),(0,N.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}p.$fo.add(e.$wF.EditorFactory,new Ee);async function me(ne,U,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async ve=>{const Fe=A.URI.revive(ve.fileUri);if(!Fe){x.info("Cannot resolve the path because it is not valid.",ve);return}if(!await U.canHandleResource(Fe)){x.info("Cannot resolve the path because it cannot be handled",ve);return}let we=ve.exists,ge=ve.type;if(typeof we!="boolean"||typeof ge!="number")try{ge=(await U.stat(Fe)).isDirectory?m.FileType.Directory:m.FileType.Unknown,we=!0}catch(Y){x.error(Y),we=!1}if(!we&&ve.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",ve);return}if(ge===m.FileType.Directory){x.info("Cannot resolve the path because it is a directory",ve);return}const Q={...ve.options,pinned:!0};return we?{resource:Fe,options:Q}:{resource:Fe,options:Q,forceUntitled:!0}}))}var ue;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function Ce(ne){const U=ne;if(!U)return!1;const x=U;if(x.modified)return Ce(x.modified);const ve=U;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function se(ne){return(0,T.$kj)(ne)}function Oe(ne,U,x){const ve=(0,T.$lj)(ne,U);return ve.forceMessage=x?.forceMessage,ve.forceSeverity=x?.forceSeverity,ve.allowDialog=x?.allowDialog,ve}}),define(Se[222],Ie([1,0,5,186,3,6,28,29,26,92,210]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=e.$6F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$5F=e.ViewContentGroups=e.$3F=e.ViewContainerLocation=e.Extensions=e.$2F=e.$1F=e.$ZF=void 0,e.$4F=b,e.$ZF="views",e.$1F=(0,O.localize)(0,null),e.$2F=(0,T.$ix)("default-view-icon",E.$Xj.window,(0,O.localize)(1,null));var S;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var l;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(l||(e.ViewContainerLocation=l={})),e.$3F=[0,1,2];function b(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class f extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$fe),this.onDidRegister=this.c.event,this.f=this.B(new C.$fe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(g,a,d){const w=this.get(g.id);if(w)return w;const $=g;return $.openCommandActionDescriptor=d?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,R.$xc)(this.g,a,[]).push($),d?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:a}),$}deregisterViewContainer(g){for(const a of this.g.keys()){const d=this.g.get(a),w=d?.indexOf(g);if(w!==-1){d?.splice(w,1),d.length===0&&this.g.delete(a),this.f.fire({viewContainer:g,viewContainerLocation:a});return}}}get(g){return this.all.filter(a=>a.id===g)[0]}getViewContainers(g){return[...this.g.get(g)||[]]}getViewContainerLocation(g){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(d=>d?.id===g.id).length>0)[0]}getDefaultViewContainer(g){return this.h.find(a=>this.getViewContainerLocation(a)===g)}}p.$fo.add(S.ViewContainersRegistry,new f);var s;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(s||(e.ViewContentGroups=s={}));function r(t,g){const a=t.group??s.More,d=g.group??s.More;return a!==d?a.localeCompare(d):(t.order??5)-(g.order??5)}class o extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$fe),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$fe),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$fe),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$fe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Hc}registerViews(g,a){this.registerViews2([{views:g,viewContainer:a}])}registerViews2(g){g.forEach(({views:a,viewContainer:d})=>this.r(a,d)),this.c.fire(g)}deregisterViews(g,a){const d=this.s(g,a);d.length&&this.f.fire({views:d,viewContainer:a})}moveViews(g,a){for(const d of this.m.keys())if(d!==a){const w=this.s(g,d);w.length&&(this.r(w,a),this.g.fire({views:w,from:d,to:a}))}}getViews(g){return this.m.get(g)||[]}getView(g){for(const a of this.j){const d=(this.m.get(a)||[]).filter(w=>w.id===g)[0];if(d)return d}return null}getViewContainer(g){for(const a of this.j)if((this.m.get(a)||[]).filter(w=>w.id===g)[0])return a;return null}registerViewWelcomeContent(g,a){return this.n.add(g,a),this.h.fire(g),(0,N.$Sc)(()=>{this.n.delete(g,a),this.h.fire(g)})}registerViewWelcomeContent2(g,a){const d=new Map;for(const[w,$]of a)this.n.add(g,$),d.set(w,(0,N.$Sc)(()=>{this.n.delete(g,$),this.h.fire(g)}));return this.h.fire(g),d}getViewWelcomeContent(g){const a=[];return this.n.forEach(g,d=>a.push(d)),a.sort(r)}r(g,a){let d=this.m.get(a);d||(d=[],this.m.set(a,d),this.j.push(a));for(const w of g){if(this.getView(w.id)!==null)throw new Error((0,O.localize)(2,null,w.id));d.push(w)}}s(g,a){const d=this.m.get(a);if(!d)return[];const w=[],$=[];for(const v of d)g.includes(v)?w.push(v):$.push(v);return w.length&&($.length?this.m.set(a,$):(this.m.delete(a),this.j.splice(this.j.indexOf(a),1))),w}}p.$fo.add(S.ViewsRegistry,new o),e.$5F=(0,A.$yi)("viewDescriptorService");var i;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class c{constructor(g,a){this.c=!1,this.d=!1,(0,m.$8n)(this,g),this.d=!!a,this.resolve=async d=>{if(a&&!this.c){const w=await a(d);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}d.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$6F=c;class u extends Error{constructor(g){super((0,O.localize)(3,null,g)),this.name="NoTreeViewError"}static is(g){return g.name==="NoTreeViewError"}}e.$7F=u}),define(Se[223],Ie([1,0,187,31]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=void 0,e.$$F=new O.$Pj("chatSessionResponseVote","",{type:"string",description:(0,C.localize)(0,null)}),e.$_F=new O.$Pj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,C.localize)(1,null)}),e.$aG=new O.$Pj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,C.localize)(2,null)}),e.$bG=new O.$Pj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,C.localize)(3,null)}),e.$cG=new O.$Pj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,C.localize)(4,null)}),e.$dG=new O.$Pj("chatResponse",!1,{type:"boolean",description:(0,C.localize)(5,null)}),e.$eG=new O.$Pj("chatRequest",!1,{type:"boolean",description:(0,C.localize)(6,null)}),e.$fG=new O.$Pj("chatEditApplied",!1,{type:"boolean",description:(0,C.localize)(7,null)}),e.$gG=new O.$Pj("chatInputHasText",!1,{type:"boolean",description:(0,C.localize)(8,null)}),e.$hG=new O.$Pj("chatInputHasFocus",!1,{type:"boolean",description:(0,C.localize)(9,null)}),e.$iG=new O.$Pj("inChatInput",!1,{type:"boolean",description:(0,C.localize)(10,null)}),e.$jG=new O.$Pj("inChat",!1,{type:"boolean",description:(0,C.localize)(11,null)}),e.$kG=new O.$Pj("chatIsEnabled",!1,{type:"boolean",description:(0,C.localize)(12,null)}),e.$lG=new O.$Pj("chatCursorAtTop",!1),e.$mG=new O.$Pj("chatInputHasAgent",!1),e.$nG=new O.$Pj("chatLocation",void 0)}),define(Se[224],Ie([1,0,11,20,5,42,6,132,13,31,3,12,102,204,216,223]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.ChatAgentLocation=void 0;var o;(function(u){u.Panel="panel",u.Terminal="terminal",u.Notebook="notebook",u.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(u){function t(g){switch(g){case"panel":return u.Panel;case"terminal":return u.Terminal;case"notebook":return u.Notebook;case"editor":return u.Editor}return u.Panel}u.fromRaw=t}(o||(e.ChatAgentLocation=o={})),e.$mH=(0,T.$yi)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new A.$fe,this.onDidChangeAgents=this.d.event,this.e=s.$kG.bindTo(this.f)}registerAgent(t,g){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const d=this,w=g.slashCommands;g={...g,get slashCommands(){return w.filter(v=>!v.when||d.f.contextMatchesRules(E.$wj.deserialize(v.when)))}};const $={data:g};return this.b.push($),(0,R.$Sc)(()=>{this.b=this.b.filter(v=>v!==$),this.d.fire(void 0)})}registerAgentImplementation(t,g){const a=this.g(t);if(!a)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(a.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return a.data.isDefault&&this.e.set(!0),a.impl=g,this.d.fire(new n(a.data,g)),(0,R.$Sc)(()=>{a.impl=void 0,this.d.fire(void 0),a.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,g){t.isDynamic=!0;const a={data:t,impl:g};return this.b.push(a),this.d.fire(new n(t,g)),(0,R.$Sc)(()=>{this.b=this.b.filter(d=>d!==a),this.d.fire(void 0)})}updateAgent(t,g){const a=this.g(t);if(!a?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);a.data.metadata={...a.data.metadata,...g},this.d.fire(new n(a.data,a.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(g=>!!g.isDefault&&g.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(g=>!!g.isDefault&&g.locations.includes(t))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(g=>g.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new n(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(g=>g.name===t)}async invokeAgent(t,g,a,d,w){const $=this.g(t);if(!$?.impl)throw new Error(`No activated agent with id ${t}`);return await $.impl.invoke(g,a,d,w)}async getFollowups(t,g,a,d,w){const $=this.g(t);if(!$?.impl)throw new Error(`No activated agent with id ${t}`);return $.impl?.provideFollowups?$.impl.provideFollowups(g,a,d,w):[]}};e.$nH=i,e.$nH=i=Je([We(0,E.$Qj)],i);class n{constructor(t,g){this.b=t,this.d=g}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,g,a,d){return this.d.invoke(t,g,a,d)}async provideFollowups(t,g,a,d){return this.d.provideFollowups?this.d.provideFollowups(t,g,a,d):[]}provideWelcomeMessage(t,g){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,g)}provideSampleQuestions(t,g){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,g)}}e.$oH=n,e.$pH=(0,T.$yi)("chatAgentNameService");let c=class{static{r=this}static{this.b="chat.participantNameRegistry"}constructor(t,g,a,d){if(this.g=g,this.h=a,this.i=d,this.e=(0,p.$3d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const w=d.get(r.b,-1);try{this.e.set(JSON.parse(w??"{}"),void 0)}catch{d.remove(r.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,C.$zh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},O.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const g=await(0,b.$Wp)(t);if(!g||g.version!==1)throw new Error("Unexpected chat participant registry response.");const a=g.restrictedChatParticipants;this.e.set(a,void 0),this.i.store(r.b,JSON.stringify(a),-1,1)}getAgentNameRestriction(t){return this.e.map(a=>a[t.name.toLowerCase()]).map(a=>a?a.some(d=>(0,m.$zf)(d,d.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$qH=c,e.$qH=c=r=Je([We(0,l.$lk),We(1,b.$Qp),We(2,S.$5j),We(3,f.$4p)],c)}),define(Se[225],Ie([1,0,2,30,3]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YG=e.$XG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$VG=N,e.$WG=R;function N(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof C.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(O.$xt.isIRange)}function R(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(N)}var p;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var m;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$XG=(0,A.$yi)("IChatService"),e.$YG="accessibility.voice.keywordActivation"}),define(Se[226],Ie([1,0,5,11,188]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$isb=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new C.$fe,this.o=new C.$fe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,m,E,T){const S={command:p};if(m&&Object.keys(m).length>0&&(S.arguments=m),this.u("request",S),typeof T=="number"){const l=setTimeout(()=>{clearTimeout(l);const b=this.f.get(S.seq);if(b){this.f.delete(S.seq);const f={type:"response",seq:0,request_seq:S.seq,success:!1,command:p,message:(0,A.localize)(0,null,T,p)};b(f)}},T)}return E&&this.f.set(S.seq,E),S.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,m){return p.type!=="event"||m.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,O.$zh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const m=p,E=this.f.get(m.request_seq);E&&(this.f.delete(m.request_seq),E(m));break}}}}u(p,m){m.type=p,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((m,E)=>p.set(E,m)),await(0,O.$zh)(500),p.forEach((m,E)=>{m({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$isb=N}),define(Se[227],Ie([1,0,2,189,31,3]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$GJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$EJ=e.MemoryRangeType=e.State=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=void 0,e.$DJ=m,e.$FJ=T,e.$rI="workbench.view.debug",e.$sI="workbench.debug.variablesView",e.$tI="workbench.debug.watchExpressionsView",e.$uI="workbench.debug.callStackView",e.$vI="workbench.debug.loadedScriptsView",e.$wI="workbench.debug.breakPointsView",e.$xI="workbench.debug.disassemblyView",e.$yI="workbench.panel.repl",e.$zI="workbench.panel.repl.view",e.$AI=new A.$Pj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$BI=new A.$Pj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$CI=new A.$Pj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$DI="debugUx",e.$EI=new A.$Pj(e.$DI,"default",{type:"string",description:O.localize(3,null)}),e.$FI=new A.$Pj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$GI=new A.$Pj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$HI=new A.$Pj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$II=new A.$Pj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$JI=new A.$Pj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$KI=new A.$Pj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$LI=new A.$Pj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$MI=new A.$Pj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$NI=new A.$Pj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$OI=new A.$Pj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$PI=new A.$Pj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$QI=new A.$Pj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$RI=new A.$Pj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$SI=new A.$Pj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$TI=new A.$Pj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$UI=new A.$Pj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$VI=new A.$Pj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$WI=new A.$Pj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$XI=new A.$Pj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$YI=new A.$Pj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$ZI=new A.$Pj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$1I=new A.$Pj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$2I=new A.$Pj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$3I=new A.$Pj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$4I=new A.$Pj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$5I=new A.$Pj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$6I=new A.$Pj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$7I=new A.$Pj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$8I=new A.$Pj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$9I=new A.$Pj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$0I=new A.$Pj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$$I=new A.$Pj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$_I=new A.$Pj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$aJ=new A.$Pj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$bJ=new A.$Pj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$cJ=new A.$Pj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$dJ=new A.$Pj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$eJ=new A.$Pj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$fJ=new A.$Pj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$gJ=new A.$Pj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$hJ=new A.$Pj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$iJ=new A.$Pj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$jJ=new A.$Pj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$kJ=new A.$Pj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$lJ=new A.$Pj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$mJ=new A.$Pj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$nJ=new A.$Pj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$oJ=new A.$Pj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$pJ=new A.$Pj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$qJ=new A.$Pj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$rJ=new A.$Pj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$sJ=new A.$Pj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$tJ=new A.$Pj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$uJ=new A.$Pj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$vJ=new A.$Pj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$wJ=new A.$Pj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$xJ=new A.$Pj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const R=n=>O.localize(61,null,n);e.$yJ=R,e.$zJ="editor.contrib.debug",e.$AJ="editor.contrib.breakpoint",e.$BJ="debug",e.$CJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var p;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(p||(e.State=p={}));function m(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$EJ="vscode-debug-memory";function T(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var S;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var l;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var b;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(b||(e.DebuggerString=b={})),e.$GJ=(0,N.$yi)("debugService");var f;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(f||(e.BreakpointWidgetContext=f={}));var s;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(s||(e.DebugVisualizationType=s={}));var r;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(r||(e.DebugTreeItemCollapsibleState=r={}));var o;(function(n){n.deserialize=c=>c,n.serialize=c=>c})(o||(e.IDebugVisualizationTreeItem=o={}));var i;(function(n){n.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:C.URI.revive(c.iconPath.light),dark:C.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),n.serialize=c=>c})(i||(e.IDebugVisualization=i={}))}),define(Se[228],Ie([1,0,13,2,19,26,16,30,20,18]),function(le,e,C,O,A,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FH=void 0,e.$tH=S,e.$uH=l,e.$vH=b,e.$wH=f,e.$xH=s,e.$yH=r,e.$zH=o,e.$AH=n,e.$BH=t,e.$CH=g,e.$DH=d,e.$EH=$;const T=/{([^}]+)}/g;function S(y,h,D){return y.replace(T,function(k,I){return h&&I.length>0&&I[0]!=="_"?k:D&&D.hasOwnProperty(I)?D[I]:k})}function l(y){const h={};for(const D of Object.keys(y))D.startsWith("!")||(h[D]=y[D]);return h}function b(y){return y.configuration.request==="attach"&&!f(y)&&(!y.parentSession||b(y.parentSession))}function f(y){let h=y.configuration.type;if(h)return h==="vslsShare"&&(h=y.configuration.adapterProxy.configuration.type),(0,C.$zf)(h,"extensionhost")||(0,C.$zf)(h,"pwa-extensionhost")?y:y.parentSession?f(y.parentSession):void 0}function s(y){return y.type&&(y.label||y.program||y.runtime)}function r(y,h,D){let k,I=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=P.exec(y);){const W=V.index+1,q=W+V[0].length;if(W<=h&&q>=D){k=V[0],I=W;break}}if(k){const W=/\w+/g;let q=null;for(;(q=W.exec(k))&&!(q.index+1+I+q[0].length>=D););q&&(k=k.substring(0,W.lastIndex))}return k?{start:I,end:I+k.length-1}:{start:0,end:0}}async function o(y,h,D,k){if(y.evaluatableExpressionProvider.has(h)){const I=y.evaluatableExpressionProvider.ordered(h),P=(0,E.$Hb)(await Promise.all(I.map(async V=>{try{return await V.provideEvaluatableExpression(h,D,k??m.CancellationToken.None)}catch{return}})));if(P.length>0){let V=P[0].expression;const W=P[0].range;return V||(V=h.getLineContent(D.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:V}}}else{const I=h.getLineContent(D.lineNumber),{start:P,end:V}=r(I,D.column,D.column),W=I.substring(P-1,V);return{matchingExpression:W,range:new p.$xt(D.lineNumber,P,D.lineNumber,P+W.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(y){return!!(y&&y.match(i))}function c(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(n(y.path))return O.URI.parse(y.path);if((0,A.$ic)(y.path))return O.URI.file(y.path)}return y.path}function u(y){if(typeof y.path=="object"){const h=O.URI.revive(y.path);if(h)return h.scheme===R.Schemas.file?h.fsPath:h.toString()}return y.path}function t(y,h){const D=h?c:u,k=(0,N.$5n)(y);return a(k,(I,P)=>{I&&P&&(P.path=D(P))}),k}function g(y,h){const D=h?c:u,k=(0,N.$5n)(y);return a(k,(I,P)=>{!I&&P&&(P.path=D(P))}),k}function a(y,h){switch(y.type){case"event":{const D=y;switch(D.event){case"output":h(!1,D.body.source);break;case"loadedSource":h(!1,D.body.source);break;case"breakpoint":h(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=y;switch(D.command){case"setBreakpoints":h(!0,D.arguments.source);break;case"breakpointLocations":h(!0,D.arguments.source);break;case"source":h(!0,D.arguments.source);break;case"gotoTargets":h(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(k=>h(!1,k));break;default:break}break}case"response":{const D=y;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(k=>h(!1,k.source));break;case"loadedSources":D.body.sources.forEach(k=>h(!1,k));break;case"scopes":D.body.scopes.forEach(k=>h(!1,k.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(k=>h(!1,k.source));break;case"setBreakpoints":D.body.breakpoints.forEach(k=>h(!1,k.source));break;case"disassemble":D.body?.instructions.forEach(I=>h(!1,I.location));break;default:break}break}}}function d(y){return y.filter(h=>!h.presentation?.hidden).sort((h,D)=>h.presentation?D.presentation?h.presentation.group?D.presentation.group?h.presentation.group!==D.presentation.group?h.presentation.group.localeCompare(D.presentation.group):w(h.presentation.order,D.presentation.order):-1:D.presentation.group?1:w(h.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function w(y,h){return typeof y!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:y-h}async function $(y,h){const D=y.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(D!=="none"&&(await h.saveAll(),D==="allEditorsInActiveGroup")){const k=h.activeEditorPane;k&&k.input.resource?.scheme===R.Schemas.untitled&&await h.save({editor:k.input,groupId:k.group.id})}await y.reloadConfiguration()}const v=(y,h)=>!y||!h?y===h:y.name===h.name&&y.path===h.path&&y.sourceReference===h.sourceReference;e.$FH=v}),define(Se[229],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YJ=e.CellExecutionUpdateType=void 0;var O;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$YJ=(0,C.$yi)("INotebookExecutionService")}),define(Se[230],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uib=e.$Tib=e.ProxyKernelState=e.$Sib=void 0,e.$Sib=100;var O;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$Tib=(0,C.$yi)("INotebookKernelService"),e.$Uib=(0,C.$yi)("INotebookKernelHistoryService")}),define(Se[231],Ie([1,0,6,30,156,96]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wXb=void 0;class R extends C.$Uc{constructor(m,E,T){super(),this._source=m,this.b=E,this.c=T,this.a=void 0}f(m){const E=m.getLineCount();return new O.$xt(1,1,E,this.g(m,E))}g(m,E){if(E<1||E>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const m=new A.$5C;m.acceptChunk(this._source);const E=m.finish(!0),{textBuffer:T,disposable:S}=E.create(1);this.b=T,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const E=new A.$5C;E.acceptChunk(m);const T=E.finish(!0),{textBuffer:S,disposable:l}=T.create(1);return this.B(l),S})),this.a}findInInputs(m){const T=new N.$SC(m,!1,!1,null).parseSearchRequest();if(!T)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,T,!0,5e3)}findInOutputs(m){const T=new N.$SC(m,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),T,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$wXb=R}),define(Se[52],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6K=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(N){N.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var O;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class A{static fromExtHostTestItem(R,p,m=R.parent){if(R._isRoot)return new A([p]);const E=[R.id];for(let T=m;T&&T.id!==p;T=T.parent)E.push(T.id);return E.push(p),new A(E.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const p=R.indexOf("\0");return p===-1?R:R.slice(0,p)}static fromString(R){return new A(R.split("\0"))}static join(R,p){return new A([...R.path,p])}static joinToString(R,p){return R.toString()+"\0"+p}static parentId(R){const p=R.lastIndexOf("\0");return p===-1?void 0:R.slice(0,p)}static localId(R){const p=R.lastIndexOf("\0");return p===-1?R:R.slice(p+1)}static isChild(R,p){return p.startsWith(R)&&p[R.length]==="\0"}static compare(R,p){return R===p?0:A.isChild(R,p)?2:A.isChild(p,R)?3:1}constructor(R,p=R.length){if(this.path=R,this.d=p,R.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new A(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new A(this.path,R)}compare(R){if(typeof R=="string")return A.compare(this.toString(),R);for(let p=0;p<R.d&&p<this.d;p++)if(R.path[p]!==this.path[p])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$6K=A}),define(Se[62],Ie([1,0,2,94,30,52]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$bL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$aL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$_K=e.$$K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$0K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$9K=e.$8K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$7K=e.TestResultState=void 0;var R;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$7K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var m;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$8K=[2,4,8,16,32,64];const E=M=>"runId"in M;e.$9K=E;var T;(function(M){M.serialize=z=>({range:z.range.toJSON(),uri:z.uri.toJSON()}),M.deserialize=(z,G)=>({range:A.$xt.lift(G.range),uri:z.asCanonicalUri(C.URI.revive(G.uri))})})(T||(e.IRichLocation=T={}));var S;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(S||(e.TestMessageType=S={}));var l;(function(M){M.serialize=z=>({message:z.message,type:0,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&T.serialize(z.location)}),M.deserialize=(z,G)=>({message:G.message,type:0,expected:G.expected,actual:G.actual,contextValue:G.contextValue,location:G.location&&T.deserialize(z,G.location)})})(l||(e.ITestErrorMessage=l={}));const b=(M,z)=>`${z?"s":"e"}${M}`;e.$0K=b;var f;(function(M){M.serialize=z=>({message:z.message,type:1,offset:z.offset,length:z.length,location:z.location&&T.serialize(z.location)}),M.deserialize=(z,G)=>({message:G.message,type:1,offset:G.offset,length:G.length,location:G.location&&T.deserialize(z,G.location)})})(f||(e.ITestOutputMessage=f={}));var s;(function(M){M.serialize=z=>z.type===0?l.serialize(z):f.serialize(z),M.deserialize=(z,G)=>G.type===0?l.deserialize(z,G):f.deserialize(z,G)})(s||(e.ITestMessage=s={}));var r;(function(M){M.serializeWithoutMessages=z=>({state:z.state,duration:z.duration,messages:[]}),M.serialize=z=>({state:z.state,duration:z.duration,messages:z.messages.map(s.serialize)}),M.deserialize=(z,G)=>({state:G.state,duration:G.duration,messages:G.messages.map(ie=>s.deserialize(z,ie))})})(r||(e.ITestTaskState=r={}));const o="\0",i=(M,z)=>M+o+z;e.$$K=i;const n=M=>{const z=M.indexOf(o);return{ctrlId:M.slice(0,z),tagId:M.slice(z+1)}};e.$_K=n;var c;(function(M){M.serialize=z=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?.toJSON(),range:z.range?.toJSON()||null,description:z.description,error:z.error,sortText:z.sortText}),M.deserialize=(z,G)=>({extId:G.extId,label:G.label,tags:G.tags,busy:G.busy,children:void 0,uri:G.uri?z.asCanonicalUri(C.URI.revive(G.uri)):void 0,range:G.range?A.$xt.lift(G.range):null,description:G.description,error:G.error,sortText:G.sortText})})(c||(e.ITestItem=c={}));var u;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var t;(function(M){M.serialize=z=>({expand:z.expand,item:c.serialize(z.item)}),M.deserialize=(z,G)=>({controllerId:N.$6K.root(G.item.extId),expand:G.expand,item:c.deserialize(z,G.item)})})(t||(e.InternalTestItem=t={}));var g;(function(M){M.serialize=z=>{let G;return z.item&&(G={},z.item.label!==void 0&&(G.label=z.item.label),z.item.tags!==void 0&&(G.tags=z.item.tags),z.item.busy!==void 0&&(G.busy=z.item.busy),z.item.uri!==void 0&&(G.uri=z.item.uri?.toJSON()),z.item.range!==void 0&&(G.range=z.item.range?.toJSON()),z.item.description!==void 0&&(G.description=z.item.description),z.item.error!==void 0&&(G.error=z.item.error),z.item.sortText!==void 0&&(G.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:G}},M.deserialize=z=>{let G;return z.item&&(G={},z.item.label!==void 0&&(G.label=z.item.label),z.item.tags!==void 0&&(G.tags=z.item.tags),z.item.busy!==void 0&&(G.busy=z.item.busy),z.item.range!==void 0&&(G.range=z.item.range?A.$xt.lift(z.item.range):null),z.item.description!==void 0&&(G.description=z.item.description),z.item.error!==void 0&&(G.error=z.item.error),z.item.sortText!==void 0&&(G.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:G}}})(g||(e.ITestItemUpdate=g={}));const a=(M,z)=>{z.expand!==void 0&&(M.expand=z.expand),z.item!==void 0&&(M.item=M.item?Object.assign(M.item,z.item):z.item)};e.$aL=a;var d;(function(M){M.serializeWithoutMessages=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(r.serializeWithoutMessages)}),M.serialize=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(r.serialize)}),M.deserialize=(z,G)=>({...t.deserialize(z,G),ownComputedState:G.ownComputedState,computedState:G.computedState,tasks:G.tasks.map(ie=>r.deserialize(z,ie)),retired:!0})})(d||(e.TestResultItem=d={}));var w;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(z,G)=>{z.covered+=G.covered,z.total+=G.total}})(w||(e.ICoverageCount=w={}));var $;(function(M){M.serialize=z=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,testId:z.testId?.toString(),uri:z.uri.toJSON()}),M.deserialize=(z,G)=>({id:G.id,statement:G.statement,branch:G.branch,declaration:G.declaration,testId:G.testId?N.$6K.fromString(G.testId):void 0,uri:z.asCanonicalUri(C.URI.revive(G.uri))}),M.empty=(z,G)=>({id:z,uri:G,testId:void 0,statement:w.empty()})})($||(e.IFileCoverage=$={}));function v(M){return{...M,location:M.location?.toJSON()}}function y(M){return M.location=M.location?O.$wt.isIPosition(M.location)?O.$wt.lift(M.location):A.$xt.lift(M.location):void 0,M}e.$bL=3;var h;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(h||(e.DetailType=h={}));var D;(function(M){M.serialize=z=>z.type===0?I.serialize(z):P.serialize(z),M.deserialize=z=>z.type===0?I.deserialize(z):P.deserialize(z)})(D||(e.CoverageDetails=D={}));var k;(function(M){M.serialize=v,M.deserialize=y})(k||(e.IBranchCoverage=k={}));var I;(function(M){M.serialize=v,M.deserialize=y})(I||(e.IDeclarationCoverage=I={}));var P;(function(M){M.serialize=z=>({...v(z),branches:z.branches?.map(k.serialize)}),M.deserialize=z=>({...y(z),branches:z.branches?.map(k.deserialize)})})(P||(e.IStatementCoverage=P={}));var V;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var W;(function(M){M.deserialize=(z,G)=>G.op===0?{op:G.op,item:t.deserialize(z,G.item)}:G.op===1?{op:G.op,item:g.deserialize(G.item)}:G.op===2?{op:G.op,uri:z.asCanonicalUri(C.URI.revive(G.uri)),docv:G.docv}:G,M.serialize=z=>z.op===0?{op:z.op,item:t.serialize(z.item)}:z.op===1?{op:z.op,item:g.serialize(z.item)}:z})(W||(e.TestsDiffOp=W={}));class q{constructor(z){this.k=z,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(z){const G=this.v();for(const ie of z)switch(ie.op){case 0:this.l(t.deserialize(this.k,ie.item),G);break;case 1:this.o(g.deserialize(ie.item),G);break;case 3:this.p(ie.itemId,G);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}G.complete?.()}l(z,G){const ie=N.$6K.parentId(z.item.extId)?.toString();let de;if(!ie)de=this.w(z),this.g.add(de),this.f.set(z.item.extId,de);else if(this.f.has(ie)){const ye=this.f.get(ie);ye.children.add(z.item.extId),de=this.w(z,ye),this.f.set(z.item.extId,de)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(z)}`);return}return G.add?.(de),z.expand===2&&this.h++,de}o(z,G){const ie=this.f.get(z.extId);if(ie)return z.expand!==void 0&&(ie.expand===2&&this.h--,z.expand===2&&this.h++),(0,e.$aL)(ie,z),G.update?.(ie),ie}p(z,G){const ie=this.f.get(z);if(!ie)return;const de=N.$6K.parentId(ie.item.extId)?.toString();de?this.f.get(de).children.delete(ie.item.extId):this.g.delete(ie);const ye=[[z]];for(;ye.length;)for(const Ee of ye.pop()){const me=this.f.get(Ee);me&&(ye.push(me.children),this.f.delete(Ee),G.remove?.(me,me!==ie),me.expand===2&&this.h--)}}q(z){}updatePendingRoots(z){this.j+=z}v(){return{}}}e.$cL=q}),define(Se[77],Ie([1,0,11,5,6,57,62,52]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.TestItemEventOp=void 0;var m;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const E=(i,n)=>i===n,S=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:E,label:E,description:E,error:E,sortText:E,tags:(i,n)=>!(i.length!==n.length||i.some(c=>!n.includes(c)))}),l=(i,n)=>{let c;for(const[u,t]of S)t(i[u],n[u])||(c?c[u]=n[u]:c={[u]:n[u]});return c};class b extends A.$Uc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new C.$Kh(()=>this.flushDiff(),200)),this.g=this.B(new O.$fe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===n.uri){c.docv=n.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===n.item.extId){(0,R.$aL)(c.item,n.item);return}if(c.op===0&&c.item.item.extId===n.item.extId){(0,R.$aL)(c.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,c){const u=this.tree.get(n);if(u){if((u.expandLevels===void 0||c>u.expandLevels)&&(u.expandLevels=c),u.expand===1){const t=this.M(u);return t.isOpen()?this.L(u,c-1):t.wait().then(()=>this.L(u,c-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,c-1)):this.L(u,c-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,c){switch(c.op){case 3:this.O(p.$6K.joinToString(n.fullId,c.id));break;case 0:this.z(c.item,n);break;case 5:for(const u of c.ops)this.w(n,u);break;case 1:this.C(c.new,c.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:c.update}});break;case 6:this.y(n.actual.uri);break;default:(0,N.$ed)(c)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,c){const u=p.$6K.fromExtHostTestItem(n,this.root.id,c?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(n.id);let g=this.tree.get(u.toString());if(!g){g={fullId:u,actual:n,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(g.fullId.toString(),g),this.G(n,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:g.expand,item:this.s.toITestItem(n)}}),this.I(n,g,c);return}if(g.actual===n){this.H(n,g,c);return}if(g.actual.uri?.toString()!==n.uri?.toString())return this.O(u.toString()),this.z(n,c);const a=this.s.getChildren(g.actual),d=g.actual,w=l(this.s.toITestItem(d),this.s.toITestItem(n));this.s.getApiFor(d).listener=void 0,g.actual=n,g.resolveBarrier=void 0,g.expand=0,w&&(w.hasOwnProperty("tags")&&(this.C(n.tags,d.tags,u.toString()),delete w.tags),this.w(g,{op:4,update:w})),this.I(n,g,c);for(const[v,y]of a)this.s.getChildren(n).get(y.id)||this.O(p.$6K.joinToString(u,y.id));const $=g.expandLevels;$!==void 0&&queueMicrotask(()=>{g.expand===1&&(g.expandLevels=void 0,this.expand(u.toString(),$))}),this.y(g.actual.uri)}C(n,c,u){const t=new Set(c.map(g=>g.id));for(const g of n)t.delete(g.id)||this.D(g);this.pushDiff({op:1,item:{extId:u,item:{tags:n.map(g=>(0,R.$$K)(this.s.controllerId,g.id))}}}),t.forEach(this.F,this)}D(n){const c=this.j.get(n.id);c?c.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$$K)(this.s.controllerId,n.id)}}))}F(n){const c=this.j.get(n);c&&!--c.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$$K)(this.s.controllerId,n)}))}G(n,c){this.s.getApiFor(n).parent=c&&c.actual!==this.root?c.actual:void 0}H(n,c,u){this.G(n,u);const t=this.s.getApiFor(n);t.parent=u?.actual,t.listener=g=>this.w(c,g),this.J(c)}I(n,c,u){this.H(n,c,u);for(const[t,g]of this.s.getChildren(n))this.z(g,c)}J(n){let c;this.h?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:c}}),c===1&&n.expandLevels!==void 0&&this.M(n))}L(n,c){if(c<0)return;const u=[];for(const[t,g]of this.s.getChildren(n.actual)){const a=this.expand(p.$6K.joinToString(n.fullId,g.id),c);(0,C.$kh)(a)&&u.push(a)}if(u.length)return Promise.all(u).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const g=new C.$xh;return g.open(),g}n.expand=2,this.N(n);const c=n.resolveBarrier=new C.$xh,u=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,g)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(g){u(g)}return(0,C.$kh)(t)?t.catch(u).then(()=>{c.open(),this.J(n)}):(c.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const u=[c];for(;u.length;){const t=u.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const g of t.actual.tags)this.F(g.id);this.tree.delete(t.fullId.toString());for(const[g,a]of this.s.getChildren(t.actual))u.push(this.tree.get(p.$6K.joinToString(t.fullId,a.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$BO=b;class f extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$CO=f;class s extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$DO=s;class r extends Error{constructor(n,c,u){super(`TestItem with ID "${n}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.$EO=r;const o=(i,n,c)=>{let u=new Map;return{get size(){return u.size},forEach(t,g){for(const a of u.values())t.call(g,a,this)},[Symbol.iterator](){return u.entries()},replace(t){const g=new Map,a=new Set(u.keys()),d={op:5,ops:[]};for(const w of t){if(!(w instanceof c))throw new s(w.id);const $=n(w).controllerId;if($!==i.controllerId)throw new r(w.id,$,i.controllerId);if(g.has(w.id))throw new f(w.id);g.set(w.id,w),a.delete(w.id),d.ops.push({op:0,item:w})}for(const w of a.keys())d.ops.push({op:3,id:w});i.listener?.(d),u=g},add(t){if(!(t instanceof c))throw new s(t.id);u.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){u.delete(t)&&i.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.$FO=o}),define(Se[107],Ie([1,0,77]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=e.$GO=void 0;const O=new WeakMap,A=(R,p)=>{const m={controllerId:p};return O.set(R,m),m};e.$GO=A;const N=R=>{const p=O.get(R);if(!p)throw new C.$DO(R?.id||"<unknown>");return p};e.$HO=N}),define(Se[78],Ie([1,0,16,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Ab=e.$9Ab=e.$8Ab=void 0,e.$$Ab=A,e.$_Ab=R,e.$8Ab="vscode-cdn.net",e.$9Ab=`vscode-resource.${e.$8Ab}`,e.$0Ab=`'self' https://*.${e.$8Ab}`;function A(p,m){return p.scheme===C.Schemas.http||p.scheme===C.Schemas.https?p:(m&&m.authority&&m.isRemote&&p.scheme===C.Schemas.file&&(p=O.URI.from({scheme:C.Schemas.vscodeRemote,authority:m.authority,path:p.path})),O.URI.from({scheme:C.Schemas.https,authority:`${p.scheme}+${N(p.authority)}.${e.$9Ab}`,path:p.path,fragment:p.fragment,query:p.query}))}function N(p){return p.replace(/./g,m=>{const E=m.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?m:"-"+E.toString(16).padStart(4,"0")})}function R(p){return p.replace(/-([0-9a-f]{4})/g,(m,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Se[232],Ie([1,0,5,6,78]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;class N{constructor(p,m,E){this.d=p,this.e=m,this.f=E,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const T=m.getVisibleTextEditors();for(const S of this.c.values())T.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,m,E,T,S){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===p){l=n;break}if(!l)throw new Error("not a visible editor");const b=this,f=this.a++,s=new C.$fe,r=new C.$fe,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,A.$$Ab)(n,b.f)}get cspSource(){return A.$0Ab}set options(n){this.b=n,b.d.$setOptions(f,n)}get options(){return this.b}set html(n){this.a=n,b.d.$setHtml(f,n)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(n){return b.d.$postMessage(f,n)}},i=new class{constructor(){this.editor=p,this.line=m,this.height=E,this.webview=o,this.onDidDispose=r.event}dispose(){b.c.has(f)&&(b.c.delete(f),b.d.$disposeEditorInset(f),r.fire(),r.dispose(),s.dispose())}};return this.d.$createEditorInset(f,l.id,l.value.document.uri,m+1,E,T||{},S.identifier,S.extensionLocation),this.c.set(f,{editor:p,inset:i,onDidReceiveMessage:s}),i}$onDidDispose(p){const m=this.c.get(p);m&&m.inset.dispose()}$onDidReceiveMessage(p,m){this.c.get(p)?.onDidReceiveMessage.fire(m)}}e.$$lc=N}),define(Se[108],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lL=e.$kL=e.$jL=void 0,e.$jL="__",e.$kL=(0,C.$yi)("IAuthenticationService"),e.$lL=(0,C.$yi)("IAuthenticationExtensionsService")}),define(Se[233],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.VariableKind=e.$zP=void 0,e.$zP=(0,C.$yi)("configurationResolverService");var O;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class A extends Error{constructor(R,p){super(p),this.variable=R}}e.$AP=A}),define(Se[234],Ie([1,0,19,75,15,26,23,97,192,233,13]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,f,s,r){this.h=new Map,this.a=b,this.b=f,this.g=s,r&&(this.c=r.then(o=>this.i(o)))}i(b){if(R.$i){const f=Object.create(null);return Object.keys(b).forEach(s=>{f[s.toLowerCase()]=b[s]}),f}return b}resolveWithEnvironment(b,f,s){return this.l({env:this.i(b),userHome:void 0},f?f.uri:void 0,s)}async resolveAsync(b,f){const s={env:await this.c,userHome:await this.g};return this.l(s,b?b.uri:void 0,f)}async j(b,f,s,r){const o=N.$5n(f);R.$i&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):R.$j&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):R.$k&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,b?b.uri:void 0,o,s,r)}async resolveAnyAsync(b,f,s){return this.j(b,f,s)}async resolveAnyMap(b,f,s){const r=new Map;return{newConfig:await this.j(b,f,s,r),resolvedVariables:r}}resolveWithInteractionReplace(b,f,s,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,f,s,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,f){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,f)}async l(b,f,s,r,o){if(A.$$f(s))return this.m(b,f,s,r,o);if(Array.isArray(s))return Promise.all(s.map(i=>this.l(b,f,i,r,o)));if(A.$ag(s)){const i=Object.create(null),n=await Promise.all(Object.keys(s).map(async c=>[await this.m(b,f,c,r,o),await this.l(b,f,s[c],r,o)]));for(const[c,u]of n)i[c]=u;return i}return s}m(b,f,s,r,o){return(0,T.$rf)(s,S.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(S.VARIABLE_LHS))return i;let c=await this.o(b,i,n,f,r);return o?.set(n,c),c!==i&&A.$$f(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m(b,f,c,r,o)),c})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,f,s,r,o){let i;const n=s.split(":");n.length>1&&(s=n[0],i=n[1]);const c=g=>{const a=this.a.getFilePath();if(a)return(0,p.$Hw)(a);throw new E.$AP(g,(0,m.localize)(0,null,f))},u=g=>{const a=c(g);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,p.$Hw)(d)}throw new E.$AP(g,(0,m.localize)(1,null,f,C.$nc(a)))},t=g=>{if(i){const a=this.a.getFolderUri(i);if(a)return a;throw new E.$AP(g,(0,m.localize)(2,null,f,i))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new E.$AP(g,(0,m.localize)(3,null,f)):new E.$AP(g,(0,m.localize)(4,null,f))};switch(s){case"env":if(i){if(b.env){const g=b.env[R.$i?i.toLowerCase():i];if(A.$$f(g))return g}return""}throw new E.$AP(E.VariableKind.Env,(0,m.localize)(5,null,f));case"config":if(i){const g=this.a.getConfigurationValue(r,i);if(A.$hg(g))throw new E.$AP(E.VariableKind.Config,(0,m.localize)(6,null,f,i));if(A.$ag(g))throw new E.$AP(E.VariableKind.Config,(0,m.localize)(7,null,f,i));return g}throw new E.$AP(E.VariableKind.Config,(0,m.localize)(8,null,f));case"command":return this.p(E.VariableKind.Command,f,i,o,"command");case"input":return this.p(E.VariableKind.Input,f,i,o,"input");case"extensionInstallFolder":if(i){const g=await this.a.getExtension(i);if(!g)throw new E.$AP(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,f,i));return this.n(g.extensionLocation)}throw new E.$AP(E.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,f));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,p.$Hw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return r||i?(0,p.$Hw)(this.n(t(E.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$Hw)(C.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new E.$AP(E.VariableKind.UserHome,(0,m.localize)(11,null,f))}case"lineNumber":{const g=this.a.getLineNumber();if(g)return g;throw new E.$AP(E.VariableKind.LineNumber,(0,m.localize)(12,null,f))}case"selectedText":{const g=this.a.getSelectedText();if(g)return g;throw new E.$AP(E.VariableKind.SelectedText,(0,m.localize)(13,null,f))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return u(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return C.$nc(u(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return r||i?C.$lc(this.n(t(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const g=C.$mc(c(E.VariableKind.RelativeFileDirname));if(r||i){const a=C.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),g);return a.length===0?".":a}return g}case"fileDirname":return C.$mc(c(E.VariableKind.FileDirname));case"fileExtname":return C.$oc(c(E.VariableKind.FileExtname));case"fileBasename":return C.$nc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=C.$nc(c(E.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-C.$oc(g).length)}case"fileDirnameBasename":return C.$nc(C.$mc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const g=this.a.getExecPath();return g||f}case"execInstallFolder":{const g=this.a.getAppRoot();return g||f}case"pathSeparator":case"/":return C.sep;default:try{const g=i?`${s}:${i}`:s;return this.p(E.VariableKind.Unknown,f,g,o,void 0)}catch{return f}}}}p(b,f,s,r,o){if(s&&r){const i=o===void 0?r[s]:r[o+":"+s];if(typeof i=="string")return i;throw new E.$AP(b,(0,m.localize)(14,null,f))}return f}}e.$PP=S}),define(Se[109],Ie([1,0,3,106]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$2D=void 0,e.$3D=E,e.$4D=l,e.$5D=b,e.$2D=(0,C.$yi)("editorGroupsService");var A;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var N;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var R;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var p;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var m;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function E(f){const s=f;return(0,O.$MF)(s?.editor)&&(0,O.$MF)(s?.replacement)}var T;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var S;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(f){const s=f;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}function b(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Se[235],Ie([1,0,3,109]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9D=e.$8D=e.$7D=e.$6D=void 0,e.$0D=A,e.$6D=(0,C.$yi)("editorService"),e.$7D=-1,e.$8D=-2,e.$9D=-3;function A(N){const R=N;return typeof N=="number"||(0,O.$4D)(R)}}),define(Se[236],Ie([1,0,3,99]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EL=void 0,e.$EL=(0,C.$zi)(O.$Fi)}),define(Se[110],Ie([1,0,21,5,19,6,11]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=e.$rac=e.$qac=e.$pac=e.$oac=void 0;class p{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$oac=p;class m{static isHostExtension(i,n,c){if(n.getExtensionDescription(i))return!1;const u=c.getExtensionDescription(i);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(i,n){this.j=i,this.c=new O.$fe,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(s),this.f=new C.$Vm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const c of n)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=r(this.e,n),this.e=this.e.concat(i);const c=m.l(this.e);return this.e=r(this.e,c.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,c)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,d){this.addNode(a),this.addNode(d),this.c.has(a)?this.c.get(a).push(d):this.c.set(a,[d])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,d){const w=n.getArcs(a);for(let $=0;$<w.length;$++)if(!d.has(w[$]))return!1;return!0}getNodes(){return this.e}},c=new C.$Vm;for(const a of i)if(c.set(a.identifier,a),a.extensionDependencies)for(const d of a.extensionDependencies)n.addArc(C.$Tm.toKey(a.identifier),C.$Tm.toKey(d));const u=new Set;n.getNodes().filter(a=>n.getArcs(a).length===0).forEach(a=>u.add(a));const t=n.getNodes().filter(a=>!u.has(a));let g;do{g=!1;for(let a=0;a<t.length;a++){const d=t[a];n.hasOnlyGoodArcs(d,u)&&(t.splice(a,1),a--,u.add(d),g=!0)}}while(g);return t.map(a=>c.get(a))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$pac=m;class E{constructor(i,n){this.versionId=i,this.extensions=n}}e.$qac=E;class T{constructor(i){this.d=new b,this.c=new m(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new S(this,n)}deltaExtensions(i,n,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$rac=T;class S extends N.$Uc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$sac=S;class l{constructor(i){this.name=i;const n=(0,R.$rh)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class b{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new l(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const c=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{n&&(clearTimeout(c),n=!1,this.d=!1,this.e())};i.resolve((0,N.$Sc)(u))}}var f;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(f||(f={}));function s(o,i){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==c)return n-c;const u=A.$gc.basename(o.extensionLocation.path),t=A.$gc.basename(i.extensionLocation.path);return u<t?-1:u>t?1:0}function r(o,i){const n=new C.$Um(i);return o.filter(c=>!n.has(c.identifier))}}),define(Se[79],Ie([1,0,22]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$2m=R,e.$3m=p;var O;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(O||(e.UIKind=O={}));var A;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var N;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function R(E){const T=C.$He.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function p(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var m;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Se[63],Ie([1,0,3,5,12,27,79,58,59,26,2,6,179]),function(le,e,C,O,A,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6O=e.$4O=e.$3O=void 0,e.$5O=s;let b=class extends S.$Uc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new O.$fe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$fe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:m.$np,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,A.$7j)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const c=this.getTelemetryDetails(),u=new f(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$Km)((0,m.$tp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,c)=>{const u=n.filter(t=>!t.isDisposed);u.length===0?this.r.delete(c):this.r.set(c,u)}),this.r.forEach(n=>{for(const c of n)c.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const c=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(o.value),!1;let u=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(i),u=!0);return u}};e.$3O=b,e.$3O=b=Je([We(0,N.$2O),We(1,A.$6j)],b);class f{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,c,u,t,g){this.g=n,this.h=c,this.i=u,this.j=t,this.a=new O.$fe,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,m.$wp)(i,[]),this.c&&(i=(0,E.$8n)(i,this.c)),this.b||(i=(0,E.$8n)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},c=(0,m.$wp)(n,[]),u=new Error(c.message,{cause:c.cause});u.stack=c.stack,u.name=c.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(u,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$4O=f;function s(r){const o=Date.now()-new Date(r).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$6O=(0,C.$yi)("IExtHostTelemetry")}),define(Se[25],Ie([1,0,5,2,207,105,21,3]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PG=e.ActivationKind=e.$MG=e.$LG=e.$IG=e.ExtensionHostStartup=e.$HG=e.$GG=e.$FG=e.$EG=void 0,e.$JG=l,e.$KG=b,e.$NG=o,e.$OG=i,e.$EG=Object.freeze({identifier:new R.$Tm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$FG="extensions.webWorker",e.$GG=(0,p.$yi)("extensionService");class m{constructor(u){this.dependency=u}}e.$HG=m;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,t,g){this.c=u,this.d=t.slice(0),this.e=g.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$pG.createActivationEventsMap(this.d)}}set(u,t,g){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const a=[],d=[],w=[],$=[],v=S(this.d),y=S(t),h=(V,W)=>V.extensionLocation.toString()===W.extensionLocation.toString()||V.isBuiltin===W.isBuiltin||V.isUserBuiltin===W.isUserBuiltin||V.isUnderDevelopment===W.isUnderDevelopment;for(const V of this.d){const W=y.get(V.identifier);if(!W){a.push(V.identifier),v.delete(V.identifier);continue}if(!h(V,W)){a.push(V.identifier),v.delete(V.identifier);continue}}for(const V of t){const W=v.get(V.identifier);if(!W){d.push(V);continue}if(!h(W,V)){a.push(W.identifier),v.delete(W.identifier);continue}}const D=new R.$Um(this.e),k=new R.$Um(g);for(const V of this.e)k.has(V)||w.push(V);for(const V of g)D.has(V)||$.push(V);const I=N.$pG.createActivationEventsMap(d),P={versionId:u,toRemove:a,toAdd:d,addActivationEvents:I,myToRemove:w,myToAdd:$};return this.delta(P),P}delta(u){if(this.c>=u.versionId)return null;const{toRemove:t,toAdd:g,myToRemove:a,myToAdd:d}=u,w=new R.$Um(t),$=new R.$Um(a);for(let v=0;v<this.d.length;v++)w.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)$.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of g)this.d.push(v);for(const v of d)this.e.push(v);return this.f=null,u}containsExtension(u){for(const t of this.e)if(R.$Tm.equals(t,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const g=N.$pG.readActivationEvents(t);for(const a of g)u.add(a)}return u}}e.$IG=T;function S(c){const u=new R.$Vm;for(const t of c)u.set(t.identifier,t);return u}function l(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}function b(c,u){if(!l(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class f{constructor(u,t,g,a){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=g,this.activationReason=a}}e.$LG=f;class s{constructor(u,t){this.description=u,this.value=t}}e.$MG=s;var r;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function o(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,A.$Cp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function i(c,u){return{identifier:new R.$Tm((0,A.$Ap)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,t){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$PG=n}),define(Se[237],Ie([1,0,14,110,21,25,12,11]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=e.$ymc=e.$xmc=e.$wmc=e.$vmc=e.$umc=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(o,i,n,c){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=c}}e.$umc=m;class E{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$vmc=E;class T{constructor(o,i,n,c,u,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=c,this.exports=u,this.subscriptions=t}}e.$wmc=T;class S extends T{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xmc=S;class l extends T{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ymc=l;class b extends T{constructor(o){super(!0,o,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(o,i,n,c){this.g=c,this.a=o,this.b=i,this.c=n,this.d=new A.$Vm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(c=>({id:c.identifier,reason:{startup:i,extensionId:c.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const u=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new b(u));return this.c.onExtensionActivationError(o.id,u,new N.$HG(o.id.value)),t}const n=[],c=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const u of c){if(this.m(u))continue;const t=this.d.get(u);if(t){n.push(t);continue}if(this.l(u)){n.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:o.reason}));continue}const g=this.a.getExtensionDescription(u);if(g){if(!g.main&&!g.browser)continue;n.push(this.j({id:g.identifier,reason:o.reason}));continue}const a=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${u}'`),w=this.k(o,i.displayName,[],new b(d));return this.c.onExtensionActivationError(i.identifier,d,new N.$HG(u)),w}return this.k(o,i.displayName,n,null)}k(o,i,n,c){const u=new s(o.id,i,o.reason,n,c,this.c,this.g);return this.d.set(o.id,u),u}l(o){return O.$pac.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$zmc=f,e.$zmc=f=Je([We(3,R.$5j)],f);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,c,u,t,g){this.c=o,this.d=i,this.f=n,this.g=c,this.h=u,this.j=t,this.k=g,this.a=new p.$xh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new b(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new b(i),this.b&&C.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};s=Je([We(6,R.$5j)],s)}),define(Se[238],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[239],Ie([1,0,194,14,32,100,74,29,21,238,102,105]),function(le,e,C,O,A,N,R,p,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=void 0;const l=p.$fo.as(R.$go.JSONContribution);class b{constructor(u,t,g){this.a=u,this.b=t,this.c=g}d(u,t){this.a({type:u,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(A.default.Error,u)}warn(u){this.d(A.default.Warning,u)}info(u){this.d(A.default.Info,u)}}e.$yG=b;class f{static a(u){const t=new m.$Um;for(let g=0,a=u.length;g<a;g++)t.add(u[g].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new f(t,[]);if(!t||!t.length)return new f([],u);const g=this.a(u),a=this.a(t),d=t.filter($=>!g.has($.description.identifier)),w=u.filter($=>!a.has($.description.identifier));return new f(d,w)}constructor(u,t){this.added=u,this.removed=t}}e.$zG=f;class s{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=f.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,O.$1)(u)}}}e.$AG=s;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$BG={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Sm},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:C.localize(42,null)},{label:"*",description:C.localize(43,null),body:"*"}]}},badges:{type:"array",description:C.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(45,null)},href:{type:"string",description:C.localize(46,null)},description:{type:"string",description:C.localize(47,null)}}}},markdown:{type:"string",description:C.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Wo}},extensionPack:{description:C.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Wo}},extensionKind:{description:C.localize(52,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(53,null)},{body:["workspace"],description:C.localize(54,null)},{body:["ui","workspace"],description:C.localize(55,null)},{body:["workspace","ui"],description:C.localize(56,null)},{body:[],description:C.localize(57,null)}]},capabilities:{description:C.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(61,null),C.localize(62,null),C.localize(63,null)]},description:{type:"string",markdownDescription:C.localize(64,null)}}},untrustedWorkspaces:{description:C.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(67,null),C.localize(68,null),C.localize(69,null)]},restrictedConfigurations:{description:C.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(71,null)}}}}},sponsor:{description:C.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(74,null),type:"string"},"vscode:uninstall":{description:C.localize(75,null),type:"string"}}},icon:{type:"string",description:C.localize(76,null)},l10n:{type:"string",description:C.localize(77,null)},pricing:{type:"string",markdownDescription:C.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new s(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,t),u.activationEventsGenerator&&S.$pG.register(u.extensionPoint,u.activationEventsGenerator),e.$BG.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,l.registerSchema(o,e.$BG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$CG=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};p.$fo.add(n.ExtensionsRegistry,new i),e.$DG=p.$fo.as(n.ExtensionsRegistry),l.registerSchema(o,e.$BG),l.registerSchema(T.$mk,{properties:{extensionEnabledApiProposals:{description:C.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Se[240],Ie([1,0,190,15,26,239,31,5]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gI=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var E;(function(l){function b(f,s,r){if(!f)return;const o=O.$$f(f.type)?f.type:void 0;if(!o||o.length===0){r.error(C.localize(3,null));return}const i=[];if(Array.isArray(f.required))for(const n of f.required)O.$$f(n)&&i.push(n);return{extensionId:s.value,taskType:o,required:i,properties:f.properties?A.$5n(f.properties):{},when:f.when?R.$wj.deserialize(f.when):void 0}}l.from=b})(E||(E={}));const T=N.$DG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,b)=>{for(const f of l)f.type&&b.push(`onTaskType:${f.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:m}});class S{constructor(){this.d=new p.$fe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,f)=>{T.setHandler((s,r)=>{this.c=void 0;try{for(const o of r.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of r.added){const i=o.value;for(const n of i){const c=E.from(n,o.description.identifier,o.collector);c&&(this.a[c.taskType]=c)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const f of this.all()){const s={type:"object",additionalProperties:!1};f.required.length>0&&(s.required=f.required.slice(0)),f.properties!==void 0?s.properties=A.$5n(f.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[f.taskType]},b.push(s)}this.c={oneOf:b}}return this.c}}e.$gI=new S}),define(Se[241],Ie([1,0,191,15,24,26,31,240]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$qI=e.JsonSchemaVersion=e.ExecutionEngine=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$kI=e.ShellQuoting=e.$jI=e.$iI=e.$hI=void 0,e.$hI="settings",e.$iI=new R.$Pj("taskRunning",!1,C.localize(0,null)),e.$jI=C.localize2(2,"Tasks");var m;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$kI="$customized",function(M){function z(G){if(!G)return M.Strong;switch(G.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=z}(m||(e.ShellQuoting=m={}));var E;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(T||(e.RevealKind=T={})),function(M){function z(G){switch(G.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=z}(T||(e.RevealKind=T={}));var S;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(M){function z(G){switch(G.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=z}(S||(e.RevealProblemKind=S={}));var l;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(l||(e.PanelKind=l={})),function(M){function z(G){switch(G.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=z}(l||(e.PanelKind=l={}));var b;(function(M){M.defaults={echo:!0,reveal:T.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var f;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(f||(e.RuntimeType=f={})),function(M){function z(ie){switch(ie.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=z;function G(ie){switch(ie){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=G}(f||(e.RuntimeType=f={}));var s;(function(M){function z(G){return O.$$f(G)?G:G.value}M.value=z})(s||(e.CommandString=s={}));var r;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function z(ie){return ie===M.Clean._id||ie===M.Build._id||ie===M.Rebuild._id||ie===M.Test._id}M.is=z;function G(ie){if(ie!==void 0)return O.$$f(ie)?z(ie)?{_id:ie,isDefault:!1}:void 0:ie}M.from=G})(r||(e.TaskGroup=r={}));var o;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function z(G){switch(G){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=z})(i||(e.TaskSourceKind=i={}));var n;(function(M){M.parallel="parallel",M.sequence="sequence"})(n||(e.DependsOrder=n={}));var c;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var u;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(z,G,ie,de,ye,Ee){this._label="",this._id=z,G&&(this._label=G),ie&&(this.type=ie),this.runOptions=de,this.configurationProperties=ye,this._source=Ee}getDefinition(z){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,G=!1){if(z===void 0)return!1;if(O.$$f(z))return z===this._label||z===this.configurationProperties.identifier||G&&z===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$lI=t;class g extends t{constructor(z,G,ie,de,ye,Ee,me,ue){super(z,ie,void 0,me,ue,G),this.command={},this._source=G,this.hasDefinedMatchers=Ee,ye&&(this.command=ye)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let G;switch(this.command?this.command.runtime:void 0){case f.Shell:G="shell";break;case f.Process:G="process";break;case f.CustomExecution:G="customExecution";break;case void 0:G="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:G,_key:this._id,id:this._id}}}static is(z){return z instanceof g}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$hI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const z=this.d();if(!z)return;let G=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(G+=this._source.kind);const ie={type:e.$kI,folder:z,id:G};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$9g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new g(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$mI=g;class a extends t{constructor(z,G,ie,de,ye,Ee,me){super(z,ie,de,Ee,me,G),this._source=G,this.configures=ye}static is(z){return z instanceof a}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$9g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$hI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const z=this.d();if(!z)return;let G=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(G+=this._source.kind);const ie={type:e.$kI,folder:z,id:G};return JSON.stringify(ie)}}e.$nI=a;class d extends t{constructor(z,G,ie,de,ye,Ee,me,ue,Ce){super(z,ie,de,ue,Ce,G),this.defines=ye,this.hasDefinedMatchers=me,this.command=Ee,this.icon=Ce.icon,this.hide=Ce.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof d}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new d(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$oI=d;class w extends t{constructor(z,G,ie,de,ye,Ee){super(z,ie,de,ye,Ee,G),this._source=G}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new w(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$pI=w;var $;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})($||(e.ExecutionEngine=$={})),function(M){M._default=M.Terminal}($||(e.ExecutionEngine=$={}));var v;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class y{constructor(z){this.c=new Map;for(let G=0;G<z.length;G++)this.c.set(z[G].uri.toString(),G)}compare(z,G){const ie=z.getWorkspaceFolder(),de=G.getWorkspaceFolder();if(ie&&de){let ye=this.c.get(ie.uri.toString());ye=ye===void 0?0:ye+1;let Ee=this.c.get(de.uri.toString());return Ee=Ee===void 0?0:Ee+1,ye===Ee?z._label.localeCompare(G._label):ye-Ee}else return!ie&&de?-1:ie&&!de?1:0}}e.$qI=y;var h;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(h||(e.TaskEventKind=h={}));var D;(function(M){M.SingleRun="singleRun",M.Background="background"})(D||(e.TaskRunType=D={}));var k;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var I;(function(M){function z(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function G(ue,Ce,se){return{...z(ue),kind:"start",terminalId:Ce,resolvedVariables:se}}M.start=G;function ie(ue,Ce,se){return{...z(ue),kind:"processStarted",terminalId:Ce,processId:se}}M.processStarted=ie;function de(ue,Ce,se){return{...z(ue),kind:"processEnded",terminalId:Ce,exitCode:se}}M.processEnded=de;function ye(ue,Ce,se){return{...z(ue),kind:"terminated",exitReason:se,terminalId:Ce}}M.terminated=ye;function Ee(ue,Ce,se){return{...z(Ce),kind:ue,terminalId:se}}M.general=Ee;function me(){return{kind:"changed"}}M.changed=me})(I||(e.TaskEvent=I={}));var P;(function(M){function z(ie){const de=Object.keys(ie).sort();let ye="";for(const Ee of de){let me=ie[Ee];me instanceof Object?me=z(me):typeof me=="string"&&(me=me.replace(/,/g,",,")),ye+=Ee+","+me+","}return ye}function G(ie){const ye={_key:z(ie),type:ie.taskType};return Object.assign(ye,ie),ye}M.create=G})(P||(e.KeyedTaskIdentifier=P={}));var V;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var W;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var q;(function(M){function z(G,ie){const de=p.$gI.get(G.type);if(de===void 0){const ue=N.$5n(G);return delete ue._key,P.create(ue)}const ye=Object.create(null);ye.type=de.taskType;const Ee=new Set;de.required.forEach(ue=>Ee.add(ue));const me=de.properties;for(const ue of Object.keys(me)){const Ce=G[ue];if(Ce!=null)ye[ue]=Ce;else if(Ee.has(ue)){const se=me[ue];if(se.default!==void 0)ye[ue]=N.$5n(se.default);else switch(se.type){case"boolean":ye[ue]=!1;break;case"number":case"integer":ye[ue]=0;break;case"string":ye[ue]="";break;default:ie.error(C.localize(1,null,JSON.stringify(G,void 0,0),ue));return}}}return P.create(ye)}M.createTaskIdentifier=z})(q||(e.TaskDefinition=q={}))}),define(Se[242],Ie([1,0,14]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=e.$tac=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,p)=>{this.b=R,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,C.$1)(R))}then(R,p){return this.j().then(R,p)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$tac=O;class A extends O{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$uac=A}),define(Se[34],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Bw=void 0,e.$Cw=A,e.$Dw=N;class C{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++C.count}}e.$Bw=C;const O=[];function A(p){const m=new C(p);return O[m.nid]=m,m}function N(p){return O[p].sid}class R{constructor(m){this.value=m}}e.$Ew=R}),define(Se[4],Ie([1,0,34]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$gM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var A;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput",s[s.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var N;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var R;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var p;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var m;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var E;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output",s[s.Hybrid=3]="Hybrid"})(T||(e.CandidatePortSource=T={}));class S{static{this.a=0}static mixin(r){return r._id=S.a++,r}}e.$gM=S;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var b;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var f;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$hM={MainThreadAuthentication:(0,C.$Cw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$Cw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,C.$Cw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,C.$Cw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,C.$Cw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$Cw)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$Cw)("MainThreadClipboard"),MainThreadCommands:(0,C.$Cw)("MainThreadCommands"),MainThreadComments:(0,C.$Cw)("MainThreadComments"),MainThreadConfiguration:(0,C.$Cw)("MainThreadConfiguration"),MainThreadConsole:(0,C.$Cw)("MainThreadConsole"),MainThreadDebugService:(0,C.$Cw)("MainThreadDebugService"),MainThreadDecorations:(0,C.$Cw)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$Cw)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$Cw)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$Cw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$Cw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$Cw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$Cw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$Cw)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$Cw)("MainThreadErrors"),MainThreadTreeViews:(0,C.$Cw)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$Cw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$Cw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$Cw)("MainThreadLanguages"),MainThreadLogger:(0,C.$Cw)("MainThreadLogger"),MainThreadMessageService:(0,C.$Cw)("MainThreadMessageService"),MainThreadOutputService:(0,C.$Cw)("MainThreadOutputService"),MainThreadProgress:(0,C.$Cw)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$Cw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$Cw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$Cw)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$Cw)("MainThreadSecretState"),MainThreadStorage:(0,C.$Cw)("MainThreadStorage"),MainThreadSpeech:(0,C.$Cw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$Cw)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$Cw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,C.$Cw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,C.$Cw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$Cw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$Cw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$Cw)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$Cw)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$Cw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$Cw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$Cw)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$Cw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$Cw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$Cw)("MainThreadExtensionService"),MainThreadSCM:(0,C.$Cw)("MainThreadSCM"),MainThreadSearch:(0,C.$Cw)("MainThreadSearch"),MainThreadShare:(0,C.$Cw)("MainThreadShare"),MainThreadTask:(0,C.$Cw)("MainThreadTask"),MainThreadWindow:(0,C.$Cw)("MainThreadWindow"),MainThreadLabelService:(0,C.$Cw)("MainThreadLabelService"),MainThreadNotebook:(0,C.$Cw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$Cw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$Cw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$Cw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$Cw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$Cw)("MainThreadInteractive"),MainThreadTheming:(0,C.$Cw)("MainThreadTheming"),MainThreadTunnelService:(0,C.$Cw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$Cw)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$Cw)("MainThreadTimeline"),MainThreadTesting:(0,C.$Cw)("MainThreadTesting"),MainThreadLocalization:(0,C.$Cw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$Cw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$Cw)("MainThreadAiEmbeddingVector")},e.$iM={ExtHostCommands:(0,C.$Cw)("ExtHostCommands"),ExtHostConfiguration:(0,C.$Cw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$Cw)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$Cw)("ExtHostDebugService"),ExtHostDecorations:(0,C.$Cw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$Cw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$Cw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$Cw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$Cw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$Cw)("ExtHostEditors"),ExtHostTreeViews:(0,C.$Cw)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$Cw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$Cw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$Cw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$Cw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$Cw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$Cw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$Cw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$Cw)("ExtHostStatusBar"),ExtHostShare:(0,C.$Cw)("ExtHostShare"),ExtHostExtensionService:(0,C.$Cw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$Cw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$Cw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,C.$Cw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,C.$Cw)("ExtHostSCM"),ExtHostSearch:(0,C.$Cw)("ExtHostSearch"),ExtHostTask:(0,C.$Cw)("ExtHostTask"),ExtHostWorkspace:(0,C.$Cw)("ExtHostWorkspace"),ExtHostWindow:(0,C.$Cw)("ExtHostWindow"),ExtHostWebviews:(0,C.$Cw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$Cw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$Cw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$Cw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$Cw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$Cw)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$Cw)("ExtHostProgress"),ExtHostComments:(0,C.$Cw)("ExtHostComments"),ExtHostSecretState:(0,C.$Cw)("ExtHostSecretState"),ExtHostStorage:(0,C.$Cw)("ExtHostStorage"),ExtHostUrls:(0,C.$Cw)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$Cw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$Cw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$Cw)("ExtHostOutputService"),ExtHostLabelService:(0,C.$Cw)("ExtHostLabelService"),ExtHostNotebook:(0,C.$Cw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$Cw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$Cw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$Cw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$Cw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$Cw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$Cw)("ExtHostInteractive"),ExtHostChatAgents2:(0,C.$Cw)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$Cw)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$Cw)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$Cw)("ExtHostSpeech"),ExtHostEmbeddings:(0,C.$Cw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,C.$Cw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$Cw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$Cw)("ExtHostTheming"),ExtHostTunnelService:(0,C.$Cw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$Cw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$Cw)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$Cw)("ExtHostTimeline"),ExtHostTesting:(0,C.$Cw)("ExtHostTesting"),ExtHostTelemetry:(0,C.$Cw)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$Cw)("ExtHostLocalization")}}),define(Se[80],Ie([1,0,3,12,4,17]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=e.$Tlc=void 0,e.$Tlc=(0,C.$yi)("IExtHostApiDeprecationService");let R=class{constructor(m,E){this.c=E,this.a=new Set,this.b=m.getProxy(A.$hM.MainThreadTelemetry)}report(m,E,T){const S=this.d(m,E);this.a.has(S)||(this.a.add(S),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:m}))}d(m,E){return`${m}-${E.identifier.value}`}};e.$Ulc=R,e.$Ulc=R=Je([We(0,N.$LO),We(1,O.$5j)],R),e.$Vlc=Object.freeze(new class{report(p,m,E){}})}),define(Se[243],Ie([1,0,4]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;class O{constructor(N){const R=N.getProxy(C.$hM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(p){return R.$writeText(p)}})}}e.$9lc=O}),define(Se[244],Ie([1,0,26,4,27,17]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=void 0;let R=class{constructor(T,S){this.a=T.getProxy(O.$hM.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,S){const l=this,b=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){l.e(T,S,b,arguments)}})}e(T,S,l,b){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:m(b,this.b)}),this.c&&this.f(T,l,b)}};e.$3nc=R,e.$3nc=R=Je([We(0,N.$LO),We(1,A.$2O)],R);const p=1e5;function m(E,T){const S=[];if(E.length)for(let l=0;l<E.length;l++){let b=E[l];if(typeof b>"u")b="undefined";else if(b instanceof Error){const f=b;f.stack?b=f.stack:b=f.toString()}S.push(b)}if(T){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,C.$0n)(S);return l.length>p?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Se[245],Ie([1,0,2,4,25]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class N{constructor(p){this.a=p.getProxy(O.$hM.MainThreadDialogs)}showOpenDialog(p,m){return m?.allowUIResources&&(0,A.$KG)(p,"showLocal"),this.a.$showOpenDialog(m).then(E=>E?E.map(T=>C.URI.revive(T)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(m=>m?C.URI.revive(m):void 0)}}e.$6mc=N}),define(Se[246],Ie([1,0,20,5,6,4]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=void 0;class R{constructor(m){this.b=new Map,this.c=new O.$fe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=m.getProxy(N.$hM.MainThreadEmbeddings)}registerEmbeddingsProvider(m,E,T){if(this.d.has(E))throw new Error("An embeddings provider for this model is already registered");const S=this.e++;return this.a.$registerEmbeddingProvider(S,E),this.b.set(S,{id:E,provider:T}),(0,A.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(S),this.b.delete(S)})}async computeEmbeddings(m,E,T){T??=C.CancellationToken.None;let S=!1;typeof E=="string"&&(E=[E],S=!0);const l=await this.a.$computeEmbeddings(m,E,T);if(l.length!==E.length)throw new Error;if(S){if(l.length!==1)throw new Error;return l[0]}return l}async $provideEmbeddings(m,E,T){const S=this.b.get(m);if(!S)return[];const l=await S.provider.provideEmbeddings(E,T);return l||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(m){this.d=new Set(m),this.c.fire()}}e.$9mc=R}),define(Se[247],Ie([1,0,6,4]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;class A{constructor(R){this.b=0,this.a=R.getProxy(O.$hM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,R),(0,C.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$nnc=A}),define(Se[81],Ie([1,0,23,13,2,3,12,4,27,17]),function(le,e,C,O,A,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=e.$Nmc=void 0;let T=class{constructor(l,b,f){this.f=f,this.d=new Map,this.a=b.getProxy(p.$hM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===C.$g}getMessage(l,b){const{message:f,args:s,comment:r}=b;if(this.c)return(0,O.$$e)(f,s??{});let o=f;r&&r.length>0&&(o+=`/${Array.isArray(r)?r.join(""):r}`);const i=this.d.get(l)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$$e)(i??f,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let b;const f=await this.g(l);if(!f){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(f),r=JSON.parse(s);b=l.isBuiltin?r.contents?.bundle:r}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${f}: ${s.message}`);return}b&&this.d.set(l.identifier.value,{contents:b,uri:f})}async g(l){if(l.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return A.URI.revive(b)}return l.l10n?A.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Nmc=T,e.$Nmc=T=Je([We(0,m.$2O),We(1,E.$LO),We(2,R.$5j)],T),e.$Omc=(0,N.$yi)("IExtHostLocalizationService")}),define(Se[248],Ie([1,0,12,4,27,17,2,49]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=void 0;let m=class extends C.$dk{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map(b=>(0,p.$8h)(b))),this.r=S.getProxy(O.$hM.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(R.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,b){return new E(this.r,S,l,b)}};e.$2nc=m,e.$2nc=m=Je([We(0,N.$LO),We(1,A.$2O)],m);class E extends C.$$j{constructor(S,l,b,f){super(f?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(l,f).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const b=[[S,l]];this.m?this.u(b):this.n.push(...b)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Se[82],Ie([1,0,4,3,6,17,22]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=void 0,e.$Pmc=(0,O.$yi)("IExtHostManagedSockets");let p=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(C.$hM.MainThreadManagedSockets)}setFactory(S,l){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,b=await this.c.makeConnection(),f=new A.$Tc;return this.d.set(l,new E(l,b,f)),f.add((0,A.$Sc)(()=>this.d.delete(l))),f.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),f.dispose()})),f.add(b.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),f.dispose()})),f.add(b.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,R.$He.wrap(s)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$Qmc=p,e.$Qmc=p=Je([We(0,N.$LO)],p);class m{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class E extends A.$Uc{constructor(S,l,b){super(),this.socketId=S,this.actual=l,this.B(b)}}}),define(Se[249],Ie([1,0,4,12,25]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;function N(p){return p&&p.title}let R=class{constructor(m,E){this.b=E,this.a=m.getProxy(C.$hM.MainThreadMessageService)}showMessage(m,E,T,S,l){const b={source:{identifier:m.identifier,label:m.displayName||m.name}};let f;typeof S=="string"||N(S)?f=[S,...l]:(b.modal=S?.modal,b.useCustom=S?.useCustom,b.detail=S?.detail,f=l),b.useCustom&&(0,A.$KG)(m,"resolvers");const s=[];let r=!1;for(let o=0;o<f.length;o++){const i=f[o];if(typeof i=="string")s.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:c}=i;s.push({title:n,isCloseAffordance:!!c,handle:o}),c&&(r?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,i):r=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,i)}return this.a.$showMessage(E,T,b,s).then(o=>{if(typeof o=="number")return f[o]})}};e.$pnc=R,e.$pnc=R=Je([We(1,O.$5j)],R)}),define(Se[250],Ie([1,0,6,15,2,25,4]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=void 0;class p{constructor(E){this.b=new Map,this.a=E.getProxy(R.$hM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,T,S){if((0,N.$KG)(E,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,S),this.a.$registerProfileContentHandler(T,S.name,S.description,E.identifier.value),(0,C.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,S,l){const b=this.b.get(E);if(!b)throw new Error(`Unknown handler with id: ${E}`);return b.saveProfile(T,S,l)}async $readProfile(E,T,S){const l=this.b.get(E);if(!l)throw new Error(`Unknown handler with id: ${E}`);return l.readProfile((0,O.$$f)(T)?T:A.URI.revive(T),S)}}e.$ync=p}),define(Se[83],Ie([1,0,4,5,3]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=e.$Kmc=void 0;class N{constructor(p){this.b=new O.$fe,this.onDidChangePassword=this.b.event,this.a=p.getProxy(C.$hM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,m){return this.a.$getPassword(p,m)}store(p,m,E){return this.a.$setPassword(p,m,E)}delete(p,m){return this.a.$deletePassword(p,m)}}e.$Kmc=N,e.$Lmc=(0,A.$yi)("IExtHostSecretState")}),define(Se[251],Ie([1,0,20,6,4]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=void 0;class N{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.f=new Map,this.b=p.getProxy(A.$hM.MainThreadSpeech)}async $createSpeechToTextSession(p,m,E){const T=this.c.get(p);if(!T)return;const S=new O.$Tc,l=new C.$qe;this.d.set(m,l);const b=await T.provideSpeechToTextSession(l.token,E?{language:E}:void 0);b&&(S.add(b.onDidChange(f=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,f)})),S.add(l.token.onCancellationRequested(()=>S.dispose())))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createTextToSpeechSession(p,m){const E=this.c.get(p);if(!E)return;const T=new O.$Tc,S=new C.$qe;this.d.set(m,S);const l=await E.provideTextToSpeechSession(S.token);l&&(this.f.set(m,l),T.add(l.onDidChange(b=>{S.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,b)})),T.add(S.token.onCancellationRequested(()=>T.dispose())))}async $synthesizeSpeech(p,m){this.f.get(p)?.synthesize(m)}async $cancelTextToSpeechSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p),this.f.delete(p)}async $createKeywordRecognitionSession(p,m){const E=this.c.get(p);if(!E)return;const T=new O.$Tc,S=new C.$qe;this.d.set(m,S);const l=await E.provideKeywordRecognitionSession(S.token);l&&(T.add(l.onDidChange(b=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,b)})),T.add(S.token.onCancellationRequested(()=>T.dispose())))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,m,E){const T=N.a++;return this.c.set(T,E),this.b.$registerProvider(T,m,{extension:p,displayName:p.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$Fnc=N}),define(Se[84],Ie([1,0,4,5,3]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=e.$Amc=void 0;class N{constructor(p,m){this.c=m,this.b=new O.$fe,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(C.$hM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,m){this.a.$registerExtensionStorageKeysToSync(p,m)}async initializeExtensionStorage(p,m,E){const T=await this.a.$initializeExtensionStorage(p,m);let S;return T&&(S=this.d(p,m,T)),S||E}setValue(p,m,E){return this.a.$setValue(p,m,E)}$acceptValue(p,m,E){const T=this.d(p,m,E);T&&this.b.fire({shared:p,key:m,value:T})}d(p,m,E){try{return JSON.parse(E)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${p}): ${T}`)}}}e.$Amc=N,e.$Bmc=(0,A.$yi)("IExtHostStorage")}),define(Se[252],Ie([1,0,6,16,2,4]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=void 0;class R{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(N.$hM.MainThreadUriOpeners)}registerExternalUriOpener(m,E,T,S){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const l=S.schemes.find(b=>!R.a.has(b));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(E,T),this.b.$registerUriOpener(E,S.schemes,m,S.label),(0,C.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(m,E,T){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener with id: ${m}`);const l=A.URI.revive(E);return S.canOpenExternalUri(l,T)}async $openUri(m,E,T){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener id: '${m}'`);return S.openExternalUri(A.URI.revive(E.resolvedUri),{sourceUri:A.URI.revive(E.sourceUri)},T)}}e.$Vnc=R}),define(Se[253],Ie([1,0,4,2,6,14,21]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;class p{static{this.a=0}constructor(E){this.c=new R.$Um,this.d=new Map,this.b=E.getProxy(C.$hM.MainThreadUrls)}registerUriHandler(E,T){const S=E.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=p.a++;return this.c.add(S),this.d.set(l,T),this.b.$registerUriHandler(l,S,E.displayName||E.name),(0,A.$Sc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(E,T){const S=this.d.get(E);if(!S)return Promise.resolve(void 0);try{S.handleUri(O.URI.revive(T))}catch(l){(0,N.$1)(l)}return Promise.resolve(void 0)}async createAppUri(E){return O.URI.revive(await this.b.$createAppUri(E))}}e.$Wnc=p}),define(Se[64],Ie([1,0,5,6,16,26,2,197,221,78,4]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=e.$lmc=void 0,e.$mmc=l,e.$omc=s,e.$pmc=r;class S{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,u,t,g,a,d,w){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new C.$fe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$fe,this._onDidDispose=this.#h.event,this.#e=c,this.#t=u,this.#o=t,this.#n=g,this.#s=a,this.#r=d,this.#l=l(d),this.#d=b(d),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,E.$$Ab)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===A.Schemas.https||c.scheme===A.Schemas.http){let u=c.toString();return u.endsWith("/")||(u+="/"),u+" "+E.$0Ab}return E.$0Ab}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),N.$9n(this.#o,c)||this.#t.$setOptions(this.#e,r(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const u=(0,m.$8rb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const u=this.#r.extensionLocation?.scheme===A.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,a,d,w,$,v)=>{const y=R.URI.from({scheme:w||"file",path:decodeURIComponent($)}),h=(0,E.$$Ab)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(g,a,d,w,$,v)=>{const y=R.URI.from({scheme:w||"file",path:decodeURIComponent($)}),h=(0,E.$$Ab)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`})}}e.$lmc=S;function l(n){try{const c=(0,p.$Lp)((0,p.$Kp)(n.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function b(n){try{const c=(0,p.$Lp)((0,p.$Kp)(n.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class f extends O.$Uc{constructor(c,u,t,g,a){super(),this.c=u,this.f=t,this.g=g,this.h=a,this.b=new Map,this.a=c.getProxy(T.$hM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,u,t){const g=this.j(c);if(g){const{message:a}=(0,m.$9rb)(u,t.value);g._onMessageEmitter.fire(a)}}$onMissingCsp(c,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,u,t){const g=new S(c,this.a,o(u),this.c,this.f,t,this.h);this.b.set(c,g);const a=g._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return g}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$nmc=f;function s(n){return{id:n.identifier,location:n.extensionLocation}}function r(n,c,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||i(n,c)}}function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(c=>R.URI.from(c))}}function i(n,c){return[...(c?.getWorkspaceFolders()||[]).map(u=>u.uri),n.extensionLocation]}}),define(Se[111],Ie([1,0,5,16,13,2,3,17,4]),function(le,e,C,O,A,N,R,p,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=e.$Ync=void 0;let T=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new C.$fe,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=l.getProxy(m.$hM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:f})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,b){b!==this.d[l]&&(this.d={...this.d,[l]:b},this.c.fire(this.d))}openUri(l,b){let f;if(typeof l=="string"){f=l;try{l=N.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,A.$9e)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,f,b)}async asExternalUri(l,b){if((0,A.$9e)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(l,b);return N.URI.from(f)}};e.$Ync=T,e.$Ync=T=E=Je([We(0,p.$LO)],T),e.$Znc=(0,R.$yi)("IExtHostWindow")}),define(Se[254],Ie([1,0,244,27,17]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=void 0;let N=class extends C.$3nc{constructor(p,m){super(p,m)}f(p,m,E){m.apply(console,E)}};e.$$pc=N,e.$$pc=N=Je([We(0,A.$LO),We(1,O.$2O)],N)}),define(Se[255],Ie([1,0,11,22,20,14,5,6,150,242,34]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=e.ResponsiveState=e.RequestInitiator=void 0,e.$vac=r,e.$wac=o;function l(k,I){try{return JSON.stringify(k,I)}catch{return"null"}}const b="$$ref$$",f={[b]:-1};class s{constructor(I,P){this.jsonString=I,this.referencedBuffers=P}}function r(k,I=null,P=!1){const V=[];return{jsonString:(P?l:JSON.stringify)(k,(q,M)=>{if(typeof M>"u")return f;if(typeof M=="object"){if(M instanceof O.$He){const z=V.push(M)-1;return{[b]:z}}if(I)return I(q,M)}return M}),referencedBuffers:V}}function o(k,I,P){return JSON.parse(k,(V,W)=>{if(W){const q=W[b];if(typeof q=="number")return I[q];if(P&&W.$mid===1)return P.transformIncoming(W)}return W})}function i(k,I){return JSON.stringify(k,I)}function n(k){return k?(I,P)=>P&&P.$mid===1?k.transformOutgoing(P):P:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var u;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},g=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends p.$Uc{static{S=g}static{this.a=3*1e3}constructor(I,P=null,V=null){super(),this[S]=!0,this.b=this.B(new R.$fe),this.onDidChangeResponsiveState=this.b.event,this.c=I,this.f=P,this.g=V,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,q=T.$Bw.count;W<q;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$Kh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(I=>{const P=this.w[I];delete this.w[I],P.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(I){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(I){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(I){this.y!==I&&(this.y=I,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(I){return this.g?(0,m.$Dn)(I,this.g):I}getProxy(I){const{nid:P,sid:V}=I;return this.s[P]||(this.s[P]=this.J(P,V)),this.s[P]}J(I,P){const V={get:(W,q)=>(typeof q=="string"&&!W[q]&&q.charCodeAt(0)===36&&(W[q]=(...M)=>this.U(I,q,M)),q===a?P:W[q])};return new Proxy(Object.create(null),V)}set(I,P){return this.m[I.nid]=P,P}assertRegistered(I){for(let P=0,V=I.length;P<V;P++){const W=I[P];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(I){if(this.j)return;const P=I.byteLength,V=$.read(I,0),W=V.readUInt8(),q=V.readUInt32();switch(W){case 1:case 2:{let{rpcId:M,method:z,args:G}=y.deserializeRequestJSONArgs(V);this.g&&(G=(0,m.$Dn)(G,this.g)),this.M(P,q,M,z,G,W===2);break}case 3:case 4:{let{rpcId:M,method:z,args:G}=y.deserializeRequestMixedArgs(V);this.g&&(G=(0,m.$Dn)(G,this.g)),this.M(P,q,M,z,G,W===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let M=y.deserializeReplyOKJSON(V);this.g&&(M=(0,m.$Dn)(M,this.g)),this.O(P,q,M);break}case 10:{const M=y.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(P,q,M);break}case 8:{const M=y.deserializeReplyOKVSBuffer(V);this.O(P,q,M);break}case 11:{let M=y.deserializeReplyErrError(V);this.g&&(M=(0,m.$Dn)(M,this.g)),this.P(P,q,M);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(I)}}M(I,P,V,W,q,M){this.f?.logIncoming(I,P,1,`receiveRequest ${(0,T.$Dw)(V)}.${W}(`,q);const z=String(P);let G,ie;if(M){const ye=new A.$qe;q.push(ye.token),G=this.Q(V,W,q),ie=()=>ye.cancel()}else G=this.Q(V,W,q),ie=t;this.u[z]=ie;const de=y.serializeAcknowledged(P);this.f?.logOutgoing(de.byteLength,P,1,"ack"),this.c.send(de),G.then(ye=>{delete this.u[z];const Ee=y.serializeReplyOK(P,ye,this.h);this.f?.logOutgoing(Ee.byteLength,P,1,"reply:",ye),this.c.send(Ee)},ye=>{delete this.u[z];const Ee=y.serializeReplyErr(P,ye);this.f?.logOutgoing(Ee.byteLength,P,1,"replyErr:",ye),this.c.send(Ee)})}N(I,P){this.f?.logIncoming(I,P,1,"receiveCancel");const V=String(P);this.u[V]?.()}O(I,P,V){this.f?.logIncoming(I,P,0,"receiveReply:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W],q.resolveOk(V)}P(I,P,V){this.f?.logIncoming(I,P,0,"receiveReplyErr:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W];let M;V&&(V.$isError?(M=new Error,M.name=V.name,M.message=V.message,M.stack=V.stack):M=V),q.resolveErr(M)}Q(I,P,V){try{return Promise.resolve(this.S(I,P,V))}catch(W){return Promise.reject(W)}}S(I,P,V){const W=this.m[I];if(!W)throw new Error("Unknown actor "+(0,T.$Dw)(I));const q=W[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,T.$Dw)(I));return q.apply(W,V)}U(I,P,V){if(this.j)return new E.$uac;let W=null;if(V.length>0&&A.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(N.$6());const q=y.serializeRequestArguments(V,this.h),M=++this.t,z=String(M),G=new E.$tac,ie=new p.$Tc;W&&ie.add(W.onCancellationRequested(()=>{const ye=y.serializeCancel(M);this.f?.logOutgoing(ye.byteLength,M,0,"cancel"),this.c.send(y.serializeCancel(M))})),this.w[z]=new w(G,ie),this.F(M);const de=y.serializeRequest(M,I,P,q,!!W);return this.f?.logOutgoing(de.byteLength,M,0,`request: ${(0,T.$Dw)(I)}.${P}(`,V),this.c.send(de),G}}e.$xac=d;class w{constructor(I,P){this.a=I,this.b=P}resolveOk(I){this.a.resolveOk(I),this.b.dispose()}resolveErr(I){this.a.resolveErr(I),this.b.dispose()}}class ${static alloc(I,P,V){const W=new $(O.$He.alloc(V+1+4),0);return W.writeUInt8(I),W.writeUInt32(P),W}static read(I,P){return new $(I,P)}get buffer(){return this.a}constructor(I,P){this.a=I,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(I){this.a.writeUInt8(I,this.b),this.b+=1}readUInt8(){const I=this.a.readUInt8(this.b);return this.b+=1,I}writeUInt32(I){this.a.writeUInt32BE(I,this.b),this.b+=4}readUInt32(){const I=this.a.readUInt32BE(this.b);return this.b+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this.a.writeUInt8(I.byteLength,this.b),this.b+=1,this.a.set(I,this.b),this.b+=I.byteLength}readShortString(){const I=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+I).toString();return this.b+=I,V}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readLongString(){const I=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+I).toString();return this.b+=I,V}writeBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readVSBuffer(){const I=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+I);return this.b+=I,P}static sizeMixedArray(I){let P=0;P+=1;for(let V=0,W=I.length;V<W;V++){const q=I[V];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let M=0;M<q.buffers.length;++M)P+=this.sizeVSBuffer(q.buffers[M]);break;case 4:break}}return P}writeMixedArray(I){this.a.writeUInt8(I.length,this.b),this.b+=1;for(let P=0,V=I.length;P<V;P++){const W=I[P];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let q=0;q<W.buffers.length;++q)this.writeBuffer(W.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this.a.readUInt8(this.b);this.b+=1;const P=new Array(I);for(let V=0;V<I;V++)switch(this.readUInt8()){case 1:P[V]=this.readLongString();break;case 2:P[V]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),M=this.readLongString(),z=[];for(let G=0;G<q;++G)z.push(this.readVSBuffer());P[V]=new T.$Ew(o(M,z,null));break}case 4:P[V]=void 0;break}return P}}var v;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(v||(v={}));class y{static a(I){for(let P=0,V=I.length;P<V;P++)if(I[P]instanceof O.$He||I[P]instanceof T.$Ew||typeof I[P]>"u")return!0;return!1}static serializeRequestArguments(I,P){if(this.a(I)){const V=[];for(let W=0,q=I.length;W<q;W++){const M=I[W];if(M instanceof O.$He)V[W]={type:2,value:M};else if(typeof M>"u")V[W]={type:4};else if(M instanceof T.$Ew){const{jsonString:z,referencedBuffers:G}=r(M.value,P);V[W]={type:3,value:O.$He.fromString(z),buffers:G}}else V[W]={type:1,value:O.$He.fromString(i(M,P))}}return{type:1,args:V}}return{type:0,args:i(I,P)}}static serializeRequest(I,P,V,W,q){switch(W.type){case 0:return this.b(I,P,V,W.args,q);case 1:return this.c(I,P,V,W.args,q)}}static b(I,P,V,W,q){const M=O.$He.fromString(V),z=O.$He.fromString(W);let G=0;G+=$.sizeUInt8(),G+=$.sizeShortString(M),G+=$.sizeLongString(z);const ie=$.alloc(q?2:1,I,G);return ie.writeUInt8(P),ie.writeShortString(M),ie.writeLongString(z),ie.buffer}static deserializeRequestJSONArgs(I){const P=I.readUInt8(),V=I.readShortString(),W=I.readLongString();return{rpcId:P,method:V,args:JSON.parse(W)}}static c(I,P,V,W,q){const M=O.$He.fromString(V);let z=0;z+=$.sizeUInt8(),z+=$.sizeShortString(M),z+=$.sizeMixedArray(W);const G=$.alloc(q?4:3,I,z);return G.writeUInt8(P),G.writeShortString(M),G.writeMixedArray(W),G.buffer}static deserializeRequestMixedArgs(I){const P=I.readUInt8(),V=I.readShortString(),W=I.readMixedArray(),q=new Array(W.length);for(let M=0,z=W.length;M<z;M++){const G=W[M];typeof G=="string"?q[M]=JSON.parse(G):q[M]=G}return{rpcId:P,method:V,args:q}}static serializeAcknowledged(I){return $.alloc(5,I,0).buffer}static serializeCancel(I){return $.alloc(6,I,0).buffer}static serializeReplyOK(I,P,V){if(typeof P>"u")return this.d(I);if(P instanceof O.$He)return this.e(I,P);if(P instanceof T.$Ew){const{jsonString:W,referencedBuffers:q}=r(P.value,V,!0);return this.g(I,W,q)}else return this.f(I,l(P,V))}static d(I){return $.alloc(7,I,0).buffer}static e(I,P){let V=0;V+=$.sizeVSBuffer(P);const W=$.alloc(8,I,V);return W.writeVSBuffer(P),W.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static f(I,P){const V=O.$He.fromString(P);let W=0;W+=$.sizeLongString(V);const q=$.alloc(9,I,W);return q.writeLongString(V),q.buffer}static g(I,P,V){const W=O.$He.fromString(P);let q=0;q+=$.sizeUInt32,q+=$.sizeLongString(W);for(const z of V)q+=$.sizeVSBuffer(z);const M=$.alloc(10,I,q);M.writeUInt32(V.length),M.writeLongString(W);for(const z of V)M.writeBuffer(z);return M.buffer}static deserializeReplyOKJSON(I){const P=I.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(I,P){const V=I.readUInt32(),W=I.readLongString(),q=[];for(let M=0;M<V;++M)q.push(I.readVSBuffer());return new T.$Ew(o(W,q,P))}static serializeReplyErr(I,P){const V=P?l(N.$3(P),null):void 0;if(typeof V!="string")return this.h(I);const W=O.$He.fromString(V);let q=0;q+=$.sizeLongString(W);const M=$.alloc(11,I,q);return M.writeLongString(W),M.buffer}static deserializeReplyErrError(I){const P=I.readLongString();return JSON.parse(P)}static h(I){return $.alloc(12,I,0).buffer}}var h;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var D;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(D||(D={}))}),define(Se[256],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=void 0;const C=function(N){const R=p=>{globalThis.removeEventListener("message",R);const m=p.data;Object.defineProperties(globalThis,{postMessage:{value(E,T){m.postMessage(E,T)}},onmessage:{get(){return m.onmessage},set(E){m.onmessage=E}}}),m.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",R)}.toString();class O extends EventTarget{constructor(N,R,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${C})('${R}'))`,E=new Blob([m],{type:"application/javascript"}),T=URL.createObjectURL(E),S=new MessageChannel,l=T,b={type:"_newWorker",id:l,port:S.port2,url:T,options:p};N(b,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{N({type:"_terminateWorker",id:l}),URL.revokeObjectURL(T),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(f){S.port1.onmessage=f}},onmessageerror:{get(){return S.port1.onmessageerror},set(f){S.port1.onmessageerror=f}}}),S.port1.addEventListener("messageerror",f=>{const s=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(s)}),S.port1.addEventListener("message",f=>{const s=new MessageEvent("message",{data:f.data});this.dispatchEvent(s)}),S.port1.start()}}e.$aqc=O}),define(Se[257],Ie([1,0,22,28,16,56,3]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$UJ=void 0,e.$VJ=T,e.$WJ=S,e.$UJ=(0,R.$yi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${p.join("")}]+`),E=7;function T(b){if(b.scheme!==A.Schemas.vscodeNotebookCell)return;const f=b.fragment.indexOf("s");if(f<0)return;const s=parseInt(b.fragment.substring(0,f).replace(m,""),E),r=(0,C.$1e)(b.fragment.substring(f+1)).toString();if(!isNaN(s))return{handle:s,notebook:b.with({scheme:r,fragment:null})}}function S(b,f){const s=f.toString(E),o=`${s.length<p.length?p[s.length-1]:"z"}${s}s${(0,C.$2e)(C.$He.fromString(b.scheme),!0,!0)}`;return b.with({scheme:A.Schemas.vscodeNotebookCell,fragment:o})}class l{constructor(){this.a=new O.$Ac}getNotebook(f){if(f.scheme===A.Schemas.vscodeNotebookCell){const s=T(f);if(s){const r=this.a.get(s.notebook);if(r)return r}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$XJ=l,(0,N.$As)(e.$UJ,l,1)}),define(Se[85],Ie([1,0,22,37,42,70,16,19,23,31,257]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fK=e.$cK=e.CellStatusbarAlignment=e.$bK=e.NotebookEditorPriority=e.$$J=e.$0J=e.$8J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$7J=e.$6J=e.$5J=e.$4J=e.CellKind=e.$3J=e.$2J=e.$1J=void 0,e.$9J=g,e.$_J=d,e.$aK=w,e.$dK=y,e.$eK=D,e.$1J="workbench.editor.notebook",e.$2J="workbench.editor.notebookTextDiffEditor",e.$3J="workbench.editor.interactive";var S;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(S||(e.CellKind=S={})),e.$4J=["application/json","application/javascript","text/html","image/svg+xml",N.$Ts.latex,N.$Ts.markdown,"image/png","image/jpeg",N.$Ts.text],e.$5J=[N.$Ts.latex,N.$Ts.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$Ts.text],e.$6J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$7J="_notAvailable";var l;(function(G){G[G.Running=1]="Running",G[G.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var b;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var f;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var s;(function(G){G[G.WithHardKernelDependency=0]="WithHardKernelDependency",G[G.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",G[G.Pure=2]="Pure",G[G.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var r;(function(G){G.Always="always",G.Never="never",G.Optional="optional"})(r||(e.RendererMessagingSpec=r={}));var o;(function(G){G[G.ModelChange=1]="ModelChange",G[G.Move=2]="Move",G[G.ChangeCellLanguage=5]="ChangeCellLanguage",G[G.Initialize=6]="Initialize",G[G.ChangeCellMetadata=7]="ChangeCellMetadata",G[G.Output=8]="Output",G[G.OutputItem=9]="OutputItem",G[G.ChangeCellContent=10]="ChangeCellContent",G[G.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",G[G.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",G[G.ChangeCellMime=13]="ChangeCellMime",G[G.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(G){G[G.Handle=0]="Handle",G[G.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(G){G[G.Replace=1]="Replace",G[G.Output=2]="Output",G[G.Metadata=3]="Metadata",G[G.CellLanguage=4]="CellLanguage",G[G.DocumentMetadata=5]="DocumentMetadata",G[G.Move=6]="Move",G[G.OutputItems=7]="OutputItems",G[G.PartialMetadata=8]="PartialMetadata",G[G.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var c;(function(G){G.scheme=R.Schemas.vscodeNotebookCell;function ie(Ce,se){return(0,T.$WJ)(Ce,se)}G.generate=ie;function de(Ce){return(0,T.$VJ)(Ce)}G.parse=de;function ye(Ce,se){return Ce.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${se??""},${Ce.scheme!==R.Schemas.file?Ce.scheme:""}`})}G.generateCellOutputUri=ye;function Ee(Ce){if(Ce.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Ce.fragment);if(!se)return;const Oe=se[1]&&se[1]!==""?se[1]:void 0,ne=se[2];return{outputId:Oe,notebook:Ce.with({scheme:ne||R.Schemas.file,fragment:null})}}G.parseCellOutputUri=Ee;function me(Ce,se,Oe){return G.generate(Ce,se).with({scheme:Oe})}G.generateCellPropertyUri=me;function ue(Ce,se){if(Ce.scheme===se)return G.parse(Ce.with({scheme:G.scheme}))}G.parseCellPropertyUri=ue})(c||(e.CellUri=c={}));const u=G=>m.$i?G.replace(/\//g,"\\"):G;class t{constructor(ie=[],de=e.$4J){this.e=de,this.d=[...new Set(ie)].map(ye=>({pattern:ye,matches:O.$sk(u(ye))}))}sort(ie){const de=new Map(A.Iterable.map(ie,Ee=>[Ee,u(Ee)]));let ye=[];for(const{matches:Ee}of this.d)for(const[me,ue]of de)if(Ee(ue)){ye.push(me),de.delete(me);break}return de.size&&(ye=ye.concat([...de.keys()].sort((Ee,me)=>this.e.indexOf(Ee)-this.e.indexOf(me)))),ye}prioritize(ie,de){const ye=this.f(ie);if(ye===-1){this.d.unshift({pattern:ie,matches:O.$sk(u(ie))});return}const Ee=new Set(de.map(ue=>this.f(ue,ye)));Ee.delete(-1);const me=Array.from(Ee).sort();this.d.splice(ye+1,0,...me.map(ue=>this.d[ue]));for(let ue=me.length-1;ue>=0;ue--)this.d.splice(me[ue],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,de=this.d.length){const ye=u(ie);for(let Ee=0;Ee<de;Ee++)if(this.d[Ee].matches(ye))return Ee;return-1}}e.$8J=t;function g(G,ie,de,ye=(Ee,me)=>Ee===me){const Ee=[];function me(se,Oe,ne){if(Oe===0&&ne.length===0)return;const U=Ee[Ee.length-1];U&&U.start+U.deleteCount===se?(U.deleteCount+=Oe,U.toInsert.push(...ne)):Ee.push({start:se,deleteCount:Oe,toInsert:ne})}let ue=0,Ce=0;for(;;){if(ue===G.length){me(ue,0,ie.slice(Ce));break}if(Ce===ie.length){me(ue,G.length-ue,[]);break}const se=G[ue],Oe=ie[Ce];if(ye(se,Oe)){ue+=1,Ce+=1;continue}de(Oe)?(me(ue,1,[]),ue+=1):(me(ue,0,[Oe]),Ce+=1)}return Ee}e.$0J=new E.$Pj("notebookEditorCursorAtBoundary","none"),e.$$J=new E.$Pj("notebookEditorCursorAtLineBoundary","none");var a;(function(G){G.default="default",G.option="option"})(a||(e.NotebookEditorPriority=a={}));function d(G){const ie=G;return!!((typeof ie.include=="string"||O.$tk(ie.include))&&(typeof ie.exclude=="string"||O.$tk(ie.exclude)))}function w(G,ie,de){if(Array.isArray(G.viewType)&&G.viewType.indexOf(ie)>=0||G.viewType===ie)return!0;if(G.filenamePattern){const ye=d(G.filenamePattern)?G.filenamePattern.include:G.filenamePattern,Ee=d(G.filenamePattern)?G.filenamePattern.exclude:void 0;if(O.$rk(ye,(0,p.$nc)(de.fsPath).toLowerCase()))return!(Ee&&O.$rk(Ee,(0,p.$nc)(de.fsPath).toLowerCase()))}return!1}e.$bK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var $;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})($||(e.CellStatusbarAlignment=$={}));class v{static{this.d="notebook/"}static create(ie){return`${v.d}${ie}`}static parse(ie){if(ie.startsWith(v.d))return ie.substring(v.d.length)}}e.$cK=v;function y(G){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(G)}const h=new TextDecoder;function D(G){const ie=[];let de=!1;for(const ue of G)(ie.length===0||de)&&(ie.push(ue),de=!0);let ye=P(ie);const Ee=C.$He.concat(ie.map(ue=>C.$He.wrap(ue))),me=z(Ee);return ye=ye||me.byteLength!==Ee.byteLength,{data:me,didCompression:ye}}e.$fK="\x1B[A";const k=e.$fK.split("").map(G=>G.charCodeAt(0)),I=10;function P(G){let ie=!1;return G.forEach((de,ye)=>{if(ye===0||de.length<e.$fK.length)return;const Ee=G[ye-1],me=de.subarray(0,e.$fK.length);if(me[0]===k[0]&&me[1]===k[1]&&me[2]===k[2]){const ue=Ee.lastIndexOf(I);if(ue===-1)return;ie=!0,G[ye-1]=Ee.subarray(0,ue),G[ye]=de.subarray(e.$fK.length)}}),ie}function V(G){let ie=G;do G=ie,ie=G.replace(/[^\n]\x08/gm,"");while(ie.length<G.length);return G}function W(G){for(G=G.replace(/\r+\n/gm,`
`);G.search(/\r[^$]/g)>-1;){const ie=G.match(/^(.*)\r+/m)[1];let de=G.match(/\r+(.*)$/m)[1];de=de+ie.slice(de.length,ie.length),G=G.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,de)}return G}const q=8,M=13;function z(G){return!G.buffer.includes(q)&&!G.buffer.includes(M)?G:C.$He.fromString(W(V(h.decode(G.buffer))))}}),define(Se[7],Ie([1,0,18,14,55,28,70,13,15,2,33,21,38,104,85]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f){"use strict";var s,r,o,i,n,c,u,t,g,a,d,w,$,v,y,h,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$zO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$fO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$5N=e.$4N=e.$3N=e.$2N=e.$ZN=e.$YN=e.$XN=e.$WN=e.TestRunProfileKind=e.TestResultState=e.$VN=e.$UN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$TN=e.NotebookVariablesRequestKind=e.$SN=e.$RN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$QN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.ColorThemeKind=e.$KN=e.$JN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$IN=e.$HN=e.DebugConsoleMode=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$BN=e.$AN=e.FileChangeType=e.$zN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$yN=e.$xN=e.$wN=e.$vN=e.InlineCompletionTriggerKind=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$iN=e.ConfigurationTarget=e.$hN=e.$gN=e.$fN=e.$eN=e.DocumentPasteTriggerKind=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$0M=e.ViewBadge=e.ProgressLocation=e.$9M=e.$8M=e.TaskScope=e.ShellQuoting=e.$7M=e.$6M=e.$5M=e.TaskPanelKind=e.TaskRevealKind=e.$4M=e.TerminalLocation=e.$3M=e.$2M=e.$1M=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$ZM=e.$YM=e.$XM=e.$WM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$UM=e.$TM=e.$SM=e.$RM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$QM=e.$PM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.LanguageStatusSeverity=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.CodeActionTriggerKind=e.$DM=e.$CM=e.SymbolTag=e.SymbolKind=e.$BM=e.$AM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.DiagnosticSeverity=e.DiagnosticTag=e.$uM=e.$tM=e.FileEditType=e.$sM=e.$rM=e.$qM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$VM=Vt,e.$jN=Ae,e.$1N=vn;function k(j){return Object.assign(j,{apply:function(...te){if(te.length===0)return Reflect.construct(j,[]);{const De=te.length===1?[]:te[1];return Reflect.construct(j,De,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(j,[]);{const[De,...Ge]=te;return Reflect.construct(j,Ge,De.constructor)}}})}var I;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(I||(e.TerminalOutputAnchor=I={}));var P;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let V=s=class{static from(...F){let te=F;return new s(function(){if(te){for(const De of te)De&&typeof De.dispose=="function"&&De.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$jM=V,e.$jM=V=s=Je([k],V);let W=r=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ge=F[De];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ge=F[De];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(F){if(!F)return!1;if(F instanceof r)return!0;const{line:te,character:De}=F;return typeof te=="number"&&typeof De=="number"}static of(F){if(F instanceof r)return F;if(this.isPosition(F))return new r(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,O.$7)("line must be non-negative");if(te<0)throw(0,O.$7)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,O.$7)();let De;return typeof F>"u"?De=0:typeof F=="number"?De=F:(De=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),De===0&&te===0?this:new r(this.line+De,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,O.$7)();let De;return typeof F>"u"?De=this.line:typeof F=="number"?De=F:(De=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),De===this.line&&te===this.character?this:new r(De,te)}toJSON(){return{line:this.line,character:this.character}}};e.$kM=W,e.$kM=W=r=Je([k],W);let q=o=class{static isRange(F){return F instanceof o?!0:F?W.isPosition(F.start)&&W.isPosition(F.end):!1}static of(F){if(F instanceof o)return F;if(this.isRange(F))return new o(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,De,Ge){let Ye,lt;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"?(Ye=new W(F,te),lt=new W(De,Ge)):W.isPosition(F)&&W.isPosition(te)&&(Ye=W.of(F),lt=W.of(te)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(F){return o.isRange(F)?this.contains(F.start)&&this.contains(F.end):W.isPosition(F)?!(W.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=W.Max(F.start,this.c),De=W.Min(F.end,this.e);if(!te.isAfter(De))return new o(te,De)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=W.Min(F.start,this.c),De=W.Max(F.end,this.end);return new o(te,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,O.$7)();let De;return F?W.isPosition(F)?De=F:(De=F.start||this.start,te=F.end||this.end):De=this.start,De.isEqual(this.c)&&te.isEqual(this.end)?this:new o(De,te)}toJSON(){return[this.start,this.end]}};e.$lM=q,e.$lM=q=o=Je([k],q);let M=i=class extends q{static isSelection(F){return F instanceof i?!0:F?q.isRange(F)&&W.isPosition(F.anchor)&&W.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,De,Ge){let Ye,lt;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"?(Ye=new W(F,te),lt=new W(De,Ge)):W.isPosition(F)&&W.isPosition(te)&&(Ye=W.of(F),lt=W.of(te)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$mM=M,e.$mM=M=i=Je([k],M);const z=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,O.$7)("connectionToken")};class G{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,De){if(typeof F!="string"||F.length===0)throw(0,O.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,O.$7)("port");typeof De<"u"&&z(De),this.host=F,this.port=Math.round(te),this.connectionToken=De}}e.$nM=G;class ie{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&z(te)}}e.$oM=ie;class de extends Error{static NotAvailable(F,te){return new de(F,b.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new de(F,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=b.RemoteAuthorityResolverErrorCode.Unknown,De){super(F),this._message=F,this._code=te,this._detail=De,Object.setPrototypeOf(this,de.prototype)}}e.$pM=de;var ye;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var Ee;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(Ee||(e.EnvironmentVariableMutatorType=Ee={}));let me=n=class{static isTextEdit(F){return F instanceof n?!0:F?q.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new n(F,te)}static insert(F,te){return n.replace(new q(F,F),te)}static delete(F){return n.replace(F,"")}static setEndOfLine(F){const te=new n(new q(new W(0,0),new W(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!q.isRange(F))throw(0,O.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,O.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,O.$7)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$qM=me,e.$qM=me=n=Je([k],me);let ue=c=class{static isNotebookCellEdit(F){return F instanceof c?!0:F?gi.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new c(F,te)}static insertCells(F,te){return new c(new gi(F,F),te)}static deleteCells(F){return new c(F,[])}static updateCellMetadata(F,te){const De=new c(new gi(F,F),[]);return De.newCellMetadata=te,De}static updateNotebookMetadata(F){const te=new c(new gi(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$rM=ue,e.$rM=ue=c=Je([k],ue);class Ce{static isSnippetTextEdit(F){return F instanceof Ce?!0:F?q.isRange(F.range)&&ne.isSnippetString(F.snippet):!1}static replace(F,te){return new Ce(F,te)}static insert(F,te){return Ce.replace(new q(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$sM=Ce;var se;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,De,Ge){this.c.push({_type:1,from:F,to:te,options:De,metadata:Ge})}createFile(F,te,De){this.c.push({_type:1,from:void 0,to:F,options:te,metadata:De})}deleteFile(F,te,De){this.c.push({_type:1,from:F,to:void 0,options:te,metadata:De})}e(F,te,De){this.c.push({_type:3,metadata:De,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}f(F,te,De,Ge){const Ye=te.start,lt=te.end;(Ye!==lt||De.length>0)&&this.c.push({_type:5,uri:F,index:Ye,count:lt-Ye,cells:De,metadata:Ge})}g(F,te,De,Ge){this.c.push({_type:3,metadata:Ge,uri:F,edit:{editType:3,index:te,metadata:De}})}replace(F,te,De,Ge){this.c.push({_type:2,uri:F,edit:new me(te,De),metadata:Ge})}insert(F,te,De,Ge){this.replace(F,new q(te,te),De,Ge)}delete(F,te,De){this.replace(F,te,"",De)}has(F){return this.c.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const De of te){if(!De)continue;let Ge,Ye;Array.isArray(De)?(Ge=De[0],Ye=De[1]):Ge=De,ue.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(F,Ge.range.start,Ge.newCellMetadata,Ye):Ge.newNotebookMetadata?this.e(F,Ge.newNotebookMetadata,Ye):this.f(F,Ge.range,Ge.newCells,Ye):Ce.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:F,range:Ge.range,edit:Ge.snippet,metadata:Ye}):this.c.push({_type:2,uri:F,edit:Ge,metadata:Ye})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===F.toString()&&(this.c[De]=void 0);break}}(0,C.$Ib)(this.c)}}get(F){const te=[];for(const De of this.c)De._type===2&&De.uri.toString()===F.toString()&&te.push(De.edit);return te}entries(){const F=new N.$Ac;for(const te of this.c)if(te._type===2){let De=F.get(te.uri);De||(De=[te.uri,[]],F.set(te.uri,De)),De[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$tM=Oe,e.$tM=Oe=Je([k],Oe);let ne=u=class{static isSnippetString(F){return F instanceof u?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=u.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const De=new u;De.e=this.e,F(De),this.e=De.e,F=De.value}else F=u.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const De=F.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const De=new u;De.e=this.e,te(De),this.e=De.e,te=De.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$uM=ne,e.$uM=ne=u=Je([k],ne);var U;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var x;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let ve=t=class{static isLocation(F){return F instanceof t?!0:F?q.isRange(F.range)&&E.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(q.isRange(te))this.range=q.of(te);else if(W.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$vM=ve,e.$vM=ve=t=Je([k],ve);let Fe=class{static is(F){return F?typeof F.message=="string"&&F.location&&q.isRange(F.location.range)&&E.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$wM=Fe,e.$wM=Fe=Je([k],Fe);let ke=class{constructor(F,te,De=x.Error){if(!q.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=De}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,C.$ub)(F.tags,te.tags)&&(0,C.$ub)(F.relatedInformation,te.relatedInformation,Fe.isEqual)}};e.$xM=ke,e.$xM=ke=Je([k],ke);let we=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$yM=we,e.$yM=we=Je([k],we);let ge=class extends we{constructor(F,te,De,Ge){super(F,te),this.canIncreaseHover=De,this.canDecreaseHover=Ge}};e.$zM=ge,e.$zM=ge=Je([k],ge);var Q;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let he=class{constructor(F,te=Y.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$AM=he,e.$AM=he=Je([k],he);let ce=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$BM=ce,e.$BM=ce=Je([k],ce);var Ne;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ne||(e.SymbolKind=Ne={}));var fe;(function(j){j[j.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Pe=g=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,De,Ge,Ye){this.name=F,this.kind=te,this.containerName=Ye,typeof De=="string"&&(this.containerName=De),Ge instanceof ve?this.location=Ge:De instanceof q&&(this.location=new ve(Ge,De)),g.validate(this)}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};e.$CM=Pe,e.$CM=Pe=g=Je([k],Pe);let Me=a=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(a.validate)}constructor(F,te,De,Ge,Ye){this.name=F,this.detail=te,this.kind=De,this.range=Ge,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$DM=Me,e.$DM=Me=a=Je([k],Me);var je;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let B=class{constructor(F,te){this.title=F,this.kind=te}};e.$EM=B,e.$EM=B=Je([k],B);let L=class{static{d=this}static{this.c="."}constructor(F){this.value=F}append(F){return new d(this.value?this.value+d.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+d.c)}};e.$FM=L,e.$FM=L=d=Je([k],L),L.Empty=new L(""),L.QuickFix=L.Empty.append("quickfix"),L.Refactor=L.Empty.append("refactor"),L.RefactorExtract=L.Refactor.append("extract"),L.RefactorInline=L.Refactor.append("inline"),L.RefactorMove=L.Refactor.append("move"),L.RefactorRewrite=L.Refactor.append("rewrite"),L.Source=L.Empty.append("source"),L.SourceOrganizeImports=L.Source.append("organizeImports"),L.SourceFixAll=L.Source.append("fixAll"),L.Notebook=L.Empty.append("notebook");let K=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$GM=K,e.$GM=K=Je([k],K);class H{constructor(F,te,De,Ge,Ye,lt){this.kind=F,this.name=te,this.detail=De,this.uri=Ge,this.range=Ye,this.selectionRange=lt}}e.$HM=H;class ee{constructor(F,te){this.fromRanges=te,this.from=F}}e.$IM=ee;class re{constructor(F,te){this.fromRanges=te,this.to=F}}e.$JM=re;var Te;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Te||(e.LanguageStatusSeverity=Te={}));let Be=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$KM=Be,e.$KM=Be=Je([k],Be);let He=w=class{#e;static isMarkdownString(F){return F instanceof w?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new A.$Vk(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$LM=He,e.$LM=He=w=Je([k],He);let _e=class{constructor(F,te){this.label=F,this.documentation=te}};e.$MM=_e,e.$MM=_e=Je([k],_e);let xe=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$NM=xe,e.$NM=xe=Je([k],xe);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$OM=et,e.$OM=et=Je([k],et);var tt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let at=class{constructor(F){this.value=F}};e.$PM=at,e.$PM=at=Je([k],at);let gt=class{constructor(F,te,De){this.position=F,this.label=te,this.kind=De}};e.$QM=gt,e.$QM=gt=Je([k],gt);var Ue;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var rt;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(rt||(e.CompletionItemKind=rt={}));var Z;(function(j){j[j.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let X=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$RM=X,e.$RM=X=Je([k],X);let $e=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$SM=$e,e.$SM=$e=Je([k],$e);let Ke=class{constructor(F,te,De){this.insertText=F,this.range=te,this.command=De}};e.$TM=Ke,e.$TM=Ke=Je([k],Ke);let be=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$UM=be,e.$UM=be=Je([k],be);var st;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(st||(e.PartialAcceptTriggerKind=st={}));var dt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var Ct;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ct||(e.StatusBarAlignment=Ct={}));function Vt(j,F){return`${S.$Tm.toKey(j)}.${F}`}var Qt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var ii;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(ii||(e.TextDocumentSaveReason=ii={}));var Xt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Xt||(e.TextEditorRevealType=Xt={}));var Et;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Zt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var Yt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(j){function F(te){switch(te){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=F}(Et||(e.TextEditorSelectionChangeKind=Et={}));var Ze;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ze||(e.SyntaxTokenType=Ze={})),function(j){function F(te){switch(te){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=F}(Ze||(e.SyntaxTokenType=Ze={}));let si=class{constructor(F,te){if(te&&!E.URI.isUri(te))throw(0,O.$7)("target");if(!q.isRange(F)||F.isEmpty)throw(0,O.$7)("range");this.range=F,this.target=te}};e.$WM=si,e.$WM=si=Je([k],si);let Ht=class{constructor(F,te,De,Ge){this.red=F,this.green=te,this.blue=De,this.alpha=Ge}};e.$XM=Ht,e.$XM=Ht=Je([k],Ht);let ht=class{constructor(F,te){if(te&&!(te instanceof Ht))throw(0,O.$7)("color");if(!q.isRange(F)||F.isEmpty)throw(0,O.$7)("range");this.range=F,this.color=te}};e.$YM=ht,e.$YM=ht=Je([k],ht);let mt=class{constructor(F){if(!F||typeof F!="string")throw(0,O.$7)("label");this.label=F}};e.$ZM=mt,e.$ZM=mt=Je([k],mt);var xt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(xt||(e.ColorFormat=xt={}));var Gt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Gt||(e.SourceControlInputBoxValidationType=Gt={}));var Nt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Nt||(e.TerminalExitReason=Nt={}));var ft;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(ft||(e.TerminalShellExecutionCommandLineConfidence=ft={}));class Bt{constructor(F,te,De){if(this.startIndex=F,this.length=te,this.tooltip=De,typeof F!="number"||F<0)throw(0,O.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,O.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,O.$7)("tooltip")}}e.$1M=Bt;class _t{constructor(F){this.uri=F}}e.$2M=_t;class zt{constructor(F){this.terminalCommand=F}}e.$3M=zt;var Qe;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ui{constructor(F){if(this.options=F,typeof F!="object")throw(0,O.$7)("options")}}e.$4M=ui;var Jt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var Ut;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Ut||(e.TaskPanelKind=Ut={}));let wt=class{static{$=this}static{this.Clean=new $("clean","Clean")}static{this.Build=new $("build","Build")}static{this.Rebuild=new $("rebuild","Rebuild")}static{this.Test=new $("test","Test")}static from(F){switch(F){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,O.$7)("name");this.c=F}get id(){return this.c}};e.$5M=wt,e.$5M=wt=$=Je([k],wt);function jt(j){let F="";for(let te=0;te<j.length;te++)F+=j[te].replace(/,/g,",,")+",";return F}let At=class{constructor(F,te,De){if(typeof F!="string")throw(0,O.$7)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=De):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,O.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return jt(F)}};e.$6M=At,e.$6M=At=Je([k],At);let Rt=class{constructor(F,te,De){if(this.f=[],Array.isArray(te)){if(!F)throw(0,O.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,O.$7)("command");this.e=F,this.f=te,this.g=De}else{if(typeof F!="string")throw(0,O.$7)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,O.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,O.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return jt(F)}};e.$7M=Rt,e.$7M=Rt=Je([k],Rt);var ei;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ei||(e.ShellQuoting=ei={}));var Wt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Wt||(e.TaskScope=Wt={}));class oi{constructor(F){this.c=F}computeId(){return"customExecution"+(0,T.$Ug)()}set callback(F){this.c=F}get callback(){return this.c}}e.$8M=oi;let Ot=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,De,Ge,Ye,lt){this.k=!1,this.l=this.definition=F;let pt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=De,this.execution=Ge,pt=Ye,this.k=!0):te===Wt.Global||te===Wt.Workspace?(this.target=te,this.o=this.name=De,this.w=this.source=Ge,this.execution=Ye,pt=lt):(this.target=te,this.o=this.name=De,this.w=this.source=Ge,this.execution=Ye,pt=lt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof At?this.l={type:v.e,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:v.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:v.c,id:this.q.computeId()}:this.l={type:v.g,id:(0,T.$Ug)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,O.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(v.g===te||v.e===te||v.f===te||v.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$9M=Ot,e.$9M=Ot=v=Je([k],Ot);var qt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(qt||(e.ProgressLocation=qt={}));var Mt;(function(j){function F(te){const De=te;return(0,m.$cg)(De.value)?De.tooltip&&!(0,m.$$f)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}j.isViewBadge=F})(Mt||(e.ViewBadge=Mt={}));let St=y=class{static isTreeItem(F,te){const De=F;if(De.checkboxState!==void 0){const Ge=(0,m.$cg)(De.checkboxState)?De.checkboxState:(0,m.$ag)(De.checkboxState)&&(0,m.$cg)(De.checkboxState.state)?De.checkboxState.state:void 0,Ye=!(0,m.$cg)(De.checkboxState)&&(0,m.$ag)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Dt.Checked&&Ge!==Dt.Unchecked||Ye!==void 0&&!(0,m.$$f)(Ye))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(F instanceof y)return!0;if(De.label!==void 0&&!(0,m.$$f)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,m.$$f)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,m.$$f)(De.iconPath)&&!E.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,m.$$f)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,m.$$f)(Ge.light)&&!E.URI.isUri(Ge.light)&&!(0,m.$$f)(Ge.dark)&&!E.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,m.$$f)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!E.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,m.$$f)(De.tooltip)&&!(De.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<$t.None&&De.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,m.$$f)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(F,te=$t.None){this.collapsibleState=te,E.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$0M=St,e.$0M=St=y=Je([k],St);var $t;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var Dt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let ai=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$$M=ai,e.$$M=ai=Je([k],ai);class kt extends ai{}e.$_M=kt;class fi extends kt{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$aN=fi;class ni{constructor(F,te,De,Ge){this.name=F,this.uri=te,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$bN=ni;let $i=class{#e=new Map;constructor(F){for(const[te,De]of F??[]){const Ge=this.#e.get(this.#t(te));Ge?Ge.push(De):this.#e.set(this.#t(te),[De])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[De,Ge]of this.#e)for(const Ye of Ge)F.call(te,Ye,De,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const De of te)yield[F,De]}#t(F){return F.toLowerCase()}};e.$cN=$i,e.$cN=$i=Je([k],$i);let li=class{constructor(F,te,De){this.insertText=F,this.title=te,this.kind=De}};e.$dN=li,e.$dN=li=Je([k],li);var bi;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(bi||(e.DocumentPasteTriggerKind=bi={}));class It{static{this.c="."}constructor(F){this.value=F}append(...F){return new It((this.value?[this.value,...F]:F).join(It.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+It.c)}}e.$eN=It,It.Empty=new It("");class Ei{constructor(F,te,De){this.title=te,this.insertText=F,this.kind=De}}e.$fN=Ei;let ri=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$gN=ri,e.$gN=ri=Je([k],ri),ri.File=new ri("file"),ri.Folder=new ri("folder");let pe=class{constructor(F){this.id=F}};e.$hN=pe,e.$hN=pe=Je([k],pe);var Re;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Re||(e.ConfigurationTarget=Re={}));let ae=class{get base(){return this.c}set base(F){this.c=F,this.e=E.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!E.URI.isUri(F)&&!E.URI.isUri(F.uri)))throw(0,O.$7)("base");if(typeof te!="string")throw(0,O.$7)("pattern");typeof F=="string"?this.baseUri=E.URI.file(F):E.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$iN=ae,e.$iN=ae=Je([k],ae);const J=new WeakMap;function Ae(j,F){J.set(j,F)}let Ve=class{constructor(F,te,De,Ge,Ye){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=J.get(this)??(0,T.$Ug)()),this.c}};e.$kN=Ve,e.$kN=Ve=Je([k],Ve);let Xe=class extends Ve{constructor(F,te,De,Ge,Ye,lt){if(super(te,De,Ge,Ye,lt),F===null)throw(0,O.$7)("location");this.location=F}};e.$lN=Xe,e.$lN=Xe=Je([k],Xe);let qe=class extends Ve{constructor(F,te,De,Ge,Ye,lt){super(te,De,Ge,Ye,lt),this.functionName=F}};e.$mN=qe,e.$mN=qe=Je([k],qe);let ut=class extends Ve{constructor(F,te,De,Ge,Ye,lt,pt,Kt){if(super(Ge,Ye,lt,pt,Kt),!te)throw(0,O.$7)("dataId");this.label=F,this.dataId=te,this.canPersist=De}};e.$nN=ut,e.$nN=ut=Je([k],ut);let yt=class{constructor(F,te,De){this.command=F,this.args=te||[],this.options=De}};e.$oN=yt,e.$oN=yt=Je([k],yt);let Ft=class{constructor(F,te){this.port=F,this.host=te}};e.$pN=Ft,e.$pN=Ft=Je([k],Ft);let ct=class{constructor(F){this.path=F}};e.$qN=ct,e.$qN=ct=Je([k],ct);let Tt=class{constructor(F){this.implementation=F}};e.$rN=Tt,e.$rN=Tt=Je([k],Tt);class Lt{constructor(F,te,De){this.session=F,this.threadId=te,this.frameId=De}}e.$sN=Lt;class Di{constructor(F,te){this.session=F,this.threadId=te}}e.$tN=Di;let Ii=class{constructor(F,te){this.range=F,this.expression=te}};e.$uN=Ii,e.$uN=Ii=Je([k],Ii);var Ji;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let Oi=class{constructor(F,te){this.range=F,this.text=te}};e.$vN=Oi,e.$vN=Oi=Je([k],Oi);let Ti=class{constructor(F,te,De=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=De}};e.$wN=Ti,e.$wN=Ti=Je([k],Ti);let Ci=class{constructor(F,te){this.range=F,this.expression=te}};e.$xN=Ci,e.$xN=Ci=Je([k],Ci);let Ni=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$yN=Ni,e.$yN=Ni=Je([k],Ni);var Fi;(function(j){j[j.AIGenerated=1]="AIGenerated"})(Fi||(e.NewSymbolNameTag=Fi={}));var Qi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Qi||(e.NewSymbolNameTriggerKind=Qi={}));class Li{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$zN=Li;var Pi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Pi||(e.FileChangeType=Pi={}));let zi=h=class extends Error{static FileExists(F){return new h(F,l.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(F){return new h(F,l.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(F){return new h(F,l.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(F){return new h(F,l.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(F){return new h(F,l.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(F){return new h(F,l.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(F,te=l.FileSystemProviderErrorCode.Unknown,De){super(E.URI.isUri(F)?F.toString(!0):F),this.code=De?.name??"Unknown",(0,l.$hl)(this,te),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$AN=zi,e.$AN=zi=h=Je([k],zi);let Ui=class{constructor(F,te,De){this.start=F,this.end=te,this.kind=De}};e.$BN=Ui,e.$BN=Ui=Je([k],Ui);var vi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(vi||(e.FoldingRangeKind=vi={}));var Xi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Xi||(e.CommentThreadCollapsibleState=Xi={}));var Zi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Ai;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Ai||(e.CommentState=Ai={}));var Yi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Yi||(e.CommentThreadState=Yi={}));var ji;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(ji||(e.CommentThreadApplicability=ji={}));class dn{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$CN=dn;function xi(j){return typeof j>"u"||(0,m.$_f)(j)}class Bi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,De=F.tokenTypes.length;te<De;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,De=F.tokenModifiers.length;te<De;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,De,Ge,Ye){if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(F,te,De,Ge,Ye);if(q.isRange(F)&&typeof te=="string"&&xi(De))return this.o(F,te,De);throw(0,O.$7)()}o(F,te,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=F.start.line,Ye=F.start.character,lt=F.end.character-F.start.character,pt=this.k.get(te);let Kt=0;if(De)for(const ci of De){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const di=this.l.get(ci);Kt|=1<<di>>>0}this.q(Ge,Ye,lt,pt,Kt)}q(F,te,De,Ge,Ye){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const Kt=this.g.length/5|0;let ci=0,di=0;for(let mi=0;mi<Kt;mi++){let wi=this.g[5*mi],Hi=this.g[5*mi+1];wi===0?(wi=ci,Hi+=di):wi+=ci,this.g[5*mi]=wi,this.g[5*mi+1]=Hi,ci=wi,di=Hi}}let lt=F,pt=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&(pt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=pt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=Ye,this.c=F,this.e=te}static r(F){const te=[],De=F.length/5|0;for(let pt=0;pt<De;pt++)te[pt]=pt;te.sort((pt,Kt)=>{const ci=F[5*pt],di=F[5*Kt];if(ci===di){const mi=F[5*pt+1],wi=F[5*Kt+1];return mi-wi}return ci-di});const Ge=new Uint32Array(F.length);let Ye=0,lt=0;for(let pt=0;pt<De;pt++){const Kt=5*te[pt],ci=F[Kt+0],di=F[Kt+1],mi=F[Kt+2],wi=F[Kt+3],Hi=F[Kt+4],Ln=ci-Ye,wr=Ln===0?di-lt:di,Gi=5*pt;Ge[Gi+0]=Ln,Ge[Gi+1]=wr,Ge[Gi+2]=mi,Ge[Gi+3]=wi,Ge[Gi+4]=Hi,Ye=ci,lt=di}return Ge}build(F){return this.f?new pi(new Uint32Array(this.g),F):new pi(Bi.r(this.g),F)}}e.$DN=Bi;class pi{constructor(F,te){this.resultId=te,this.data=F}}e.$EN=pi;class fn{constructor(F,te,De){this.start=F,this.deleteCount=te,this.data=De}}e.$FN=fn;class gn{constructor(F,te){this.resultId=te,this.edits=F}}e.$GN=gn;var _i;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class Vi{constructor(F){this.name=F}}e.$HN=Vi;let Mi=class{static{this.Back={iconPath:new ri("arrow-left")}}constructor(){}};e.$IN=Mi,e.$IN=Mi=Je([k],Mi);var ze;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(ze||(e.QuickPickItemKind=ze={}));var hi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(hi||(e.InputBoxValidationSeverity=hi={}));var Wi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Wi||(e.ExtensionKind=Wi={}));class nt{static validate(F){if(typeof F.badge=="string"){let te=(0,p.$Jf)(F.badge,0);if(te<F.badge.length&&(te+=(0,p.$Jf)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!ri.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,De){this.badge=F,this.tooltip=te,this.color=De}}e.$JN=nt;let bt=class{constructor(F){this.kind=F}};e.$KN=bt,e.$KN=bt=Je([k],bt);var en;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class gi{static isNotebookRange(F){return F instanceof gi?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,O.$7)("start must be positive");if(te<0)throw(0,O.$7)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,De=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(De=F.end),te===this.c&&De===this.e?this:new gi(te,De)}}e.$LN=gi;class ki{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>ki.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,De,Ge,Ye,lt,pt){this.kind=F,this.value=te,this.languageId=De,this.mime=Ge,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=pt,ki.validate(this)}}e.$MN=ki;class mn{constructor(F){this.cells=F}}e.$NN=mn;class ti{static isNotebookCellOutputItem(F){return F instanceof ti?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return ti.json(te,"application/vnd.code.notebook.error")}static stdout(F){return ti.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ti.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new ti(F,te)}static#e=new TextEncoder;static text(F,te=R.$Ts.text){const De=ti.#e.encode(String(F));return new ti(De,te)}static json(F,te="text/x-json"){const De=JSON.stringify(F,void 0,"	");return ti.text(De,te)}constructor(F,te){this.data=F,this.mime=te;const De=(0,R.$Xs)(te,!0);if(!De)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$ON=ti;class Ri{static isNotebookCellOutput(F){return F instanceof Ri?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const De=new Set,Ge=new Set;for(let Ye=0;Ye<F.length;Ye++){const lt=F[Ye],pt=(0,R.$Xs)(lt.mime);if(!De.has(pt)||(0,f.$dK)(pt)){De.add(pt);continue}Ge.add(Ye),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?F:F.filter((Ye,lt)=>!Ge.has(lt))}constructor(F,te,De){this.items=Ri.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=De):(this.id=(0,T.$Ug)(),this.metadata=te??De)}}e.$PN=Ri;var tn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var qi;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(qi||(e.NotebookCellStatusBarAlignment=qi={}));var rn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class $n{constructor(F,te){this.text=F,this.alignment=te}}e.$QN=$n;var sn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(F,te=[]){this.uri=F,this.provides=(0,C.$2b)(te)}}e.$RN=pn;class wn{constructor(F){this.label=F}}e.$SN=wn;var an;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let Ki=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$TN=Ki,e.$TN=Ki=Je([k],Ki);var cn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var ln;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class _{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$UN=_;class oe{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$VN=oe;var Le;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Le||(e.TestResultState=Le={}));var ot;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ot||(e.TestRunProfileKind=ot={}));let vt=class{constructor(F=void 0,te=void 0,De=void 0,Ge=!1,Ye=!0){this.include=F,this.exclude=te,this.profile=De,this.continuous=Ge,this.preserveFocus=Ye}};e.$WN=vt,e.$WN=vt=Je([k],vt);let Pt=D=class{static diff(F,te,De){const Ge=new D(F);return Ge.expectedOutput=te,Ge.actualOutput=De,Ge}constructor(F){this.message=F}};e.$XN=Pt,e.$XN=Pt=D=Je([k],Pt);let Si=class{constructor(F){this.id=F}};e.$YN=Si,e.$YN=Si=Je([k],Si);class hn{constructor(F,te){this.covered=F,this.total=te,vn(this)}}e.$ZN=hn;function vn(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class bn{static fromDetails(F,te){const De=new hn(0,0),Ge=new hn(0,0),Ye=new hn(0,0);for(const pt of te)if("branches"in pt){De.total+=1,De.covered+=pt.executed?1:0;for(const Kt of pt.branches)Ge.total+=1,Ge.covered+=Kt.executed?1:0}else Ye.total+=1,Ye.covered+=pt.executed?1:0;const lt=new bn(F,De,Ge.total>0?Ge:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=te,lt}constructor(F,te,De,Ge,Ye){this.uri=F,this.statementCoverage=te,this.branchCoverage=De,this.declarationCoverage=Ge,this.testItem=Ye}}e.$2N=bn;class zn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De=[]){this.executed=F,this.location=te,this.branches=De}}e.$3N=zn;class Un{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.executed=F,this.location=te,this.label=De}}e.$4N=Un;class jn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.name=F,this.executed=te,this.location=De}}e.$5N=jn;var yn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(yn||(e.ExternalUriOpenerPriority=yn={}));var En;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(En||(e.WorkspaceTrustState=En={}));var Dn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Dn||(e.PortAutoForwardAction=Dn={}));class Bn{constructor(F,te,De,Ge,Ye,lt){this.kind=F,this.name=te,this.detail=De,this.uri=Ge,this.range=Ye,this.selectionRange=lt}}e.$6N=Bn;class Vn{constructor(F){this.uri=F}}e.$7N=Vn;class Wn{constructor(F,te){this.original=F,this.modified=te}}e.$8N=Wn;class qn{constructor(F,te,De,Ge){this.base=F,this.input1=te,this.input2=De,this.result=Ge}}e.$9N=qn;class Kn{constructor(F,te){this.uri=F,this.viewType=te}}e.$0N=Kn;class Hn{constructor(F){this.viewType=F}}e.$$N=Hn;class Gn{constructor(F,te){this.uri=F,this.notebookType=te}}e.$_N=Gn;class Jn{constructor(F,te,De){this.original=F,this.modified=te,this.notebookType=De}}e.$aO=Jn;class Qn{constructor(){}}e.$bO=Qn;class Xn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$cO=Xn;class Zn{constructor(){}}e.$dO=Zn;class Yn{constructor(F){this.textDiffs=F}}e.$eO=Yn;var kn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Sn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Sn||(e.ChatCopyKind=Sn={}));var In;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(In||(e.ChatVariableLevel=In={}));class xn{constructor(F,te){this.label=F,this.values=te}}e.$fO=xn;var Cn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(Cn||(e.InteractiveEditorResponseFeedbackKind=Cn={}));var Pn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Pn||(e.ChatResultFeedbackKind=Pn={}));class _n{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new He(F):F}}e.$gO=_n;class er{constructor(F,te){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new He(F):F,this.vulnerabilities=te}}e.$hO=er;class tr{constructor(F,te){this.participant=F,this.command=te}}e.$iO=tr;class ir{constructor(F,te,De){this.title=F,this.message=te,this.data=De}}e.$jO=ir;class nr{constructor(F,te){this.value=F,this.baseUri=te}}e.$kO=nr;class rr{constructor(F,te){this.value=F,this.title=te}}e.$lO=rr;class sr{constructor(F){this.value=F}}e.$mO=sr;class or{constructor(F,te){this.value=F,this.task=te}}e.$nO=or;class ar{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new He(F):F}}e.$oO=ar;class cr{constructor(F){this.value=F}}e.$pO=cr;class ur{constructor(F,te){this.value=F,this.iconPath=te}}e.$qO=ur;class lr{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$rO=lr;class hr{constructor(F,te,De,Ge){this.prompt=F,this.command=te,this.variables=De,this.participant=Ge}}e.$sO=hr;class dr{constructor(F,te,De,Ge){this.response=F,this.result=te,this.participant=De,this.command=Ge}}e.$tO=dr;var An;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(An||(e.ChatLocation=An={}));var Mn;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})(Mn||(e.LanguageModelChatMessageRole=Mn={}));class fr{constructor(F,te,De){this.role=F,this.content=te,this.name=De}}e.$uO=fr;class gr{constructor(F){this.content=F}}e.$vO=gr;class mr{constructor(F,te){this.content=F,this.name=te}}e.$wO=mr;class $r{constructor(F,te){this.content=F,this.name=te}}e.$xO=$r;class yi extends Error{static NotFound(F){return new yi(F,yi.NotFound.name)}static NoPermissions(F){return new yi(F,yi.NoPermissions.name)}static Blocked(F){return new yi(F,yi.Blocked.name)}constructor(F,te,De){super(F,{cause:De}),this.name="LanguageModelError",this.code=te??""}}e.$yO=yi;var Rn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Rn||(e.RelatedInformationType=Rn={}));var On;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(On||(e.SpeechToTextStatus=On={}));var Tn;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Tn||(e.TextToSpeechStatus=Tn={}));var Nn;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(Nn||(e.KeywordRecognitionStatus=Nn={}));class pr{constructor(F,te){this.text=F,this.range=te}}e.$zO=pr;var Fn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Fn||(e.InlineEditTriggerKind=Fn={}))}),define(Se[258],Ie([1,0,4,7]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=void 0;class A{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(C.$hM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,p,m){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(R);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(p,m)??[]}getRelatedInformation(R,p,m){return this.c.$getAiRelatedInformation(p,m)}registerRelatedInformationProvider(R,p,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiRelatedInformationProvider(E,p),new O.$jM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Slc=A}),define(Se[86],Ie([1,0,5,4,7,21,108,3,17]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=e.$4lc=void 0,e.$4lc=(0,p.$yi)("IExtHostAuthentication");let E=class{constructor(l){this.b=new Map,this.c=new C.$fe,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=l.getProxy(O.$hM.MainThreadAuthentication)}async getSession(l,b,f,s={}){const r=N.$Tm.toKey(l.identifier),o=[...f].sort().join(" ");return await this.d.getOrCreate(`${r} ${b} ${o}`,async()=>{await this.a.$ensureProvider(b);const i=l.displayName||l.name;return this.a.$getSession(b,f,r,i,s)})}async getSessions(l,b,f){const s=N.$Tm.toKey(l.identifier),r=[...f].sort().join(" ");return await this.f.getOrCreate(`${s} ${r}`,async()=>{await this.a.$ensureProvider(b);const o=l.displayName||l.name;return this.a.$getSessions(b,f,s,o)})}async removeSession(l,b){const f=this.b.get(l);return f?f.provider.removeSession(b):this.a.$removeSession(l,b)}registerAuthenticationProvider(l,b,f,s){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:b,provider:f,options:s??{supportsMultipleAccounts:!1}});const r=f.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(l,o));return this.a.$registerAuthenticationProvider(l,b,s?.supportsMultipleAccounts??!1),new A.$jM(()=>{r.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}async $createSession(l,b,f){const s=this.b.get(l);if(s)return await s.provider.createSession(b,f);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $removeSession(l,b){const f=this.b.get(l);if(f)return await f.provider.removeSession(b);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $getSessions(l,b){const f=this.b.get(l);if(f)return await f.provider.getSessions(b);throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,b){return l.startsWith(R.$jL)||this.c.fire({provider:{id:l,label:b}}),Promise.resolve()}};e.$5lc=E,e.$5lc=E=Je([We(0,m.$LO)],E);class T{constructor(){this.a=new Map}getOrCreate(l,b){const f=this.a.get(l);if(f)return f;const s=b().finally(()=>this.a.delete(l));return this.a.set(l,s),s}}}),define(Se[112],Ie([1,0,2,4,7,3,17,12,18,13,19,25]),function(le,e,C,O,A,N,R,p,m,E,T,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=e.$4mc=void 0;let b=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,r){this.h=r,this.f=new Map,this.g=s.getProxy(O.$hM.MainThreadDecorations)}registerFileDecorationProvider(s,r){const o=l.c++;this.f.set(o,{provider:s,extensionDescription:r}),this.g.$registerDecorationProvider(o,r.identifier.value);const i=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const c=(0,m.$2b)(n);if(c.length<=l.d){this.g.$onDidChange(o,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",r.identifier.value,c.length);const u=c.map(a=>({uri:a,rank:(0,E.$cf)(a.path,"/")})),t=(0,m.$zb)(u,(a,d)=>a.rank-d.rank||(0,E.$sf)(a.uri.path,d.uri.path)),g=[];e:for(const a of t){let d;for(const w of a){const $=(0,T.$mc)(w.uri.path);if(d!==$&&(d=$,g.push(w.uri)>=l.d))break e}}this.g.$onDidChange(o,g)});return new A.$jM(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(s,r,o){if(!this.f.has(s))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:c}=this.f.get(s);return await Promise.all(r.map(async u=>{try{const{uri:t,id:g}=u,a=await Promise.resolve(n.provideFileDecoration(C.URI.revive(t),o));if(!a)return;try{A.$JN.validate(a),a.badge&&typeof a.badge!="string"&&(0,S.$KG)(c,"codiconDecoration"),i[g]=[a.propagate,a.tooltip,a.badge,a.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(t){this.h.error(t)}})),i}};e.$4mc=b,e.$4mc=b=l=Je([We(0,R.$LO),We(1,p.$5j)],b),e.$5mc=(0,N.$yi)("IExtHostDecorations")}),define(Se[259],Ie([1,0,14,2,7,4,16,20,13]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class E{static{this.a=0}constructor(S,l,b){this.d=l,this.e=b,this.b=new Map,this.c=S.getProxy(N.$hM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(R.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const b=E.a++;this.b.set(b,l),this.c.$registerTextContentProvider(b,S);let f;if(typeof l.onDidChange=="function"){let s;f=l.onDidChange(async r=>{if(r.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${r.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(r))return;s&&await s;const o=this.$provideTextDocumentContent(b,r).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(r);if(!n)return;const c=(0,m.$mf)(i);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(r,i)}).catch(C.$1).finally(()=>{s===o&&(s=void 0)});s=o})}return new A.$jM(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(S,l){const b=this.b.get(S);return b?Promise.resolve(b.provideTextDocumentContent(O.URI.revive(l),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$7mc=E}),define(Se[113],Ie([1,0,57,16,13,313,159,7,18]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=void 0,e.$NO=T;const E=new Map;function T(f,s){s?E.set(f,s):E.delete(f)}function S(f){return E.get(f)}class l extends N.$9v{constructor(s,r,o,i,n,c,u){super(r,o,i,n),this.c=s,this.m=c,this.q=u,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,m.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===O.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(r){return r?s.s(r):s.getText()},get eol(){return s.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(r){return s.t(r)},offsetAt(r){return s.u(r)},positionAt(r){return s.v(r)},validateRange(r){return s.w(r)},validatePosition(r){return s.x(r)},getWordRangeAtPosition(r,o){return s.y(r,o)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,C.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,C.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const r=this.w(s);if(r.isEmpty)return"";if(r.isSingleLine)return this.f[r.start.line].substring(r.start.character,r.end.character);const o=this.g,i=r.start.line,n=r.end.line,c=[];c.push(this.f[i].substring(r.start.character));for(let u=i+1;u<n;u++)c.push(this.f[u]);return c.push(this.f[n].substring(0,r.end.character)),c.join(o)}t(s){let r;if(s instanceof p.$kM?r=s.line:typeof s=="number"&&(r=s),typeof r!="number"||r<0||r>=this.f.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new b(r,this.f[r],r===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const r=this.j.getIndexOf(s),o=this.f[r.index].length;return new p.$kM(r.index,Math.min(r.remainder,o))}w(s){if(!(s instanceof p.$lM))throw new Error("Invalid argument");const r=this.x(s.start),o=this.x(s.end);return r===s.start&&o===s.end?s:new p.$lM(r.line,r.character,o.line,o.character)}x(s){if(!(s instanceof p.$kM))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:r,character:o}=s,i=!1;if(r<0)r=0,o=0,i=!0;else if(r>=this.f.length)r=this.f.length-1,o=this.f[r].length,i=!0;else{const n=this.f[r].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new p.$kM(r,o):s}y(s,r){const o=this.x(s);if(!r)r=S(this.m);else if((0,A.$lf)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const i=(0,R.$_s)(o.character+1,(0,R.$0s)(r),this.f[o.line],0);if(i)return new p.$lM(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$OO=l;class b{constructor(s,r,o){this.a=s,this.b=r,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$lM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$lM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$PO=b}),define(Se[260],Ie([1,0,4,7]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0;class A{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(C.$hM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,p,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(R);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector(p,m);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(R,p,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerAiEmbeddingVectorProvider(p,E),new O.$jM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$0mc=A}),define(Se[65],Ie([1,0,4,38,7,22,3,17,46,6,11,24,16]),function(le,e,C,O,A,N,R,p,m,E,T,S,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=e.$hmc=void 0;let f=b=class{constructor(r,o){this.b=new Map,this.c=new T.$Hh,this.a=r.getProxy(C.$hM.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let c;const u=i.b.get(n.scheme);return u?(await i.a.$ensureActivation(n.scheme),c=await u.impl.stat(n)):c=await i.a.$stat(n),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===O.FilePermission.Readonly?1:void 0}}catch(c){b.e(c)}},async readDirectory(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(c){return b.e(c)}},async createDirectory(n){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,n)):await i.a.$mkdir(n)}catch(c){return b.e(c)}},async readFile(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(c){return b.e(c)}},async writeFile(n,c){try{const u=i.b.get(n.scheme);return u&&!u.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(u.impl,u.extUri,u.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(u.impl.writeFile(n,c,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,N.$He.wrap(c))}catch(u){return b.e(u)}},async delete(n,c){try{const u=i.b.get(n.scheme);return u&&!u.isReadonly&&!c?.useTrash?(await i.a.$ensureActivation(n.scheme),await u.impl.delete(n,{recursive:!1,...c})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(u){return b.e(u)}},async rename(n,c,u){try{return await i.a.$rename(n,c,{overwrite:!1,...u})}catch(t){return b.e(t)}},async copy(n,c,u){try{return await i.a.$copy(n,c,{overwrite:!1,...u})}catch(t){return b.e(t)}},isWritableFileSystem(n){const c=o.getCapabilities(n);if(typeof c=="number")return!(c&2048)}})}async d(r,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await r.stat(i)).type&O.FileType.Directory))throw A.$AN.FileExists(`Unable to create folder '${i.scheme===l.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(O.$il(c)!==O.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(o.basename(i)),i=o.dirname(i)}for(let c=n.length-1;c>=0;c--){i=o.joinPath(i,n[c]);try{await r.createDirectory(i)}catch(u){if(O.$il(u)!==O.FileSystemProviderErrorCode.FileExists)throw u}}}static e(r){if(r instanceof A.$AN)throw r;if(r instanceof O.$el)switch(r.code){case O.FileSystemProviderErrorCode.FileExists:throw A.$AN.FileExists(r.message);case O.FileSystemProviderErrorCode.FileNotFound:throw A.$AN.FileNotFound(r.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw A.$AN.FileNotADirectory(r.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw A.$AN.FileIsADirectory(r.message);case O.FileSystemProviderErrorCode.NoPermissions:throw A.$AN.NoPermissions(r.message);case O.FileSystemProviderErrorCode.Unavailable:throw A.$AN.Unavailable(r.message);default:throw new A.$AN(r.message,r.name)}if(!(r instanceof Error))throw new A.$AN(String(r));if(r.name==="ENOPRO"||r.message.includes("ENOPRO"))throw A.$AN.Unavailable(r.message);switch(r.name){case O.FileSystemProviderErrorCode.FileExists:throw A.$AN.FileExists(r.message);case O.FileSystemProviderErrorCode.FileNotFound:throw A.$AN.FileNotFound(r.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw A.$AN.FileNotADirectory(r.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw A.$AN.FileIsADirectory(r.message);case O.FileSystemProviderErrorCode.NoPermissions:throw A.$AN.NoPermissions(r.message);case O.FileSystemProviderErrorCode.Unavailable:throw A.$AN.Unavailable(r.message);default:throw new A.$AN(r.message,r.name)}}addFileSystemProvider(r,o,i){return this.b.set(r,{impl:o,extUri:i?.isCaseSensitive?S.$2g:S.$4g,isReadonly:!!i?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(r))}getFileSystemProviderExtUri(r){return this.b.get(r)?.extUri??S.$2g}};e.$hmc=f,e.$hmc=f=b=Je([We(0,p.$LO),We(1,m.$Xlc)],f),e.$imc=(0,R.$yi)("IExtHostConsumerFileSystem")}),define(Se[87],Ie([1,0,3,27,12,65,2]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=e.$jmc=void 0,e.$jmc=(0,C.$yi)("IExtensionStoragePaths");let p=class{constructor(E,T,S){this.d=T,this.f=S,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(E){return R.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,T=await this.g(E);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(R.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(E){if(this.c)return R.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return R.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$kmc=p,e.$kmc=p=Je([We(0,O.$2O),We(1,A.$5j),We(2,N.$imc)],p)}),define(Se[261],Ie([1,0,7,17,5]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0;let N=class{constructor(p){this.a=new C.$KN(C.ColorThemeKind.Dark),this.b=new A.$fe}get activeColorTheme(){return this.a}$onColorThemeChange(p){let m;switch(p){case"light":m=C.ColorThemeKind.Light;break;case"hcDark":m=C.ColorThemeKind.HighContrast;break;case"hcLight":m=C.ColorThemeKind.HighContrastLight;break;default:m=C.ColorThemeKind.Dark}this.a=new C.$KN(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Rnc=N,e.$Rnc=N=Je([We(0,O.$LO)],N)}),define(Se[88],Ie([1,0,20,5,6,182,3,12,211,4,27,17,7]),function(le,e,C,O,A,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SDb=e.$RDb=e.TunnelDtoConverter=void 0;class b extends m.$vw{}var f;(function(r){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:n.protocol}}r.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==m.TunnelPrivacyId.ConstantPrivate&&n.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}r.fromServiceTunnel=i})(f||(e.TunnelDtoConverter=f={})),e.$RDb=(0,R.$yi)("IExtHostTunnelService");let s=class extends A.$Uc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$fe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(E.$hM.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const c=new b(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new l.$jM(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,c,u){const t=[];for(const a of o){const d=this.r.get(a);if(!d)return[];t.push(...await Promise.all(i.map(async w=>{let $;try{$=await d.provider.providePortAttributes({port:w,pid:n,commandLine:c},u)}catch{$=await d.provider.providePortAttributes(w,n,c,u)}return{providedAttributes:$,port:w}})))}const g=t.filter(a=>!!a.providedAttributes);return g.length>0?g.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,u)=>await o.provideTunnel(c,u,C.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,A.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let c=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const u=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,A.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const c=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const u=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:c,disposeListener:u}),f.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(c=>this.f(c.host,c.port,c.detail??""))),n=o.filter((c,u)=>i[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(c=>c.port).join(", ")} to ${n.map(c=>c.port).join(", ")}`),n}};e.$SDb=s,e.$SDb=s=Je([We(0,S.$LO),We(1,T.$2O),We(2,p.$5j)],s)}),define(Se[8],Ie([1,0,18,22,138,262,55,28,127,49,70,26,133,24,36,15,2,30,89,101,107,106,224,85,52,62,235,7]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c,u,t,g,a,d,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$IO=G,e.$JO=de,e.$KO=ye;var v;(function(pe){function Re(J){const{selectionStartLineNumber:Ae,selectionStartColumn:Ve,positionLineNumber:Xe,positionColumn:qe}=J,ut=new $.$kM(Ae-1,Ve-1),yt=new $.$kM(Xe-1,qe-1);return new $.$mM(ut,yt)}pe.to=Re;function ae(J){const{anchor:Ae,active:Ve}=J;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}pe.from=ae})(v||(e.Selection=v={}));var y;(function(pe){function Re(J){if(!J)return;const{start:Ae,end:Ve}=J;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}pe.from=Re;function ae(J){if(!J)return;const{startLineNumber:Ae,startColumn:Ve,endLineNumber:Xe,endColumn:qe}=J;return new $.$lM(Ae-1,Ve-1,Xe-1,qe-1)}pe.to=ae})(y||(e.Range=y={}));var h;(function(pe){function Re(J){return{uri:J.uri,range:y.from(J.range)}}pe.from=Re;function ae(J){return new $.$vM(r.URI.revive(J.uri),y.to(J.range))}pe.to=ae})(h||(e.Location=h={}));var D;(function(pe){function Re(ae){switch(ae){case 1:return $.StandardTokenType.Comment;case 0:return $.StandardTokenType.Other;case 3:return $.StandardTokenType.RegEx;case 2:return $.StandardTokenType.String}}pe.to=Re})(D||(e.TokenType=D={}));var k;(function(pe){function Re(J){return new $.$kM(J.lineNumber-1,J.column-1)}pe.to=Re;function ae(J){return{lineNumber:J.line+1,column:J.character+1}}pe.from=ae})(k||(e.Position=k={}));var I;(function(pe){function Re(Ae,Ve,Xe){return(0,C.$Hb)((0,C.$2b)(Ae).map(qe=>ae(qe,Ve,Xe)))}pe.from=Re;function ae(Ae,Ve,Xe){if(typeof Ae=="string")return{$serialized:!0,language:Ae,isBuiltin:Xe?.isBuiltin};if(Ae)return{$serialized:!0,language:Ae.language,scheme:J(Ae.scheme,Ve),pattern:$e.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType,isBuiltin:Xe?.isBuiltin}}function J(Ae,Ve){return Ve&&typeof Ae=="string"?Ve.transformOutgoingScheme(Ae):Ae}})(I||(e.DocumentSelector=I={}));var P;(function(pe){function Re(J){switch(J){case $.DiagnosticTag.Unnecessary:return 1;case $.DiagnosticTag.Deprecated:return 2}}pe.from=Re;function ae(J){switch(J){case 1:return $.DiagnosticTag.Unnecessary;case 2:return $.DiagnosticTag.Deprecated;default:return}}pe.to=ae})(P||(e.DiagnosticTag=P={}));var V;(function(pe){function Re(J){let Ae;return J.code&&((0,s.$$f)(J.code)||(0,s.$cg)(J.code)?Ae=String(J.code):Ae={value:String(J.code.value),target:J.code.target}),{...y.from(J.range),message:J.message,source:J.source,code:Ae,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(W.from),tags:Array.isArray(J.tags)?(0,C.$Hb)(J.tags.map(P.from)):void 0}}pe.from=Re;function ae(J){const Ae=new $.$xM(y.to(J),J.message,q.to(J.severity));return Ae.source=J.source,Ae.code=(0,s.$$f)(J.code)?J.code:J.code?.value,Ae.relatedInformation=J.relatedInformation&&J.relatedInformation.map(W.to),Ae.tags=J.tags&&(0,C.$Hb)(J.tags.map(P.to)),Ae}pe.to=ae})(V||(e.Diagnostic=V={}));var W;(function(pe){function Re(J){return{...y.from(J.location.range),message:J.message,resource:J.location.uri}}pe.from=Re;function ae(J){return new $.$wM(new $.$vM(J.resource,y.to(J)),J.message)}pe.to=ae})(W||(e.DiagnosticRelatedInformation=W={}));var q;(function(pe){function Re(J){switch(J){case $.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case $.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case $.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case $.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}pe.from=Re;function ae(J){switch(J){case n.MarkerSeverity.Info:return $.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return $.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return $.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return $.DiagnosticSeverity.Hint;default:return $.DiagnosticSeverity.Error}}pe.to=ae})(q||(e.DiagnosticSeverity=q={}));var M;(function(pe){function Re(J){return typeof J=="number"&&J>=$.ViewColumn.One?J-1:J===$.ViewColumn.Beside?w.$8D:w.$7D}pe.from=Re;function ae(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=ae})(M||(e.ViewColumn=M={}));function z(pe){return typeof pe.range<"u"}function G(pe){return pe.length===0?!0:!!z(pe[0])}var ie;(function(pe){function Re(qe){return qe.map(pe.from)}pe.fromMany=Re;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(ae(qe)){const{language:Tt,value:Lt}=qe;ut={value:"```"+Tt+`
`+Lt+"\n```\n"}}else $.$LM.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const Ft=Tt=>{try{let Lt=r.URI.parse(Tt,!0);Lt=Lt.with({query:Ae(Lt.query,yt)}),yt[Tt]=Lt}catch{}return""},ct=new m.marked.Renderer;return ct.link=Ft,ct.image=Tt=>typeof Tt=="string"?Ft(R.$4k(Tt).href):"",(0,m.marked)(ut.value,{renderer:ct}),ut}pe.from=J;function Ae(qe,ut){if(!qe)return qe;let yt;try{yt=(0,E.$7h)(qe)}catch{}if(!yt)return qe;let Ft=!1;return yt=(0,S.$7n)(yt,ct=>{if(r.URI.isUri(ct)){const Tt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Tt]=ct,Ft=!0,Tt}else return}),Ft?JSON.stringify(yt):qe}function Ve(qe){const ut=new $.$LM(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?r.URI.from(qe.baseUri):void 0,ut}pe.to=Ve;function Xe(qe){if(qe)return typeof qe=="string"?qe:pe.from(qe)}pe.fromStrict=Xe})(ie||(e.MarkdownString=ie={}));function de(pe){return G(pe)?pe.map(Re=>({range:y.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?ie.fromMany(Re.hoverMessage):Re.hoverMessage?ie.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):pe.map(Re=>({range:y.from(Re)}))}function ye(pe){return typeof pe>"u"?pe:typeof pe=="string"?r.URI.file(pe):pe}var Ee;(function(pe){function Re(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?ye(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}pe.from=Re})(Ee||(e.ThemableDecorationAttachmentRenderOptions=Ee={}));var me;(function(pe){function Re(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ye(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ee.from(ae.before):void 0,after:ae.after?Ee.from(ae.after):void 0}}pe.from=Re})(me||(e.ThemableDecorationRenderOptions=me={}));var ue;(function(pe){function Re(ae){if(typeof ae>"u")return ae;switch(ae){case $.DecorationRangeBehavior.OpenOpen:return 0;case $.DecorationRangeBehavior.ClosedClosed:return 1;case $.DecorationRangeBehavior.OpenClosed:return 2;case $.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=Re})(ue||(e.DecorationRangeBehavior=ue={}));var Ce;(function(pe){function Re(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?ue.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?me.from(ae.light):void 0,dark:ae.dark?me.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ye(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ee.from(ae.before):void 0,after:ae.after?Ee.from(ae.after):void 0}}pe.from=Re})(Ce||(e.DecorationRenderOptions=Ce={}));var se;(function(pe){function Re(J){return{text:J.newText,eol:J.newEol&&gt.from(J.newEol),range:y.from(J.range)}}pe.from=Re;function ae(J){const Ae=new $.$qM(y.to(J.range),J.text);return Ae.newEol=typeof J.eol>"u"?void 0:gt.to(J.eol),Ae}pe.to=ae})(se||(e.TextEdit=se={}));var Oe;(function(pe){function Re(J,Ae){const Ve={edits:[]};if(J instanceof $.$tM){const Xe=new p.$Bc;for(const qe of J._allEntries())qe._type===1&&r.URI.isUri(qe.to)&&qe.from===void 0&&Xe.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,O.$2e)(O.$He.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:se.from(qe.edit),versionId:Xe.has(qe.uri)?void 0:Ae?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:y.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Xe.has(qe.uri)?void 0:Ae?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(ii.from)}})}return Ve}pe.from=Re;function ae(J){const Ae=new $.$tM,Ve=new p.$Ac;for(const Xe of J.edits)if(Xe.textEdit){const qe=Xe,ut=r.URI.revive(qe.resource),yt=y.to(qe.textEdit.range),Ft=qe.textEdit.text,ct=qe.textEdit.insertAsSnippet;let Tt;ct?Tt=$.$sM.replace(yt,new $.$uM(Ft)):Tt=$.$qM.replace(yt,Ft);const Lt=Ve.get(ut);Lt?Lt.push(Tt):Ve.set(ut,[Tt])}else Ae.renameFile(r.URI.revive(Xe.oldResource),r.URI.revive(Xe.newResource),Xe.options);for(const[Xe,qe]of Ve)Ae.set(Xe,qe);return Ae}pe.to=ae})(Oe||(e.WorkspaceEdit=Oe={}));var ne;(function(pe){const Re=Object.create(null);Re[$.SymbolKind.File]=0,Re[$.SymbolKind.Module]=1,Re[$.SymbolKind.Namespace]=2,Re[$.SymbolKind.Package]=3,Re[$.SymbolKind.Class]=4,Re[$.SymbolKind.Method]=5,Re[$.SymbolKind.Property]=6,Re[$.SymbolKind.Field]=7,Re[$.SymbolKind.Constructor]=8,Re[$.SymbolKind.Enum]=9,Re[$.SymbolKind.Interface]=10,Re[$.SymbolKind.Function]=11,Re[$.SymbolKind.Variable]=12,Re[$.SymbolKind.Constant]=13,Re[$.SymbolKind.String]=14,Re[$.SymbolKind.Number]=15,Re[$.SymbolKind.Boolean]=16,Re[$.SymbolKind.Array]=17,Re[$.SymbolKind.Object]=18,Re[$.SymbolKind.Key]=19,Re[$.SymbolKind.Null]=20,Re[$.SymbolKind.EnumMember]=21,Re[$.SymbolKind.Struct]=22,Re[$.SymbolKind.Event]=23,Re[$.SymbolKind.Operator]=24,Re[$.SymbolKind.TypeParameter]=25;function ae(Ae){return typeof Re[Ae]=="number"?Re[Ae]:6}pe.from=ae;function J(Ae){for(const Ve in Re)if(Re[Ve]===Ae)return Number(Ve);return $.SymbolKind.Property}pe.to=J})(ne||(e.SymbolKind=ne={}));var U;(function(pe){function Re(J){switch(J){case $.SymbolTag.Deprecated:return 1}}pe.from=Re;function ae(J){switch(J){case 1:return $.SymbolTag.Deprecated}}pe.to=ae})(U||(e.SymbolTag=U={}));var x;(function(pe){function Re(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(U.from),containerName:J.containerName,location:ge.from(J.location)}}pe.from=Re;function ae(J){const Ae=new $.$CM(J.name,ne.to(J.kind),J.containerName,ge.to(J.location));return Ae.tags=J.tags&&J.tags.map(U.to),Ae}pe.to=ae})(x||(e.WorkspaceSymbol=x={}));var ve;(function(pe){function Re(J){const Ae={name:J.name||"!!MISSING: name!!",detail:J.detail,range:y.from(J.range),selectionRange:y.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(U.from)??[]};return J.children&&(Ae.children=J.children.map(Re)),Ae}pe.from=Re;function ae(J){const Ae=new $.$DM(J.name,J.detail,ne.to(J.kind),y.to(J.range),y.to(J.selectionRange));return(0,C.$Lb)(J.tags)&&(Ae.tags=J.tags.map(U.to)),J.children&&(Ae.children=J.children.map(ae)),Ae}pe.to=ae})(ve||(e.DocumentSymbol=ve={}));var Fe;(function(pe){function Re(J){const Ae=new $.$HM(ne.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Ae._sessionId=J._sessionId,Ae._itemId=J._itemId,Ae}pe.to=Re;function ae(J,Ae,Ve){if(Ae=Ae??J._sessionId,Ve=Ve??J._itemId,Ae===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ve,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(U.from)}}pe.from=ae})(Fe||(e.CallHierarchyItem=Fe={}));var ke;(function(pe){function Re(ae){return new $.$IM(Fe.to(ae.from),ae.fromRanges.map(J=>y.to(J)))}pe.to=Re})(ke||(e.CallHierarchyIncomingCall=ke={}));var we;(function(pe){function Re(ae){return new $.$JM(Fe.to(ae.to),ae.fromRanges.map(J=>y.to(J)))}pe.to=Re})(we||(e.CallHierarchyOutgoingCall=we={}));var ge;(function(pe){function Re(J){return{range:J.range&&y.from(J.range),uri:J.uri}}pe.from=Re;function ae(J){return new $.$vM(r.URI.revive(J.uri),y.to(J.range))}pe.to=ae})(ge||(e.location=ge={}));var Q;(function(pe){function Re(J){const Ae=J,Ve=J;return{originSelectionRange:Ae.originSelectionRange?y.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Ve.uri,range:y.from(Ae.targetRange?Ae.targetRange:Ve.range),targetSelectionRange:Ae.targetSelectionRange?y.from(Ae.targetSelectionRange):void 0}}pe.from=Re;function ae(J){return{targetUri:r.URI.revive(J.uri),targetRange:y.to(J.range),targetSelectionRange:J.targetSelectionRange?y.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?y.to(J.originSelectionRange):void 0}}pe.to=ae})(Q||(e.DefinitionLink=Q={}));var Y;(function(pe){function Re(J){return{range:y.from(J.range),contents:ie.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}pe.from=Re;function ae(J){const Ae=J.contents.map(ie.to),Ve=y.to(J.range),Xe=J.canIncreaseVerbosity,qe=J.canDecreaseVerbosity;return new $.$zM(Ae,Ve,Xe,qe)}pe.to=ae})(Y||(e.Hover=Y={}));var he;(function(pe){function Re(J){return{range:y.from(J.range),expression:J.expression}}pe.from=Re;function ae(J){return new $.$uN(y.to(J.range),J.expression)}pe.to=ae})(he||(e.EvaluatableExpression=he={}));var ce;(function(pe){function Re(J){if(J instanceof $.$vN)return{type:"text",range:y.from(J.range),text:J.text};if(J instanceof $.$wN)return{type:"variable",range:y.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof $.$xN)return{type:"expression",range:y.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=Re;function ae(J){switch(J.type){case"text":return{range:y.to(J.range),text:J.text};case"variable":return{range:y.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:y.to(J.range),expression:J.expression}}}pe.to=ae})(ce||(e.InlineValue=ce={}));var Ne;(function(pe){function Re(J){return{frameId:J.frameId,stoppedLocation:y.from(J.stoppedLocation)}}pe.from=Re;function ae(J){return new $.$yN(J.frameId,y.to(J.stoppedLocation))}pe.to=ae})(Ne||(e.InlineValueContext=Ne={}));var fe;(function(pe){function Re(J){return{range:y.from(J.range),kind:J.kind}}pe.from=Re;function ae(J){return new $.$AM(y.to(J.range),J.kind)}pe.to=ae})(fe||(e.DocumentHighlight=fe={}));var Pe;(function(pe){function Re(J){return{uri:J.uri,highlights:J.highlights.map(fe.from)}}pe.from=Re;function ae(J){return new $.$BM(r.URI.revive(J.uri),J.highlights.map(fe.to))}pe.to=ae})(Pe||(e.MultiDocumentHighlight=Pe={}));var Me;(function(pe){function Re(ae){switch(ae){case 1:return $.CompletionTriggerKind.TriggerCharacter;case 2:return $.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return $.CompletionTriggerKind.Invoke}}pe.to=Re})(Me||(e.CompletionTriggerKind=Me={}));var je;(function(pe){function Re(ae){return{triggerKind:Me.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}pe.to=Re})(je||(e.CompletionContext=je={}));var B;(function(pe){function Re(J){switch(J){case $.CompletionItemTag.Deprecated:return 1}}pe.from=Re;function ae(J){switch(J){case 1:return $.CompletionItemTag.Deprecated}}pe.to=ae})(B||(e.CompletionItemTag=B={}));var L;(function(pe){const Re=new Map([[$.CompletionItemKind.Method,0],[$.CompletionItemKind.Function,1],[$.CompletionItemKind.Constructor,2],[$.CompletionItemKind.Field,3],[$.CompletionItemKind.Variable,4],[$.CompletionItemKind.Class,5],[$.CompletionItemKind.Interface,7],[$.CompletionItemKind.Struct,6],[$.CompletionItemKind.Module,8],[$.CompletionItemKind.Property,9],[$.CompletionItemKind.Unit,12],[$.CompletionItemKind.Value,13],[$.CompletionItemKind.Constant,14],[$.CompletionItemKind.Enum,15],[$.CompletionItemKind.EnumMember,16],[$.CompletionItemKind.Keyword,17],[$.CompletionItemKind.Snippet,27],[$.CompletionItemKind.Text,18],[$.CompletionItemKind.Color,19],[$.CompletionItemKind.File,20],[$.CompletionItemKind.Reference,21],[$.CompletionItemKind.Folder,23],[$.CompletionItemKind.Event,10],[$.CompletionItemKind.Operator,11],[$.CompletionItemKind.TypeParameter,24],[$.CompletionItemKind.Issue,26],[$.CompletionItemKind.User,25]]);function ae(Ve){return Re.get(Ve)??9}pe.from=ae;const J=new Map([[0,$.CompletionItemKind.Method],[1,$.CompletionItemKind.Function],[2,$.CompletionItemKind.Constructor],[3,$.CompletionItemKind.Field],[4,$.CompletionItemKind.Variable],[5,$.CompletionItemKind.Class],[7,$.CompletionItemKind.Interface],[6,$.CompletionItemKind.Struct],[8,$.CompletionItemKind.Module],[9,$.CompletionItemKind.Property],[12,$.CompletionItemKind.Unit],[13,$.CompletionItemKind.Value],[14,$.CompletionItemKind.Constant],[15,$.CompletionItemKind.Enum],[16,$.CompletionItemKind.EnumMember],[17,$.CompletionItemKind.Keyword],[27,$.CompletionItemKind.Snippet],[18,$.CompletionItemKind.Text],[19,$.CompletionItemKind.Color],[20,$.CompletionItemKind.File],[21,$.CompletionItemKind.Reference],[23,$.CompletionItemKind.Folder],[10,$.CompletionItemKind.Event],[11,$.CompletionItemKind.Operator],[24,$.CompletionItemKind.TypeParameter],[25,$.CompletionItemKind.User],[26,$.CompletionItemKind.Issue]]);function Ae(Ve){return J.get(Ve)??$.CompletionItemKind.Property}pe.to=Ae})(L||(e.CompletionItemKind=L={}));var K;(function(pe){function Re(ae,J){const Ae=new $.$RM(ae.label);return Ae.insertText=ae.insertText,Ae.kind=L.to(ae.kind),Ae.tags=ae.tags?.map(B.to),Ae.detail=ae.detail,Ae.documentation=R.$Xk(ae.documentation)?ie.to(ae.documentation):ae.documentation,Ae.sortText=ae.sortText,Ae.filterText=ae.filterText,Ae.preselect=ae.preselect,Ae.commitCharacters=ae.commitCharacters,o.$xt.isIRange(ae.range)?Ae.range=y.to(ae.range):typeof ae.range=="object"&&(Ae.range={inserting:y.to(ae.range.insert),replacing:y.to(ae.range.replace)}),Ae.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?Ae.insertText=new $.$uM(ae.insertText):(Ae.insertText=ae.insertText,Ae.textEdit=Ae.range instanceof $.$lM?new $.$qM(Ae.range,Ae.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Ae.additionalTextEdits=ae.additionalTextEdits.map(Ve=>se.to(Ve))),Ae.command=J&&ae.command?J.fromInternal(ae.command):void 0,Ae}pe.to=Re})(K||(e.CompletionItem=K={}));var H;(function(pe){function Re(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}pe.from=Re;function ae(J){return{label:J.label,documentation:R.$Xk(J.documentation)?ie.to(J.documentation):J.documentation}}pe.to=ae})(H||(e.ParameterInformation=H={}));var ee;(function(pe){function Re(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}pe.from=Re;function ae(J){return{label:J.label,documentation:R.$Xk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}pe.to=ae})(ee||(e.SignatureInformation=ee={}));var re;(function(pe){function Re(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.from):[]}}pe.from=Re;function ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.to):[]}}pe.to=ae})(re||(e.SignatureHelp=re={}));var Te;(function(pe){function Re(ae,J){const Ae=new $.$QM(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,ae)),J.kind&&He.to(J.kind));return Ae.textEdits=J.textEdits&&J.textEdits.map(se.to),Ae.tooltip=R.$Xk(J.tooltip)?ie.to(J.tooltip):J.tooltip,Ae.paddingLeft=J.paddingLeft,Ae.paddingRight=J.paddingRight,Ae}pe.to=Re})(Te||(e.InlayHint=Te={}));var Be;(function(pe){function Re(ae,J){const Ae=new $.$PM(J.label);return Ae.tooltip=R.$Xk(J.tooltip)?ie.to(J.tooltip):J.tooltip,i.Command.is(J.command)&&(Ae.command=ae.fromInternal(J.command)),J.location&&(Ae.location=ge.to(J.location)),Ae}pe.to=Re})(Be||(e.InlayHintLabelPart=Be={}));var He;(function(pe){function Re(J){return J}pe.from=Re;function ae(J){return J}pe.to=ae})(He||(e.InlayHintKind=He={}));var _e;(function(pe){function Re(J){return{range:y.from(J.range),url:J.target,tooltip:J.tooltip}}pe.from=Re;function ae(J){let Ae;if(J.url)try{Ae=typeof J.url=="string"?r.URI.parse(J.url,!0):r.URI.revive(J.url)}catch{}return new $.$WM(y.to(J.range),Ae)}pe.to=ae})(_e||(e.DocumentLink=_e={}));var xe;(function(pe){function Re(J){const Ae=new $.$ZM(J.label);return J.textEdit&&(Ae.textEdit=se.to(J.textEdit)),J.additionalTextEdits&&(Ae.additionalTextEdits=J.additionalTextEdits.map(Ve=>se.to(Ve))),Ae}pe.to=Re;function ae(J){return{label:J.label,textEdit:J.textEdit?se.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Ae=>se.from(Ae)):void 0}}pe.from=ae})(xe||(e.ColorPresentation=xe={}));var et;(function(pe){function Re(J){return new $.$XM(J[0],J[1],J[2],J[3])}pe.to=Re;function ae(J){return[J.red,J.green,J.blue,J.alpha]}pe.from=ae})(et||(e.Color=et={}));var tt;(function(pe){function Re(J){return{range:y.from(J.range)}}pe.from=Re;function ae(J){return new $.$GM(y.to(J.range))}pe.to=ae})(tt||(e.SelectionRange=tt={}));var it;(function(pe){function Re(ae){switch(ae){case 2:return $.TextDocumentSaveReason.AfterDelay;case 1:return $.TextDocumentSaveReason.Manual;case 3:case 4:return $.TextDocumentSaveReason.FocusOut}}pe.to=Re})(it||(e.TextDocumentSaveReason=it={}));var at;(function(pe){function Re(J){switch(J){case $.TextEditorLineNumbersStyle.Off:return 0;case $.TextEditorLineNumbersStyle.Relative:return 2;case $.TextEditorLineNumbersStyle.Interval:return 3;case $.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=Re;function ae(J){switch(J){case 0:return $.TextEditorLineNumbersStyle.Off;case 2:return $.TextEditorLineNumbersStyle.Relative;case 3:return $.TextEditorLineNumbersStyle.Interval;case 1:default:return $.TextEditorLineNumbersStyle.On}}pe.to=ae})(at||(e.TextEditorLineNumbersStyle=at={}));var gt;(function(pe){function Re(J){if(J===$.EndOfLine.CRLF)return 1;if(J===$.EndOfLine.LF)return 0}pe.from=Re;function ae(J){if(J===1)return $.EndOfLine.CRLF;if(J===0)return $.EndOfLine.LF}pe.to=ae})(gt||(e.EndOfLine=gt={}));var Ue;(function(pe){function Re(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case $.ProgressLocation.SourceControl:return 3;case $.ProgressLocation.Window:return 10;case $.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=Re})(Ue||(e.ProgressLocation=Ue={}));var rt;(function(pe){function Re(J){const Ae={start:J.start+1,end:J.end+1};return J.kind&&(Ae.kind=Z.from(J.kind)),Ae}pe.from=Re;function ae(J){const Ae={start:J.start-1,end:J.end-1};return J.kind&&(Ae.kind=Z.to(J.kind)),Ae}pe.to=ae})(rt||(e.FoldingRange=rt={}));var Z;(function(pe){function Re(J){if(J)switch(J){case $.FoldingRangeKind.Comment:return i.$gu.Comment;case $.FoldingRangeKind.Imports:return i.$gu.Imports;case $.FoldingRangeKind.Region:return i.$gu.Region}}pe.from=Re;function ae(J){if(J)switch(J.value){case i.$gu.Comment.value:return $.FoldingRangeKind.Comment;case i.$gu.Imports.value:return $.FoldingRangeKind.Imports;case i.$gu.Region.value:return $.FoldingRangeKind.Region}}pe.to=ae})(Z||(e.FoldingRangeKind=Z={}));var X;(function(pe){function Re(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?y.from(ae.selection):void 0,override:typeof ae.override=="boolean"?u.$xF.id:void 0}}pe.from=Re})(X||(e.TextEditorOpenOptions=X={}));var $e;(function(pe){function Re(Ve){return Ve instanceof $.$iN?Ve.toJSON():typeof Ve=="string"?Ve:ae(Ve)||J(Ve)?new $.$iN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}pe.from=Re;function ae(Ve){const Xe=Ve;return Xe?r.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function J(Ve){const Xe=Ve;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ae(Ve){return typeof Ve=="string"?Ve:new $.$iN(r.URI.revive(Ve.baseUri),Ve.pattern)}pe.to=Ae})($e||(e.GlobPattern=$e={}));var Ke;(function(pe){function Re(ae){if(ae){if(Array.isArray(ae))return ae.map(Re);if(typeof ae=="string")return ae;{const J=ae;return{language:J.language,scheme:J.scheme,pattern:$e.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}pe.from=Re})(Ke||(e.LanguageSelector=Ke={}));var be;(function(pe){function Re(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Ae=>Array.isArray(Ae)&&Ae.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&r.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Xe=>Xe instanceof $.$lM)))}pe.is=Re;function ae(J){return{documents:J.documents.map(Ae=>Ae.map(Ve=>({uri:r.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Xe=>y.from(Xe))})))}}pe.from=ae})(be||(e.MappedEditsContext=be={}));var st;(function(pe){function Re(J){return{start:J.start,end:J.end}}pe.from=Re;function ae(J){return new $.$LN(J.start,J.end)}pe.to=ae})(st||(e.NotebookRange=st={}));var dt;(function(pe){function Re(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}pe.to=Re;function ae(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}pe.from=ae})(dt||(e.NotebookCellExecutionSummary=dt={}));var Ct;(function(pe){function Re(ae){if(ae===g.NotebookCellExecutionState.Unconfirmed)return $.NotebookCellExecutionState.Pending;if(ae===g.NotebookCellExecutionState.Pending)return;if(ae===g.NotebookCellExecutionState.Executing)return $.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}pe.to=Re})(Ct||(e.NotebookCellExecutionState=Ct={}));var Vt;(function(pe){function Re(J){switch(J){case $.NotebookCellKind.Markup:return g.CellKind.Markup;case $.NotebookCellKind.Code:default:return g.CellKind.Code}}pe.from=Re;function ae(J){switch(J){case g.CellKind.Markup:return $.NotebookCellKind.Markup;case g.CellKind.Code:default:return $.NotebookCellKind.Code}}pe.to=ae})(Vt||(e.NotebookCellKind=Vt={}));var Qt;(function(pe){function Re(J){const Ae={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)$.$MN.validate(Ve),Ae.cells.push(ii.from(Ve));return Ae}pe.from=Re;function ae(J){const Ae=new $.$NN(J.cells.map(ii.to));return(0,s.$lg)(J.metadata)||(Ae.metadata=J.metadata),Ae}pe.to=ae})(Qt||(e.NotebookData=Qt={}));var ii;(function(pe){function Re(J){return{cellKind:Vt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Et.from):[]}}pe.from=Re;function ae(J){return new $.$MN(Vt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Et.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}pe.to=ae})(ii||(e.NotebookCellData=ii={}));var Xt;(function(pe){function Re(J){return{mime:J.mime,valueBytes:O.$He.wrap(J.data)}}pe.from=Re;function ae(J){return new $.$ON(J.valueBytes.buffer,J.mime)}pe.to=ae})(Xt||(e.NotebookCellOutputItem=Xt={}));var Et;(function(pe){function Re(J){return{outputId:J.id,items:J.items.map(Xt.from),metadata:J.metadata}}pe.from=Re;function ae(J){const Ae=J.items.map(Xt.to);return new $.$PN(Ae,J.outputId,J.metadata)}pe.to=ae})(Et||(e.NotebookCellOutput=Et={}));var Zt;(function(pe){function Re(Ae){return J(Ae)?{include:$e.from(Ae.include)??void 0,exclude:$e.from(Ae.exclude)??void 0}:$e.from(Ae)??void 0}pe.from=Re;function ae(Ae){return J(Ae)?{include:$e.to(Ae.include),exclude:$e.to(Ae.exclude)}:$e.to(Ae)}pe.to=ae;function J(Ae){const Ve=Ae;return Ve?!(0,s.$hg)(Ve.include)&&!(0,s.$hg)(Ve.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Yt;(function(pe){function Re(ae,J,Ae){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===$.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,Ae),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}pe.from=Re})(Yt||(e.NotebookStatusBarItem=Yt={}));var Ze;(function(pe){function Re(ae,J,Ae){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:J.toInternal(Ve,Ae),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}pe.from=Re})(Ze||(e.NotebookKernelSourceAction=Ze={}));var si;(function(pe){function Re(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}pe.from=Re})(si||(e.NotebookDocumentContentOptions=si={}));var Ht;(function(pe){function Re(J){return{uri:J.uri,provides:J.provides}}pe.from=Re;function ae(J){return new $.$RN(r.URI.revive(J.uri),J.provides)}pe.to=ae})(Ht||(e.NotebookRendererScript=Ht={}));var ht;(function(pe){function Re(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:y.from(J.location.range),uri:J.location.uri}}}pe.from=Re;function ae(J){const Ae=new $.$XN(typeof J.message=="string"?J.message:ie.to(J.message));return Ae.actualOutput=J.actual,Ae.expectedOutput=J.expected,Ae.contextValue=J.contextValue,Ae.location=J.location?ge.to(J.location):void 0,Ae}pe.to=ae})(ht||(e.TestMessage=ht={}));var mt;(function(pe){pe.namespace=d.$$K,pe.denamespace=d.$_K})(mt||(e.TestTag=mt={}));var xt;(function(pe){function Re(J){const Ae=(0,c.$HO)(J).controllerId;return{extId:a.$6K.fromExtHostTestItem(J,Ae).toString(),label:J.label,uri:r.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>mt.namespace(Ae,Ve.id)),range:o.$xt.lift(y.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}pe.from=Re;function ae(J){return{parent:void 0,error:void 0,id:a.$6K.fromString(J.extId).localId,label:J.label,uri:r.URI.revive(J.uri),tags:(J.tags||[]).map(Ae=>{const{tagId:Ve}=mt.denamespace(Ae);return new $.$YN(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}pe.toPlain=ae})(xt||(e.TestItem=xt={})),function(pe){function Re(J){return{id:J.id}}pe.from=Re;function ae(J){return new $.$YN(J.id)}pe.to=ae}(mt||(e.TestTag=mt={}));var Gt;(function(pe){const Re=(J,Ae)=>{const Ve=J.value;if(!Ve)return;const Xe={...xt.toPlain(Ve.item),parent:Ae,taskStates:Ve.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(ht.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Re(qe,Xe);ut&&Xe.children.push(ut)}return Xe};function ae(J){const Ae=new l.$AO;for(const qe of J.items)Ae.insert(a.$6K.fromString(qe.item.extId).path,qe);const Ve=[Ae.nodes],Xe=[];for(;Ve.length;)for(const qe of Ve.pop())qe.value?Xe.push(qe):qe.children&&Ve.push(qe.children.values());return{completedAt:J.completedAt,results:Xe.map(qe=>Re(qe)).filter(s.$gg)}}pe.to=ae})(Gt||(e.TestResults=Gt={}));var Nt;(function(pe){function Re(Ve){return{covered:Ve.covered,total:Ve.total}}function ae(Ve){return"line"in Ve?k.from(Ve):y.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:ae(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&ae(Xe.location),label:Xe.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:ae(Ve.location)}}pe.fromDetails=J;function Ae(Ve,Xe,qe){return $.$1N(qe.statementCoverage),$.$1N(qe.branchCoverage),$.$1N(qe.declarationCoverage),{id:Xe,uri:qe.uri,statement:Re(qe.statementCoverage),branch:qe.branchCoverage&&Re(qe.branchCoverage),declaration:qe.declarationCoverage&&Re(qe.declarationCoverage),testId:qe instanceof $.$2N&&qe.testItem?a.$6K.fromExtHostTestItem(qe.testItem,Ve).toString():void 0}}pe.fromFile=Ae})(Nt||(e.TestCoverage=Nt={}));var ft;(function(pe){function Re(ae){switch(ae){case 1:return $.CodeActionTriggerKind.Invoke;case 2:return $.CodeActionTriggerKind.Automatic}}pe.to=Re})(ft||(e.CodeActionTriggerKind=ft={}));var Bt;(function(pe){function Re(J){const Ae=new $.$6N(ne.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Ae._sessionId=J._sessionId,Ae._itemId=J._itemId,Ae}pe.to=Re;function ae(J,Ae,Ve){if(Ae=Ae??J._sessionId,Ve=Ve??J._itemId,Ae===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Ve,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(U.from)}}pe.from=ae})(Bt||(e.TypeHierarchyItem=Bt={}));var _t;(function(pe){function Re(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}pe.from=Re})(_t||(e.ViewBadge=_t={}));var zt;(function(pe){function Re(Ve,Xe,qe){const ut=Xe.fileData;return ut?new $.$aN(new $.$bN(ut.name,r.URI.revive(ut.uri),ut.id,(0,N.$db)(()=>qe(ut.id)))):Ve===T.$Ts.uriList&&Xe.uriListData?new $.$_M(Ae(Xe.uriListData)):new $.$_M(Xe.asString)}pe.to=Re;async function ae(Ve,Xe){const qe=await Xe.asString();if(Ve===T.$Ts.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Xe.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}pe.from=ae;function J(Ve){return A.$Xt.split(Ve).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return r.URI.parse(Xe)}catch{}return Xe})}function Ae(Ve){return A.$Xt.create(Ve.map(Xe=>typeof Xe=="string"?Xe:r.URI.revive(Xe)))}})(zt||(e.DataTransferItem=zt={}));var Qe;(function(pe){function Re(J,Ae){const Ve=J.items.map(([Xe,qe])=>[Xe,zt.to(Xe,qe,Ae)]);return new $.$cN(Ve)}pe.toDataTransfer=Re;async function ae(J){const Ae={items:[]},Ve=[];for(const[Xe,qe]of J)Ve.push((async()=>{Ae.items.push([Xe,await zt.from(Xe,qe)])})());return await Promise.all(Ve),Ae}pe.from=ae})(Qe||(e.DataTransfer=Qe={}));var ui;(function(pe){function Re(J,Ae){return{kind:"reply",agentId:J.participant??Ae?.agentId??"",subCommand:J.command??Ae?.command,message:J.prompt,title:J.label}}pe.from=Re;function ae(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}pe.to=ae})(ui||(e.ChatFollowup=ui={}));var Jt;(function(pe){function Re(J){switch(J.role){case 0:return new $.$uO($.LanguageModelChatMessageRole.System,J.content);case 1:return new $.$uO($.LanguageModelChatMessageRole.User,J.content);case 2:return new $.$uO($.LanguageModelChatMessageRole.Assistant,J.content)}}pe.to=Re;function ae(J){switch(J.role){case $.LanguageModelChatMessageRole.System:return{role:0,content:J.content};case $.LanguageModelChatMessageRole.User:return{role:1,content:J.content};case $.LanguageModelChatMessageRole.Assistant:return{role:2,content:J.content}}}pe.from=ae})(Jt||(e.LanguageModelChatMessage=Jt={}));var Ut;(function(pe){function Re(J){return{kind:"markdownContent",content:ie.from(J.value)}}pe.from=Re;function ae(J){return new $.$gO(ie.to(J.content))}pe.to=ae})(Ut||(e.ChatResponseMarkdownPart=Ut={}));var wt;(function(pe){function Re(J){return{kind:"markdownVuln",content:ie.from(J.value),vulnerabilities:J.vulnerabilities}}pe.from=Re;function ae(J){return new $.$hO(ie.to(J.content),J.vulnerabilities)}pe.to=ae})(wt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=wt={}));var jt;(function(pe){function Re(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}pe.from=Re;function ae(J){return new $.$iO(J.agentId,J.command)}pe.to=ae})(jt||(e.ChatResponseDetectedParticipantPart=jt={}));var At;(function(pe){function Re(ae){return{kind:"confirmation",title:ae.title,message:ae.message,data:ae.data}}pe.from=Re})(At||(e.ChatResponseConfirmationPart=At={}));var Rt;(function(pe){function Re(J){const{value:Ae,baseUri:Ve}=J;function Xe(qe,ut){return qe.map(yt=>{const Ft=r.URI.joinPath(ut,yt.name);return{label:yt.name,uri:Ft,children:yt.children&&Xe(yt.children,Ft)}})}return{kind:"treeData",treeData:{label:(0,b.$9g)(Ve),uri:Ve,children:Xe(Ae,Ve)}}}pe.from=Re;function ae(J){const Ae=(0,E.$8h)(J.treeData);function Ve(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&Ve(yt.children)}))}const Xe=Ae.uri,qe=Ae.children?Ve(Ae.children):[];return new $.$kO(qe,Xe)}pe.to=ae})(Rt||(e.ChatResponseFilesPart=Rt={}));var ei;(function(pe){function Re(J){return{kind:"inlineReference",name:J.title,inlineReference:r.URI.isUri(J.value)?J.value:h.from(J.value)}}pe.from=Re;function ae(J){const Ae=(0,E.$8h)(J);return new $.$lO(r.URI.isUri(Ae.inlineReference)?Ae.inlineReference:h.to(Ae.inlineReference),J.name)}pe.to=ae})(ei||(e.ChatResponseAnchorPart=ei={}));var Wt;(function(pe){function Re(J){return{kind:"progressMessage",content:ie.from(J.value)}}pe.from=Re;function ae(J){return new $.$mO(J.content.value)}pe.to=ae})(Wt||(e.ChatResponseProgressPart=Wt={}));var oi;(function(pe){function Re(J){return{kind:"warning",content:ie.from(J.value)}}pe.from=Re;function ae(J){return new $.$oO(J.content.value)}pe.to=ae})(oi||(e.ChatResponseWarningPart=oi={}));var Ot;(function(pe){function Re(ae){return{kind:"progressTask",content:ie.from(ae.value)}}pe.from=Re})(Ot||(e.ChatTask=Ot={}));var qt;(function(pe){function Re(ae){return{kind:"progressTaskResult",content:typeof ae=="string"?ie.from(ae):void 0}}pe.from=Re})(qt||(e.ChatTaskResult=qt={}));var Mt;(function(pe){function Re(J,Ae,Ve){return{kind:"command",command:Ae.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}pe.from=Re;function ae(J,Ae){return new $.$pO(Ae.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}pe.to=ae})(Mt||(e.ChatResponseCommandButtonPart=Mt={}));var St;(function(pe){function Re(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Ae=>se.from(Ae))}}pe.from=Re;function ae(J){return new $.$rO(r.URI.revive(J.uri),J.edits.map(Ae=>se.to(Ae)))}pe.to=ae})(St||(e.ChatResponseTextEditPart=St={}));var $t;(function(pe){function Re(J){const Ae=f.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&r.URI.isUri(J.iconPath.light)&&r.URI.isUri(J.iconPath.dark)?{light:r.URI.revive(J.iconPath.light),dark:r.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:r.URI.isUri(J.value.value)||!J.value.value?J.value.value:h.from(J.value.value)},iconPath:Ae}:{kind:"reference",reference:r.URI.isUri(J.value)?J.value:h.from(J.value),iconPath:Ae}}pe.from=Re;function ae(J){const Ae=(0,E.$8h)(J),Ve=Xe=>r.URI.isUri(Xe)?Xe:h.to(Xe);return new $.$qO("variableName"in Ae.reference?{variableName:Ae.reference.variableName,value:Ae.reference.value&&Ve(Ae.reference.value)}:Ve(Ae.reference))}pe.to=ae})($t||(e.ChatResponseReferencePart=$t={}));var Dt;(function(pe){function Re(Ae,Ve,Xe){return Ae instanceof $.$gO?Ut.from(Ae):Ae instanceof $.$lO?ei.from(Ae):Ae instanceof $.$qO?$t.from(Ae):Ae instanceof $.$mO?Wt.from(Ae):Ae instanceof $.$kO?Rt.from(Ae):Ae instanceof $.$pO?Mt.from(Ae,Ve,Xe):Ae instanceof $.$rO?St.from(Ae):Ae instanceof $.$hO?wt.from(Ae):Ae instanceof $.$iO?jt.from(Ae):Ae instanceof $.$oO?oi.from(Ae):{kind:"markdownContent",content:ie.from("")}}pe.from=Re;function ae(Ae,Ve){switch(Ae.kind){case"reference":return $t.to(Ae);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Ae,Ve)}}pe.to=ae;function J(Ae,Ve){switch(Ae.kind){case"markdownContent":return Ut.to(Ae);case"inlineReference":return ei.to(Ae);case"progressMessage":return;case"treeData":return Rt.to(Ae);case"command":return Mt.to(Ae,Ve)}}pe.toContent=J})(Dt||(e.ChatResponsePart=Dt={}));var ai;(function(pe){function Re(ae){return{prompt:ae.message,command:ae.command,attempt:ae.attempt??0,enableCommandDetection:ae.enableCommandDetection??!0,variables:ae.variables.variables.map(fi.to),location:kt.to(ae.location),acceptedConfirmationData:ae.acceptedConfirmationData,rejectedConfirmationData:ae.rejectedConfirmationData}}pe.to=Re})(ai||(e.ChatAgentRequest=ai={}));var kt;(function(pe){function Re(ae){switch(ae){case t.ChatAgentLocation.Notebook:return $.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return $.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return $.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return $.ChatLocation.Editor}}pe.to=Re})(kt||(e.ChatLocation=kt={}));var fi;(function(pe){function Re(ae){const J=ae.value;if(!J)throw new Error("Invalid value reference");return{name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],value:(0,r.$vc)(J)?r.URI.revive(J):J}}pe.to=Re})(fi||(e.ChatAgentValueReference=fi={}));var ni;(function(pe){function Re(ae,J,Ae){return{label:ae.label,value:ae.values[0].value,insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation,command:J.toInternal(ae.command,Ae)}}pe.from=Re})(ni||(e.ChatAgentCompletionItem=ni={}));var $i;(function(pe){function Re(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}pe.to=Re})($i||(e.ChatAgentResult=$i={}));var li;(function(pe){function Re(ae,J,Ae){if(J.action.kind==="vote")return;const Ve=$i.to(ae);if(J.action.kind==="command"){const Xe=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ae.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:ui.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}pe.to=Re})(li||(e.ChatAgentUserActionEvent=li={}));var bi;(function(pe){function Re(ae,J,Ae){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:J.toInternal(ae,Ae)}pe.from=Re})(bi||(e.TerminalQuickFix=bi={}));var It;(function(pe){function Re(ae){return{kind:Ei.to(ae.kind)}}pe.to=Re})(It||(e.PartialAcceptInfo=It={}));var Ei;(function(pe){function Re(ae){switch(ae){case 0:return $.PartialAcceptTriggerKind.Word;case 1:return $.PartialAcceptTriggerKind.Line;case 2:return $.PartialAcceptTriggerKind.Suggest;default:return $.PartialAcceptTriggerKind.Unknown}}pe.to=Re})(Ei||(e.PartialAcceptTriggerKind=Ei={}));var ri;(function(pe){function Re(ae,J){return{id:J,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}pe.from=Re})(ri||(e.DebugTreeItem=ri={}))}),define(Se[263],Ie([1,0,4,17,8,34]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;let R=class{constructor(m,E){this.a=m.getProxy(C.$hM.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>E.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,T){const S=new N.$Ew(A.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,T?.isRefactoring??!1)}};e.$6lc=R,e.$6lc=R=Je([We(0,O.$LO)],R)}),define(Se[264],Ie([1,0,18,11,44,5,42,6,66,15,2,21,4,8,7,225,25]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=void 0;class o{constructor(u,t,g,a,d){this.j=u,this.k=t,this.l=g,this.m=a,this.n=d,this.b=m.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(a){if(u.c){const d=new Error("Response stream has been closed");throw Error.captureStackTrace(d,a),d}};const u=this;this.b.reset();const g=(a,d)=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a).then(w=>{typeof w=="number"&&d&&d().then($=>{this.l.$handleProgressChunk(this.k.requestId,b.ChatTaskResult.from($),w)})})};this.g={markdown(a){t(this.markdown);const d=new f.$gO(a),w=b.ChatResponseMarkdownPart.from(d);return g(w),this},markdownWithVulnerabilities(a,d){t(this.markdown),d&&(0,r.$KG)(u.j,"chatParticipantAdditions");const w=new f.$hO(a,d),$=b.ChatResponseMarkdownWithVulnerabilitiesPart.from(w);return g($),this},filetree(a,d){t(this.filetree);const w=new f.$kO(a,d),$=b.ChatResponseFilesPart.from(w);return g($),this},anchor(a,d){t(this.anchor);const w=new f.$lO(a,d),$=b.ChatResponseAnchorPart.from(w);return g($),this},button(a){t(this.anchor);const d=new f.$pO(a),w=b.ChatResponseCommandButtonPart.from(d,u.m,u.n);return g(w),this},progress(a,d){t(this.progress);const w=new f.$nO(a,d),$=d?b.ChatTask.from(w):b.ChatResponseProgressPart.from(w);return g($,d),this},warning(a){t(this.progress),(0,r.$KG)(u.j,"chatParticipantAdditions");const d=new f.$oO(a),w=b.ChatResponseWarningPart.from(d);return g(w),this},reference(a,d){if(t(this.reference),"variableName"in a&&!a.value){const w=u.k.variables.variables.find($=>$.name===a.variableName);if(w){let $;if(w.references?.length)$=w.references.map(v=>({kind:"reference",reference:{variableName:a.variableName,value:v.reference}}));else{const v=new f.$qO(a,d);$=[b.ChatResponseReferencePart.from(v)]}return $.forEach(v=>g(v)),this}}else{const w=new f.$qO(a,d),$=b.ChatResponseReferencePart.from(w);g($)}return this},textEdit(a,d){t(this.textEdit),(0,r.$KG)(u.j,"chatParticipantAdditions");const w=new f.$rO(a,d),$=b.ChatResponseTextEditPart.from(w);return g($),this},detectedParticipant(a,d){t(this.detectedParticipant),(0,r.$KG)(u.j,"chatParticipantAdditions");const w=new f.$iO(a,d),$=b.ChatResponseDetectedParticipantPart.from(w);return g($),this},confirmation(a,d,w){t(this.confirmation),(0,r.$KG)(u.j,"chatParticipantAdditions");const $=new f.$jO(a,d,w),v=b.ChatResponseConfirmationPart.from($);return g(v),this},push(a){if(t(this.push),(a instanceof f.$rO||a instanceof f.$hO||a instanceof f.$iO||a instanceof f.$oO||a instanceof f.$jO)&&(0,r.$KG)(u.j,"chatParticipantAdditions"),a instanceof f.$qO)this.reference(a.value,a.iconPath);else{const d=b.ChatResponsePart.from(a,u.m,u.n);g(d)}return this}}}return this.g}}class i extends p.$Uc{static{this.b=0}constructor(u,t,g){super(),this.n=t,this.s=g,this.c=new Map,this.j=this.B(new p.$4c),this.m=this.B(new p.$4c),this.g=u.getProxy(l.$hM.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,t,g){const a=i.b++,d=new n(u,t,this.g,a,g);return this.c.set(a,d),this.g.$registerAgent(a,u.identifier,t,{},void 0),d.apiAgent}createDynamicChatAgent(u,t,g,a,d,w){const $=i.b++,v=new n(u,t,this.g,$,w);return this.c.set($,v),this.g.$registerAgent($,u.identifier,t,{isSticky:!0},{name:g,description:d,publisherDisplayName:a}),v.apiAgent}async $invokeAgent(u,t,g,a){const d=this.c.get(u);if(!d)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let w=this.j.get(t.sessionId);w||(w=new p.$Tc,this.j.set(t.sessionId,w));const $=new o(d.extension,t,this.g,this.s.converter,w);try{const v=await this.t(t.agentId,g),y=d.invoke(b.ChatAgentRequest.to(t),{history:v},$.apiObject,a);return await(0,O.$mh)(Promise.resolve(y).then(h=>{if(h?.metadata)try{JSON.stringify(h.metadata)}catch(D){const k=`result.metadata MUST be JSON.stringify-able. Got error: ${D.message}`;return this.n.error(`[${d.extension.identifier.value}] [@${d.id}] ${k}`,d.extension),{errorDetails:{message:k},timings:$.timings}}return{errorDetails:h?.errorDetails,timings:$.timings,metadata:h?.metadata}}),a)}catch(v){return this.n.error(v,d.extension),{errorDetails:{message:(0,A.$jj)(v),responseIsIncomplete:!0}}}finally{$.close()}}async t(u,t){const g=[];for(const a of t.history){const d=b.ChatAgentResult.to(a.result),w=u===a.request.agentId?d:{...d,metadata:void 0};g.push(new f.$sO(a.request.message,a.request.command,a.request.variables.variables.map(b.ChatAgentValueReference.to),a.request.agentId));const $=(0,C.$Hb)(a.response.map(v=>b.ChatResponsePart.toContent(v,this.s.converter)));g.push(new f.$tO($,w,a.request.agentId,a.request.command))}return g}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,t,g,a,d){const w=this.c.get(t);if(!w)return Promise.resolve([]);const $=await this.t(w.id,a),v=b.ChatAgentResult.to(g);return(await w.provideFollowups(v,{history:$},d)).filter(y=>{const h=!y.participant||R.Iterable.some(this.c.values(),D=>D.id===y.participant&&S.$Tm.equals(D.extension.identifier,w.extension.identifier));return h||this.n.warn(`[@${w.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),h}).map(y=>b.ChatFollowup.from(y,u))}$acceptFeedback(u,t,g,a){const d=this.c.get(u);if(!d)return;const w=b.ChatAgentResult.to(t);let $;switch(g){case s.InteractiveSessionVoteDirection.Down:$=f.ChatResultFeedbackKind.Unhelpful;break;case s.InteractiveSessionVoteDirection.Up:$=f.ChatResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(a?{result:w,kind:$,reportIssue:a}:{result:w,kind:$}))}$acceptAction(u,t,g){const a=this.c.get(u);if(!a||g.action.kind==="vote")return;const d=b.ChatAgentUserActionEvent.to(t,g,this.s.converter);d&&a.acceptAction(Object.freeze(d))}async $invokeCompletionProvider(u,t,g){const a=this.c.get(u);if(!a)return[];let d=this.m.get(u);return d?d.clear():(d=new p.$Tc,this.m.set(u,d)),(await a.invokeCompletionProvider(t,g)).map($=>b.ChatAgentCompletionItem.from($,this.s.converter,d))}async $provideWelcomeMessage(u,t,g){const a=this.c.get(u);if(a)return await a.provideWelcomeMessage(b.ChatLocation.to(t),g)}async $provideSampleQuestions(u,t,g){const a=this.c.get(u);if(a)return(await a.provideSampleQuestions(b.ChatLocation.to(t),g)).map(d=>b.ChatFollowup.from(d,void 0))}}e.$7lc=i;class n{constructor(u,t,g,a,d){this.extension=u,this.id=t,this.u=g,this.w=a,this.x=d,this.n=new N.$fe,this.o=new N.$fe}acceptFeedback(u){this.n.fire(u)}acceptAction(u){this.o.fire(u)}async invokeCompletionProvider(u,t){return this.q?await this.q.provider.provideCompletionItems(u,t)??[]:[]}async provideFollowups(u,t,g){if(!this.b)return[];const a=await this.b.provideFollowups(u,t,g);return a?a.filter(d=>!(d&&"commandId"in d)).filter(d=>!(d&&"message"in d)):[]}async provideWelcomeMessage(u,t){if(!this.s)return[];const g=await this.s.provideWelcomeMessage(u,t);return g?g.map(a=>typeof a=="string"?a:b.MarkdownString.from(a)):[]}async provideSampleQuestions(u,t){if(!this.s||!this.s.provideSampleQuestions)return[];const g=await this.s.provideSampleQuestions(u,t);return g||[]}get apiAgent(){let u=!1,t=!1;const g=()=>{u||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof f.$gN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:b.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:b.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:b.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),t=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,r.$KG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName(d){(0,r.$KG)(a.extension,"defaultChatParticipant"),a.c=d,g()},get iconPath(){return a.d},set iconPath(d){a.d=d,g()},get requestHandler(){return a.x},set requestHandler(d){(0,E.$ig)(typeof d=="function","Invalid request handler"),a.x=d},get followupProvider(){return a.b},set followupProvider(d){a.b=d,g()},get isDefault(){return(0,r.$KG)(a.extension,"defaultChatParticipant"),a.g},set isDefault(d){(0,r.$KG)(a.extension,"defaultChatParticipant"),a.g=d,g()},get helpTextPrefix(){return(0,r.$KG)(a.extension,"defaultChatParticipant"),a.j},set helpTextPrefix(d){(0,r.$KG)(a.extension,"defaultChatParticipant"),a.j=d,g()},get helpTextVariablesPrefix(){return(0,r.$KG)(a.extension,"defaultChatParticipant"),a.k},set helpTextVariablesPrefix(d){(0,r.$KG)(a.extension,"defaultChatParticipant"),a.k=d,g()},get helpTextPostfix(){return(0,r.$KG)(a.extension,"defaultChatParticipant"),a.l},set helpTextPostfix(d){(0,r.$KG)(a.extension,"defaultChatParticipant"),a.l=d,g()},get isSecondary(){return(0,r.$KG)(a.extension,"defaultChatParticipant"),a.m},set isSecondary(d){(0,r.$KG)(a.extension,"defaultChatParticipant"),a.m=d,g()},get supportIssueReporting(){return(0,r.$KG)(a.extension,"chatParticipantAdditions"),a.p},set supportIssueReporting(d){(0,r.$KG)(a.extension,"chatParticipantAdditions"),a.p=d,g()},get onDidReceiveFeedback(){return a.n.event},set participantVariableProvider(d){if((0,r.$KG)(a.extension,"chatParticipantAdditions"),a.q=d,d){if(!d.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,d.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,r.$KG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(d){(0,r.$KG)(a.extension,"defaultChatParticipant"),a.s=d,g()},get welcomeMessageProvider(){return(0,r.$KG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,r.$JG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(d){a.t=d,g()},get requester(){return a.t},dispose(){u=!0,a.b=void 0,a.n.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(u,t,g,a){return this.x(u,t,g,a)}}}),define(Se[265],Ie([1,0,14,6,4,8,7,25]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=void 0;class m{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(A.$hM.MainThreadChatVariables)}async $resolveVariable(S,l,b,f){const s=this.b.get(S);if(s)try{if(s.resolver.resolve2){(0,p.$KG)(s.extension,"chatParticipantAdditions");const r=new E(l,this.c),o=await s.resolver.resolve2(s.data.name,{prompt:b},r.apiObject,f);if(o&&o[0])return o[0].value}else{const r=await s.resolver.resolve(s.data.name,{prompt:b},f);if(r&&r[0])return r[0].value}}catch(r){(0,C.$2)(r)}}registerVariableResolver(S,l,b,f){const s=m.a++;return this.b.set(s,{extension:S,data:{name:l,description:b},resolver:f}),this.c.$registerVariable(s,{name:l,description:b}),(0,O.$Sc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$8lc=m;class E{constructor(S,l){this.c=S,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(f){if(S.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,f),s}};const S=this,b=f=>{this.d.$handleProgressChunk(this.c,f)};this.b={progress(f){l(this.progress);const s=new R.$mO(f),r=N.ChatResponseProgressPart.from(s);return b(r),this},reference(f){l(this.reference);const s=new R.$qO(f),r=N.ChatResponseReferencePart.from(s);return b(r),this},push(f){return l(this.push),f instanceof R.$qO?b(N.ChatResponseReferencePart.from(f)):f instanceof R.$mO&&b(N.ChatResponseProgressPart.from(f)),this}}}return this.b}}}),define(Se[266],Ie([1,0,11,69,5,6,2,89,21,8,7,4,25]),function(le,e,C,O,A,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=b;function b(f,s,r){const o=f.getProxy(S.$hM.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$Vm,s.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===6){const y=this.b.get(v.handle);return y?y.value:v}else if(v&&v.$mid===7){const y=v,h=this.b.get(y.commentControlHandle);if(!h)return y;const D=h.getCommentThread(y.commentThreadHandle);return D?D.value:y}else if(v&&(v.$mid===9||v.$mid===8)){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);return h?v.$mid===8?h.value:{thread:h.value,text:v.text}:v}else if(v&&v.$mid===10){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const D=v.commentUniqueId,k=h.getCommentByUniqueId(D);return k||v}else if(v&&v.$mid===11){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const D=v.text,k=v.commentUniqueId,I=h.getCommentByUniqueId(k);return I?(typeof I.body=="string"?I.body=D:I.body=new T.$LM(D),I):v}return v}})}createCommentController(v,y,h){const D=i.a++,k=new c(v,D,y,h);this.b.set(k.handle,k);const I=this.c.get(v.identifier)||[];return I.push(k),this.c.set(v.identifier,I),k.value}async $createCommentThreadTemplate(v,y,h,D){const k=this.b.get(v);k&&k.$createCommentThreadTemplate(y,h,D)}async $setActiveComment(v,y){const h=this.b.get(v);h&&h.$setActiveComment(y??void 0)}async $updateCommentThreadTemplate(v,y,h){const D=this.b.get(v);D&&D.$updateCommentThreadTemplate(y,h)}$deleteCommentThread(v,y){this.b.get(v)?.$deleteCommentThread(y)}async $provideCommentingRanges(v,y,h){const D=this.b.get(v);if(!D||!D.commentingRangeProvider)return Promise.resolve(void 0);const k=await r.ensureDocumentData(R.URI.revive(y));return(0,C.$qh)(async()=>{const I=await D.commentingRangeProvider.provideCommentingRanges(k.document,h);let P;return Array.isArray(I)?P={ranges:I,fileComments:!1}:I?P={ranges:I.ranges||[],fileComments:I.fileComments||!1}:P=I??void 0,P}).then(I=>{let P;return I&&(P={ranges:I.ranges.map(V=>E.Range.from(V)),fileComments:I.fileComments}),P})}$toggleReaction(v,y,h,D,k){const I=this.b.get(v);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,C.$qh)(()=>{const P=I.getCommentThread(y);if(P){const V=P.getCommentByUniqueId(D.uniqueIdInThread);if(I!==void 0&&V&&I.reactionHandler)return I.reactionHandler(V,g(k))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,typeof v=="object"?((0,l.$KG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=v.resolved,this.b.applicability=v.applicability):this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,y,h,D,k,I,P,V,W){this.m=y,this.n=h,this.o=D,this.p=k,this.q=I,this.extensionDescription=P,this.r=V,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$fe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Vc,this.l.value=new N.$Tc,this.n===void 0&&(this.n=`${v}.${this.handle}`),o.$createCommentThread(y,this.handle,this.n,this.o,E.Range.from(this.p),P.identifier,this.r,W),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this.i.push({dispose:()=>{o.$deleteCommentThread(y,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(M){q.range=M},get comments(){return q.comments},set comments(M){q.comments=M},get collapsibleState(){return q.collapsibleState},set collapsibleState(M){q.collapsibleState=M},get canReply(){return q.canReply},set canReply(M){q.canReply=M},get contextValue(){return q.contextValue},set contextValue(M){q.contextValue=M},get label(){return q.label},set label(M){q.label=M},get state(){return q.state},set state(M){q.state=M},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Tc);const v=h=>Object.prototype.hasOwnProperty.call(this.b,h),y={};v("range")&&(y.range=E.Range.from(this.p)),v("label")&&(y.label=this.label),v("contextValue")&&(y.contextValue=this.contextValue??null),v("comments")&&(y.comments=this.q.map(h=>u(this,h,this.k,this.extensionDescription))),v("collapsibleState")&&(y.collapseState=a(this.g)),v("canReply")&&(y.canReply=this.canReply),v("state")&&(y.state=d(this.h)),v("applicability")&&(y.applicability=w(this.h)),v("isTemplate")&&(y.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(v){for(const y of this.k){const h=y[0],D=y[1];if(v===D)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}Je([(0,O.$4h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,v?.resourceHints&&(0,l.$KG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,v?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$KG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$KG)(this.h,"activeComment"),this.f}constructor(v,y,h,D){this.h=v,this.i=y,this.j=h,this.k=D,this.a=new Map,o.$registerCommentController(this.handle,h,D,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(I){k.options=I},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(I){k.commentingRangeProvider=I},get reactionHandler(){return k.reactionHandler},set reactionHandler(I){k.reactionHandler=I},get activeCommentThread(){return k.activeCommentThread},createCommentThread(I,P,V){return k.createCommentThread(I,P,V).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(v,y,h){y===void 0&&(0,l.$KG)(this.h,"fileComments");const D=new n(this.id,this.handle,void 0,v,y,h,this.h,!1);return this.a.set(D.handle,D),D}$setActiveComment(v){if(!v){this.e=void 0,this.f=void 0;return}const y=this.a.get(v.commentThreadHandle);y&&(this.e=v.uniqueIdInThread?y.getCommentByUniqueId(v.uniqueIdInThread):void 0,this.f=y)}$createCommentThreadTemplate(v,y,h){const D=new n(this.id,this.handle,void 0,R.URI.revive(v),E.Range.to(y),[],this.h,!0,h);return D.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(v,y){const h=this.a.get(v);h&&(h.range=E.Range.to(y))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.g.forEach(v=>v.dispose())}}function u($,v,y,h){let D=y.get(v);return D||(D=++$.commentHandle,y.set(v,D)),v.state!==void 0&&(0,l.$KG)(h,"commentsDraftState"),v.reactions?.some(k=>k.reactors!==void 0)&&(0,l.$KG)(h,"commentReactor"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:D,body:typeof v.body=="string"?v.body:E.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(k=>t(k)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function t($){return{label:$.label,iconPath:$.iconPath?E.$KO($.iconPath):void 0,count:$.count,hasReacted:$.authorHasReacted,reactors:$.reactors&&$.reactors.length>0&&typeof $.reactors[0]!="string"?$.reactors.map(v=>v.name):$.reactors}}function g($){return{label:$.label||"",count:$.count||0,iconPath:$.iconPath?R.URI.revive($.iconPath):"",authorHasReacted:$.hasReacted||!1,reactors:$.reactors?.map(v=>({name:v}))}}function a($){if($!==void 0)switch($){case T.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function d($){let v;if(typeof $=="object"?v=$.resolved:v=$,v!==void 0)switch(v){case T.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function w($){let v;if(typeof $=="object"&&(v=$.applicability),v!==void 0)switch(v){case T.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Se[267],Ie([1,0,20,73,6,16,24,2,8,64,76,4,7]),function(le,e,C,O,A,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rmc=void 0;class b{constructor(g,a){this.document=g,this.b=a,this.a=1,this.c=new T.$Rlc("custom documents")}addEdit(g){return this.c.add([g])}async undo(g,a){await this.f(g).undo(),a||this.disposeBackup()}async redo(g,a){await this.f(g).redo(),a||this.disposeBackup()}disposeEdits(g){for(const a of g)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const g=u(this.document.uri)+this.a++;return(0,R.$_g)(this.b,g)}updateBackup(g){this.d?.delete(),this.d=g}disposeBackup(){this.d?.delete(),this.d=void 0}f(g){const a=this.c.get(g,0);if(!a)throw new Error("No edit found");return a}}class f{constructor(){this.a=new Map}get(g,a){return this.a.get(this.b(g,a))}add(g,a,d){const w=this.b(g,a.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${g} resource:${a.uri}`);const $=new b(a,d);return this.a.set(w,$),$}delete(g,a){const d=this.b(g,a.uri);this.a.delete(d)}b(g,a){return`${g}@@@${a}`}}var s;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(s||(s={}));class r{constructor(){this.a=new Map}addTextProvider(g,a,d){return this.b(g,{type:0,extension:a,provider:d})}addCustomProvider(g,a,d){return this.b(g,{type:1,extension:a,provider:d})}get(g){return this.a.get(g)}b(g,a){if(this.a.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this.a.set(g,a),new l.$jM(()=>this.a.delete(g))}}class o{constructor(g,a,d,w,$){this.d=a,this.f=d,this.g=w,this.h=$,this.b=new r,this.c=new f,this.a=g.getProxy(S.$hM.MainThreadCustomEditors)}registerCustomEditorProvider(g,a,d,w){const $=new A.$Tc;return n(d)?($.add(this.b.addTextProvider(a,g,d)),this.a.$registerTextEditorProvider((0,E.$omc)(g),a,w.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,E.$mmc)(g))):($.add(this.b.addCustomProvider(a,g,d)),i(d)&&$.add(d.onDidChangeCustomDocument(v=>{const y=this.i(a,v.document.uri);if(c(v)){const h=y.addEdit(v);this.a.$onDidEdit(v.document.uri,a,h,v.label)}else this.a.$onContentChange(v.document.uri,a)})),this.a.$registerCustomEditorProvider((0,E.$omc)(g),a,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,E.$mmc)(g))),l.$jM.from($,new l.$jM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(g,a,d,w,$){const v=this.b.get(a);if(!v)throw new Error(`No provider found for '${a}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${a}'`);const y=p.URI.revive(g),h=await v.provider.openCustomDocument(y,{backupId:d,untitledDocumentData:w?.buffer},$);let D;return i(v.provider)&&this.f&&(D=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(a,h,D),{editable:i(v.provider)}}async $disposeCustomDocument(g,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const w=p.URI.revive(g),{document:$}=this.i(a,w);this.c.delete(a,$),$.dispose()}async $resolveCustomEditor(g,a,d,w,$,v){const y=this.b.get(d);if(!y)throw new Error(`No provider found for '${d}'`);const h=m.ViewColumn.to($),D=this.g.createNewWebview(a,w.contentOptions,y.extension),k=this.h.createNewWebviewPanel(a,d,w.title,h,w.options,D,w.active),I=p.URI.revive(g);switch(y.type){case 1:{const{document:P}=this.i(d,I);return y.provider.resolveCustomEditor(P,k,v)}case 0:{const P=this.d.getDocument(I);return y.provider.resolveCustomTextEditor(P,k,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,a,d){this.i(a,g).disposeEdits(d)}async $onMoveCustomEditor(g,a,d){const w=this.b.get(d);if(!w)throw new Error(`No provider found for '${d}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const $=this.h.getWebviewPanel(g);if(!$)throw new Error("No webview found");const v=p.URI.revive(a),y=this.d.getDocument(v);await w.provider.moveCustomTextEditor(y,$,C.CancellationToken.None)}async $undo(g,a,d,w){return this.i(a,g).undo(d,w)}async $redo(g,a,d,w){return this.i(a,g).redo(d,w)}async $revert(g,a,d){const w=this.i(a,g);await this.j(a).revertCustomDocument(w.document,d),w.disposeBackup()}async $onSave(g,a,d){const w=this.i(a,g);await this.j(a).saveCustomDocument(w.document,d),w.disposeBackup()}async $onSaveAs(g,a,d,w){const $=this.i(a,g);return this.j(a).saveCustomDocumentAs($.document,p.URI.revive(d),w)}async $backup(g,a,d){const w=this.i(a,g),v=await this.j(a).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},d);return w.updateBackup(v),v.id}i(g,a){const d=this.c.get(g,p.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(g){const d=this.b.get(g)?.provider;if(!d||!i(d))throw new Error("Custom document is not editable");return d}}e.$rmc=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const g=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,O.$mj)(g)+""}}),define(Se[268],Ie([1,0,172,101,2,4,7,8,5,12,28,46]),function(le,e,C,O,A,N,R,p,m,E,T,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=e.$Ylc=void 0;class b{#e;#t;#i;constructor(r,o,i,n,c,u,t,g){this.d=r,this.e=o,this.f=i,this.g=n,this.h=c,this.c=!1,this.f=Math.max(n,i),this.#i=new T.$Ac(a=>u.getComparisonKey(a)),this.#e=t,this.#t=g}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(r,o){if(!r){this.clear();return}this.j();let i=[];if(A.URI.isUri(r)){if(!o){this.delete(r);return}this.#i.set(r,o.slice()),i=[r]}else if(Array.isArray(r)){i=[];let u;r=[...r].sort(b.k);for(const t of r){const[g,a]=t;if((!u||g.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=g,i.push(g),this.#i.set(g,[])),a)this.#i.get(g)?.push(...a);else{const d=this.#i.get(g);d&&(d.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let c=0;for(const u of i){let t=[];const g=this.#i.get(u);if(g)if(g.length>this.g){t=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const w of g)if(w.severity===a[d]&&t.push({...p.Diagnostic.from(w),modelVersionId:this.h(u)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,C.localize)(0,null,g.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=g.map(a=>({...p.Diagnostic.from(a),modelVersionId:this.h(u)}));if(n.push([u,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,n)}delete(r){this.j(),this.#t.fire([r]),this.#i.delete(r),this.#e?.$changeMany(this.e,[[r,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(r,o){this.j();for(const[i,n]of this)r.call(o,i,n,this)}*[Symbol.iterator](){this.j();for(const r of this.#i.keys())yield[r,this.get(r)]}get(r){this.j();const o=this.#i.get(r);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(r){return this.j(),Array.isArray(this.#i.get(r))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(r,o){return r[0].toString()<o[0].toString()?-1:r[0].toString()>o[0].toString()?1:0}}e.$Ylc=b;let f=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(r){const o=new T.$Ac;for(const i of r)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(r,o,i,n){this.j=o,this.k=i,this.l=n,this.g=new Map,this.h=new m.$je({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,l._mapper),this.f=r.getProxy(N.$hM.MainThreadDiagnostics)}createDiagnosticCollection(r,o){const{g:i,f:n,h:c,j:u,k:t,l:g}=this,a=new class{$changeMany($,v){n.$changeMany($,v),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,$,v.length===0?"CLEARING":v)}$clear($){n.$clear($),u.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,$)}dispose(){n.dispose()}};let d;if(!o)o="_generated_diagnostic_collection_name_#"+l.c++,d=o;else if(!i.has(o))d=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do d=o+l.c++;while(i.has(d))}return new class extends b{constructor(){super(o,d,l.e,l.d,$=>g.getDocument($)?.version,t.extUri,a,c),i.set(d,this)}dispose(){super.dispose(),i.delete(d)}}}getDiagnostics(r){if(r)return this.m(r);{const o=new Map,i=[];for(const n of this.g.values())n.forEach((c,u)=>{let t=o.get(c.toString());typeof t>"u"&&(t=i.length,o.set(c.toString(),t),i.push([c,[]])),i[t][1]=i[t][1].concat(...u)});return i}}m(r){let o=[];for(const i of this.g.values())i.has(r)&&(o=o.concat(i.get(r)));return o}$acceptMarkersChange(r){if(!this.n){const o="_generated_mirror",i=new b(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of r)this.n.set(A.URI.revive(o),i.map(p.Diagnostic.to))}};e.$Zlc=f,e.$Zlc=f=l=Je([We(1,E.$5j),We(2,S.$Xlc)],f)}),define(Se[269],Ie([1,0,2,14,7,8,200,34]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=void 0;class m{constructor(T,S,l,b={timeout:1500,errors:3}){this.c=T,this.d=S,this.f=l,this.g=b,this.a=new R.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(S,l,b)=>{const s={dispose:this.a.push([S,l,T])};return Array.isArray(b)&&b.push(s),s}}async $participateInSave(T,S){const l=C.URI.revive(T);let b=!1;const f=setTimeout(()=>b=!0,this.g.timeout),s=[];try{for(const r of[...this.a]){if(b)break;const o=this.d.getDocument(l),i=await this.h(r,{document:o,reason:N.TextDocumentSaveReason.to(S)});s.push(i)}}finally{clearTimeout(f)}return s}h([T,S,l],b){const f=this.b.get(T);return typeof f=="number"&&f>this.g.errors?Promise.resolve(!1):this.i(l,T,S,b).then(()=>!0,s=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const r=this.b.get(T);this.b.set(T,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,S,l,b){const f=[],s=Date.now(),{document:r,reason:o}=b,{version:i}=r,n=Object.freeze({document:r,reason:o,waitUntil(c){if(Object.isFrozen(f))throw(0,O.$8)("waitUntil can not be called async");f.push(Promise.resolve(c))}});try{S.apply(l,[n])}catch(c){return Promise.reject(c)}return Object.freeze(f),new Promise((c,u)=>{const t=setTimeout(()=>u(new Error("timeout")),this.g.timeout);return Promise.all(f).then(g=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(t),c(g)}).catch(g=>{clearTimeout(t),u(g)})}).then(c=>{const u={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(g=>g instanceof A.$qM))for(const{newText:g,newEol:a,range:d}of t)u.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:d&&N.Range.from(d),text:g,eol:a&&N.EndOfLine.from(a)}});if(u.edits.length!==0)return i===r.version?this.f.$tryApplyWorkspaceEdit(new p.$Ew(u)):Promise.reject(new Error("concurrent_edits"))})}}e.$8mc=m}),define(Se[270],Ie([1,0,5,6,2,4,113,8,15,26,7]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;class S{constructor(b,f){this.a=new C.$fe,this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=b.getProxy(N.$hM.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(s=>{for(const r of s)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const r of s)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const f=this.g.getDocument(b);if(f)return f}getDocument(b){const f=this.getDocumentData(b);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this.g.getDocument(b);if(f)return Promise.resolve(f);let s=this.h.get(b.toString());return s||(s=this.f.$tryOpenDocument(b).then(r=>{this.h.delete(b.toString());const o=A.URI.revive(r);return(0,m.$jg)(this.g.getDocument(o))},r=>(this.h.delete(b.toString()),Promise.reject(r))),this.h.set(b.toString(),s)),s}createDocumentData(b){return this.f.$tryCreateDocument(b).then(f=>A.URI.revive(f))}$acceptModelLanguageChanged(b,f){const s=A.URI.revive(b),r=this.g.getDocument(s);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(f),this.a.fire(r.document)}$acceptModelSaved(b){const f=A.URI.revive(b),s=this.g.getDocument(f);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(b,f){const s=A.URI.revive(b),r=this.g.getDocument(s);if(!r)throw new Error("unknown document");r._acceptIsDirty(f),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,f,s){const r=A.URI.revive(b),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(s),o.onEvents(f);let i;f.isUndoing?i=T.TextDocumentChangeReason.Undo:f.isRedoing&&(i=T.TextDocumentChangeReason.Redo),this.c.fire((0,E.$6n)({document:o.document,contentChanges:f.changes.map(n=>({range:p.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(b,f){(0,R.$NO)(b,f)}}e.$1lc=S}),define(Se[67],Ie([1,0,271,5,15,2,3,4,17,8,7]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=e.$smc=void 0,e.$smc=(0,R.$yi)("IExtHostEditorTabs");class S{constructor(r,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,o={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$7N(N.URI.revive(this.b.input.uri));case 2:return new T.$8N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new T.$9N(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new T.$0N(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$$N(this.b.input.viewType);case 4:return new T.$_N(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$aO(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$bO;case 9:return new T.$cO(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$dO;case 11:return new T.$eO(this.b.input.diffEditors.map(r=>new T.$8N(N.URI.revive(r.original),N.URI.revive(r.modified))));default:return}}}class l{constructor(r,o){this.c=[],this.d="",this.b=r,this.e=o;for(const i of r.tabs)i.isActive&&(this.d=i.id),this.c.push(new S(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,o={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return E.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(i=>i.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const i=new S(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,i),r.tabDto.isActive&&(this.d=i.tabId),i}else if(r.kind===1){const i=this.c.splice(r.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(r.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,i),i}const o=this.c.find(i=>i.tabId===r.tabDto.id);if(!o)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(r.tabDto),o}activeTabId(){return this.d}}let b=class{constructor(r){this.b=new O.$fe,this.c=new O.$fe,this.e=[],this.a=r.getProxy(p.$hM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,o={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(i=>i.apiObject))},get activeTabGroup(){const i=r.d;return(0,A.$jg)(r.e.find(c=>c.groupId===i)?.apiObject)},close:async(i,n)=>{const c=Array.isArray(i)?i:[i];return c.length?f(c[0])?this.j(c,n):this.i(c,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(r){const o=new Set(this.e.map(a=>a.groupId)),i=new Set(r.map(a=>a.groupId)),n=(0,C.$L)(o,i),c=this.e.filter(a=>n.removed.includes(a.groupId)).map(a=>a.apiObject),u=[],t=[];this.e=r.map(a=>{const d=new l(a,()=>this.d);return n.added.includes(d.groupId)?u.push(d.apiObject):t.push(d.apiObject),d});const g=(0,A.$jg)(r.find(a=>a.isActive===!0)?.groupId);g!==void 0&&this.d!==g&&(this.d=g),this.c.fire(Object.freeze({opened:u,closed:c,changed:t}))}$acceptTabGroupUpdate(r){const o=this.e.find(i=>i.groupId===r.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const o=this.e.find(n=>n.groupId===r.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(r){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===r)return i}h(r){return this.e.find(o=>o.apiObject===r)}async i(r,o){const i=[];for(const n of r){const c=this.g(n);if(!c)throw new Error("Tab close: Invalid tab not found!");i.push(c.tabId)}return this.a.$closeTab(i,o)}async j(r,o){const i=[];for(const n of r){const c=this.h(n);if(!c)throw new Error("Group close: Invalid group not found!");i.push(c.groupId)}return this.a.$closeGroup(i,o)}};e.$tmc=b,e.$tmc=b=Je([We(0,m.$LO)],b);function f(s){return s.tabs!==void 0}}),define(Se[272],Ie([1,0,2,4,6,7,8,314,13,22,25,55]),function(le,e,C,O,A,N,R,p,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const r=this.a.indexOf(s);r>=0&&(this.a.splice(r,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),r=[];let o,i,n=14,c=14;for(const u of s){let t=o?(0,m.$Bf)(o,u):0;for(t===0?i=1:i=c;t<u.length;t++)t+1===u.length?(n=c,c=9):c+=1,r.push([i,u.toUpperCase().charCodeAt(t),c]),r.push([i,u.toLowerCase().charCodeAt(t),c]),i=c;o=u,c=n}r.push([9,58,10]),r.push([10,47,12]),this.b=new p.$I2(r)}}provideDocumentLinks(s){this.c();const r=[],o=p.$J2.computeLinks({getLineContent(i){return s.lineAt(i-1).text},getLineCount(){return s.lineCount}},this.b);for(const i of o){const n=R.DocumentLink.to(i);n.target&&r.push(n)}return r}}class b{constructor(s,r){this.i=r,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(O.$hM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,r,o,i={}){if(b.j(o),this.d.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const n=this.h++;this.b.add(r),this.d.add(r),this.c.set(n,o);let c=2;i.isCaseSensitive&&(c+=1024),i.isReadonly&&(c+=2048),typeof o.copy=="function"&&(c+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,T.$KG)(s,"fsChunks"),c+=4);let u;i.isReadonly&&(0,S.$Xk)(i.isReadonly)&&i.isReadonly.value!==""&&(u={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,r,c,u).catch(g=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${r}`),console.error(g)});const t=o.onDidChangeFile(g=>{const a=[];for(const d of g){const{uri:w,type:$}=d;if(w.scheme!==r)continue;let v;switch($){case N.FileChangeType.Changed:v=0;break;case N.FileChangeType.Created:v=1;break;case N.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:w,type:v})}this.a.$onFileSystemChange(n,a)});return(0,A.$Sc)(()=>{t.dispose(),this.b.delete(r),this.d.delete(r),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:r,ctime:o,mtime:i,size:n,permissions:c}=s;return{type:r,ctime:o,mtime:i,size:n,permissions:c}}$stat(s,r){return Promise.resolve(this.l(s).stat(C.URI.revive(r))).then(o=>b.k(o))}$readdir(s,r){return Promise.resolve(this.l(s).readDirectory(C.URI.revive(r)))}$readFile(s,r){return Promise.resolve(this.l(s).readFile(C.URI.revive(r))).then(o=>E.$He.wrap(o))}$writeFile(s,r,o,i){return Promise.resolve(this.l(s).writeFile(C.URI.revive(r),o.buffer,i))}$delete(s,r,o){return Promise.resolve(this.l(s).delete(C.URI.revive(r),o))}$rename(s,r,o,i){return Promise.resolve(this.l(s).rename(C.URI.revive(r),C.URI.revive(o),i))}$copy(s,r,o,i){const n=this.l(s);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(C.URI.revive(r),C.URI.revive(o),i))}$mkdir(s,r){return Promise.resolve(this.l(s).createDirectory(C.URI.revive(r)))}$watch(s,r,o,i){const n=this.l(s).watch(C.URI.revive(o),i);this.f.set(r,n)}$unwatch(s,r){const o=this.f.get(r);o&&(o.dispose(),this.f.delete(r))}$open(s,r,o){const i=this.l(s);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(C.URI.revive(r),o))}$close(s,r){const o=this.l(s);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(r))}$read(s,r,o,i){const n=this.l(s);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$He.alloc(i);return Promise.resolve(n.read(r,o,c.buffer,0,i)).then(u=>c.slice(0,u))}$write(s,r,o,i){const n=this.l(s);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(r,o,i.buffer,0,i.byteLength))}l(s){const r=this.c.get(s);if(!r){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return r}}e.$$mc=b}),define(Se[273],Ie([1,0,5,37,2,4,8,7,43]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,f,s,r,o,i){this.a=Math.random(),this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,O.$sk)(o),c=typeof o=="string",u=i?.correlate,t=r(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(u&&typeof g.session>"u")){if(!i?.ignoreCreateEvents)for(const a of g.created){const d=A.URI.revive(a);n(d.fsPath)&&(!c||f.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const a of g.changed){const d=A.URI.revive(a);n(d.fsPath)&&(!c||f.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const a of g.deleted){const d=A.URI.revive(a);n(d.fsPath)&&(!c||f.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=p.$jM.from(this.i(b,s,o,i,i?.correlate),this.b,this.c,this.d,t)}i(b,f,s,r,o){const i=p.$jM.from();if(typeof s=="string"||r?.ignoreChangeEvents&&r?.ignoreCreateEvents&&r?.ignoreDeleteEvents)return i;const n=b.getProxy(N.$hM.MainThreadFileSystemEventService);let c=!1;(s.pattern.includes(O.$ok)||s.pattern.includes(O.$pk))&&(c=!0);let u;return o&&(r?.ignoreChangeEvents||r?.ignoreCreateEvents||r?.ignoreDeleteEvents)&&(u=14,r?.ignoreChangeEvents&&(u&=-3),r?.ignoreCreateEvents&&(u&=-5),r?.ignoreDeleteEvents&&(u&=-9)),n.$watch(f.identifier.value,this.a,s.baseUri,{recursive:c,excludes:r?.excludes??[],filter:u},!!o),p.$jM.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(b){this.a=b,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(A.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(A.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(b,f,s){this.j=b,this.k=f,this.l=s,this.a=new C.$fe,this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.g=new C.$he,this.h=new C.$he,this.i=new C.$he,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,f,s,r){return new E(this.j,b,f,this.a.event,R.GlobPattern.from(s),r)}$onFileEvent(b){this.a.fire(new T(b))}$onDidRunFileOperation(b,f){switch(b){case 2:this.b.fire(Object.freeze({files:f.map(s=>({oldUri:A.URI.revive(s.source),newUri:A.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(s=>A.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(s=>A.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,f){return(s,r,o)=>{const i=function(c){s.call(r,c)};return i.extension=b,f.event(i,void 0,o)}}async $onWillRunFileOperation(b,f,s,r){switch(b){case 2:return await this.n(this.g,{files:f.map(o=>({oldUri:A.URI.revive(o.source),newUri:A.URI.revive(o.target)}))},s,r);case 1:return await this.n(this.i,{files:f.map(o=>A.URI.revive(o.target))},s,r);case 0:case 3:return await this.n(this.h,{files:f.map(o=>A.URI.revive(o.target))},s,r)}}async n(b,f,s,r){const o=new Set,i=[];if(await b.fireAsync(f,r,async(c,u)=>{const t=Date.now(),g=await Promise.resolve(c);g instanceof p.$tM&&(i.push([u.extension,g]),o.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>s&&this.k.warn("SLOW file-participant",u.extension.identifier)}),r.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,c]of i){const{edits:u}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(u)}return{edit:n,extensionNames:Array.from(o)}}}e.$_mc=S}),define(Se[274],Ie([1,0,18,11,20,14,91,6,26,66,13,15,2,30,315,89,98,174,21,8,7,25,76,4]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c,u,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class a{constructor(B,L){this.d=B,this.e=L}async provideDocumentSymbols(B,L){const K=this.d.getDocument(B),H=await this.e.provideDocumentSymbols(K,L);if(!(0,C.$Kb)(H))return H[0]instanceof c.$DM?H.map(n.DocumentSymbol.from):a.f(H)}static f(B){B=B.slice(0).sort((H,ee)=>{let re=H.location.range.start.compareTo(ee.location.range.start);return re===0&&(re=ee.location.range.end.compareTo(H.location.range.end)),re});const L=[],K=[];for(const H of B){const ee={name:H.name||"!!MISSING: name!!",kind:n.SymbolKind.from(H.kind),tags:H.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:n.Range.from(H.location.range),selectionRange:n.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(ee),L.push(ee);break}const re=K[K.length-1];if(b.$xt.containsRange(re.range,ee.range)&&!b.$xt.equalsRange(re.range,ee.range)){re.children?.push(ee),K.push(ee);break}K.pop()}}return L}}class d{constructor(B,L,K,H,ee,re){this.f=B,this.g=L,this.h=K,this.j=H,this.k=ee,this.l=re,this.d=new t.$Rlc("CodeLens"),this.e=new Map}async provideCodeLenses(B,L){const K=this.f.getDocument(B),H=await this.h.provideCodeLenses(K,L);if(!H||L.isCancellationRequested)return;const ee=this.d.add(H),re=new p.$Tc;this.e.set(ee,re);const Te={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Te.lenses.push({cacheId:[ee,Be],range:n.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,re)});return Te}async resolveCodeLens(B,L){const K=B.cacheId&&this.d.get(...B.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,L),H||(H=K),L.isCancellationRequested)return;const ee=B.cacheId&&this.e.get(B.cacheId[0]);if(ee){if(!H.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return B.command=this.g.toInternal(H.command,ee),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function w(je){return Array.isArray(je)?je.map(n.DefinitionLink.from):je?[n.DefinitionLink.from(je)]:[]}class ${constructor(B,L){this.d=B,this.e=L}async provideDefinition(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideDefinition(H,ee,K);return w(re)}}class v{constructor(B,L){this.d=B,this.e=L}async provideDeclaration(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideDeclaration(H,ee,K);return w(re)}}class y{constructor(B,L){this.d=B,this.e=L}async provideImplementation(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideImplementation(H,ee,K);return w(re)}}class h{constructor(B,L){this.d=B,this.e=L}async provideTypeDefinition(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideTypeDefinition(H,ee,K);return w(re)}}class D{static{this.f=10}constructor(B,L){this.g=B,this.h=L,this.d=0,this.e=new Map}async provideHover(B,L,K,H){const ee=this.g.getDocument(B),re=n.Position.to(L);let Te;if(K&&K.verbosityRequest){const xe=K.verbosityRequest.previousHover.id,et=this.e.get(xe);if(!et)throw new Error(`Hover with id ${xe} not found`);const tt={action:K.verbosityRequest.action,previousHover:et};Te=await this.h.provideHover(ee,re,H,tt)}else Te=await this.h.provideHover(ee,re,H);if(!Te||(0,C.$Kb)(Te.contents))return;Te.range||(Te.range=ee.getWordRangeAtPosition(re)),Te.range||(Te.range=new c.$lM(re,re));const Be=n.Hover.from(Te),He=this.d;if(this.e.size===D.f){const xe=Math.min(...this.e.keys());this.e.delete(xe)}return this.e.set(He,Te),this.d+=1,{...Be,id:He}}releaseHover(B){this.e.delete(B)}}class k{constructor(B,L){this.d=B,this.e=L}async provideEvaluatableExpression(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideEvaluatableExpression(H,ee,K);if(re)return n.EvaluatableExpression.from(re)}}class I{constructor(B,L){this.d=B,this.e=L}async provideInlineValues(B,L,K,H){const ee=this.d.getDocument(B),re=await this.e.provideInlineValues(ee,n.Range.to(L),n.InlineValueContext.to(K),H);if(Array.isArray(re))return re.map(Te=>n.InlineValue.from(Te))}}class P{constructor(B,L){this.d=B,this.e=L}async provideDocumentHighlights(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideDocumentHighlights(H,ee,K);if(Array.isArray(re))return re.map(n.DocumentHighlight.from)}}class V{constructor(B,L){this.d=B,this.e=L}async provideMultiDocumentHighlights(B,L,K,H){const ee=this.d.getDocument(B),re=K.map(He=>this.d.getDocument(He)),Te=n.Position.to(L),Be=await this.e.provideMultiDocumentHighlights(ee,Te,re,H);if(Array.isArray(Be))return Be.map(n.MultiDocumentHighlight.from)}}class W{constructor(B,L){this.d=B,this.e=L}async provideLinkedEditingRanges(B,L,K){const H=this.d.getDocument(B),ee=n.Position.to(L),re=await this.e.provideLinkedEditingRanges(H,ee,K);if(re&&Array.isArray(re.ranges))return{ranges:(0,C.$Hb)(re.ranges.map(n.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(B,L){this.d=B,this.e=L}async provideReferences(B,L,K,H){const ee=this.d.getDocument(B),re=n.Position.to(L),Te=await this.e.provideReferences(ee,re,K,H);if(Array.isArray(Te))return Te.map(n.location.from)}}class M{static{this.d=1e3}constructor(B,L,K,H,ee,re,Te){this.g=B,this.h=L,this.j=K,this.k=H,this.l=ee,this.m=re,this.n=Te,this.e=new t.$Rlc("CodeAction"),this.f=new Map}async provideCodeActions(B,L,K,H){const ee=this.g.getDocument(B),re=f.$zt.isISelection(L)?n.Selection.to(L):n.Range.to(L),Te=[];for(const tt of this.j.getDiagnostics(B))if(re.intersection(tt.range)&&Te.push(tt)>M.d)break;const Be={diagnostics:Te,only:K.only?new c.$FM(K.only):void 0,triggerKind:n.CodeActionTriggerKind.to(K.trigger)},He=await this.k.provideCodeActions(ee,re,Be,H);if(!(0,C.$Lb)(He)||H.isCancellationRequested)return;const _e=this.e.add(He),xe=new p.$Tc;this.f.set(_e,xe);const et=[];for(let tt=0;tt<He.length;tt++){const it=He[tt];if(it)if(M.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,xe)});else{Be.only&&(it.kind?Be.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=it.ranges??[];et.push({cacheId:[_e,tt],title:it.title,command:it.command&&this.h.toInternal(it.command,xe),diagnostics:it.diagnostics&&it.diagnostics.map(n.Diagnostic.from),edit:it.edit&&n.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,u.$JG)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,u.$JG)(this.m,"codeActionRanges")?(0,C.$Hb)(at.map(n.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:_e,actions:et}}async resolveCodeAction(B,L){const[K,H]=B,ee=this.e.get(K,H);if(!ee||M.o(ee))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(ee,L)??ee;let Te;re.edit&&(Te=n.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const He=this.f.get(K);He&&(Be=this.h.toInternal(re.command,He))}return{edit:Te,command:Be}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{constructor(B,L,K,H,ee){this.e=B,this.f=L,this.g=K,this.h=H,this.j=ee,this.d=new t.$Rlc("DocumentPasteEdit")}async prepareDocumentPaste(B,L,K,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(B),re=L.map(He=>n.Range.to(He)),Te=n.DataTransfer.toDataTransfer(K,()=>{throw new N.$$});if(await this.g.prepareDocumentPaste(ee,re,Te,H),H.isCancellationRequested)return;const Be=Array.from(Te).filter(([,He])=>!(He instanceof c.$_M));return n.DataTransfer.from(Be)}async providePasteEdits(B,L,K,H,ee,re){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(L),Be=K.map(et=>n.Range.to(et)),He=n.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolvePasteFileData(this.h,B,et)).buffer),_e=await this.g.provideDocumentPasteEdits(Te,Be,He,{only:ee.only?new c.$eN(ee.only):void 0,triggerKind:ee.triggerKind},re);if(!_e||re.isCancellationRequested)return[];const xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,L){const[K,H]=B,ee=this.d.get(K,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(B){this.d.delete(B)}}class G{constructor(B,L){this.d=B,this.e=L}async provideDocumentFormattingEdits(B,L,K){const H=this.d.getDocument(B),ee=await this.e.provideDocumentFormattingEdits(H,L,K);if(Array.isArray(ee))return ee.map(n.TextEdit.from)}}class ie{constructor(B,L){this.d=B,this.e=L}async provideDocumentRangeFormattingEdits(B,L,K,H){const ee=this.d.getDocument(B),re=n.Range.to(L),Te=await this.e.provideDocumentRangeFormattingEdits(ee,re,K,H);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,L,K,H){(0,S.$ig)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(B),re=L.map(n.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(ee,re,K,H);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}}class de{constructor(B,L){this.d=B,this.e=L,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,L,K,H,ee){const re=this.d.getDocument(B),Te=n.Position.to(L),Be=await this.e.provideOnTypeFormattingEdits(re,Te,K,H,ee);if(Array.isArray(Be))return Be.map(n.TextEdit.from)}}class ye{constructor(B,L){this.e=B,this.f=L,this.d=new t.$Rlc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,L){const K=await this.e.provideWorkspaceSymbols(B,L);if(!(0,C.$Lb)(K))return{symbols:[]};const H=this.d.add(K),ee={cacheId:H,symbols:[]};for(let re=0;re<K.length;re++){const Te=K[re];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}ee.symbols.push({...n.WorkspaceSymbol.from(Te),cacheId:[H,re]})}return ee}async resolveWorkspaceSymbol(B,L){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const K=this.d.get(...B.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,L);return H&&(0,m.$8n)(B,n.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class Ee{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,L,K){this.d=B,this.e=L,this.f=K}async provideRenameEdits(B,L,K,H){const ee=this.d.getDocument(B),re=n.Position.to(L);try{const Te=await this.e.provideRenameEdits(ee,re,K,H);return Te?n.WorkspaceEdit.from(Te):void 0}catch(Te){const Be=Ee.g(Te);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(B,L,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(B),ee=n.Position.to(L);try{const re=await this.e.prepareRename(H,ee,K);let Te,Be;if(c.$lM.isRange(re)?(Te=re,Be=H.getText(re)):(0,S.$ag)(re)&&(Te=re.range,Be=re.placeholder),!Te||!Be)return;if(Te.start.line>ee.line||Te.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Te),text:Be}}catch(re){const Te=Ee.g(re);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(re)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class me{static{this.d={[s.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[s.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(B,L,K){this.e=B,this.f=L,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(B,L,K,H){const ee=this.e.getDocument(B),re=n.Range.to(L);try{const Te=me.d[K],Be=await this.f.provideNewSymbolNames(ee,re,Te,H);return Be?Be.map(He=>typeof He=="string"?{newSymbolName:He}:{newSymbolName:He.newSymbolName,tags:He.tags}):void 0}catch(Te){this.g.error(me.h(Te)??JSON.stringify(Te,null,"	"));return}}static h(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ue{constructor(B,L){this.resultId=B,this.tokens=L}}class Ce{constructor(B,L){this.f=B,this.g=L,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,L,K){const H=this.f.getDocument(B),ee=L!==0?this.d.get(L):null;let re=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return ee&&this.d.delete(L),re?(re=Ce.h(re),this.o(Ce.n(ee,re),re)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return Ce.j(B)?Ce.k(B)?B:new c.$EN(new Uint32Array(B.data),B.resultId):Ce.l(B)?Ce.m(B)?B:new c.$GN(B.edits.map(L=>new c.$FN(L.start,L.deleteCount,L.data?new Uint32Array(L.data):L.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const L of B.edits)if(!(L.data instanceof Uint32Array))return!1;return!0}static n(B,L){if(!Ce.j(L)||!B||!B.tokens)return L;const K=B.tokens,H=K.length,ee=L.data,re=ee.length;let Te=0;const Be=Math.min(H,re);for(;Te<Be&&K[Te]===ee[Te];)Te++;if(Te===H&&Te===re)return new c.$GN([],L.resultId);let He=0;const _e=Be-Te;for(;He<_e&&K[H-He-1]===ee[re-He-1];)He++;return new c.$GN([{start:Te,deleteCount:H-Te-He,data:ee.subarray(Te,re-He)}],L.resultId)}o(B,L){if(Ce.j(B)){const K=this.e++;return this.d.set(K,new ue(B.resultId,B.data)),(0,r.$zbb)({id:K,type:"full",data:B.data})}if(Ce.l(B)){const K=this.e++;return Ce.j(L)?this.d.set(K,new ue(L.resultId,L.data)):this.d.set(K,new ue(B.resultId)),(0,r.$zbb)({id:K,type:"delta",deltas:(B.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class se{constructor(B,L){this.d=B,this.e=L}async provideDocumentRangeSemanticTokens(B,L,K){const H=this.d.getDocument(B),ee=await this.e.provideDocumentRangeSemanticTokens(H,n.Range.to(L),K);return ee?this.f(ee):null}f(B){return(0,r.$zbb)({id:0,type:"full",data:B.data})}}class Oe{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,L,K,H,ee){this.f=B,this.g=L,this.h=K,this.j=H,this.k=ee,this.d=new t.$Rlc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,L,K,H){const ee=this.f.getDocument(B),re=n.Position.to(L),Te=ee.getWordRangeAtPosition(re)||new c.$lM(re,re),Be=Te.with({end:re}),He=new E.$be,_e=await this.h.provideCompletionItems(ee,re,H,n.CompletionContext.to(K));if(!_e||H.isCancellationRequested)return;const xe=Array.isArray(_e)?new c.$SM(_e):_e,et=Oe.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),tt=new p.$Tc;this.e.set(et,tt);const it=[],at={x:et,b:it,a:{replace:n.Range.from(Te),insert:n.Range.from(Be)},c:xe.isIncomplete||void 0,d:He.elapsed()};for(let gt=0;gt<xe.items.length;gt++){const Ue=xe.items[gt],rt=this.l(Ue,[et,gt],Be,Te);it.push(rt)}return at}async resolveCompletionItem(B,L){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...B);if(!K)return;const H=this.l(K,B),ee=await this.h.resolveCompletionItem(K,L);if(!ee)return;const re=this.l(ee,B);return(H.h!==re.h||H.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==re.n||H.o!==re.o||!(0,m.$9n)(H.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,L,K,H){const ee=this.e.get(L[0]);if(!ee)throw Error("DisposableStore is missing...");const re=this.g.toInternal(B.command,ee),Te={x:L,a:B.label,b:B.kind!==void 0?n.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(n.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:n.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(n.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=B.textEdit.newText):typeof B.insertText=="string"?Te.h=B.insertText:B.insertText instanceof c.$uM&&(Te.h=B.insertText.value,Te.i|=4);let Be;return B.textEdit?Be=B.textEdit.range:B.range&&(Be=B.range),c.$lM.isRange(Be)?Te.j=n.Range.from(Be):Be&&(!K?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Te.j={insert:n.Range.from(Be.inserting),replace:n.Range.from(Be.replacing)}),Te}}class ne{async provideInlineCompletions(B,L,K,H){}disposeCompletions(B){}handleDidShowCompletionItem(B,L,K){}handlePartialAccept(B,L,K,H){}}class U extends ne{constructor(B,L,K,H){super(),this.f=B,this.g=L,this.h=K,this.j=H,this.d=new ve,this.e=(0,u.$JG)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,u.$JG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,L,K,H){const ee=this.g.getDocument(B),re=n.Position.to(L),Te=await this.h.provideInlineCompletionItems(ee,re,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:n.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Te||H.isCancellationRequested)return;const Be=Array.isArray(Te)?Te:Te.items,He=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],_e=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((tt,it)=>{let at;tt.command&&(xe||(xe=new p.$Tc),at=this.j.toInternal(tt.command,xe));const gt=tt.insertText;return{insertText:typeof gt=="string"?gt:{snippet:gt.value},filterText:tt.filterText,range:tt.range?n.Range.from(tt.range):void 0,command:at,idx:it,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:He.map(tt=>(xe||(xe=new p.$Tc),this.j.toInternal(tt,xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,L,K){const H=this.d.get(B)?.items[L];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(B,L,K,H){const ee=this.d.get(B)?.items[L];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,K),this.h.handleDidPartiallyAcceptCompletionItem(ee,n.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(B,L,K){const H=this.f.getDocument(B),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[L.triggerKind]},K);if(!ee||K.isCancellationRequested)return;let re;const Te=this.d.createReferenceId({dispose(){re?.dispose()},item:ee});let Be;ee.accepted&&(re||(re=new p.$Tc),Be=this.h.toInternal(ee.accepted,re));let He;return ee.rejected&&(re||(re=new p.$Tc),He=this.h.toInternal(ee.rejected,re)),{pid:Te,text:ee.text,range:n.Range.from(ee.range),accepted:Be,rejected:He}}disposeEdit(B){this.d.disposeReferenceId(B)?.dispose()}constructor(B,L,K,H){this.f=L,this.g=K,this.h=H,this.d=new ve,this.e={[s.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const L=this.e++;return this.d.set(L,B),L}disposeReferenceId(B){const L=this.d.get(B);return this.d.delete(B),L}get(B){return this.d.get(B)}}class Fe{constructor(B,L){this.e=B,this.f=L,this.d=new t.$Rlc("SignatureHelp")}async provideSignatureHelp(B,L,K,H){const ee=this.e.getDocument(B),re=n.Position.to(L),Te=this.g(K),Be=await this.f.provideSignatureHelp(ee,re,H,Te);if(Be){const He=this.d.add([Be]);return{...n.SignatureHelp.from(Be),id:He}}}g(B){let L;if(B.activeSignatureHelp){const K=n.SignatureHelp.to(B.activeSignatureHelp),H=this.d.get(B.activeSignatureHelp.id,0);H?(L=H,L.activeSignature=K.activeSignature,L.activeParameter=K.activeParameter):L=K}return{...B,activeSignatureHelp:L}}releaseSignatureHelp(B){this.d.delete(B)}}class ke{constructor(B,L,K,H,ee){this.f=B,this.g=L,this.h=K,this.j=H,this.k=ee,this.d=new t.$Rlc("InlayHints"),this.e=new Map}async provideInlayHints(B,L,K){const H=this.f.getDocument(B),ee=n.Range.to(L),re=await this.h.provideInlayHints(H,ee,K);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`);return}if(K.isCancellationRequested)return;const Te=this.d.add(re);this.e.set(Te,new p.$Tc);const Be={hints:[],cacheId:Te};for(let He=0;He<re.length;He++)this.l(re[He],ee)&&Be.hints.push(this.m(re[He],[Te,He]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`),Be}async resolveInlayHint(B,L){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...B);if(!K)return;const H=await this.h.resolveInlayHint(K,L);if(H&&this.l(H))return this.m(H,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,L){return B.label.length===0||Array.isArray(B.label)&&B.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(L&&!L.contains(B.position))}m(B,L){const K=this.e.get(L[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:L,tooltip:n.MarkdownString.fromStrict(B.tooltip),position:n.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(n.TextEdit.from),kind:B.kind&&n.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")H.label=B.label;else{const ee=[];H.label=ee;for(const re of B.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:re.value,tooltip:n.MarkdownString.fromStrict(re.tooltip)};c.$vM.isLocation(re.location)&&(Te.location=n.location.from(re.location)),re.command&&(Te.command=this.g.toInternal(re.command,K)),ee.push(Te)}}return H}}class we{constructor(B,L){this.e=B,this.f=L,this.d=new t.$Rlc("DocumentLink")}async provideLinks(B,L){const K=this.e.getDocument(B),H=await this.f.provideDocumentLinks(K,L);if(!(!Array.isArray(H)||H.length===0)&&!L.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(we.g).map(n.DocumentLink.from)};{const ee=this.d.add(H),re={links:[],cacheId:ee};for(let Te=0;Te<H.length;Te++){if(!we.g(H[Te]))continue;const Be=n.DocumentLink.from(H[Te]);Be.cacheId=[ee,Te],re.links.push(Be)}return re}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,L){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...B);if(!K)return;const H=await this.f.resolveDocumentLink(K,L);if(!(!H||!we.g(H)))return n.DocumentLink.from(H)}releaseLinks(B){this.d.delete(B)}}class ge{constructor(B,L){this.d=B,this.e=L}async provideColors(B,L){const K=this.d.getDocument(B),H=await this.e.provideDocumentColors(K,L);return Array.isArray(H)?H.map(re=>({color:n.Color.from(re.color),range:n.Range.from(re.range)})):[]}async provideColorPresentations(B,L,K){const H=this.d.getDocument(B),ee=n.Range.to(L.range),re=n.Color.to(L.color),Te=await this.e.provideColorPresentations(re,{document:H,range:ee},K);if(Array.isArray(Te))return Te.map(n.ColorPresentation.from)}}class Q{constructor(B,L){this.d=B,this.e=L}async provideFoldingRanges(B,L,K){const H=this.d.getDocument(B),ee=await this.e.provideFoldingRanges(H,L,K);if(Array.isArray(ee))return ee.map(n.FoldingRange.from)}}class Y{constructor(B,L,K){this.d=B,this.e=L,this.f=K}async provideSelectionRanges(B,L,K){const H=this.d.getDocument(B),ee=L.map(n.Position.to),re=await this.e.provideSelectionRanges(H,ee,K);if(!(0,C.$Lb)(re))return[];if(re.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let Be=0;Be<ee.length;Be++){const He=[];Te.push(He);let _e=ee[Be],xe=re[Be];for(;;){if(!xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(He.push(n.SelectionRange.from(xe)),!xe.parent)break;_e=xe.range,xe=xe.parent}}return Te}}class he{constructor(B,L){this.f=B,this.g=L,this.d=new R.$QO(""),this.e=new Map}async prepareSession(B,L,K){const H=this.f.getDocument(B),ee=n.Position.to(L),re=await this.g.prepareCallHierarchy(H,ee,K);if(!re)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(re)?re.map(Be=>this.h(Te,Be)):[this.h(Te,re)]}async provideCallsTo(B,L,K){const H=this.j(B,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,K);if(ee)return ee.map(re=>({from:this.h(B,re.from),fromRanges:re.fromRanges.map(Te=>n.Range.from(Te))}))}async provideCallsFrom(B,L,K){const H=this.j(B,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(ee)return ee.map(re=>({to:this.h(B,re.to),fromRanges:re.fromRanges.map(Te=>n.Range.from(Te))}))}releaseSession(B){this.e.delete(B)}h(B,L){const K=this.e.get(B),H=n.CallHierarchyItem.from(L,B,K.size.toString(36));return K.set(H._itemId,L),H}j(B,L){return this.e.get(B)?.get(L)}}class ce{constructor(B,L){this.f=B,this.g=L,this.d=new R.$QO(""),this.e=new Map}async prepareSession(B,L,K){const H=this.f.getDocument(B),ee=n.Position.to(L),re=await this.g.prepareTypeHierarchy(H,ee,K);if(!re)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(re)?re.map(Be=>this.h(Te,Be)):[this.h(Te,re)]}async provideSupertypes(B,L,K){const H=this.j(B,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,K);if(ee)return ee.map(re=>this.h(B,re))}async provideSubtypes(B,L,K){const H=this.j(B,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,K);if(ee)return ee.map(re=>this.h(B,re))}releaseSession(B){this.e.delete(B)}h(B,L){const K=this.e.get(B),H=n.TypeHierarchyItem.from(L,B,K.size.toString(36));return K.set(H._itemId,L),H}j(B,L){return this.e.get(B)?.get(L)}}class Ne{constructor(B,L,K,H,ee){this.e=B,this.f=L,this.g=K,this.h=H,this.j=ee,this.d=new t.$Rlc("DocumentDropEdit")}async provideDocumentOnDropEdits(B,L,K,H,ee){const re=this.f.getDocument(L),Te=n.Position.to(K),Be=n.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,B,et)).buffer),He=await this.g.provideDocumentDropEdits(re,Te,Be,ee);if(!He)return;const _e=(0,C.$2b)(He),xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(B,L){const[K,H]=B,ee=this.d.get(K,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(ee,L)??ee;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(B){this.d.delete(B)}}class fe{constructor(B,L){this.d=B,this.e=L}async provideMappedEdits(B,L,K,H){const ee=l.URI.revive(B),re=this.d.getDocument(ee),Te=K.documents.map(_e=>_e.map(xe=>({uri:l.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(et=>n.Range.to(et))}))),Be={documents:Te,selections:Te[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(re,L,Be,H);return He?n.WorkspaceEdit.from(He):null}}class Pe{constructor(B,L){this.adapter=B,this.extension=L}}class Me{static{this.d=0}constructor(B,L,K,H,ee,re,Te,Be){this.g=L,this.h=K,this.j=H,this.k=ee,this.l=re,this.m=Te,this.n=Be,this.f=new Map,this.e=B.getProxy(g.$hM.MainThreadLanguageFeatures)}o(B,L){return n.DocumentSelector.from(B,this.g,L)}p(B){return new c.$jM(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return Me.d++}async s(B,L,K,H,ee,re=!1){const Te=this.f.get(B);if(!Te||!(Te.adapter instanceof L))return H;const Be=Date.now();re||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const He=K(Te.adapter,Te.extension);return Promise.resolve(He).catch(_e=>{(0,N.$4)(_e)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Te.extension.identifier,_e))}).finally(()=>{re||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),A.CancellationToken.isCancellationToken(ee)?(0,O.$nh)(He,ee):He}t(B,L){const K=this.q();return this.f.set(K,new Pe(B,L)),K}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,L,K,H){const ee=this.t(new a(this.h,K),B),re=H&&H.label||Me.u(B);return this.e.$registerDocumentSymbolProvider(ee,this.o(L,B),re),this.p(ee)}$provideDocumentSymbols(B,L,K){return this.s(B,a,H=>H.provideDocumentSymbols(l.URI.revive(L),K),void 0,K)}registerCodeLensProvider(B,L,K){const H=this.q(),ee=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Pe(new d(this.h,this.j.converter,K,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(H,this.o(L,B),ee);let re=this.p(H);if(ee!==void 0){const Te=K.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));re=c.$jM.from(re,Te)}return re}$provideCodeLenses(B,L,K){return this.s(B,d,H=>H.provideCodeLenses(l.URI.revive(L),K),void 0,K)}$resolveCodeLens(B,L,K){return this.s(B,d,H=>H.resolveCodeLens(L,K),void 0,void 0)}$releaseCodeLenses(B,L){this.s(B,d,K=>Promise.resolve(K.releaseCodeLenses(L)),void 0,void 0)}registerDefinitionProvider(B,L,K){const H=this.t(new $(this.h,K),B);return this.e.$registerDefinitionSupport(H,this.o(L,B)),this.p(H)}$provideDefinition(B,L,K,H){return this.s(B,$,ee=>ee.provideDefinition(l.URI.revive(L),K,H),[],H)}registerDeclarationProvider(B,L,K){const H=this.t(new v(this.h,K),B);return this.e.$registerDeclarationSupport(H,this.o(L,B)),this.p(H)}$provideDeclaration(B,L,K,H){return this.s(B,v,ee=>ee.provideDeclaration(l.URI.revive(L),K,H),[],H)}registerImplementationProvider(B,L,K){const H=this.t(new y(this.h,K),B);return this.e.$registerImplementationSupport(H,this.o(L,B)),this.p(H)}$provideImplementation(B,L,K,H){return this.s(B,y,ee=>ee.provideImplementation(l.URI.revive(L),K,H),[],H)}registerTypeDefinitionProvider(B,L,K){const H=this.t(new h(this.h,K),B);return this.e.$registerTypeDefinitionSupport(H,this.o(L,B)),this.p(H)}$provideTypeDefinition(B,L,K,H){return this.s(B,h,ee=>ee.provideTypeDefinition(l.URI.revive(L),K,H),[],H)}registerHoverProvider(B,L,K,H){const ee=this.t(new D(this.h,K),B);return this.e.$registerHoverProvider(ee,this.o(L,B)),this.p(ee)}$provideHover(B,L,K,H,ee){return this.s(B,D,re=>re.provideHover(l.URI.revive(L),K,H,ee),void 0,ee)}$releaseHover(B,L){this.s(B,D,K=>Promise.resolve(K.releaseHover(L)),void 0,void 0)}registerEvaluatableExpressionProvider(B,L,K,H){const ee=this.t(new k(this.h,K),B);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(L,B)),this.p(ee)}$provideEvaluatableExpression(B,L,K,H){return this.s(B,k,ee=>ee.provideEvaluatableExpression(l.URI.revive(L),K,H),void 0,H)}registerInlineValuesProvider(B,L,K,H){const ee=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new I(this.h,K),B);this.e.$registerInlineValuesProvider(re,this.o(L,B),ee);let Te=this.p(re);if(ee!==void 0){const Be=K.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(ee));Te=c.$jM.from(Te,Be)}return Te}$provideInlineValues(B,L,K,H,ee){return this.s(B,I,re=>re.provideInlineValues(l.URI.revive(L),K,H,ee),void 0,ee)}registerDocumentHighlightProvider(B,L,K){const H=this.t(new P(this.h,K),B);return this.e.$registerDocumentHighlightProvider(H,this.o(L,B)),this.p(H)}registerMultiDocumentHighlightProvider(B,L,K){const H=this.t(new V(this.h,K),B);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(L,B)),this.p(H)}$provideDocumentHighlights(B,L,K,H){return this.s(B,P,ee=>ee.provideDocumentHighlights(l.URI.revive(L),K,H),void 0,H)}$provideMultiDocumentHighlights(B,L,K,H,ee){return this.s(B,V,re=>re.provideMultiDocumentHighlights(l.URI.revive(L),K,H.map(Te=>l.URI.revive(Te)),ee),void 0,ee)}registerLinkedEditingRangeProvider(B,L,K){const H=this.t(new W(this.h,K),B);return this.e.$registerLinkedEditingRangeProvider(H,this.o(L,B)),this.p(H)}$provideLinkedEditingRanges(B,L,K,H){return this.s(B,W,async ee=>{const re=await ee.provideLinkedEditingRanges(l.URI.revive(L),K,H);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Me.w(re.wordPattern):void 0}},void 0,H)}registerReferenceProvider(B,L,K){const H=this.t(new q(this.h,K),B);return this.e.$registerReferenceSupport(H,this.o(L,B)),this.p(H)}$provideReferences(B,L,K,H,ee){return this.s(B,q,re=>re.provideReferences(l.URI.revive(L),K,H,ee),void 0,ee)}registerCodeActionProvider(B,L,K,H){const ee=new p.$Tc,re=this.t(new M(this.h,this.j.converter,this.k,K,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(re,this.o(L,B),{providedKinds:H?.providedCodeActionKinds?.map(Te=>Te.value),documentation:H?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,ee)}))},Me.u(B),!!K.resolveCodeAction),ee.add(this.p(re)),ee}$provideCodeActions(B,L,K,H,ee){return this.s(B,M,re=>re.provideCodeActions(l.URI.revive(L),K,H,ee),void 0,ee)}$resolveCodeAction(B,L,K){return this.s(B,M,H=>H.resolveCodeAction(L,K),{},void 0)}$releaseCodeActions(B,L){this.s(B,M,K=>Promise.resolve(K.releaseCodeActions(L)),void 0,void 0)}registerDocumentFormattingEditProvider(B,L,K){const H=this.t(new G(this.h,K),B);return this.e.$registerDocumentFormattingSupport(H,this.o(L,B),B.identifier,B.displayName||B.name),this.p(H)}$provideDocumentFormattingEdits(B,L,K,H){return this.s(B,G,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(L),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(B,L,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,K),B);return this.e.$registerRangeFormattingSupport(ee,this.o(L,B),B.identifier,B.displayName||B.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(B,L,K,H,ee){return this.s(B,ie,re=>re.provideDocumentRangeFormattingEdits(l.URI.revive(L),K,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(B,L,K,H,ee){return this.s(B,ie,re=>re.provideDocumentRangesFormattingEdits(l.URI.revive(L),K,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(B,L,K,H){const ee=this.t(new de(this.h,K),B);return this.e.$registerOnTypeFormattingSupport(ee,this.o(L,B),H,B.identifier),this.p(ee)}$provideOnTypeFormattingEdits(B,L,K,H,ee,re){return this.s(B,de,Te=>Te.provideOnTypeFormattingEdits(l.URI.revive(L),K,H,ee,re),void 0,re)}registerWorkspaceSymbolProvider(B,L){const K=this.t(new ye(L,this.l),B);return this.e.$registerNavigateTypeSupport(K,typeof L.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(B,L,K){return this.s(B,ye,H=>H.provideWorkspaceSymbols(L,K),{symbols:[]},K)}$resolveWorkspaceSymbol(B,L,K){return this.s(B,ye,H=>H.resolveWorkspaceSymbol(L,K),void 0,void 0)}$releaseWorkspaceSymbols(B,L){this.s(B,ye,K=>K.releaseWorkspaceSymbols(L),void 0,void 0)}registerRenameProvider(B,L,K){const H=this.t(new Ee(this.h,K,this.l),B);return this.e.$registerRenameSupport(H,this.o(L,B),Ee.supportsResolving(K)),this.p(H)}$provideRenameEdits(B,L,K,H,ee){return this.s(B,Ee,re=>re.provideRenameEdits(l.URI.revive(L),K,H,ee),void 0,ee)}$resolveRenameLocation(B,L,K,H){return this.s(B,Ee,ee=>ee.resolveRenameLocation(l.URI.revive(L),K,H),void 0,H)}registerNewSymbolNamesProvider(B,L,K){const H=this.t(new me(this.h,K,this.l),B);return this.e.$registerNewSymbolNamesProvider(H,this.o(L,B)),this.p(H)}$supportsAutomaticNewSymbolNamesTriggerKind(B){return this.s(B,me,L=>L.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(B,L,K,H,ee){return this.s(B,me,re=>re.provideNewSymbolNames(l.URI.revive(L),K,H,ee),void 0,ee)}registerDocumentSemanticTokensProvider(B,L,K,H){const ee=this.t(new Ce(this.h,K),B),re=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(L,B),H,re);let Te=this.p(ee);if(re){const Be=K.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(re));Te=c.$jM.from(Te,Be)}return Te}$provideDocumentSemanticTokens(B,L,K,H){return this.s(B,Ce,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(L),K,H),null,H)}$releaseDocumentSemanticTokens(B,L){this.s(B,Ce,K=>K.releaseDocumentSemanticColoring(L),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,L,K,H){const ee=this.t(new se(this.h,K),B);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(L,B),H),this.p(ee)}$provideDocumentRangeSemanticTokens(B,L,K,H){return this.s(B,se,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(L),K,H),null,H)}registerCompletionItemProvider(B,L,K,H){const ee=this.t(new Oe(this.h,this.j.converter,K,this.m,B),B);return this.e.$registerCompletionsProvider(ee,this.o(L,B),H,Oe.supportsResolving(K),B.identifier),this.p(ee)}$provideCompletionItems(B,L,K,H,ee){return this.s(B,Oe,re=>re.provideCompletionItems(l.URI.revive(L),K,H,ee),void 0,ee)}$resolveCompletionItem(B,L,K){return this.s(B,Oe,H=>H.resolveCompletionItem(L,K),void 0,K)}$releaseCompletionItems(B,L){this.s(B,Oe,K=>K.releaseCompletionItems(L),void 0,void 0)}registerInlineCompletionsProvider(B,L,K,H){const ee=new U(B,this.h,K,this.j.converter),re=this.t(ee,B);return this.e.$registerInlineCompletionsSupport(re,this.o(L,B),ee.supportsHandleEvents,i.$Tm.toKey(B.identifier.value),H?.yieldTo?.map(Te=>i.$Tm.toKey(Te))||[]),this.p(re)}$provideInlineCompletions(B,L,K,H,ee){return this.s(B,ne,re=>re.provideInlineCompletions(l.URI.revive(L),K,H,ee),void 0,ee)}$handleInlineCompletionDidShow(B,L,K,H){this.s(B,ne,async ee=>{ee.handleDidShowCompletionItem(L,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,L,K,H,ee){this.s(B,ne,async re=>{re.handlePartialAccept(L,K,H,ee)},void 0,void 0)}$freeInlineCompletionsList(B,L){this.s(B,ne,async K=>{K.disposeCompletions(L)},void 0,void 0)}registerInlineEditProvider(B,L,K){const H=new x(B,this.h,K,this.j.converter),ee=this.t(H,B);return this.e.$registerInlineEditProvider(ee,this.o(L,B),B.identifier),this.p(ee)}$provideInlineEdit(B,L,K,H){return this.s(B,x,ee=>ee.provideInlineEdits(l.URI.revive(L),K,H),void 0,H)}$freeInlineEdit(B,L){this.s(B,x,async K=>{K.disposeEdit(L)},void 0,void 0)}registerSignatureHelpProvider(B,L,K,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,re=this.t(new Fe(this.h,K),B);return this.e.$registerSignatureHelpProvider(re,this.o(L,B),ee),this.p(re)}$provideSignatureHelp(B,L,K,H,ee){return this.s(B,Fe,re=>re.provideSignatureHelp(l.URI.revive(L),K,H,ee),void 0,ee)}$releaseSignatureHelp(B,L){this.s(B,Fe,K=>K.releaseSignatureHelp(L),void 0,void 0)}registerInlayHintsProvider(B,L,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ke(this.h,this.j.converter,K,this.l,B),B);this.e.$registerInlayHintsProvider(ee,this.o(L,B),typeof K.resolveInlayHint=="function",H,Me.u(B));let re=this.p(ee);if(H!==void 0){const Te=K.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));re=c.$jM.from(re,Te)}return re}$provideInlayHints(B,L,K,H){return this.s(B,ke,ee=>ee.provideInlayHints(l.URI.revive(L),K,H),void 0,H)}$resolveInlayHint(B,L,K){return this.s(B,ke,H=>H.resolveInlayHint(L,K),void 0,K)}$releaseInlayHints(B,L){this.s(B,ke,K=>K.releaseHints(L),void 0,void 0)}registerDocumentLinkProvider(B,L,K){const H=this.t(new we(this.h,K),B);return this.e.$registerDocumentLinkProvider(H,this.o(L,B),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(B,L,K){return this.s(B,we,H=>H.provideLinks(l.URI.revive(L),K),void 0,K,L.scheme==="output")}$resolveDocumentLink(B,L,K){return this.s(B,we,H=>H.resolveLink(L,K),void 0,void 0,!0)}$releaseDocumentLinks(B,L){this.s(B,we,K=>K.releaseLinks(L),void 0,void 0,!0)}registerColorProvider(B,L,K){const H=this.t(new ge(this.h,K),B);return this.e.$registerDocumentColorProvider(H,this.o(L,B)),this.p(H)}$provideDocumentColors(B,L,K){return this.s(B,ge,H=>H.provideColors(l.URI.revive(L),K),[],K)}$provideColorPresentations(B,L,K,H){return this.s(B,ge,ee=>ee.provideColorPresentations(l.URI.revive(L),K,H),void 0,H)}registerFoldingRangeProvider(B,L,K){const H=this.q(),ee=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Pe(new Q(this.h,K),B)),this.e.$registerFoldingRangeProvider(H,this.o(L,B),B.identifier,ee);let re=this.p(H);if(ee!==void 0){const Te=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));re=c.$jM.from(re,Te)}return re}$provideFoldingRanges(B,L,K,H){return this.s(B,Q,ee=>ee.provideFoldingRanges(l.URI.revive(L),K,H),void 0,H)}registerSelectionRangeProvider(B,L,K){const H=this.t(new Y(this.h,K,this.l),B);return this.e.$registerSelectionRangeProvider(H,this.o(L,B)),this.p(H)}$provideSelectionRanges(B,L,K,H){return this.s(B,Y,ee=>ee.provideSelectionRanges(l.URI.revive(L),K,H),[],H)}registerCallHierarchyProvider(B,L,K){const H=this.t(new he(this.h,K),B);return this.e.$registerCallHierarchyProvider(H,this.o(L,B)),this.p(H)}$prepareCallHierarchy(B,L,K,H){return this.s(B,he,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(L),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(B,L,K,H){return this.s(B,he,ee=>ee.provideCallsTo(L,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(B,L,K,H){return this.s(B,he,ee=>ee.provideCallsFrom(L,K,H),void 0,H)}$releaseCallHierarchy(B,L){this.s(B,he,K=>Promise.resolve(K.releaseSession(L)),void 0,void 0)}registerTypeHierarchyProvider(B,L,K){const H=this.t(new ce(this.h,K),B);return this.e.$registerTypeHierarchyProvider(H,this.o(L,B)),this.p(H)}$prepareTypeHierarchy(B,L,K,H){return this.s(B,ce,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(L),K,H)),void 0,H)}$provideTypeHierarchySupertypes(B,L,K,H){return this.s(B,ce,ee=>ee.provideSupertypes(L,K,H),void 0,H)}$provideTypeHierarchySubtypes(B,L,K,H){return this.s(B,ce,ee=>ee.provideSubtypes(L,K,H),void 0,H)}$releaseTypeHierarchy(B,L){this.s(B,ce,K=>Promise.resolve(K.releaseSession(L)),void 0,void 0)}registerDocumentOnDropEditProvider(B,L,K,H){const ee=this.q();return this.f.set(ee,new Pe(new Ne(this.e,this.h,K,ee,B),B)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(L,B),(0,u.$JG)(B,"documentPaste")&&H?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(B,L,K,H,ee,re){return this.s(B,Ne,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(L,l.URI.revive(K),H,ee,re)),void 0,void 0)}$resolveDropEdit(B,L,K){return this.s(B,Ne,H=>H.resolveDropEdit(L,K),{},void 0)}$releaseDropEdits(B,L){this.s(B,Ne,K=>Promise.resolve(K.releaseDropEdits(L)),void 0,void 0)}registerMappedEditsProvider(B,L,K){const H=this.t(new fe(this.h,K),B);return this.e.$registerMappedEditsProvider(H,this.o(L,B)),this.p(H)}$provideMappedEdits(B,L,K,H,ee){return this.s(B,fe,re=>Promise.resolve(re.provideMappedEdits(L,K,H,ee)),null,ee)}registerDocumentPasteEditProvider(B,L,K,H){const ee=this.q();return this.f.set(ee,new Pe(new z(this.e,this.h,K,ee,B),B)),this.e.$registerPasteEditProvider(ee,this.o(L,B),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(B,L,K,H,ee){return this.s(B,z,re=>re.prepareDocumentPaste(l.URI.revive(L),K,H,ee),void 0,ee)}$providePasteEdits(B,L,K,H,ee,re,Te){return this.s(B,z,Be=>Be.providePasteEdits(L,l.URI.revive(K),H,ee,re,Te),void 0,Te)}$resolvePasteEdit(B,L,K){return this.s(B,z,H=>H.resolvePasteEdit(L,K),{},void 0)}$releasePasteEdits(B,L){this.s(B,z,K=>Promise.resolve(K.releasePasteEdits(L)),void 0,void 0)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:Me.w(B.decreaseIndentPattern),increaseIndentPattern:Me.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Me.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Me.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:Me.w(B.beforeText),afterText:B.afterText?Me.w(B.afterText):void 0,previousLineText:B.previousLineText?Me.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(Me.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(L=>c.SyntaxTokenType.toString(L)):void 0}}static D(B){return B.map(Me.C)}setLanguageConfiguration(B,L,K){const{wordPattern:H}=K;if(H&&(0,T.$lf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(L,H):this.h.setWordDefinitionFor(L,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ee=this.q(),re={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Me.w(K.wordPattern):void 0,indentationRules:K.indentationRules?Me.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Me.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Me.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,L,re),this.p(ee)}$setWordDefinitions(B){for(const L of B)this.h.setWordDefinitionFor(L.languageId,new RegExp(L.regexSource,L.regexFlags))}}e.$2lc=Me}),define(Se[90],Ie([1,0,11,20,14,5,42,6,175,21,3,12,103,4,86,17,8,7,108,25]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=e.$Imc=void 0,e.$Imc=(0,T.$yi)("IExtHostLanguageModels");class u{constructor(d,w){this.option=d,this.stream=new C.$2h,this.stream=w??new C.$2h}}class t{constructor(){this.a=new Map,this.b=new C.$2h,this.c=!1,this.d=!1;const d=this;this.apiObject={stream:d.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;this.d=!0;let w=this.a.get(d.index);w||(this.a.size===0?w=new u(d.index,this.b):w=new u(d.index),this.a.set(d.index,w)),w.stream.emitOne(d.part)}get isStreaming(){return this.d}reject(d){this.c=!0;for(const w of this.f())w.reject(d)}resolve(){this.c=!0;for(const d of this.f())d.resolve()}}let g=class{static{c=this}static{this.a=1}constructor(d,w,$){this.j=w,this.k=$,this.c=new N.$fe,this.d=new N.$fe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new E.$Vm,this.i=new Map,this.r=new Set,this.b=d.getProxy(b.$hM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,w,$,v){const y=c.a++;this.f.set(y,{extension:d.identifier,provider:$,languageModelId:w});let h;v.auth&&(h={providerLabel:d.displayName||d.name,accountLabel:typeof v.auth=="object"?v.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,`${E.$Tm.toKey(d.identifier)}/${y}/${w}`,{extension:d.identifier,id:w,vendor:v.vendor??E.$Tm.toKey(d.identifier),name:v.name??"",family:v.family??"",version:v.version,tokens:v.tokens,auth:h,targetExtensions:v.extensions});const D=$.onDidReceiveLanguageModelResponse2?.(({extensionId:k,participant:I,tokenCount:P})=>{this.b.$whenLanguageModelChatRequestMade(w,new E.$Tm(k),I,P)});return(0,p.$Sc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),D?.dispose()})}async $provideLanguageModelResponse(d,w,$,v,y,h){const D=this.f.get(d);if(!D)return;const k=new l.$gw(async I=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(w,{index:I.index,part:I.part})});return D.provider.provideLanguageModelResponse(v.map(r.LanguageModelChatMessage.to),y,E.$Tm.toKey($),k,h)}$provideTokenLength(d,w,$){const v=this.f.get(d);return v?Promise.resolve(v.provider.provideTokenCount(w,$)):Promise.resolve(0)}$acceptChatModelMetadata(d){if(d.added)for(const{identifier:w,metadata:$}of d.added)this.g.set(w,{metadata:$,apiObjects:new E.$Vm});if(d.removed)for(const w of d.removed){this.g.delete(w);for(const[$,v]of this.i)v.languageModelId===w&&(v.res.reject(new A.$5),this.i.delete($))}d.added?.forEach(w=>this.p(w.metadata)),this.d.fire(void 0)}async selectLanguageModels(d,w){const $=await this.b.$selectChatModels({...w,extension:d.identifier}),v=[],y=this;for(const h of $){const D=this.g.get(h);if(!D)continue;let k=D.apiObjects.get(d.identifier);k||(k={id:h,vendor:D.metadata.vendor,family:D.metadata.family,version:D.metadata.version,name:D.metadata.name,contextSize:D.metadata.tokens,computeTokenLength(I,P){if(!y.g.has(h))throw o.$yO.NotFound(h);return y.q(h,I,P??O.CancellationToken.None)},sendRequest(I,P,V){if(!y.g.has(h))throw o.$yO.NotFound(h);return y.l(d,h,I,P??{},V??O.CancellationToken.None)}},Object.freeze(k),D.apiObjects.set(d.identifier,k)),v.push(k)}if(v.length!==0)return v}async l(d,w,$,v,y){const h=this.m(d,$),D=d.identifier,k=this.g.get(w)?.metadata;if(!k||!this.g.has(w))throw o.$yO.NotFound(`Language model '${w}' is unknown.`);if(this.o(D,k)&&(!await this.n(d,{identifier:k.extension,displayName:k.auth.providerLabel},v.justification,!1)||!this.h.get(D)?.has(k.extension)))throw o.$yO.NoPermissions(`Language model '${w}' cannot be used by '${D.value}'.`);const I=Math.random()*1e6|0,P=this.b.$fetchResponse(D,w,I,h,v.modelOptions??{},y),V=new C.$xh,W=new t;this.i.set(I,{languageModelId:w,res:W});let q;if(P.catch(M=>{V.isOpen()?W.reject(M):q=M}).finally(()=>{this.i.delete(I),W.resolve(),V.open()}),await V.wait(),q)throw q.name===o.$yO.name?q:new o.$yO(`Language model '${w}' errored, check cause for more details`,"Unknown",q);return W.apiObject}m(d,w){const $=[];for(const v of w)v.role===o.LanguageModelChatMessageRole.System&&(0,n.$KG)(d,"languageModelSystem"),$.push(r.LanguageModelChatMessage.from(v));return $}async $handleResponseFragment(d,w){const $=this.i.get(d);$&&$.res.handleFragment(w)}async n(d,w,$,v){const y=i.$jL+w.identifier.value;if(await this.k.getSession(d,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:w.identifier,enabled:!0}]),!0;if(v)return!1;try{const D=$?(0,m.localize)(0,null,w.displayName,$):(0,m.localize)(1,null,w.displayName);return await this.k.getSession(d,y,[],{forceNewSession:{detail:D}}),this.$updateModelAccesslist([{from:d.identifier,to:w.identifier,enabled:!0}]),!0}catch{return!1}}o(d,w){return!!w.auth&&!E.$Tm.equals(w.extension,d)}async p(d){for(const w of this.r)try{await this.n(w,{identifier:d.extension,displayName:""},void 0,!0)}catch($){this.j.error("Fake Auth request failed"),this.j.error($)}}async q(d,w,$){if(!this.g.get(d))throw o.$yO.NotFound(`Language model '${d}' is unknown.`);const y=R.Iterable.find(this.f.values(),h=>h.languageModelId===d);return y?y.provider.provideTokenCount(w,$):this.b.$countTokens(d,typeof w=="string"?w:r.LanguageModelChatMessage.from(w),$)}$updateModelAccesslist(d){const w=new Array;for(const{from:$,to:v,enabled:y}of d){const h=this.h.get($)??new E.$Um;if(h.has(v)!==y){y?h.add(v):h.delete(v),this.h.set($,h);const k={from:$,to:v};w.push(k),this.c.fire(k)}}}createLanguageModelAccessInformation(d){this.r.add(d);const w=this,$=N.Event.signal(N.Event.filter(this.c.event,y=>E.$Tm.equals(y.from,d.identifier))),v=N.Event.signal(this.d.event);return{get onDidChange(){return N.Event.any($,v)},canSendRequest(y){const h=w.g.get(y);if(!h)return;if(!w.o(d.identifier,h.metadata))return!0;const D=w.h.get(d.identifier);if(D)return D.has(h.metadata.extension)}}}};e.$Jmc=g,e.$Jmc=g=c=Je([We(0,s.$LO),We(1,S.$5j),We(2,f.$4lc)],g)}),define(Se[275],Ie([1,0,4,8,7,32,11,6,25]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=void 0;class E{constructor(S,l,b,f){this.c=l,this.d=b,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(C.$hM.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const b=this.c.getDocumentData(S);if(!b)throw new Error(`document '${S.toString()}' NOT found`);return b.document}async tokenAtPosition(S,l){const b=S.version,f=O.Position.from(l),s=await this.a.$tokensAtPosition(S.uri,f),r={type:A.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new A.$lM(l.line,l.character,l.line,l.character)};if(!s)return r;const o={range:O.Range.to(s.range),type:O.TokenType.to(s.type)};return!o.range.contains(l)||b!==S.version?r:o}createLanguageStatusItem(S,l,b){const f=this.f++,s=this.a,r=this.g,o=`${S.identifier.value}/${l}`;if(r.has(o))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);r.add(o);const i={selector:b,id:l,name:S.displayName??S.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const c=new p.$Tc,u=()=>{if(n?.dispose(),!r.has(o)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$Ah)(()=>{c.clear(),this.a.$setLanguageStatus(f,{id:o,name:i.name??S.displayName??S.name,source:S.displayName??S.name,selector:O.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===A.LanguageStatusSeverity.Error?N.default.Error:i.severity===A.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:i.command&&this.d.toInternal(i.command,c),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){c.dispose(),n?.dispose(),s.$removeLanguageStatus(f),r.delete(o)},get id(){return i.id},get name(){return i.name},set name(g){i.name=g,u()},get selector(){return i.selector},set selector(g){i.selector=g,u()},get text(){return i.text},set text(g){i.text=g,u()},set text2(g){(0,m.$KG)(S,"languageStatusText"),i.text=g,u()},get text2(){return(0,m.$KG)(S,"languageStatusText"),i.text},get detail(){return i.detail},set detail(g){i.detail=g,u()},get severity(){return i.severity},set severity(g){i.severity=g,u()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(g){i.accessibilityInformation=g,u()},get command(){return i.command},set command(g){i.command=g,u()},get busy(){return i.busy},set busy(g){i.busy=g,u()}};return u(),t}}e.$onc=E}),define(Se[276],Ie([1,0,16,2,8,7,85]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=e.$anc=void 0;class p{constructor(S,l,b,f){this.start=S,this.deletedCount=l,this.deletedItems=b,this.items=f}asApiEvent(){return{range:new N.$LN(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,l,b){this.notebook=S,this.h=l,this.j=b,this.handle=b.handle,this.uri=O.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(A.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(f){S.g=f},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(b)}return this.f}setOutputs(S){this.a=S.map(A.NotebookCellOutput.to)}setOutputItems(S,l,b){const f=b.map(A.NotebookCellOutputItem.to),s=this.a.find(r=>r.id===S);if(s&&(l||(s.items.length=0),s.items.push(...f),s.items.length>1&&s.items.every(r=>R.$dK(r.mime)))){const r=new Map,o=[];s.items.forEach(i=>{let n;r.has(i.mime)?n=r.get(i.mime):(n=[],r.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),s.items.length=0,o.forEach(i=>{const n=R.$eK(r.get(i));s.items.push({mime:i,data:n.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$anc=m;class E{static{this.a=0}constructor(S,l,b,f,s){this.k=S,this.l=l,this.m=b,this.uri=f,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===C.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(b){return b=S.n(b),S.b[b].apiCell},getCells(b){return(b?S.p(b):S.b).map(s=>s.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,b){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:b});const f={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},s=[];for(const o of S.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,f.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,f.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),s.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),s.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),s.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),s.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),s.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const r=new Map;for(let o=0;o<s.length;o++){const i=s[o],n=r.get(i.cell);if(n===void 0){const c=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});r.set(i.cell,c-1)}else f.cellChanges[n]={...f.cellChanges[n],...i}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,b=S.end|0;return l<0&&(l=0),b>this.b.length&&(b=this.b.length),S.with({start:l,end:b})}p(S){S=this.o(S);const l=[];for(let b=S.start;b<S.end;b++)l.push(this.b[b]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,b){if(this.j)return;const f=[],s=[],r=[];if(S.reverse().forEach(o=>{const n=o[2].map(t=>{const g=new m(this,this.l,t);return l||s.push(m.asModelAddData(t)),g}),c=new p(o[0],o[1],[],n),u=this.b.splice(o[0],o[1],...n);for(const t of u)r.push(t.uri),c.deletedItems.push(t.apiCell);f.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:r}),b)for(const o of f)b.push(o.asApiEvent())}s(S,l,b,f){const s=this.b.splice(S,l);this.b.splice(b,0,...s);const r=[new p(S,l,s.map(o=>o.apiCell),[]),new p(b,0,[],s)];for(const o of r)f.push(o.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,b,f){this.b[S].setOutputItems(l,b,f)}v(S,l){const b=this.b[S];b.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(b.uri,l)}w(S,l){const b=this.b[S];b.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$bnc=E}),define(Se[277],Ie([1,0,5,2,8,7,34]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=void 0;class p{constructor(E,T,S,l={timeout:1500,errors:3}){this.b=E,this.c=T,this.d=S,this.f=l,this.a=new C.$he}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(T,S,l)=>{const b=function(s){T.call(S,s)};return b.extension=E,this.a.event(b,void 0,l)}}async $participateInSave(E,T,S){const l=O.URI.revive(E),b=this.c.getNotebookDocument(l);if(!b)throw new Error("Unable to resolve notebook document");const f=[];if(await this.a.fireAsync({notebook:b.apiNotebook,reason:A.TextDocumentSaveReason.to(T)},S,async(r,o)=>{const i=Date.now(),n=await await Promise.resolve(r);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!S.isCancellationRequested&&n&&(n instanceof N.$tM?f.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(f.length===0)return!0;const s={edits:[]};for(const r of f){const{edits:o}=A.WorkspaceEdit.from(r);s.edits=s.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new R.$Ew(s))}}e.$qnc=p}),define(Se[114],Ie([1,0,14,8,7]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,m,E,T,S,l){this.id=p,this.f=m,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=T,this.c=l}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(m){this.selections=[m]},get selections(){return p.a},set selections(m){if(!Array.isArray(m)||!m.every(A.$LN.isNotebookRange))throw(0,C.$7)("selections");p.a=m,p.g(m)},get visibleRanges(){return p.b},revealRange(m,E){p.f.$tryRevealRange(p.id,O.NotebookRange.from(m),E??A.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(O.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$cnc=N}),define(Se[278],Ie([1,0,5,12,8]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;let N=class{constructor(p,m){this.c=p,this.d=m,this.a=new C.$fe,this.b=new C.$fe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,m);const E=this.d.getEditorById(p);m.visibleRanges&&E._acceptVisibleRanges(m.visibleRanges.ranges.map(A.NotebookRange.to)),m.selections&&E._acceptSelections(m.selections.selections.map(A.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const m in p)this.d.getEditorById(m)._acceptViewColumn(A.ViewColumn.to(p[m]))}};e.$snc=N,e.$snc=N=Je([We(0,O.$5j)],N)}),define(Se[279],Ie([1,0,5,4,114]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;class N{constructor(p,m){this.c=m,this.a=new Map,this.b=p.getProxy(O.$hM.MainThreadNotebookRenderers)}$postRendererMessage(p,m,E){const T=this.c.getEditorById(p);this.a.get(m)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging(p,m){if(!p.contributes?.notebookRenderer?.some(T=>T.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(T,S,l)=>this.d(m).event(T,S,l),postMessage:(T,S)=>{A.$cnc.apiEditorsToExtHost.has(T)&&([T,S]=[S,T]);const l=S&&A.$cnc.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,m,T)}}}d(p){let m=this.a.get(p);return m||(m=new C.$fe({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(p)}}),this.a.set(p,m),m)}}e.$vnc=N}),define(Se[280],Ie([1,0,8,103,20,69,14]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;class p{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,l,b){const f=this.b++,{title:s,location:r,cancellable:o}=l,i={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(f,{location:C.ProgressLocation.from(r),title:s,source:i,cancellable:o},S.isUnderDevelopment?void 0:S.identifier.value).catch(R.$2),this.d(f,b,!!o)}d(S,l,b){let f;b&&(f=new A.$qe,this.c.set(S,f));const s=o=>{this.a.$progressEnd(o),this.c.delete(o),f?.dispose()};let r;try{r=l(new E(this.a,S),b&&f?f.token:A.CancellationToken.None)}catch(o){throw s(S),o}return r.then(o=>s(S),o=>s(S)),r}$acceptProgressCanceled(S){const l=this.c.get(S);l&&(l.cancel(),this.c.delete(S))}}e.$znc=p;function m(T,S){return T.message=S.message,typeof S.increment=="number"&&(typeof T.increment=="number"?T.increment+=S.increment:T.increment=S.increment),T}class E extends O.$gw{constructor(S,l){super(b=>this.throttledReport(b)),this.c=S,this.d=l}throttledReport(S){this.c.$progressReport(this.d,S)}}Je([(0,N.$5h)(100,(T,S)=>m(T,S),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Se[281],Ie([1,0,2,4,11,8]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=void 0;class R{static{this.a=0}constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(O.$hM.MainThreadQuickDiff)}$provideOriginalResource(m,E,T){const S=C.URI.revive(E),l=this.c.get(m);return l?(0,A.$qh)(()=>l.provideOriginalResource(S,T)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(m,E,T,S){const l=R.a++;return this.c.set(l,E),this.b.$registerQuickDiffProvider(l,N.DocumentSelector.from(m,this.d),T,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Anc=R}),define(Se[282],Ie([1,0,20,5,6,4,2,7,14,18,32,36,25,8]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=f;function f(s,r,o){const i=s.getProxy(N.$hM.MainThreadQuickOpen);class n{constructor(v,y){this.e=new Map,this.f=0,this.a=v,this.b=y}showQuickPick(v,y,h,D=C.CancellationToken.None){this.c=void 0;const k=Promise.resolve(y),I=++this.f,P=i.$show(I,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},D),V={},W=P.then(()=>V);return Promise.race([W,k]).then(q=>{if(q===V)return;const M=(0,l.$JG)(v,"quickPickItemTooltip");return k.then(z=>{const G=[];for(let ie=0;ie<z.length;ie++){const de=z[ie];if(typeof de=="string")G.push({label:de,handle:ie});else if(de.kind===p.QuickPickItemKind.Separator)G.push({type:"separator",label:de.label});else{de.tooltip&&!M&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const ye=de.iconPath?a(de.iconPath):void 0;G.push({label:de.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:M?b.MarkdownString.fromStrict(de.tooltip):void 0,handle:ie})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=ie=>{h.onDidSelectItem(z[ie])}),i.$setItems(I,G),P.then(ie=>{if(typeof ie=="number")return z[ie];if(Array.isArray(ie))return ie.map(de=>z[de])})})}).then(void 0,q=>{if(!(0,m.$4)(q))return i.$setError(I,q),Promise.reject(q)})}$onItemSelected(v){this.c?.(v)}showInput(v,y=C.CancellationToken.None){return this.d=v?.validateInput,i.$input(v,typeof this.d=="function",y).then(void 0,h=>{if(!(0,m.$4)(h))return Promise.reject(h)})}async $validateInput(v){if(!this.d)return;const y=await this.d(v);if(!y||typeof y=="string")return y;let h;switch(y.severity){case p.InputBoxValidationSeverity.Info:h=T.default.Info;break;case p.InputBoxValidationSeverity.Warning:h=T.default.Warning;break;case p.InputBoxValidationSeverity.Error:h=T.default.Error;break;default:h=y.message?T.default.Error:T.default.Ignore;break}return{content:y.message,severity:h}}async showWorkspaceFolderPick(v,y=C.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!h)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(k=>k.uri.toString()===h.uri.toString())}createQuickPick(v){const y=new d(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(v){const y=new w(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(v,y){this.e.get(v)?._fireDidChangeValue(y)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,y){const h=this.e.get(v);h instanceof d&&h._fireDidChangeActive(y)}$onDidChangeSelection(v,y){const h=this.e.get(v);h instanceof d&&h._fireDidChangeSelection(y)}$onDidTriggerButton(v,y){this.e.get(v)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(v,y,h){const D=this.e.get(v);D instanceof d&&D._fireDidTriggerItemButton(y,h)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class c{static{this.a=1}constructor(v,y){this.x=v,this.y=y,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$fe,this.q=new O.$fe,this.r=new O.$fe,this.s=new O.$fe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((y,h)=>{const D=y===p.$IN.Back?-1:h;this.o.set(D,y)}),this.z({buttons:v.map((y,h)=>({...a(y.iconPath),tooltip:y.tooltip,handle:y===p.$IN.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const y=this.o.get(v);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(v){if(!this.v){for(const y of Object.keys(v)){const h=v[y];this.u[y]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function u($){if($ instanceof p.$gN)return{id:$.id};const v=g($),y=t($);return{dark:typeof v=="string"?R.URI.file(v):v,light:typeof y=="string"?R.URI.file(y):y}}function t($){return typeof $=="object"&&"light"in $?$.light:$}function g($){return typeof $=="object"&&"dark"in $?$.dark:$}function a($){const v=u($);let y,h;return"id"in v?h=S.ThemeIcon.asClassName(v):y=v,{iconPath:y,iconClass:h}}class d extends c{constructor(v,y){super(v.identifier,y),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$fe,this.L=[],this.M=new O.$fe,this.N=new O.$fe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((D,k)=>{this.C.set(k,D),this.D.set(D,k)});const y=(0,l.$JG)(this.O,"quickPickItemTooltip"),h=[];for(let D=0;D<v.length;D++){const k=v[D];if(k.kind===p.QuickPickItemKind.Separator)h.push({type:"separator",label:k.label});else{k.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const I=k.iconPath?a(k.iconPath):void 0;h.push({handle:D,label:k.label,iconPath:I?.iconPath,iconClass:I?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:y?b.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((P,V)=>({...a(P.iconPath),tooltip:P.tooltip,handle:V}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(v){const y=(0,E.$Hb)(v.map(h=>this.C.get(h)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(v){const y=(0,E.$Hb)(v.map(h=>this.C.get(h)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(v,y){const h=this.C.get(v);if(!h||!h.buttons||!h.buttons.length)return;const D=h.buttons[y];D&&this.N.fire({button:D,item:h})}}class w extends c{constructor(v,y){super(v.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:T.default.Error}):this.z({validationMessage:v.message,severity:v.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new n(r,o)}}),define(Se[283],Ie([1,0,2,5,69,6,11,4,18,149,12,21,36,8,25,16,23]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnc=e.$Cnc=void 0;function i(I){return I instanceof C.URI}function n(I,P){return I.scheme===s.Schemas.file&&P.scheme===s.Schemas.file&&r.$k?I.toString()===P.toString():I.toString().toLowerCase()===P.toString().toLowerCase()}function c(I){if(I)return typeof I.iconPath=="string"?C.URI.file(I.iconPath):C.URI.isUri(I.iconPath)||l.ThemeIcon.isThemeIcon(I.iconPath)?I.iconPath:void 0}function u(I){if(I.icon){if(C.URI.isUri(I.icon))return I.icon;if(l.ThemeIcon.isThemeIcon(I.icon))return I.icon;{const P=I.icon;return{light:P.light,dark:P.dark}}}else return}function t(I,P){if(!I.iconPath&&!P.iconPath)return 0;if(I.iconPath){if(!P.iconPath)return 1}else return-1;const V=typeof I.iconPath=="string"?I.iconPath:C.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id,W=typeof P.iconPath=="string"?P.iconPath:C.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,E.$tr)(V,W)}function g(I,P){let V=0;if(I.strikeThrough!==P.strikeThrough)return I.strikeThrough?1:-1;if(I.faded!==P.faded)return I.faded?1:-1;if(I.tooltip!==P.tooltip)return(I.tooltip||"").localeCompare(P.tooltip||"");if(V=t(I,P),V!==0)return V;if(I.light&&P.light)V=t(I.light,P.light);else{if(I.light)return 1;if(P.light)return-1}if(V!==0)return V;if(I.dark&&P.dark)V=t(I.dark,P.dark);else{if(I.dark)return 1;if(P.dark)return-1}return V}function a(I,P){if(I.command!==P.command)return I.command<P.command?-1:1;if(I.title!==P.title)return I.title<P.title?-1:1;if(I.tooltip!==P.tooltip){if(I.tooltip!==void 0&&P.tooltip!==void 0)return I.tooltip<P.tooltip?-1:1;if(I.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(I.arguments===P.arguments)return 0;if(I.arguments)if(P.arguments){if(I.arguments.length!==P.arguments.length)return I.arguments.length-P.arguments.length}else return 1;else return-1;for(let V=0;V<I.arguments.length;V++){const W=I.arguments[V],q=P.arguments[V];if(W!==q&&!(i(W)&&i(q)&&n(W,q)))return W<q?-1:1}return 0}function d(I,P){let V=(0,E.$tr)(I.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(V!==0)return V;if(I.command&&P.command)V=a(I.command,P.command);else{if(I.command)return 1;if(P.command)return-1}if(V!==0)return V;if(I.decorations&&P.decorations)V=g(I.decorations,P.decorations);else{if(I.decorations)return 1;if(P.decorations)return-1}if(I.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)V=(0,E.$tr)(I.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(I.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(I.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)V=(0,E.$tr)(I.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(I.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return V}function w(I,P){for(let V=0;V<I.length;V++)if(I[V]!==P[V])return!1;return!0}function $(I,P){return I.command===P.command&&I.title===P.title&&I.tooltip===P.tooltip&&(I.arguments&&P.arguments?w(I.arguments,P.arguments):I.arguments===P.arguments)}function v(I,P){return(0,m.$ub)(I,P,$)}class y{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,f.$KG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,f.$KG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,f.$KG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,V,W,q,M){this.k=P,this.l=q,this.m=M,this.d="",this.e=new O.$fe,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=W}showValidationMessage(P,V){(0,f.$KG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,V)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$Cnc=y;class h{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,V,W,q,M,z,G){this.q=P,this.s=V,this.t=W,this.u=q,this.v=M,this.multiDiffEditorEnableViewChanges=z,this.w=G,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$fe,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$fe,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=h.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,V){const W=this.h.get(P);return W?(0,R.$qh)(()=>this.s.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(d),W=(0,m.$Db)(this.o,P,d).map(z=>{const G=z.toInsert.map(ie=>{const de=this.e++;this.g.set(de,ie);const ye=ie.resourceUri;let Ee;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const ge=new N.$Tc;Ee=this.s.converter.toInternal(ie.command,ge),this.j.set(de,ge)}else this.h.set(de,ie.command);const me=(0,f.$JG)(this.w,"scmMultiDiffEditor"),ue=me?ie.multiDiffEditorOriginalUri:void 0,Ce=me?ie.multiFileDiffEditorModifiedUri:void 0,se=c(ie.decorations),Oe=ie.decorations&&c(ie.decorations.light)||se,ne=ie.decorations&&c(ie.decorations.dark)||se,U=[Oe,ne],x=ie.decorations&&ie.decorations.tooltip||"",ve=ie.decorations&&!!ie.decorations.strikeThrough,Fe=ie.decorations&&!!ie.decorations.faded,ke=ie.contextValue||"";return{rawResource:[de,ye,U,x,ve,Fe,ke,Ee,ue,Ce],handle:de}});return{start:z.start,deleteCount:z.deleteCount,toInsert:G}}),q=W.map(({start:z,deleteCount:G,toInsert:ie})=>[z,G,ie.map(de=>de.rawResource)]),M=W.reverse();for(const{start:z,deleteCount:G,toInsert:ie}of M){const de=ie.map(Ee=>Ee.handle),ye=this.n.splice(z,G,...de);for(const Ee of ye)this.g.delete(Ee),this.h.delete(Ee),this.j.get(Ee)?.dispose(),this.j.delete(Ee)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class D{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let V;(0,f.$JG)(this.x,"quickDiffProvider")&&(V=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:V})}get historyProvider(){return(0,f.$KG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,f.$KG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new N.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new N.$Tc,this.o=P;const V=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:V})}get actionButton(){return(0,f.$KG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,f.$KG)(this.x,"scmActionButton"),this.p.value=new N.$Tc,this.q=P;const V=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(W=>W.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:V??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&v(this.t,P))return;this.s.value=new N.$Tc,this.t=P;const V=(P||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:V})}get selected(){return this.u}constructor(P,V,W,q,M,z,G){this.x=P,this.y=q,this.z=M,this.A=z,this.B=G,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Vc,this.m=void 0,this.n=new N.$Vc,this.o=void 0,this.p=new N.$Vc,this.s=new N.$Vc,this.t=void 0,this.u=!1,this.v=new O.$fe,this.onDidChangeSelection=this.v.event,this.w=D.d++,this.C=new Map,this.D=new Set,this.#e=W;const ie=C.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:G?`rootUri=${encodeURIComponent(G.toString())}`:void 0});this.f=new y(P,V,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,M,z,G,ie)}createResourceGroup(P,V,W){const q=(0,f.$JG)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,M=new h(this.#e,this.y,this.w,P,V,q,this.x),z=O.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,z),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const P=[],V=[];for(const[W,q]of this.C){q.dispose();const M=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});O.Event.once(W.onDidDispose)(()=>{this.D.delete(W),M.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),P.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const z=W._takeResourceStateSnapshot();z.length>0&&V.push([W.handle,z]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,P,V),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&P.push([V.handle,W])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,A.$4h)(100)],D.prototype,"eventuallyAddResourceGroups",null),Je([(0,A.$4h)(100)],D.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,V,W,q){this.l=V,this.m=W,this.n=q,this.g=new Map,this.h=new S.$Vm,this.j=new O.$fe,this.e=P.getProxy(p.$hM.MainThreadSCM),this.f=P.getProxy(p.$hM.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const z=this.g.get(M.sourceControlHandle);if(!z)return M;const G=z.getResourceGroup(M.groupHandle);return G?G.getResourceState(M.handle):M}else if(M&&M.$mid===4){const z=this.g.get(M.sourceControlHandle);return z?z.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const z=this.g.get(M.handle);return z||M}return M}})}createSourceControl(P,V,W,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,V,W,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const M=o.d++,z=new D(P,this.m,this.e,this.l,V,W,q);this.g.set(M,z);const G=this.h.get(P.identifier)||[];return G.push(z),this.h.set(P.identifier,G),z}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const V=this.h.get(P.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(P,V,W){const q=C.URI.revive(V);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const M=this.g.get(P);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$qh)(()=>M.quickDiffProvider.provideOriginalResource(q,W)).then(z=>z||null)}$onInputBoxValueChange(P,V){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const W=this.g.get(P);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(P,V,W,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,V,W);const M=this.g.get(P);if(!M)return Promise.resolve(void 0);const z=M.getResourceGroup(V);return z?z.$executeResourceCommand(W,q):Promise.resolve(void 0)}$validateInput(P,V,W){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,R.$qh)(()=>q.inputBox.validateInput(V,W)).then(M=>{if(!M)return Promise.resolve(void 0);const z=b.MarkdownString.fromStrict(M.message);return z?Promise.resolve([z,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,V,W,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,q)??void 0}async $provideHistoryItems(P,V,W,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(V,W,q))?.map(G=>({...G,icon:u(G)}))??void 0}async $provideHistoryItemSummary(P,V,W,q){const M=this.g.get(P)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const z=await M.provideHistoryItemSummary(V,W,q);return z?{...z,icon:u(z)}:void 0}async $provideHistoryItemChanges(P,V,W,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(V,W,q)??void 0}};e.$Dnc=k,e.$Dnc=k=o=Je([We(3,T.$5j)],k)}),define(Se[284],Ie([1,0,4,8,2]),function(le,e,C,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=void 0;class N{static{this.a=0}constructor(p,m){this.d=m,this.c=new Map,this.b=p.getProxy(C.$hM.MainThreadShare)}async $provideShare(p,m,E){return await this.c.get(p)?.provideShare({selection:O.Range.to(m.selection),resourceUri:A.URI.revive(m.resourceUri)},E)??void 0}registerShareProvider(p,m){const E=N.a++;return this.c.set(E,m),this.b.$registerShareProvider(E,O.DocumentSelector.from(p,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Enc=N}),define(Se[285],Ie([1,0,7,4,178,6,8,15]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$hN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$hN("statusBarItem.warningForeground")]])}#e;#t;constructor(l,b,f,s,r,o=C.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new N.$Tc,this.#e=l,this.#t=b,r&&s){this.c=(0,C.$VM)(s.identifier,r);const n=f.get(this.c);n&&(o=n.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(m.a++);this.e=s,this.f=r,this.g=o,this.h=this.u(i)}u(l){if((0,p.$cg)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!m.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new N.$Tc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let b;this.m?b=this.m:b=(0,A.localize)(0,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=m.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,b,this.k,s,this.r?.internal,f,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Gnc=m;class E{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const b={message:l};return this.b.unshift(b),this.c(),new C.$jM(()=>{const f=this.b.indexOf(b);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(l,b){this.e=new Map,this.a=l.getProxy(O.$hM.MainThreadStatusBar),this.b=b,this.c=new E(this)}$acceptStaticEntries(l){for(const b of l)this.e.set(b.entryId,b)}createStatusBarEntry(l,b,f,s){return new m(this.a,this.b,this.e,l,b,f,s)}setStatusBarMessage(l,b){const f=this.c.setMessage(l);let s;return typeof b=="number"?s=setTimeout(()=>f.dispose(),b):typeof b<"u"&&b.then(()=>f.dispose(),()=>f.dispose()),new C.$jM(()=>{f.dispose(),clearTimeout(s)})}}e.$Hnc=T}),define(Se[115],Ie([1,0,30,107,52,77,62,8,2]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=e.$YO=e.$XO=void 0;const E=(n,c,u,t)=>{let g=c;return{enumerable:!0,configurable:!1,get(){return g},set(a){if(!u(g,a)){const d=g;g=a,n.listener?.(t(a,d))}}}},T=(n,c)=>n===c,S={range:(n,c)=>n===c?!0:!n||!c?!1:n.isEqual(c),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(n,c)=>!(n.length!==c.length||n.some(u=>!c.find(t=>u.id===t.id)))},l=n=>c=>({op:4,update:n(c)}),b=(n,c)=>({range:(()=>{let u;const t=l(g=>({range:C.$xt.lift(p.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return u},set(g){n.listener?.({op:6}),S.range(u,g)||(u=g,n.listener?.(t(g)))}}})(),label:E(n,c,S.label,l(u=>({label:u}))),description:E(n,void 0,S.description,l(u=>({description:u}))),sortText:E(n,void 0,S.sortText,l(u=>({sortText:u}))),canResolveChildren:E(n,!1,S.canResolveChildren,u=>({op:2,state:u})),busy:E(n,!1,S.busy,l(u=>({busy:u}))),error:E(n,void 0,S.error,l(u=>({error:p.MarkdownString.fromStrict(u)||null}))),tags:E(n,[],S.tags,(u,t)=>({op:1,new:u.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),f=n=>{const c=A.$6K.fromString(n.extId),u=new r(c.controllerId,c.localId,n.label,m.URI.revive(n.uri)||void 0);return u.range=p.Range.to(n.range||void 0),u.description=n.description||void 0,u.sortText=n.sortText||void 0,u.tags=n.tags.map(t=>p.TestTag.to({id:(0,R.$_K)(t).tagId})),u},s=n=>{let c;for(const u of n.tests){const t=f(u.item);(0,O.$HO)(t).parent=c,c=t}return c};e.$XO=s;class r{constructor(c,u,t,g){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const a=(0,O.$GO)(this,c);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof o?void 0:a.parent}},children:{value:(0,N.$FO)(a,O.$HO,r),enumerable:!0,writable:!1},...b(a,t)})}}e.$YO=r;class o extends r{constructor(c,u){super(c,c,u,void 0),this._isRoot=!0}}e.$ZO=o;class i extends N.$BO{constructor(c,u,t){super({controllerId:c,getDocumentVersion:g=>g&&t.getDocument(g)?.version,getApiFor:O.$HO,getChildren:g=>g.children,root:new o(c,u),toITestItem:p.TestItem.from})}}e.$1O=i}),define(Se[35],Ie([1,0,15,7,8,26,4,18,12,49,30,94,2,6,3,17,115,22,34,44,66,59,63,33]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c,u,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=void 0;let a=class{#e;#t;#i;constructor(h,D,k){this.b=new Map,this.c=new Map,this.#e=h.getProxy(R.$hM.MainThreadCommands),this.d=D,this.#i=k,this.#t=h.getProxy(R.$hM.MainThreadTelemetry),this.converter=new d(this,I=>{const P=this.c.get(I);return P?.result===$.Void?P:void 0},D),this.f=[{processArgument(I){return(0,E.$8h)(I)}},{processArgument(I){return(0,N.$7n)(I,function(P){if(T.$xt.isIRange(P))return A.Range.to(P);if(S.$wt.isIPosition(P))return A.Position.to(P);if(T.$xt.isIRange(P.range)&&l.URI.isUri(P.uri))return A.location.to(P);if(P instanceof o.$He)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const D=this.registerCommand(!1,h.id,async(...k)=>{const I=h.args.map((V,W)=>{if(!V.validate(k[W]))throw new Error(`Invalid argument '${V.name}' when running '${h.id}', received: ${typeof k[W]=="object"?JSON.stringify(k[W],null,"	"):k[W]} `);return V.convert(k[W])}),P=await this.executeCommand(h.internalId,...I);return h.result.convert(P,k,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new O.$jM(()=>{D.dispose(),this.c.delete(h.id)})}registerCommand(h,D,k,I,P,V){if(this.d.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this.b.has(D))throw new Error(`command '${D}' already exists`);return this.b.set(D,{callback:k,thisArg:I,metadata:P,extension:V}),h&&this.#e.$registerCommand(D),new O.$jM(()=>{this.b.delete(D)&&h&&this.#e.$unregisterCommand(D)})}executeCommand(h,...D){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,D,!0)}async g(h,D,k){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,D,!1);{let I=!1;const P=(0,N.$7n)(D,function(V){if(V instanceof O.$kM)return A.Position.from(V);if(V instanceof O.$lM)return A.Range.from(V);if(V instanceof O.$vM)return A.location.from(V);if(O.$LN.isNotebookRange(V))return A.NotebookRange.from(V);if(V instanceof ArrayBuffer)return I=!0,o.$He.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return I=!0,o.$He.wrap(V);if(V instanceof o.$He)return I=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(h,I?new i.$Ew(P):P,k);return(0,E.$8h)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(h,D,!1);throw V}}}async h(h,D,k){const I=this.b.get(h);if(!I)throw new Error("Unknown command");const{callback:P,thisArg:V,metadata:W}=I;if(W?.args)for(let M=0;M<W.args.length;M++)try{(0,C.$pg)(D[M],W.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${W.args[M].name}' - ${W.args[M].description}`)}const q=c.$be.create();try{return await P.apply(V,D)}catch(M){if(h===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...D);z&&(h=z.command)}if(this.d.error(M,h,I.extension?.identifier),!k)throw M;if(I.extension?.identifier){const z=this.#i.onExtensionError(I.extension.identifier,M);this.d.trace("forwarded error to extension?",z,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$jj)(M)),this.id=h,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,h,q.elapsed())}}j(h,D,k){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new u.$ip(D),duration:k})}$executeContributedCommand(h,...D){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const k=this.b.get(h);return k?(D=D.map(I=>this.f.reduce((P,V)=>V.processArgument(P,k.extension?.identifier),I)),this.h(h,D,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(D=>(h&&(D=D.filter(k=>k[0]!=="_")),D))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[D,k]of this.b){const{metadata:I}=k;I&&(h[D]=I)}return Promise.resolve(h)}};e.$7O=a,e.$7O=a=Je([We(0,s.$LO),We(1,m.$5j),We(2,t.$6O)],a),e.$8O=(0,f.$yi)("IExtHostCommands");class d{constructor(h,D,k){this.d=h,this.f=D,this.g=k,this.delegatingCommandId=`__vsc${(0,g.$Ug)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,D){if(!h)return;const k={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return k;const I=this.f(h.command);if(I)k.id=I.internalId,k.arguments=I.args.map((P,V)=>P.convert(h.arguments&&h.arguments[V]));else if((0,p.$Lb)(h.arguments)){const P=`${h.command} /${++this.c}`;this.b.set(P,h),D.add((0,b.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),k.$ident=P,k.id=this.delegatingCommandId,k.arguments=[P],this.g.trace("CommandsConverter#CREATE",h.command,P)}return k}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const D=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],D?D.command:"MISSING"),D?this.d.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$9O=d;class w{static{this.Uri=new w("uri","Uri of a text document",h=>l.URI.isUri(h),h=>h)}static{this.Position=new w("position","A position in a text document",h=>O.$kM.isPosition(h),A.Position.from)}static{this.Range=new w("range","A range in a text document",h=>O.$lM.isRange(h),A.Range.from)}static{this.Selection=new w("selection","A selection in a text document",h=>O.$mM.isSelection(h),A.Selection.from)}static{this.Number=new w("number","",h=>typeof h=="number",h=>h)}static{this.String=new w("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=w.Arr(w.String)}static Arr(h){return new w(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,D=>Array.isArray(D)&&D.every(k=>h.validate(k)),D=>D.map(k=>h.convert(k)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",h=>h instanceof O.$HM,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",h=>h instanceof O.$6N,A.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",h=>h instanceof r.$YO,A.TestItem.from)}constructor(h,D,k,I){this.name=h,this.description=D,this.validate=k,this.convert=I}optional(){return new w(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,D){return new w(h??this.name,D??this.description,this.validate,this.convert)}}e.$0O=w;class ${static{this.Void=new $("no result",h=>h)}constructor(h,D){this.description=h,this.convert=D}}e.$$O=$;class v{constructor(h,D,k,I,P){this.id=h,this.internalId=D,this.description=k,this.args=I,this.result=P}}e.$_O=v}),define(Se[286],Ie([1,0,18,16,2,89,98,31,35,8,7]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;const S=[new m.$_O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$0O.Uri,m.$0O.Position],new m.$$O("A promise that resolves to an array of DocumentHighlight-instances.",b(E.DocumentHighlight.to))),new m.$_O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$0O.Uri],new m.$$O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,r)=>{if((0,C.$Kb)(s))return;class o extends T.$CM{static to(n){const c=new o(n.name,E.SymbolKind.to(n.kind),n.containerName||"",new T.$vM(r[0],E.Range.to(n.range)));return c.detail=n.detail,c.range=c.location.range,c.selectionRange=E.Range.to(n.selectionRange),c.children=n.children?n.children.map(o.to):[],c}}return s.map(o.to)})),new m.$_O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$0O.Uri,new m.$0O("options","Formatting options",s=>!0,s=>s)],new m.$$O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$_O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$0O.Uri,m.$0O.Range,new m.$0O("options","Formatting options",s=>!0,s=>s)],new m.$$O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$_O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$0O.Uri,m.$0O.Position,new m.$0O("ch","Trigger character",s=>typeof s=="string",s=>s),new m.$0O("options","Formatting options",s=>!0,s=>s)],new m.$$O("A promise that resolves to an array of TextEdits.",b(E.TextEdit.to))),new m.$_O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$0O.Uri,m.$0O.Position],new m.$$O("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$_O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$0O.Uri,m.$0O.Position],new m.$$O("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$_O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$0O.Uri,m.$0O.Position],new m.$$O("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$_O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$0O.Uri,m.$0O.Position],new m.$$O("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$_O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$0O.Uri,m.$0O.Position],new m.$$O("A promise that resolves to an array of Location-instances.",b(E.location.to))),new m.$_O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$0O.Uri,m.$0O.Position],new m.$$O("A promise that resolves to an array of Hover-instances.",b(E.Hover.to))),new m.$_O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$0O.Uri,new m.$0O("position","A position in a text document",s=>Array.isArray(s)&&s.every(r=>T.$kM.isPosition(r)),s=>s.map(E.Position.from))],new m.$$O("A promise that resolves to an array of ranges.",s=>s.map(r=>{let o;for(const i of r.reverse())o=new T.$GM(E.Range.to(i),o);return o}))),new m.$_O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$0O.String.with("query","Search string")],new m.$$O("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(E.WorkspaceSymbol.to))),new m.$_O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$0O.Uri,m.$0O.Position],new m.$$O("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(E.CallHierarchyItem.to))),new m.$_O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$0O.CallHierarchyItem],new m.$$O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(E.CallHierarchyIncomingCall.to))),new m.$_O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$0O.CallHierarchyItem],new m.$$O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(E.CallHierarchyOutgoingCall.to))),new m.$_O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$0O.Uri,m.$0O.Position],new m.$$O("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:E.Range.to(s.range),placeholder:s.text}})),new m.$_O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$0O.Uri,m.$0O.Position,m.$0O.String.with("newName","The new symbol name")],new m.$$O("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return E.WorkspaceEdit.to(s)}})),new m.$_O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$0O.Uri,m.$0O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$$O("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(E.DocumentLink.to))),new m.$_O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$0O.Uri],new m.$$O("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$CN(s.tokenTypes,s.tokenModifiers)})),new m.$_O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$0O.Uri],new m.$$O("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const r=(0,R.$Abb)(s);if(r.type==="full")return new T.$EN(r.data,void 0)})),new m.$_O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$0O.Uri,m.$0O.Range.optional()],new m.$$O("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$CN(s.tokenTypes,s.tokenModifiers)})),new m.$_O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$0O.Uri,m.$0O.Range],new m.$$O("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const r=(0,R.$Abb)(s);if(r.type==="full")return new T.$EN(r.data,void 0)})),new m.$_O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$0O.Uri,m.$0O.Position,m.$0O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$0O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$$O("A promise that resolves to a CompletionList-instance.",(s,r,o)=>{if(!s)return new T.$SM([]);const i=s.suggestions.map(n=>E.CompletionItem.to(n,o));return new T.$SM(i,s.incomplete)})),new m.$_O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$0O.Uri,m.$0O.Position,m.$0O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$$O("A promise that resolves to SignatureHelp.",s=>{if(s)return E.SignatureHelp.to(s)})),new m.$_O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$0O.Uri,m.$0O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$$O("A promise that resolves to an array of CodeLens-instances.",(s,r,o)=>b(i=>new T.$KM(E.Range.to(i.range),i.command&&o.fromInternal(i.command)))(s))),new m.$_O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$0O.Uri,new m.$0O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.$lM.isRange(s),s=>T.$mM.isSelection(s)?E.Selection.from(s):E.Range.from(s)),m.$0O.String.with("kind","Code action kind to return code actions for").optional(),m.$0O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$$O("A promise that resolves to an array of Command-instances.",(s,r,o)=>b(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const n=new T.$EM(i.title,i.kind?new T.$FM(i.kind):void 0);return i.edit&&(n.edit=E.WorkspaceEdit.to(i.edit)),i.command&&(n.command=o.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(s))),new m.$_O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$0O.Uri],new m.$$O("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(r=>new T.$YM(E.Range.to(r.range),E.Color.to(r.color))):[])),new m.$_O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$0O("color","The color to show and insert",s=>s instanceof T.$XM,E.Color.from),new m.$0O("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:E.Range.from(s.range)}))],new m.$$O("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(E.ColorPresentation.to):[])),new m.$_O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$0O.Uri,m.$0O.Range],new m.$$O("A promise that resolves to an array of Inlay objects",(s,r,o)=>s.map(E.InlayHint.to.bind(void 0,o)))),new m.$_O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$0O.Uri],new m.$$O("A promise that resolves to an array of FoldingRange objects",(s,r)=>{if(s)return s.map(E.FoldingRange.to)})),new m.$_O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$$O("A promise that resolves to an array of NotebookContentProvider static info objects.",b(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(r=>E.NotebookExclusiveDocumentPattern.to(r))})))),new m.$_O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$0O.Uri,m.$0O.Range,new m.$0O("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof T.$lM,s=>E.InlineValueContext.from(s))],new m.$$O("A promise that resolves to an array of InlineValue objects",s=>s.map(E.InlineValue.to))),new m.$_O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$0O("uriOrString","Uri-instance or string (only http/https)",s=>A.URI.isUri(s)||typeof s=="string"&&(0,O.$Ig)(s,O.Schemas.http,O.Schemas.https),s=>s),new m.$0O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[E.ViewColumn.from(s),void 0]:[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)])).optional(),m.$0O.String.with("label","").optional()],m.$$O.Void),new m.$_O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$0O.Uri.with("resource","Resource to open"),m.$0O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$0O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[E.ViewColumn.from(s),void 0]:[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)])).optional()],m.$$O.Void),new m.$_O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$0O.Uri.with("left","Left-hand side resource of the diff editor"),m.$0O.Uri.with("right","Right-hand side resource of the diff editor"),m.$0O.String.with("title","Human readable title for the diff editor").optional(),new m.$0O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)]).optional()],m.$$O.Void),new m.$_O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$0O.String.with("title","Human readable title for the changes editor"),new m.$0O("resourceList","List of resources to compare",s=>{for(const r of s){if(r.length!==3)return!1;const[o,i,n]=r;if(!A.URI.isUri(o)||!A.URI.isUri(i)&&i!==void 0&&i!==null||!A.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},s=>s)],m.$$O.Void),new m.$_O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$0O.Uri,m.$0O.Position],new m.$$O("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new m.$_O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$0O.TypeHierarchyItem],new m.$$O("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new m.$_O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$0O.TypeHierarchyItem],new m.$$O("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new m.$_O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$0O.TestItem],m.$$O.Void),new m.$_O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$0O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$$O.Void),new m.$_O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$0O.String.with("name","The context key name"),new m.$0O("value","The context key value",()=>!0,s=>s)],m.$$O.Void),new m.$_O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$0O.Uri,m.$0O.StringArray,new m.$0O("MappedEditsContext","Mapped Edits Context",s=>E.MappedEditsContext.is(s),s=>E.MappedEditsContext.from(s))],new m.$$O("A promise that resolves to a workspace edit or null",s=>s?E.WorkspaceEdit.to(s):null)),new m.$_O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$0O("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?E.Range.from(s.initialRange):void 0,initialSelection:T.$mM.isSelection(s.initialSelection)?E.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?E.Position.from(s.position):void 0}})],m.$$O.Void)];class l{static register(r){S.forEach(r.registerApiCommand,r),this.a(r)}static a(r){r.registerCommand(!1,"_validateWhenClauses",p.$xj)}}e.$3lc=l;function b(s){return r=>{if(Array.isArray(r))return r.map(s)}}function f(s){if(!Array.isArray(s))return;const r=[];for(const o of s)N.$cu(o)?r.push(E.DefinitionLink.to(o)):r.push(E.location.to(o));return r}}),define(Se[287],Ie([1,0,2,35]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;class A{constructor(R,p,m,E,T){this.a=p,this.b=m,this.c=E;const S=new O.$_O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$0O("showOptions","Show Options",l=>!0,l=>l),new O.$0O("resource","Interactive resource Uri",l=>!0,l=>l),new O.$0O("controllerId","Notebook controller Id",l=>!0,l=>l),new O.$0O("title","Interactive editor title",l=>!0,l=>l)],new O.$$O("Notebook and input URI",l=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const b=this.a.getEditorById(l.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:C.URI.revive(l.notebookUri),inputUri:C.URI.revive(l.inputUri),notebookEditor:b.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:C.URI.revive(l.notebookUri),inputUri:C.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(R,p,m,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:m,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$mnc=A}),define(Se[288],Ie([1,0,18,11,20,5,6,28,2,21,12,4,35,8,7,78,229,25,34,230]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0,e.$unc=w;let c=class{constructor(v,y,h,D,k){this.m=y,this.n=h,this.o=D,this.q=k,this.b=new p.$Ac,this.c=new p.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$fe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=v.getProxy(S.$hM.MainThreadNotebookKernels);const I=new l.$_O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$0O("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const W=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:W}}else if(V&&"notebookEditor"in V){const W=this.n.getIdByEditor(V.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return V})],l.$$O.Void),P=new l.$_O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$0O.Uri],new l.$$O("A promise that resolves to an array of variables",(V,W)=>V.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(I),this.o.registerApiCommand(P)}createNotebookController(v,y,h,D,k,I){for(const se of this.j.values())if(se.controller.id===y&&E.$Tm.equals(v.identifier,se.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const P=this.k++,V=this;this.q.trace(`NotebookController[${P}], CREATED by ${v.identifier.value}, ${y}`);const W=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${v.identifier}'`);let q=!1;const M=new N.$fe,z=new N.$fe,G={id:w(v.identifier,y),notebookType:h,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:D||v.identifier.value,preloads:I?I.map(b.NotebookRendererScript.from):[]};let ie=k??W,de,ye;this.a.$addKernel(P,G).catch(se=>{console.log(se),q=!0});let Ee=0;const me=()=>{if(q)return;const se=++Ee;Promise.resolve().then(()=>{se===Ee&&this.a.$updateKernel(P,G)})},ue=new p.$Ac,Ce={get id(){return y},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return G.label},set label(se){G.label=se??v.displayName??v.name,me()},get detail(){return G.detail??""},set detail(se){G.detail=se,me()},get description(){return G.description??""},set description(se){G.description=se,me()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(se){G.supportedLanguages=se,me()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(se){G.supportsExecutionOrder=se,me()},get rendererScripts(){return G.preloads?G.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(se){ie=se??W},get interruptHandler(){return de},set interruptHandler(se){de=se,G.supportsInterrupt=!!se,me()},set variableProvider(se){(0,o.$KG)(v,"notebookVariableProvider"),ye=se,G.hasVariableProvider=!!se,se?.onDidChangeVariables(Oe=>V.a.$variablesUpdated(Oe.uri)),me()},get variableProvider(){return ye},createNotebookCellExecution(se){if(q)throw new Error("notebook controller is DISPOSED");if(!ue.has(se.notebook.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Oe=>Oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return V._createNotebookCellExecution(se,w(v.identifier,this.id))},createNotebookExecution(se){if((0,o.$KG)(v,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!ue.has(se.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Oe=>Oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return V._createNotebookExecution(se,w(v.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),M.dispose(),z.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(se,Oe){Oe===f.NotebookControllerAffinity2.Hidden&&(0,o.$KG)(v,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(P,se.uri,Oe)},onDidReceiveMessage:z.event,postMessage(se,Oe){return(0,o.$KG)(v,"notebookMessaging"),V.a.$postMessage(P,Oe&&V.n.getIdByEditor(Oe),se)},asWebviewUri(se){return(0,o.$KG)(v,"notebookMessaging"),(0,s.$$Ab)(se,V.m.remote)}};return this.j.set(P,{extensionId:v.identifier,controller:Ce,onDidReceiveMessage:z,onDidChangeSelection:M,associatedNotebooks:ue}),Ce}getIdByController(v){for(const[y,h]of this.j)if(h.controller===v)return w(h.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,y){const h=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask(h,y);const k={dispose:()=>{this.f.delete(h),D.a.$removeKernelDetectionTask(h)}};return this.f.set(h,k),k}registerKernelSourceActionProvider(v,y,h){const D=this.i++,k=typeof h.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,I=this;this.h.set(D,h),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,y);let P;return k!==void 0&&(P=h.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(D),I.a.$removeKernelSourceActionProvider(D,D),P?.dispose()}}}async $provideKernelSourceActions(v,y){const h=this.h.get(v);if(h){const D=new R.$Tc;return(await h.provideNotebookKernelSourceActions(y)??[]).map(I=>b.NotebookKernelSourceAction.from(I,this.o.converter,D))}return[]}$acceptNotebookAssociation(v,y,h){const D=this.j.get(v);if(D){const k=this.n.getNotebookDocument(m.URI.revive(y));h?D.associatedNotebooks.set(k.uri,!0):D.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,k.uri.toString(),h),D.onDidChangeSelection.fire({selected:h,notebook:k.apiNotebook})}}async $executeCells(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getNotebookDocument(m.URI.revive(y)),I=[];for(const P of h){const V=k.getCell(P);V&&I.push(V.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,k.uri.toString(),I.length),await D.controller.executeHandler.call(D.controller,I,k.apiNotebook,D.controller)}catch(P){this.q.error(`NotebookController[${v}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getNotebookDocument(m.URI.revive(y));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,k.apiNotebook);else for(const I of h){const P=k.getCell(I);P&&this.b.get(P.uri)?.cancel()}if(D.controller.interruptHandler){const I=this.c.get(k.uri);this.c.delete(k.uri),h.length&&Array.isArray(I)&&I.length&&I.forEach(P=>P.dispose())}}async $provideVariables(v,y,h,D,k,I,P){const V=this.j.get(v);if(!V)return;const W=this.n.getNotebookDocument(m.URI.revive(h)),q=V.controller.variableProvider;if(!q)return;let M;if(D!==void 0){if(M=this.s[D],!M)return}else this.s={};const z=k==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,G=q.provideVariables(W.apiNotebook,M,z,I,P);let ie=0;for await(const de of G){if(P.isCancellationRequested)return;const ye={id:this.r++,name:de.variable.name,value:de.variable.value,type:de.variable.type,interfaces:de.variable.interfaces,language:de.variable.language,expression:de.variable.expression,hasNamedChildren:de.hasNamedChildren,indexedChildrenCount:de.indexedChildrenCount,extensionId:V.extensionId.value};if(this.s[ye.id]=de.variable,this.a.$receiveVariable(y,ye),ie++>=n.$Sib)return}}$acceptKernelMessageFromRenderer(v,y,h){const D=this.j.get(v);if(!D)return;const k=this.n.getEditorById(y);D.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:h}))}$cellExecutionChanged(v,y,h){const k=this.n.getNotebookDocument(m.URI.revive(v)).getCell(y);if(k){const I=h?b.NotebookCellExecutionState.to(h):f.NotebookCellExecutionState.Idle;I!==void 0&&this.l.fire({cell:k.apiCell,state:I})}}_createNotebookCellExecution(v,y){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const k=new t(y,D,this.a);this.b.set(D.uri,k);const I=k.onDidChangeState(()=>{k.state===u.Resolved&&(k.dispose(),I.dispose(),this.b.delete(D.uri))});return k.asApiObject()}_createNotebookExecution(v,y){const h=this.n.getNotebookDocument(v.uri),D=v.getCells().find(P=>{const V=h.getCellFromApiCell(P);return V&&this.b.has(V.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const k=new a(y,h,this.a),I=k.onDidChangeState(()=>{k.state===g.Resolved&&(k.dispose(),I.dispose(),this.c.delete(h.uri))});return this.c.set(h.uri,[k,I]),k.asApiObject()}};e.$tnc=c,e.$tnc=c=Je([We(4,T.$5j)],c);var u;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(u||(u={}));class t extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.m=y,this.n=h,this.b=t.a++,this.c=new N.$fe,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new A.$qe),this.h=new d(10,D=>this.s(D)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,v,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(v){await this.h.addItem(v)}async s(v){const y=Array.isArray(v)?v:[v];return this.n.$updateExecution(this.b,new i.$Ew(y))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(v){let y=this.m;if(v&&(y=this.m.notebook.getCellFromApiCell(v)),!y)throw new Error("INVALID cell");return y.handle}y(v){return v.map(y=>{const h=f.$PN.ensureUniqueMimeTypes(y.items,!0);return h===y.items?b.NotebookCellOutput.from(y):b.NotebookCellOutput.from({items:h,id:y.id,metadata:y.metadata})})}async z(v,y,h){const D=this.w(y),k=this.y((0,C.$2b)(v));return this.r({editType:r.CellExecutionUpdateType.Output,cellHandle:D,append:h,outputs:k})}async C(v,y,h){return v=f.$PN.ensureUniqueMimeTypes((0,C.$2b)(v),!0),this.r({editType:r.CellExecutionUpdateType.OutputItems,items:v.map(b.NotebookCellOutputItem.from),outputId:y.id,append:h})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.m.apiCell},get executionOrder(){return v.j},set executionOrder(h){v.j=h,v.s([{editType:r.CellExecutionUpdateType.ExecutionState,executionOrder:v.j}])},start(h){if(v.f===u.Resolved||v.f===u.Started)throw new Error("Cannot call start again");v.f=u.Started,v.c.fire(),v.s({editType:r.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,D,k){if(v.f===u.Resolved)throw new Error("Cannot call resolve twice");v.f=u.Resolved,v.c.fire(),v.h.flush();const I=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;v.n.$completeExecution(v.b,new i.$Ew({runEndTime:D,lastRunSuccess:h,error:I}))},clearOutput(h){return v.t(),v.z([],h,!1)},appendOutput(h,D){return v.t(),v.z(h,D,!0)},replaceOutput(h,D){return v.t(),v.z(h,D,!1)},appendOutputItems(h,D){return v.t(),v.C(h,D,!0)},replaceOutputItems(h,D){return v.t(),v.C(h,D,!1)}})}}var g;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(g||(g={}));class a extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.h=y,this.j=h,this.b=a.a++,this.c=new N.$fe,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new A.$qe),this.j.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===g.Resolved||this.f===g.Started)throw new Error("Cannot call start again");this.f=g.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===g.Resolved)throw new Error("Cannot call resolve twice");this.f=g.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(v,y){this.f=v,this.g=y,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new O.$Vh,this.b=Date.now(),(0,O.$zh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>v.complete())}}function w($,v){return`${$.value}/${v}`}}),define(Se[53],Ie([1,0,5,4,3,2,17,6,7,180,14,208,20,33,209,36,11,8,35]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=e.$Gmc=e.$Fmc=e.$Emc=void 0,e.$Emc=(0,A.$yi)("IExtHostTerminalService");class n extends p.$Uc{constructor(h,D,k,I){super(),this.u=h,this._id=D,this.w=k,this.y=I,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new C.$fe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(V,W=!0){P.C(),P.u.$sendText(P._id,V,W)},show(V){P.C(),P.u.$show(P._id,V)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(h,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??D?.cwd??void 0,env:h.env??void 0,icon:w(h.iconPath)??void 0,color:s.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.z(h.location,D?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,D,k,I,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:I,color:s.ThemeColor.isThemeColor(P)?P.id:void 0,location:D?.location||this.z(h,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(h,D){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in h?{viewColumn:o.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.y=h}setExitStatus(h,D){this.j=Object.freeze({code:h,reason:D})}setDimensions(h,D){return h===this.f&&D===this.h||h===0||D===0?!1:(this.f=h,this.h=D,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(h){this.n=h}_setProcessId(h){this.g?(this.g(h),this.g=void 0):this.b.then(D=>{D!==h&&(this.b=Promise.resolve(h))})}}e.$Fmc=n;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new C.$fe,this.onProcessData=this.a.event,this.b=new C.$fe,this.d=new C.$fe,this.onDidChangeProperty=this.d.event,this.f=new C.$fe,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,D){this.g.setDimensions?.({columns:h,rows:D})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,D,k){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$fe,this.onDidCloseTerminal=this.H.event,this.I=new C.$fe,this.onDidOpenTerminal=this.I.event,this.J=new C.$fe,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$fe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$fe,this.onDidChangeTerminalState=this.M.event,this.N=new C.$fe,this.onDidChangeShell=this.N.event,this.O=new C.$fe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$fe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(O.$hM.MainThreadTerminalService),this.y=new f.$9vb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:I=>{const P=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(I?.$mid){case 15:return P(I);default:{if(Array.isArray(I))for(let V=0;V<I.length&&I[V].$mid===15;V++)I[V]=P(I[V]);return I}}}}),this.B({dispose:()=>{for(const[I,P]of this.g)P.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,D){const k=new n(this.a,(0,b.$Ug)(),h,h.name),I=new c(h.pty);return k.createExtensionTerminal(h.location,D,this.R(h,D).resolvedExtHostIdentifier,w(h.iconPath),$(h.color)).then(P=>{const V=this.S(P,I);this.h[P]=V}),this.f.push(k),k.value}R(h,D){if(D=D||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const k=h.location.parentTerminal;if(k){const I=this.f.find(P=>P.value===k);I&&(D.resolvedExtHostIdentifier=I._id)}}else h.location&&typeof h.location!="object"?D.location=h.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal(h,D){if(!this.getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const I=new c(D),P=this.S(h,I);this.h[h]=P}async $acceptActiveTerminalChanged(h){const D=this.b;if(h===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(h);k&&(this.b=k,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,D){const k=this.getTerminalById(h);k&&this.O.fire({terminal:k.value,data:D})}async $acceptTerminalDimensions(h,D,k){const I=this.getTerminalById(h);I&&I.setDimensions(D,k)&&this.L.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptDidExecuteCommand(h,D){const k=this.getTerminalById(h);k&&this.P.fire({terminal:k.value,...D})}async $acceptTerminalMaximumDimensions(h,D,k){this.g.get(h)?.resize(D,k)}async $acceptTerminalTitleChange(h,D){const k=this.getTerminalById(h);k&&(k.name=D)}async $acceptTerminalClosed(h,D,k){const I=this.X(this.f,h);if(I!==null){const P=this.f.splice(I,1)[0];P.setExitStatus(D,k),this.H.fire(P.value)}}$acceptTerminalOpened(h,D,k,I){if(D){const W=this.X(this.f,D);if(W!==null){this.f[W]._id=h,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const P={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:N.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},V=new n(this.a,h,P,k);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(h,D){this.getTerminalById(h)?._setProcessId(D)}async $startExtensionTerminal(h,D){const k=this.getTerminalById(h);if(!k)return{message:(0,E.localize)(0,null,h)};k.isOpen||await new Promise(P=>{const V=this.onDidOpenTerminal(async W=>{W===k.value&&(V.dispose(),P())})});const I=this.g.get(h);I?I.startSendingEvents(D):this.j[h]={initialDimensions:D}}S(h,D){const k=new p.$Tc;k.add(D.onProcessReady(P=>this.a.$sendProcessReady(h,P.pid,P.cwd,P.windowsPty))),k.add(D.onDidChangeProperty(P=>this.a.$sendProcessProperty(h,P))),this.y.startBuffering(h,D.onProcessData),k.add(D.onProcessExit(P=>this.U(h,P))),this.g.set(h,D);const I=this.j[h];return I&&D instanceof c&&(D.startSendingEvents(I.initialDimensions),delete this.j[h]),k}$acceptProcessAckDataEvent(h,D){this.g.get(h)?.acknowledgeDataEvent(D)}$acceptProcessInput(h,D){this.g.get(h)?.input(D)}$acceptTerminalInteraction(h){const D=this.getTerminalById(h);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection(h,D){this.getTerminalById(h)?.setSelection(D)}$acceptProcessResize(h,D,k){try{this.g.get(h)?.resize(D,k)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(h,D){this.g.get(h)?.shutdown(D)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(D=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(D=>this.a.$sendProcessProperty(h,{type:"cwd",value:D}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new m.$jM(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,D,k){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,k),this.a.$registerProfileProvider(D,h.identifier.value),new m.$jM(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider(h,D,k){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,k),this.a.$registerQuickFixProvider(h,D),new m.$jM(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,D){const k=new l.$qe().token;if(k.isCancellationRequested)return;const I=this.D.get(h);if(!I)return;const P=await I.provideTerminalQuickFixes(D,k);if(P===null||Array.isArray(P)&&P.length===0)return;const V=new p.$Tc;if(this.w.value=V,!Array.isArray(P))return P?o.TerminalQuickFix.from(P,this.Q.converter,V):void 0;const W=[];for(const q of P){const M=o.TerminalQuickFix.from(q,this.Q.converter,V);M&&W.push(M)}return W}async $createContributedProfileTerminal(h,D){const k=new l.$qe().token;let I=await this.C.get(h)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,D);return}this.createTerminalFromOptions(I.options,D)}}async $provideLinks(h,D){const k=this.getTerminalById(h);if(!k)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const P=new l.$qe;this.G.set(h,P);const V=[],W={terminal:k.value,line:D},q=[];for(const G of this.z)q.push(r.Promises.withAsyncBody(async ie=>{P.token.onCancellationRequested(()=>ie({provider:G,links:[]}));const de=await G.provideTerminalLinks(W,P.token)||[];P.token.isCancellationRequested||ie({provider:G,links:de})}));const M=await Promise.all(q);if(P.token.isCancellationRequested)return[];const z=new Map;for(const G of M)G&&G.links.length>0&&V.push(...G.links.map(ie=>{const de={id:u++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return z.set(de.id,{provider:G.provider,link:ie}),de}));return this.F.set(h,z),V}$activateLink(h,D){const k=this.F.get(h)?.get(D);k&&k.provider.handleTerminalLink(k.link)}U(h,D){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const k=this.h[h];k&&(k.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,D)}getTerminalById(h){return this.W(this.f,h)}getTerminalIdByApiObject(h){const D=this.f.findIndex(k=>k.value===h);return D>=0?D:null}W(h,D){const k=this.X(h,D);return k!==null?h[k]:null}X(h,D){const k=h.findIndex(I=>I._id===D);return k>=0?k:null}getEnvironmentVariableCollection(h){let D=this.n.get(h.identifier.value);return D||(D=new g,this.Z(h.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Y(h,D){const k=(0,S.$os)(D.map),I=(0,S.$ps)(D.descriptionMap);this.a.$setEnvironmentVariableCollection(h,D.persistent,k.length===0?void 0:k,I)}$initEnvironmentVariableCollections(h){h.forEach(D=>{const k=D[0],I=new g(D[1]);this.Z(k,I)})}$acceptDefaultProfile(h,D){const k=this.s;this.s=h,this.u=D,k?.path!==h.path&&this.N.fire(h.path)}Z(h,D){this.n.set(h,D),D.onDidChangeCollection(()=>{this.Y(h,D)})}};e.$Gmc=t,e.$Gmc=t=Je([We(1,i.$8O),We(2,R.$LO)],t);class g{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$fe,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const D=this.h(h);let k=this.a.get(D);return k||(k=new a(this,h),this.a.set(D,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(h,D,k,I){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:I})}append(h,D,k,I){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:I})}prepend(h,D,k,I){this.f(h,{value:D,type:m.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:I})}f(h,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(h,D.scope),I=this.map.get(k),P=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!I||I.value!==D.value||I.type!==D.type||I.options?.applyAtProcessCreation!==P.applyAtProcessCreation||I.options?.applyAtShellIntegration!==P.applyAtShellIntegration||I.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const V=this.g(h,D.scope),W={variable:h,...D,options:P};this.map.set(V,W),this.d.fire()}}get(h,D){const k=this.g(h,D),I=this.map.get(k);return I?v(I):void 0}g(h,D){const k=this.h(D);return k.length?`${h}:::${k}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const D=new Map;for(const[k,I]of this.map)this.h(I.scope)===this.h(h)&&D.set(I.variable,v(I));return D}delete(h,D){const k=this.g(h,D);this.map.delete(k),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[D,k]of this.map)k.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(D);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,D){const k=this.h(D),I=this.descriptionMap.get(k);if(!I||I.description!==h){let P;typeof h=="string"?P=h:P=h?.value.split(`

`)[0];const V={description:P,scope:D};this.descriptionMap.set(k,V),this.d.fire()}}getDescription(h){const D=this.h(h);return this.descriptionMap.get(D)?.description}k(h){const D=this.h(h);this.descriptionMap.delete(D)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,D){this.b=h,this.d=D,this.a=new C.$fe}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,D,k){this.b.replace(h,D,k,this.d)}append(h,D,k){this.b.append(h,D,k,this.d)}prepend(h,D,k){this.b.prepend(h,D,k,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,D){this.b.getVariableMap(this.d).forEach((k,I)=>h.call(D,I,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends t{constructor(h,D){super(!1,h,D)}createTerminal(h,D,k){throw new T.$_}createTerminalFromOptions(h,D){throw new T.$_}};e.$Hmc=d,e.$Hmc=d=Je([We(0,i.$8O),We(1,R.$LO)],d);function w(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function $(y){return s.ThemeColor.isThemeColor(y)?y:void 0}function v(y){const h={...y};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Se[116],Ie([1,0,7,6,3,4,17,53,5,2,11]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=e.$Lnc=void 0,e.$Lnc=(0,A.$yi)("IExtHostTerminalShellIntegration");let S=class extends O.$Uc{constructor(r,o){super(),this.h=o,this.b=new Map,this.c=new m.$fe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$fe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$fe,this.onDidEndTerminalShellExecution=this.g.event,this.a=r.getProxy(N.$hM.MainThreadTerminalShellIntegration),this.B((0,O.$Sc)(()=>{for(const[i,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(r){const o=this.h.getTerminalById(r);if(!o)return;const i=o.value;let n=this.b.get(r);n||(n=new l(o.value,this.f),this.b.set(r,n),n.store.add(o.onWillDispose(()=>this.b.get(r)?.dispose())),n.store.add(n.onDidRequestShellExecution(c=>this.a.$executeCommand(r,c))),n.store.add(n.onDidRequestEndExecution(c=>this.g.fire(c))),n.store.add(n.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),o.shellIntegration=n.value),this.c.fire({terminal:i,shellIntegration:n.value})}$shellExecutionStart(r,o,i,n,c){this.b.has(r)||this.$shellIntegrationChange(r);const u={value:o,confidence:i,isTrusted:n};this.b.get(r)?.startShellExecution(u,c)}$shellExecutionEnd(r,o,i,n,c){const u={value:o,confidence:i,isTrusted:n};this.b.get(r)?.endShellExecution(u,c)}$shellExecutionData(r,o){this.b.get(r)?.emitData(o)}$cwdChange(r,o){this.b.get(r)?.setCwd((0,E.$vc)(o)?E.URI.revive(o):o)}$closeTerminal(r){this.b.get(r)?.dispose(),this.b.delete(r)}};e.$Mnc=S,e.$Mnc=S=Je([We(0,R.$LO),We(1,p.$Emc)],S);class l extends O.$Uc{get currentExecution(){return this.a}constructor(r,o){super(),this.j=r,this.m=o,this.b=!1,this.store=this.B(new O.$Tc),this.f=this.B(new m.$fe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$fe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$fe),this.onDidRequestEndExecution=this.h.event;const i=this;this.value={get cwd(){return i.c},executeCommand(n,c){let u=n;c&&(u+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),i.g.fire(u);const t={value:u,confidence:C.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},g=i.startShellExecution(t,i.c,!0).value;return i.b=!0,g}}}startShellExecution(r,o,i){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new b(r,o);i?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(r){this.currentExecution?.emitData(r)}endShellExecution(r,o){this.a&&(this.a.endExecution(r),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(r){let o=!1;E.URI.isUri(this.c)?o=!E.URI.isUri(r)||this.c.toString()!==r.toString():this.c!==r&&(o=!0),o&&(this.c=r,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class b{constructor(r,o){this.c=r,this.cwd=o,this.b=!1;const i=this;this.value={get commandLine(){return i.c},get cwd(){return i.cwd},read(){return i.d()}}}d(){if(!this.a){if(this.b)return T.$Yh.EMPTY;this.a=new f}return this.a.createIterable()}emitData(r){this.a?.emitData(r)}endExecution(r){r&&(this.c=r),this.a?.endExecution(),this.a=void 0,this.b=!0}}class f extends O.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new T.$xh);const r=this.a;return new T.$Yh(async i=>{this.b.push(i),await r.wait()})}emitData(r){for(const o of this.b)o.emitOne(r)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Se[289],Ie([1,0,11,22,20,5,262,73,6,15,33,12,4,17,115,8,7,52,77,62,25]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=e.$Pnc=e.$Onc=e.$Nnc=void 0;let u=class extends m.$Uc{constructor(V,W,q,M){super(),this.w=M,this.f=this.B(new N.$fe),this.g=new Map,this.s=this.B(new N.$fe),this.onResultsChanged=this.f.event,this.results=[],this.h=V.getProxy(l.$hM.MainThreadTesting),this.m=new h(this.h),this.j=new d(this.h,W),q.registerArgumentProcessor({processArgument:z=>{switch(z?.$mid){case 16:{const G=z,ie=G.tests[G.tests.length-1].item.extId;return this.g.get(o.$6K.root(ie))?.collection.tree.get(ie)?.actual??(0,f.$XO)(z)}case 18:{const{test:G,message:ie}=z,de=G.item.extId;return{test:this.g.get(o.$6K.root(de))?.collection.tree.get(de)?.actual??(0,f.$XO)({$mid:16,tests:[G]}),message:s.TestMessage.to(ie)}}default:return z}}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const z=await q.executeCommand("_testing.getExplorerSelection"),G=ie=>{const de=this.g.get(o.$6K.root(ie));if(de)return o.$6K.isRoot(ie)?de.controller:de.collection.tree.get(ie)?.actual};return{include:z?.include.map(G).filter(E.$gg)||[],exclude:z?.exclude.map(G).filter(E.$gg)||[]}})}createTestController(V,W,q,M){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const z=new m.$Tc,G=z.add(new f.$1O(W,q,this.w));G.root.label=q;const ie=new Map,de=new Set,ye=this.h,Ee={items:G.root.children,get label(){return q},set label(ue){q=ue,G.root.label=ue,ye.$updateController(W,{label:q})},get refreshHandler(){return M},set refreshHandler(ue){M=ue,ye.$updateController(W,{canRefresh:!!ue})},get id(){return W},createRunProfile:(ue,Ce,se,Oe,ne,U)=>{let x=(0,p.$mj)(ue);for(;ie.has(x);)x++;return new k(this.h,ie,de,this.s.event,W,x,ue,Ce,se,Oe,ne,U)},createTestItem(ue,Ce,se){return new f.$YO(W,ue,Ce,se)},createTestRun:(ue,Ce,se=!0)=>this.j.createTestRun(V,W,G,ue,Ce,se),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const Ce=ue instanceof Array?ue:[ue];this.h.$markTestRetired(Ce.map(se=>o.$6K.fromExtHostTestItem(se,W).toString()))}},set resolveHandler(ue){G.resolveHandler=ue},get resolveHandler(){return G.resolveHandler},dispose:()=>{z.dispose()}};ye.$registerTestController(W,q,!!M),z.add((0,m.$Sc)(()=>ye.$unregisterTestController(W)));const me={controller:Ee,collection:G,profiles:ie,extension:V,activeProfiles:de};return this.g.set(W,me),z.add((0,m.$Sc)(()=>this.g.delete(W))),z.add(G.onDidGenerateDiff(ue=>ye.$publishDiff(W,ue.map(n.TestsDiffOp.serialize)))),Ee}createTestObserver(){return this.m.checkout()}async runTests(V,W=A.CancellationToken.None){const q=w(V);if(!q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.g.get(q.controllerId);if(!M)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:V.preserveFocus??!0,targets:[{testIds:V.include?.map(z=>o.$6K.fromExtHostTestItem(z,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:I[q.kind],profileId:q.profileId,controllerId:q.controllerId}],exclude:V.exclude?.map(z=>z.id)},W)}$syncTests(){for(const{collection:V}of this.g.values())V.flushDiff();return Promise.resolve()}async $getCoverageDetails(V,W){return(await this.j.getCoverageDetails(V,W))?.map(s.TestCoverage.fromDetails)}async $disposeRun(V){this.j.disposeTestRun(V)}$configureRunProfile(V,W){this.g.get(V)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(V){const W=new Map;for(const[q,M]of Object.entries(V)){const z=this.g.get(q);if(!z)continue;const G=new Map,ie=M.filter(ye=>!z.activeProfiles.has(ye)),de=[...z.activeProfiles].filter(ye=>!M.includes(ye));for(const ye of ie)G.set(ye,!0),z.activeProfiles.add(ye);for(const ye of de)G.set(ye,!1),z.activeProfiles.delete(ye);G.size&&W.set(q,G)}this.s.fire(W)}async $refreshTests(V,W){await this.g.get(V)?.controller.refreshHandler?.(W)}$publishTestResults(V){this.results=Object.freeze(V.map(s.TestResults.to).concat(this.results).sort((W,q)=>q.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(V,W){const q=this.g.get(o.$6K.fromString(V).controllerId)?.collection;q&&(await q.expand(V,W<0?1/0:W),q.flushDiff())}$acceptDiff(V){this.m.applyDiff(V.map(W=>n.TestsDiffOp.deserialize({asCanonicalUri:q=>q},W)))}async $runControllerTests(V,W){return Promise.all(V.map(q=>this.y(q,!1,W)))}async $startContinuousRun(V,W){const q=new A.$qe(W),M=await Promise.all(V.map(z=>this.y(z,!0,q.token)));return!W.isCancellationRequested&&!M.some(z=>z.error)&&await new Promise(z=>W.onCancellationRequested(z)),q.dispose(!0),M}async y(V,W,q){const M=this.g.get(V.controllerId);if(!M)return{};const{collection:z,profiles:G,extension:ie}=M,de=G.get(V.profileId);if(!de)return{};const ye=V.testIds.map(Ce=>z.tree.get(Ce)).filter(E.$gg),Ee=V.excludeExtIds.map(Ce=>M.collection.tree.get(Ce)).filter(E.$gg).filter(Ce=>ye.some(se=>se.fullId.compare(Ce.fullId)===2));if(!ye.length)return{};const me=new r.$WN(ye.some(Ce=>Ce.actual instanceof f.$ZO)?void 0:ye.map(Ce=>Ce.actual),Ee.map(Ce=>Ce.actual),de,W),ue=(0,n.$9K)(V)&&this.j.prepareForMainThreadTestRun(ie,me,$.fromInternal(V,M.collection),de,q);try{return await de.runHandler(me,q),{}}catch(Ce){return{error:String(Ce)}}finally{ue&&ue.hasRunningTasks&&!q.isCancellationRequested&&await N.Event.toPromise(ue.onEnd)}}$cancelExtensionTestRun(V){V===void 0?this.j.cancelAllRuns():this.j.cancelRunById(V)}};e.$Nnc=u,e.$Nnc=u=Je([We(0,b.$LO),We(1,S.$5j)],u);const t=1e4;var g;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(g||(g={}));class a extends m.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(V,W,q,M,z,G){super(),this.y=V,this.z=W,this.C=q,this.D=M,this.F=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new N.$fe),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new A.$qe(G));const ie=this.B(new C.$Kh(()=>this.G(),t));this.B(this.j.token.onCancellationRequested(()=>ie.schedule()));const de=new N.$fe;this.s=de.event,this.B((0,m.$Sc)(()=>{de.fire(),de.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.G()}getCoverageDetails(V,W){const[,q,M]=o.$6K.fromString(V).path,z=this.w.get(M);if(!z)return[];const G=this.g.get(q);if(!G)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(G.run,z,W)??[]}createRun(V){const W=this.y.id,q=this.y.controllerId,M=(0,T.$Ug)(),z=Ee=>(me,...ue)=>{if(ie){this.C.warn(`Setting the state of test "${me.id}" is a no-op after the run ends.`);return}this.y.isIncluded(me)&&(this.I(me),Ee(me,...ue))},G=(Ee,me)=>{const ue=me instanceof Array?me.map(s.TestMessage.from):[s.TestMessage.from(me)];if(Ee.uri&&Ee.range){const Ce={range:s.Range.from(Ee.range),uri:Ee.uri};for(const se of ue)se.location=se.location||Ce}this.z.$appendTestMessagesInRun(W,M,o.$6K.fromExtHostTestItem(Ee,q).toString(),ue)};let ie=!1;const de=new Map,ye={isPersisted:this.y.isPersisted,token:this.j.token,name:V,onDidDispose:this.s,addCoverage:Ee=>{if(ie)return;const me=Ee instanceof r.$2N?Ee.testItem:void 0;let ue;if(me){if((0,c.$KG)(this.F,"attributableCoverage"),!this.y.isIncluded(me))throw new Error("Attempted to `addCoverage` for a test item not included in the run");ue=de.get(me),ue===void 0&&(ue=de.size,de.set(me,ue))}const Ce=Ee.uri.toString(),se=new o.$6K(ue?[W,M,Ce,String(ue)]:[W,M,Ce]).toString();this.w.set(Ce,Ee),this.z.$appendCoverage(W,M,s.TestCoverage.fromFile(q,se,Ee))},enqueued:z(Ee=>{this.z.$updateTestStateInRun(W,M,o.$6K.fromExtHostTestItem(Ee,q).toString(),1)}),skipped:z(Ee=>{this.z.$updateTestStateInRun(W,M,o.$6K.fromExtHostTestItem(Ee,q).toString(),5)}),started:z(Ee=>{this.z.$updateTestStateInRun(W,M,o.$6K.fromExtHostTestItem(Ee,q).toString(),2)}),errored:z((Ee,me,ue)=>{G(Ee,me),this.z.$updateTestStateInRun(W,M,o.$6K.fromExtHostTestItem(Ee,q).toString(),6,ue)}),failed:z((Ee,me,ue)=>{G(Ee,me),this.z.$updateTestStateInRun(W,M,o.$6K.fromExtHostTestItem(Ee,q).toString(),4,ue)}),passed:z((Ee,me)=>{this.z.$updateTestStateInRun(W,M,o.$6K.fromExtHostTestItem(Ee,this.y.controllerId).toString(),3,me)}),appendOutput:(Ee,me,ue)=>{ie||(ue&&(this.y.isIncluded(ue)?this.I(ue):ue=void 0),this.z.$appendOutputToRun(W,M,O.$He.fromString(Ee),me&&s.location.from(me),ue&&o.$6K.fromExtHostTestItem(ue,q).toString()))},end:()=>{ie||(ie=!0,de.clear(),this.z.$finishedTestRunTask(W,M),--this.f||this.H())}};return this.f++,this.g.set(M,{run:ye}),this.z.$startedTestRunTask(W,{id:M,name:V,running:!0}),ye}G(){for(const{run:V}of this.g.values())V.end()}H(){this.c!==2&&(this.c=2,this.m.fire())}I(V){if(!(V instanceof f.$YO))throw new i.$DO(V.id);if(this.h.has(o.$6K.fromExtHostTestItem(V,this.y.controllerId).toString()))return;const W=[],q=this.y.colllection.root;for(;;){const M=s.TestItem.from(V);if(W.unshift(M),this.h.has(M.extId)||(this.h.add(M.extId),V===q))break;V=V.parent||q}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.H(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(V,W){this.g=V,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(V,W){const q=o.$6K.root(V);return this.f.get(q)?.getCoverageDetails(V,W)||[]}disposeTestRun(V){this.f.get(V)?.dispose(),this.f.delete(V);for(const[W,{id:q}]of this.c)q===V&&this.c.delete(W)}prepareForMainThreadTestRun(V,W,q,M,z){return this.j(W,q,M,V,z)}cancelRunById(V){this.f.get(V)?.cancel()}cancelAllRuns(){for(const V of this.c.values())V.cancel()}createTestRun(V,W,q,M,z,G){const ie=this.c.get(M);if(ie)return ie.createRun(z);const de=$.fromPublic(W,q,M,G),ye=w(M);this.g.$startedExtensionTestRun({controllerId:W,continuous:!!M.continuous,profile:ye&&{group:I[ye.kind],id:ye.profileId},exclude:M.exclude?.map(me=>o.$6K.fromExtHostTestItem(me,q.root.id).toString())??[],id:de.id,include:M.include?.map(me=>o.$6K.fromExtHostTestItem(me,q.root.id).toString())??[q.root.id],preserveFocus:M.preserveFocus??!0,persist:G});const Ee=this.j(M,de,M.profile,V);return N.Event.once(Ee.onEnd)(()=>{this.g.$finishedExtensionTestRun(de.id)}),Ee.createRun(z)}j(V,W,q,M,z){const G=new a(W,this.g,this.h,q,M,z);return this.c.set(V,G),this.f.set(G.id,G),G}}e.$Onc=d;const w=P=>{if(P.profile){if(!(P.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class ${static fromPublic(V,W,q,M){return new $(V,(0,T.$Ug)(),q.include?.map(z=>o.$6K.fromExtHostTestItem(z,V).toString())??[V],q.exclude?.map(z=>o.$6K.fromExtHostTestItem(z,V).toString())??[],M,W)}static fromInternal(V,W){return new $(V.controllerId,V.runId,V.testIds,V.excludeExtIds,!0,W)}constructor(V,W,q,M,z,G){this.controllerId=V,this.id=W,this.isPersisted=z,this.colllection=G,this.c=q.map(ie=>ie+"\0"),this.f=M.map(ie=>ie+"\0")}isIncluded(V){const W=o.$6K.fromExtHostTestItem(V,this.controllerId).toString()+"\0";for(const q of this.f)if(W===q||W.startsWith(q))return!1;for(const q of this.c)if(W===q||W.startsWith(q))return!0;return!1}}e.$Pnc=$;class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(V){this.j=V,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(V){this.c.add(V)}update(V){Object.assign(V.revived,s.TestItem.toPlain(V.item)),this.c.has(V)||this.f.add(V)}remove(V){if(this.c.has(V)){this.c.delete(V);return}this.f.delete(V);const W=o.$6K.parentId(V.item.extId);if(W&&this.h.has(W.toString())){this.h.add(V.item.extId);return}this.g.add(V)}getChangeEvent(){const{c:V,f:W,g:q}=this;return{get added(){return[...V].map(M=>M.revived)},get updated(){return[...W].map(M=>M.revived)},get removed(){return[...q].map(M=>M.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends n.$cL{constructor(){super(...arguments),this.s=new N.$fe,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(V){return this.f.get(V)}getMirroredTestDataByReference(V){return this.f.get(V.id)}w(V,W){return{...V,revived:s.TestItem.toPlain(V.item),depth:W?W.depth+1:0,children:new Set}}v(){return new v(this.s)}}class h{constructor(V){this.f=V}checkout(){this.c||(this.c=this.g());const V=this.c;return V.observers++,{onDidChangeTest:V.tests.onDidChangeTests,get tests(){return[...V.tests.rootTests].map(W=>W.revived)},dispose:(0,R.$db)(()=>{--V.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(V){return this.c?.tests.getMirroredTestDataByReference(V)}applyDiff(V){this.c?.tests.apply(V)}g(){const V=new y({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:V}}}const D=(P,V,W,q)=>{W?Object.assign(W,q):V.$updateTestRunConfig(P.controllerId,P.profileId,q)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(V){V!==this.f&&(this.f=V,D(this,this.#e,this.#n,{label:V}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(V){V!==this.g&&(this.g=V,D(this,this.#e,this.#n,{supportsContinuousRun:V}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(V){V!==this.isDefault&&(V?this.#t.add(this.profileId):this.#t.delete(this.profileId),D(this,this.#e,this.#n,{isDefault:V}))}get tag(){return this._tag}set tag(V){V?.id!==this._tag?.id&&(this._tag=V,D(this,this.#e,this.#n,{tag:V?s.TestTag.namespace(this.controllerId,V.id):null}))}get configureHandler(){return this.c}set configureHandler(V){V!==this.c&&(this.c=V,D(this,this.#e,this.#n,{hasConfigurationHandler:!!V}))}get onDidChangeDefault(){return N.Event.chain(this.#i,V=>V.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(E.$gg))}constructor(V,W,q,M,z,G,ie,de,ye,Ee=!1,me=void 0,ue=!1){this.controllerId=z,this.profileId=G,this.f=ie,this.kind=de,this.runHandler=ye,this._tag=me,this.g=ue,this.#e=V,this.#s=W,this.#t=q,this.#i=M,W.set(G,this);const Ce=I[de];if(typeof Ce!="number")throw new Error(`Unknown TestRunProfile.group ${de}`);Ee&&q.add(G),this.#n={profileId:G,controllerId:z,tag:me?s.TestTag.namespace(this.controllerId,me.id):null,label:ie,group:Ce,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Qnc=k;const I={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Se[117],Ie([1,0,57,14,91,8,7]),function(le,e,C,O,A,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=e.$SO=void 0;class p{static{this.c=new A.$QO("TextEditorDecorationType")}constructor(l,b,f){const s=p.c.nextId();l.$registerTextEditorDecorationType(b.identifier,s,N.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$SO=p;class m{constructor(l,b){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,b){this.k();let f=null;if(l instanceof R.$kM)f=new R.$lM(l,l);else if(l instanceof R.$lM)f=l;else throw new Error("Unrecognized location");this.l(f,b,!1)}insert(l,b){this.k(),this.l(new R.$lM(l,l),b,!0)}delete(l){this.k();let b=null;if(l instanceof R.$lM)b=l;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(l,b,f){const s=this.c.validateRange(l);this.g.push({range:s,text:b,forceMoveMarkers:f})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=l}}class E{constructor(l,b,f,s){this.c=l,this.d=b,this._accept(f),this.e=s;const r=this;this.value={get tabSize(){return r.f},set tabSize(o){r.n(o)},get indentSize(){return r.g},set indentSize(o){r.p(o)},get insertSpaces(){return r.j},set insertSpaces(o){r.s(o)},get cursorStyle(){return r.k},set cursorStyle(o){r.t(o)},get lineNumbers(){return r.l},set lineNumbers(o){r.u(o)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}n(l){const b=this.m(l);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}p(l){const b=this.o(l);if(b!==null){if(typeof b=="number"){if(this.h===b)return;this.g=b,this.h=b}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const b=this.q(l);if(typeof b=="boolean"){if(this.j===b)return;this.j=b}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(l)})))}assign(l){const b={};let f=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(f=!0,b.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,f=!0,b.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(f=!0,b.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,f=!0,b.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(f=!0,b.insertSpaces=s):this.j!==s&&(this.j=s,f=!0,b.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,f=!0,b.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,f=!0,b.lineNumbers=N.TextEditorLineNumbersStyle.from(l.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,b))}v(l,b){b.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(f)})}}e.$TO=E;class T{constructor(l,b,f,s,r,o,i,n){this.id=l,this.j=b,this.k=f,this.g=!1,this.h=new Set,this.c=r,this.d=new E(this.j,this.id,o,f),this.e=i,this.f=n;const c=this;this.value=Object.freeze({get document(){return s.value},set document(u){throw new O.$9("document")},get selection(){return c.c&&c.c[0]},set selection(u){if(!(u instanceof R.$mM))throw(0,O.$7)("selection");c.c=[u],c.l()},get selections(){return c.c},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof R.$mM)))throw(0,O.$7)("selections");c.c=u,c.l()},get visibleRanges(){return c.e},set visibleRanges(u){throw new O.$9("visibleRanges")},get options(){return c.d.value},set options(u){c.g||c.d.assign(u)},get viewColumn(){return c.f},set viewColumn(u){throw new O.$9("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new m(s.value,t);return u(g),c.m(g)},insertSnippet(u,t,g={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c.c.map(d=>N.Range.from(d));else if(t instanceof R.$kM){const{lineNumber:d,column:w}=N.Position.from(t);a=[{startLineNumber:d,startColumn:w,endLineNumber:d,endColumn:w}]}else if(t instanceof R.$lM)a=[N.Range.from(t)];else{a=[];for(const d of t)if(d instanceof R.$lM)a.push(N.Range.from(d));else{const{lineNumber:w,column:$}=N.Position.from(d);a.push({startLineNumber:w,startColumn:$,endLineNumber:w,endColumn:$})}}return b.$tryInsertSnippet(l,s.value.version,u.value,a,g)},setDecorations(u,t){const g=t.length===0;g&&!c.h.has(u.key)||(g?c.h.delete(u.key):c.h.add(u.key),c.n(()=>{if(N.$IO(t))return b.$trySetDecorations(l,u.key,N.$JO(t));{const a=new Array(4*t.length);for(let d=0,w=t.length;d<w;d++){const $=t[d];a[4*d]=$.start.line+1,a[4*d+1]=$.start.character+1,a[4*d+2]=$.end.line+1,a[4*d+3]=$.end.character+1}return b.$trySetDecorationsFast(l,u.key,a)}}))},revealRange(u,t){c.n(()=>b.$tryRevealRange(l,N.Range.from(u),t||R.TextEditorRevealType.Default))},show(u){b.$tryShowEditor(l,N.ViewColumn.from(u))},hide(){b.$tryHideEditor(l)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,C.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,C.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,C.ok)(!this.g),this.f=l}_acceptSelections(l){(0,C.ok)(!this.g),this.c=l}async l(){const l=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const b=l.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const f=b.edits.map(r=>r.range);f.sort((r,o)=>r.end.line===o.end.line?r.end.character===o.end.character?r.start.line===o.start.line?r.start.character-o.start.character:r.start.line-o.start.line:r.end.character-o.end.character:r.end.line-o.end.line);for(let r=0,o=f.length-1;r<o;r++){const i=f[r].end;if(f[r+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=b.edits.map(r=>({range:N.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,s,{setEndOfLine:typeof b.setEndOfLine=="number"?N.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$UO=T}),define(Se[68],Ie([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=e.$VO=void 0;class o{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(c,u){this.h=c,this.i=u,this.a=null,this.b=new Map,this.c=new b.$Ac,this.d=new O.$fe,this.e=new O.$fe,this.f=new O.$fe,this.g=new O.$fe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],t=[],g=[];if(c.removedDocuments)for(const a of c.removedDocuments){const d=N.URI.revive(a),w=this.c.get(d);w?.unref()&&(this.c.delete(d),u.push(w.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const d=N.URI.revive(a.uri);let w=this.c.get(d);if(w&&d.scheme!==f.Schemas.vscodeNotebookCell&&d.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);w||(w=new o(new m.$OO(this.h.getProxy(p.$hM.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(d,w),t.push(w.value)),w.ref()}if(c.removedEditors)for(const a of c.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&g.push(d)}if(c.addedEditors)for(const a of c.addedEditors){const d=N.URI.revive(a.documentUri);C.ok(this.c.has(d),`document '${d}' does not exist`),C.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const w=this.c.get(d).value,$=new T.$UO(a.id,this.h.getProxy(p.$hM.MainThreadTextEditors),this.i,new r.$V(()=>w.document),a.selections.map(S.Selection.to),a.options,a.visibleRanges.map(v=>S.Range.to(v)),typeof a.editorPosition=="number"?S.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,$)}c.newActiveEditor!==void 0&&(C.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,A.$Pc)(u),(0,A.$Pc)(g),c.removedDocuments&&this.e.fire(u),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const u=this.b.get(this.a);return c?u:u?.value}allEditors(){return[...this.b.values()]}};e.$VO=i,e.$VO=i=Je([We(0,E.$LO),We(1,l.$5j)],i),e.$WO=(0,R.$yi)("IExtHostDocumentsAndEditors")}),define(Se[290],Ie([1,0,18,5,4,117,8,7]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;class m{constructor(T,S){this.i=S,this.a=new O.$fe,this.b=new O.$fe,this.c=new O.$fe,this.d=new O.$fe,this.f=new O.$fe,this.g=new O.$fe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(A.$hM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const S=this.i.allEditors();return T?S:S.map(l=>l.value)}async showTextDocument(T,S,l){let b;typeof S=="number"?b={position:R.ViewColumn.from(S),preserveFocus:l}:typeof S=="object"?b={position:R.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?R.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:b={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(T.uri,b),s=f&&this.i.getEditor(f);if(s)return s.value;throw f?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,S){return new N.$SO(this.h,T,S).value}$acceptEditorPropertiesChanged(T,S){const l=this.i.getEditor(T);if(!l)throw new Error("unknown text editor");if(S.options&&l._acceptOptions(S.options),S.selections){const b=S.selections.selections.map(R.Selection.to);l._acceptSelections(b)}if(S.visibleRanges){const b=C.$Hb(S.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(b)}if(S.options&&this.b.fire({textEditor:l.value,options:{...S.options,lineNumbers:R.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const b=p.TextEditorSelectionChangeKind.fromValue(S.selections.source),f=S.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:f,kind:b})}if(S.visibleRanges){const b=C.$Hb(S.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:b})}}$acceptEditorPositionData(T){for(const S in T){const l=this.i.getEditor(S);if(!l)throw new Error("Unknown text editor");const b=R.ViewColumn.to(T[S]);l.value.viewColumn!==b&&(l._acceptViewColumn(b),this.d.fire({textEditor:l.value,viewColumn:b}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$0lc=m}),define(Se[291],Ie([1,0,2,3,4,6,7,8,21,15]),function(le,e,C,O,A,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnc=e.$Snc=void 0,e.$Snc=(0,O.$yi)("IExtHostTimeline");class T{constructor(b,f){this.b=new Map,this.c=new Map,this.a=b.getProxy(A.$hM.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(s,r)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&m.$Tm.equals(r,this.b.get(s.source)?.extension)){const o=s.uri===void 0?void 0:C.URI.revive(s.uri);return this.c.get(s.source)?.get(S(o))?.get(s.handle)}else return;return s}})}async $getTimeline(b,f,s,r){return this.b.get(b)?.provider.provideTimeline(C.URI.revive(f),s,r)}registerTimelineProvider(b,f,s,r){const o=new N.$Tc,i=this.d(f.id,r,o).bind(this);let n;f.onDidChange&&(n=f.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:f.id}),this));const c=this.c;return this.f({...f,scheme:b,onDidChange:void 0,async provideTimeline(u,t,g){t?.resetCache&&(o.clear(),c.get(f.id)?.clear());const a=await f.provideTimeline(u,t,g);if(a==null)return;const d=i(u,t);return{...a,source:f.id,items:a.items.map(d)}},dispose(){for(const u of c.values())u.get(f.id)?.clear();n?.dispose(),o.dispose()}},s)}d(b,f,s){return(r,o)=>{let i;if(o?.cacheResults){let n=this.c.get(b);n===void 0&&(n=new Map,this.c.set(b,n));const c=S(r);i=n.get(c),i===void 0&&(i=new Map,n.set(c,i))}return n=>{const{iconPath:c,...u}=n,t=`${b}|${n.id??n.timestamp}`;i?.set(t,n);let g,a,d;n.iconPath&&(c instanceof R.$gN?d={id:c.id,color:c.color}:C.URI.isUri(c)?(g=c,a=c):{light:g,dark:a}=c);let w;return R.$LM.isMarkdownString(u.tooltip)?w=p.MarkdownString.from(u.tooltip):(0,E.$$f)(u.tooltip)?w=u.tooltip:R.$LM.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=p.MarkdownString.from(u.detail)):(0,E.$$f)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=u.detail),{...u,id:u.id??void 0,handle:t,source:b,command:n.command?f.toInternal(n.command,s):void 0,icon:g,iconDark:a,themeIcon:d,tooltip:w,accessibilityInformation:n.accessibilityInformation}}}}f(b,f){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:f}),(0,N.$Sc)(()=>{for(const r of this.c.values())r.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Tnc=T;function S(l){return l?.toString()}}),define(Se[292],Ie([1,0,181,24,2,5,6,222,11,7,15,18,8,55,20,143,25]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=void 0;function o(c,u){if((0,T.$$f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class i extends R.$Uc{constructor(u,t,g){super(),this.f=u,this.g=t,this.h=g,this.a=new Map,this.b=new s.$I0;function a(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:d=>a(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(w=>a(w)?this.r(w):w):d})}registerTreeDataProvider(u,t,g){const a=this.createTreeView(u,{treeDataProvider:t},g);return{dispose:()=>a.dispose()}}createTreeView(u,t,g){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],d=t.dragAndDropController?.dragMimeTypes??[],w=!!t.dragAndDropController?.handleDrag,$=!!t.dragAndDropController?.handleDrop,v=this.m(u,t,g),y={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:d,hasHandleDrag:w,hasHandleDrop:$,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(u,y),D={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,r.$KG)(g,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,r.$KG)(g,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(k){(0,b.$Xk)(k)&&(0,r.$KG)(g,"treeViewMarkdownMessage"),v.message=k},get title(){return v.title},set title(k){v.title=k},get description(){return v.description},set description(k){v.description=k},get badge(){return v.badge},set badge(k){k!==void 0&&E.ViewBadge.isViewBadge(k)?v.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(v.badge=void 0)},reveal:(k,I)=>v.reveal(k,I),dispose:async()=>{await h,this.a.delete(u),v.dispose()}};return this.B(D),D}$getChildren(u,t){const g=this.a.get(u);return g?g.getChildren(t):Promise.reject(new p.$7F(u))}async $handleDrop(u,t,g,a,d,w,$,v){const y=this.a.get(u);if(!y)return Promise.reject(new p.$7F(u));const h=l.DataTransfer.toDataTransfer(g,async D=>(await this.f.$resolveDropFileData(u,t,D)).buffer);return $===u&&v&&await this.j(h,y,v,d,w),y.onDrop(h,a,d)}async j(u,t,g,a,d){const w=this.b.removeDragOperationTransfer(d);if(w)(await w)?.forEach(($,v)=>{$&&u.set(v,$)});else if(d&&t.handleDrag){const $=t.handleDrag(g,u,a);this.b.addDragOperationTransfer(d,$),await $}return u}async $handleDrag(u,t,g,a){const d=this.a.get(u);if(!d)return Promise.reject(new p.$7F(u));const w=await this.j(new E.$cN,d,t,a,g);if(!(!w||a.isCancellationRequested))return l.DataTransfer.from(w)}async $hasResolve(u){const t=this.a.get(u);if(!t)throw new p.$7F(u);return t.hasResolve}$resolve(u,t,g){const a=this.a.get(u);if(!a)throw new p.$7F(u);return a.resolveTreeItem(t,g)}$setExpanded(u,t,g){const a=this.a.get(u);if(!a)throw new p.$7F(u);a.setExpanded(t,g)}$setSelectionAndFocus(u,t,g){const a=this.a.get(u);if(!a)throw new p.$7F(u);a.setSelectionAndFocus(t,g)}$setVisible(u,t){const g=this.a.get(u);if(!g){if(!t)return;throw new p.$7F(u)}g.setVisible(t)}$changeCheckboxState(u,t){const g=this.a.get(u);if(!g)throw new p.$7F(u);g.setCheckboxState(t)}m(u,t,g){const a=this.B(new n(u,t,this.f,this.g.converter,this.h,g));return this.a.set(u,a),a}r(u){const t=this.a.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.$Unc=i;class n extends R.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,T.$hg)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,t,g,a,d,w){if(super(),this.I=u,this.J=g,this.L=a,this.M=d,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$fe),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$fe),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$fe),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$fe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$fe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$fe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$fe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$qe,w.contributes&&w.contributes.views)for(const h in w.contributes.views)for(const D of w.contributes.views[h])D.id===u&&(this.P=D.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>{Array.isArray(h)&&h.length===0||this.F.fire({message:!1,element:h})}));let $,v;const y=N.Event.debounce(this.F.event,(h,D)=>(h||(h={message:!1,elements:[]}),D.element!==!1&&($||($=new Promise(k=>v=k),this.G=this.G.then(()=>$)),Array.isArray(D.element)?h.elements.push(...D.element):h.elements.push(D.element)),D.message&&(h.message=!0),h),200,!0);this.B(y(({message:h,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const k=v;return $=null,this.$(D).then(()=>k())})),h&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let g=this.X(u);return g||(g=await this.Y(t)),g?g.map(a=>a.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const g=(0,T.$hg)(t.select)?!0:t.select,a=(0,T.$hg)(t.focus)?!1:t.focus,d=(0,T.$hg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(w=>this.W(u,w[w.length-1]).then($=>this.J.$reveal(this.I,{item:$.item,parentChain:w.map(v=>v.item)},{select:g,focus:a,expand:d})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:g,focus:a,expand:d})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=l.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,t){const g=this.getExtensionElement(u);g&&(t?this.u.fire(Object.freeze({element:g})):this.w.fire(Object.freeze({element:g})))}setSelectionAndFocus(u,t){const g=!(0,S.$ub)(this.s,u);this.s=u;const a=this.t!==t;this.t=t,g&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async g=>{const a=this.getExtensionElement(g.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:g.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);t.forEach(g=>{g.treeItem.checkboxState=g.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(g=>[g.extensionItem,g.newState])})}async handleDrag(u,t,g){const a=[];for(const d of u){const w=this.getExtensionElement(d);w&&a.push(w)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,g),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,t,g){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,m.$qh)(()=>this.g?.handleDrop?this.g.handleDrop(a,u,g):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,t){if(!this.f.resolveTreeItem)return;const g=this.j.get(u);if(g){const a=this.m.get(g);if(a){const d=await this.f.resolveTreeItem(a.extensionItem,g,t)??a.extensionItem;return this.hb(d),a.item.tooltip=this.eb(d.tooltip),a.item.command=this.fb(a.disposableStore,d.command),a.item}}}S(u){return this.U(u).then(t=>t?this.S(t).then(g=>this.W(t,g[g.length-1]).then(a=>(g.push(a),g))):Promise.resolve([]))}U(u){const t=this.m.get(u);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,m.$qh)(()=>this.f.getParent(u))}W(u,t){const g=this.m.get(u);return g?Promise.resolve(g):(0,m.$qh)(()=>this.f.getTreeItem(u)).then(a=>this.kb(u,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const d=this.getExtensionElement(a);if(d){const w=this.m.get(d);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let t;if(typeof u=="string"){const g=this.getExtensionElement(u);t=g?this.m.get(g):void 0}else t=u;return t&&t.children||void 0}return this.h}async Y(u){this.rb(u);const t=new f.$qe(this.Z.token);try{const g=u?this.m.get(u):void 0,a=await this.f.getChildren(u);if(t.token.isCancellationRequested)return;const d=(0,S.$Hb)(a||[]),w=await Promise.all((0,S.$Hb)(d).map(v=>this.f.getTreeItem(v)));if(t.token.isCancellationRequested)return;const $=w.map((v,y)=>v?this.db(d[y],v,g):null);return(0,S.$Hb)($)}finally{t.dispose()}}$(u){if(u.some(g=>!g))return this.Z.dispose(!0),this.Z=new f.$qe,this.tb(),this.J.$refresh(this.I);{const g=this.ab(u);if(g.length)return this.bb(g)}return Promise.resolve(void 0)}ab(u){const t=new Set,g=u.map(d=>this.m.get(d));for(const d of g)if(d&&!t.has(d.item.handle)){let w=d;for(;w&&w.parent&&g.findIndex($=>w&&w.parent&&$&&$.item.handle===w.parent.item.handle)===-1;){const $=this.j.get(w.parent.item.handle);w=$?this.m.get($):void 0}w&&!w.parent&&t.add(d.item.handle)}const a=[];return t.forEach(d=>{const w=this.j.get(d);if(w){const $=this.m.get(w);$&&(!$.parent||!t.has($.parent.item.handle))&&a.push(d)}}),a}bb(u){const t={};return Promise.all(u.map(g=>this.cb(g).then(a=>{a&&(t[g]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(u){const t=this.getExtensionElement(u);if(t){const g=this.m.get(t);if(g)return this.rb(t),(0,m.$qh)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const d=this.ib(t,a,g.parent);return this.pb(t,d,g,g.parent),g.dispose(),d}return null})}return Promise.resolve(null)}db(u,t,g){const a=this.ib(u,t,g);if(t.id&&this.j.has(a.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(u,a),this.qb(a,g),a}eb(u){return E.$LM.isMarkdownString(u)?l.MarkdownString.from(u):u}fb(u,t){return t?{...this.L.toInternal(t,u),originalId:t.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let t,g,a;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,g=u.checkboxState.tooltip,a=u.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:a}}hb(u){if(!E.$0M.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,t,g){this.hb(t);const a=this.B(new R.$Tc),d=this.kb(u,t,g),w=this.lb(t);return{item:{handle:d,parentHandle:g?g.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:w,iconDark:this.mb(t)||w,themeIcon:this.jb(t),collapsibleState:(0,T.$hg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:g,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(u){return u.iconPath instanceof E.$gN?u.iconPath:void 0}kb(u,{id:t,label:g,resourceUri:a},d,w){if(t)return`${n.b}/${t}`;const $=o(g,this.N),v=d?d.item.handle:n.a;let y=$?$.label:a?(0,O.$9g)(a):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const h=this.m.has(u)?this.m.get(u).item.handle:void 0,D=this.X(d)||[];let k,I=0;do{if(k=`${v}/${I}:${y}`,w||!this.j.has(k)||h===k)break;I++}while(I<=D.length);return k}lb(u){if(u.iconPath&&!(u.iconPath instanceof E.$gN))return typeof u.iconPath=="string"||A.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof E.$gN)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return A.URI.isUri(u)?u:A.URI.file(u)}ob(u,t){this.j.set(t.item.handle,u),this.m.set(u,t)}pb(u,t,g,a){this.j.delete(t.item.handle),this.m.delete(u),t.item.handle!==g.item.handle&&this.j.delete(g.item.handle),this.ob(u,t);const d=this.X(a)||[],w=d.filter($=>$.item.handle===g.item.handle)[0];w&&d.splice(d.indexOf(w),1,t)}qb(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const t=this.m.get(u);if(t){if(t.children)for(const g of t.children){const a=this.j.get(g.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(u){const t=this.m.get(u);if(t){if(t.children)for(const g of t.children){const a=this.j.get(g.item.handle);a&&this.sb(a)}this.m.delete(u),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[293],Ie([1,0,5,6,2,33,8,64,4,7]),function(le,e,C,O,A,N,R,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0;class T extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(f,s,r,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new C.$fe),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$fe),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=s,this.#n=r,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,A.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(f){this.#l||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#u=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:R.ViewColumn.from(f),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends O.$Uc{static c(){return(0,N.$Ug)()}constructor(f,s,r){super(),this.j=s,this.m=r,this.g=new Map,this.h=new Map,this.f=f.getProxy(m.$hM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,s,r,o,i={}){const n=typeof o=="object"?o.viewColumn:o,c={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},u=(0,p.$mmc)(f),t=S.c();this.f.$createWebviewPanel((0,p.$omc)(f),t,s,{title:r,panelOptions:l(i),webviewOptions:(0,p.$pmc)(f,this.m,i),serializeBuffersForPostMessage:u},c);const g=this.j.createNewWebview(t,i,f);return this.createNewWebviewPanel(t,s,r,n,i,g,!0)}$onDidChangeWebviewPanelViewStates(f){const s=Object.keys(f);s.sort((r,o)=>{const i=f[r],n=f[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const r of s){const o=this.getWebviewPanel(r);if(!o)continue;const i=f[r];o._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,s,r){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:r,extension:f}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,p.$mmc)(f)}),new E.$jM(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(f,s,r,o){const i=this.h.get(s);if(!i)throw new Error(`No serializer found for '${s}'`);const{serializer:n,extension:c}=i,u=this.j.createNewWebview(f,r.webviewOptions,c),t=this.createNewWebviewPanel(f,s,r.title,o,r.panelOptions,u,r.active);await n.deserializeWebviewPanel(t,r.state)}createNewWebviewPanel(f,s,r,o,i,n,c){const u=new T(f,this.f,n,{viewType:s,title:r,viewColumn:o,panelOptions:i,active:c});return this.g.set(f,u),u}getWebviewPanel(f){return this.g.get(f)}}e.$qmc=S;function l(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Se[294],Ie([1,0,5,6,64,8,4,7]),function(le,e,C,O,A,N,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=void 0;class m extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(S,l,b,f,s,r){super(),this.#s=!1,this.#u=this.B(new C.$fe),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new C.$fe),this.onDidDispose=this.#l.event,this.#i=b,this.#a=f,this.#e=S,this.#t=l,this.#n=s,this.#r=r}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#o}set description(S){this.a(),this.#o!==S&&(this.#o=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(S){S===this.#r||this.#s||(this.#r=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(S,l){this.d=l,this.b=new Map,this.c=new Map,this.a=S.getProxy(R.$hM.MainThreadWebviewViews)}registerWebviewViewProvider(S,l,b,f){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:b,extension:S}),this.a.$registerWebviewViewProvider((0,A.$omc)(S),l,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$mmc)(S)}),new p.$jM(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(S,l,b,f,s){const r=this.b.get(l);if(!r)throw new Error(`No view provider found for '${l}'`);const{provider:o,extension:i}=r,n=this.d.createNewWebview(S,{},i),c=new m(S,this.a,l,b,n,!0);this.c.set(S,c),await o.resolveWebviewView(c,{state:f},s)}async $onDidChangeWebviewViewVisibility(S,l){this.e(S)._setVisible(l)}async $disposeWebviewView(S){const l=this.e(S);this.c.delete(S),l.dispose(),this.d.deleteWebview(S)}e(S){const l=this.c.get(S);if(!l)throw new Error("No webview found");return l}}e.$Xnc=E}),define(Se[295],Ie([1,0,5,29,31,3]),function(le,e,C,O,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=e.$CL=e.OutputChannelUpdateMode=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=void 0,e.$pL="text/x-code-output",e.$qL="output",e.$rL="Log",e.$sL="text/x-code-log-output",e.$tL="log",e.$uL="workbench.panel.output",e.$vL=new A.$Pj("inOutput",!1),e.$wL=new A.$Pj("activeLogOutput",!1),e.$xL=new A.$Pj("activeLogOutput.levelSettable",!1),e.$yL=new A.$Pj("activeLogOutput.level",""),e.$zL=new A.$Pj("activeLogOutput.levelIsDefault",!1),e.$AL=new A.$Pj("outputView.scrollLock",!1),e.$BL=(0,N.$yi)("outputService");var R;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$CL={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new C.$fe,this.onDidRegisterChannel=this.b.event,this.c=new C.$fe,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(T=>E.push(T)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}O.$fo.add(e.$CL.OutputChannels,new p),e.$DL=new A.$Pj("activeOutputChannel","")}),define(Se[118],Ie([1,0,4,3,17,21,12,295,65,27,46,147,22,15,38,5,6]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=e.$wnc=void 0;class o extends R.$$j{get disposed(){return this.n}constructor(u,t,g,a,d){super(),this.id=u,this.name=t,this.r=g,this.s=a,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(g.getLevel()),this.B(g.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.m;this.info(u),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(u,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.s.$close(this.id)}g(u,t){this.m+=l.$He.fromString(t).byteLength,(0,R.log)(this.r,u,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(u){this.append(u)}}let n=class{constructor(u,t,g,a,d,w){this.i=t,this.j=g,this.k=a,this.l=d,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(C.$hM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,S.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[t,g]of this.g)g.visible=t===this.h}createOutputChannel(u,t,g){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,d=(0,b.$$f)(t)?t:void 0;if((0,b.$$f)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const $=this.i.environment.extensionLogLevel?.find(([y])=>N.$Tm.equals(g.identifier,y))?.[1];$&&(w=(0,R.$jk)($));const v=a?this.o(u,w,g):this.n(u,d,g);return v.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),a?this.r(u,w??this.m.getLevel(),v):this.q(u,v)}async n(u,t,g){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),$=await this.a.$register(u,d,t,g.identifier.value);return new o($,u,w,this.a,g)}async o(u,t,g){const a=await this.p(g),d=u.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(a,`${d}.log`),$=`${g.identifier.value}.${d}`,v=this.l.createLogger(w,{id:$,name:u,logLevel:t,extensionId:g.identifier.value});return new i($,u,v,this.a,g)}p(u){let t=this.d.get(u.identifier.value);if(!t){const g=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(g)}catch(a){if((0,f.$il)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}return g})())}return t}q(u,t){let g=!1;const a=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return u},append(d){a(),t.then(w=>w.append(d))},appendLine(d){a(),t.then(w=>w.appendLine(d))},clear(){a(),t.then(d=>d.clear())},replace(d){a(),t.then(w=>w.replace(d))},show(d,w){a(),t.then($=>$.show(d,w))},hide(){a(),t.then(d=>d.hide())},dispose(){g=!0,t.then(d=>d.dispose())}}}r(u,t,g){const a=new r.$Tc,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},w=a.add(new s.$fe);function $(v){t=v,w.fire(v)}return g.then(v=>{a.add(v),v.logLevel!==t&&$(v.logLevel),a.add(v.onDidChangeLogLevel(y=>$(y)))}),{...this.q(u,g),get logLevel(){return t},onDidChangeLogLevel:w.event,trace(v,...y){d(),g.then(h=>h.trace(v,...y))},debug(v,...y){d(),g.then(h=>h.debug(v,...y))},info(v,...y){d(),g.then(h=>h.info(v,...y))},warn(v,...y){d(),g.then(h=>h.warn(v,...y))},error(v,...y){d(),g.then(h=>h.error(v,...y))},dispose(){a.dispose()}}}};e.$wnc=n,e.$wnc=n=Je([We(0,A.$LO),We(1,E.$2O),We(2,m.$imc),We(3,T.$Xlc),We(4,R.$6j),We(5,R.$5j)],n),e.$xnc=(0,O.$yi)("IExtHostOutputService")}),define(Se[119],Ie([1,0,3,11]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$in=(0,C.$yi)("remoteAgentService"),e.$jn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let N=1/0;for(let p=0;p<this.maxSampleCount;p++){const m=await A.getRoundTripTime();if(m===void 0)return;N=Math.min(N,m/2),await(0,O.$zh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(N):R=this.initial.reduce((p,m)=>p+m,0)/this.initial.length,this.lastMeasurement={initial:R,current:N,average:this.average.reduce((p,m)=>p+m,0)/this.average.length,high:typeof R>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[296],Ie([1,0,184,51,29,45,50,6,5,119,23,26,11]),function(le,e,C,O,A,N,R,p,m,E,T,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgb=e.$Pgb=e.$Ogb=e.$Ngb=e.$Mgb=e.$Lgb=e.$Kgb=void 0,e.$Kgb=Object.freeze({id:"application",order:100,title:(0,C.localize)(0,null),type:"object"}),e.$Lgb=Object.freeze({id:"workbench",order:7,title:(0,C.localize)(1,null),type:"object"}),e.$Mgb=Object.freeze({id:"security",scope:1,title:(0,C.localize)(2,null),type:"object",order:7}),e.$Ngb=Object.freeze({id:"problems",title:(0,C.localize)(3,null),type:"object",order:101}),e.$Ogb={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new m.$fe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const f=new b;A.$fo.add(e.$Ogb.ConfigurationMigration,f);let s=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const u of c.added)await this.f(u,f.migrations)})),this.c(f.migrations),this.B(f.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(c=>this.g(c,i?.uri))])}async g(i,n){const c=this.a.inspect(i.key,{resource:n}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,g]of u){const a=c[t];if(!a)continue;const d=[];if(a.value!==void 0){const w=await this.h(i,t,a.value,n,void 0);for(const $ of w??[])d.push([$,[]])}for(const{identifiers:w,value:$}of a.overrides??[])if($!==void 0){const v=await this.h(i,t,$,n,w);for(const y of v??[])d.push([y,w])}d.length&&await Promise.allSettled(d.map(async([[w,$],v])=>this.a.updateValue(w,$.value,{resource:n,overrideIdentifiers:v},g)))}}async h(i,n,c,u,t){const g=d=>{const $=this.a.inspect(d,{resource:u})[n];if($)return t?$.overrides?.find(({identifiers:v})=>(0,S.$9n)(v,t))?.value:$.value},a=await i.migrateFn(c,g);return Array.isArray(a)?a:[[i.key,a]]}};e.$Pgb=s,e.$Pgb=s=Je([We(0,R.$5i),We(1,N.$Hi)],s);let r=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new l.$Vh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;A.$fo.as(O.$ko.Configuration).registerConfiguration({...e.$Mgb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,C.localize)(4,null)},default:[],markdownDescription:(0,C.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,C.localize)(6,null),scope:2}}})}};e.$Qgb=r,e.$Qgb=r=Je([We(0,E.$in)],r)}),define(Se[297],Ie([1,0,37,16,19,24,193,296,51,3,29]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Sgb=e.$Rgb=void 0,e.$Tgb=s,e.$Ugb=r,e.$Rgb=(0,E.$yi)("editorResolverService"),e.$Sgb="workbench.editorAssociations";const S=T.$fo.as(m.$ko.Configuration),l={...p.$Lgb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var b;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(b||(e.RegisteredEditorPriority=b={}));var f;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function s(o){switch(o){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}function r(o,i){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(i.scheme))return!1;const u=typeof o=="string"&&o.indexOf(A.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,N.$9g)(i);return C.$rk(typeof o=="string"?o.toLowerCase():o,u.toLowerCase())}}),define(Se[298],Ie([1,0,48,16,19,23,24,2,3,214,45,236,119]),function(le,e,C,O,A,N,R,p,m,E,T,S,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=void 0,e.$VL=(0,m.$yi)("pathService");let f=b=class{constructor(r,o,i,n){this.d=r,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??r})()}hasValidBasename(r,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(r,n,o)):this.h(r,o,i)}h(r,o,i){return r.scheme===O.Schemas.file||r.scheme===O.Schemas.vscodeRemote?(0,C.$vg)(i??(0,R.$9g)(r),o===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(r,o){if(r.remoteAuthority)return O.Schemas.vscodeRemote;const i=(0,E.$SL)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const c=o.getWorkspace().configuration;return c?c.scheme:O.Schemas.file}userHome(r){return r?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(r=>r===1?A.$fc:A.$gc)}async fileURI(r){let o="";if(await this.a===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const n=r.indexOf("/",2);n===-1?(o=r.substring(2),r="/"):(o=r.substring(2,n),r=r.substring(n)||"/")}return p.URI.from({scheme:O.Schemas.file,authority:o,path:r,query:"",fragment:""})}};e.$WL=f,e.$WL=f=b=Je([We(1,l.$in),We(2,S.$EL),We(3,T.$Hi)],f)}),define(Se[120],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$oK=e.$nK=void 0;class C{constructor(R,p){this.line=R,this.character=p}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,p){return new C(0,0)}with(R){return new C(0,0)}}e.$nK=C;class O{constructor(R,p,m,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(R,p),this.end=new C(m,E)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new O(0,0,0,0)}with(R){return new O(0,0,0,0)}}e.$oK=O;var A;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(Se[47],Ie([1,0,18,37,26,48,13,3,19,14,120,11]),function(le,e,C,O,A,N,R,p,m,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$LK=e.$EK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$BK=e.$AK=e.$zK=e.$yK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.TextSearchCompleteMessageType=void 0,e.$vK=o,e.$wK=i,e.$xK=n,e.$CK=v,e.$DK=y,e.$FK=k,e.$GK=I,e.$HK=P,e.$IK=V,e.$JK=W,e.$KK=q,e.$MK=z,e.$OK=de,e.$PK=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$pK="workbench.view.search",e.$qK="workbench.panel.search",e.$rK="workbench.view.search",e.$sK="search-result",e.$tK="search.exclude";const l="\u27EA ",b=" characters skipped \u27EB",f=(l.length+b.length+5)*2;e.$uK=(0,p.$yi)("searchService");var s;(function(me){me[me.file=0]="file",me[me.text=1]="text",me[me.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var r;(function(me){me[me.File=1]="File",me[me.Text=2]="Text",me[me.aiText=3]="aiText"})(r||(e.QueryType=r={}));function o(me){return!!me.preview}function i(me){return!!me.resource}function n(me){return!!me.message}var c;(function(me){me[me.Normal=0]="Normal",me[me.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class u{constructor(ue){this.resource=ue,this.results=[]}}e.$yK=u;class t{constructor(ue,Ce,se,Oe){this.ranges=Ce,this.webviewIndex=Oe;const ne=Array.isArray(Ce)?Ce:[Ce];if(se&&se.matchLines===1&&g(ne)){ue=(0,R.$4f)(ue,se.matchLines);let U="",x=0,ve=0;const Fe=Math.floor(se.charsPerLine/5),ke=[];for(const we of ne){const ge=Math.max(we.startColumn-Fe,0),Q=we.startColumn+se.charsPerLine;if(ge>ve+Fe+f){const Y=l+(ge-ve)+b;U+=Y+ue.slice(ge,Q),x+=ge-(ve+Y.length)}else U+=ue.slice(ve,Q);ke.push(new d(0,we.startColumn-x,we.endColumn-x)),ve=Q}this.preview={text:U,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const U=Array.isArray(Ce)?Ce[0].startLineNumber:Ce.startLineNumber;this.preview={text:ue,matches:(0,C.$1b)(Ce,x=>new a(x.startLineNumber-U,x.startColumn,x.endLineNumber-U,x.endColumn))}}}}e.$zK=t;function g(me){const ue=me[0].startLineNumber;for(const Ce of me)if(Ce.startLineNumber!==ue||Ce.endLineNumber!==ue)return!1;return!0}class a{constructor(ue,Ce,se,Oe){this.startLineNumber=ue,this.startColumn=Ce,this.endLineNumber=se,this.endColumn=Oe}}e.$AK=a;class d extends a{constructor(ue,Ce,se){super(ue,Ce,ue,se)}}e.$BK=d;var w;(function(me){me.List="list",me.Tree="tree"})(w||(e.ViewMode=w={}));var $;(function(me){me.Default="default",me.FileNames="fileNames",me.Type="type",me.Modified="modified",me.CountDescending="countDescending",me.CountAscending="countAscending"})($||(e.SearchSortOrder=$={}));function v(me,ue=!0){const Ce=me&&me.files&&me.files.exclude,se=ue&&me&&me.search&&me.search.exclude;if(!Ce&&!se)return;if(!Ce||!se)return Ce||se;let Oe=Object.create(null);return Oe=A.$8n(Oe,A.$5n(Ce)),Oe=A.$8n(Oe,A.$5n(se),!0),Oe}function y(me,ue){return me.excludePattern&&O.$rk(me.excludePattern,ue)?!1:me.includePattern||me.usingSearchPaths?me.includePattern&&O.$rk(me.includePattern,ue)?!0:me.usingSearchPaths?!!me.folderQueries&&me.folderQueries.some(Ce=>{const se=Ce.folder.fsPath;if(N.$xg(ue,se)){const Oe=m.$lc(se,ue);return!Ce.includePattern||!!O.$rk(Ce.includePattern,Oe)}else return!1}):!1:!0}var h;(function(me){me[me.unknownEncoding=1]="unknownEncoding",me[me.regexParseError=2]="regexParseError",me[me.globParseError=3]="globParseError",me[me.invalidLiteral=4]="invalidLiteral",me[me.rgProcessError=5]="rgProcessError",me[me.other=6]="other",me[me.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class D extends Error{constructor(ue,Ce){super(ue),this.code=Ce}}e.$EK=D;function k(me){const ue=me.message;if((0,E.$4)(me))return new D(ue,h.canceled);try{const Ce=JSON.parse(ue);return new D(Ce.message,Ce.code)}catch{return new D(ue,h.other)}}function I(me){const ue={message:me.message,code:me.code};return new Error(JSON.stringify(ue))}function P(me){return me.type==="error"?!0:me.type==="success"}function V(me){return me.type==="success"}function W(me){return!!me.path}function q(me,ue,Ce=!0){const se=me.searchPath?me.searchPath:me.relativePath;return Ce?(0,R.$1f)(se,ue):O.$rk(ue,se)}class M{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$LK=M;function z(me,ue){const Ce={...me||{},...ue||{}};return Object.keys(Ce).filter(se=>{const Oe=Ce[se];return typeof Oe=="boolean"&&Oe})}class G{constructor(ue,Ce){this.c=null,this.a={...ue.excludePattern||{},...Ce.excludePattern||{}},this.b=O.$sk(this.a);let se=ue.includePattern;Ce.includePattern&&(se?se={...se,...Ce.includePattern}:se=Ce.includePattern),se&&(this.c=O.$sk(se))}matchesExcludesSync(ue,Ce,se){return!!(this.b&&this.b(ue,Ce,se))}includedInQuerySync(ue,Ce,se){return!(this.b&&this.b(ue,Ce,se)||this.c&&!this.c(ue,Ce,se))}includedInQuery(ue,Ce,se){const Oe=this.b(ue,Ce,se),ne=()=>this.c?!!this.c(ue,Ce,se):!0;return(0,S.$kh)(Oe)?Oe.then(U=>U?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$NK=G;function ie(me){for(const ue in me)if(typeof me[ue]!="boolean")return!0;return!1}function de(me){if(!me)return;let ue;return Ce=>(ue||(ue=(me()||Promise.resolve([])).then(se=>se?Ee(se):{})),ue.then(se=>!!se[Ce]))}function ye(me){if(!me)return;let ue;return Ce=>{if(!ue){const se=me();ue=se?Ee(se):{}}return!!ue[Ce]}}function Ee(me){const ue={};for(const Ce of me)ue[Ce]=!0;return ue}}),define(Se[39],Ie([1,0,18,11,20,5,6,54,16,129,24,13,2,183,3,12,202,45,46,27,17,8,7,61,47,4,49]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c,u,t,g,a,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=e.$cmc=void 0;function $(V,W,q){return new T.$1g(M=>D(M,q)).isEqual(V,W)}function v(V,W,q){return $(V.uri,W.uri,q)?0:(0,S.$sf)(V.uri.toString(),W.uri.toString())}function y(V,W,q){return V.index!==W.index?V.index<W.index?-1:1:$(V.uri,W.uri,q)?(0,S.$sf)(V.name,W.name):(0,S.$sf)(V.uri.toString(),W.uri.toString())}function h(V,W,q,M){const z=V.slice(0).sort((ie,de)=>q(ie,de,M)),G=W.slice(0).sort((ie,de)=>q(ie,de,M));return(0,C.$Eb)(z,G,(ie,de)=>q(ie,de,M))}function D(V,W){const q=W.getCapabilities(V.scheme);return!(q&&q&1024)}class k extends o.$Ri{static toExtHostWorkspace(W,q,M,z){if(!W)return{workspace:null,added:[],removed:[]};const{id:G,name:ie,folders:de,configuration:ye,transient:Ee,isUntitled:me}=W,ue=[],Ce=q;q?de.forEach((U,x)=>{const ve=l.URI.revive(U.uri),Fe=k.o(M||q,ve,z);Fe?(Fe.name=U.name,Fe.index=U.index,ue.push(Fe)):ue.push({uri:ve,name:U.name,index:x})}):ue.push(...de.map(({uri:U,name:x,index:ve})=>({uri:l.URI.revive(U),name:x,index:ve}))),ue.sort((U,x)=>U.index<x.index?-1:1);const se=new k(G,ie,ue,!!Ee,ye?l.URI.revive(ye):null,!!me,U=>D(U,z)),{added:Oe,removed:ne}=h(Ce?Ce.workspaceFolders:[],se.workspaceFolders,v,z);return{workspace:se,added:Oe,removed:ne}}static o(W,q,M){for(let z=0;z<W.folders.length;z++){const G=W.workspaceFolders[z];if($(G.uri,q,M))return G}}constructor(W,q,M,z,G,ie,de){super(W,M.map(ye=>new o.$Si(ye)),z,G,de),this.t=q,this.u=ie,this.q=[],this.s=p.$Ei.forUris(de),M.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,q){return q&&this.s.get(W)&&(W=(0,T.$$g)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let I=class{constructor(W,q,M,z,G){this.c=new N.$fe,this.onDidChangeWorkspace=this.c.event,this.g=new N.$fe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$he,this.C=new Map,this.h=z,this.s=M,this.t=G,this.j=new E.$Fm,this.k=new O.$xh,this.o=W.getProxy(d.$hM.MainThreadWorkspace),this.q=W.getProxy(d.$hM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new k(ie.id,ie.name,[],!!ie.transient,ie.configuration?l.URI.revive(ie.configuration):null,!!ie.isUntitled,de=>D(de,M)):void 0}$initializeWorkspace(W,q){this.v=q,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:m.Schemas.untitled,path:(0,T.$9g)((0,T.$$g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,q,M,...z){const G=[];if(Array.isArray(z)&&z.forEach(me=>{l.URI.isUri(me.uri)&&!G.some(ue=>$(ue.uri,me.uri,this.s))&&G.push({uri:me.uri,name:me.name||(0,T.$8g)(me.uri)})}),this.n||[q,M].some(me=>typeof me!="number"||me<0)||M===0&&G.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+M>ie.length)return!1;const de=ie.slice(0);de.splice(q,M,...G.map(me=>({uri:me.uri,name:me.name||(0,T.$8g)(me.uri),index:void 0})));for(let me=0;me<de.length;me++){const ue=de[me];if(de.some((Ce,se)=>se!==me&&$(ue.uri,Ce.uri,this.s)))return!1}de.forEach((me,ue)=>me.index=ue);const{added:ye,removed:Ee}=h(ie,de,y,this.s);if(ye.length===0&&Ee.length===0)return!1;if(this.o){const me=W.displayName||W.name;this.o.$updateWorkspaceFolders(me,q,M,G).then(void 0,ue=>{this.n=void 0;const Ce={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(r.Severity.Error,(0,b.localize)(0,null,me,ue.toString()),Ce,[])})}return this.y(de),!0}getWorkspaceFolder(W,q){if(this.x)return this.x.getWorkspaceFolder(W,q)}async getWorkspaceFolder2(W,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,q)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,q){let M,z="";if(typeof W=="string"?(M=l.URI.file(W),z=W):typeof W<"u"&&(M=W,z=W.fsPath),!M)return z;const G=this.getWorkspaceFolder(M,!0);if(!G)return z;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,T.$bh)(G.uri,M);return q&&G.name&&(ie=`${G.name}/${ie}`),ie}y(W){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:q,added:M,removed:z}=k.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:z}))}findFiles(W,q,M,z,G=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let ie="",de=!0;return q===null?de=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(W,void 0,{exclude:ie,maxResults:M,useDefaultExcludes:de,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},G)}findFiles2(W,q={},M,z=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,W,q,z)}async z(W,q,M,z=A.CancellationToken.None){if(z&&z.isCancellationRequested)return Promise.resolve([]);const G=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ie={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:G,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let de;if(W){const{includePattern:ye,folder:Ee}=P(u.GlobPattern.from(W));de=Ee,ie.includePattern=ye}else{const{includePattern:ye,folder:Ee}=P(u.GlobPattern.from(q));de=Ee,ie.filePattern=ye}return this.o.$startFileSearch(de??null,ie,z).then(ye=>Array.isArray(ye)?ye.map(Ee=>l.URI.revive(Ee)):[])}async findTextInFiles(W,q,M,z,G=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),de=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ye,folder:Ee}=P(u.GlobPattern.from(q.include)),me=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,ue={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:de,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ye,excludePattern:me},Ce=!1;if(this.u[ie]=se=>{if(Ce)return;const Oe=l.URI.revive(se.resource);se.results.forEach(ne=>{const U=(0,w.$8h)(ne);(0,a.$vK)(U)?M({uri:Oe,preview:{text:U.preview.text,matches:(0,C.$1b)(U.preview.matches,x=>new t.$lM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,C.$1b)(U.ranges,x=>new t.$lM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):M({uri:Oe,text:U.text,lineNumber:U.lineNumber})})},G.isCancellationRequested)return{};try{const se=await this.o.$startTextSearch(W,Ee??null,ue,ie,G);return delete this.u[ie],se||{}}catch(se){throw delete this.u[ie],se}}$handleTextSearchResult(W,q){this.u[q]?.(W)}async save(W){const q=await this.o.$save(W,{saveAs:!1});return l.URI.revive(q)}async saveAs(W){const q=await this.o.$save(W,{saveAs:!0});return l.URI.revive(q)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,q){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,q);const M=this.t.transformOutgoingScheme(W),z=this.A++;return this.o.$registerEditSessionIdentityProvider(z,M),(0,R.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(W,q){this.h.info("Getting edit session identifier for workspaceFolder",W);const M=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const z=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!z),!z)return;const G=await z.provideEditSessionIdentity(M,q);if(this.h.info("Provider returned edit session identifier: ",G),!!G)return G}async $provideEditSessionIdentityMatch(W,q,M,z){this.h.info("Getting edit session identifier for workspaceFolder",W);const G=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!G){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",G);const ie=this.w.get(G.uri.scheme);if(this.h.info(`Provider for scheme ${G.uri.scheme} is defined: `,!!ie),!ie)return;const de=await ie.provideEditSessionIdentityMatch?.(q,M,z);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(W){return(q,M,z)=>{const G=function(de){q.call(M,de)};return G.extension=W,this.B.event(G,void 0,z)}}async $onWillCreateEditSessionIdentity(W,q,M){const z=await this.resolveWorkspaceFolder(l.URI.revive(W));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:z},q,async(G,ie)=>{const de=Date.now();await Promise.resolve(G),Date.now()-de>M&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(W,q){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,q);const M=this.t.transformOutgoingScheme(W),z=this.A++;return this.o.$registerCanonicalUriProvider(z,M),(0,R.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(W,q,M){const z=this.C.get(W.scheme);if(!z)return;const G=await z.provideCanonicalUri?.(l.URI.revive(W),q,M);if(G)return G}async $provideCanonicalUri(W,q,M){return this.provideCanonicalUri(l.URI.revive(W),{targetScheme:q},M)}};e.$cmc=I,e.$cmc=I=Je([We(0,c.$LO),We(1,n.$2O),We(2,i.$Xlc),We(3,s.$5j),We(4,g.$amc)],I),e.$dmc=(0,f.$yi)("IExtHostWorkspace");function P(V){let W,q;return V&&(typeof V=="string"?W=V:(W=V.pattern,q=l.URI.revive(V.baseUri))),{includePattern:W,folder:q}}}),define(Se[40],Ie([1,0,26,5,39,4,7,203,51,15,11,3,17,12,2]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=e.$fmc=e.$emc=void 0;function s(g,a){if(a){const d=a.split(".");let w=g;for(let $=0;w&&$<d.length;$++)w=w[d[$]];return w}}function r(g){return g instanceof f.URI}function o(g){return g&&g.uri instanceof f.URI&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function n(g){return g&&g.uri instanceof f.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function c(g){if(r(g))return{resource:g};if(o(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(i(g))return{overrideIdentifier:g.languageId};if(n(g))return{resource:g.uri};if(g===null)return{resource:null}}let u=class{constructor(a,d,w){this.a=a.getProxy(N.$hM.MainThreadConfiguration),this.c=d,this.b=w,this.d=new T.$xh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(a,d))}};e.$emc=u,e.$emc=u=Je([We(0,l.$LO),We(1,A.$dmc),We(2,b.$5j)],u);class t{constructor(a,d,w,$){this.a=new O.$fe,this.b=a,this.f=$,this.c=d,this.e=p.$Do.parse(w,$),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Do.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,w))}getConfiguration(a,d,w){const $=c(d)||{},v=this.g(a?s(this.e.getValue(void 0,$,this.c.workspace),a):this.e.getValue(void 0,$,this.c.workspace));a&&this.h(a,$,w?.identifier);function y(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(D){return typeof s(v,D)<"u"},get:(D,k)=>{this.h(a?`${a}.${D}`:D,$,w?.identifier);let I=s(v,D);if(typeof I>"u")I=k;else{let P;const V=(W,q)=>{if((0,E.$ag)(W)){let M;const z=()=>{P=P||(0,C.$5n)(v),M=M||s(P,q)};return new Proxy(W,{get:(G,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return z(),()=>M;if(P)return M=M||s(P,q),M[ie];const de=G[ie];return typeof ie=="string"?V(de,`${q}.${ie}`):de},set:(G,ie,de)=>(z(),M&&(M[ie]=de),!0),deleteProperty:(G,ie)=>(z(),M&&delete M[ie],!0),defineProperty:(G,ie,de)=>(z(),M&&Object.defineProperty(M,ie,de),!0)})}return Array.isArray(W)?(0,C.$5n)(W):W};I=V(I,D)}return I},update:(D,k,I,P)=>{D=a?`${a}.${D}`:D;const V=y(I);return k!==void 0?this.b.$updateConfigurationOption(V,D,k,$,P):this.b.$removeConfigurationOption(V,D,$,P)},inspect:D=>{D=a?`${a}.${D}`:D;const k=this.e.inspect(D,$,this.c.workspace);if(k)return{key:D,defaultValue:(0,C.$5n)(k.policy?.value??k.default?.value),globalValue:(0,C.$5n)(k.user?.value??k.application?.value),workspaceValue:(0,C.$5n)(k.workspace?.value),workspaceFolderValue:(0,C.$5n)(k.workspaceFolder?.value),defaultLanguageValue:(0,C.$5n)(k.default?.override),globalLanguageValue:(0,C.$5n)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,C.$5n)(k.workspace?.override),workspaceFolderLanguageValue:(0,C.$5n)(k.workspaceFolder?.override),languageIds:(0,C.$5n)(k.overrideIdentifiers)}}};return typeof v=="object"&&(0,C.$8n)(h,v,!1),Object.freeze(h)}g(a){const d=w=>(0,E.$ag)(w)?new Proxy(w,{get:($,v)=>d($[v]),set:($,v,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:($,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:($,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:$=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return d(a)}h(a,d,w){const $=m.$uo.test(a)?4:this.d.get(a),v=w?`[${w.value}] `:"";if($===4){typeof d?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if($===3){d?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const w=new p.$Fo(a,d,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:($,v)=>w.affectsConfiguration($,c(v))})}k(a){return a.reduce((d,w)=>(d.set(w[0],w[1]),d),new Map)}}e.$fmc=t,e.$gmc=(0,S.$yi)("IExtHostConfiguration")}),define(Se[121],Ie([1,0,2,11,5,4,7,39,68,40,20,53,17,27,3,16,23,12,80,241,14]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=e.$Jnc=e.$Inc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(V){function W(M){if(M!=null)return M}V.from=W;function q(M){if(M!=null)return M}V.to=q})(u||(u={}));var t;(function(V){function W(M){if(M!=null)return M}V.from=W;function q(M){if(M!=null)return M}V.to=q})(t||(t={}));var g;(function(V){function W(M){if(M!=null)return M}V.from=W;function q(M){if(M!=null)return M}V.to=q})(g||(g={}));var a;(function(V){function W(z){if(z){const G=z;return G&&!!G.process}else return!1}V.is=W;function q(z){if(z==null)return;const G={process:z.process,args:z.args};return z.options&&(G.options=g.from(z.options)),G}V.from=q;function M(z){if(z!=null)return new R.$6M(z.process,z.args,z.options)}V.to=M})(a||(a={}));var d;(function(V){function W(M){if(M!=null)return M}V.from=W;function q(M){if(M!=null)return M}V.to=q})(d||(d={}));var w;(function(V){function W(z){if(z){const G=z;return G&&(!!G.commandLine||!!G.command)}else return!1}V.is=W;function q(z){if(z==null)return;const G={};return z.commandLine!==void 0?G.commandLine=z.commandLine:(G.command=z.command,G.args=z.args),z.options&&(G.options=d.from(z.options)),G}V.from=q;function M(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new R.$7M(z.commandLine,z.options):new R.$7M(z.command,z.args?z.args:[],z.options)}V.to=M})(w||(w={}));var $;(function(V){function W(z){if(z){const G=z;return G&&G.customExecution==="customExecution"}else return!1}V.is=W;function q(z){return{customExecution:"customExecution"}}V.from=q;function M(z,G){return G.get(z)}V.to=M})($||(e.CustomExecutionDTO=$={}));var v;(function(V){function W(q,M){let z;return q.scope!==void 0&&typeof q.scope!="number"?z=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===R.TaskScope.Workspace&&M&&M.workspaceFile?z=M.workspaceFile:z=n.$hI),{id:q._id,workspaceFolder:z}}V.from=W})(v||(e.TaskHandleDTO=v={}));var y;(function(V){function W(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}V.from=W})(y||(y={}));var h;(function(V){function W(z,G){if(z==null)return[];const ie=[];for(const de of z){const ye=q(de,G);ye&&ie.push(ye)}return ie}V.fromMany=W;function q(z,G){if(z==null)return;let ie;z.execution instanceof R.$6M?ie=a.from(z.execution):z.execution instanceof R.$7M?ie=w.from(z.execution):z.execution&&z.execution instanceof R.$8M&&(ie=$.from(z.execution));const de=u.from(z.definition);let ye;return z.scope?typeof z.scope=="number"?ye=z.scope:ye=z.scope.uri:ye=R.TaskScope.Workspace,!de||!ye?void 0:{_id:z._id,definition:de,name:z.name,source:{extensionId:G.identifier.value,label:z.source,scope:ye},execution:ie,isBackground:z.isBackground,group:y.from(z.group),presentationOptions:t.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}V.from=q;async function M(z,G,ie){if(z==null)return;let de;a.is(z.execution)?de=a.to(z.execution):w.is(z.execution)?de=w.to(z.execution):$.is(z.execution)&&(de=$.to(z._id,ie));const ye=u.to(z.definition);let Ee;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?Ee=z.source.scope:Ee=await G.resolveWorkspaceFolder(C.URI.revive(z.source.scope)):Ee=R.TaskScope.Workspace),!ye||!Ee)return;const me=new R.$9M(ye,Ee,z.name,z.source.label,de,z.problemMatchers);return z.isBackground!==void 0&&(me.isBackground=z.isBackground),z.group!==void 0&&(me.group=R.$5M.from(z.group._id),me.group&&z.group.isDefault&&(me.group=new R.$5M(me.group.id,me.group.label),z.group.isDefault===!0&&(me.group.isDefault=z.group.isDefault))),z.presentationOptions&&(me.presentationOptions=t.to(z.presentationOptions)),z._id&&(me._id=z._id),z.detail&&(me.detail=z.detail),me}V.to=M})(h||(e.TaskDTO=h={}));var D;(function(V){function W(M){return M}V.from=W;function q(M){if(M)return Object.assign(Object.create(null),M)}V.to=q})(D||(D={}));class k{#e;constructor(W,q,M){this._id=q,this.a=M,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let I=class{constructor(W,q,M,z,G,ie,de,ye){this.q=new A.$fe,this.r=new A.$fe,this.s=new A.$fe,this.u=new A.$fe,this.a=W.getProxy(N.$hM.MainThreadTask),this.b=M,this.c=z,this.d=G,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,q,M){if(!M)return new R.$jM(()=>{});const z=this.x();return this.j.set(z,{type:q,provider:M,extension:W}),this.a.$registerTaskProvider(z,q),new R.$jM(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(W,q){this.a.$registerTaskSystem(W,q)}fetchTasks(W){return this.a.$fetchTasks(D.from(W)).then(async q=>{const M=[];for(const z of q){const G=await h.to(z,this.b,this.m);G&&M.push(G)}return M})}get taskExecutions(){const W=[];return this.k.forEach(q=>W.push(q)),W}terminateTask(W){if(!(W instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,q,M){const z=this.m.get(W.id);z&&(this.o.set(W.id,z),this.e.attachPtyToTerminal(q,await z.callback(M))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const q=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const q=await this.z(W.id);this.s.fire({execution:q,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const q=await this.z(W.id);this.u.fire({execution:q,exitCode:W.exitCode})}$provideTasks(W,q){const M=this.j.get(W);if(!M)return Promise.reject(new Error("no handler found"));const z=[],G=(0,O.$qh)(()=>M.provider.provideTasks(T.CancellationToken.None)).then(ie=>this.v(q,z,M,ie));return new Promise(ie=>{G.then(de=>{Promise.all(z).then(()=>{ie(de)})})})}async $resolveTask(W,q){const M=this.j.get(W);if(!M)return Promise.reject(new Error("no handler found"));if(q.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${M.type}].`);const z=await h.to(q,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const G=await M.provider.resolveTask(z,T.CancellationToken.None);if(!G)return;this.A(G,M);const ie=h.from(G,M.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return $.is(ie.execution)&&await this.y(ie,G,!0),await this.w(ie)}x(){return this.h++}async y(W,q,M){const z=await this.a.$createTaskId(W);!M&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,q.execution)),this.m.set(z,q.execution)}async z(W,q){if(typeof W=="string"){const G=this.l.get(W);if(!G)throw new c.$bb("Unexpected: The specified task is missing an execution");return G}const M=this.l.get(W.id);if(M)return M;let z;return q?z=Promise.resolve(new k(this,W.id,q)):z=h.to(W.task,this.b,this.m).then(G=>{if(!G)throw new c.$bb("Unexpected: Task does not exist.");return new k(this,W.id,G)}),this.l.set(W.id,z),z.then(G=>(this.k.set(W.id,G),G))}A(W,q){W._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const M=this.n.values();let z=M.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=M.next()}};e.$Inc=I,e.$Inc=I=Je([We(0,l.$LO),We(1,b.$2O),We(2,p.$dmc),We(3,m.$WO),We(4,E.$gmc),We(5,S.$Emc),We(6,o.$5j),We(7,i.$Tlc)],I);let P=class extends I{constructor(W,q,M,z,G,ie,de,ye){super(W,q,M,z,G,ie,de,ye),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:r.$h(0)})}async executeTask(W,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const M=h.from(q,W);if(M===void 0)throw new Error("Task is not valid");if($.is(M.execution))await this.y(M,q,!1);else throw new c.$_;const z=await this.z(await this.a.$getTaskExecution(M),q);return this.a.$executeTask(M).catch(G=>{throw new Error(G)}),z}v(W,q,M,z){const G=[];if(z)for(const ie of z){if(this.A(ie,M),!ie.definition||!W[ie.definition.type]){const ye=ie.source?ie.source:"No task source";this.f.warn(`The task [${ye}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const de=h.from(ie,M.extension);de&&$.is(de.execution)?(G.push(de),q.push(this.y(de,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:G,extension:M.extension}}async w(W){if($.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,q,M){}};e.$Jnc=P,e.$Jnc=P=Je([We(0,l.$LO),We(1,b.$2O),We(2,p.$dmc),We(3,m.$WO),We(4,E.$gmc),We(5,S.$Emc),We(6,o.$5j),We(7,i.$Tlc)],P),e.$Knc=(0,f.$yi)("IExtHostTask")}),define(Se[299],Ie([1,0,47,30]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WK=void 0,e.$VK=A,e.$XK=N;function A(R){return"cellResults"in R}e.$WK="rawCell#";function N(R,p){let m=-1;const E=[];let T=[];return R.forEach(l=>{l.range.startLineNumber!==m&&T.length>0&&(E.push([...T]),T=[]),T.push(l),m=l.range.endLineNumber}),T.length>0&&E.push([...T]),E.map(l=>{const b=[],f=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let r=f;r<=s;r++)b.push(p.getLineContent(r));return new C.$zK(b.join(`
`)+`
`,l.map(r=>new O.$xt(r.range.startLineNumber-1,r.range.startColumn-1,r.range.endLineNumber-1,r.range.endColumn-1)))})}}),define(Se[300],Ie([1,0,177,22,5,6,28,13,15,2,38,76,4,35,8,7,34,276,114,26,16,231,299,297]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c,u,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,$,v,y,h,D){this.q=v,this.r=y,this.s=h,this.t=D,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new A.$fe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$fe,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$fe,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$fe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$Rlc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=w.getProxy(l.$hM.MainThreadNotebook),this.c=w.getProxy(l.$hM.MainThreadNotebookDocuments),this.d=w.getProxy(l.$hM.MainThreadNotebookEditors),this.i=$.converter,$.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const I=k.notebookEditor?.notebookUri,P=k.cell.handle,W=this.g.get(I)?.getCell(P);if(W)return W.apiCell}if(k&&k.$mid===14){const I=k.uri,P=this.g.get(I);if(P)return P.apiNotebook}return k}}),a.B($)}getEditorById(w){const $=this.h.get(w);if(!$)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return $}getIdByEditor(w){for(const[$,v]of this.h)if(v.apiEditor===w)return $}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,$){const v=this.g.get(w);if(!v&&!$)throw new Error(`NO notebook document for '${w}'`);return v}static u(w,$){if(!$)return;const v=$.filenamePattern.map(y=>f.NotebookExclusiveDocumentPattern.from(y)).filter(y=>y!==void 0);if($.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${$.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:$.displayName,filenamePattern:v,exclusive:$.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,$,v){const y=a.a++,h=typeof v.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(y,v),this.b.$registerNotebookCellStatusBarItemProvider(y,h,$);let D;return h!==void 0&&(D=v.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(h))),new s.$jM(()=>{this.f.delete(y),this.b.$unregisterNotebookCellStatusBarItemProvider(y,h),D?.dispose()})}async createNotebookDocument(w){const $=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&f.NotebookData.from(w.content)});return E.URI.revive($)}async openNotebookDocument(w){const $=this.g.get(w);if($)return $.apiNotebook;const v=await this.c.$tryOpenNotebook(w),y=this.g.get(E.URI.revive(v));return(0,m.$jg)(y?.apiNotebook)}async showNotebookDocument(w,$){E.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let v;typeof $=="object"?v={position:f.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selections:$.selections&&$.selections.map(f.NotebookRange.from),pinned:typeof $.preview=="boolean"?!$.preview:void 0}:v={preserveFocus:!1};const y=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,v),h=y&&this.h.get(y)?.apiEditor;if(h)return h;throw y?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,$,v,y){const h=this.f.get(w),D=E.URI.revive($),k=this.g.get(D);if(!k||!h)return;const I=k.getCellFromIndex(v);if(!I)return;const P=await h.provideCellStatusBarItems(I.apiCell,y);if(!P)return;const V=new N.$Tc,W=this.p.add([V]),M=(Array.isArray(P)?P:[P]).map(z=>f.NotebookStatusBarItem.from(z,this.i,V));return{cacheId:W,items:M}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,$,v,y,h){if((0,p.$9e)($))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:$,serializer:v,options:y}),this.b.$registerNotebookSerializer(D,{id:w.identifier,location:w.extensionLocation},$,f.NotebookDocumentContentOptions.from(y),a.u(w,h)),(0,N.$Sc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(w,$,v){const y=this.x.get(w);if(!y)throw new Error("NO serializer found");const h=await y.serializer.deserializeNotebook($.buffer,v);return new r.$Ew(f.NotebookData.from(h))}async $notebookToData(w,$,v){const y=this.x.get(w);if(!y)throw new Error("NO serializer found");const h=await y.serializer.serializeNotebook(f.NotebookData.to($.value),v);return O.$He.wrap(h)}async $saveNotebook(w,$,v,y,h){const D=E.URI.revive($),k=this.x.get(w);if(!k)throw new Error("NO serializer found");const I=this.g.get(D);if(!I)throw new Error("Document NOT found");if(I.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new T.$nl((0,C.localize)(0,null,this.z(D)),6);const P={metadata:(0,n.$ao)(I.apiNotebook.metadata,z=>!(k.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of I.apiNotebook.getCells()){const G=new s.$MN(z.kind,z.document.getText(),z.document.languageId,z.mime,k.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);G.metadata=(0,n.$ao)(z.metadata,ie=>!(k.options?.transientCellMetadata??{})[ie]),P.cells.push(G)}await this.y(D,y);const V=await k.serializer.serializeNotebook(P,h);await this.s.value.writeFile(D,V);const W=this.s.getFileSystemProviderExtUri(D.scheme),q=await this.s.value.stat(D);return{name:W.basename(D),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$yl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(w,$,v,y,h){const D=this.x.get(w)?.serializer;if(!D)return{limitHit:!1,results:[]};const k=new R.$Bc;await(async(q,M,z)=>{await Promise.all(q.map(async G=>await Promise.all(G.filenamePatterns.map(ie=>{const de={_reason:z._reason,folderQueries:z.folderQueries,includePattern:z.includePattern,excludePattern:z.excludePattern,maxResults:z.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(de,M,ye=>{ye.forEach(Ee=>{k.has(Ee)||y.some(ue=>G.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(Ce=>(0,g.$Ugb)(Ce,Ee)))||k.add(Ee)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(v,h,$);const P=new R.$Ac;let V=!1;const W=Array.from(k).map(async q=>{const M=[];try{if(h.isCancellationRequested)return;if($.maxResults&&[...P.values()].reduce((de,ye)=>de+ye.cellResults.length,0)>$.maxResults){V=!0;return}const z=[],G=this.g.get(q);if(G)G.apiNotebook.getCells().forEach(ye=>z.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(Ee=>Ee.items.map(me=>me.data.toString()))}));else{const de=await this.s.value.readFile(q),ye=O.$He.fromString(de.toString()),Ee=await D.deserializeNotebook(ye.buffer,h);if(h.isCancellationRequested)return;f.NotebookData.from(Ee).cells.forEach(ue=>z.push({input:ue.source,outputs:ue.outputs.flatMap(Ce=>Ce.items.map(se=>se.valueBytes.toString()))}))}if(h.isCancellationRequested)return;z.forEach((de,ye)=>{const Ee=$.contentPattern.pattern,me=new u.$wXb(de.input,void 0,de.outputs),ue=me.findInInputs(Ee),Ce=me.findInOutputs(Ee),se=Ce.flatMap(Oe=>(0,t.$XK)(Oe.matches,Oe.textBuffer)).map((Oe,ne)=>(Oe.webviewIndex=ne,Oe));if(ue.length>0||Ce.length>0){const Oe={index:ye,contentResults:(0,t.$XK)(ue,me.inputTextBuffer),webviewResults:se};M.push(Oe)}});const ie={resource:q,cellResults:M};P.set(q,ie);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...P.values()]}}async y(w,$){const v=await this.s.value.stat(w);if(typeof $?.mtime=="number"&&typeof $.etag=="string"&&$.etag!==T.$xl&&typeof v.mtime=="number"&&typeof v.size=="number"&&$.mtime<v.mtime&&$.etag!==T.$yl({mtime:$.mtime,size:v.size}))throw new T.$nl((0,C.localize)(1,null),3,$)}z(w){return w.scheme===c.Schemas.file?w.fsPath:w.toString()}A(w,$,v){if(this.h.has($))throw new Error(`editor with id ALREADY EXSIST: ${$}`);const y=new i.$cnc($,this.d,w,v.visibleRanges.map(f.NotebookRange.to),v.selections.map(f.NotebookRange.to),typeof v.viewColumn=="number"?f.ViewColumn.to(v.viewColumn):void 0);this.h.set($,y)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const v of w.value.removedDocuments){const y=E.URI.revive(v),h=this.g.get(y);h&&(h.dispose(),this.g.delete(y),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(h.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===y.toString()&&this.h.delete(D.id)}if(w.value.addedDocuments){const v=[];for(const y of w.value.addedDocuments){const h=E.URI.revive(y.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const D=new o.$bnc(this.c,this.q,this.r,h,y);v.push(...y.cells.map(k=>o.$anc.asModelAddData(k))),this.g.get(h)?.dispose(),this.g.set(h,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(D.apiNotebook)}}if(w.value.addedEditors)for(const v of w.value.addedEditors){if(this.h.has(v.id))return;const y=E.URI.revive(v.documentUri),h=this.g.get(y);h&&this.A(h,v.id,v)}const $=[];if(w.value.removedEditors)for(const v of w.value.removedEditors){const y=this.h.get(v);y&&(this.h.delete(v),this.k?.id===y.id&&(this.k=void 0),$.push(y))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(y=>this.h.get(y)).filter(y=>!!y);const v=new Set;this.l.forEach(y=>v.add(y.id));for(const y of this.h.values()){const h=v.has(y.id);y._acceptVisibility(h)}this.l=[...this.h.values()].map(y=>y).filter(y=>y.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.h.get(w.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${w.value.newActiveEditor}`),this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(w){const $=b.$0O.String.with("notebookType","A notebook type"),v=new b.$_O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[$,new b.$0O("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>O.$He.wrap(h))],new b.$$O("Notebook Data",h=>f.NotebookData.to(h.value))),y=new b.$_O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[$,new b.$0O("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new r.$Ew(f.NotebookData.from(h)))],new b.$$O("Bytes",h=>h.buffer));w.registerApiCommand(v),w.registerApiCommand(y)}}e.$lnc=a}),define(Se[301],Ie([1,0,19,20,44,37,24,66,47]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=void 0;class E{constructor(l,b,f){this.k=l,this.l=b,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&N.$sk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&N.$sk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const b=this.k.folderQueries||[];return new Promise((f,s)=>{const r=o=>{this.f++,l(o)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=C.$nc(i);this.j&&this.j(i,n)||this.v(r,{base:o,basename:n})}),Promise.all(b.map(o=>this.p(o,r))).then(o=>{f({limitHit:this.e,stats:o[0]||void 0})},o=>{s(new Error((0,A.$jj)(o)))})})}async p(l,b){const f=new O.$qe,s=this.q(l),r=this.r(),o=new m.$NK(this.k,l),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(f),n=p.$be.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,f.token),u=n.elapsed(),t=p.$be.create();return this.g&&!this.e||(c&&c.forEach(g=>{const a=C.$gc.relative(l.folder.path,g.path);if(i){const d=C.$nc(g.path);this.v(b,{base:l.folder,relativePath:a,basename:d});return}this.s(r,l.folder,a,b)}),this.g&&!this.e)?null:(this.u(r,o,b),{providerTime:u,postProcessTime:t.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(l){const b=(0,m.$MK)(this.k.includePattern,l.includePattern),f=(0,m.$MK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:f,includes:b,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},b,f,s){if(f===this.a){const o=C.$nc(this.a);this.v(s,{base:b,relativePath:this.a,basename:o})}function r(o){const i=C.$nc(o),n=C.$mc(o);let c=l[n];c||(c=l[n]=[],r(n)),c.push({base:b,relativePath:o,basename:i})}r(f)}u({rootEntries:l,pathToEntries:b},f,s){const r=this,o=this.a;function i(n){const c=(0,m.$PK)(()=>n.map(u=>u.basename));for(let u=0,t=n.length;u<t;u++){const g=n[u],{relativePath:a,basename:d}=g;if(f.matchesExcludesSync(a,d,o!==d?c:void 0))continue;const w=b[a];if(w)i(w);else{if(a===o)continue;r.v(s,g)}if(r.e)break}}i(l)}v(l,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(b))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,b,f,s){const r=this.c(l.cacheKey),o=new E(l,b,r&&r.token);let i=0;const n=c=>{i+=c.length,f(c.map(u=>this.d(u)))};return this.e(o,T.a,n,s).then(c=>({limitHit:c.limitHit,stats:c.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:c.stats}:void 0,messages:[]}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new O.$qe),this.b.get(l)}d(l){return l.relativePath?{resource:R.$_g(l.base,l.relativePath)}:{resource:l.base}}e(l,b,f,s){const r=s.onCancellationRequested(()=>{l.cancel()}),o=n=>{n&&(i.push(n),b>0&&i.length>=b&&(f(i),i=[]))};let i=[];return l.search(o).then(n=>(i.length&&f(i),r.dispose(),n),n=>(i.length&&f(i),r.dispose(),Promise.reject(n)))}}e.$dnc=T}),define(Se[302],Ie([1,0,18,271,37,97,28,16,19,24,13,15,2,96,195,50,12,45,109,298,47]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=void 0,e.$YL=y;let u=class{constructor(D,k,I,P,V){this.a=D,this.b=k,this.c=I,this.d=P,this.e=V}text(D,k,I={}){D=this.f(D,I);const P=this.a.getValue(),V=k&&k.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(k?.map(o.$Ti),I),type:2,contentPattern:D,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:P.search.usePCRE2||V||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}f(D,k){const I=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const P={...D,wordSeparators:I.editor.wordSeparators};return this.j(D,k)&&(P.isCaseSensitive=!0),this.k(D)&&(P.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),P}file(D,k={}){return{...this.h(D,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(D,k){return D?(D=Array.isArray(D)?D.map(w):w(D),k?this.parseSearchPaths(D):{pattern:g(...Array.isArray(D)?D:[D])}):{}}h(D=[],k={}){const I=this.g(k.includePattern,k.expandPatterns),P=this.g(k.excludePattern,k.expandPatterns),V=D.length>1,W=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(z=>this.q(z,k,P)):D.map(z=>this.r(z,k,P,V))).filter(z=>!!z),q={_reason:k._reason,folderQueries:W,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:P.pattern,includePattern:I.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const z=C.$Hb(this.c.groups.flatMap(de=>de.editors.map(ye=>ye.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const G=z.filter(de=>(0,c.$DK)(q,de.fsPath)),ie=this.i(G);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const M=k.extraFileResources&&k.extraFileResources.filter(z=>(0,c.$DK)(q,z.fsPath));return q.extraFileResources=M&&M.length?M:void 0,q}i(D){const k=[],I=new R.$Ac,P={};let V=!1;return D.forEach(W=>{if(W.scheme===p.Schemas.walkThrough)return;if((0,E.$dh)(W)){const M=this.b.getWorkspaceFolder(W)?.uri??W.with({path:m.$mc(W.fsPath)});let z=I.get(M);z||(V=!0,z={folder:M,includePattern:{}},k.push(z),I.set(M,z));const G=m.$lc(M.fsPath,W.fsPath);(0,S.$jg)(z.includePattern)[G.replace(/\\/g,"/")]=!0}else W.fsPath&&(V=!0,P[W.fsPath]=!0)}),{folderQueries:k,includePattern:P,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(D,k){if(k.isSmartCase){if(D.isRegExp){if(T.$2f(D.pattern,!0))return!0}else if(T.$2f(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,b.$TC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const k=ie=>m.$ic(ie)||/^\.\.?([\/\\]|$)/.test(ie),P=(Array.isArray(D)?D:a(D)).map(ie=>{const de=this.e.resolvedUserHome;return de?(0,N.$Jw)(ie,de.scheme===p.Schemas.file?de.fsPath:de.path):ie}),V=O.$K(P,ie=>k(ie)?"searchPaths":"exprSegments"),W=(V.exprSegments||[]).map(ie=>T.$hf(ie,"/")).map(ie=>T.$hf(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),d(ie))),q={},M=this.m(V.searchPaths||[]);M&&M.length&&(q.searchPaths=M);const z=W.flat(),G=g(...z);return G&&(q.pattern=G),q}l(D,k){return k.disregardExcludeSettings?void 0:(0,c.$CK)(D,!k.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const k=D.flatMap(P=>{let{pathPortion:V,globPortion:W}=t(P);return W&&(W=$(W)),this.n(V).flatMap(M=>this.o(M,W))}),I=new Map;return k.forEach(P=>{const V=P.searchPath.toString(),W=I.get(V);W?P.pattern&&(W.pattern=W.pattern||{},W.pattern[P.pattern]=!0):I.set(V,{searchPath:P.searchPath,pattern:P.pattern?g(P.pattern):void 0})}),Array.from(I.values())}n(D){if(m.$ic(D)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==p.Schemas.file?[{searchPath:k[0].uri.with({path:D})}]:[{searchPath:l.URI.file(m.$hc(D))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(D=w(D),D.startsWith("../")||D===".."){const P=m.$gc.resolve(k.path,D);return[{searchPath:k.with({path:P})}]}const I=$(D);return[{searchPath:k,pattern:I}]}else{if(D==="./"||D===".\\")return[];{const k=D.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(V=>{const W=k.match(new RegExp(`^${T.$bf(V.name)}(?:/(.*)|$)`));return W?{match:W,folder:V}:null}).filter(S.$gg);if(P.length)return P.map(V=>{const W=V.match[1];return{searchPath:V.folder.uri,pattern:W&&$(W)}});{const V=D.match(/\.[\/\\](.+)[\/\\]?/),W=V?V[1]:D,q=f.localize(0,null,W);throw new Error(q)}}}}o(D,k){const I=D.pattern&&k?`${D.pattern}/${k}`:D.pattern||k,P=[{searchPath:D.searchPath,pattern:I}];return I&&!I.endsWith("**")&&P.push({searchPath:D.searchPath,pattern:I+"/**"}),P}q(D,k,I){const P=this.r((0,o.$Ti)(D.searchPath),k,I,!1);return P?{...P,includePattern:D.pattern}:null}r(D,k,I,P){let V;const W=l.URI.isUri(D)?D:D.uri;if(I.searchPaths){const ie=I.searchPaths.filter(de=>(0,E.$5g)(de.searchPath,W))[0];if(ie&&!ie.pattern)return null;ie&&(V=ie.pattern)}const q=this.a.getValue({resource:W}),z={...this.l(q,k)||{},...V||{}},G=l.URI.isUri(D)?(0,E.$9g)(D):D.name;return{folder:W,folderName:P?G:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!q.search.followSymlinks}}};e.$XL=u,e.$XL=u=Je([We(0,s.$5i),We(1,o.$Hi),We(2,i.$2D),We(3,r.$5j),We(4,n.$VL)],u);function t(h){const D=h.match(/[\*\{\}\(\)\[\]\?]/);if(D){const k=D.index,I=h.substr(0,k).match(/[/|\\][^/\\]*$/);if(I){let P=h.substr(0,I.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:h.substr((I.index||0)+1)}}}return{pathPortion:h}}function g(...h){return h.length?h.reduce((D,k)=>(D[k]=!0,D),Object.create(null)):void 0}function a(h){return A.$qk(h,",").map(D=>D.trim()).filter(D=>!!D.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function w(h){return h.replace(/\\/g,"/")}function $(h){return w(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(h){return h.replace(/([?*[\]])/g,"[$1]")}function y(h,D){h=C.$Mb(h,P=>P.toString());const k=[],I=D.getWorkspace();return h&&h.forEach(P=>{let V;if(D.getWorkbenchState()===2)V=(0,E.$bh)(I.folders[0].uri,P),V&&V!=="."&&(V="./"+V);else{const W=D.getWorkspaceFolder(P);if(W){const q=W.name;if(I.folders.filter(z=>z.name===q).length===1){const z=(0,E.$bh)(W.uri,P);z===""?V=`./${W.name}`:V=`./${W.name}/${z}`}else V=P.fsPath}}V&&k.push(v(V))}),k}}),define(Se[303],Ie([1,0,24,2,20,14,3,302,47,45,11]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Owb=l,e.$Pwb=s;const S=7e3;function l(r,o){const i=o.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],c=[];for(const w of i)if(/^workspaceContains:/.test(w)){const $=w.substr(18);$.indexOf("*")>=0||$.indexOf("?")>=0||r.forceUsingSearch?c.push($):n.push($)}if(n.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:u,resolve:t}=(0,T.$rh)(),g=w=>t({activationEvent:w}),a=Promise.all(n.map(w=>b(r,w,g))).then(()=>{}),d=f(r,o.identifier,c,g);return Promise.all([a,d]).then(()=>{t(void 0)}),u}async function b(r,o,i){for(const n of r.folders)if(await r.exists(C.$_g(O.URI.revive(n),o))){i(`workspaceContains:${o}`);return}}async function f(r,o,i,n){if(i.length===0)return Promise.resolve(void 0);const c=new A.$qe,u=r.checkExists(r.folders,i,c.token),t=setTimeout(async()=>{c.cancel(),r.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},S);let g=!1;try{g=await u}catch(a){N.$4(a)||N.$1(a)}c.dispose(),clearTimeout(t),g&&n(`workspaceContains:${i.join(",")}`)}function s(r,o,i,n){const c=r.get(R.$xi),u=r.get(m.$uK),g=c.createInstance(p.$XL).file(o.map(a=>(0,E.$Ti)(O.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return u.fileSearch(g,n).then(a=>!!a.limitHit,a=>N.$4(a)?!1:Promise.reject(a))}}),define(Se[41],Ie([1,0,173,19,60,24,11,6,54,2,12,4,40,237,84,39,25,110,14,21,22,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,23,82]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c,u,t,g,a,d,w,$,v,y,h,D,k,I,P,V,W,q,M,z,G){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=e.$Umc=e.$Tmc=e.$Smc=e.$Rmc=void 0,e.$Rmc=(0,a.$yi)("IHostUtils");let de=ie=class extends p.$Uc{constructor(U,x,ve,Fe,ke,we,ge,Q,Y,he,ce,Ne,fe){super(),this.Y=Ne,this.Z=fe,this.a=this.B(new k.$fe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=ve,this.f=ge,this.j=Fe,this.m=ke,this.s=we,this.t=Y,this.u=he,this.w=ce,this.y=this.g.getProxy(S.$hM.MainThreadWorkspace),this.z=this.g.getProxy(S.$hM.MainThreadTelemetry),this.C=this.g.getProxy(S.$hM.MainThreadExtensionService),this.D=new R.$xh,this.F=new R.$xh,this.G=new R.$xh,this.H=new R.$xh,this.I=new Oe(this.f.extensions.activationEvents),this.L=new o.$pac(this.I,this.f.extensions.allExtensions);const Pe=new n.$Um(this.f.extensions.myExtensions);this.J=new o.$pac(this.I,Ce(this.L,Pe)),z.$t&&(this.s.info(`Creating extension host with the following global extensions: ${me(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${me(this.J)}`)),this.M=new f.$Amc(this.g,this.s),this.N=new P.$Kmc(this.g),this.O=Q,this.h=U.createChild(new v.$wi([f.$Bmc,this.M],[P.$Lmc,this.N])),this.P=this.B(new b.$zmc(this.J,this.L,{onExtensionActivationError:(Me,je,B)=>{this.C.$onExtensionActivationError(Me,i.$3(je),B)},actualActivateExtension:async(Me,je)=>{if(o.$pac.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,je),new b.$ymc;const B=this.J.getExtensionDescription(Me);return this.fb(B,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){i.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.eb(ke))}catch{}await Promise.all(U)}terminate(U,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Fe=>{this.s.error(Fe)}),this.g.dispose();const ve=this.$();Promise.race([(0,R.$zh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const x=await this.C.$getExtension(U);return x&&{...x,identifier:new n.$Tm(x.identifier.value),extensionLocation:E.URI.revive(x.extensionLocation)}}ab(U,x){return this.P.activateByEvent(U,x)}bb(U,x){return this.P.activateById(U,x)}activateByIdWithErrors(U,x){return this.bb(U,x).then(()=>{const ve=this.P.getActivatedExtension(U);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===W.Schemas.file&&this.c.fsRealpath){const x=U.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const ve=await this.R.get(x);return E.URI.file(ve)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new se(U))),this.Q}async db(U){const x=m.$Ei.forUris(ve=>N.$3g.ignorePathCasing(ve));return await Promise.all(U.map(async ve=>{if(this.wb(ve)){const Fe=await this.cb(ve.extensionLocation);x.set(Fe,ve)}})),x}eb(U){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return x;const ve=this.P.getActivatedExtension(U);if(!ve)return x;try{typeof ve.module.deactivate=="function"&&(x=Promise.resolve(ve.module.deactivate()).then(void 0,Fe=>(this.s.error(Fe),Promise.resolve(void 0))))}catch(Fe){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Fe)}try{(0,p.$Pc)(ve.subscriptions)}catch(Fe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Fe)}return x}async fb(U,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,x).then(ve=>{const Fe=ve.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Fe.codeLoadingTime,Fe.activateCallTime,Fe.activateResolvedTime,x),this.gb(U,x,"success",Fe),ve},ve=>{throw this.gb(U,x,"failure"),ve})}gb(U,x,ve,Fe){const ke=Ee(U,x);this.z.$publicLog2("extensionActivationTimes",{...ke,...Fe||{},outcome:ve})}hb(U,x){const ve=Ee(U,x);this.z.$publicLog2("activatePlugin",ve);const Fe=this.wb(U);if(!Fe)return Promise.resolve(new b.$xmc(b.$umc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${U.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const ke=new b.$vmc(x.startup);return Promise.all([this.xb(U,(0,N.$_g)(U.extensionLocation,Fe),ke),this.ib(U)]).then(we=>(A.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),ie.jb(this.s,U.identifier,we[0],we[1],ke))).then(we=>(A.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),we))}ib(U){const x=this.Z.createLanguageModelAccessInformation(U),ve=new u.$Dmc(U,this.M),Fe=new u.$Cmc(U.identifier.value,!1,this.M),ke=new V.$Mmc(U,this.N),we=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([ve.whenReady,Fe.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,he;const ce=(0,r.$JG)(U,"ipc")?this.f.messagePorts?.get(n.$Tm.toKey(U.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Fe,secrets:ke,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ne){return O.$jc(U.extensionLocation.fsPath,Ne)},get storagePath(){return Q.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return Q.O.globalValue(U).fsPath},get logPath(){return O.$jc(Q.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return E.URI.joinPath(Q.f.logsLocation,U.identifier.value)},get storageUri(){return Q.O.workspaceValue(U)},get globalStorageUri(){return Q.O.globalValue(U)},get extensionMode(){return we},get extension(){return Y===void 0&&(Y=new ue(Q,U.identifier,U,ge,!1)),Y},get extensionRuntime(){return(0,r.$KG)(U,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!he){if(!ce)return;const Ne=k.Event.buffer(k.Event.fromDOMEventEmitter(ce,"message",fe=>fe.data));ce.start(),he={onDidReceiveMessage:Ne,postMessage:ce.postMessage.bind(ce)}}return he}})})}static jb(U,x,ve,Fe,ke){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(U,x,ve,Fe,ke).then(we=>new b.$wmc(!1,null,ke.build(),ve,we,Fe.subscriptions))}static kb(U,x,ve,Fe,ke){if(typeof ve.activate=="function")try{ke.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${x.value}`);const we=typeof global=="object"?global:self,ge=ve.activate.apply(we,[Fe]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(ge).then(Q=>(ke.activateResolveStop(),Q))}catch(we){return Promise.reject(we)}else return Promise.resolve(ve)}lb(U,x){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:x}).then(void 0,ve=>{this.s.error(ve)})}mb(U,x=0){const Fe=Date.now();(0,z.$B)(()=>{for(let ke=x;ke<U.length;ke+=1){const we=U[ke];for(const ge of we.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Fe>50){this.mb(U,ke);break}else this.lb(we,ge)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(U=>{const x=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(x)this.mb(ve);else for(const Fe of ve)if(Fe.activationEvents)for(const ke of Fe.activationEvents)ke==="onStartupFinished"&&this.lb(Fe,ke)})}ob(){const U=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const x=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(x),Fe=this.rb(),ke=Promise.all([Fe,U,ve]).then(()=>{});return Promise.race([ke,(0,R.$zh)(1e4)]).then(()=>{this.nb()}),ke}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(U,x))).then(()=>{})}async qb(U,x){if(this.isActivated(x.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Fe={logService:this.s,folders:U.map(we=>we.uri),forceUsingSearch:ve||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,ge,Q)=>this.y.$checkExists(we,ge,Q)},ke=await(0,I.$Owb)(Fe,x);if(ke)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ke.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:x}=this.f.environment;if(!U||!x)throw new Error(C.localize(0,null));const ve=await this.xb(null,x,new b.$vmc(!1));if(!ve||typeof ve.run!="function")throw new Error(C.localize(1,null,x.toString()));return new Promise((Fe,ke)=>{const we=(Y,he)=>{Y?(z.$t&&this.s.error("Test runner called back with error",Y),ke(Y)):(z.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Fe(typeof he=="number"&&he>0?1:0))},ge=(0,N.$Zg)(x),Q=ve.run(ge,we);Q&&Q.then&&Q.then(()=>{z.$t&&this.s.info("Test runner finished successfully."),Fe(0)}).catch(Y=>{z.$t&&this.s.error("Test runner finished with error",Y),ke(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$zh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,x){return this.S[U]=x,(0,p.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:x}=await this.ub(U);return x?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const x=U.indexOf("+");if(x===-1)throw new t.$pM("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=U.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(U,x){const ve=M.$be.create(!1),Fe=()=>`[resolveAuthority(${(0,g.$Nl)(U)},${x})][${ve.elapsed()}ms] `,ke=L=>this.s.info(`${Fe()}${L}`),we=L=>this.s.warn(`${Fe()}${L}`),ge=(L,K=void 0)=>this.s.error(`${Fe()}${L}`,K),Q=L=>{if(L instanceof t.$pM)return{type:"error",error:{code:L._code,message:L._message,detail:L._detail}};throw L},Y=async L=>{ke(`activating resolver for ${L}...`);const{resolver:K,authorityPrefix:H}=await this.ub(L);if(!K)throw ge(`no resolver for ${H}`),new t.$pM(`No remote extension installed to resolve ${H}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:H,remoteAuthority:L}},he=U.split(/@|%40/g).reverse();ke(`activating remote resolvers ${he.join(" -> ")}`);let ce;try{ce=await Promise.all(he.map(Y)).catch(async L=>{if(!(L instanceof t.$pM)||L._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw L;return we(`resolving nested authorities failed: ${L.message}`),[await Y(U)]})}catch(L){return Q(L)}const Ne=new R.$Jh;Ne.cancelAndSet(()=>ke("waiting..."),1e3);let fe,Pe;for(const[L,{authorityPrefix:K,resolver:H,remoteAuthority:ee}]of ce.entries())try{if(L===ce.length-1)ke("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${K}`),fe=await H.resolve(ee,{resolveAttempt:x,execServer:Pe}),A.mark(`code/extHost/didResolveAuthorityOK/${K}`),ke("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$oM.isManagedResolvedAuthority(fe)?fe:void 0));else{if(ke(`invoking resolveExecServer() for ${ee}`),A.mark(`code/extHost/willResolveExecServer/${K}`),Pe=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Pe}),!Pe)throw new t.$pM(`Exec server was not available for ${ee}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(re){return A.mark(`code/extHost/didResolveAuthorityError/${K}`),ge("returned an error",re),Ne.dispose(),Q(re)}Ne.dispose();const Me={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};ke(`returned ${t.$oM.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let B;if(t.$oM.isManagedResolvedAuthority(fe)){const L=x;this.Y.setFactory(L,fe.makeConnection),B={authority:U,connectTo:new g.$Kl(L),connectionToken:fe.connectionToken}}else B={authority:U,connectTo:new g.$Ll(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:B,options:je,tunnelInformation:Me}}}async $getCanonicalURI(U,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,g.$Nl)(U)})`);const{resolver:ve}=await this.ub(U);if(!ve)return null;const Fe=E.URI.revive(x);if(typeof ve.getCanonicalURI>"u")return Fe;const ke=await(0,R.$qh)(()=>ve.getCanonicalURI(Fe));return ke||Fe}async $startExtensionHost(U){U.toAdd.forEach(we=>we.extensionLocation=E.URI.revive(we.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,U),Fe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$startExtensionHost: global extensions: ${me(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${me(this.J)}`)),this.tb()}$activateByEvent(U,x){return x===1?this.D.wait().then(ve=>this.ab(U,!1)):this.G.wait().then(ve=>this.ab(U,!1))}async $activate(U,x){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,x),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(we=>we.extensionLocation=E.URI.revive(we.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,U),Fe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$deltaExtensions: global extensions: ${me(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${me(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const x=c.$He.alloc(U),ve=Math.random()%256;for(let Fe=0;Fe<U;Fe++)x.writeUInt8(ve,Fe);return x}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$Smc=de,e.$Smc=de=ie=Je([We(0,a.$xi),We(1,e.$Rmc),We(2,$.$LO),We(3,s.$dmc),We(4,l.$gmc),We(5,T.$5j),We(6,d.$2O),We(7,w.$jmc),We(8,y.$RDb),We(9,h.$Emc),We(10,q.$Omc),We(11,G.$Pmc),We(12,D.$Imc)],de);function ye(ne,U,x,ve){ne.addActivationEvents(ve.addActivationEvents);const Fe=new o.$pac(ne,U.getAllExtensionDescriptions());Fe.deltaExtensions(ve.toAdd,ve.toRemove);const ke=new n.$Um(x.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of ve.myToRemove)ke.delete(ge);for(const ge of ve.myToAdd)ke.add(ge);const we=Ce(Fe,ke);return{globalRegistry:Fe,myExtensions:we}}function Ee(ne,U){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function me(ne){return ne.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$Tmc=(0,a.$yi)("IExtHostExtensionService");class ue{#e;#t;#i;constructor(U,x,ve,Fe,ke){this.#e=U,this.#t=x,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=O.$hc((0,N.$Zg)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Fe,this.isFromDifferentExtensionHost=ke}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Umc=ue;function Ce(ne,U){return ne.getAllExtensionDescriptions().filter(x=>U.has(x.identifier))}class se{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$Vmc=se;class Oe{constructor(U){this.a=new n.$Vm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const x of Object.keys(U))this.a.set(x,U[x])}}}),define(Se[304],Ie([1,0,60,2,4,40,25,21,17,27,3,41,12,13]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=void 0;let s=class{constructor(c,u,t,g,a,d,w){this.c=c,this.d=u,this.e=t,this.f=g,this.g=a,this.h=d,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new o(this.c,u,this.d,c,this.i)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,u,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const u of c.nodeModuleName)this.a.set(u,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(u=>c.alternativeModuleName(u))}};e.$5nc=s,e.$5nc=s=Je([We(2,T.$xi),We(3,N.$gmc),We(4,S.$Tmc),We(5,E.$2O),We(6,l.$5j)],s);let r=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&f.a.size){const u=(0,b.$bf)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",g=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${a}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const u=this.b.exec(this.c(c));if(!u)return;const[,t,g,a]=u,d=f.a.get(g);if(d!==void 0)return console.warn(`${g} as been renamed to ${d}, please update your imports`),t+d+a}c(c){return c.replace(/\\/g,"/")}};r=f=Je([We(0,E.$2O)],r);class o{constructor(c,u,t,g,a){this.c=c,this.d=u,this.e=t,this.f=g,this.g=a,this.nodeModuleName="vscode",this.a=new p.$Vm}load(c,u){const t=this.d.findSubstr(u);if(t){let g=this.a.get(t.identifier);return g||(g=this.c(t,this.e,this.f),this.a.set(t.identifier,g)),g}if(!this.b){let g="";this.d.forEach((a,d)=>g+=`	${d} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${g}`),this.b=this.c(R.$EG,this.e,this.f)}return this.b}}let i=class{constructor(c,u,t){this.e=c,this.f=u,this.nodeModuleName=["open","opn"],this.d=t.getProxy(A.$hM.MainThreadTelemetry);const g=t.getProxy(A.$hM.MainThreadWindow);this.c=(a,d)=>{const w=O.URI.parse(a);return d?this.g(a,d):w.scheme==="http"||w.scheme==="https"?g.$openUri(w,a,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?g.$openUri(w,a,{}):this.g(a,d)}}load(c,u,t){const g=this.e.findSubstr(u);return g&&(this.a=g.identifier.value,this.h()),this.b=t(c),this.c}g(c,u){return this.i(),this.b(c,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([We(2,m.$LO)],i)}),define(Se[122],Ie([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=e.$Wmc=void 0,e.$Wmc=(0,R.$yi)("IExtHostVariableResolverProvider");class f extends l.$PP{constructor(o,i,n,c,u,t,g){function a(){if(n){const d=n.activeEditor();if(d)return d.document.uri;const w=c.tabGroups.all.find($=>$.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof T.$8N||w.input instanceof T.$aO)return w.input.modified;if(w.input instanceof T.$7N||w.input instanceof T.$_N||w.input instanceof T.$0N)return w.input.uri}}}super({getFolderUri:d=>{const w=t.folders.filter($=>$.name===d);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(d,w)=>u.getConfiguration(void 0,d).get(w),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return A.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const d=a();if(d){const w=i.getWorkspaceFolder(d);if(w)return A.$hc(w.uri.fsPath)}}},getSelectedText:()=>{if(n){const d=n.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(n){const d=n.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>o.getExtension(d)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(N.env))}}let s=class extends O.$Uc{constructor(o,i,n,c,u){super(),this.b=o,this.c=i,this.g=n,this.h=c,this.j=u,this.a=new C.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$Xmc=s,e.$Xmc=s=Je([We(0,E.$Tmc),We(1,S.$dmc),We(2,p.$WO),We(3,b.$gmc),We(4,m.$smc)],s)}),define(Se[123],Ie([1,0,11,5,2,21,3,4,67,41,17,7,39,226,228,40,122,6,36,35,8,18]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=e.$2mc=e.$1mc=e.$Zmc=e.$Ymc=void 0,e.$Ymc=(0,R.$yi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(y,h,D,k,I,P,V){this.N=h,this.O=D,this.P=k,this.Q=I,this.R=P,this.S=V,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$fe,this.o=new O.$fe,this.q=new O.$fe,this.w=new O.$fe,this.l=y.getProxy(p.$hM.MainThreadDebugService),this.A=new O.$fe,this.C=new O.$fe,this.y=new a(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(q=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(y,h){const D=this.W(h);if(!D)return;const k=await this.H.get(y)?.getTreeItem?.(D);return k?this.U(y,k):void 0}registerDebugVisualizationTree(y,h,D){const k=N.$Tm.toKey(y.identifier),I=this.jb(k,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.H.set(I,D),this.l.$registerDebugVisualizerTree(I,!!D.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(I),this.H.delete(h)})}async $getVisualizerTreeItemChildren(y,h){const D=this.J.get(h)?.item;return D?(await this.H.get(y)?.getChildren?.(D))?.map(I=>this.U(y,I))||[]:[]}async $editVisualizerTreeItem(y,h){const D=this.J.get(y);if(!D)return;const k=await this.H.get(D.provider)?.editItem?.(D.item,h);return this.U(D.provider,k||D.item)}$disposeVisualizedTree(y){const h=this.J.get(y);if(!h)return;const D=[h.children];for(const k of D)if(k)for(const I of k)D.push(this.J.get(I)?.children),this.J.delete(I)}U(y,h){let D=this.I.get(h);return D||(D=this.F++,this.I.set(h,D),this.J.set(D,{provider:y,item:h})),c.DebugTreeItem.from(h,D)}asDebugSourceUri(y,h){const D=y;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let k=`debug:${encodeURIComponent(D.path||"")}`,I="?";return h&&(k+=`${I}session=${encodeURIComponent(h.id)}`,I="&"),k+=`${I}ref=${D.sourceReference}`,A.URI.parse(k)}else{if(D.path)return A.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(y){const h=[];for(const D of y.getAllExtensionDescriptions())if(D.contributes){const k=D.contributes.debuggers;if(k&&k.length>0)for(const I of k)(0,f.$xH)(I)&&h.push(I.type)}this.l.$registerDebugTypes(h)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const y=[];return this.z.forEach(h=>y.push(h)),y}async $resolveDebugVisualizer(y,h){const D=this.L.get(y);if(!D)throw new Error(`No debug visualizer found with id '${y}'`);let{v:k,provider:I,extensionId:P}=D;if(k.visualization||(k=await I.resolveDebugVisualization?.(k,h)||k,D.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${I}'`);return this.kb(P,k.visualization)}async $executeDebugVisualizerCommand(y){const h=this.L.get(y);if(!h)throw new Error(`No debug visualizer found with id '${y}'`);const D=h.v.visualization;D&&"command"in D&&this.S.executeCommand(D.command,...D.arguments||[])}W(y){const h=this.m.get(y.sessionId);return h&&{session:h.api,variable:y.variable,containerId:y.containerId,frameId:y.frameId,threadId:y.threadId}}async $provideDebugVisualizers(y,h,D,k){const I=this.W(D),P=this.jb(y,h),V=this.G.get(P);if(!I||!V)return[];const W=await V.provideDebugVisualization(I,k);return W?W.map(q=>{const M=++this.M;this.L.set(M,{v:q,provider:V,extensionId:y});const z=q.iconPath?this.lb(q.iconPath):void 0;return{id:M,name:q.name,iconClass:z?.iconClass,iconPath:z?.iconPath,visualization:this.kb(y,q.visualization)}}):[]}$disposeDebugVisualizers(y){for(const h of y)this.L.delete(h)}registerDebugVisualizationProvider(y,h,D){if(!y.contributes?.debugVisualizers?.some(P=>P.id===h))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${h})`);const k=N.$Tm.toKey(y.identifier),I=this.jb(k,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.G.set(I,D),this.l.$registerDebugVisualizer(k,h),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,h),this.G.delete(h)})}addBreakpoints(y){const h=y.filter(I=>{const P=I.id;return this.z.has(P)?!1:(this.z.set(P,I),!0)});this.gb(h,[],[]);const D=[],k=new Map;for(const I of h)if(I instanceof S.$lN){let P=k.get(I.location.uri.toString());P||(P={type:"sourceMulti",uri:I.location.uri,lines:[]},k.set(I.location.uri.toString(),P),D.push(P)),P.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character,mode:I.mode})}else I instanceof S.$mN&&D.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName,mode:I.mode});return this.l.$registerBreakpoints(D)}removeBreakpoints(y){const h=y.filter(P=>this.z.delete(P.id));this.gb([],h,[]);const D=h.filter(P=>P instanceof S.$lN).map(P=>P.id),k=h.filter(P=>P instanceof S.$mN).map(P=>P.id),I=h.filter(P=>P instanceof S.$nN).map(P=>P.id);return this.l.$unregisterBreakpoints(D,k,I)}startDebugging(y,h,D){return this.l.$startDebugging(y?y.uri:void 0,h,{parentSessionID:D.parentSession?D.parentSession.id:void 0,lifecycleManagedByParent:D.lifecycleManagedByParent,repl:D.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact,suppressSaveBeforeStart:D.suppressSaveBeforeStart,suppressDebugStatusbar:D.suppressDebugStatusbar??D.debugUI?.simple,suppressDebugToolbar:D.suppressDebugToolbar??D.debugUI?.simple,suppressDebugView:D.suppressDebugView??D.debugUI?.simple})}stopDebugging(y){return this.l.$stopDebugging(y?y.id:void 0)}registerDebugConfigurationProvider(y,h,D){if(!h)return new S.$jM(()=>{});const k=this.d++;return this.f.push({type:y,handle:k,provider:h}),this.l.$registerDebugConfigurationProvider(y,D,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,k),new S.$jM(()=>{this.f=this.f.filter(I=>I.provider!==h),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(y,h,D){if(!D)return new S.$jM(()=>{});if(!this.cb(y,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.$(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:h,handle:k,factory:D}),this.l.$registerDebugAdapterDescriptorFactory(h,k),new S.$jM(()=>{this.h=this.h.filter(I=>I.factory!==D),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(y,h){if(!h)return new S.$jM(()=>{});const D=this.j++;return this.k.push({type:y,handle:D,factory:h}),new S.$jM(()=>{this.k=this.k.filter(k=>k.factory!==h)})}async $runInTerminal(y,h){return Promise.resolve(void 0)}async $substituteVariables(y,h){let D;const k=await this.ib(y);return k&&(D={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(D,h)}X(y,h){if(y.type==="implementation")return new w(y.implementation)}Y(){}async $startDASession(y,h){const D=this,k=await this.hb(h);return this.eb(this.$(k.type),k).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const P=this.Z(I),V=this.X(P,k);if(!V)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const W=V;return this.D.set(y,W),this.db(k).then(q=>(q&&this.E.set(y,q),W.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const z=M,G={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const ie=await this.K.sign(z.arguments.value);G.body={signature:ie},W.sendResponse(G)}else throw new Error("no signer")}catch(ie){G.success=!1,G.message=ie.message,W.sendResponse(G)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(M),M=(0,f.$CH)(M,!0),D.l.$acceptDAMessage(y,M)}),W.onError(M=>{q&&q.onError&&q.onError(M),this.l.$acceptDAError(y,M.name,M.message,M.stack)}),W.onExit(M=>{q&&q.onExit&&q.onExit(M??void 0,void 0),this.l.$acceptDAExit(y,M??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),W.startSession()))})}$sendDAMessage(y,h){h=(0,f.$BH)(h,!1);const D=this.E.get(y);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(h),this.D.get(y)?.sendMessage(h)}$stopDASession(y){const h=this.E.get(y);this.E.delete(y),h&&h.onWillStopSession&&h.onWillStopSession();const D=this.D.get(y);return this.D.delete(y),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(y){const h=[],D=[],k=[];if(y.added)for(const I of y.added){const P=I.id;if(P&&!this.z.has(P)){let V;if(I.type==="function")V=new S.$mN(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode);else if(I.type==="data")V=new S.$nN(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage,I.mode);else{const W=A.URI.revive(I.uri);V=new S.$lN(new S.$vM(W,new S.$kM(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode)}(0,S.$jN)(V,P),this.z.set(P,V),h.push(V)}}if(y.removed)for(const I of y.removed){const P=this.z.get(I);P&&(this.z.delete(I),D.push(P))}if(y.changed){for(const I of y.changed)if(I.id){const P=this.z.get(I.id);if(P){if(P instanceof S.$mN&&I.type==="function"){const V=P;V.enabled=I.enabled,V.condition=I.condition,V.hitCondition=I.hitCondition,V.logMessage=I.logMessage,V.functionName=I.functionName}else if(P instanceof S.$lN&&I.type==="source"){const V=P;V.enabled=I.enabled,V.condition=I.condition,V.hitCondition=I.hitCondition,V.logMessage=I.logMessage,V.location=new S.$vM(A.URI.revive(I.uri),new S.$kM(I.line,I.character))}k.push(P)}}}this.gb(h,D,k)}async $acceptStackFrameFocus(y){let h;if(y){const D=await this.hb(y.sessionId);y.kind==="thread"?h=new S.$tN(D.api,y.threadId):h=new S.$sN(D.api,y.threadId,y.frameId)}this.B=h,this.C.fire(this.B)}$provideDebugConfigurations(y,h,D){return(0,C.$qh)(async()=>{const k=this.bb(y);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.ib(h);return k.provideDebugConfigurations(I,D)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(y,h,D,k){return(0,C.$qh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(h);return I.resolveDebugConfiguration(P,D,k)})}$resolveDebugConfigurationWithSubstitutedVariables(y,h,D,k){return(0,C.$qh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(h);return I.resolveDebugConfigurationWithSubstitutedVariables(P,D,k)})}async $provideDebugAdapter(y,h){const D=this.ab(y);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(h);return this.eb(D,k).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(I)})}async $acceptDebugSessionStarted(y){const h=await this.hb(y);this.n.fire(h.api)}async $acceptDebugSessionTerminated(y){const h=await this.hb(y);h&&(this.o.fire(h.api),this.m.delete(h.id))}async $acceptDebugSessionActiveChanged(y){this.u=y?await this.hb(y):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(y,h){(await this.hb(y))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(y,h){const k={session:(await this.hb(y)).api,event:h.event,body:h.body};this.w.fire(k)}Z(y){if(y instanceof S.$oN)return{type:"executable",command:y.command,args:y.args,options:y.options};if(y instanceof S.$pN)return{type:"server",port:y.port,host:y.host};if(y instanceof S.$qN)return{type:"pipeServer",path:y.path};if(y instanceof S.$rN)return{type:"implementation",implementation:y.implementation};throw new Error("convertToDto unexpected type")}$(y){const h=this.h.filter(D=>D.type===y);if(h.length>0)return h[0].factory}ab(y){const h=this.h.filter(D=>D.handle===y);if(h.length>0)return h[0].factory}bb(y){const h=this.f.filter(D=>D.handle===y);if(h.length>0)return h[0].provider}cb(y,h){if(y.contributes){const D=y.contributes.debuggers;if(D&&D.length>0){for(const k of D)if(k.label&&k.type&&k.type===h)return!0}}return!1}db(y){const D=y.configuration.type,k=this.k.filter(I=>I.type===D||I.type==="*").map(I=>(0,C.$qh)(()=>I.factory.createDebugAdapterTracker(y.api)).then(P=>P,P=>null));return Promise.race([Promise.all(k).then(I=>{const P=(0,u.$Hb)(I);if(P.length>0)return new d(P)}),new Promise(I=>setTimeout(()=>I(void 0),1e3))]).catch(I=>{})}async eb(y,h){const D=h.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new S.$pN(D));if(y){const I=await this.O.getExtensionRegistry();return(0,C.$qh)(()=>y.createDebugAdapterDescriptor(h.api,this.fb(h,I))).then(P=>{if(P)return P})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(h,k))}fb(y,h){}gb(y,h,D){(y.length>0||h.length>0||D.length>0)&&this.A.fire(Object.freeze({added:y,removed:h,changed:D}))}async hb(y){if(y)if(typeof y=="string"){const h=this.m.get(y);if(h)return h}else{let h=this.m.get(y.id);if(!h){const D=await this.ib(y.folderUri),k=y.parent?this.m.get(y.parent):void 0;h=new g(this.l,y.id,y.type,y.name,D,y.configuration,k?.api),this.m.set(h.id,h),this.l.$sessionCached(h.id)}return h}throw new Error("cannot find session")}ib(y){if(y){const h=A.URI.revive(y);return this.N.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}jb(y,h){return`${y}\0${h}`}kb(y,h){if(h){if("title"in h&&"command"in h)return{type:0};if("treeId"in h)return{type:1,id:`${y}\0${h.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(y){const h=this.mb(y);let D,k;return"id"in h?k=i.ThemeIcon.asClassName(h):D=h,{iconPath:D,iconClass:k}}mb(y){if(y instanceof S.$gN)return{id:y.id};const h=typeof y=="object"&&"dark"in y?y.dark:y,D=typeof y=="object"&&"light"in y?y.light:y;return{dark:typeof h=="string"?A.URI.file(h):h,light:typeof D=="string"?A.URI.file(D):D}}};e.$Zmc=t,e.$Zmc=t=Je([We(0,T.$LO),We(1,l.$dmc),We(2,E.$Tmc),We(3,s.$gmc),We(4,m.$smc),We(5,r.$Wmc),We(6,n.$8O)],t);class g{constructor(y,h,D,k,I,P,V){this.f=y,this.g=h,this.h=D,this.j=k,this.k=I,this.l=P,this.m=V}get api(){const y=this;return this.d??=Object.freeze({id:y.g,type:y.h,get name(){return y.j},set name(h){y.j=h,y.f.$setDebugSessionName(y.g,h)},parentSession:y.m,workspaceFolder:y.k,configuration:y.l,customRequest(h,D){return y.f.$customDebugAdapterRequest(y.g,h,D)},getDebugProtocolBreakpoint(h){return y.f.$getDebugProtocolBreakpoint(y.g,h.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(y){this.j=y}get configuration(){return this.l}}e.$1mc=g;class a{constructor(y){this.value=Object.freeze({append(h){y.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$2mc=a;class d{constructor(y){this.d=y}onWillStartSession(){this.d.forEach(y=>y.onWillStartSession?y.onWillStartSession():void 0)}onWillReceiveMessage(y){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(y):void 0)}onDidSendMessage(y){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(y):void 0)}onWillStopSession(){this.d.forEach(y=>y.onWillStopSession?y.onWillStopSession():void 0)}onError(y){this.d.forEach(h=>h.onError?h.onError(y):void 0)}onExit(y,h){this.d.forEach(D=>D.onExit?D.onExit(y,h):void 0)}}class w extends b.$isb{constructor(y){super(),this.h=y,y.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(y){this.h.handleMessage(y)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let $=class extends t{constructor(y,h,D,k,I,P,V){super(y,h,D,k,I,P,V)}};e.$3mc=$,e.$3mc=$=Je([We(0,T.$LO),We(1,l.$dmc),We(2,E.$Tmc),We(3,s.$gmc),We(4,m.$smc),We(5,r.$Wmc),We(6,n.$8O)],$)}),define(Se[305],Ie([1,0,14,60,2,4,255,12,56,72,27,199,17,61,41,63]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=e.$6nc=void 0;class r{static async installEarlyHandler(n){Error.stackTraceLimit=100;const c=n.get(p.$5j),t=n.get(l.$LO).getProxy(N.$hM.MainThreadErrors);C.setUnexpectedErrorHandler(g=>{c.error(g);const a=C.$3(g);t.$onUnexpectedError(a)})}static async installFullHandler(n){const c=n.get(p.$5j),u=n.get(l.$LO),t=n.get(f.$Tmc),g=n.get(s.$6O),a=u.getProxy(N.$hM.MainThreadExtensionService),d=u.getProxy(N.$hM.MainThreadErrors),w=await t.getExtensionPathIndex(),$=new WeakMap;function v(D,k){if($.has(D))return $.get(D).stack;let I="",P,V;for(const q of k)I+=`
	at ${q.toString()}`,V=q.getFileName(),!P&&V&&(P=w.findSubstr(A.URI.file(V)));const W=`${D.name||"Error"}: ${D.message||""}${I}`;return $.set(D,{extensionIdentifier:P?.identifier,stack:W}),W}const y=Symbol("prepareStackTrace wrapped");let h=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(D){if(D===v||!D||D[y]){h=D||v;return}h=function(k,I){return v(k,I),D.call(Error,k,I)},Object.assign(h,{[y]:!0})}}),C.setUnexpectedErrorHandler(D=>{c.error(D);const k=C.$3(D),I=$.get(D);if(!I?.extensionIdentifier){d.$onUnexpectedError(k);return}a.$onExtensionRuntimeError(I.extensionIdentifier,k);const P=g.onExtensionError(I.extensionIdentifier,D);c.trace("forwarded error to extension?",P,I)})}}e.$6nc=r;class o{constructor(n,c,u,t,g){this.a=u,this.b=new R.$xac(n,null,t),c=o.e(c,this.b);const a=new E.$wi(...(0,m.$Bs)());a.set(T.$2O,{_serviceBrand:void 0,...c,messagePorts:g}),a.set(l.$LO,new l.$MO(this.b)),a.set(b.$amc,new b.$bmc(t)),a.set(f.$Rmc,u);const d=new S.$fr(a,!0);d.invokeFunction(r.installEarlyHandler),this.d=d.invokeFunction(w=>w.get(p.$5j)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(w=>w.get(f.$Tmc)),this.c.initialize(),d.invokeFunction(r.installFullHandler)}async asBrowserUri(n){const c=this.b.getProxy(N.$hM.MainThreadExtensionService);return A.URI.revive(await c.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,c){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=A.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=A.URI.revive(c.transformIncomingURIs(n.environment.appRoot));const u=n.environment.extensionDevelopmentLocationURI;return u&&(n.environment.extensionDevelopmentLocationURI=u.map(t=>A.URI.revive(c.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=A.URI.revive(c.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=A.URI.revive(c.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=A.URI.revive(c.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=A.URI.revive(c.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=A.URI.revive(c.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=A.URI.revive(c.transformIncomingURIs(n.logsLocation)),n.workspace=c.transformIncomingURIs(n.workspace),n}}e.$7nc=o}),define(Se[306],Ie([1,0,18,11,20,44,16,19,24,2,47]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=e.$fnc=e.$enc=void 0,e.$gnc=s;class S{constructor(i,n,c){this.d=i,this.e=n,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const c=this.g.folderQueries||[],u=new A.$qe(n);return new Promise((t,g)=>{this.a=new b(i);let a=!1;const d=(w,$)=>{if(!a&&!this.b){const v=this.h(w);s(w)&&typeof this.g.maxResults=="number"&&this.c+v>this.g.maxResults&&(this.b=!0,a=!0,u.cancel(),w=this.j(w,this.g.maxResults-this.c));const y=this.h(w);this.c+=y,(y>0||!s(w))&&this.a.add(w,$)}};Promise.all(c.map((w,$)=>this.k(w,v=>d(v,$),u.token))).then(w=>{u.dispose(),this.a.flush();const $=w.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||$,messages:w.flatMap(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[]),stats:{type:this.f}})},w=>{u.dispose();const $=(0,N.$jj)(w);g(new Error($))})})}h(i){return s(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const c=Array.isArray(i.ranges)?i.ranges:[i.ranges],u=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:c.slice(0,n),preview:{matches:u.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,c){const u=new T.$NK(this.g,i),t=[],g={report:w=>{if(!this.l(w))return;const $=i.folder.scheme===R.Schemas.file?(0,T.$OK)(()=>this.e.readdir(m.$$g(w.uri))):void 0,v=m.$bh(i.folder,w.uri);if(v){const y=u.includedInQuery(v,p.$nc(v),$);(0,O.$kh)(y)?t.push(y.then(h=>{h&&n(w)})):y&&n(w)}}},a=this.n(i);let d;return this.d.query.type===3?d=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,g,c):d=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),a,g,c),t.length&&await Promise.all(t),d}l(i){if(s(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,T.$MK)(this.g.includePattern,i.includePattern),c=(0,T.$MK)(this.g.excludePattern,i.excludePattern),u={folder:E.URI.from(i.folder),excludes:c,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(u.usePCRE2=this.g.usePCRE2),u}}e.$enc=S;function l(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class b{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new r(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!m.$5g(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(f(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$fnc=b;function f(o){return s(o)?{preview:{matches:(0,C.$1b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,C.$1b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function s(o){return!!o.preview}class r{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$hnc=r}),define(Se[124],Ie([1,0,6,4,3,301,17,61,12,2,306]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=e.$inc=void 0,e.$knc=l,e.$inc=(0,A.$yi)("IExtHostSearch");let S=class{constructor(s,r,o){this.n=s,this.o=r,this.q=o,this.c=this.n.getProxy(O.$hM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$dnc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,r){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const o=this.d++;return this.e.set(o,r),this.c.$registerTextSearchProvider(o,this.s(s)),(0,C.$Sc)(()=>{this.g.delete(s),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(s,r){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const o=this.d++;return this.h.set(o,r),this.c.$registerAITextSearchProvider(o,this.s(s)),(0,C.$Sc)(()=>{this.i.delete(s),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(s,r){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const o=this.d++;return this.j.set(o,r),this.c.$registerFileSearchProvider(o,this.s(s)),(0,C.$Sc)(()=>{this.k.delete(s),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(s,r,o,i){const n=l(o),c=this.j.get(s);if(c)return this.l.fileSearch(n,c,u=>{this.c.$handleFileMatch(s,r,u.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,r,o){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,r,o,i){const n=this.e.get(s);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const c=l(o);return this.t(c,n).search(t=>this.c.$handleTextMatch(s,r,t),i)}$provideAITextSearchResults(s,r,o,i){const n=this.h.get(s);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const c=l(o);return this.v(c,n).search(t=>this.c.$handleTextMatch(s,r,t),i)}$enableExtensionHostSearch(){}t(s,r){return new T.$enc({query:s,provider:r},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(s,r){return new T.$enc({query:s,provider:r},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$jnc=S,e.$jnc=S=Je([We(0,R.$LO),We(1,p.$amc),We(2,m.$5j)],S);function l(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(s=>E.URI.revive(s))}}function b(f){return{...f,folder:E.URI.revive(f.folder)}}}),define(Se[307],Ie([1,0,20,14,5,6,16,32,2,158,154,141,95,21,38,12,58,59,213,4,258,286,80,86,263,264,265,243,232,35,266,40,267,123,112,268,245,259,269,270,68,67,246,260,41,272,65,273,46,27,287,247,274,90,275,81,82,249,300,277,219,278,288,279,118,250,280,281,282,17,283,124,83,284,251,285,84,87,121,63,53,116,289,290,261,291,292,88,8,7,252,61,253,64,293,294,111,39,227,79,25,120]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c,u,t,g,a,d,w,$,v,y,h,D,k,I,P,V,W,q,M,z,G,ie,de,ye,Ee,me,ue,Ce,se,Oe,ne,U,x,ve,Fe,ke,we,ge,Q,Y,he,ce,Ne,fe,Pe,Me,je,B,L,K,H,ee,re,Te,Be,He,_e,xe,et,tt,it,at,gt,Ue,rt,Z,X,$e,Ke,be,st,dt,Ct,Vt,Qt,ii,Xt,Et,Zt,Yt,Ze,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=Ht;function Ht(ht){const mt=ht.get(Oe.$2O),xt=ht.get(se.$Xlc),Gt=ht.get(ue.$imc),Nt=ht.get(Ee.$Tmc),ft=ht.get(Et.$dmc),Bt=ht.get(tt.$6O),_t=ht.get(D.$gmc),zt=ht.get(dt.$amc),Qe=ht.get(K.$LO),ui=ht.get(_e.$Bmc),Jt=ht.get(xe.$jmc),Ut=ht.get(s.$6j),wt=ht.get(s.$5j),jt=ht.get($e.$RDb),At=ht.get(t.$Tlc),Rt=ht.get(Xt.$Znc),ei=ht.get(re.$Lmc),Wt=ht.get(ie.$smc),oi=ht.get(we.$Pmc),Ot=ht.get(g.$4lc),qt=ht.get(ve.$Imc);Qe.set(n.$iM.ExtHostFileSystemInfo,xt),Qe.set(n.$iM.ExtHostLogLevelServiceShape,Ut),Qe.set(n.$iM.ExtHostWorkspace,ft),Qe.set(n.$iM.ExtHostConfiguration,_t),Qe.set(n.$iM.ExtHostExtensionService,Nt),Qe.set(n.$iM.ExtHostStorage,ui),Qe.set(n.$iM.ExtHostTunnelService,jt),Qe.set(n.$iM.ExtHostWindow,Rt),Qe.set(n.$iM.ExtHostSecretState,ei),Qe.set(n.$iM.ExtHostTelemetry,Bt),Qe.set(n.$iM.ExtHostEditorTabs,Wt),Qe.set(n.$iM.ExtHostManagedSockets,oi),Qe.set(n.$iM.ExtHostAuthentication,Ot),Qe.set(n.$iM.ExtHostChatProvider,qt);const Mt=Qe.set(n.$iM.ExtHostDecorations,ht.get(P.$5mc)),St=Qe.set(n.$iM.ExtHostDocumentsAndEditors,ht.get(G.$WO)),$t=Qe.set(n.$iM.ExtHostCommands,ht.get(y.$8O)),Dt=Qe.set(n.$iM.ExtHostTerminalService,ht.get(it.$Emc)),ai=Qe.set(n.$iM.ExtHostTerminalShellIntegration,ht.get(at.$Lnc)),kt=Qe.set(n.$iM.ExtHostDebugService,ht.get(I.$Ymc)),fi=Qe.set(n.$iM.ExtHostSearch,ht.get(ee.$inc)),ni=Qe.set(n.$iM.ExtHostTask,ht.get(et.$Knc)),$i=Qe.set(n.$iM.ExtHostOutputService,ht.get(Pe.$xnc)),li=Qe.set(n.$iM.ExtHostLocalization,ht.get(ke.$Omc)),bi=Qe.set(n.$iM.ExtHostUrls,new Ct.$Wnc(Qe)),It=Qe.set(n.$iM.ExtHostDocuments,new z.$1lc(Qe,St)),Ei=Qe.set(n.$iM.ExtHostDocumentContentProviders,new q.$7mc(Qe,St,wt)),ri=Qe.set(n.$iM.ExtHostDocumentSaveParticipant,new M.$8mc(wt,It,Qe.getProxy(n.$hM.MainThreadBulkEdits))),pe=Qe.set(n.$iM.ExtHostNotebook,new Q.$lnc(Qe,$t,St,It,Gt,fi)),Re=Qe.set(n.$iM.ExtHostNotebookDocuments,new he.$rnc(pe)),ae=Qe.set(n.$iM.ExtHostNotebookEditors,new ce.$snc(wt,pe)),J=Qe.set(n.$iM.ExtHostNotebookKernels,new Ne.$tnc(Qe,mt,pe,$t,wt)),Ae=Qe.set(n.$iM.ExtHostNotebookRenderers,new fe.$vnc(Qe,pe)),Ve=Qe.set(n.$iM.ExtHostNotebookDocumentSaveParticipant,new Y.$qnc(wt,pe,Qe.getProxy(n.$hM.MainThreadBulkEdits))),Xe=Qe.set(n.$iM.ExtHostEditors,new Ue.$0lc(Qe,St)),qe=Qe.set(n.$iM.ExtHostTreeViews,new X.$Unc(Qe.getProxy(n.$hM.MainThreadTreeViews),$t,wt)),ut=Qe.set(n.$iM.ExtHostEditorInsets,new v.$$lc(Qe.getProxy(n.$hM.MainThreadEditorInsets),Xe,mt.remote)),yt=Qe.set(n.$iM.ExtHostDiagnostics,new V.$Zlc(Qe,wt,xt,St)),Ft=Qe.set(n.$iM.ExtHostLanguages,new Fe.$onc(Qe,It,$t.converter,zt)),ct=Qe.set(n.$iM.ExtHostLanguageFeatures,new x.$2lc(Qe,zt,It,$t,yt,wt,At,Bt)),Tt=Qe.set(n.$iM.ExtHostFileSystem,new me.$$mc(Qe,ct)),Lt=Qe.set(n.$iM.ExtHostFileSystemEventService,new Ce.$_mc(Qe,wt,St)),Di=Qe.set(n.$iM.ExtHostQuickOpen,(0,L.$Bnc)(Qe,ft,$t)),Ii=Qe.set(n.$iM.ExtHostSCM,new H.$Dnc(Qe,$t,It,wt)),Ji=Qe.set(n.$iM.ExtHostQuickDiff,new B.$Anc(Qe,zt)),Oi=Qe.set(n.$iM.ExtHostShare,new Te.$Enc(Qe,zt)),Ti=Qe.set(n.$iM.ExtHostComments,(0,h.$_lc)(Qe,$t,It)),Ci=Qe.set(n.$iM.ExtHostProgress,new je.$znc(Qe.getProxy(n.$hM.MainThreadProgress))),Ni=Qe.set(n.$iM.ExtHostLabelService,new U.$nnc(Qe)),Fi=Qe.set(n.$iM.ExtHostTheming,new rt.$Rnc(Qe)),Qi=Qe.set(n.$iM.ExtHostTimeline,new Z.$Tnc(Qe,$t)),Li=Qe.set(n.$iM.ExtHostWebviews,new Vt.$nmc(Qe,mt.remote,ft,wt,At)),Pi=Qe.set(n.$iM.ExtHostWebviewPanels,new Qt.$qmc(Qe,Li,ft)),zi=Qe.set(n.$iM.ExtHostCustomEditors,new k.$rmc(Qe,It,Jt,Li,Pi)),Ui=Qe.set(n.$iM.ExtHostWebviewViews,new ii.$Xnc(Qe,Li)),vi=Qe.set(n.$iM.ExtHostTesting,new gt.$Nnc(Qe,wt,$t,St)),Xi=Qe.set(n.$iM.ExtHostUriOpeners,new st.$Vnc(Qe)),Zi=Qe.set(n.$iM.ExtHostProfileContentHandlers,new Me.$ync(Qe));Qe.set(n.$iM.ExtHostInteractive,new ne.$mnc(Qe,pe,St,$t,wt));const Ai=Qe.set(n.$iM.ExtHostChatAgents2,new d.$7lc(Qe,wt,$t)),Yi=Qe.set(n.$iM.ExtHostChatVariables,new w.$8lc(Qe)),ji=Qe.set(n.$iM.ExtHostAiRelatedInformation,new c.$Slc(Qe)),dn=Qe.set(n.$iM.ExtHostAiEmbeddingVector,new ye.$0mc(Qe)),xi=Qe.set(n.$iM.ExtHostStatusBar,new He.$Hnc(Qe,$t.converter)),Bi=Qe.set(n.$iM.ExtHostSpeech,new Be.$Fnc(Qe)),pi=Qe.set(n.$iM.ExtHostEmbeddings,new de.$9mc(Qe)),fn=Object.values(n.$iM);Qe.assertRegistered(fn);const gn=new a.$6lc(Qe,St),_i=new $.$9lc(Qe),Vi=new ge.$pnc(Qe,wt),Mi=new W.$6mc(Qe);return u.$3lc.register($t),function(ze,hi,Wi){function nt(_){return(oe,Le,ot)=>{const vt=_(Pt=>{try{oe.call(Le,Pt)}catch(Si){O.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Bt.onExtensionError(ze.identifier,Si)}});return ot?.push(vt),vt}}const bt=function(){let _=!ze.isUnderDevelopment;function oe(){_||(wt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(ot){if(Array.isArray(ot))ot.forEach(Le);else if(typeof ot=="string")oe();else{const vt=ot;typeof vt.scheme>"u"&&oe(),typeof vt.exclusive=="boolean"&&(0,Ze.$KG)(ze,"documentFiltersExclusive")}return ot}}(),en={getSession(_,oe,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ze.$KG)(ze,"authLearnMore"),Ot.getSession(ze,_,oe,Le)},getSessions(_,oe){return(0,Ze.$KG)(ze,"authGetSessions"),Ot.getSessions(ze,_,oe)},async hasSession(_,oe){return(0,Ze.$KG)(ze,"authSession"),!!await Ot.getSession(ze,_,oe,{silent:!0})},get onDidChangeSessions(){return nt(Ot.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Le,ot){return Ot.registerAuthenticationProvider(_,oe,Le,ot)}},gi={registerCommand(_,oe,Le){return $t.registerCommand(!0,_,oe,Le,void 0,ze)},registerTextEditorCommand(_,oe,Le){return $t.registerCommand(!0,_,(...ot)=>{const vt=Xe.getActiveTextEditor();if(!vt){wt.warn("Cannot execute "+_+" because there is no active text editor.");return}return vt.edit(Pt=>{oe.apply(Le,[vt,Pt,...ot])}).then(Pt=>{Pt||wt.warn("Edits from command "+_+" were not applied.")},Pt=>{wt.warn("An error occurred while running command "+_,Pt)})},void 0,void 0,ze)},registerDiffInformationCommand:(_,oe,Le)=>((0,Ze.$KG)(ze,"diffCommand"),$t.registerCommand(!0,_,async(...ot)=>{const vt=St.activeEditor(!0);if(!vt){wt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Pt=await Xe.getDiffInformation(vt.id);oe.apply(Le,[Pt,...ot])},void 0,void 0,ze)),executeCommand(_,...oe){return $t.executeCommand(_,...oe)},getCommands(_=!1){return $t.getCommands(_)}},ki={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return _i.value},get shell(){return Dt.getDefaultShell(!1)},get onDidChangeShell(){return nt(Dt.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$KG)(ze,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$KG)(ze,"telemetry"),nt(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$5O)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return tt.$4O.validateSender(_),Bt.instantiateLogger(ze,_,oe)},openExternal(_,oe){return Rt.openUri(_,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===mt.environment.appUriScheme)return bi.createAppUri(_);try{return await Rt.asExternalUri(_,{allowTunneling:!!mt.remote.authority})}catch(oe){if((0,R.$Hg)(_,R.Schemas.http)||(0,R.$Hg)(_,R.Schemas.https))return _;throw oe}},get remoteName(){return(0,r.$Km)(mt.remote.authority)},get remoteAuthority(){return(0,Ze.$KG)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return nt(wt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$KG)(ze,"resolvers"),mt.quality},get appCommit(){return(0,Ze.$KG)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(ki);const mn={createTestController(_,oe,Le){return vi.createTestController(ze,_,oe,Le)},createTestObserver(){return(0,Ze.$KG)(ze,"testObserver"),vi.createTestObserver()},runTests(_){return(0,Ze.$KG)(ze,"testObserver"),vi.runTests(_)},get onDidChangeTestResults(){return(0,Ze.$KG)(ze,"testObserver"),nt(vi.onResultsChanged)},get testResults(){return(0,Ze.$KG)(ze,"testObserver"),vi.results}},ti=mt.remote.isRemote?be.ExtensionKind.Workspace:be.ExtensionKind.UI,Ri={getExtension(_,oe){(0,Ze.$JG)(ze,"extensionsAny")||(oe=!1);const Le=hi.mine.getExtensionDescription(_);if(Le)return new Ee.$Umc(Nt,ze.identifier,Le,ti,!1);if(oe){const ot=hi.all.getExtensionDescription(_);if(ot)return new Ee.$Umc(Nt,ze.identifier,ot,ti,!0)}},get all(){const _=[];for(const oe of hi.mine.getAllExtensionDescriptions())_.push(new Ee.$Umc(Nt,ze.identifier,oe,ti,!1));return _},get allAcrossExtensionHosts(){(0,Ze.$KG)(ze,"extensionsAny");const _=new b.$Um(hi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),oe=[];for(const Le of hi.all.getAllExtensionDescriptions()){const ot=!_.has(Le.identifier);oe.push(new Ee.$Umc(Nt,ze.identifier,Le,ti,ot))}return oe},get onDidChange(){return(0,Ze.$JG)(ze,"extensionsAny")?nt(A.Event.any(hi.mine.onDidChange,hi.all.onDidChange)):nt(hi.mine.onDidChange)}},tn={createDiagnosticCollection(_){return yt.createDiagnosticCollection(ze.identifier,_)},get onDidChangeDiagnostics(){return nt(yt.onDidChangeDiagnostics)},getDiagnostics:_=>yt.getDiagnostics(_),getLanguages(){return Ft.getLanguages()},setTextDocumentLanguage(_,oe){return Ft.changeLanguage(_.uri,oe)},match(_,oe){const Le=Ke.LanguageSelector.from(_);let ot;return(0,T.$2t)(Le)&&(ot=pe.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Pt=>Pt.document===oe))?.apiNotebook),(0,T.$1t)(Le,oe.uri,oe.languageId,!0,ot?.uri,ot?.notebookType)},registerCodeActionsProvider(_,oe,Le){return ct.registerCodeActionProvider(ze,bt(_),oe,Le)},registerDocumentPasteEditProvider(_,oe,Le){return(0,Ze.$KG)(ze,"documentPaste"),ct.registerDocumentPasteEditProvider(ze,bt(_),oe,Le)},registerCodeLensProvider(_,oe){return ct.registerCodeLensProvider(ze,bt(_),oe)},registerDefinitionProvider(_,oe){return ct.registerDefinitionProvider(ze,bt(_),oe)},registerDeclarationProvider(_,oe){return ct.registerDeclarationProvider(ze,bt(_),oe)},registerImplementationProvider(_,oe){return ct.registerImplementationProvider(ze,bt(_),oe)},registerTypeDefinitionProvider(_,oe){return ct.registerTypeDefinitionProvider(ze,bt(_),oe)},registerHoverProvider(_,oe){return ct.registerHoverProvider(ze,bt(_),oe,ze.identifier)},registerEvaluatableExpressionProvider(_,oe){return ct.registerEvaluatableExpressionProvider(ze,bt(_),oe,ze.identifier)},registerInlineValuesProvider(_,oe){return ct.registerInlineValuesProvider(ze,bt(_),oe,ze.identifier)},registerDocumentHighlightProvider(_,oe){return ct.registerDocumentHighlightProvider(ze,bt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return ct.registerMultiDocumentHighlightProvider(ze,bt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return ct.registerLinkedEditingRangeProvider(ze,bt(_),oe)},registerReferenceProvider(_,oe){return ct.registerReferenceProvider(ze,bt(_),oe)},registerRenameProvider(_,oe){return ct.registerRenameProvider(ze,bt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Ze.$KG)(ze,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(ze,bt(_),oe)},registerDocumentSymbolProvider(_,oe,Le){return ct.registerDocumentSymbolProvider(ze,bt(_),oe,Le)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(ze,_)},registerDocumentFormattingEditProvider(_,oe){return ct.registerDocumentFormattingEditProvider(ze,bt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return ct.registerDocumentRangeFormattingEditProvider(ze,bt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Le,...ot){return ct.registerOnTypeFormattingEditProvider(ze,bt(_),oe,[Le].concat(ot))},registerDocumentSemanticTokensProvider(_,oe,Le){return ct.registerDocumentSemanticTokensProvider(ze,bt(_),oe,Le)},registerDocumentRangeSemanticTokensProvider(_,oe,Le){return ct.registerDocumentRangeSemanticTokensProvider(ze,bt(_),oe,Le)},registerSignatureHelpProvider(_,oe,Le,...ot){return typeof Le=="object"?ct.registerSignatureHelpProvider(ze,bt(_),oe,Le):ct.registerSignatureHelpProvider(ze,bt(_),oe,typeof Le>"u"?[]:[Le,...ot])},registerCompletionItemProvider(_,oe,...Le){return ct.registerCompletionItemProvider(ze,bt(_),oe,Le)},registerInlineCompletionItemProvider(_,oe,Le){return oe.handleDidShowCompletionItem&&(0,Ze.$KG)(ze,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$KG)(ze,"inlineCompletionsAdditions"),Le&&(0,Ze.$KG)(ze,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(ze,bt(_),oe,Le)},registerInlineEditProvider(_,oe){return(0,Ze.$KG)(ze,"inlineEdit"),ct.registerInlineEditProvider(ze,bt(_),oe)},registerDocumentLinkProvider(_,oe){return ct.registerDocumentLinkProvider(ze,bt(_),oe)},registerColorProvider(_,oe){return ct.registerColorProvider(ze,bt(_),oe)},registerFoldingRangeProvider(_,oe){return ct.registerFoldingRangeProvider(ze,bt(_),oe)},registerSelectionRangeProvider(_,oe){return ct.registerSelectionRangeProvider(ze,_,oe)},registerCallHierarchyProvider(_,oe){return ct.registerCallHierarchyProvider(ze,_,oe)},registerTypeHierarchyProvider(_,oe){return ct.registerTypeHierarchyProvider(ze,_,oe)},setLanguageConfiguration:(_,oe)=>ct.setLanguageConfiguration(ze,_,oe),getTokenInformationAtPosition(_,oe){return(0,Ze.$KG)(ze,"tokenInformation"),Ft.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return ct.registerInlayHintsProvider(ze,_,oe)},createLanguageStatusItem(_,oe){return Ft.createLanguageStatusItem(ze,_,oe)},registerDocumentDropEditProvider(_,oe,Le){return ct.registerDocumentOnDropEditProvider(ze,_,oe,(0,Ze.$JG)(ze,"documentPaste")?Le:void 0)}},nn={get activeTextEditor(){return Xe.getActiveTextEditor()},get visibleTextEditors(){return Xe.getVisibleTextEditors()},get activeTerminal(){return Dt.activeTerminal},get terminals(){return Dt.terminals},async showTextDocument(_,oe,Le){m.URI.isUri(_)&&_.scheme===R.Schemas.vscodeRemote&&!_.authority&&At.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await(m.URI.isUri(_)?Promise.resolve(qi.openTextDocument(_)):Promise.resolve(_));return Xe.showTextDocument(ot,oe,Le)},createTextEditorDecorationType(_){return Xe.createTextEditorDecorationType(ze,_)},onDidChangeActiveTextEditor(_,oe,Le){return nt(Xe.onDidChangeActiveTextEditor)(_,oe,Le)},onDidChangeVisibleTextEditors(_,oe,Le){return nt(Xe.onDidChangeVisibleTextEditors)(_,oe,Le)},onDidChangeTextEditorSelection(_,oe,Le){return nt(Xe.onDidChangeTextEditorSelection)(_,oe,Le)},onDidChangeTextEditorOptions(_,oe,Le){return nt(Xe.onDidChangeTextEditorOptions)(_,oe,Le)},onDidChangeTextEditorVisibleRanges(_,oe,Le){return nt(Xe.onDidChangeTextEditorVisibleRanges)(_,oe,Le)},onDidChangeTextEditorViewColumn(_,oe,Le){return nt(Xe.onDidChangeTextEditorViewColumn)(_,oe,Le)},onDidCloseTerminal(_,oe,Le){return nt(Dt.onDidCloseTerminal)(_,oe,Le)},onDidOpenTerminal(_,oe,Le){return nt(Dt.onDidOpenTerminal)(_,oe,Le)},onDidChangeActiveTerminal(_,oe,Le){return nt(Dt.onDidChangeActiveTerminal)(_,oe,Le)},onDidChangeTerminalDimensions(_,oe,Le){return(0,Ze.$KG)(ze,"terminalDimensions"),nt(Dt.onDidChangeTerminalDimensions)(_,oe,Le)},onDidChangeTerminalState(_,oe,Le){return nt(Dt.onDidChangeTerminalState)(_,oe,Le)},onDidWriteTerminalData(_,oe,Le){return(0,Ze.$KG)(ze,"terminalDataWriteEvent"),nt(Dt.onDidWriteTerminalData)(_,oe,Le)},onDidExecuteTerminalCommand(_,oe,Le){return(0,Ze.$KG)(ze,"terminalExecuteCommandEvent"),nt(Dt.onDidExecuteTerminalCommand)(_,oe,Le)},onDidChangeTerminalShellIntegration(_,oe,Le){return(0,Ze.$KG)(ze,"terminalShellIntegration"),nt(ai.onDidChangeTerminalShellIntegration)(_,oe,Le)},onDidStartTerminalShellExecution(_,oe,Le){return(0,Ze.$KG)(ze,"terminalShellIntegration"),nt(ai.onDidStartTerminalShellExecution)(_,oe,Le)},onDidEndTerminalShellExecution(_,oe,Le){return(0,Ze.$KG)(ze,"terminalShellIntegration"),nt(ai.onDidEndTerminalShellExecution)(_,oe,Le)},get state(){return Rt.getState()},onDidChangeWindowState(_,oe,Le){return nt(Rt.onDidChangeWindowState)(_,oe,Le)},showInformationMessage(_,...oe){return Vi.showMessage(ze,p.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Vi.showMessage(ze,p.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Vi.showMessage(ze,p.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Le){return Di.showQuickPick(ze,_,oe,Le)},showWorkspaceFolderPick(_){return Di.showWorkspaceFolderPick(_)},showInputBox(_,oe){return Di.showInput(_,oe)},showOpenDialog(_){return Mi.showOpenDialog(ze,_)},showSaveDialog(_){return Mi.showSaveDialog(_)},createStatusBarItem(_,oe,Le){let ot,vt,Pt;return typeof _=="string"?(ot=_,vt=oe,Pt=Le):(vt=_,Pt=oe),xi.createStatusBarEntry(ze,ot,vt,Pt)},setStatusBarMessage(_,oe){return xi.setStatusBarMessage(_,oe)},withScmProgress(_){return At.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ci.withProgress(ze,{location:be.ProgressLocation.SourceControl},(oe,Le)=>_({report(ot){}}))},withProgress(_,oe){return Ci.withProgress(ze,_,oe)},createOutputChannel(_,oe){return $i.createOutputChannel(_,oe,ze)},createWebviewPanel(_,oe,Le,ot){return Pi.createWebviewPanel(ze,_,oe,Le,ot)},createWebviewTextEditorInset(_,oe,Le,ot){return(0,Ze.$KG)(ze,"editorInsets"),ut.createWebviewEditorInset(_,oe,Le,ot,ze)},createTerminal(_,oe,Le){return typeof _=="object"?"pty"in _?Dt.createExtensionTerminal(_):Dt.createTerminalFromOptions(_):Dt.createTerminal(_,oe,Le)},registerTerminalLinkProvider(_){return Dt.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return Dt.registerProfileProvider(ze,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Ze.$KG)(ze,"terminalQuickFixProvider"),Dt.registerTerminalQuickFixProvider(_,ze.identifier.value,oe)},registerTreeDataProvider(_,oe){return qe.registerTreeDataProvider(_,oe,ze)},createTreeView(_,oe){return qe.createTreeView(_,oe,ze)},registerWebviewPanelSerializer:(_,oe)=>Pi.registerWebviewPanelSerializer(ze,_,oe),registerCustomEditorProvider:(_,oe,Le={})=>zi.registerCustomEditorProvider(ze,_,oe,Le),registerFileDecorationProvider(_){return Mt.registerFileDecorationProvider(_,ze)},registerUriHandler(_){return bi.registerUriHandler(ze,_)},createQuickPick(){return Di.createQuickPick(ze)},createInputBox(){return Di.createInputBox(ze)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Le){return nt(Fi.onDidChangeActiveColorTheme)(_,oe,Le)},registerWebviewViewProvider(_,oe,Le){return Ui.registerWebviewViewProvider(ze,_,oe,Le?.webviewOptions)},get activeNotebookEditor(){return pe.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Le){return nt(pe.onDidChangeActiveNotebookEditor)(_,oe,Le)},get visibleNotebookEditors(){return pe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(pe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Le){return nt(ae.onDidChangeNotebookEditorSelection)(_,oe,Le)},onDidChangeNotebookEditorVisibleRanges(_,oe,Le){return nt(ae.onDidChangeNotebookEditorVisibleRanges)(_,oe,Le)},showNotebookDocument(_,oe){return pe.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Le){return(0,Ze.$KG)(ze,"externalUriOpener"),Xi.registerExternalUriOpener(ze.identifier,_,oe,Le)},registerProfileContentHandler(_,oe){return(0,Ze.$KG)(ze,"profileContentHandlers"),Zi.registerProfileContentHandler(ze,_,oe)},registerQuickDiffProvider(_,oe,Le,ot){return(0,Ze.$KG)(ze,"quickDiffProvider"),Ji.registerQuickDiffProvider(bt(_),oe,Le,ot)},get tabGroups(){return Wt.tabGroups},registerShareProvider(_,oe){return(0,Ze.$KG)(ze,"shareProvider"),Oi.registerShareProvider(bt(_),oe)}},qi={get rootPath(){return At.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new O.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new O.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Le)=>ft.updateWorkspaceFolders(ze,_,oe||0,...Le),onDidChangeWorkspaceFolders:function(_,oe,Le){return nt(ft.onDidChangeWorkspace)(_,oe,Le)},asRelativePath:(_,oe)=>ft.getRelativePath(_,oe),findFiles:(_,oe,Le,ot)=>ft.findFiles(_,oe,Le,ze.identifier,ot),findFiles2:(_,oe,Le)=>((0,Ze.$KG)(ze,"findFiles2"),ft.findFiles2(_,oe,ze.identifier,Le)),findTextInFiles:(_,oe,Le,ot)=>{(0,Ze.$KG)(ze,"findTextInFiles");let vt,Pt;return typeof oe=="object"?(vt=oe,Pt=Le):(vt={},Pt=oe,ot=Le),ft.findTextInFiles(_,vt||{},Pt,ze.identifier,ot)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,oe){return gn.applyWorkspaceEdit(_,ze,oe)},createFileSystemWatcher:(_,oe,Le,ot)=>{let vt;return typeof oe=="boolean"?vt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!ot,correlate:!1}:oe&&((0,Ze.$KG)(ze,"createFileSystemWatcher"),vt={...oe,correlate:!0}),Lt.createFileSystemWatcher(ft,ze,_,vt)},get textDocuments(){return It.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new O.$9("textDocuments")},openTextDocument(_){let oe;const Le=_;if(typeof _=="string")oe=Promise.resolve(m.URI.file(_));else if(m.URI.isUri(_))oe=Promise.resolve(_);else if(!Le||typeof Le=="object")oe=It.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(ot=>(ot.scheme===R.Schemas.vscodeRemote&&!ot.authority&&At.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),It.ensureDocumentData(ot).then(vt=>vt.document)))},onDidOpenTextDocument:(_,oe,Le)=>nt(It.onDidAddDocument)(_,oe,Le),onDidCloseTextDocument:(_,oe,Le)=>nt(It.onDidRemoveDocument)(_,oe,Le),onDidChangeTextDocument:(_,oe,Le)=>nt(It.onDidChangeDocument)(_,oe,Le),onDidSaveTextDocument:(_,oe,Le)=>nt(It.onDidSaveDocument)(_,oe,Le),onWillSaveTextDocument:(_,oe,Le)=>nt(ri.getOnWillSaveTextDocumentEvent(ze))(_,oe,Le),get notebookDocuments(){return pe.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Le;if(m.URI.isUri(_))Le=_,await pe.openNotebookDocument(_);else if(typeof _=="string")Le=m.URI.revive(await pe.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return pe.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,oe,Le){return nt(Re.onDidSaveNotebookDocument)(_,oe,Le)},onDidChangeNotebookDocument(_,oe,Le){return nt(Re.onDidChangeNotebookDocument)(_,oe,Le)},onWillSaveNotebookDocument(_,oe,Le){return nt(Ve.getOnWillSaveNotebookDocumentEvent(ze))(_,oe,Le)},get onDidOpenNotebookDocument(){return nt(pe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(pe.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Le,ot){return pe.registerNotebookSerializer(ze,_,oe,Le,(0,Ze.$JG)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(_,oe,Le)=>nt(Wi.onDidChangeConfiguration)(_,oe,Le),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,Wi.getConfiguration(_,oe,ze)},registerTextDocumentContentProvider(_,oe){return Ei.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(At.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ni.registerTaskProvider(ze,_,oe)),registerFileSystemProvider(_,oe,Le){return(0,N.$Rc)(Tt.registerFileSystemProvider(ze,_,oe,Le),Gt.addFileSystemProvider(_,oe,Le))},get fs(){return Gt.value},registerFileSearchProvider:(_,oe)=>((0,Ze.$KG)(ze,"fileSearchProvider"),fi.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Ze.$KG)(ze,"textSearchProvider"),fi.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Ze.$KG)(ze,"aiTextSearchProvider"),(0,Ze.$KG)(ze,"textSearchProvider"),fi.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Ze.$KG)(ze,"resolvers"),Nt.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Ze.$KG)(ze,"resolvers"),Ni.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ze.$KG)(ze,"resolvers"),Nt.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Le)=>nt(Lt.onDidCreateFile)(_,oe,Le),onDidDeleteFiles:(_,oe,Le)=>nt(Lt.onDidDeleteFile)(_,oe,Le),onDidRenameFiles:(_,oe,Le)=>nt(Lt.onDidRenameFile)(_,oe,Le),onWillCreateFiles:(_,oe,Le)=>nt(Lt.getOnWillCreateFileEvent(ze))(_,oe,Le),onWillDeleteFiles:(_,oe,Le)=>nt(Lt.getOnWillDeleteFileEvent(ze))(_,oe,Le),onWillRenameFiles:(_,oe,Le)=>nt(Lt.getOnWillRenameFileEvent(ze))(_,oe,Le),openTunnel:_=>((0,Ze.$KG)(ze,"tunnels"),jt.openTunnel(ze,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Ze.$KG)(ze,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(_,oe,Le)=>((0,Ze.$KG)(ze,"tunnels"),nt(jt.onDidChangeTunnels)(_,oe,Le)),registerPortAttributesProvider:(_,oe)=>((0,Ze.$KG)(ze,"portsAttributes"),jt.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Ze.$KG)(ze,"tunnelFactory"),jt.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Ze.$KG)(ze,"timeline"),Qi.registerTimelineProvider(_,oe,ze.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Ze.$KG)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Le)=>nt(ft.onDidGrantWorkspaceTrust)(_,oe,Le),registerEditSessionIdentityProvider:(_,oe)=>((0,Ze.$KG)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Le)=>((0,Ze.$KG)(ze,"editSessionIdentityProvider"),nt(ft.getOnWillCreateEditSessionIdentityEvent(ze))(_,oe,Le)),registerCanonicalUriProvider:(_,oe)=>((0,Ze.$KG)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Le)=>((0,Ze.$KG)(ze,"canonicalUriProvider"),ft.provideCanonicalUri(_,oe,Le))},rn={get inputBox(){return At.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ii.getLastInputBox(ze)},createSourceControl(_,oe,Le){return Ii.createSourceControl(ze,_,oe,Le)}},$n={createCommentController(_,oe){return Ti.createCommentController(ze,_,oe)}},sn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){return kt.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Ze.$KG)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Ze.$KG)(ze,"debugVisualization"),kt.registerDebugVisualizationTree(ze,_,oe)},onDidStartDebugSession(_,oe,Le){return nt(kt.onDidStartDebugSession)(_,oe,Le)},onDidTerminateDebugSession(_,oe,Le){return nt(kt.onDidTerminateDebugSession)(_,oe,Le)},onDidChangeActiveDebugSession(_,oe,Le){return nt(kt.onDidChangeActiveDebugSession)(_,oe,Le)},onDidReceiveDebugSessionCustomEvent(_,oe,Le){return nt(kt.onDidReceiveDebugSessionCustomEvent)(_,oe,Le)},onDidChangeBreakpoints(_,oe,Le){return nt(kt.onDidChangeBreakpoints)(_,oe,Le)},onDidChangeActiveStackItem(_,oe,Le){return nt(kt.onDidChangeActiveStackItem)(_,oe,Le)},registerDebugConfigurationProvider(_,oe,Le){return kt.registerDebugConfigurationProvider(_,oe,Le||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return kt.registerDebugAdapterDescriptorFactory(ze,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return kt.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?kt.startDebugging(_,oe,{parentSession:Le}):kt.startDebugging(_,oe,Le||{})},stopDebugging(_){return kt.stopDebugging(_)},addBreakpoints(_){return kt.addBreakpoints(_)},removeBreakpoints(_){return kt.removeBreakpoints(_)},asDebugSourceUri(_,oe){return kt.asDebugSourceUri(_,oe)}},on={registerTaskProvider:(_,oe)=>ni.registerTaskProvider(ze,_,oe),fetchTasks:_=>ni.fetchTasks(_),executeTask:_=>ni.executeTask(ze,_),get taskExecutions(){return ni.taskExecutions},onDidStartTask:(_,oe,Le)=>nt(ni.onDidStartTask)(_,oe,Le),onDidEndTask:(_,oe,Le)=>nt(ni.onDidEndTask)(_,oe,Le),onDidStartTaskProcess:(_,oe,Le)=>nt(ni.onDidStartTaskProcess)(_,oe,Le),onDidEndTaskProcess:(_,oe,Le)=>nt(ni.onDidEndTaskProcess)(_,oe,Le)},pn={createNotebookController(_,oe,Le,ot,vt){return J.createNotebookController(ze,_,oe,Le,ot,(0,Ze.$JG)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>pe.registerNotebookCellStatusBarItemProvider(ze,_,oe),createRendererMessaging(_){return Ae.createRendererMessaging(ze,_)},createNotebookControllerDetectionTask(_){return(0,Ze.$KG)(ze,"notebookKernelSource"),J.createNotebookControllerDetectionTask(ze,_)},registerKernelSourceActionProvider(_,oe){return(0,Ze.$KG)(ze,"notebookKernelSource"),J.registerKernelSourceActionProvider(ze,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Le){return(0,Ze.$KG)(ze,"notebookCellExecutionState"),nt(J.onDidChangeNotebookCellExecutionState)(_,oe,Le)}},wn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return li.getMessage(ze.identifier.value,{message:oe,args:Le})}return li.getMessage(ze.identifier.value,_[0])},get bundle(){return li.getBundle(ze.identifier.value)},get uri(){return li.getBundleUri(ze.identifier.value)}},an={_version:1,transferActiveChat(_){return(0,Ze.$KG)(ze,"interactive"),Ai.transferActiveChat(_)}},Ki={getRelatedInformation(_,oe){return(0,Ze.$KG)(ze,"aiRelatedInformation"),ji.getRelatedInformation(ze,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Ze.$KG)(ze,"aiRelatedInformation"),ji.registerRelatedInformationProvider(ze,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Ze.$KG)(ze,"aiRelatedInformation"),dn.registerEmbeddingVectorProvider(ze,_,oe)}},cn={registerChatResponseProvider(_,oe,Le){return(0,Ze.$KG)(ze,"chatProvider"),qt.registerLanguageModel(ze,_,oe,Le)},registerChatVariableResolver(_,oe,Le){return(0,Ze.$KG)(ze,"chatVariableResolver"),Yi.registerVariableResolver(ze,_,oe,Le)},registerMappedEditsProvider(_,oe){return(0,Ze.$KG)(ze,"mappedEditsProvider"),ct.registerMappedEditsProvider(ze,_,oe)},createChatParticipant(_,oe){return(0,Ze.$KG)(ze,"chatParticipant"),Ai.createChatAgent(ze,_,oe)},createDynamicChatParticipant(_,oe,Le,ot,vt){return(0,Ze.$KG)(ze,"chatParticipantAdditions"),Ai.createDynamicChatAgent(ze,_,oe,Le,ot,vt)}},un={selectChatModels:_=>((0,Ze.$KG)(ze,"languageModels"),qt.selectLanguageModels(ze,_??{})),onDidChangeChatModels:(_,oe,Le)=>((0,Ze.$KG)(ze,"languageModels"),qt.onDidChangeProviders(_,oe,Le)),get embeddingModels(){return(0,Ze.$KG)(ze,"embeddings"),pi.embeddingsModels},onDidChangeEmbeddingModels:(_,oe,Le)=>((0,Ze.$KG)(ze,"embeddings"),pi.onDidChange(_,oe,Le)),registerEmbeddingsProvider(_,oe){return(0,Ze.$KG)(ze,"embeddings"),pi.registerEmbeddingsProvider(ze,_,oe)},async computeEmbeddings(_,oe,Le){return(0,Ze.$KG)(ze,"embeddings"),pi.computeEmbeddings(_,oe,Le)}},ln={registerSpeechProvider(_,oe){return(0,Ze.$KG)(ze,"speech"),Bi.registerProvider(ze.identifier,_,oe)}};return{version:mt.version,ai:Ki,authentication:en,commands:gi,comments:$n,chat:cn,debug:sn,env:ki,extensions:Ri,interactive:an,l10n:wn,languages:tn,lm:un,notebooks:pn,scm:rn,speech:ln,tasks:on,tests:mn,window:nn,workspace:qi,Breakpoint:be.$kN,TerminalOutputAnchor:be.TerminalOutputAnchor,ChatResultFeedbackKind:be.ChatResultFeedbackKind,ChatVariableLevel:be.ChatVariableLevel,ChatCompletionItem:be.$fO,CallHierarchyIncomingCall:be.$IM,CallHierarchyItem:be.$HM,CallHierarchyOutgoingCall:be.$JM,CancellationError:O.$5,CancellationTokenSource:C.$qe,CandidatePortSource:n.CandidatePortSource,CodeAction:be.$EM,CodeActionKind:be.$FM,CodeActionTriggerKind:be.CodeActionTriggerKind,CodeLens:be.$KM,Color:be.$XM,ColorInformation:be.$YM,ColorPresentation:be.$ZM,ColorThemeKind:be.ColorThemeKind,CommentMode:be.CommentMode,CommentState:be.CommentState,CommentThreadCollapsibleState:be.CommentThreadCollapsibleState,CommentThreadState:be.CommentThreadState,CommentThreadApplicability:be.CommentThreadApplicability,CompletionItem:be.$RM,CompletionItemKind:be.CompletionItemKind,CompletionItemTag:be.CompletionItemTag,CompletionList:be.$SM,CompletionTriggerKind:be.CompletionTriggerKind,ConfigurationTarget:be.ConfigurationTarget,CustomExecution:be.$8M,DebugAdapterExecutable:be.$oN,DebugAdapterInlineImplementation:be.$rN,DebugAdapterNamedPipeServer:be.$qN,DebugAdapterServer:be.$pN,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:be.DebugConsoleMode,DebugVisualization:be.$HN,DecorationRangeBehavior:be.DecorationRangeBehavior,Diagnostic:be.$xM,DiagnosticRelatedInformation:be.$wM,DiagnosticSeverity:be.DiagnosticSeverity,DiagnosticTag:be.DiagnosticTag,Disposable:be.$jM,DocumentHighlight:be.$AM,DocumentHighlightKind:be.DocumentHighlightKind,MultiDocumentHighlight:be.$BM,DocumentLink:be.$WM,DocumentSymbol:be.$DM,EndOfLine:be.EndOfLine,EnvironmentVariableMutatorType:be.EnvironmentVariableMutatorType,EvaluatableExpression:be.$uN,InlineValueText:be.$vN,InlineValueVariableLookup:be.$wN,InlineValueEvaluatableExpression:be.$xN,InlineCompletionTriggerKind:be.InlineCompletionTriggerKind,EventEmitter:A.$fe,ExtensionKind:be.ExtensionKind,ExtensionMode:be.ExtensionMode,ExternalUriOpenerPriority:be.ExternalUriOpenerPriority,FileChangeType:be.FileChangeType,FileDecoration:be.$JN,FileDecoration2:be.$JN,FileSystemError:be.$AN,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:be.$BN,FoldingRangeKind:be.FoldingRangeKind,FunctionBreakpoint:be.$mN,InlineCompletionItem:be.$TM,InlineCompletionList:be.$UM,Hover:be.$yM,VerboseHover:be.$zM,HoverVerbosityAction:be.HoverVerbosityAction,IndentAction:S.IndentAction,Location:be.$vM,MarkdownString:be.$LM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:be.$MM,PortAutoForwardAction:be.PortAutoForwardAction,Position:be.$kM,ProcessExecution:be.$6M,ProgressLocation:be.ProgressLocation,QuickInputButtons:be.$IN,Range:be.$lM,RelativePattern:be.$iN,Selection:be.$mM,SelectionRange:be.$GM,SemanticTokens:be.$EN,SemanticTokensBuilder:be.$DN,SemanticTokensEdit:be.$FN,SemanticTokensEdits:be.$GN,SemanticTokensLegend:be.$CN,ShellExecution:be.$7M,ShellQuoting:be.ShellQuoting,SignatureHelp:be.$OM,SignatureHelpTriggerKind:be.SignatureHelpTriggerKind,SignatureInformation:be.$NM,SnippetString:be.$uM,SourceBreakpoint:be.$lN,StandardTokenType:be.StandardTokenType,StatusBarAlignment:be.StatusBarAlignment,SymbolInformation:be.$CM,SymbolKind:be.SymbolKind,SymbolTag:be.SymbolTag,Task:be.$9M,TaskGroup:be.$5M,TaskPanelKind:be.TaskPanelKind,TaskRevealKind:be.TaskRevealKind,TaskScope:be.TaskScope,TerminalLink:be.$1M,TerminalQuickFixTerminalCommand:be.$3M,TerminalQuickFixOpener:be.$2M,TerminalLocation:be.TerminalLocation,TerminalProfile:be.$4M,TerminalExitReason:be.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:be.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:be.TextDocumentSaveReason,TextEdit:be.$qM,SnippetTextEdit:be.$sM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:be.TextEditorLineNumbersStyle,TextEditorRevealType:be.TextEditorRevealType,TextEditorSelectionChangeKind:be.TextEditorSelectionChangeKind,SyntaxTokenType:be.SyntaxTokenType,TextDocumentChangeReason:be.TextDocumentChangeReason,ThemeColor:be.$hN,ThemeIcon:be.$gN,TreeItem:be.$0M,TreeItemCheckboxState:be.TreeItemCheckboxState,TreeItemCollapsibleState:be.TreeItemCollapsibleState,TypeHierarchyItem:be.$6N,UIKind:Yt.UIKind,Uri:m.URI,ViewColumn:be.ViewColumn,WorkspaceEdit:be.$tM,DocumentPasteTriggerKind:be.DocumentPasteTriggerKind,DocumentDropEdit:be.$dN,DocumentDropOrPasteEditKind:be.$eN,DocumentPasteEdit:be.$fN,InlayHint:be.$QM,InlayHintLabelPart:be.$PM,InlayHintKind:be.InlayHintKind,RemoteAuthorityResolverError:be.$pM,ResolvedAuthority:be.$nM,ManagedResolvedAuthority:be.$oM,SourceControlInputBoxValidationType:be.SourceControlInputBoxValidationType,ExtensionRuntime:be.ExtensionRuntime,TimelineItem:be.$TN,NotebookRange:be.$LN,NotebookCellKind:be.NotebookCellKind,NotebookCellExecutionState:be.NotebookCellExecutionState,NotebookCellData:be.$MN,NotebookData:be.$NN,NotebookRendererScript:be.$RN,NotebookCellStatusBarAlignment:be.NotebookCellStatusBarAlignment,NotebookEditorRevealType:be.NotebookEditorRevealType,NotebookCellOutput:be.$PN,NotebookCellOutputItem:be.$ON,NotebookCellStatusBarItem:be.$QN,NotebookControllerAffinity:be.NotebookControllerAffinity,NotebookControllerAffinity2:be.NotebookControllerAffinity2,NotebookEdit:be.$rM,NotebookKernelSourceAction:be.$SN,NotebookVariablesRequestKind:be.NotebookVariablesRequestKind,PortAttributes:be.$VN,LinkedEditingRanges:be.$UN,TestResultState:be.TestResultState,TestRunRequest:be.$WN,TestMessage:be.$XN,TestTag:be.$YN,TestRunProfileKind:be.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:be.$cN,DataTransferItem:be.$$M,TestCoverageCount:be.$ZN,FileCoverage:be.$2N,FileCoverage2:be.$2N,StatementCoverage:be.$3N,BranchCoverage:be.$4N,DeclarationCoverage:be.$5N,WorkspaceTrustState:be.WorkspaceTrustState,LanguageStatusSeverity:be.LanguageStatusSeverity,QuickPickItemKind:be.QuickPickItemKind,InputBoxValidationSeverity:be.InputBoxValidationSeverity,TabInputText:be.$7N,TabInputTextDiff:be.$8N,TabInputTextMerge:be.$9N,TabInputCustom:be.$0N,TabInputNotebook:be.$_N,TabInputNotebookDiff:be.$aO,TabInputWebview:be.$$N,TabInputTerminal:be.$bO,TabInputInteractiveWindow:be.$cO,TabInputChat:be.$dO,TabInputTextMultiDiff:be.$eO,TelemetryTrustedValue:o.$ip,LogLevel:s.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:be.InteractiveSessionVoteDirection,ChatCopyKind:be.ChatCopyKind,InteractiveEditorResponseFeedbackKind:be.InteractiveEditorResponseFeedbackKind,DebugStackFrame:be.$sN,DebugThread:be.$tN,RelatedInformationType:be.RelatedInformationType,SpeechToTextStatus:be.SpeechToTextStatus,TextToSpeechStatus:be.TextToSpeechStatus,PartialAcceptTriggerKind:be.PartialAcceptTriggerKind,KeywordRecognitionStatus:be.KeywordRecognitionStatus,ChatResponseMarkdownPart:be.$gO,ChatResponseFileTreePart:be.$kO,ChatResponseAnchorPart:be.$lO,ChatResponseProgressPart:be.$mO,ChatResponseProgressPart2:be.$nO,ChatResponseReferencePart:be.$qO,ChatResponseWarningPart:be.$oO,ChatResponseTextEditPart:be.$rO,ChatResponseMarkdownWithVulnerabilitiesPart:be.$hO,ChatResponseCommandButtonPart:be.$pO,ChatResponseDetectedParticipantPart:be.$iO,ChatResponseConfirmationPart:be.$jO,ChatRequestTurn:be.$sO,ChatResponseTurn:be.$tO,ChatLocation:be.ChatLocation,LanguageModelChatMessageRole:be.LanguageModelChatMessageRole,LanguageModelChatMessage:be.$uO,LanguageModelChatMessage2:be.$uO,LanguageModelChatSystemMessage:be.$vO,LanguageModelChatUserMessage:be.$wO,LanguageModelChatAssistantMessage:be.$xO,LanguageModelError:be.$yO,NewSymbolName:be.$zN,NewSymbolNameTag:be.NewSymbolNameTag,NewSymbolNameTriggerKind:be.NewSymbolNameTriggerKind,InlineEdit:be.$zO,InlineEditTriggerKind:be.InlineEditTriggerKind}}}}),define(Se[308],Ie([1,0,56,118,39,112,40,35,68,53,121,123,124,84,88,80,111,65,46,83,63,67,248,12,122,81,82,86,90,116]),function(le,e,C,O,A,N,R,p,m,E,T,S,l,b,f,s,r,o,i,n,c,u,t,g,a,d,w,$,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$As)(d.$Omc,d.$Nmc,1),(0,C.$As)(g.$6j,t.$2nc,1),(0,C.$As)(s.$Tlc,s.$Ulc,1),(0,C.$As)(p.$8O,p.$7O,0),(0,C.$As)($.$4lc,$.$5lc,0),(0,C.$As)(v.$Imc,v.$Jmc,0),(0,C.$As)(R.$gmc,R.$emc,0),(0,C.$As)(o.$imc,o.$hmc,0),(0,C.$As)(S.$Ymc,S.$3mc,0),(0,C.$As)(N.$5mc,N.$4mc,0),(0,C.$As)(m.$WO,m.$VO,0),(0,C.$As)(w.$Pmc,w.$Qmc,0),(0,C.$As)(i.$Xlc,i.$Wlc,0),(0,C.$As)(O.$xnc,O.$wnc,1),(0,C.$As)(l.$inc,l.$jnc,0),(0,C.$As)(b.$Bmc,b.$Amc,0),(0,C.$As)(T.$Knc,T.$Jnc,0),(0,C.$As)(E.$Emc,E.$Hmc,0),(0,C.$As)(y.$Lnc,y.$Mnc,0),(0,C.$As)(f.$RDb,f.$SDb,0),(0,C.$As)(r.$Znc,r.$Ync,0),(0,C.$As)(A.$dmc,A.$cmc,0),(0,C.$As)(n.$Lmc,n.$Kmc,0),(0,C.$As)(c.$6O,c.$3O,0),(0,C.$As)(u.$smc,u.$tmc,0),(0,C.$As)(a.$Wmc,a.$Xmc,0)}),define(Se[309],Ie([1,0,307,41,2,304,7,11,254]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=void 0;class E extends N.$5nc{j(){}getModule(b,f){for(const s of this.b){const r=s(b);if(r){b=r;break}}if(this.a.has(b))return this.a.get(b).load(b,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends O.$Smc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(m.$$pc);const b=this.h.invokeFunction(C.$1nc);this.r=this.h.createInstance(E,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(b){return b.browser}async xb(b,f,s){f=f.with({path:S(f.path,".js")});const r=b?.identifier.value;r&&performance.mark(`code/extHost/willFetchExtensionCode/${r}`);const o=A.URI.revive(await this.C.$asBrowserUri(f)),i=await fetch(o.toString(!0));if(r&&performance.mark(`code/extHost/didFetchExtensionCode/${r}`),i.status!==200)throw new Error(i.statusText);const n=await i.text(),c=`${f.toString(!0)}#vscode-extension`,u=`${n}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",u)}catch(w){throw console.error(r?`Loading code for extension ${r} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${f.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}b&&await this.w.initializeLocalizedMessages(b);const g={},a={exports:g},d=w=>{const $=this.r.getModule(w,f);if($===void 0)throw new Error(`Cannot load module '${w}'`);return $};try{return s.codeLoadingStart(),r&&performance.mark(`code/extHost/willLoadExtensionCode/${r}`),t(a,g,d),a.exports!==g?a.exports:g}finally{r&&performance.mark(`code/extHost/didLoadExtensionCode/${r}`),s.codeLoadingStop()}}async $setRemoteEnvironment(b){}async Bb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+b;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,p.$zh)(10)}}e.$_pc=T;function S(l,b){return l.endsWith(b)?l:l+b}}),define(Se[310],Ie([1,0,71,56,12,41,217,87,309]),function(le,e,C,O,A,N,R,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.$As)(A.$5j,new C.$vi(R.$4nc,[!0],!0)),(0,O.$As)(N.$Tmc,m.$_pc,0),(0,O.$As)(p.$jmc,p.$kmc,0)}),define(Se[316],Ie([1,0,22,5,79,305,256,19,60,16,2,308,310]),function(le,e,C,O,A,N,R,p,m,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=u;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function s(t){self.fetch=async function(g,a){return g instanceof Request||b(String(g))&&(g=(await t(T.URI.parse(String(g)))).toString(!0)),f(g,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(g,a,d,w,$){(async()=>(b(a.toString())&&(a=(await t(T.URI.parse(a.toString()))).toString(!0)),super.open(g,a,d??!0,w,$)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(g,a){if(/^file:/i.test(g.toString()))g=E.$Sg.uriToBrowserUri(T.URI.parse(g.toString())).toString(!0);else if(/^vscode-remote:/i.test(g.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(h){function D(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const k=fetch.bind(self);self.fetch=function(P,V){return P instanceof Request?k(P,V):k(D(P),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,V,W,q,M){return super.open(P,D(V),W??!0,q,M)}};const I=importScripts.bind(self);self.importScripts=(...P)=>{I(...P.map(D))},I(h)}.toString()}('${g}'))`;a=a||{},a.name=`${name} -> ${a.name||p.$nc(g.toString())}`;const $=new Blob([w],{type:"application/javascript"}),v=URL.createObjectURL($);return new t(v,a)}}else self.Worker=class extends R.$aqc{constructor(t,g){super(l,t,{name:p.$nc(t.toString()),...g})}};const r=new class{constructor(){this.pid=void 0}exit(t){S()}};class o{constructor(){const g=new MessageChannel,a=new O.$fe;let d=!1;l(g.port2,[g.port2]),g.port1.onmessage=w=>{const{data:$}=w;if(!($ instanceof ArrayBuffer)){console.warn("UNKNOWN data received",$);return}const v=C.$He.wrap(new Uint8Array($,0,$.byteLength));if((0,A.$3m)(v,2)){d=!0,n("received terminate message from renderer");return}a.fire(v)},this.protocol={onMessage:a.event,send:w=>{if(!d){const $=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);g.port1.postMessage($,[$])}}}}}function i(t){return new Promise(g=>{const a=t.onMessage(d=>{a.dispose();const w=JSON.parse(d.toString());t.send((0,A.$2m)(0)),g({protocol:t,initData:w})});t.send((0,A.$2m)(1))})}let n=t=>S();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function u(){m.mark("code/extHost/willConnectToRenderer");const t=new o;return{onmessage(g){c(g)&&i(t.protocol).then(a=>{m.mark("code/extHost/didWaitForInitData");const d=new N.$7nc(a.protocol,a.initData,r,null,g.data);s(w=>d.asBrowserUri(w)),n=w=>d.terminate(w)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5f78b58b57b7cf84d28d801fed6bb4a48f908601/core/vs/workbench/api/worker/extensionHostWorker.js.map
